/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/process","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/processes","vs/base/common/codicons","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],he=function(G){for(var e=[],n=0,r=G.length;n<r;n++)e[n]=le[G[n]];return e};define(le[138],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=n,e.$fb=r,e.$gb=k,e.$hb=R,e.$ib=T,e.$jb=I,e.$kb=p,e.$mb=m,e.$nb=h,e.$ob=d,e.$pb=w,e.$qb=f;function n(g,v){const b=r(g,v);if(b!==-1)return g[b]}function r(g,v,b=g.length-1){for(let $=b;$>=0;$--){const P=g[$];if(v(P))return $}return-1}function k(g,v){const b=R(g,v);return b===-1?void 0:g[b]}function R(g,v,b=0,$=g.length){let P=b,E=$;for(;P<E;){const t=Math.floor((P+E)/2);v(g[t])?P=t+1:E=t}return P-1}function T(g,v){const b=I(g,v);return b===g.length?void 0:g[b]}function I(g,v,b=0,$=g.length){let P=b,E=$;for(;P<E;){const t=Math.floor((P+E)/2);v(g[t])?E=t:P=t+1}return P}function p(g,v,b=0,$=g.length){const P=I(g,v,b,$);return P===g.length?-1:P}class c{static{this.assertInvariants=!1}constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(c.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!v($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const b=R(this.e,v,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$lb=c;function m(g,v){if(g.length===0)return;let b=g[0];for(let $=1;$<g.length;$++){const P=g[$];v(P,b)>0&&(b=P)}return b}function h(g,v){if(g.length===0)return;let b=g[0];for(let $=1;$<g.length;$++){const P=g[$];v(P,b)>=0&&(b=P)}return b}function d(g,v){return m(g,(b,$)=>-v(b,$))}function w(g,v){if(g.length===0)return-1;let b=0;for(let $=1;$<g.length;$++){const P=g[$];v(P,g[b])>0&&(b=$)}return b}function f(g,v){for(const b of g){const $=v(b);if($!==void 0)return $}}}),define(le[39],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(le[139],he([0,1]),function(G,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=r,e.$d=k,e.$e=R,e.$f=T;function r(p,c){const m=Object.create(null);for(const h of p){const d=c(h);let w=m[d];w||(w=m[d]=[]),w.push(h)}return m}function k(p,c){const m=[],h=[];for(const d of p)c.has(d)||m.push(d);for(const d of c)p.has(d)||h.push(d);return{removed:m,added:h}}function R(p,c){const m=[],h=[];for(const[d,w]of p)c.has(d)||m.push(w);for(const[d,w]of c)p.has(d)||h.push(w);return{removed:m,added:h}}function T(p,c){const m=new Set;for(const h of c)p.has(h)&&m.add(h);return m}class I{static{n=Symbol.toStringTag}constructor(c,m){this.b=m,this.a=new Map,this[n]="SetWithKey";for(const h of c)this.add(h)}get size(){return this.a.size}add(c){const m=this.b(c);return this.a.set(m,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,m){this.a.forEach(h=>c.call(m,h,h,this))}[Symbol.iterator](){return this.values()}}e.$g=I}),define(le[140],he([0,1,39]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.$ju=e.$iu=void 0;function r(p,c){const m=Math.pow(10,c);return Math.round(p*m)/m}class k{constructor(c,m,h,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.r===m.r&&c.g===m.g&&c.b===m.b&&c.a===m.a}}e.$iu=k;class R{constructor(c,m,h,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.l=r(Math.max(Math.min(1,h),0),3),this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.l===m.l&&c.a===m.a}static fromRGBA(c){const m=c.r/255,h=c.g/255,d=c.b/255,w=c.a,f=Math.max(m,h,d),g=Math.min(m,h,d);let v=0,b=0;const $=(g+f)/2,P=f-g;if(P>0){switch(b=Math.min($<=.5?P/(2*$):P/(2-2*$),1),f){case m:v=(h-d)/P+(h<d?6:0);break;case h:v=(d-m)/P+2;break;case d:v=(m-h)/P+4;break}v*=60,v=Math.round(v)}return new R(v,b,$,w)}static i(c,m,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?c+(m-c)*6*h:h<1/2?m:h<2/3?c+(m-c)*(2/3-h)*6:c}static toRGBA(c){const m=c.h/360,{s:h,l:d,a:w}=c;let f,g,v;if(h===0)f=g=v=d;else{const b=d<.5?d*(1+h):d+h-d*h,$=2*d-b;f=R.i($,b,m+1/3),g=R.i($,b,m),v=R.i($,b,m-1/3)}return new k(Math.round(f*255),Math.round(g*255),Math.round(v*255),w)}}e.$ju=R;class T{constructor(c,m,h,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.v=r(Math.max(Math.min(1,h),0),3),this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.v===m.v&&c.a===m.a}static fromRGBA(c){const m=c.r/255,h=c.g/255,d=c.b/255,w=Math.max(m,h,d),f=Math.min(m,h,d),g=w-f,v=w===0?0:g/w;let b;return g===0?b=0:w===m?b=((h-d)/g%6+6)%6:w===h?b=(d-m)/g+2:b=(m-h)/g+4,new T(Math.round(b*60),v,w,c.a)}static toRGBA(c){const{h:m,s:h,v:d,a:w}=c,f=d*h,g=f*(1-Math.abs(m/60%2-1)),v=d-f;let[b,$,P]=[0,0,0];return m<60?(b=f,$=g):m<120?(b=g,$=f):m<180?($=f,P=g):m<240?($=g,P=f):m<300?(b=g,P=f):m<=360&&(b=f,P=g),b=Math.round((b+v)*255),$=Math.round(($+v)*255),P=Math.round((P+v)*255),new k(b,$,P,w)}}e.$ku=T;class I{static fromHex(c){return I.Format.CSS.parseHex(c)||I.red}static equals(c,m){return!c&&!m?!0:!c||!m?!1:c.equals(m)}get hsla(){return this.i?this.i:R.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:T.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof k)this.rgba=c;else if(c instanceof R)this.i=c,this.rgba=R.toRGBA(c);else if(c instanceof T)this.j=c,this.rgba=T.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&k.equals(this.rgba,c.rgba)&&R.equals(this.hsla,c.hsla)&&T.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=I.k(this.rgba.r),m=I.k(this.rgba.g),h=I.k(this.rgba.b),d=.2126*c+.7152*m+.0722*h;return r(d,4)}static k(c){const m=c/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(c){const m=this.getRelativeLuminance(),h=c.getRelativeLuminance();return m>h?(m+.05)/(h+.05):(h+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const m=this.getRelativeLuminance(),h=c.getRelativeLuminance();return m>h}isDarkerThan(c){const m=this.getRelativeLuminance(),h=c.getRelativeLuminance();return m<h}lighten(c){return new I(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new I(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:m,g:h,b:d,a:w}=this.rgba;return new I(new k(m,h,d,w*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const m=c.rgba,h=this.rgba.a,d=m.a,w=h+d*(1-h);if(w<1e-6)return I.transparent;const f=this.rgba.r*h/w+m.r*d*(1-h)/w,g=this.rgba.g*h/w+m.g*d*(1-h)/w,v=this.rgba.b*h/w+m.b*d*(1-h)/w;return new I(new k(f,g,v,w))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:m,g:h,b:d,a:w}=this.rgba;return new I(new k(c.rgba.r-w*(c.rgba.r-m),c.rgba.g-w*(c.rgba.g-h),c.rgba.b-w*(c.rgba.b-d),1))}flatten(...c){const m=c.reduceRight((h,d)=>I.o(d,h));return I.o(this,m)}static o(c,m){const h=1-c.rgba.a;return new I(new k(h*m.rgba.r+c.rgba.a*c.rgba.r,h*m.rgba.g+c.rgba.a*c.rgba.g,h*m.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(c,m,h){if(c.isLighterThan(m))return c;h=h||.5;const d=c.getRelativeLuminance(),w=m.getRelativeLuminance();return h=h*(w-d)/w,c.lighten(h)}static getDarkerColor(c,m,h){if(c.isDarkerThan(m))return c;h=h||.5;const d=c.getRelativeLuminance(),w=m.getRelativeLuminance();return h=h*(d-w)/d,c.darken(h)}static{this.white=new I(new k(255,255,255,1))}static{this.black=new I(new k(0,0,0,1))}static{this.red=new I(new k(255,0,0,1))}static{this.blue=new I(new k(0,0,255,1))}static{this.green=new I(new k(0,255,0,1))}static{this.cyan=new I(new k(0,255,255,1))}static{this.lightgrey=new I(new k(211,211,211,1))}static{this.transparent=new I(new k(0,0,0,0))}}e.$lu=I,function(p){let c;(function(m){let h;(function(d){function w(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:p.Format.CSS.formatRGBA(i)}d.formatRGB=w;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}d.formatRGBA=f;function g(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:p.Format.CSS.formatHSLA(i)}d.formatHSL=g;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}d.formatHSLA=v;function b(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function $(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}d.formatHex=$;function P(i,o=!1){return o&&i.rgba.a===1?p.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}d.formatHexA=P;function E(i){return i.isOpaque()?p.Format.CSS.formatHex(i):p.Format.CSS.formatRGBA(i)}d.format=E;function t(i){const o=i.length;if(o===0||i.charCodeAt(0)!==n.CharCode.Hash)return null;if(o===7){const s=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),a=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),l=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new p(new k(s,a,l,1))}if(o===9){const s=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),a=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),l=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),S=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new p(new k(s,a,l,S/255))}if(o===4){const s=u(i.charCodeAt(1)),a=u(i.charCodeAt(2)),l=u(i.charCodeAt(3));return new p(new k(16*s+s,16*a+a,16*l+l))}if(o===5){const s=u(i.charCodeAt(1)),a=u(i.charCodeAt(2)),l=u(i.charCodeAt(3)),S=u(i.charCodeAt(4));return new p(new k(16*s+s,16*a+a,16*l+l,(16*S+S)/255))}return null}d.parseHex=t;function u(i){switch(i){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(h=m.CSS||(m.CSS={}))})(c=p.Format||(p.Format={}))}(I||(e.$lu=I={}))}),define(le[53],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=r,e.$8h=k,e.$9h=R;function n(T){return(I,p,c)=>{let m=null,h=null;if(typeof c.value=="function"?(m="value",h=c.value):typeof c.get=="function"&&(m="get",h=c.get),!h)throw new Error("not supported");c[m]=T(h,p)}}function r(T,I,p){let c=null,m=null;if(typeof p.value=="function"?(c="value",m=p.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",m=p.get),!m)throw new Error("not supported");const h=`$memoize$${I}`;p[c]=function(...d){return this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,d)}),this[h]}}function k(T,I,p){return n((c,m)=>{const h=`$debounce$${m}`,d=`$debounce$result$${m}`;return function(...w){this[d]||(this[d]=p?p():void 0),clearTimeout(this[h]),I&&(this[d]=I(this[d],...w),w=[this[d]]),this[h]=setTimeout(()=>{c.apply(this,w),this[d]=p?p():void 0},T)}})}function R(T,I,p){return n((c,m)=>{const h=`$throttle$timer$${m}`,d=`$throttle$result$${m}`,w=`$throttle$lastRun$${m}`,f=`$throttle$pending$${m}`;return function(...g){if(this[d]||(this[d]=p?p():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[d]=I(this[d],...g)),this[f])return;const v=this[w]+T;v<=Date.now()?(this[w]=Date.now(),c.apply(this,[this[d]]),this[d]=p?p():void 0):(this[f]=!0,this[h]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),c.apply(this,[this[d]]),this[d]=p?p():void 0},v-Date.now()))}})}}),define(le[15],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=r,e.$X=k,e.$Y=R,e.$Z=T,e.$1=I,e.$2=p,e.$3=m,e.$5=d,e.$6=w,e.$7=f,e.$9=v;class n{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?E.isErrorNoTelemetry(i)?new E(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=n,e.$V=new n;function r(u){e.$V.setUnexpectedErrorHandler(u)}function k(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function R(u){m(u)||e.$V.onUnexpectedError(u)}function T(u){m(u)||e.$V.onUnexpectedExternalError(u)}function I(u){if(u instanceof Error){const{name:i,message:o}=u,s=u.stacktrace||u.stack;return{$isError:!0,name:i,message:o,stack:s,noTelemetry:E.isErrorNoTelemetry(u)}}return u}function p(u){let i;return u.noTelemetry?i=new E:(i=new Error,i.name=u.name),i.message=u.message,i.stack=u.stack,i}const c="Canceled";function m(u){return u instanceof h?!0:u instanceof Error&&u.name===c&&u.message===c}class h extends Error{constructor(){super(c),this.name=this.message}}e.$4=h;function d(){const u=new Error(c);return u.name=u.message,u}function w(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class g extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=g;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=b;class $ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=$;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=P;class E extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof E)return i;const o=new E;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=E;class t extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$bb=t}),define(le[21],he([0,1,15,138]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=k,e.$sb=R,e.$tb=T,e.$ub=I,e.$vb=p,e.$wb=c,e.$xb=m,e.$yb=h,e.$zb=d,e.$Ab=w,e.$Bb=f,e.$Cb=g,e.$Db=v,e.top=b,e.$Fb=$,e.$Gb=E,e.$Hb=t,e.$Ib=u,e.$Jb=i,e.$Kb=o,e.$Lb=s,e.$Mb=a,e.$Nb=l,e.$Ob=S,e.$Pb=y,e.$Qb=D,e.$Rb=L,e.$Sb=A,e.$Tb=O,e.$Ub=W,e.$Vb=V,e.$Wb=H,e.$Xb=Y,e.$Yb=Z,e.$Zb=U,e.$1b=te,e.$2b=x,e.$3b=J,e.$4b=B,e.$5b=X,e.$6b=ae,e.$9b=se;function k(N,z=0){return N[N.length-(1+z)]}function R(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function T(N,z,_=(Q,q)=>Q===q){if(N===z)return!0;if(!N||!z||N.length!==z.length)return!1;for(let Q=0,q=N.length;Q<q;Q++)if(!_(N[Q],z[Q]))return!1;return!0}function I(N,z){const _=N.length-1;z<_&&(N[z]=N[_]),N.pop()}function p(N,z,_){return c(N.length,Q=>_(N[Q],z))}function c(N,z){let _=0,Q=N-1;for(;_<=Q;){const q=(_+Q)/2|0,re=z(q);if(re<0)_=q+1;else if(re>0)Q=q-1;else return q}return-(_+1)}function m(N,z,_){if(N=N|0,N>=z.length)throw new TypeError("invalid index");const Q=z[Math.floor(z.length*Math.random())],q=[],re=[],de=[];for(const me of z){const we=_(me,Q);we<0?q.push(me):we>0?re.push(me):de.push(me)}return N<q.length?m(N,q,_):N<q.length+de.length?de[0]:m(N-(q.length+de.length),re,_)}function h(N,z){const _=[];let Q;for(const q of N.slice(0).sort(z))!Q||z(Q[0],q)!==0?(Q=[q],_.push(Q)):Q.push(q);return _}function*d(N,z){let _,Q;for(const q of N)Q!==void 0&&z(Q,q)?_.push(q):(_&&(yield _),_=[q]),Q=q;_&&(yield _)}function w(N,z){for(let _=0;_<=N.length;_++)z(_===0?void 0:N[_-1],_===N.length?void 0:N[_])}function f(N,z){for(let _=0;_<N.length;_++)z(_===0?void 0:N[_-1],N[_],_+1===N.length?void 0:N[_+1])}function g(N,z,_){const Q=[];function q(me,we,De){if(we===0&&De.length===0)return;const ke=Q[Q.length-1];ke&&ke.start+ke.deleteCount===me?(ke.deleteCount+=we,ke.toInsert.push(...De)):Q.push({start:me,deleteCount:we,toInsert:De})}let re=0,de=0;for(;;){if(re===N.length){q(re,0,z.slice(de));break}if(de===z.length){q(re,N.length-re,[]);break}const me=N[re],we=z[de],De=_(me,we);De===0?(re+=1,de+=1):De<0?(q(re,1,[]),re+=1):De>0&&(q(re,0,[we]),de+=1)}return Q}function v(N,z,_){const Q=g(N,z,_),q=[],re=[];for(const de of Q)q.push(...N.slice(de.start,de.start+de.deleteCount)),re.push(...de.toInsert);return{removed:q,added:re}}function b(N,z,_){if(_===0)return[];const Q=N.slice(0,_).sort(z);return P(N,z,Q,_,N.length),Q}function $(N,z,_,Q,q){return _===0?Promise.resolve([]):new Promise((re,de)=>{(async()=>{const me=N.length,we=N.slice(0,_).sort(z);for(let De=_,ke=Math.min(_+Q,me);De<me;De=ke,ke=Math.min(ke+Q,me)){if(De>_&&await new Promise(Pe=>setTimeout(Pe)),q&&q.isCancellationRequested)throw new n.$4;P(N,z,we,De,ke)}return we})().then(re,de)})}function P(N,z,_,Q,q){for(const re=_.length;Q<q;Q++){const de=N[Q];if(z(de,_[re-1])<0){_.pop();const me=(0,r.$jb)(_,we=>z(de,we)<0);_.splice(me,0,de)}}}function E(N){return N.filter(z=>!!z)}function t(N){let z=0;for(let _=0;_<N.length;_++)N[_]&&(N[z]=N[_],z+=1);N.length=z}function u(N,z,_){N.splice(_,0,N.splice(z,1)[0])}function i(N){return!Array.isArray(N)||N.length===0}function o(N){return Array.isArray(N)&&N.length>0}function s(N,z=_=>_){const _=new Set;return N.filter(Q=>{const q=z(Q);return _.has(q)?!1:(_.add(q),!0)})}function a(N){const z=new Set;return _=>{const Q=N(_);return z.has(Q)?!1:(z.add(Q),!0)}}function l(N,z){return N.length>0?N[0]:z}function S(N,z){return N.length>0?N[N.length-1]:z}function y(N,z,_=(Q,q)=>Q===q){let Q=0;for(let q=0,re=Math.min(N.length,z.length);q<re&&_(N[q],z[q]);q++)Q++;return Q}function D(N,z){let _=typeof z=="number"?N:0;typeof z=="number"?_=N:(_=0,z=N);const Q=[];if(_<=z)for(let q=_;q<z;q++)Q.push(q);else for(let q=_;q>z;q--)Q.push(q);return Q}function L(N,z,_){return N.reduce((Q,q)=>(Q[z(q)]=_?_(q):q,Q),Object.create(null))}function A(N,z){return N.push(z),()=>O(N,z)}function O(N,z){const _=N.indexOf(z);if(_>-1)return N.splice(_,1),z}function W(N,z,_){const Q=N.slice(0,z),q=N.slice(z);return Q.concat(_,q)}function V(N,z){let _;if(typeof z=="number"){let Q=z;_=()=>{const q=Math.sin(Q++)*179426549;return q-Math.floor(q)}}else _=Math.random;for(let Q=N.length-1;Q>0;Q-=1){const q=Math.floor(_()*(Q+1)),re=N[Q];N[Q]=N[q],N[q]=re}}function H(N,z){const _=N.indexOf(z);_>-1&&(N.splice(_,1),N.unshift(z))}function Y(N,z){const _=N.indexOf(z);_>-1&&(N.splice(_,1),N.push(z))}function Z(N,z){for(const _ of z)N.push(_)}function U(N,z){return Array.isArray(N)?N.map(z):z(N)}function te(N){return Array.isArray(N)?N:[N]}function x(N){return N[Math.floor(Math.random()*N.length)]}function J(N,z,_){const Q=j(N,z),q=N.length,re=_.length;N.length=q+re;for(let de=q-1;de>=Q;de--)N[de+re]=N[de];for(let de=0;de<re;de++)N[de+Q]=_[de]}function B(N,z,_,Q){const q=j(N,z);let re=N.splice(q,_);return re===void 0&&(re=[]),J(N,q,Q),re}function j(N,z){return z<0?Math.max(z+N.length,0):Math.min(z,N.length)}var C;(function(N){function z(re){return re<0}N.isLessThan=z;function _(re){return re<=0}N.isLessThanOrEqual=_;function Q(re){return re>0}N.isGreaterThan=Q;function q(re){return re===0}N.isNeitherLessOrGreaterThan=q,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(C||(e.CompareResult=C={}));function X(N,z){return(_,Q)=>z(N(_),N(Q))}function ae(...N){return(z,_)=>{for(const Q of N){const q=Q(z,_);if(!C.isNeitherLessOrGreaterThan(q))return q}return C.neitherLessOrGreaterThan}}const K=(N,z)=>N-z;e.$7b=K;const ce=(N,z)=>(0,e.$7b)(N?1:0,z?1:0);e.$8b=ce;function se(N){return(z,_)=>-N(z,_)}class ie{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let _=this.c;for(;_<this.g.length&&z(this.g[_]);)_++;const Q=_===this.c?null:this.g.slice(this.c,_);return this.c=_,Q}takeFromEndWhile(z){let _=this.d;for(;_>=0&&z(this.g[_]);)_--;const Q=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const _=this.g.slice(this.c,this.c+z);return this.c+=z,_}}e.$0b=ie;class M{static{this.empty=new M(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(_=>(z(_),!0))}toArray(){const z=[];return this.iterate(_=>(z.push(_),!0)),z}filter(z){return new M(_=>this.iterate(Q=>z(Q)?_(Q):!0))}map(z){return new M(_=>this.iterate(Q=>_(z(Q))))}some(z){let _=!1;return this.iterate(Q=>(_=z(Q),!_)),_}findFirst(z){let _;return this.iterate(Q=>z(Q)?(_=Q,!1):!0),_}findLast(z){let _;return this.iterate(Q=>(z(Q)&&(_=Q),!0)),_}findLastMaxBy(z){let _,Q=!0;return this.iterate(q=>((Q||C.isGreaterThan(z(q,_)))&&(Q=!1,_=q),!0)),_}}e.$$b=M;class F{constructor(z){this.c=z}static createSortPermutation(z,_){const Q=Array.from(z.keys()).sort((q,re)=>_(z[q],z[re]));return new F(Q)}apply(z){return z.map((_,Q)=>z[this.c[Q]])}inverse(){const z=this.c.slice();for(let _=0;_<this.c.length;_++)z[this.c[_]]=_;return new F(z)}}e.$_b=F}),define(le[141],he([0,1,15]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$dd=k,e.$ed=R,e.$fd=T,e.$gd=I,e.$hd=p;function r(c,m){if(!c)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}function k(c,m="Unreachable"){throw new Error(m)}function R(c,m="unexpected state"){if(!c)throw new n.$bb(`Assertion Failed: ${m}`)}function T(c){c||(0,n.$Y)(new n.$bb("Soft Assertion Failed"))}function I(c){if(!c()){debugger;c(),(0,n.$Y)(new n.$bb("Assertion Failed"))}}function p(c,m){let h=0;for(;h<c.length-1;){const d=c[h],w=c[h+1];if(!m(d,w))return!1;h++}return!0}}),define(le[89],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=n;function n(r,k){const R=this;let T=!1,I;return function(){if(T)return I;if(T=!0,k)try{I=r.apply(R,arguments)}finally{k()}else I=r.apply(R,arguments);return I}}}),define(le[77],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function k(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}r.is=k;const R=Object.freeze([]);function T(){return R}r.empty=T;function*I(i){yield i}r.single=I;function p(i){return k(i)?i:I(i)}r.wrap=p;function c(i){return i||R}r.from=c;function*m(i){for(let o=i.length-1;o>=0;o--)yield i[o]}r.reverse=m;function h(i){return!i||i[Symbol.iterator]().next().done===!0}r.isEmpty=h;function d(i){return i[Symbol.iterator]().next().value}r.first=d;function w(i,o){let s=0;for(const a of i)if(o(a,s++))return!0;return!1}r.some=w;function f(i,o){for(const s of i)if(o(s))return s}r.find=f;function*g(i,o){for(const s of i)o(s)&&(yield s)}r.filter=g;function*v(i,o){let s=0;for(const a of i)yield o(a,s++)}r.map=v;function*b(i,o){let s=0;for(const a of i)yield*o(a,s++)}r.flatMap=b;function*$(...i){for(const o of i)yield*o}r.concat=$;function P(i,o,s){let a=s;for(const l of i)a=o(a,l);return a}r.reduce=P;function*E(i,o,s=i.length){for(o<0&&(o+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);o<s;o++)yield i[o]}r.slice=E;function t(i,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,i];const a=i[Symbol.iterator]();for(let l=0;l<o;l++){const S=a.next();if(S.done)return[s,r.empty()];s.push(S.value)}return[s,{[Symbol.iterator](){return a}}]}r.consume=t;async function u(i){const o=[];for await(const s of i)o.push(s);return Promise.resolve(o)}r.asyncToArray=u})(n||(e.Iterable=n={}))}),define(le[43],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=T,e.$Un=h,e.$Vn=d,e.$Wn=w,e.$Xn=f,e.$Yn=g,e.$Zn=v,e.$1n=b,e.$2n=$,e.$3n=P,e.$4n=E;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function T(t,u=!1){let i=0;const o=t.length;let s="",a=0,l=r.Unknown,S=n.None;function y(H){let Y=0,Z=0;for(;Y<H;){const U=t.charCodeAt(i);if(U>=m._0&&U<=m._9)Z=Z*16+U-m._0;else if(U>=m.A&&U<=m.F)Z=Z*16+U-m.A+10;else if(U>=m.a&&U<=m.f)Z=Z*16+U-m.a+10;else break;i++,Y++}return Y<H&&(Z=-1),Z}function D(H){i=H,s="",a=0,l=r.Unknown,S=n.None}function L(){const H=i;if(t.charCodeAt(i)===m._0)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===m.dot)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return S=n.UnexpectedEndOfNumber,t.substring(H,i);let Y=i;if(i<t.length&&(t.charCodeAt(i)===m.E||t.charCodeAt(i)===m.e))if(i++,(i<t.length&&t.charCodeAt(i)===m.plus||t.charCodeAt(i)===m.minus)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;Y=i}else S=n.UnexpectedEndOfNumber;return t.substring(H,Y)}function A(){let H="",Y=i;for(;;){if(i>=o){H+=t.substring(Y,i),S=n.UnexpectedEndOfString;break}const Z=t.charCodeAt(i);if(Z===m.doubleQuote){H+=t.substring(Y,i),i++;break}if(Z===m.backslash){if(H+=t.substring(Y,i),i++,i>=o){S=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case m.doubleQuote:H+='"';break;case m.backslash:H+="\\";break;case m.slash:H+="/";break;case m.b:H+="\b";break;case m.f:H+="\f";break;case m.n:H+=`
`;break;case m.r:H+="\r";break;case m.t:H+="	";break;case m.u:{const te=y(4);te>=0?H+=String.fromCharCode(te):S=n.InvalidUnicode;break}default:S=n.InvalidEscapeCharacter}Y=i;continue}if(Z>=0&&Z<=31)if(p(Z)){H+=t.substring(Y,i),S=n.UnexpectedEndOfString;break}else S=n.InvalidCharacter;i++}return H}function O(){if(s="",S=n.None,a=i,i>=o)return a=o,l=r.EOF;let H=t.charCodeAt(i);if(I(H)){do i++,s+=String.fromCharCode(H),H=t.charCodeAt(i);while(I(H));return l=r.Trivia}if(p(H))return i++,s+=String.fromCharCode(H),H===m.carriageReturn&&t.charCodeAt(i)===m.lineFeed&&(i++,s+=`
`),l=r.LineBreakTrivia;switch(H){case m.openBrace:return i++,l=r.OpenBraceToken;case m.closeBrace:return i++,l=r.CloseBraceToken;case m.openBracket:return i++,l=r.OpenBracketToken;case m.closeBracket:return i++,l=r.CloseBracketToken;case m.colon:return i++,l=r.ColonToken;case m.comma:return i++,l=r.CommaToken;case m.doubleQuote:return i++,s=A(),l=r.StringLiteral;case m.slash:{const Y=i-1;if(t.charCodeAt(i+1)===m.slash){for(i+=2;i<o&&!p(t.charCodeAt(i));)i++;return s=t.substring(Y,i),l=r.LineCommentTrivia}if(t.charCodeAt(i+1)===m.asterisk){i+=2;const Z=o-1;let U=!1;for(;i<Z;){if(t.charCodeAt(i)===m.asterisk&&t.charCodeAt(i+1)===m.slash){i+=2,U=!0;break}i++}return U||(i++,S=n.UnexpectedEndOfComment),s=t.substring(Y,i),l=r.BlockCommentTrivia}return s+=String.fromCharCode(H),i++,l=r.Unknown}case m.minus:if(s+=String.fromCharCode(H),i++,i===o||!c(t.charCodeAt(i)))return l=r.Unknown;case m._0:case m._1:case m._2:case m._3:case m._4:case m._5:case m._6:case m._7:case m._8:case m._9:return s+=L(),l=r.NumericLiteral;default:for(;i<o&&W(H);)i++,H=t.charCodeAt(i);if(a!==i){switch(s=t.substring(a,i),s){case"true":return l=r.TrueKeyword;case"false":return l=r.FalseKeyword;case"null":return l=r.NullKeyword}return l=r.Unknown}return s+=String.fromCharCode(H),i++,l=r.Unknown}}function W(H){if(I(H)||p(H))return!1;switch(H){case m.closeBrace:case m.closeBracket:case m.openBrace:case m.openBracket:case m.doubleQuote:case m.colon:case m.comma:case m.slash:return!1}return!0}function V(){let H;do H=O();while(H>=r.LineCommentTrivia&&H<=r.Trivia);return H}return{setPosition:D,getPosition:()=>i,scan:u?V:O,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>S}}function I(t){return t===m.space||t===m.tab||t===m.verticalTab||t===m.formFeed||t===m.nonBreakingSpace||t===m.ogham||t>=m.enQuad&&t<=m.zeroWidthSpace||t===m.narrowNoBreakSpace||t===m.mathematicalSpace||t===m.ideographicSpace||t===m.byteOrderMark}function p(t){return t===m.lineFeed||t===m.carriageReturn||t===m.lineSeparator||t===m.paragraphSeparator}function c(t){return t>=m._0&&t<=m._9}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function h(t,u){const i=[],o=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function S(y,D,L,A){a.value=y,a.offset=D,a.length=L,a.type=A,a.colonOffset=void 0,s=a}try{P(t,{onObjectBegin:(y,D)=>{if(u<=y)throw o;s=void 0,l=u>y,i.push("")},onObjectProperty:(y,D,L)=>{if(u<D||(S(y,D,L,"property"),i[i.length-1]=y,u<=D+L))throw o},onObjectEnd:(y,D)=>{if(u<=y)throw o;s=void 0,i.pop()},onArrayBegin:(y,D)=>{if(u<=y)throw o;s=void 0,i.push(0)},onArrayEnd:(y,D)=>{if(u<=y)throw o;s=void 0,i.pop()},onLiteralValue:(y,D,L)=>{if(u<D||(S(y,D,L,E(y)),u<=D+L))throw o},onSeparator:(y,D,L)=>{if(u<=D)throw o;if(y===":"&&s&&s.type==="property")s.colonOffset=D,l=!1,s=void 0;else if(y===","){const A=i[i.length-1];typeof A=="number"?i[i.length-1]=A+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(y){if(y!==o)throw y}return{path:i,previousNode:s,isAtPropertyKey:l,matches:y=>{let D=0;for(let L=0;D<y.length&&L<i.length;L++)if(y[D]===i[L]||y[D]==="*")D++;else if(y[D]!=="**")return!1;return D===y.length}}}function d(t,u=[],i=R.DEFAULT){let o=null,s=[];const a=[];function l(y){Array.isArray(s)?s.push(y):o!==null&&(s[o]=y)}return P(t,{onObjectBegin:()=>{const y={};l(y),a.push(s),s=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const y=[];l(y),a.push(s),s=y,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:l,onError:(y,D,L)=>{u.push({error:y,offset:D,length:L})}},i),s[0]}function w(t,u=[],i=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){o.type==="property"&&(o.length=y-o.offset,o=o.parent)}function a(y){return o.children.push(y),y}P(t,{onObjectBegin:y=>{o=a({type:"object",offset:y,length:-1,parent:o,children:[]})},onObjectProperty:(y,D,L)=>{o=a({type:"property",offset:D,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:y,offset:D,length:L,parent:o})},onObjectEnd:(y,D)=>{o.length=y+D-o.offset,o=o.parent,s(y+D)},onArrayBegin:(y,D)=>{o=a({type:"array",offset:y,length:-1,parent:o,children:[]})},onArrayEnd:(y,D)=>{o.length=y+D-o.offset,o=o.parent,s(y+D)},onLiteralValue:(y,D,L)=>{a({type:E(y),offset:D,length:L,parent:o,value:y}),s(D+L)},onSeparator:(y,D,L)=>{o.type==="property"&&(y===":"?o.colonOffset=D:y===","&&s(D))},onError:(y,D,L)=>{u.push({error:y,offset:D,length:L})}},i);const S=o.children[0];return S&&delete S.parent,S}function f(t,u){if(!t)return;let i=t;for(const o of u)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===o){i=a.children[1],s=!0;break}if(!s)return}else{const s=o;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function g(t){if(!t.parent||!t.parent.children)return[];const u=g(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;u.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&u.push(i)}return u}function v(t){switch(t.type){case"array":return t.children.map(v);case"object":{const u=Object.create(null);for(const i of t.children){const o=i.children[1];o&&(u[i.children[0].value]=v(o))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function b(t,u,i=!1){return u>=t.offset&&u<t.offset+t.length||i&&u===t.offset+t.length}function $(t,u,i=!1){if(b(t,u,i)){const o=t.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=u;s++){const a=$(o[s],u,i);if(a)return a}return t}}function P(t,u,i=R.DEFAULT){const o=T(t,!1);function s(X){return X?()=>X(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(X){return X?ae=>X(ae,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=s(u.onObjectBegin),S=a(u.onObjectProperty),y=s(u.onObjectEnd),D=s(u.onArrayBegin),L=s(u.onArrayEnd),A=a(u.onLiteralValue),O=a(u.onSeparator),W=s(u.onComment),V=a(u.onError),H=i&&i.disallowComments,Y=i&&i.allowTrailingComma;function Z(){for(;;){const X=o.scan();switch(o.getTokenError()){case n.InvalidUnicode:U(k.InvalidUnicode);break;case n.InvalidEscapeCharacter:U(k.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:U(k.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:H||U(k.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:U(k.UnexpectedEndOfString);break;case n.InvalidCharacter:U(k.InvalidCharacter);break}switch(X){case r.LineCommentTrivia:case r.BlockCommentTrivia:H?U(k.InvalidCommentToken):W();break;case r.Unknown:U(k.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return X}}}function U(X,ae=[],K=[]){if(V(X),ae.length+K.length>0){let ce=o.getToken();for(;ce!==r.EOF;){if(ae.indexOf(ce)!==-1){Z();break}else if(K.indexOf(ce)!==-1)break;ce=Z()}}}function te(X){const ae=o.getTokenValue();return X?A(ae):S(ae),Z(),!0}function x(){switch(o.getToken()){case r.NumericLiteral:{let X=0;try{X=JSON.parse(o.getTokenValue()),typeof X!="number"&&(U(k.InvalidNumberFormat),X=0)}catch{U(k.InvalidNumberFormat)}A(X);break}case r.NullKeyword:A(null);break;case r.TrueKeyword:A(!0);break;case r.FalseKeyword:A(!1);break;default:return!1}return Z(),!0}function J(){return o.getToken()!==r.StringLiteral?(U(k.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(te(!1),o.getToken()===r.ColonToken?(O(":"),Z(),C()||U(k.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):U(k.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function B(){l(),Z();let X=!1;for(;o.getToken()!==r.CloseBraceToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(X||U(k.ValueExpected,[],[]),O(","),Z(),o.getToken()===r.CloseBraceToken&&Y)break}else X&&U(k.CommaExpected,[],[]);J()||U(k.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),X=!0}return y(),o.getToken()!==r.CloseBraceToken?U(k.CloseBraceExpected,[r.CloseBraceToken],[]):Z(),!0}function j(){D(),Z();let X=!1;for(;o.getToken()!==r.CloseBracketToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(X||U(k.ValueExpected,[],[]),O(","),Z(),o.getToken()===r.CloseBracketToken&&Y)break}else X&&U(k.CommaExpected,[],[]);C()||U(k.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),X=!0}return L(),o.getToken()!==r.CloseBracketToken?U(k.CloseBracketExpected,[r.CloseBracketToken],[]):Z(),!0}function C(){switch(o.getToken()){case r.OpenBracketToken:return j();case r.OpenBraceToken:return B();case r.StringLiteral:return te(!0);default:return x()}}return Z(),o.getToken()===r.EOF?i.allowEmptyContent?!0:(U(k.ValueExpected,[],[]),!1):C()?(o.getToken()!==r.EOF&&U(k.EndOfFileExpected,[],[]),!0):(U(k.ValueExpected,[],[]),!1)}function E(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[142],he([0,1,43]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=r,e.$6n=k,e.$7n=I,e.$8n=p;function r(c,m,h){let d,w,f,g,v;if(m){for(g=m.offset,v=g+m.length,f=g;f>0&&!p(c,f-1);)f--;let S=v;for(;S<c.length&&!p(c,S);)S++;w=c.substring(f,S),d=T(w,h)}else w=c,d=0,f=0,g=0,v=c.length;const b=I(h,c);let $=!1,P=0,E;h.insertSpaces?E=R(" ",h.tabSize||4):E="	";const t=(0,n.$Tn)(w,!1);let u=!1;function i(){return b+R(E,d+P)}function o(){let S=t.scan();for($=!1;S===n.SyntaxKind.Trivia||S===n.SyntaxKind.LineBreakTrivia;)$=$||S===n.SyntaxKind.LineBreakTrivia,S=t.scan();return u=S===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,S}const s=[];function a(S,y,D){!u&&y<v&&D>g&&c.substring(y,D)!==S&&s.push({offset:y,length:D-y,content:S})}let l=o();if(l!==n.SyntaxKind.EOF){const S=t.getTokenOffset()+f,y=R(E,d);a(y,f,S)}for(;l!==n.SyntaxKind.EOF;){let S=t.getTokenOffset()+t.getTokenLength()+f,y=o(),D="";for(;!$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia);){const A=t.getTokenOffset()+f;a(" ",S,A),S=t.getTokenOffset()+t.getTokenLength()+f,D=y===n.SyntaxKind.LineCommentTrivia?i():"",y=o()}if(y===n.SyntaxKind.CloseBraceToken)l!==n.SyntaxKind.OpenBraceToken&&(P--,D=i());else if(y===n.SyntaxKind.CloseBracketToken)l!==n.SyntaxKind.OpenBracketToken&&(P--,D=i());else{switch(l){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:P++,D=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:D=i();break;case n.SyntaxKind.BlockCommentTrivia:$?D=i():D=" ";break;case n.SyntaxKind.ColonToken:D=" ";break;case n.SyntaxKind.StringLiteral:if(y===n.SyntaxKind.ColonToken){D="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia?D=" ":y!==n.SyntaxKind.CommaToken&&y!==n.SyntaxKind.EOF&&(u=!0);break;case n.SyntaxKind.Unknown:u=!0;break}$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia)&&(D=i())}const L=t.getTokenOffset()+f;a(D,S,L),l=y}return s}function k(c,m){const h=JSON.stringify(c,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?h.replace(/\r\n|\r|\n/g,m.eol):h}function R(c,m){let h="";for(let d=0;d<m;d++)h+=c;return h}function T(c,m){let h=0,d=0;const w=m.tabSize||4;for(;h<c.length;){const f=c.charAt(h);if(f===" ")d++;else if(f==="	")d+=w;else break;h++}return Math.floor(d/w)}function I(c,m){for(let h=0;h<m.length;h++){const d=m.charAt(h);if(d==="\r")return h+1<m.length&&m.charAt(h+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return c&&c.eol||`
`}function p(c,m){return`\r
`.indexOf(c.charAt(m))!==-1}}),define(le[107],he([0,1,43,142]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=k,e.$0n=R,e.$$n=T,e.$_n=I,e.$ao=p;function k(c,m,h){return R(c,m,void 0,h)}function R(c,m,h,d,w){const f=m.slice(),g=[],v=(0,n.$Wn)(c,g);let b,$;for(;f.length>0&&($=f.pop(),b=(0,n.$Xn)(v,f),b===void 0&&h!==void 0);)typeof $=="string"?h={[$]:h}:h=[h];if(b)if(b.type==="object"&&typeof $=="string"&&Array.isArray(b.children)){const P=(0,n.$Xn)(b,[$]);if(P!==void 0)if(h===void 0){if(!P.parent)throw new Error("Malformed AST");const E=b.children.indexOf(P.parent);let t,u=P.parent.offset+P.parent.length;if(E>0){const i=b.children[E-1];t=i.offset+i.length}else t=b.offset+1,b.children.length>1&&(u=b.children[1].offset);return T(c,{offset:t,length:u-t,content:""},d)}else return T(c,{offset:P.offset,length:P.length,content:JSON.stringify(h)},d);else{if(h===void 0)return[];const E=`${JSON.stringify($)}: ${JSON.stringify(h)}`,t=w?w(b.children.map(i=>i.children[0].value)):b.children.length;let u;if(t>0){const i=b.children[t-1];u={offset:i.offset+i.length,length:0,content:","+E}}else b.children.length===0?u={offset:b.offset+1,length:0,content:E}:u={offset:b.offset+1,length:0,content:E+","};return T(c,u,d)}}else if(b.type==="array"&&typeof $=="number"&&Array.isArray(b.children))if(h!==void 0){const P=`${JSON.stringify(h)}`;let E;if(b.children.length===0||$===0)E={offset:b.offset+1,length:0,content:b.children.length===0?P:P+","};else{const t=$===-1||$>b.children.length?b.children.length:$,u=b.children[t-1];E={offset:u.offset+u.length,length:0,content:","+P}}return T(c,E,d)}else{const P=$,E=b.children[P];let t;if(b.children.length===1)t={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===P){const u=b.children[P-1],i=u.offset+u.length,o=b.offset+b.length;t={offset:i,length:o-2-i,content:""}}else t={offset:E.offset,length:b.children[P+1].offset-E.offset,content:""};return T(c,t,d)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${b.type}`);else return h===void 0?[]:T(c,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(h)},d)}function T(c,m,h){let d=I(c,m),w=m.offset,f=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;w>0&&!(0,r.$8n)(d,w-1);)w--;for(;f<d.length&&!(0,r.$8n)(d,f);)f++}const g=(0,r.$5n)(d,{offset:w,length:f-w},h);for(let b=g.length-1;b>=0;b--){const $=g[b];d=I(d,$),w=Math.min(w,$.offset),f=Math.max(f,$.offset+$.length),f+=$.content.length-$.length}const v=c.length-(d.length-f)-w;return[{offset:w,length:v,content:d.substring(w,f)}]}function I(c,m){return c.substring(0,m.offset)+m.content+c.substring(m.offset+m.length)}function p(c,m){const h=m.slice(0).sort((w,f)=>{const g=w.offset-f.offset;return g===0?w.length-f.length:g});let d=c.length;for(let w=h.length-1;w>=0;w--){const f=h[w];if(f.offset+f.length<=d)c=I(c,f);else throw new Error("Overlapping edit");d=f.offset}return c}}),define(le[143],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=n;function n(R){let T=!1;const I=new Map,p=new Map;if(k(R,g=>{if(R===g)return!0;const v=JSON.stringify(g);if(v.length<30)return!0;const b=I.get(v);if(!b){const $={schemas:[g]};return I.set(v,$),p.set(g,$),!0}return b.schemas.push(g),p.set(g,b),T=!0,!1}),I.clear(),!T)return JSON.stringify(R);let m="$defs";for(;R.hasOwnProperty(m);)m+="_";const h=[];function d(g){return JSON.stringify(g,(v,b)=>{if(b!==g){const $=p.get(b);if($&&$.schemas.length>1)return $.id||($.id=`_${h.length}`,h.push($.schemas[0])),{$ref:`#/${m}/${$.id}`}}return b})}const w=d(R),f=[];for(let g=0;g<h.length;g++)f.push(`"_${g}":${d(h[g])}`);return f.length?`${w.substring(0,w.length-1)},"${m}":{${f.join(",")}}}`:w}function r(R){return typeof R=="object"&&R!==null}function k(R,T){if(!R||typeof R!="object")return;const I=(...w)=>{for(const f of w)r(f)&&h.push(f)},p=(...w)=>{for(const f of w)if(r(f))for(const g in f){const v=f[g];r(v)&&h.push(v)}},c=(...w)=>{for(const f of w)if(Array.isArray(f))for(const g of f)r(g)&&h.push(g)},m=w=>{if(Array.isArray(w))for(const f of w)r(f)&&h.push(f);else r(w)&&h.push(w)},h=[R];let d=h.pop();for(;d;)T(d)&&(I(d.additionalItems,d.additionalProperties,d.not,d.contains,d.propertyNames,d.if,d.then,d.else,d.unevaluatedItems,d.unevaluatedProperties),p(d.definitions,d.$defs,d.properties,d.patternProperties,d.dependencies,d.dependentSchemas),c(d.anyOf,d.allOf,d.oneOf,d.prefixItems),m(d.items)),d=h.pop()}}),function(){function G(){const e=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function n(k){return k.replace(e,function(R,T,I,p,c,m){if(p)return"";if(c){const h=c.length;return c[h-1]===`
`?c[h-2]==="\r"?`\r
`:`
`:""}else return m?R.substring(1):R})}function r(k){const R=n(k);try{return JSON.parse(R)}catch{const I=R.replace(/,\s*([}\]])/g,"$1");return JSON.parse(I)}}return{stripComments:n,parse:r}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return G()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=G():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[65],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class n{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=n}),define(le[108],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(R){this.element=R,this.next=n.Undefined,this.prev=n.Undefined}}class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let R=this.a;for(;R!==n.Undefined;){const T=R.next;R.prev=n.Undefined,R.next=n.Undefined,R=T}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,T){const I=new n(R);if(this.a===n.Undefined)this.a=I,this.b=I;else if(T){const c=this.b;this.b=I,I.prev=c,c.next=I}else{const c=this.a;this.a=I,I.next=c,c.prev=I}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(I))}}shift(){if(this.a!==n.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==n.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==n.Undefined&&R.next!==n.Undefined){const T=R.prev;T.next=R.next,R.next.prev=T}else R.prev===n.Undefined&&R.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):R.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):R.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==n.Undefined;)yield R.element,R=R.next}}e.$4c=r}),define(le[31],he([0,1]),function(G,e){"use strict";var n,r,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=void 0,e.$wc=R,e.$xc=T,e.$yc=I,e.$Hc=E;function R(t,u,i){let o=t.get(u);return o===void 0&&(o=i,t.set(u,o)),o}function T(t){const u=[];return t.forEach((i,o)=>{u.push(`${o} => ${i}`)}),`Map(${t.size}) {${u.join(", ")}}`}function I(t){const u=[];return t.forEach(i=>{u.push(i)}),`Set(${t.size}) {${u.join(", ")}}`}class p{constructor(u,i){this.uri=u,this.value=i}}function c(t){return Array.isArray(t)}class m{static{this.c=u=>u.toString()}constructor(u,i){if(this[n]="ResourceMap",u instanceof m)this.d=new Map(u.d),this.e=i??m.c;else if(c(u)){this.d=new Map,this.e=i??m.c;for(const[o,s]of u)this.set(o,s)}else this.d=new Map,this.e=u??m.c}set(u,i){return this.d.set(this.e(u),new p(u,i)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,i){typeof i<"u"&&(u=u.bind(i));for(const[o,s]of this.d)u(s.value,s.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}e.$zc=m;class h{constructor(u,i){this[r]="ResourceSet",!u||typeof u=="function"?this.c=new m(u):(this.c=new m(i),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,i){this.c.forEach((o,s)=>u.call(i,s,s,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=h;var d;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class w{constructor(){this[k]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,i=d.None){const o=this.c.get(u);if(o)return i!==d.None&&this.m(o,i),o.value}set(u,i,o=d.None){let s=this.c.get(u);if(s)s.value=i,o!==d.None&&this.m(s,o);else{switch(s={key:u,value:i,next:void 0,previous:void 0},o){case d.None:this.k(s);break;case d.AsOld:this.j(s);break;case d.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(u,s),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const i=this.c.get(u);if(i)return this.c.delete(u),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,i){const o=this.g;let s=this.d;for(;s;){if(i?u.bind(i)(s.value,s.key,this):u(s.value,s.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.key,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}values(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.value,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}entries(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:[o.key,o.value],done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.d,o=this.size;for(;i&&o>u;)this.c.delete(i.key),i=i.next,o--;this.d=i,this.f=o,i&&(i.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.e,o=this.size;for(;i&&o>u;)this.c.delete(i.key),i=i.previous,o--;this.e=i,this.f=o,i&&(i.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const i=u.next,o=u.previous;if(!i||!o)throw new Error("Invalid list");i.previous=o,o.next=i}u.next=void 0,u.previous=void 0,this.g++}m(u,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==d.AsOld&&i!==d.AsNew)){if(i===d.AsOld){if(u===this.d)return;const o=u.next,s=u.previous;u===this.e?(s.next=void 0,this.e=s):(o.previous=s,s.next=o),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(i===d.AsNew){if(u===this.e)return;const o=u.next,s=u.previous;u===this.d?(o.previous=void 0,this.d=o):(o.previous=s,s.next=o),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((i,o)=>{u.push([o,i])}),u}fromJSON(u){this.clear();for(const[i,o]of u)this.set(i,o)}}e.$Bc=w;class f extends w{constructor(u,i=1){super(),this.n=u,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,i=d.AsNew){return super.get(u,i)}peek(u){return super.get(u,d.None)}set(u,i){return super.set(u,i,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends f{constructor(u,i=1){super(u,i)}q(u){this.h(u)}set(u,i){return super.set(u,i),this.p(),this}}e.$Cc=g;class v extends f{constructor(u,i=1){super(u,i)}q(u){this.i(u)}set(u,i){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,i),this}}e.$Dc=v;class b{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let i=this.c.get(u)||0;return i===0?!1:(i--,i===0?this.c.delete(u):this.c.set(u,i),!0)}has(u){return this.c.has(u)}}e.$Ec=b;class ${constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[i,o]of u)this.set(i,o)}clear(){this.c.clear(),this.d.clear()}set(u,i){this.c.set(u,i),this.d.set(i,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const i=this.c.get(u);return i===void 0?!1:(this.c.delete(u),this.d.delete(i),!0)}forEach(u,i){this.c.forEach((o,s)=>{u.call(i,o,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=$;class P{constructor(){this.c=new Map}add(u,i){let o=this.c.get(u);o||(o=new Set,this.c.set(u,o)),o.add(i)}delete(u,i){const o=this.c.get(u);o&&(o.delete(i),o.size===0&&this.c.delete(u))}forEach(u,i){const o=this.c.get(u);o&&o.forEach(i)}get(u){const i=this.c.get(u);return i||new Set}}e.$Gc=P;function E(t,u){if(t===u)return!0;if(t.size!==u.size)return!1;for(const[i,o]of t)if(!u.has(i)||u.get(i)!==o)return!1;for(const[i]of u)if(!t.has(i))return!1;return!0}}),define(le[2],he([0,1,21,139,31,89,77]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=m,e.$Kc=h,e.$Lc=d,e.$Mc=g,e.$Nc=v,e.$Oc=b,e.$Pc=$,e.$Qc=P,e.$Rc=E,e.$2c=D;const I=!1;let p=null;class c{constructor(){this.b=new Map}static{this.a=0}c(O){let W=this.b.get(O);return W||(W={parent:null,source:null,isSingleton:!1,value:O,idx:c.a++},this.b.set(O,W)),W}trackDisposable(O){const W=this.c(O);W.source||(W.source=new Error().stack)}setParent(O,W){const V=this.c(O);V.parent=W}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,W){const V=W.get(O);if(V)return V;const H=O.parent?this.f(this.c(O.parent),W):O;return W.set(O,H),H}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,V])=>V.source!==null&&!this.f(V,O).isSingleton).flatMap(([V])=>V)}computeLeakingDisposables(O=10,W){let V;if(W)V=W;else{const te=new Map,x=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,te).isSingleton);if(x.length===0)return;const J=new Set(x.map(B=>B.value));if(V=x.filter(B=>!(B.parent&&J.has(B.parent))),V.length===0)throw new Error("There are cyclic diposable chains!")}if(!V)return;function H(te){function x(B,j){for(;B.length>0&&j.some(C=>typeof C=="string"?C===B[0]:B[0].match(C));)B.shift()}const J=te.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return x(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const Y=new k.$Gc;for(const te of V){const x=H(te);for(let J=0;J<=x.length;J++)Y.add(x.slice(0,J).join(`
`),te)}V.sort((0,n.$5b)(te=>te.idx,n.$7b));let Z="",U=0;for(const te of V.slice(0,O)){U++;const x=H(te),J=[];for(let B=0;B<x.length;B++){let j=x[B];j=`(shared with ${Y.get(x.slice(0,B+1).join(`
`)).size}/${V.length} leaks) at ${j}`;const X=Y.get(x.slice(0,B).join(`
`)),ae=(0,r.$c)([...X].map(K=>H(K)[B]),K=>K);delete ae[x[B]];for(const[K,ce]of Object.entries(ae))J.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${K}`);J.unshift(j)}Z+=`


==================== Leaking disposable ${U}/${V.length}: ${te.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return V.length>O&&(Z+=`


... and ${V.length-O} more leaking disposables

`),{leaks:V,details:Z}}}e.$Ic=c;function m(A){p=A}if(I){const A="__is_disposable_tracked__";m(new class{trackDisposable(O){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[A]||console.log(W)},3e3)}setParent(O,W){if(O&&O!==u.None)try{O[A]=!0}catch{}}markAsDisposed(O){if(O&&O!==u.None)try{O[A]=!0}catch{}}markAsSingleton(O){}})}function h(A){return p?.trackDisposable(A),A}function d(A){p?.markAsDisposed(A)}function w(A,O){p?.setParent(A,O)}function f(A,O){if(p)for(const W of A)p.setParent(W,O)}function g(A){return p?.markAsSingleton(A),A}function v(A){return typeof A=="object"&&A!==null&&typeof A.dispose=="function"&&A.dispose.length===0}function b(A){if(T.Iterable.is(A)){const O=[];for(const W of A)if(W)try{W.dispose()}catch(V){O.push(V)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}function $(A){for(const O of A)v(O)&&O.dispose();return[]}function P(...A){const O=E(()=>b(A));return f(A,O),O}function E(A){const O=h({dispose:(0,R.$cb)(()=>{d(O),A()})});return O}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,h(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return w(O,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),w(O,null))}}e.$Sc=t;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,h(this),w(this.q,this)}dispose(){d(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}e.$Tc=u;class i{constructor(){this.b=!1,h(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&w(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&w(O,null),O}}e.$Uc=i;class o{constructor(O){this.a=new i,this.b=!1,this.a.value=O}get value(){return this.a.value}set value(O){this.b||O===this.a.value||(this.a.value=O)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=o;class s{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(O){let W=O;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,d(this))},this}}e.$Xc=a;class l{constructor(){this.a=new Map}acquire(O,...W){let V=this.a.get(O);V||(V={counter:0,object:this.b(O,...W)},this.a.set(O,V));const{object:H}=V,Y=(0,R.$cb)(()=>{--V.counter===0&&(this.c(O,V.object),this.a.delete(O))});return V.counter++,{object:H,dispose:Y}}}e.$Yc=l;class S{constructor(O){this.a=O}async acquire(O,...W){const V=this.a.acquire(O,...W);try{return{object:await V.object,dispose:()=>V.dispose()}}catch(H){throw V.dispose(),H}}}e.$Zc=S;class y{constructor(O){this.object=O}dispose(){}}e.$1c=y;function D(A){const O=new t;try{A(O)}finally{O.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,h(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,W,V=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),V||this.a.get(O)?.dispose(),this.a.set(O,W)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}deleteAndLeak(O){const W=this.a.get(O);return this.a.delete(O),W}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=L}),define(le[90],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(le[78],he([0,1,31]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=void 0,e.$km=k,e.$lm=T;const r=new n.$Cc(1e4);function k(c){return p(c,"NFC",r)}const R=new n.$Cc(1e4);function T(c){return p(c,"NFD",R)}const I=/[^\u0000-\u0080]/;function p(c,m,h){if(!c)return c;const d=h.get(c);if(d)return d;let w;return I.test(c)?w=c.normalize(m):w=c,h.set(c,w),w}e.$mm=function(){const c=/[\u0300-\u036f]/g;return function(m){return T(m).replace(c,"")}}()}),define(le[144],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0,e.$Im=n,e.rot=r,e.$Nm=I;function n(p,c,m){return Math.min(Math.max(p,c),m)}function r(p,c){return(c+p%c)%c}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Km=k;class R{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Lm=R;class T{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const m=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Mm=T;function I(p,c,m,h,d,w,f,g){const v=f-m,b=g-h,$=d-m,P=w-h,E=p-m,t=c-h,u=v*v+b*b,i=v*$+b*P,o=v*E+b*t,s=$*$+P*P,a=$*E+P*t,l=1/(u*s-i*i),S=(s*o-i*a)*l,y=(u*a-i*o)*l;return S>=0&&y>=0&&S+y<1}}),function(){function G(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function T(p){R.push(p,Date.now())}function I(){const p=[];for(let c=0;c<R.length;c+=2)p.push({name:R[c],startTime:R[c+1]});return p}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(k+T.startTime)});return R}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function n(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(le[3],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=u,e.$E=S,e.$K=y,e.$h="en";let n=!1,r=!1,k=!1,R=!1,T=!1,I=!1,p=!1,c=!1,m=!1,h=!1,d,w=e.$h,f=e.$h,g,v;const b=globalThis;let $;typeof b.vscode<"u"&&typeof b.vscode.process<"u"?$=b.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const P=typeof $?.versions?.electron=="string",E=P&&$?.type==="renderer";if(typeof $=="object"){n=$.platform==="win32",r=$.platform==="darwin",k=$.platform==="linux",R=k&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=P,m=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$h,w=e.$h;const D=$.env.VSCODE_NLS_CONFIG;if(D)try{const L=JSON.parse(D);d=L.userLocale,f=L.osLocale,w=L.resolvedLanguage||e.$h,g=L.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!E?(v=navigator.userAgent,n=v.indexOf("Windows")>=0,r=v.indexOf("Macintosh")>=0,c=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=v.indexOf("Linux")>=0,h=v?.indexOf("Mobi")>=0,I=!0,w=globalThis._VSCODE_NLS_LANGUAGE||e.$h,d=navigator.language.toLowerCase(),f=d):console.error("Unable to resolve platform.");var t;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(D){switch(D){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let i=t.Web;r?i=t.Mac:n?i=t.Windows:k&&(i=t.Linux),e.$j=n,e.$k=r,e.$l=k,e.$m=R,e.$n=T,e.$o=p,e.$p=I,e.$q=I&&typeof b.importScripts=="function",e.$r=e.$q?b.origin:void 0,e.$s=c,e.$t=h,e.$u=m,e.$v=i,e.$w=v,e.$x=w;var o;(function(D){function L(){return e.$x}D.value=L;function A(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}D.isDefaultVariant=A;function O(){return e.$x==="en"}D.isDefault=O})(o||(e.Language=o={})),e.$y=d,e.$z=f,e.$A=g,e.$B=typeof b.postMessage=="function"&&!b.importScripts,e.$C=(()=>{if(e.$B){const D=[];b.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let O=0,W=D.length;O<W;O++){const V=D[O];if(V.id===A.data.vscodeScheduleAsyncWork){D.splice(O,1),V.callback();return}}});let L=0;return A=>{const O=++L;D.push({id:O,callback:A}),b.postMessage({vscodeScheduleAsyncWork:O},"*")}}return D=>setTimeout(D)})();var s;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=r||c?s.Macintosh:n?s.Windows:s.Linux;let a=!0,l=!1;function S(){if(!l){l=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,a=new Uint16Array(D.buffer)[0]===513}return a}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(D){return parseFloat(D)>=20}}),define(le[36],he([0,1,3]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let r;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const R=k.process;r={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$j?"win32":n.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$cc=r.platform,e.$dc=r.arch});var Rt=this&&this.__createBinding||(Object.create?function(G,e,n,r){r===void 0&&(r=n);var k=Object.getOwnPropertyDescriptor(e,n);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(G,r,k)}:function(G,e,n,r){r===void 0&&(r=n),G[r]=e[n]}),At=this&&this.__setModuleDefault||(Object.create?function(G,e){Object.defineProperty(G,"default",{enumerable:!0,value:e})}:function(G,e){G.default=e}),Ie=this&&this.__importStar||function(G){if(G&&G.__esModule)return G;var e={};if(G!=null)for(var n in G)n!=="default"&&Object.prototype.hasOwnProperty.call(G,n)&&Rt(e,G,n);return At(e,G),e};define(le[9],he([0,1,36]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0,n=Ie(n);const r=65,k=97,R=90,T=122,I=46,p=47,c=92,m=58,h=63;class d extends Error{constructor(o,s,a){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const S=o.indexOf(".")!==-1?"property":"argument";let y=`The "${o}" ${S} ${l} of type ${s}`;y+=`. Received type ${typeof a}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function w(i,o){if(i===null||typeof i!="object")throw new d(o,"Object",i)}function f(i,o){if(typeof i!="string")throw new d(o,"string",i)}const g=n.$cc==="win32";function v(i){return i===p||i===c}function b(i){return i===p}function $(i){return i>=r&&i<=R||i>=k&&i<=T}function P(i,o,s,a){let l="",S=0,y=-1,D=0,L=0;for(let A=0;A<=i.length;++A){if(A<i.length)L=i.charCodeAt(A);else{if(a(L))break;L=p}if(a(L)){if(!(y===A-1||D===1))if(D===2){if(l.length<2||S!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const O=l.lastIndexOf(s);O===-1?(l="",S=0):(l=l.slice(0,O),S=l.length-1-l.lastIndexOf(s)),y=A,D=0;continue}else if(l.length!==0){l="",S=0,y=A,D=0;continue}}o&&(l+=l.length>0?`${s}..`:"..",S=2)}else l.length>0?l+=`${s}${i.slice(y+1,A)}`:l=i.slice(y+1,A),S=A-y-1;y=A,D=0}else L===I&&D!==-1?++D:D=-1}return l}function E(i){return i?`${i[0]==="."?"":"."}${i}`:""}function t(i,o){w(o,"pathObject");const s=o.dir||o.root,a=o.base||`${o.name||""}${E(o.ext)}`;return s?s===o.root?`${s}${a}`:`${s}${i}${a}`:a}e.$ec={resolve(...i){let o="",s="",a=!1;for(let l=i.length-1;l>=-1;l--){let S;if(l>=0){if(S=i[l],f(S,`paths[${l}]`),S.length===0)continue}else o.length===0?S=n.cwd():(S=n.env[`=${o}`]||n.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==o.toLowerCase()&&S.charCodeAt(2)===c)&&(S=`${o}\\`));const y=S.length;let D=0,L="",A=!1;const O=S.charCodeAt(0);if(y===1)v(O)&&(D=1,A=!0);else if(v(O))if(A=!0,v(S.charCodeAt(1))){let W=2,V=W;for(;W<y&&!v(S.charCodeAt(W));)W++;if(W<y&&W!==V){const H=S.slice(V,W);for(V=W;W<y&&v(S.charCodeAt(W));)W++;if(W<y&&W!==V){for(V=W;W<y&&!v(S.charCodeAt(W));)W++;(W===y||W!==V)&&(L=`\\\\${H}\\${S.slice(V,W)}`,D=W)}}}else D=1;else $(O)&&S.charCodeAt(1)===m&&(L=S.slice(0,2),D=2,y>2&&v(S.charCodeAt(2))&&(A=!0,D=3));if(L.length>0)if(o.length>0){if(L.toLowerCase()!==o.toLowerCase())continue}else o=L;if(a){if(o.length>0)break}else if(s=`${S.slice(D)}\\${s}`,a=A,A&&o.length>0)break}return s=P(s,!a,"\\",v),a?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){f(i,"path");const o=i.length;if(o===0)return".";let s=0,a,l=!1;const S=i.charCodeAt(0);if(o===1)return b(S)?"\\":i;if(v(S))if(l=!0,v(i.charCodeAt(1))){let D=2,L=D;for(;D<o&&!v(i.charCodeAt(D));)D++;if(D<o&&D!==L){const A=i.slice(L,D);for(L=D;D<o&&v(i.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&!v(i.charCodeAt(D));)D++;if(D===o)return`\\\\${A}\\${i.slice(L)}\\`;D!==L&&(a=`\\\\${A}\\${i.slice(L,D)}`,s=D)}}}else s=1;else $(S)&&i.charCodeAt(1)===m&&(a=i.slice(0,2),s=2,o>2&&v(i.charCodeAt(2))&&(l=!0,s=3));let y=s<o?P(i.slice(s),!l,"\\",v):"";return y.length===0&&!l&&(y="."),y.length>0&&v(i.charCodeAt(o-1))&&(y+="\\"),a===void 0?l?`\\${y}`:y:l?`${a}\\${y}`:`${a}${y}`},isAbsolute(i){f(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return v(s)||o>2&&$(s)&&i.charCodeAt(1)===m&&v(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let S=0;S<i.length;++S){const y=i[S];f(y,"path"),y.length>0&&(o===void 0?o=s=y:o+=`\\${y}`)}if(o===void 0)return".";let a=!0,l=0;if(typeof s=="string"&&v(s.charCodeAt(0))){++l;const S=s.length;S>1&&v(s.charCodeAt(1))&&(++l,S>2&&(v(s.charCodeAt(2))?++l:a=!1))}if(a){for(;l<o.length&&v(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.$ec.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o)return"";const s=e.$ec.resolve(i),a=e.$ec.resolve(o);if(s===a||(i=s.toLowerCase(),o=a.toLowerCase(),i===o))return"";let l=0;for(;l<i.length&&i.charCodeAt(l)===c;)l++;let S=i.length;for(;S-1>l&&i.charCodeAt(S-1)===c;)S--;const y=S-l;let D=0;for(;D<o.length&&o.charCodeAt(D)===c;)D++;let L=o.length;for(;L-1>D&&o.charCodeAt(L-1)===c;)L--;const A=L-D,O=y<A?y:A;let W=-1,V=0;for(;V<O;V++){const Y=i.charCodeAt(l+V);if(Y!==o.charCodeAt(D+V))break;Y===c&&(W=V)}if(V!==O){if(W===-1)return a}else{if(A>O){if(o.charCodeAt(D+V)===c)return a.slice(D+V+1);if(V===2)return a.slice(D+V)}y>O&&(i.charCodeAt(l+V)===c?W=V:V===2&&(W=3)),W===-1&&(W=0)}let H="";for(V=l+W+1;V<=S;++V)(V===S||i.charCodeAt(V)===c)&&(H+=H.length===0?"..":"\\..");return D+=W,H.length>0?`${H}${a.slice(D,L)}`:(a.charCodeAt(D)===c&&++D,a.slice(D,L))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$ec.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const s=o.charCodeAt(2);if(s!==h&&s!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if($(o.charCodeAt(0))&&o.charCodeAt(1)===m&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return i},dirname(i){f(i,"path");const o=i.length;if(o===0)return".";let s=-1,a=0;const l=i.charCodeAt(0);if(o===1)return v(l)?i:".";if(v(l)){if(s=a=1,v(i.charCodeAt(1))){let D=2,L=D;for(;D<o&&!v(i.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&v(i.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&!v(i.charCodeAt(D));)D++;if(D===o)return i;D!==L&&(s=a=D+1)}}}}else $(l)&&i.charCodeAt(1)===m&&(s=o>2&&v(i.charCodeAt(2))?3:2,a=s);let S=-1,y=!0;for(let D=o-1;D>=a;--D)if(v(i.charCodeAt(D))){if(!y){S=D;break}}else y=!1;if(S===-1){if(s===-1)return".";S=s}return i.slice(0,S)},basename(i,o){o!==void 0&&f(o,"suffix"),f(i,"path");let s=0,a=-1,l=!0,S;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===m&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let y=o.length-1,D=-1;for(S=i.length-1;S>=s;--S){const L=i.charCodeAt(S);if(v(L)){if(!l){s=S+1;break}}else D===-1&&(l=!1,D=S+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=S):(y=-1,a=D))}return s===a?a=D:a===-1&&(a=i.length),i.slice(s,a)}for(S=i.length-1;S>=s;--S)if(v(i.charCodeAt(S))){if(!l){s=S+1;break}}else a===-1&&(l=!1,a=S+1);return a===-1?"":i.slice(s,a)},extname(i){f(i,"path");let o=0,s=-1,a=0,l=-1,S=!0,y=0;i.length>=2&&i.charCodeAt(1)===m&&$(i.charCodeAt(0))&&(o=a=2);for(let D=i.length-1;D>=o;--D){const L=i.charCodeAt(D);if(v(L)){if(!S){a=D+1;break}continue}l===-1&&(S=!1,l=D+1),L===I?s===-1?s=D:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||l===-1||y===0||y===1&&s===l-1&&s===a+1?"":i.slice(s,l)},format:t.bind(null,"\\"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let a=0,l=i.charCodeAt(0);if(s===1)return v(l)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(v(l)){if(a=1,v(i.charCodeAt(1))){let W=2,V=W;for(;W<s&&!v(i.charCodeAt(W));)W++;if(W<s&&W!==V){for(V=W;W<s&&v(i.charCodeAt(W));)W++;if(W<s&&W!==V){for(V=W;W<s&&!v(i.charCodeAt(W));)W++;W===s?a=W:W!==V&&(a=W+1)}}}}else if($(l)&&i.charCodeAt(1)===m){if(s<=2)return o.root=o.dir=i,o;if(a=2,v(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;a=3}}a>0&&(o.root=i.slice(0,a));let S=-1,y=a,D=-1,L=!0,A=i.length-1,O=0;for(;A>=a;--A){if(l=i.charCodeAt(A),v(l)){if(!L){y=A+1;break}continue}D===-1&&(L=!1,D=A+1),l===I?S===-1?S=A:O!==1&&(O=1):S!==-1&&(O=-1)}return D!==-1&&(S===-1||O===0||O===1&&S===D-1&&S===y+1?o.base=o.name=i.slice(y,D):(o.name=i.slice(y,S),o.base=i.slice(y,D),o.ext=i.slice(S,D))),y>0&&y!==a?o.dir=i.slice(0,y-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(g){const i=/\\/g;return()=>{const o=n.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$fc={resolve(...i){let o="",s=!1;for(let a=i.length-1;a>=-1&&!s;a--){const l=a>=0?i[a]:u();f(l,`paths[${a}]`),l.length!==0&&(o=`${l}/${o}`,s=l.charCodeAt(0)===p)}return o=P(o,!s,"/",b),s?`/${o}`:o.length>0?o:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===p,s=i.charCodeAt(i.length-1)===p;return i=P(i,!o,"/",b),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===p},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const a=i[s];f(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.$fc.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o||(i=e.$fc.resolve(i),o=e.$fc.resolve(o),i===o))return"";const s=1,a=i.length,l=a-s,S=1,y=o.length-S,D=l<y?l:y;let L=-1,A=0;for(;A<D;A++){const W=i.charCodeAt(s+A);if(W!==o.charCodeAt(S+A))break;W===p&&(L=A)}if(A===D)if(y>D){if(o.charCodeAt(S+A)===p)return o.slice(S+A+1);if(A===0)return o.slice(S+A)}else l>D&&(i.charCodeAt(s+A)===p?L=A:A===0&&(L=0));let O="";for(A=s+L+1;A<=a;++A)(A===a||i.charCodeAt(A)===p)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(S+L)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===p;let s=-1,a=!0;for(let l=i.length-1;l>=1;--l)if(i.charCodeAt(l)===p){if(!a){s=l;break}}else a=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let s=0,a=-1,l=!0,S;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let y=o.length-1,D=-1;for(S=i.length-1;S>=0;--S){const L=i.charCodeAt(S);if(L===p){if(!l){s=S+1;break}}else D===-1&&(l=!1,D=S+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=S):(y=-1,a=D))}return s===a?a=D:a===-1&&(a=i.length),i.slice(s,a)}for(S=i.length-1;S>=0;--S)if(i.charCodeAt(S)===p){if(!l){s=S+1;break}}else a===-1&&(l=!1,a=S+1);return a===-1?"":i.slice(s,a)},extname(i){f(i,"path");let o=-1,s=0,a=-1,l=!0,S=0;for(let y=i.length-1;y>=0;--y){const D=i.charCodeAt(y);if(D===p){if(!l){s=y+1;break}continue}a===-1&&(l=!1,a=y+1),D===I?o===-1?o=y:S!==1&&(S=1):o!==-1&&(S=-1)}return o===-1||a===-1||S===0||S===1&&o===a-1&&o===s+1?"":i.slice(o,a)},format:t.bind(null,"/"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===p;let a;s?(o.root="/",a=1):a=0;let l=-1,S=0,y=-1,D=!0,L=i.length-1,A=0;for(;L>=a;--L){const O=i.charCodeAt(L);if(O===p){if(!D){S=L+1;break}continue}y===-1&&(D=!1,y=L+1),O===I?l===-1?l=L:A!==1&&(A=1):l!==-1&&(A=-1)}if(y!==-1){const O=S===0&&s?1:S;l===-1||A===0||A===1&&l===y-1&&l===S+1?o.base=o.name=i.slice(O,y):(o.name=i.slice(O,l),o.base=i.slice(O,y),o.ext=i.slice(l,y))}return S>0?o.dir=i.slice(0,S-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=g?e.$ec.normalize:e.$fc.normalize,e.$hc=g?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=g?e.$ec.join:e.$fc.join,e.$jc=g?e.$ec.resolve:e.$fc.resolve,e.$kc=g?e.$ec.relative:e.$fc.relative,e.$lc=g?e.$ec.dirname:e.$fc.dirname,e.$mc=g?e.$ec.basename:e.$fc.basename,e.$nc=g?e.$ec.extname:e.$fc.extname,e.$oc=g?e.$ec.format:e.$fc.format,e.$pc=g?e.$ec.parse:e.$fc.parse,e.$qc=g?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=g?e.$ec.sep:e.$fc.sep,e.$sc=g?e.$ec.delimiter:e.$fc.delimiter}),define(le[79],he([0,1,3]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$im=R,e.$jm=T;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function R(I,...p){const c=p.reduce((d,w)=>(d[w]=!0,d),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(d=>!c[d]).forEach(d=>{for(let w=0;w<m.length;w++)if(d.search(m[w])!==-1){delete I[d];break}})}function T(I){I&&(delete I.DEBUG,n.$l&&delete I.LD_PRELOAD)}}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:G)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function n(r){if(e[r])return e[r].exports;var k=e[r]={i:r,l:!1,exports:{}};return G[r].call(k.exports,k,k.exports,n),k.l=!0,k.exports}return n.m=G,n.c=e,n.d=function(r,k,R){n.o(r,k)||Object.defineProperty(r,k,{enumerable:!0,get:R})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,k){if(1&k&&(r=n(r)),8&k||4&k&&typeof r=="object"&&r&&r.__esModule)return r;var R=Object.create(null);if(n.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:r}),2&k&&typeof r!="string")for(var T in r)n.d(R,T,function(I){return r[I]}.bind(null,T));return R},n.n=function(r){var k=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(k,"a",k),k},n.o=function(r,k){return Object.prototype.hasOwnProperty.call(r,k)},n.p="",n(n.s=0)}([function(G,e,n){(function(r){var k;e=G.exports=ce,k=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],p=e.src=[],c=0,m=c++;p[m]="0|[1-9]\\d*";var h=c++;p[h]="[0-9]+";var d=c++;p[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=c++;p[w]="("+p[m]+")\\.("+p[m]+")\\.("+p[m]+")";var f=c++;p[f]="("+p[h]+")\\.("+p[h]+")\\.("+p[h]+")";var g=c++;p[g]="(?:"+p[m]+"|"+p[d]+")";var v=c++;p[v]="(?:"+p[h]+"|"+p[d]+")";var b=c++;p[b]="(?:-("+p[g]+"(?:\\."+p[g]+")*))";var $=c++;p[$]="(?:-?("+p[v]+"(?:\\."+p[v]+")*))";var P=c++;p[P]="[0-9A-Za-z-]+";var E=c++;p[E]="(?:\\+("+p[P]+"(?:\\."+p[P]+")*))";var t=c++,u="v?"+p[w]+p[b]+"?"+p[E]+"?";p[t]="^"+u+"$";var i="[v=\\s]*"+p[f]+p[$]+"?"+p[E]+"?",o=c++;p[o]="^"+i+"$";var s=c++;p[s]="((?:<|>)?=?)";var a=c++;p[a]=p[h]+"|x|X|\\*";var l=c++;p[l]=p[m]+"|x|X|\\*";var S=c++;p[S]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[b]+")?"+p[E]+"?)?)?";var y=c++;p[y]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[$]+")?"+p[E]+"?)?)?";var D=c++;p[D]="^"+p[s]+"\\s*"+p[S]+"$";var L=c++;p[L]="^"+p[s]+"\\s*"+p[y]+"$";var A=c++;p[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=c++;p[O]="(?:~>?)";var W=c++;p[W]="(\\s*)"+p[O]+"\\s+",I[W]=new RegExp(p[W],"g");var V=c++;p[V]="^"+p[O]+p[S]+"$";var H=c++;p[H]="^"+p[O]+p[y]+"$";var Y=c++;p[Y]="(?:\\^)";var Z=c++;p[Z]="(\\s*)"+p[Y]+"\\s+",I[Z]=new RegExp(p[Z],"g");var U=c++;p[U]="^"+p[Y]+p[S]+"$";var te=c++;p[te]="^"+p[Y]+p[y]+"$";var x=c++;p[x]="^"+p[s]+"\\s*("+i+")$|^$";var J=c++;p[J]="^"+p[s]+"\\s*("+u+")$|^$";var B=c++;p[B]="(\\s*)"+p[s]+"\\s*("+i+"|"+p[S]+")",I[B]=new RegExp(p[B],"g");var j=c++;p[j]="^\\s*("+p[S]+")\\s+-\\s+("+p[S]+")\\s*$";var C=c++;p[C]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var X=c++;p[X]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)k(ae,p[ae]),I[ae]||(I[ae]=new RegExp(p[ae]));function K(ee,ue){if(ee instanceof ce)return ee;if(typeof ee!="string"||ee.length>R||!(ue?I[o]:I[t]).test(ee))return null;try{return new ce(ee,ue)}catch{return null}}function ce(ee,ue){if(ee instanceof ce){if(ee.loose===ue)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ce))return new ce(ee,ue);k("SemVer",ee,ue),this.loose=ue;var fe=ee.trim().match(ue?I[o]:I[t]);if(!fe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ae=+be;if(Ae>=0&&Ae<T)return Ae}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=K,e.valid=function(ee,ue){var fe=K(ee,ue);return fe?fe.version:null},e.clean=function(ee,ue){var fe=K(ee.trim().replace(/^[=v]+/,""),ue);return fe?fe.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(ee){return k("SemVer.compare",this.version,this.loose,ee),ee instanceof ce||(ee=new ce(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},ce.prototype.compareMain=function(ee){return ee instanceof ce||(ee=new ce(ee,this.loose)),ie(this.major,ee.major)||ie(this.minor,ee.minor)||ie(this.patch,ee.patch)},ce.prototype.comparePre=function(ee){if(ee instanceof ce||(ee=new ce(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ue=0;do{var fe=this.prerelease[ue],be=ee.prerelease[ue];if(k("prerelease compare",ue,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return ie(fe,be)}while(++ue)},ce.prototype.inc=function(ee,ue){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ue,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new ce(ee,fe).inc(ue,be).version}catch{return null}},e.diff=function(ee,ue){if(z(ee,ue))return null;var fe=K(ee),be=K(ue);if(fe.prerelease.length||be.prerelease.length){for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==be[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==be[Ae])return Ae},e.compareIdentifiers=ie;var se=/^[0-9]+$/;function ie(ee,ue){var fe=se.test(ee),be=se.test(ue);return fe&&be&&(ee=+ee,ue=+ue),fe&&!be?-1:be&&!fe?1:ee<ue?-1:ee>ue?1:0}function M(ee,ue,fe){return new ce(ee,fe).compare(new ce(ue,fe))}function F(ee,ue,fe){return M(ee,ue,fe)>0}function N(ee,ue,fe){return M(ee,ue,fe)<0}function z(ee,ue,fe){return M(ee,ue,fe)===0}function _(ee,ue,fe){return M(ee,ue,fe)!==0}function Q(ee,ue,fe){return M(ee,ue,fe)>=0}function q(ee,ue,fe){return M(ee,ue,fe)<=0}function re(ee,ue,fe,be){var Ae;switch(ue){case"===":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),Ae=ee===fe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),Ae=ee!==fe;break;case"":case"=":case"==":Ae=z(ee,fe,be);break;case"!=":Ae=_(ee,fe,be);break;case">":Ae=F(ee,fe,be);break;case">=":Ae=Q(ee,fe,be);break;case"<":Ae=N(ee,fe,be);break;case"<=":Ae=q(ee,fe,be);break;default:throw new TypeError("Invalid operator: "+ue)}return Ae}function de(ee,ue){if(ee instanceof de){if(ee.loose===ue)return ee;ee=ee.value}if(!(this instanceof de))return new de(ee,ue);k("comparator",ee,ue),this.loose=ue,this.parse(ee),this.semver===me?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ee,ue){return ie(ue,ee)},e.major=function(ee,ue){return new ce(ee,ue).major},e.minor=function(ee,ue){return new ce(ee,ue).minor},e.patch=function(ee,ue){return new ce(ee,ue).patch},e.compare=M,e.compareLoose=function(ee,ue){return M(ee,ue,!0)},e.rcompare=function(ee,ue,fe){return M(ue,ee,fe)},e.sort=function(ee,ue){return ee.sort(function(fe,be){return e.compare(fe,be,ue)})},e.rsort=function(ee,ue){return ee.sort(function(fe,be){return e.rcompare(fe,be,ue)})},e.gt=F,e.lt=N,e.eq=z,e.neq=_,e.gte=Q,e.lte=q,e.cmp=re,e.Comparator=de;var me={};function we(ee,ue){if(ee instanceof we)return ee.loose===ue?ee:new we(ee.raw,ue);if(ee instanceof de)return new we(ee.value,ue);if(!(this instanceof we))return new we(ee,ue);if(this.loose=ue,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function De(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function ke(ee,ue,fe,be,Ae,Ne,Me,Oe,Be,Ke,Ze,qe,Qe){return((ue=De(fe)?"":De(be)?">="+fe+".0.0":De(Ae)?">="+fe+"."+be+".0":">="+ue)+" "+(Oe=De(Be)?"":De(Ke)?"<"+(+Be+1)+".0.0":De(Ze)?"<"+Be+"."+(+Ke+1)+".0":qe?"<="+Be+"."+Ke+"."+Ze+"-"+qe:"<="+Oe)).trim()}function Pe(ee,ue){for(var fe=0;fe<ee.length;fe++)if(!ee[fe].test(ue))return!1;if(ue.prerelease.length){for(fe=0;fe<ee.length;fe++)if(k(ee[fe].semver),ee[fe].semver!==me&&ee[fe].semver.prerelease.length>0){var be=ee[fe].semver;if(be.major===ue.major&&be.minor===ue.minor&&be.patch===ue.patch)return!0}return!1}return!0}function Re(ee,ue,fe){try{ue=new we(ue,fe)}catch{return!1}return ue.test(ee)}function $e(ee,ue,fe,be){var Ae,Ne,Me,Oe,Be;switch(ee=new ce(ee,be),ue=new we(ue,be),fe){case">":Ae=F,Ne=q,Me=N,Oe=">",Be=">=";break;case"<":Ae=N,Ne=Q,Me=F,Oe="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re(ee,ue,be))return!1;for(var Ke=0;Ke<ue.set.length;++Ke){var Ze=ue.set[Ke],qe=null,Qe=null;if(Ze.forEach(function(Je){Je.semver===me&&(Je=new de(">=0.0.0")),qe=qe||Je,Qe=Qe||Je,Ae(Je.semver,qe.semver,be)?qe=Je:Me(Je.semver,Qe.semver,be)&&(Qe=Je)}),qe.operator===Oe||qe.operator===Be||(!Qe.operator||Qe.operator===Oe)&&Ne(ee,Qe.semver)||Qe.operator===Be&&Me(ee,Qe.semver))return!1}return!0}de.prototype.parse=function(ee){var ue=this.loose?I[x]:I[J],fe=ee.match(ue);if(!fe)throw new TypeError("Invalid comparator: "+ee);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new ce(fe[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(ee){return k("Comparator.test",ee,this.loose),this.semver===me||(typeof ee=="string"&&(ee=new ce(ee,this.loose)),re(ee,this.operator,this.semver,this.loose))},de.prototype.intersects=function(ee,ue){if(!(ee instanceof de))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(ee.value,ue),Re(this.value,fe,ue);if(ee.operator==="")return fe=new we(this.value,ue),Re(ee.semver,fe,ue);var be=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Ne=this.semver.version===ee.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Oe=re(this.semver,"<",ee.semver,ue)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Be=re(this.semver,">",ee.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return be||Ae||Ne&&Me||Oe||Be},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(ee){var ue=this.loose;ee=ee.trim(),k("range",ee,ue);var fe=ue?I[C]:I[j];ee=ee.replace(fe,ke),k("hyphen replace",ee),ee=ee.replace(I[B],"$1$2$3"),k("comparator trim",ee,I[B]),ee=(ee=(ee=ee.replace(I[W],"$1~")).replace(I[Z],"$1^")).split(/\s+/).join(" ");var be=ue?I[x]:I[J],Ae=ee.split(" ").map(function(Ne){return function(Me,Oe){return k("comp",Me),Me=function(Be,Ke){return Be.trim().split(/\s+/).map(function(Ze){return function(qe,Qe){k("caret",qe,Qe);var Je=Qe?I[te]:I[U];return qe.replace(Je,function(Xe,Ce,ne,ge,pe){var ye;return k("caret",qe,Xe,Ce,ne,ge,pe),De(Ce)?ye="":De(ne)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":De(ge)?ye=Ce==="0"?">="+Ce+"."+ne+".0 <"+Ce+"."+(+ne+1)+".0":">="+Ce+"."+ne+".0 <"+(+Ce+1)+".0.0":pe?(k("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=Ce==="0"?ne==="0"?">="+Ce+"."+ne+"."+ge+pe+" <"+Ce+"."+ne+"."+(+ge+1):">="+Ce+"."+ne+"."+ge+pe+" <"+Ce+"."+(+ne+1)+".0":">="+Ce+"."+ne+"."+ge+pe+" <"+(+Ce+1)+".0.0"):(k("no pr"),ye=Ce==="0"?ne==="0"?">="+Ce+"."+ne+"."+ge+" <"+Ce+"."+ne+"."+(+ge+1):">="+Ce+"."+ne+"."+ge+" <"+Ce+"."+(+ne+1)+".0":">="+Ce+"."+ne+"."+ge+" <"+(+Ce+1)+".0.0"),k("caret return",ye),ye})}(Ze,Ke)}).join(" ")}(Me,Oe),k("caret",Me),Me=function(Be,Ke){return Be.trim().split(/\s+/).map(function(Ze){return function(qe,Qe){var Je=Qe?I[H]:I[V];return qe.replace(Je,function(Xe,Ce,ne,ge,pe){var ye;return k("tilde",qe,Xe,Ce,ne,ge,pe),De(Ce)?ye="":De(ne)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":De(ge)?ye=">="+Ce+"."+ne+".0 <"+Ce+"."+(+ne+1)+".0":pe?(k("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+Ce+"."+ne+"."+ge+pe+" <"+Ce+"."+(+ne+1)+".0"):ye=">="+Ce+"."+ne+"."+ge+" <"+Ce+"."+(+ne+1)+".0",k("tilde return",ye),ye})}(Ze,Ke)}).join(" ")}(Me,Oe),k("tildes",Me),Me=function(Be,Ke){return k("replaceXRanges",Be,Ke),Be.split(/\s+/).map(function(Ze){return function(qe,Qe){qe=qe.trim();var Je=Qe?I[L]:I[D];return qe.replace(Je,function(Xe,Ce,ne,ge,pe,ye){k("xRange",qe,Xe,Ce,ne,ge,pe,ye);var We=De(ne),Ue=We||De(ge),_e=Ue||De(pe);return Ce==="="&&_e&&(Ce=""),We?Xe=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&_e?(Ue&&(ge=0),_e&&(pe=0),Ce===">"?(Ce=">=",Ue?(ne=+ne+1,ge=0,pe=0):_e&&(ge=+ge+1,pe=0)):Ce==="<="&&(Ce="<",Ue?ne=+ne+1:ge=+ge+1),Xe=Ce+ne+"."+ge+"."+pe):Ue?Xe=">="+ne+".0.0 <"+(+ne+1)+".0.0":_e&&(Xe=">="+ne+"."+ge+".0 <"+ne+"."+(+ge+1)+".0"),k("xRange return",Xe),Xe})}(Ze,Ke)}).join(" ")}(Me,Oe),k("xrange",Me),Me=function(Be,Ke){return k("replaceStars",Be,Ke),Be.trim().replace(I[X],"")}(Me,Oe),k("stars",Me),Me}(Ne,ue)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Ne){return!!Ne.match(be)})),Ae=Ae.map(function(Ne){return new de(Ne,ue)})},we.prototype.intersects=function(ee,ue){if(!(ee instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return ee.set.some(function(Ae){return Ae.every(function(Ne){return be.intersects(Ne,ue)})})})})},e.toComparators=function(ee,ue){return new we(ee,ue).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new ce(ee,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Pe(this.set[ue],ee))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function(ee,ue,fe){var be=null,Ae=null;try{var Ne=new we(ue,fe)}catch{return null}return ee.forEach(function(Me){Ne.test(Me)&&(be&&Ae.compare(Me)!==-1||(Ae=new ce(be=Me,fe)))}),be},e.minSatisfying=function(ee,ue,fe){var be=null,Ae=null;try{var Ne=new we(ue,fe)}catch{return null}return ee.forEach(function(Me){Ne.test(Me)&&(be&&Ae.compare(Me)!==1||(Ae=new ce(be=Me,fe)))}),be},e.validRange=function(ee,ue){try{return new we(ee,ue).range||"*"}catch{return null}},e.ltr=function(ee,ue,fe){return $e(ee,ue,"<",fe)},e.gtr=function(ee,ue,fe){return $e(ee,ue,">",fe)},e.outside=$e,e.prerelease=function(ee,ue){var fe=K(ee,ue);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ee,ue,fe){return ee=new we(ee,fe),ue=new we(ue,fe),ee.intersects(ue)},e.coerce=function(ee){if(ee instanceof ce)return ee;if(typeof ee!="string")return null;var ue=ee.match(I[A]);return ue==null?null:K((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,n(1))},function(G,e){var n,r,k=G.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(v){if(n===setTimeout)return setTimeout(v,0);if((n===R||!n)&&setTimeout)return n=setTimeout,setTimeout(v,0);try{return n(v,0)}catch{try{return n.call(null,v,0)}catch{return n.call(this,v,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:R}catch{n=R}try{r=typeof clearTimeout=="function"?clearTimeout:T}catch{r=T}})();var p,c=[],m=!1,h=-1;function d(){m&&p&&(m=!1,p.length?c=p.concat(c):h=-1,c.length&&w())}function w(){if(!m){var v=I(d);m=!0;for(var b=c.length;b;){for(p=c,c=[];++h<b;)p&&p[h].run();h=-1,b=c.length}p=null,m=!1,function($){if(r===clearTimeout)return clearTimeout($);if((r===T||!r)&&clearTimeout)return r=clearTimeout,clearTimeout($);try{r($)}catch{try{return r.call(null,$)}catch{return r.call(this,$)}}}(v)}}function f(v,b){this.fun=v,this.array=b}function g(){}k.nextTick=function(v){var b=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)b[$-1]=arguments[$];c.push(new f(v,b)),c.length!==1||m||I(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=g,k.addListener=g,k.once=g,k.off=g,k.removeListener=g,k.removeAllListeners=g,k.emit=g,k.prependListener=g,k.prependOnceListener=g,k.listeners=function(v){return[]},k.binding=function(v){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(v){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(le[145],he([0,1]),function(G,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class r{constructor(I,p,c){this.level=I,this.key=p,this.value=c,this.forward=[]}}const k=void 0;class R{constructor(I,p=2**16){this.comparator=I,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new r(this.c,k,k)}get size(){return this.f}clear(){this.e=new r(this.c,k,k),this.f=0}has(I){return!!R.g(this,I,this.comparator)}get(I){return R.g(this,I,this.comparator)?.value}set(I,p){return R.h(this,I,p,this.comparator)&&(this.f+=1),this}delete(I){const p=R.k(this,I,this.comparator);return p&&(this.f-=1),p}forEach(I,p){let c=this.e.forward[0];for(;c;)I.call(p,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",p=this.e.forward[0];for(;p;)I+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return I}static g(I,p,c){let m=I.e;for(let h=I.d-1;h>=0;h--)for(;m.forward[h]&&c(m.forward[h].key,p)<0;)m=m.forward[h];if(m=m.forward[0],m&&c(m.key,p)===0)return m}static h(I,p,c,m){const h=[];let d=I.e;for(let w=I.d-1;w>=0;w--){for(;d.forward[w]&&m(d.forward[w].key,p)<0;)d=d.forward[w];h[w]=d}if(d=d.forward[0],d&&m(d.key,p)===0)return d.value=c,!1;{const w=R.j(I);if(w>I.d){for(let f=I.d;f<w;f++)h[f]=I.e;I.d=w}d=new r(w,p,c);for(let f=0;f<w;f++)d.forward[f]=h[f].forward[f],h[f].forward[f]=d;return!0}}static j(I,p=.5){let c=1;for(;Math.random()<p&&c<I.c;)c+=1;return c}static k(I,p,c){const m=[];let h=I.e;for(let d=I.d-1;d>=0;d--){for(;h.forward[d]&&c(h.forward[d].key,p)<0;)h=h.forward[d];m[d]=h}if(h=h.forward[0],!h||c(h.key,p)!==0)return!1;for(let d=0;d<I.d&&m[d].forward[d]===h;d++)m[d].forward[d]=h.forward[d];for(;I.d>0&&I.e.forward[I.d-1]===k;)I.d-=1;return!0}}e.$Qs=R}),define(le[66],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(R){return new r(R)}constructor(R){this.c=n&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=r}),define(le[4],he([0,1,15,89,2,108,66]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=w;const I=!1,p=!1,c=!1;var m;(function(H){H.None=()=>k.$Tc.None;function Y(ke){if(c){const{onDidAddListener:Pe}=ke,Re=g.create();let $e=0;ke.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),Pe?.()}}}function Z(ke,Pe){return K(ke,()=>{},0,void 0,!0,void 0,Pe)}H.defer=Z;function U(ke){return(Pe,Re=null,$e)=>{let ee=!1,ue;return ue=ke(fe=>{if(!ee)return ue?ue.dispose():ee=!0,Pe.call(Re,fe)},null,$e),ee&&ue.dispose(),ue}}H.once=U;function te(ke,Pe,Re){return X(($e,ee=null,ue)=>ke(fe=>$e.call(ee,Pe(fe)),null,ue),Re)}H.map=te;function x(ke,Pe,Re){return X(($e,ee=null,ue)=>ke(fe=>{Pe(fe),$e.call(ee,fe)},null,ue),Re)}H.forEach=x;function J(ke,Pe,Re){return X(($e,ee=null,ue)=>ke(fe=>Pe(fe)&&$e.call(ee,fe),null,ue),Re)}H.filter=J;function B(ke){return ke}H.signal=B;function j(...ke){return(Pe,Re=null,$e)=>{const ee=(0,k.$Qc)(...ke.map(ue=>ue(fe=>Pe.call(Re,fe))));return ae(ee,$e)}}H.any=j;function C(ke,Pe,Re,$e){let ee=Re;return te(ke,ue=>(ee=Pe(ee,ue),ee),$e)}H.reduce=C;function X(ke,Pe){let Re;const $e={onWillAddFirstListener(){Re=ke(ee.fire,ee)},onDidRemoveLastListener(){Re?.dispose()}};Pe||Y($e);const ee=new i($e);return Pe?.add(ee),ee.event}function ae(ke,Pe){return Pe instanceof Array?Pe.push(ke):Pe&&Pe.add(ke),ke}function K(ke,Pe,Re=100,$e=!1,ee=!1,ue,fe){let be,Ae,Ne,Me=0,Oe;const Be={leakWarningThreshold:ue,onWillAddFirstListener(){be=ke(Ze=>{Me++,Ae=Pe(Ae,Ze),$e&&!Ne&&(Ke.fire(Ae),Ae=void 0),Oe=()=>{const qe=Ae;Ae=void 0,Ne=void 0,(!$e||Me>1)&&Ke.fire(qe),Me=0},typeof Re=="number"?(clearTimeout(Ne),Ne=setTimeout(Oe,Re)):Ne===void 0&&(Ne=0,queueMicrotask(Oe))})},onWillRemoveListener(){ee&&Me>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,be.dispose()}};fe||Y(Be);const Ke=new i(Be);return fe?.add(Ke),Ke.event}H.debounce=K;function ce(ke,Pe=0,Re){return H.debounce(ke,($e,ee)=>$e?($e.push(ee),$e):[ee],Pe,void 0,!0,void 0,Re)}H.accumulate=ce;function se(ke,Pe=($e,ee)=>$e===ee,Re){let $e=!0,ee;return J(ke,ue=>{const fe=$e||!Pe(ue,ee);return $e=!1,ee=ue,fe},Re)}H.latch=se;function ie(ke,Pe,Re){return[H.filter(ke,Pe,Re),H.filter(ke,$e=>!Pe($e),Re)]}H.split=ie;function M(ke,Pe=!1,Re=[],$e){let ee=Re.slice(),ue=ke(Ae=>{ee?ee.push(Ae):be.fire(Ae)});$e&&$e.add(ue);const fe=()=>{ee?.forEach(Ae=>be.fire(Ae)),ee=null},be=new i({onWillAddFirstListener(){ue||(ue=ke(Ae=>be.fire(Ae)),$e&&$e.add(ue))},onDidAddFirstListener(){ee&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return $e&&$e.add(be),be.event}H.buffer=M;function F(ke,Pe){return($e,ee,ue)=>{const fe=Pe(new z);return ke(function(be){const Ae=fe.evaluate(be);Ae!==N&&$e.call(ee,Ae)},void 0,ue)}}H.chain=F;const N=Symbol("HaltChainable");class z{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(Re=>(Pe(Re),Re)),this}filter(Pe){return this.f.push(Re=>Pe(Re)?Re:N),this}reduce(Pe,Re){let $e=Re;return this.f.push(ee=>($e=Pe($e,ee),$e)),this}latch(Pe=(Re,$e)=>Re===$e){let Re=!0,$e;return this.f.push(ee=>{const ue=Re||!Pe(ee,$e);return Re=!1,$e=ee,ue?ee:N}),this}evaluate(Pe){for(const Re of this.f)if(Pe=Re(Pe),Pe===N)break;return Pe}}function _(ke,Pe,Re=$e=>$e){const $e=(...be)=>fe.fire(Re(...be)),ee=()=>ke.on(Pe,$e),ue=()=>ke.removeListener(Pe,$e),fe=new i({onWillAddFirstListener:ee,onDidRemoveLastListener:ue});return fe.event}H.fromNodeEventEmitter=_;function Q(ke,Pe,Re=$e=>$e){const $e=(...be)=>fe.fire(Re(...be)),ee=()=>ke.addEventListener(Pe,$e),ue=()=>ke.removeEventListener(Pe,$e),fe=new i({onWillAddFirstListener:ee,onDidRemoveLastListener:ue});return fe.event}H.fromDOMEventEmitter=Q;function q(ke){return new Promise(Pe=>U(ke)(Pe))}H.toPromise=q;function re(ke){const Pe=new i;return ke.then(Re=>{Pe.fire(Re)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}H.fromPromise=re;function de(ke,Pe,Re){return Pe(Re),ke($e=>Pe($e))}H.runAndSubscribe=de;class me{constructor(Pe,Re){this._observable=Pe,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Re||Y($e),this.emitter=new i($e),Re&&Re.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,Re){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(ke,Pe){return new me(ke,Pe).emitter.event}H.fromObservable=we;function De(ke){return(Pe,Re,$e)=>{let ee=0,ue=!1;const fe={beginUpdate(){ee++},endUpdate(){ee--,ee===0&&(ke.reportChanges(),ue&&(ue=!1,Pe.call(Re)))},handlePossibleChange(){},handleChange(){ue=!0}};ke.addObserver(fe),ke.reportChanges();const be={dispose(){ke.removeObserver(fe)}};return $e instanceof k.$Sc?$e.add(be):Array.isArray($e)&&$e.push(be),be}}H.fromObservableLight=De})(m||(e.Event=m={}));class h{static{this.all=new Set}static{this.f=0}constructor(Y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Y}_${h.f++}`,h.all.add(this)}start(Y){this.g=new T.$de,this.listenerCount=Y}stop(){if(this.g){const Y=this.g.elapsed();this.durations.push(Y),this.elapsedOverall+=Y,this.invocationCount+=1,this.g=void 0}}}e.$fe=h;let d=-1;function w(H){const Y=d;return d=H,{dispose(){d=Y}}}class f{static{this.f=1}constructor(Y,Z,U=(f.f++).toString(16).padStart(3,"0")){this.j=Y,this.threshold=Z,this.name=U,this.h=0}dispose(){this.g?.clear()}check(Y,Z){const U=this.threshold;if(U<=0||Z<U)return;this.g||(this.g=new Map);const te=this.g.get(Y.value)||0;if(this.g.set(Y.value,te+1),this.h-=1,this.h<=0){this.h=U*.5;const[x,J]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${Z} listeners already. MOST frequent listener (${J}):`;console.warn(B),console.warn(x);const j=new v(B,x);this.j(j)}return()=>{const x=this.g.get(Y.value)||0;this.g.set(Y.value,x-1)}}getMostFrequentStack(){if(!this.g)return;let Y,Z=0;for(const[U,te]of this.g)(!Y||Z<te)&&(Y=[U,te],Z=te);return Y}}class g{static create(){const Y=new Error;return new g(Y.stack??"")}constructor(Y){this.value=Y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(Y,Z){super(Y),this.name="ListenerLeakError",this.stack=Z}}e.$he=v;class b extends Error{constructor(Y,Z){super(Y),this.name="ListenerRefusalError",this.stack=Z}}e.$ie=b;let $=0;class P{constructor(Y){this.value=Y,this.id=$++}}const E=2,t=(H,Y)=>{if(H instanceof P)Y(H);else for(let Z=0;Z<H.length;Z++){const U=H[Z];U&&Y(U)}};let u;if(I){const H=[];setInterval(()=>{H.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(H.join(`
`)),H.length=0)},3e3),u=new FinalizationRegistry(Y=>{typeof Y=="string"&&H.push(Y)})}class i{constructor(Y){this.z=0,this.f=Y,this.g=d>0||this.f?.leakWarningThreshold?new f(Y?.onListenerError??n.$Y,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(p){const Y=this.u;queueMicrotask(()=>{t(Y,Z=>Z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(Y,Z,U)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const C=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],X=new b(`${j}. HINT: Stack shows most frequent listener (${C[1]}-times)`,C[0]);return(this.f?.onListenerError||n.$Y)(X),k.$Tc.None}if(this.m)return k.$Tc.None;Z&&(Y=Y.bind(Z));const te=new P(Y);let x,J;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(te.stack=g.create(),x=this.g.check(te.stack,this.z+1)),p&&(te.stack=J??g.create()),this.u?this.u instanceof P?(this.w??=new s,this.u=[this.u,te]):this.u.push(te):(this.f?.onWillAddFirstListener?.(this),this.u=te,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,k.$Rc)(()=>{u?.unregister(B),x?.(),this.A(te)});if(U instanceof k.$Sc?U.add(B):Array.isArray(U)&&U.push(B),u){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),C=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);u.register(B,C?.[2]??j,B)}return B},this.q}A(Y){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Z=this.u,U=Z.indexOf(Y);if(U===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Z[U]=void 0;const te=this.w.current===this;if(this.z*E<=Z.length){let x=0;for(let J=0;J<Z.length;J++)Z[J]?Z[x++]=Z[J]:te&&(this.w.end--,x<this.w.i&&this.w.i--);Z.length=x}}B(Y,Z){if(!Y)return;const U=this.f?.onListenerError||n.$Y;if(!U){Y.value(Z);return}try{Y.value(Z)}catch(te){U(te)}}C(Y){const Z=Y.current.u;for(;Y.i<Y.end;)this.B(Z[Y.i++],Y.value);Y.reset()}fire(Y){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,Y);else{const Z=this.w;Z.enqueue(this,Y,this.u.length),this.C(Z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=i;const o=()=>new s;e.$ke=o;class s{constructor(){this.i=-1,this.end=0}enqueue(Y,Z,U){this.i=0,this.end=U,this.current=Y,this.value=Z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends i{async fireAsync(Y,Z,U){if(this.u)for(this.h||(this.h=new R.$4c),t(this.u,te=>this.h.push([te.value,Y]));this.h.size>0&&!Z.isCancellationRequested;){const[te,x]=this.h.shift(),J=[],B={...x,token:Z,waitUntil:j=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");U&&(j=U(j,te)),J.push(j)}};try{te(B)}catch(j){(0,n.$Y)(j);continue}Object.freeze(J),await Promise.allSettled(J).then(j=>{for(const C of j)C.status==="rejected"&&(0,n.$Y)(C.reason)})}}}e.$le=a;class l extends i{get isPaused(){return this.h!==0}constructor(Y){super(Y),this.h=0,this.s=new R.$4c,this.t=Y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const Y=Array.from(this.s);this.s.clear(),super.fire(this.t(Y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(Y){this.z&&(this.h!==0?this.s.push(Y):super.fire(Y))}}e.$me=l;class S extends l{constructor(Y){super(Y),this.k=Y.delay??100}fire(Y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(Y)}}e.$ne=S;class y extends i{constructor(Y){super(Y),this.h=[],this.k=Y?.merge}fire(Y){this.hasListeners()&&(this.h.push(Y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Z=>super.fire(Z)),this.h=[]}))}}e.$oe=y;class D{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(Y){const Z={event:Y,listener:null};this.h.push(Z),this.g&&this.m(Z);const U=()=>{this.g&&this.o(Z);const te=this.h.indexOf(Z);this.h.splice(te,1)};return(0,k.$Rc)((0,r.$cb)(U))}j(){this.g=!0,this.h.forEach(Y=>this.m(Y))}k(){this.g=!1,this.h.forEach(Y=>this.o(Y))}m(Y){Y.listener=Y.event(Z=>this.f.fire(Z))}o(Y){Y.listener?.dispose(),Y.listener=null}dispose(){this.f.dispose();for(const Y of this.h)Y.listener?.dispose();this.h=[]}}e.$pe=D;class L{constructor(Y,Z,U,te){this.f=new k.$Sc;const x=this.f.add(new D),J=this.f.add(new k.$3c);function B(j){J.set(j,x.add(te(j)))}for(const j of Y)B(j);this.f.add(Z(j=>{B(j)})),this.f.add(U(j=>{J.deleteAndDispose(j)})),this.event=x.event}dispose(){this.f.dispose()}}e.$qe=L;class A{constructor(){this.f=[]}wrapEvent(Y,Z,U){return(te,x,J)=>Y(B=>{const j=this.f[this.f.length-1];if(!Z){j?j.buffers.push(()=>te.call(x,B)):te.call(x,B);return}const C=j;if(!C){te.call(x,Z(U,B));return}C.items??=[],C.items.push(B),C.buffers.length===0&&j.buffers.push(()=>{C.reducedResult??=U?C.items.reduce(Z,U):C.items.reduce(Z),te.call(x,C.reducedResult)})},void 0,J)}bufferEvents(Y){const Z={buffers:new Array};this.f.push(Z);const U=Y();return this.f.pop(),Z.buffers.forEach(te=>te()),U}}e.$re=A;class O{constructor(){this.f=!1,this.g=m.None,this.h=k.$Tc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(Y){this.g=Y,this.f&&(this.h.dispose(),this.h=Y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=O;class W{static const(Y){return new V(Y)}constructor(Y){this.g=Y,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(Y){Y!==this.g&&(this.g=Y,this.f.fire(void 0))}}e.$te=W;class V{constructor(Y){this.value=Y,this.onDidChange=m.None}}}),define(le[22],he([0,1,4]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=I;const r=Object.freeze(function(p,c){const m=setTimeout(p.bind(c),0);return{dispose(){clearTimeout(m)}}});var k;(function(p){function c(m){return m===p.None||m===p.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}p.isCancellationToken=c,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(k||(e.CancellationToken=k={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=k.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=k.None}}e.$ue=T;function I(p){const c=new T;return p.add({dispose(){c.cancel()}}),c.token}}),define(le[146],he([0,1,22]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=k;class r{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new n.$ue,c=this.b(p.token);return this.a={promise:c,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$7e=r;function k(I){return I}class R{constructor(p,c){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=k):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);return this.b!==c&&(this.b=c,this.a=this.c(p)),this.a}}e.$9e=R;class T{get cachedValues(){return this.a}constructor(p,c){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=k):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);if(this.b.has(c))return this.b.get(c);const m=this.c(p);return this.a.set(p,m),this.b.set(c,m),m}}e.$0e=T}),define(le[67],he([0,1,15,2]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=k,e.$xe=R,e.$ye=T,e.$ze=I,e.$Ae=c,e.$Be=m,e.$Ce=h,e.$De=d,e.$Ee=w,e.$Fe=f,e.$Ge=g,e.$He=v,e.$Ie=b,e.$Je=$,e.$Ke=P;function k(E){const t=E;return t?typeof t.read=="function":!1}function R(E){const t=E;return t?[t.on,t.pause,t.resume,t.destroy].every(u=>typeof u=="function"):!1}function T(E){const t=E;return t?R(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function I(E,t){return new p(E,t)}class p{constructor(t,u){this.e=t,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(u=>u(t))}h(t){this.c.error.length===0?(0,n.$Y)(t):this.c.error.slice(0).forEach(u=>u(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,u){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(t,u){if(this.a.destroyed)return;let i;switch(t){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const o=i.indexOf(u);o>=0&&i.splice(o,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(E,t){const u=[];let i;for(;(i=E.read())!==null;)u.push(i);return t(u)}function m(E,t,u){const i=[];let o;for(;(o=E.read())!==null&&i.length<u;)i.push(o);return o===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return E.read()}}}function h(E,t){return new Promise((u,i)=>{const o=[];d(E,{onData:s=>{t&&o.push(s)},onError:s=>{t?i(s):u(void 0)},onEnd:()=>{u(t?t(o):void 0)}})})}function d(E,t,u){E.on("error",i=>{u?.isCancellationRequested||t.onError(i)}),E.on("end",()=>{u?.isCancellationRequested||t.onEnd()}),E.on("data",i=>{u?.isCancellationRequested||t.onData(i)})}function w(E,t){return new Promise((u,i)=>{const o=new r.$Sc,s=[],a=y=>{if(s.push(y),s.length>t)return o.dispose(),E.pause(),u({stream:E,buffer:s,ended:!1})},l=y=>(o.dispose(),i(y)),S=()=>(o.dispose(),u({stream:E,buffer:s,ended:!0}));o.add((0,r.$Rc)(()=>E.removeListener("error",l))),E.on("error",l),o.add((0,r.$Rc)(()=>E.removeListener("end",S))),E.on("end",S),o.add((0,r.$Rc)(()=>E.removeListener("data",a))),E.on("data",a)})}function f(E,t){const u=I(t);return u.end(E),u}function g(){const E=I(()=>{throw new Error("not supported")});return E.end(),E}function v(E){let t=!1;return{read:()=>t?null:(t=!0,E)}}function b(E,t,u){const i=I(u);return d(E,{onData:o=>i.write(t.data(o)),onError:o=>i.error(t.error?t.error(o):o),onEnd:()=>i.end()}),i}function $(E,t,u){let i=!1;return{read:()=>{const o=t.read();return i?o:(i=!0,o!==null?u([E,o]):E)}}}function P(E,t,u){let i=!1;const o=I(u);return d(t,{onData:s=>i?o.write(s):(i=!0,o.write(u([E,s]))),onError:s=>o.error(s),onEnd:()=>{i||(i=!0,o.write(E)),o.end()}}),o}}),define(le[17],he([0,1,65,67]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=c,e.$Ne=m,e.$Oe=h,e.$Pe=d,e.$Qe=w,e.$Re=f,e.$Se=g,e.$Te=v,e.$Ue=b,e.$Ve=$,e.$We=P,e.$Xe=E,e.$Ye=t,e.$Ze=u,e.$1e=i,e.$2e=o,e.$3e=s,e.$4e=a,e.$5e=l,e.$6e=D,r=Ie(r);const k=typeof Buffer<"u",R=new n.$T(()=>new Uint8Array(256));let T,I;class p{static alloc(A){return k?new p(Buffer.allocUnsafe(A)):new p(new Uint8Array(A))}static wrap(A){return k&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new p(A)}static fromString(A,O){return!(O?.dontUseNodeBuffer||!1)&&k?new p(Buffer.from(A)):(T||(T=new TextEncoder),new p(T.encode(A)))}static fromByteArray(A){const O=p.alloc(A.length);for(let W=0,V=A.length;W<V;W++)O.buffer[W]=A[W];return O}static concat(A,O){if(typeof O>"u"){O=0;for(let H=0,Y=A.length;H<Y;H++)O+=A[H].byteLength}const W=p.alloc(O);let V=0;for(let H=0,Y=A.length;H<Y;H++){const Z=A[H];W.set(Z,V),V+=Z.byteLength}return W}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=p.alloc(this.byteLength);return A.set(this),A}toString(){return k?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(A,O){return new p(this.buffer.subarray(A,O))}set(A,O){if(A instanceof p)this.buffer.set(A.buffer,O);else if(A instanceof Uint8Array)this.buffer.set(A,O);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),O);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return d(this.buffer,A)}writeUInt32BE(A,O){w(this.buffer,A,O)}readUInt32LE(A){return f(this.buffer,A)}writeUInt32LE(A,O){g(this.buffer,A,O)}readUInt8(A){return v(this.buffer,A)}writeUInt8(A,O){b(this.buffer,A,O)}indexOf(A,O=0){return c(this.buffer,A instanceof p?A.buffer:A,O)}}e.$Le=p;function c(L,A,O=0){const W=A.byteLength,V=L.byteLength;if(W===0)return 0;if(W===1)return L.indexOf(A[0]);if(W>V-O)return-1;const H=R.value;H.fill(A.length);for(let te=0;te<A.length;te++)H[A[te]]=A.length-te-1;let Y=O+A.length-1,Z=Y,U=-1;for(;Y<V;)if(L[Y]===A[Z]){if(Z===0){U=Y;break}Y--,Z--}else Y+=Math.max(A.length-Z,H[L[Y]]),Z=A.length-1;return U}function m(L,A){return L[A+0]<<0>>>0|L[A+1]<<8>>>0}function h(L,A,O){L[O+0]=A&255,A=A>>>8,L[O+1]=A&255}function d(L,A){return L[A]*2**24+L[A+1]*2**16+L[A+2]*2**8+L[A+3]}function w(L,A,O){L[O+3]=A,A=A>>>8,L[O+2]=A,A=A>>>8,L[O+1]=A,A=A>>>8,L[O]=A}function f(L,A){return L[A+0]<<0>>>0|L[A+1]<<8>>>0|L[A+2]<<16>>>0|L[A+3]<<24>>>0}function g(L,A,O){L[O+0]=A&255,A=A>>>8,L[O+1]=A&255,A=A>>>8,L[O+2]=A&255,A=A>>>8,L[O+3]=A&255}function v(L,A){return L[A]}function b(L,A,O){L[O]=A}function $(L){return r.$Ae(L,A=>p.concat(A))}function P(L){return r.$He(L)}function E(L){return r.$Ce(L,A=>p.concat(A))}async function t(L){return L.ended?p.concat(L.buffer):p.concat([...L.buffer,await E(L.stream)])}function u(L){return r.$Fe(L,A=>p.concat(A))}function i(L){return r.$Ie(L,{data:A=>typeof A=="string"?p.fromString(A):p.wrap(A)},A=>p.concat(A))}function o(L){return r.$ze(A=>p.concat(A),L)}function s(L,A){return r.$Je(L,A,O=>p.concat(O))}function a(L,A){return r.$Ke(L,A,O=>p.concat(O))}function l(L){let A=0,O=0,W=0;const V=new Uint8Array(Math.floor(L.length/4*3)),H=Z=>{switch(O){case 3:V[W++]=A|Z,O=0;break;case 2:V[W++]=A|Z>>>2,A=Z<<6,O=3;break;case 1:V[W++]=A|Z>>>4,A=Z<<4,O=2;break;default:A=Z<<2,O=1}};for(let Z=0;Z<L.length;Z++){const U=L.charCodeAt(Z);if(U>=65&&U<=90)H(U-65);else if(U>=97&&U<=122)H(U-97+26);else if(U>=48&&U<=57)H(U-48+52);else if(U===43||U===45)H(62);else if(U===47||U===95)H(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${L[Z]}`)}}const Y=W;for(;O>0;)H(0);return p.wrap(V).slice(0,Y)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:L},A=!0,O=!1){const W=O?y:S;let V="";const H=L.byteLength%3;let Y=0;for(;Y<L.byteLength-H;Y+=3){const Z=L[Y+0],U=L[Y+1],te=L[Y+2];V+=W[Z>>>2],V+=W[(Z<<4|U>>>4)&63],V+=W[(U<<2|te>>>6)&63],V+=W[te&63]}if(H===1){const Z=L[Y+0];V+=W[Z>>>2],V+=W[Z<<4&63],A&&(V+="==")}else if(H===2){const Z=L[Y+0],U=L[Y+1];V+=W[Z>>>2],V+=W[(Z<<4|U>>>4)&63],V+=W[U<<2&63],A&&(V+="=")}return V}}),define(le[147],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(le[12],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=n,e.$dg=r,e.$eg=k,e.$fg=R,e.$gg=T,e.$hg=I,e.$ig=p,e.$jg=c,e.$kg=m,e.$lg=h,e.$mg=d,e.$ng=w,e.$og=f,e.$pg=v,e.$qg=b,e.$rg=$,e.$sg=P,e.$tg=E;function n(t){return typeof t=="string"}function r(t){return Array.isArray(t)&&t.every(u=>n(u))}function k(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function R(t){const u=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof u}function T(t){return typeof t=="number"&&!isNaN(t)}function I(t){return!!t&&typeof t[Symbol.iterator]=="function"}function p(t){return t===!0||t===!1}function c(t){return typeof t>"u"}function m(t){return!h(t)}function h(t){return c(t)||t===null}function d(t,u){if(!t)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function w(t){if(h(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function f(...t){const u=[];for(let i=0;i<t.length;i++){const o=t[i];if(h(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);u.push(o)}return u}const g=Object.prototype.hasOwnProperty;function v(t){if(!k(t))return!1;for(const u in t)if(g.call(t,u))return!1;return!0}function b(t){return typeof t=="function"}function $(...t){return t.length>0&&t.every(b)}function P(t,u){const i=Math.min(t.length,u.length);for(let o=0;o<i;o++)E(t[o],u[o])}function E(t,u){if(n(u)){if(typeof t!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(b(u)){try{if(t instanceof u)return}catch{}if(!h(t)&&t.constructor===u||u.length===1&&u.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[109],he([0,1,12]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=k,e.$Xj=R;const r=Object.create(null);function k(T,I){if((0,n.$cg)(I)){const p=r[I];if(p===void 0)throw new Error(`${T} references an unknown codicon: ${I}`);I=p}return r[T]=I,{id:T}}function R(){return r}}),define(le[148],he([0,1,109]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=void 0,e.$Yj={add:(0,n.$Wj)("add",6e4),plus:(0,n.$Wj)("plus",6e4),gistNew:(0,n.$Wj)("gist-new",6e4),repoCreate:(0,n.$Wj)("repo-create",6e4),lightbulb:(0,n.$Wj)("lightbulb",60001),lightBulb:(0,n.$Wj)("light-bulb",60001),repo:(0,n.$Wj)("repo",60002),repoDelete:(0,n.$Wj)("repo-delete",60002),gistFork:(0,n.$Wj)("gist-fork",60003),repoForked:(0,n.$Wj)("repo-forked",60003),gitPullRequest:(0,n.$Wj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Wj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Wj)("record-keys",60005),keyboard:(0,n.$Wj)("keyboard",60005),tag:(0,n.$Wj)("tag",60006),gitPullRequestLabel:(0,n.$Wj)("git-pull-request-label",60006),tagAdd:(0,n.$Wj)("tag-add",60006),tagRemove:(0,n.$Wj)("tag-remove",60006),person:(0,n.$Wj)("person",60007),personFollow:(0,n.$Wj)("person-follow",60007),personOutline:(0,n.$Wj)("person-outline",60007),personFilled:(0,n.$Wj)("person-filled",60007),gitBranch:(0,n.$Wj)("git-branch",60008),gitBranchCreate:(0,n.$Wj)("git-branch-create",60008),gitBranchDelete:(0,n.$Wj)("git-branch-delete",60008),sourceControl:(0,n.$Wj)("source-control",60008),mirror:(0,n.$Wj)("mirror",60009),mirrorPublic:(0,n.$Wj)("mirror-public",60009),star:(0,n.$Wj)("star",60010),starAdd:(0,n.$Wj)("star-add",60010),starDelete:(0,n.$Wj)("star-delete",60010),starEmpty:(0,n.$Wj)("star-empty",60010),comment:(0,n.$Wj)("comment",60011),commentAdd:(0,n.$Wj)("comment-add",60011),alert:(0,n.$Wj)("alert",60012),warning:(0,n.$Wj)("warning",60012),search:(0,n.$Wj)("search",60013),searchSave:(0,n.$Wj)("search-save",60013),logOut:(0,n.$Wj)("log-out",60014),signOut:(0,n.$Wj)("sign-out",60014),logIn:(0,n.$Wj)("log-in",60015),signIn:(0,n.$Wj)("sign-in",60015),eye:(0,n.$Wj)("eye",60016),eyeUnwatch:(0,n.$Wj)("eye-unwatch",60016),eyeWatch:(0,n.$Wj)("eye-watch",60016),circleFilled:(0,n.$Wj)("circle-filled",60017),primitiveDot:(0,n.$Wj)("primitive-dot",60017),closeDirty:(0,n.$Wj)("close-dirty",60017),debugBreakpoint:(0,n.$Wj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Wj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Wj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Wj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Wj)("primitive-square",60018),edit:(0,n.$Wj)("edit",60019),pencil:(0,n.$Wj)("pencil",60019),info:(0,n.$Wj)("info",60020),issueOpened:(0,n.$Wj)("issue-opened",60020),gistPrivate:(0,n.$Wj)("gist-private",60021),gitForkPrivate:(0,n.$Wj)("git-fork-private",60021),lock:(0,n.$Wj)("lock",60021),mirrorPrivate:(0,n.$Wj)("mirror-private",60021),close:(0,n.$Wj)("close",60022),removeClose:(0,n.$Wj)("remove-close",60022),x:(0,n.$Wj)("x",60022),repoSync:(0,n.$Wj)("repo-sync",60023),sync:(0,n.$Wj)("sync",60023),clone:(0,n.$Wj)("clone",60024),desktopDownload:(0,n.$Wj)("desktop-download",60024),beaker:(0,n.$Wj)("beaker",60025),microscope:(0,n.$Wj)("microscope",60025),vm:(0,n.$Wj)("vm",60026),deviceDesktop:(0,n.$Wj)("device-desktop",60026),file:(0,n.$Wj)("file",60027),fileText:(0,n.$Wj)("file-text",60027),more:(0,n.$Wj)("more",60028),ellipsis:(0,n.$Wj)("ellipsis",60028),kebabHorizontal:(0,n.$Wj)("kebab-horizontal",60028),mailReply:(0,n.$Wj)("mail-reply",60029),reply:(0,n.$Wj)("reply",60029),organization:(0,n.$Wj)("organization",60030),organizationFilled:(0,n.$Wj)("organization-filled",60030),organizationOutline:(0,n.$Wj)("organization-outline",60030),newFile:(0,n.$Wj)("new-file",60031),fileAdd:(0,n.$Wj)("file-add",60031),newFolder:(0,n.$Wj)("new-folder",60032),fileDirectoryCreate:(0,n.$Wj)("file-directory-create",60032),trash:(0,n.$Wj)("trash",60033),trashcan:(0,n.$Wj)("trashcan",60033),history:(0,n.$Wj)("history",60034),clock:(0,n.$Wj)("clock",60034),folder:(0,n.$Wj)("folder",60035),fileDirectory:(0,n.$Wj)("file-directory",60035),symbolFolder:(0,n.$Wj)("symbol-folder",60035),logoGithub:(0,n.$Wj)("logo-github",60036),markGithub:(0,n.$Wj)("mark-github",60036),github:(0,n.$Wj)("github",60036),terminal:(0,n.$Wj)("terminal",60037),console:(0,n.$Wj)("console",60037),repl:(0,n.$Wj)("repl",60037),zap:(0,n.$Wj)("zap",60038),symbolEvent:(0,n.$Wj)("symbol-event",60038),error:(0,n.$Wj)("error",60039),stop:(0,n.$Wj)("stop",60039),variable:(0,n.$Wj)("variable",60040),symbolVariable:(0,n.$Wj)("symbol-variable",60040),array:(0,n.$Wj)("array",60042),symbolArray:(0,n.$Wj)("symbol-array",60042),symbolModule:(0,n.$Wj)("symbol-module",60043),symbolPackage:(0,n.$Wj)("symbol-package",60043),symbolNamespace:(0,n.$Wj)("symbol-namespace",60043),symbolObject:(0,n.$Wj)("symbol-object",60043),symbolMethod:(0,n.$Wj)("symbol-method",60044),symbolFunction:(0,n.$Wj)("symbol-function",60044),symbolConstructor:(0,n.$Wj)("symbol-constructor",60044),symbolBoolean:(0,n.$Wj)("symbol-boolean",60047),symbolNull:(0,n.$Wj)("symbol-null",60047),symbolNumeric:(0,n.$Wj)("symbol-numeric",60048),symbolNumber:(0,n.$Wj)("symbol-number",60048),symbolStructure:(0,n.$Wj)("symbol-structure",60049),symbolStruct:(0,n.$Wj)("symbol-struct",60049),symbolParameter:(0,n.$Wj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Wj)("symbol-type-parameter",60050),symbolKey:(0,n.$Wj)("symbol-key",60051),symbolText:(0,n.$Wj)("symbol-text",60051),symbolReference:(0,n.$Wj)("symbol-reference",60052),goToFile:(0,n.$Wj)("go-to-file",60052),symbolEnum:(0,n.$Wj)("symbol-enum",60053),symbolValue:(0,n.$Wj)("symbol-value",60053),symbolRuler:(0,n.$Wj)("symbol-ruler",60054),symbolUnit:(0,n.$Wj)("symbol-unit",60054),activateBreakpoints:(0,n.$Wj)("activate-breakpoints",60055),archive:(0,n.$Wj)("archive",60056),arrowBoth:(0,n.$Wj)("arrow-both",60057),arrowDown:(0,n.$Wj)("arrow-down",60058),arrowLeft:(0,n.$Wj)("arrow-left",60059),arrowRight:(0,n.$Wj)("arrow-right",60060),arrowSmallDown:(0,n.$Wj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Wj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Wj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Wj)("arrow-small-up",60064),arrowUp:(0,n.$Wj)("arrow-up",60065),bell:(0,n.$Wj)("bell",60066),bold:(0,n.$Wj)("bold",60067),book:(0,n.$Wj)("book",60068),bookmark:(0,n.$Wj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Wj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Wj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Wj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Wj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Wj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Wj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Wj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Wj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Wj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Wj)("briefcase",60076),broadcast:(0,n.$Wj)("broadcast",60077),browser:(0,n.$Wj)("browser",60078),bug:(0,n.$Wj)("bug",60079),calendar:(0,n.$Wj)("calendar",60080),caseSensitive:(0,n.$Wj)("case-sensitive",60081),check:(0,n.$Wj)("check",60082),checklist:(0,n.$Wj)("checklist",60083),chevronDown:(0,n.$Wj)("chevron-down",60084),chevronLeft:(0,n.$Wj)("chevron-left",60085),chevronRight:(0,n.$Wj)("chevron-right",60086),chevronUp:(0,n.$Wj)("chevron-up",60087),chromeClose:(0,n.$Wj)("chrome-close",60088),chromeMaximize:(0,n.$Wj)("chrome-maximize",60089),chromeMinimize:(0,n.$Wj)("chrome-minimize",60090),chromeRestore:(0,n.$Wj)("chrome-restore",60091),circleOutline:(0,n.$Wj)("circle-outline",60092),circle:(0,n.$Wj)("circle",60092),debugBreakpointUnverified:(0,n.$Wj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Wj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Wj)("circle-slash",60093),circuitBoard:(0,n.$Wj)("circuit-board",60094),clearAll:(0,n.$Wj)("clear-all",60095),clippy:(0,n.$Wj)("clippy",60096),closeAll:(0,n.$Wj)("close-all",60097),cloudDownload:(0,n.$Wj)("cloud-download",60098),cloudUpload:(0,n.$Wj)("cloud-upload",60099),code:(0,n.$Wj)("code",60100),collapseAll:(0,n.$Wj)("collapse-all",60101),colorMode:(0,n.$Wj)("color-mode",60102),commentDiscussion:(0,n.$Wj)("comment-discussion",60103),creditCard:(0,n.$Wj)("credit-card",60105),dash:(0,n.$Wj)("dash",60108),dashboard:(0,n.$Wj)("dashboard",60109),database:(0,n.$Wj)("database",60110),debugContinue:(0,n.$Wj)("debug-continue",60111),debugDisconnect:(0,n.$Wj)("debug-disconnect",60112),debugPause:(0,n.$Wj)("debug-pause",60113),debugRestart:(0,n.$Wj)("debug-restart",60114),debugStart:(0,n.$Wj)("debug-start",60115),debugStepInto:(0,n.$Wj)("debug-step-into",60116),debugStepOut:(0,n.$Wj)("debug-step-out",60117),debugStepOver:(0,n.$Wj)("debug-step-over",60118),debugStop:(0,n.$Wj)("debug-stop",60119),debug:(0,n.$Wj)("debug",60120),deviceCameraVideo:(0,n.$Wj)("device-camera-video",60121),deviceCamera:(0,n.$Wj)("device-camera",60122),deviceMobile:(0,n.$Wj)("device-mobile",60123),diffAdded:(0,n.$Wj)("diff-added",60124),diffIgnored:(0,n.$Wj)("diff-ignored",60125),diffModified:(0,n.$Wj)("diff-modified",60126),diffRemoved:(0,n.$Wj)("diff-removed",60127),diffRenamed:(0,n.$Wj)("diff-renamed",60128),diff:(0,n.$Wj)("diff",60129),diffSidebyside:(0,n.$Wj)("diff-sidebyside",60129),discard:(0,n.$Wj)("discard",60130),editorLayout:(0,n.$Wj)("editor-layout",60131),emptyWindow:(0,n.$Wj)("empty-window",60132),exclude:(0,n.$Wj)("exclude",60133),extensions:(0,n.$Wj)("extensions",60134),eyeClosed:(0,n.$Wj)("eye-closed",60135),fileBinary:(0,n.$Wj)("file-binary",60136),fileCode:(0,n.$Wj)("file-code",60137),fileMedia:(0,n.$Wj)("file-media",60138),filePdf:(0,n.$Wj)("file-pdf",60139),fileSubmodule:(0,n.$Wj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Wj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Wj)("file-symlink-file",60142),fileZip:(0,n.$Wj)("file-zip",60143),files:(0,n.$Wj)("files",60144),filter:(0,n.$Wj)("filter",60145),flame:(0,n.$Wj)("flame",60146),foldDown:(0,n.$Wj)("fold-down",60147),foldUp:(0,n.$Wj)("fold-up",60148),fold:(0,n.$Wj)("fold",60149),folderActive:(0,n.$Wj)("folder-active",60150),folderOpened:(0,n.$Wj)("folder-opened",60151),gear:(0,n.$Wj)("gear",60152),gift:(0,n.$Wj)("gift",60153),gistSecret:(0,n.$Wj)("gist-secret",60154),gist:(0,n.$Wj)("gist",60155),gitCommit:(0,n.$Wj)("git-commit",60156),gitCompare:(0,n.$Wj)("git-compare",60157),compareChanges:(0,n.$Wj)("compare-changes",60157),gitMerge:(0,n.$Wj)("git-merge",60158),githubAction:(0,n.$Wj)("github-action",60159),githubAlt:(0,n.$Wj)("github-alt",60160),globe:(0,n.$Wj)("globe",60161),grabber:(0,n.$Wj)("grabber",60162),graph:(0,n.$Wj)("graph",60163),gripper:(0,n.$Wj)("gripper",60164),heart:(0,n.$Wj)("heart",60165),home:(0,n.$Wj)("home",60166),horizontalRule:(0,n.$Wj)("horizontal-rule",60167),hubot:(0,n.$Wj)("hubot",60168),inbox:(0,n.$Wj)("inbox",60169),issueReopened:(0,n.$Wj)("issue-reopened",60171),issues:(0,n.$Wj)("issues",60172),italic:(0,n.$Wj)("italic",60173),jersey:(0,n.$Wj)("jersey",60174),json:(0,n.$Wj)("json",60175),kebabVertical:(0,n.$Wj)("kebab-vertical",60176),key:(0,n.$Wj)("key",60177),law:(0,n.$Wj)("law",60178),lightbulbAutofix:(0,n.$Wj)("lightbulb-autofix",60179),linkExternal:(0,n.$Wj)("link-external",60180),link:(0,n.$Wj)("link",60181),listOrdered:(0,n.$Wj)("list-ordered",60182),listUnordered:(0,n.$Wj)("list-unordered",60183),liveShare:(0,n.$Wj)("live-share",60184),loading:(0,n.$Wj)("loading",60185),location:(0,n.$Wj)("location",60186),mailRead:(0,n.$Wj)("mail-read",60187),mail:(0,n.$Wj)("mail",60188),markdown:(0,n.$Wj)("markdown",60189),megaphone:(0,n.$Wj)("megaphone",60190),mention:(0,n.$Wj)("mention",60191),milestone:(0,n.$Wj)("milestone",60192),gitPullRequestMilestone:(0,n.$Wj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Wj)("mortar-board",60193),move:(0,n.$Wj)("move",60194),multipleWindows:(0,n.$Wj)("multiple-windows",60195),mute:(0,n.$Wj)("mute",60196),noNewline:(0,n.$Wj)("no-newline",60197),note:(0,n.$Wj)("note",60198),octoface:(0,n.$Wj)("octoface",60199),openPreview:(0,n.$Wj)("open-preview",60200),package:(0,n.$Wj)("package",60201),paintcan:(0,n.$Wj)("paintcan",60202),pin:(0,n.$Wj)("pin",60203),play:(0,n.$Wj)("play",60204),run:(0,n.$Wj)("run",60204),plug:(0,n.$Wj)("plug",60205),preserveCase:(0,n.$Wj)("preserve-case",60206),preview:(0,n.$Wj)("preview",60207),project:(0,n.$Wj)("project",60208),pulse:(0,n.$Wj)("pulse",60209),question:(0,n.$Wj)("question",60210),quote:(0,n.$Wj)("quote",60211),radioTower:(0,n.$Wj)("radio-tower",60212),reactions:(0,n.$Wj)("reactions",60213),references:(0,n.$Wj)("references",60214),refresh:(0,n.$Wj)("refresh",60215),regex:(0,n.$Wj)("regex",60216),remoteExplorer:(0,n.$Wj)("remote-explorer",60217),remote:(0,n.$Wj)("remote",60218),remove:(0,n.$Wj)("remove",60219),replaceAll:(0,n.$Wj)("replace-all",60220),replace:(0,n.$Wj)("replace",60221),repoClone:(0,n.$Wj)("repo-clone",60222),repoForcePush:(0,n.$Wj)("repo-force-push",60223),repoPull:(0,n.$Wj)("repo-pull",60224),repoPush:(0,n.$Wj)("repo-push",60225),report:(0,n.$Wj)("report",60226),requestChanges:(0,n.$Wj)("request-changes",60227),rocket:(0,n.$Wj)("rocket",60228),rootFolderOpened:(0,n.$Wj)("root-folder-opened",60229),rootFolder:(0,n.$Wj)("root-folder",60230),rss:(0,n.$Wj)("rss",60231),ruby:(0,n.$Wj)("ruby",60232),saveAll:(0,n.$Wj)("save-all",60233),saveAs:(0,n.$Wj)("save-as",60234),save:(0,n.$Wj)("save",60235),screenFull:(0,n.$Wj)("screen-full",60236),screenNormal:(0,n.$Wj)("screen-normal",60237),searchStop:(0,n.$Wj)("search-stop",60238),server:(0,n.$Wj)("server",60240),settingsGear:(0,n.$Wj)("settings-gear",60241),settings:(0,n.$Wj)("settings",60242),shield:(0,n.$Wj)("shield",60243),smiley:(0,n.$Wj)("smiley",60244),sortPrecedence:(0,n.$Wj)("sort-precedence",60245),splitHorizontal:(0,n.$Wj)("split-horizontal",60246),splitVertical:(0,n.$Wj)("split-vertical",60247),squirrel:(0,n.$Wj)("squirrel",60248),starFull:(0,n.$Wj)("star-full",60249),starHalf:(0,n.$Wj)("star-half",60250),symbolClass:(0,n.$Wj)("symbol-class",60251),symbolColor:(0,n.$Wj)("symbol-color",60252),symbolConstant:(0,n.$Wj)("symbol-constant",60253),symbolEnumMember:(0,n.$Wj)("symbol-enum-member",60254),symbolField:(0,n.$Wj)("symbol-field",60255),symbolFile:(0,n.$Wj)("symbol-file",60256),symbolInterface:(0,n.$Wj)("symbol-interface",60257),symbolKeyword:(0,n.$Wj)("symbol-keyword",60258),symbolMisc:(0,n.$Wj)("symbol-misc",60259),symbolOperator:(0,n.$Wj)("symbol-operator",60260),symbolProperty:(0,n.$Wj)("symbol-property",60261),wrench:(0,n.$Wj)("wrench",60261),wrenchSubaction:(0,n.$Wj)("wrench-subaction",60261),symbolSnippet:(0,n.$Wj)("symbol-snippet",60262),tasklist:(0,n.$Wj)("tasklist",60263),telescope:(0,n.$Wj)("telescope",60264),textSize:(0,n.$Wj)("text-size",60265),threeBars:(0,n.$Wj)("three-bars",60266),thumbsdown:(0,n.$Wj)("thumbsdown",60267),thumbsup:(0,n.$Wj)("thumbsup",60268),tools:(0,n.$Wj)("tools",60269),triangleDown:(0,n.$Wj)("triangle-down",60270),triangleLeft:(0,n.$Wj)("triangle-left",60271),triangleRight:(0,n.$Wj)("triangle-right",60272),triangleUp:(0,n.$Wj)("triangle-up",60273),twitter:(0,n.$Wj)("twitter",60274),unfold:(0,n.$Wj)("unfold",60275),unlock:(0,n.$Wj)("unlock",60276),unmute:(0,n.$Wj)("unmute",60277),unverified:(0,n.$Wj)("unverified",60278),verified:(0,n.$Wj)("verified",60279),versions:(0,n.$Wj)("versions",60280),vmActive:(0,n.$Wj)("vm-active",60281),vmOutline:(0,n.$Wj)("vm-outline",60282),vmRunning:(0,n.$Wj)("vm-running",60283),watch:(0,n.$Wj)("watch",60284),whitespace:(0,n.$Wj)("whitespace",60285),wholeWord:(0,n.$Wj)("whole-word",60286),window:(0,n.$Wj)("window",60287),wordWrap:(0,n.$Wj)("word-wrap",60288),zoomIn:(0,n.$Wj)("zoom-in",60289),zoomOut:(0,n.$Wj)("zoom-out",60290),listFilter:(0,n.$Wj)("list-filter",60291),listFlat:(0,n.$Wj)("list-flat",60292),listSelection:(0,n.$Wj)("list-selection",60293),selection:(0,n.$Wj)("selection",60293),listTree:(0,n.$Wj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Wj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Wj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Wj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Wj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Wj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Wj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Wj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Wj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Wj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Wj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Wj)("symbol-string",60301),debugReverseContinue:(0,n.$Wj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Wj)("debug-step-back",60303),debugRestartFrame:(0,n.$Wj)("debug-restart-frame",60304),debugAlt:(0,n.$Wj)("debug-alt",60305),callIncoming:(0,n.$Wj)("call-incoming",60306),callOutgoing:(0,n.$Wj)("call-outgoing",60307),menu:(0,n.$Wj)("menu",60308),expandAll:(0,n.$Wj)("expand-all",60309),feedback:(0,n.$Wj)("feedback",60310),gitPullRequestReviewer:(0,n.$Wj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Wj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Wj)("ungroup-by-ref-type",60312),account:(0,n.$Wj)("account",60313),gitPullRequestAssignee:(0,n.$Wj)("git-pull-request-assignee",60313),bellDot:(0,n.$Wj)("bell-dot",60314),debugConsole:(0,n.$Wj)("debug-console",60315),library:(0,n.$Wj)("library",60316),output:(0,n.$Wj)("output",60317),runAll:(0,n.$Wj)("run-all",60318),syncIgnored:(0,n.$Wj)("sync-ignored",60319),pinned:(0,n.$Wj)("pinned",60320),githubInverted:(0,n.$Wj)("github-inverted",60321),serverProcess:(0,n.$Wj)("server-process",60322),serverEnvironment:(0,n.$Wj)("server-environment",60323),pass:(0,n.$Wj)("pass",60324),issueClosed:(0,n.$Wj)("issue-closed",60324),stopCircle:(0,n.$Wj)("stop-circle",60325),playCircle:(0,n.$Wj)("play-circle",60326),record:(0,n.$Wj)("record",60327),debugAltSmall:(0,n.$Wj)("debug-alt-small",60328),vmConnect:(0,n.$Wj)("vm-connect",60329),cloud:(0,n.$Wj)("cloud",60330),merge:(0,n.$Wj)("merge",60331),export:(0,n.$Wj)("export",60332),graphLeft:(0,n.$Wj)("graph-left",60333),magnet:(0,n.$Wj)("magnet",60334),notebook:(0,n.$Wj)("notebook",60335),redo:(0,n.$Wj)("redo",60336),checkAll:(0,n.$Wj)("check-all",60337),pinnedDirty:(0,n.$Wj)("pinned-dirty",60338),passFilled:(0,n.$Wj)("pass-filled",60339),circleLargeFilled:(0,n.$Wj)("circle-large-filled",60340),circleLarge:(0,n.$Wj)("circle-large",60341),circleLargeOutline:(0,n.$Wj)("circle-large-outline",60341),combine:(0,n.$Wj)("combine",60342),gather:(0,n.$Wj)("gather",60342),table:(0,n.$Wj)("table",60343),variableGroup:(0,n.$Wj)("variable-group",60344),typeHierarchy:(0,n.$Wj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Wj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Wj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Wj)("git-pull-request-create",60348),runAbove:(0,n.$Wj)("run-above",60349),runBelow:(0,n.$Wj)("run-below",60350),notebookTemplate:(0,n.$Wj)("notebook-template",60351),debugRerun:(0,n.$Wj)("debug-rerun",60352),workspaceTrusted:(0,n.$Wj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Wj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Wj)("workspace-unknown",60355),terminalCmd:(0,n.$Wj)("terminal-cmd",60356),terminalDebian:(0,n.$Wj)("terminal-debian",60357),terminalLinux:(0,n.$Wj)("terminal-linux",60358),terminalPowershell:(0,n.$Wj)("terminal-powershell",60359),terminalTmux:(0,n.$Wj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Wj)("terminal-ubuntu",60361),terminalBash:(0,n.$Wj)("terminal-bash",60362),arrowSwap:(0,n.$Wj)("arrow-swap",60363),copy:(0,n.$Wj)("copy",60364),personAdd:(0,n.$Wj)("person-add",60365),filterFilled:(0,n.$Wj)("filter-filled",60366),wand:(0,n.$Wj)("wand",60367),debugLineByLine:(0,n.$Wj)("debug-line-by-line",60368),inspect:(0,n.$Wj)("inspect",60369),layers:(0,n.$Wj)("layers",60370),layersDot:(0,n.$Wj)("layers-dot",60371),layersActive:(0,n.$Wj)("layers-active",60372),compass:(0,n.$Wj)("compass",60373),compassDot:(0,n.$Wj)("compass-dot",60374),compassActive:(0,n.$Wj)("compass-active",60375),azure:(0,n.$Wj)("azure",60376),issueDraft:(0,n.$Wj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Wj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Wj)("git-pull-request-draft",60379),debugAll:(0,n.$Wj)("debug-all",60380),debugCoverage:(0,n.$Wj)("debug-coverage",60381),runErrors:(0,n.$Wj)("run-errors",60382),folderLibrary:(0,n.$Wj)("folder-library",60383),debugContinueSmall:(0,n.$Wj)("debug-continue-small",60384),beakerStop:(0,n.$Wj)("beaker-stop",60385),graphLine:(0,n.$Wj)("graph-line",60386),graphScatter:(0,n.$Wj)("graph-scatter",60387),pieChart:(0,n.$Wj)("pie-chart",60388),bracket:(0,n.$Wj)("bracket",60175),bracketDot:(0,n.$Wj)("bracket-dot",60389),bracketError:(0,n.$Wj)("bracket-error",60390),lockSmall:(0,n.$Wj)("lock-small",60391),azureDevops:(0,n.$Wj)("azure-devops",60392),verifiedFilled:(0,n.$Wj)("verified-filled",60393),newline:(0,n.$Wj)("newline",60394),layout:(0,n.$Wj)("layout",60395),layoutActivitybarLeft:(0,n.$Wj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Wj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Wj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Wj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Wj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Wj)("layout-panel-right",60401),layoutPanel:(0,n.$Wj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Wj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Wj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Wj)("layout-statusbar",60405),layoutMenubar:(0,n.$Wj)("layout-menubar",60406),layoutCentered:(0,n.$Wj)("layout-centered",60407),target:(0,n.$Wj)("target",60408),indent:(0,n.$Wj)("indent",60409),recordSmall:(0,n.$Wj)("record-small",60410),errorSmall:(0,n.$Wj)("error-small",60411),terminalDecorationError:(0,n.$Wj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Wj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Wj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Wj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Wj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Wj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Wj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Wj)("layout-sidebar-left-off",60418),blank:(0,n.$Wj)("blank",60419),heartFilled:(0,n.$Wj)("heart-filled",60420),map:(0,n.$Wj)("map",60421),mapHorizontal:(0,n.$Wj)("map-horizontal",60421),foldHorizontal:(0,n.$Wj)("fold-horizontal",60421),mapFilled:(0,n.$Wj)("map-filled",60422),mapHorizontalFilled:(0,n.$Wj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Wj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Wj)("circle-small",60423),bellSlash:(0,n.$Wj)("bell-slash",60424),bellSlashDot:(0,n.$Wj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Wj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Wj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Wj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Wj)("search-fuzzy",60429),commentDraft:(0,n.$Wj)("comment-draft",60430),send:(0,n.$Wj)("send",60431),sparkle:(0,n.$Wj)("sparkle",60432),insert:(0,n.$Wj)("insert",60433),mic:(0,n.$Wj)("mic",60434),thumbsdownFilled:(0,n.$Wj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Wj)("thumbsup-filled",60436),coffee:(0,n.$Wj)("coffee",60437),snake:(0,n.$Wj)("snake",60438),game:(0,n.$Wj)("game",60439),vr:(0,n.$Wj)("vr",60440),chip:(0,n.$Wj)("chip",60441),piano:(0,n.$Wj)("piano",60442),music:(0,n.$Wj)("music",60443),micFilled:(0,n.$Wj)("mic-filled",60444),repoFetch:(0,n.$Wj)("repo-fetch",60445),copilot:(0,n.$Wj)("copilot",60446),lightbulbSparkle:(0,n.$Wj)("lightbulb-sparkle",60447),robot:(0,n.$Wj)("robot",60448),sparkleFilled:(0,n.$Wj)("sparkle-filled",60449),diffSingle:(0,n.$Wj)("diff-single",60450),diffMultiple:(0,n.$Wj)("diff-multiple",60451),surroundWith:(0,n.$Wj)("surround-with",60452),share:(0,n.$Wj)("share",60453),gitStash:(0,n.$Wj)("git-stash",60454),gitStashApply:(0,n.$Wj)("git-stash-apply",60455),gitStashPop:(0,n.$Wj)("git-stash-pop",60456),vscode:(0,n.$Wj)("vscode",60457),vscodeInsiders:(0,n.$Wj)("vscode-insiders",60458),codeOss:(0,n.$Wj)("code-oss",60459),runCoverage:(0,n.$Wj)("run-coverage",60460),runAllCoverage:(0,n.$Wj)("run-all-coverage",60461),coverage:(0,n.$Wj)("coverage",60462),githubProject:(0,n.$Wj)("github-project",60463),mapVertical:(0,n.$Wj)("map-vertical",60464),foldVertical:(0,n.$Wj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Wj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Wj)("fold-vertical-filled",60465),goToSearch:(0,n.$Wj)("go-to-search",60466),percentage:(0,n.$Wj)("percentage",60467),sortPercentage:(0,n.$Wj)("sort-percentage",60467),attach:(0,n.$Wj)("attach",60468)}}),define(le[80],he([0,1,109,148]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=void 0,e.$Zj=k;function k(){return Object.values(e.$2j)}e.$1j={dialogError:(0,n.$Wj)("dialog-error","error"),dialogWarning:(0,n.$Wj)("dialog-warning","warning"),dialogInfo:(0,n.$Wj)("dialog-info","info"),dialogClose:(0,n.$Wj)("dialog-close","close"),treeItemExpanded:(0,n.$Wj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Wj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Wj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Wj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Wj)("tree-item-loading","loading"),menuSelection:(0,n.$Wj)("menu-selection","check"),menuSubmenu:(0,n.$Wj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Wj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Wj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Wj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Wj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Wj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Wj)("toolbar-more","more"),quickInputBack:(0,n.$Wj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Wj)("drop-down-button",60084),symbolCustomColor:(0,n.$Wj)("symbol-customcolor",60252),exportIcon:(0,n.$Wj)("export",60332),workspaceUnspecified:(0,n.$Wj)("workspace-unspecified",60355),newLine:(0,n.$Wj)("newline",60394),thumbsDownFilled:(0,n.$Wj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Wj)("thumbsup-filled",60436),gitFetch:(0,n.$Wj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Wj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Wj)("debug-breakpoint-pending",60377)},e.$2j={...r.$Yj,...e.$1j}}),define(le[37],he([0,1,12]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=r,e.$co=k,e.$do=T,e.$eo=p,e.$fo=c,e.$go=m,e.$ho=h,e.$io=d,e.$jo=w,e.$ko=f,e.$lo=g,e.$mo=v,e.$no=b;function r($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const P=Array.isArray($)?[]:{};return Object.entries($).forEach(([E,t])=>{P[E]=t&&typeof t=="object"?r(t):t}),P}function k($){if(!$||typeof $!="object")return $;const P=[$];for(;P.length>0;){const E=P.shift();Object.freeze(E);for(const t in E)if(R.call(E,t)){const u=E[t];typeof u=="object"&&!Object.isFrozen(u)&&!(0,n.$fg)(u)&&P.push(u)}}return $}const R=Object.prototype.hasOwnProperty;function T($,P){return I($,P,new Set)}function I($,P,E){if((0,n.$lg)($))return $;const t=P($);if(typeof t<"u")return t;if(Array.isArray($)){const u=[];for(const i of $)u.push(I(i,P,E));return u}if((0,n.$eg)($)){if(E.has($))throw new Error("Cannot clone recursive data-structure");E.add($);const u={};for(const i in $)R.call($,i)&&(u[i]=I($[i],P,E));return E.delete($),u}return $}function p($,P,E=!0){return(0,n.$eg)($)?((0,n.$eg)(P)&&Object.keys(P).forEach(t=>{t in $?E&&((0,n.$eg)($[t])&&(0,n.$eg)(P[t])?p($[t],P[t],E):$[t]=P[t]):$[t]=P[t]}),$):P}function c($,P){if($===P)return!0;if($==null||P===null||P===void 0||typeof $!=typeof P||typeof $!="object"||Array.isArray($)!==Array.isArray(P))return!1;let E,t;if(Array.isArray($)){if($.length!==P.length)return!1;for(E=0;E<$.length;E++)if(!c($[E],P[E]))return!1}else{const u=[];for(t in $)u.push(t);u.sort();const i=[];for(t in P)i.push(t);if(i.sort(),!c(u,i))return!1;for(E=0;E<u.length;E++)if(!c($[u[E]],P[u[E]]))return!1}return!0}function m($){const P=new Set;return JSON.stringify($,(E,t)=>{if((0,n.$eg)(t)||Array.isArray(t)){if(P.has(t))return"[Circular]";P.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function h($,P){const E=Object.create(null);return!$||!P||Object.keys(P).forEach(u=>{const i=$[u],o=P[u];c(i,o)||(E[u]=o)}),E}function d($,P){const E=P.toLowerCase(),t=Object.keys($).find(u=>u.toLowerCase()===E);return t?$[t]:$[P]}function w($,P){const E=Object.create(null);for(const[t,u]of Object.entries($))P(t,u)&&(E[t]=u);return E}function f($){let P=[];for(;Object.prototype!==$;)P=P.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return P}function g($){const P=[];for(const E of f($))typeof $[E]=="function"&&P.push(E);return P}function v($,P){const E=u=>function(){const i=Array.prototype.slice.call(arguments,0);return P(u,i)},t={};for(const u of $)t[u]=E(u);return t}function b($,P){const E={};for(const[t,u]of Object.entries($))E[t]=P(u,t);return E}}),define(le[110],he([0,1,80]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=k;var r;(function(T){function I(p){return p&&typeof p=="object"&&typeof p.id=="string"}T.isThemeColor=I})(r||(e.ThemeColor=r={}));function k(T){return{id:T}}var R;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function p($){const P=I.exec($.id);if(!P)return p(n.$2j.error);const[,E,t]=P,u=["codicon","codicon-"+E];return t&&u.push("codicon-modifier-"+t.substring(1)),u}T.asClassNameArray=p;function c($){return p($).join(" ")}T.asClassName=c;function m($){return"."+p($).join(".")}T.asCSSSelector=m;function h($){return $&&typeof $=="object"&&typeof $.id=="string"&&(typeof $.color>"u"||r.isThemeColor($.color))}T.isThemeIcon=h;const d=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function w($){const P=d.exec($);if(!P)return;const[,E]=P;return{id:E}}T.fromString=w;function f($){return{id:$}}T.fromId=f;function g($,P){let E=$.id;const t=E.lastIndexOf("~");return t!==-1&&(E=E.substring(0,t)),P&&(E=`${E}~${P}`),{id:E}}T.modify=g;function v($){const P=$.id.lastIndexOf("~");if(P!==-1)return $.id.substring(P+1)}T.getModifier=v;function b($,P){return $.id===P.id&&$.color?.id===P.color?.id}T.isEqual=b})(R||(e.ThemeIcon=R={}))}),define(le[149],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=r,e.$_e=k;var n;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(R){return R<0?0:R>n.MAX_UINT_8?n.MAX_UINT_8:R|0}function k(R){return R<0?0:R>n.MAX_UINT_32?n.MAX_UINT_32:R|0}}),define(le[25],he([0,1,146,39,65,149]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=T,e.$bf=p,e.$cf=m,e.$df=h,e.$ef=d,e.$ff=w,e.$gf=f,e.$hf=g,e.$if=v,e.$jf=b,e.$kf=$,e.$lf=P,e.$mf=E,e.$nf=t,e.$of=u,e.$pf=i,e.$qf=o,e.$rf=s,e.$sf=a,e.$tf=l,e.$uf=S,e.$vf=y,e.$wf=D,e.$xf=L,e.$yf=A,e.$zf=O,e.$Af=W,e.$Bf=V,e.$Cf=H,e.$Df=Y,e.$Ef=Z,e.$Ff=U,e.$Gf=te,e.$Hf=x,e.$If=J,e.$Jf=B,e.$Kf=j,e.$Nf=K,e.$Of=ce,e.$Pf=se,e.$Qf=ie,e.$Rf=N,e.$Sf=_,e.$Uf=Q,e.$Vf=q,e.$Wf=re,e.$Xf=de,e.$Yf=we,e.$Zf=De,e.$1f=Pe,e.$3f=Re,e.$4f=$e,e.$5f=ee,e.$6f=ue,e.$7f=fe,e.$8f=be,e.$9f=Ae,e.$0f=Ne,e.$$f=Ze;function T(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const I=/{(\d+)}/g;function p(ne,...ge){return ge.length===0?ne:ne.replace(I,function(pe,ye){const We=parseInt(ye,10);return isNaN(We)||We<0||We>=ge.length?pe:ge[We]})}const c=/{([^}]+)}/g;function m(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(c,(pe,ye)=>ge[ye]??pe)}function h(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function d(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(ne,ge){let pe=0,ye=ne.indexOf(ge);for(;ye!==-1;)pe++,ye=ne.indexOf(ge,ye+ge.length);return pe}function g(ne,ge,pe="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${pe}`}function v(ne,ge,pe="\u2026"){if(ne.length<=ge)return ne;const ye=Math.ceil(ge/2)-pe.length/2,We=Math.floor(ge/2)-pe.length/2;return`${ne.substr(0,ye)}${pe}${ne.substr(ne.length-We)}`}function b(ne,ge=" "){const pe=$(ne,ge);return P(pe,ge)}function $(ne,ge){if(!ne||!ge)return ne;const pe=ge.length;if(pe===0||ne.length===0)return ne;let ye=0;for(;ne.indexOf(ge,ye)===ye;)ye=ye+pe;return ne.substring(ye)}function P(ne,ge){if(!ne||!ge)return ne;const pe=ge.length,ye=ne.length;if(pe===0||ye===0)return ne;let We=ye,Ue=-1;for(;Ue=ne.lastIndexOf(ge,We-1),!(Ue===-1||Ue+pe!==We);){if(Ue===0)return"";We=Ue}return ne.substring(0,We)}function E(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(ne){return ne.replace(/\*/g,"")}function u(ne,ge,pe={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=w(ne)),pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(ne,ye)}function i(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function o(ne){return ne.split(/\r\n|\r|\n/)}function s(ne){const ge=[],pe=ne.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function a(ne){for(let ge=0,pe=ne.length;ge<pe;ge++){const ye=ne.charCodeAt(ge);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ge}return-1}function l(ne,ge=0,pe=ne.length){for(let ye=ge;ye<pe;ye++){const We=ne.charCodeAt(ye);if(We!==r.CharCode.Space&&We!==r.CharCode.Tab)return ne.substring(ge,ye)}return ne.substring(ge,pe)}function S(ne,ge=ne.length-1){for(let pe=ge;pe>=0;pe--){const ye=ne.charCodeAt(pe);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return pe}return-1}function y(ne,ge,pe){const ye=[];let We=0;for(const Ue of ne.matchAll(ge)){if(ye.push(ne.slice(We,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");We=Ue.index+Ue[0].length,ye.push(pe(Ue[0],...Ue.slice(1),Ue.index,ne,Ue.groups))}return ye.push(ne.slice(We)),Promise.all(ye).then(Ue=>Ue.join(""))}function D(ne,ge){return ne<ge?-1:ne>ge?1:0}function L(ne,ge,pe=0,ye=ne.length,We=0,Ue=ge.length){for(;pe<ye&&We<Ue;pe++,We++){const rt=ne.charCodeAt(pe),at=ge.charCodeAt(We);if(rt<at)return-1;if(rt>at)return 1}const _e=ye-pe,lt=Ue-We;return _e<lt?-1:_e>lt?1:0}function A(ne,ge){return O(ne,ge,0,ne.length,0,ge.length)}function O(ne,ge,pe=0,ye=ne.length,We=0,Ue=ge.length){for(;pe<ye&&We<Ue;pe++,We++){let rt=ne.charCodeAt(pe),at=ge.charCodeAt(We);if(rt===at)continue;if(rt>=128||at>=128)return L(ne.toLowerCase(),ge.toLowerCase(),pe,ye,We,Ue);V(rt)&&(rt-=32),V(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const _e=ye-pe,lt=Ue-We;return _e<lt?-1:_e>lt?1:0}function W(ne){return ne>=r.CharCode.Digit0&&ne<=r.CharCode.Digit9}function V(ne){return ne>=r.CharCode.a&&ne<=r.CharCode.z}function H(ne){return ne>=r.CharCode.A&&ne<=r.CharCode.Z}function Y(ne,ge){return ne.length===ge.length&&O(ne,ge)===0}function Z(ne,ge){const pe=ge.length;return ge.length>ne.length?!1:O(ne,ge,0,pe)===0}function U(ne,ge){const pe=Math.min(ne.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(ne.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function te(ne,ge){const pe=Math.min(ne.length,ge.length);let ye;const We=ne.length-1,Ue=ge.length-1;for(ye=0;ye<pe;ye++)if(ne.charCodeAt(We-ye)!==ge.charCodeAt(Ue-ye))return ye;return pe}function x(ne){return 55296<=ne&&ne<=56319}function J(ne){return 56320<=ne&&ne<=57343}function B(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}function j(ne,ge,pe){const ye=ne.charCodeAt(pe);if(x(ye)&&pe+1<ge){const We=ne.charCodeAt(pe+1);if(J(We))return B(ye,We)}return ye}function C(ne,ge){const pe=ne.charCodeAt(ge-1);if(J(pe)&&ge>1){const ye=ne.charCodeAt(ge-2);if(x(ye))return B(ye,pe)}return pe}class X{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=C(this.c,this.e);return this.e-=ge>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Lf=X;class ae{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new X(ge,pe)}nextGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let We=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ue=pe.offset,_e=ge.getGraphemeBreakType(pe.nextCodePoint());if(Me(We,_e)){pe.setOffset(Ue);break}We=_e}return pe.offset-ye}prevGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let We=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ue=pe.offset,_e=ge.getGraphemeBreakType(pe.prevCodePoint());if(Me(_e,We)){pe.setOffset(Ue);break}We=_e}return ye-pe.offset}eol(){return this.c.eol()}}e.$Mf=ae;function K(ne,ge){return new ae(ne,ge).nextGraphemeLength()}function ce(ne,ge){return new ae(ne,ge).prevGraphemeLength()}function se(ne,ge){ge>0&&J(ne.charCodeAt(ge))&&ge--;const pe=ge+K(ne,ge);return[pe-ce(ne,pe),pe]}function ie(ne){const ge=new ae(ne);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let M;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(ne){return M||(M=F()),M.test(ne)}const z=/^[\t\n\r\x20-\x7E]*$/;function _(ne){return z.test(ne)}e.$Tf=/[\u2028\u2029]/;function Q(ne){return e.$Tf.test(ne)}function q(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function re(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function de(ne,ge,pe=""){const ye=ne.trimStart();if(ye.length<ge)return ye;const We=/\b/g;let Ue=0;for(;We.test(ye)&&!(ye.length-We.lastIndex<ge);)Ue=We.lastIndex,We.lastIndex+=1;return Ue===0?ye:pe+ye.substring(Ue).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(ne){let ge=0;for(const pe of ne.matchAll(me))ge!==pe.index&&(yield{isCode:!1,str:ne.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==ne.length&&(yield{isCode:!1,str:ne.substring(ge)})}function De(ne){return ne&&(ne=ne.replace(me,"")),ne}const ke=/\\\[.*?\\\]/g;function Pe(ne){return De(ne).replace(ke,"")}e.$2f=String.fromCharCode(r.CharCode.UTF8_BOM);function Re(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(ne){return Re(ne)?ne.substr(1):ne}function ee(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const pe=ge.length,ye=ne.toLowerCase();let We=0,Ue=-1;for(;We<pe;){const _e=ye.indexOf(ge[We],Ue+1);if(_e<0)return!1;Ue=_e,We++}return!0}function ue(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function fe(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function be(ne,ge=1){if(ge===0)return"";let pe=-1;do pe=ne.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ne:(ne[pe-1]==="\r"&&pe--,ne.substr(0,pe))}function Ae(ne){const ge=r.CharCode.Z-r.CharCode.A+1;return ne=ne%(2*ge),ne<ge?String.fromCharCode(r.CharCode.a+ne):String.fromCharCode(r.CharCode.A+ne-ge)}function Ne(ne){return Be.getInstance().getGraphemeBreakType(ne)}function Me(ne,ge){return ne===Oe.Other?ge!==Oe.Extend&&ge!==Oe.SpacingMark:ne===Oe.CR&&ge===Oe.LF?!1:ne===Oe.Control||ne===Oe.CR||ne===Oe.LF||ge===Oe.Control||ge===Oe.CR||ge===Oe.LF?!0:!(ne===Oe.L&&(ge===Oe.L||ge===Oe.V||ge===Oe.LV||ge===Oe.LVT)||(ne===Oe.LV||ne===Oe.V)&&(ge===Oe.V||ge===Oe.T)||(ne===Oe.LVT||ne===Oe.T)&&ge===Oe.T||ge===Oe.Extend||ge===Oe.ZWJ||ge===Oe.SpacingMark||ne===Oe.Prepend||ne===Oe.ZWJ&&ge===Oe.Extended_Pictographic||ne===Oe.Regional_Indicator&&ge===Oe.Regional_Indicator)}var Oe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class Be{static{this.c=null}static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=Ke()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?Oe.LF:ge===r.CharCode.CarriageReturn?Oe.CR:Oe.Control;if(ge<127)return Oe.Other;const pe=this.d,ye=pe.length/3;let We=1;for(;We<=ye;)if(ge<pe[3*We])We=2*We;else if(ge>pe[3*We+1])We=2*We+1;else return pe[3*We+2];return Oe.Other}}function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(ne,ge){if(ne===0)return 0;const pe=qe(ne,ge);if(pe!==void 0)return pe;const ye=new X(ge,ne);return ye.prevCodePoint(),ye.offset}function qe(ne,ge){const pe=new X(ge,ne);let ye=pe.prevCodePoint();for(;Qe(ye)||ye===Je.emojiVariantSelector||ye===Je.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!re(ye))return;let We=pe.offset;return We>0&&pe.prevCodePoint()===Je.zwj&&(We=pe.offset),We}function Qe(ne){return 127995<=ne&&ne<=127999}var Je;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),e.$_f="\xA0";class Xe{static{this.c=new k.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$9e({getCacheKey:JSON.stringify},ge=>{function pe(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function We(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Ue=this.c.value;let _e=ge.filter(tt=>!tt.startsWith("_")&&tt in Ue);_e.length===0&&(_e=["_default"]);let lt;for(const tt of _e){const ut=pe(Ue[tt]);lt=We(lt,ut)}const rt=pe(Ue._common),at=ye(rt,lt);return new Xe(at)})}static getInstance(ge){return Xe.d.get(Array.from(ge))}static{this.e=new k.$T(()=>Object.keys(Xe.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=Xe;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(ge){return Ce.e().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&Ce.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ce.e()}}e.$bg=Ce}),define(le[32],he([0,1,39,9,3,25,12]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=I,e.$vg=p,e.$wg=c,e.$xg=m,e.$yg=h,e.$zg=g,e.$Ag=v,e.$Bg=b,e.$Cg=$,e.$Dg=P,e.$Eg=E,e.$Fg=t,e.$Gg=u,e.$Hg=i,e.$Ig=o,e.$Jg=s,e.$Kg=S;function I(y){return y===n.CharCode.Slash||y===n.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,r.$fc.sep)}function c(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function m(y,D=r.$fc.sep){if(!y)return"";const L=y.length,A=y.charCodeAt(0);if(I(A)){if(I(y.charCodeAt(1))&&!I(y.charCodeAt(2))){let W=3;const V=W;for(;W<L&&!I(y.charCodeAt(W));W++);if(V!==W&&!I(y.charCodeAt(W+1))){for(W+=1;W<L;W++)if(I(y.charCodeAt(W)))return y.slice(0,W+1).replace(/[\\/]/g,D)}}return D}else if($(A)&&y.charCodeAt(1)===n.CharCode.Colon)return I(y.charCodeAt(2))?y.slice(0,2)+D:y.slice(0,2);let O=y.indexOf("://");if(O!==-1){for(O+=3;O<L;O++)if(I(y.charCodeAt(O)))return y.slice(0,O+1)}return""}function h(y){if(!k.$j||!y||y.length<5)return!1;let D=y.charCodeAt(0);if(D!==n.CharCode.Backslash||(D=y.charCodeAt(1),D!==n.CharCode.Backslash))return!1;let L=2;const A=L;for(;L<y.length&&(D=y.charCodeAt(L),D!==n.CharCode.Backslash);L++);return!(A===L||(D=y.charCodeAt(L+1),isNaN(D)||D===n.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,w=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(y,D=k.$j){const L=D?d:w;return!(!y||y.length===0||/^\s+$/.test(y)||(L.lastIndex=0,L.test(y))||D&&f.test(y)||y==="."||y===".."||D&&y[y.length-1]==="."||D&&y.length!==y.trim().length||y.length>255)}function v(y,D,L){const A=y===D;return!L||A?A:!y||!D?!1:(0,R.$Df)(y,D)}function b(y,D,L,A=r.sep){if(y===D)return!0;if(!y||!D||D.length>y.length)return!1;if(L){if(!(0,R.$Ef)(y,D))return!1;if(D.length===y.length)return!0;let W=D.length;return D.charAt(D.length-1)===A&&W--,y.charAt(W)===A}return D.charAt(D.length-1)!==A&&(D+=A),y.indexOf(D)===0}function $(y){return y>=n.CharCode.A&&y<=n.CharCode.Z||y>=n.CharCode.a&&y<=n.CharCode.z}function P(y,D){return k.$j&&y.endsWith(":")&&(y+=r.sep),(0,r.$hc)(y)||(y=(0,r.$ic)(D,y)),y=(0,r.$gc)(y),E(y)}function E(y){return k.$j?(y=(0,R.$lf)(y,r.sep),y.endsWith(":")&&(y+=r.sep)):(y=(0,R.$lf)(y,r.sep),y||(y=r.sep)),y}function t(y){const D=(0,r.$gc)(y);return k.$j?y.length>3?!1:u(D)&&(y.length===2||D.charCodeAt(2)===n.CharCode.Backslash):D===r.$fc.sep}function u(y,D=k.$j){return D?$(y.charCodeAt(0))&&y.charCodeAt(1)===n.CharCode.Colon:!1}function i(y,D=k.$j){return u(y,D)?y[0]:void 0}function o(y,D,L){return D.length>y.length?-1:y===D?0:(L&&(y=y.toLowerCase(),D=D.toLowerCase()),y.indexOf(D))}function s(y){const D=y.split(":");let L,A,O;for(const W of D){const V=Number(W);(0,T.$gg)(V)?A===void 0?A=V:O===void 0&&(O=V):L=L?[L,W].join(":"):W}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:A!==void 0?A:void 0,column:O!==void 0?O:A!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(y,D,L=8){let A="";for(let W=0;W<L;W++){let V;W===0&&k.$j&&!D&&(L===3||L===4)?V=l:V=a,A+=V.charAt(Math.floor(Math.random()*V.length))}let O;return D?O=`${D}-${A}`:O=A,y?(0,r.$ic)(y,O):O}}),define(le[46],he([0,1,25]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=r,e.$rj=k,e.$sj=R,e.$tj=I,e.$vj=g,n=Ie(n);function r(b){return k(b,0)}function k(b,$){switch(typeof b){case"object":return b===null?R(349,$):Array.isArray(b)?p(b,$):c(b,$);case"string":return I(b,$);case"boolean":return T(b,$);case"number":return R(b,$);case"undefined":return R(937,$);default:return R(617,$)}}function R(b,$){return($<<5)-$+b|0}function T(b,$){return R(b?433:863,$)}function I(b,$){$=R(149417,$);for(let P=0,E=b.length;P<E;P++)$=R(b.charCodeAt(P),$);return $}function p(b,$){return $=R(104579,$),b.reduce((P,E)=>k(E,P),$)}function c(b,$){return $=R(181387,$),Object.keys(b).sort().reduce((P,E)=>(P=I(E,P),k(b[E],P)),$)}class m{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=k($,this.g),this.g}}e.$uj=m;var h;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(h||(h={}));function d(b,$,P=32){const E=P-$,t=~((1<<E)-1);return(b<<$|(t&b)>>>E)>>>0}function w(b,$=0,P=b.byteLength,E=0){for(let t=0;t<P;t++)b[$+t]=E}function f(b,$,P="0"){for(;b.length<$;)b=P+b;return b}function g(b,$=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(P=>P.toString(16).padStart(2,"0")).join(""):f((b>>>0).toString(16),$/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(h.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const P=$.length;if(P===0)return;const E=this.p;let t=this.r,u=this.u,i,o;for(u!==0?(i=u,o=-1,u=0):(i=$.charCodeAt(0),o=0);;){let s=i;if(n.$Hf(i))if(o+1<P){const a=$.charCodeAt(o+1);n.$If(a)?(o++,s=n.$Jf(i,a)):s=h.UNICODE_REPLACEMENT}else{u=i;break}else n.$If(i)&&(s=h.UNICODE_REPLACEMENT);if(t=this.w(E,t,s),o++,o<P)i=$.charCodeAt(o);else break}this.r=t,this.u=u}w($,P,E){return E<128?$[P++]=E:E<2048?($[P++]=192|(E&1984)>>>6,$[P++]=128|(E&63)>>>0):E<65536?($[P++]=224|(E&61440)>>>12,$[P++]=128|(E&4032)>>>6,$[P++]=128|(E&63)>>>0):($[P++]=240|(E&1835008)>>>18,$[P++]=128|(E&258048)>>>12,$[P++]=128|(E&4032)>>>6,$[P++]=128|(E&63)>>>0),P>=h.BLOCK_SIZE&&(this.y(),P-=h.BLOCK_SIZE,this.t+=h.BLOCK_SIZE,$[0]=$[h.BLOCK_SIZE+0],$[1]=$[h.BLOCK_SIZE+1],$[2]=$[h.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,h.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=v.g,P=this.q;for(let S=0;S<64;S+=4)$.setUint32(S,P.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)$.setUint32(S,d($.getUint32(S-12,!1)^$.getUint32(S-32,!1)^$.getUint32(S-56,!1)^$.getUint32(S-64,!1),1),!1);let E=this.h,t=this.l,u=this.m,i=this.n,o=this.o,s,a,l;for(let S=0;S<80;S++)S<20?(s=t&u|~t&i,a=1518500249):S<40?(s=t^u^i,a=1859775393):S<60?(s=t&u|t&i|u&i,a=2400959708):(s=t^u^i,a=3395469782),l=d(E,5)+s+o+a+$.getUint32(S*4,!1)&4294967295,o=i,i=u,u=d(t,30),t=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+t&4294967295,this.m=this.m+u&4294967295,this.n=this.n+i&4294967295,this.o=this.o+o&4294967295}}e.$wj=v}),define(le[81],he([0,1,25]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=Ie(n);var r;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(r||(r={})),function(k){const R="error",T="warning",I="warn",p="info",c="ignore";function m(d){return d?n.$Df(R,d)?k.Error:n.$Df(T,d)||n.$Df(I,d)?k.Warning:n.$Df(p,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=m;function h(d){switch(d){case k.Error:return R;case k.Warning:return T;case k.Info:return p;default:return c}}k.toString=h}(r||(r={})),e.default=r}),define(le[60],he([0,1,21,39,25]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class R{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const g=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return g-v}value(){return this.b[this.c]}}e.$Ei=R;class T{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,k.$xf)(f,this.b,0,f.length,this.c,this.d):(0,k.$zf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=T;class I{constructor(f=!0,g=!0){this.f=f,this.g=g}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let g=f.length-1;g>=0;g--,this.c--){const v=this.b.charCodeAt(g);if(!(v===r.CharCode.Slash||this.f&&v===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===r.CharCode.Slash||this.f&&g===r.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,k.$xf)(f,this.b,0,f.length,this.d,this.e):(0,k.$zf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=I;var p;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(f,g){this.f=f,this.g=g,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new I(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(p.Path)),this.g(f)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===p.Scheme)return(0,k.$yf)(f,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,k.$yf)(f,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(f);if(this.d[this.e]===p.Query)return(0,k.$wf)(f,this.c.query);if(this.d[this.e]===p.Fragment)return(0,k.$wf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Hi=c;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(h||(h={}));class d{static forUris(f=()=>!1,g=()=>!1){return new d(new c(f,g))}static forPaths(f=!1){return new d(new I(void 0,!f))}static forStrings(){return new d(new R)}static forConfigKeys(){return new d(new T)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,g){if(g){const v=g.slice(0);(0,n.$Vb)(v);for(const b of v)this.set(b,f)}else{const v=f.slice(0);(0,n.$Vb)(v);for(const b of v)this.set(b[0],b[1])}}set(f,g){const v=this.b.reset(f);let b;this.c||(this.c=new m,this.c.segment=v.value());const $=[];for(b=this.c;;){const E=v.cmp(b.segment);if(E>0)b.left||(b.left=new m,b.left.segment=v.value()),$.push([h.Left,b]),b=b.left;else if(E<0)b.right||(b.right=new m,b.right.segment=v.value()),$.push([h.Right,b]),b=b.right;else if(v.hasNext())v.next(),b.mid||(b.mid=new m,b.mid.segment=v.value()),$.push([h.Mid,b]),b=b.mid;else break}const P=b.value;b.value=g,b.key=f;for(let E=$.length-1;E>=0;E--){const t=$[E][1];t.updateHeight();const u=t.balanceFactor();if(u<-1||u>1){const i=$[E][0],o=$[E+1][0];if(i===h.Right&&o===h.Right)$[E][1]=t.rotateLeft();else if(i===h.Left&&o===h.Left)$[E][1]=t.rotateRight();else if(i===h.Right&&o===h.Left)t.right=$[E+1][1]=$[E+1][1].rotateRight(),$[E][1]=t.rotateLeft();else if(i===h.Left&&o===h.Right)t.left=$[E+1][1]=$[E+1][1].rotateLeft(),$[E][1]=t.rotateRight();else throw new Error;if(E>0)switch($[E-1][0]){case h.Left:$[E-1][1].left=$[E][1];break;case h.Right:$[E-1][1].right=$[E][1];break;case h.Mid:$[E-1][1].mid=$[E][1];break}else this.c=$[0][1]}}return P}get(f){return this.d(f)?.value}d(f){const g=this.b.reset(f);let v=this.c;for(;v;){const b=g.cmp(v.segment);if(b>0)v=v.left;else if(b<0)v=v.right;else if(g.hasNext())g.next(),v=v.mid;else break}return v}has(f){const g=this.d(f);return!(g?.value===void 0&&g?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,g){const v=this.b.reset(f),b=[];let $=this.c;for(;$;){const P=v.cmp($.segment);if(P>0)b.push([h.Left,$]),$=$.left;else if(P<0)b.push([h.Right,$]),$=$.right;else if(v.hasNext())v.next(),b.push([h.Mid,$]),$=$.mid;else break}if($){if(g?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const P=this.f($.right);if(P.key){const{key:E,value:t,segment:u}=P;this.e(P.key,!1),$.key=E,$.value=t,$.segment=u}}else{const P=$.left??$.right;if(b.length>0){const[E,t]=b[b.length-1];switch(E){case h.Left:t.left=P;break;case h.Mid:t.mid=P;break;case h.Right:t.right=P;break}}else this.c=P}for(let P=b.length-1;P>=0;P--){const E=b[P][1];E.updateHeight();const t=E.balanceFactor();if(t>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),b[P][1]=E.rotateLeft()):t<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),b[P][1]=E.rotateRight()),P>0)switch(b[P-1][0]){case h.Left:b[P-1][1].left=b[P][1];break;case h.Right:b[P-1][1].right=b[P][1];break;case h.Mid:b[P-1][1].mid=b[P][1];break}else this.c=b[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const g=this.b.reset(f);let v=this.c,b;for(;v;){const $=g.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(g.hasNext())g.next(),b=v.value||b,v=v.mid;else break}return v&&v.value||b}findSuperstr(f){return this.g(f,!1)}g(f,g){const v=this.b.reset(f);let b=this.c;for(;b;){const $=v.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(v.hasNext())v.next(),b=b.mid;else return b.mid?this.h(b.mid):g?b.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[g,v]of this)f(v,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const g=[];return this.j(f,g),g[Symbol.iterator]()}j(f,g){f&&(f.left&&this.j(f.left,g),f.value&&g.push([f.key,f.value]),f.mid&&this.j(f.mid,g),f.right&&this.j(f.right,g))}_isBalanced(){const f=g=>{if(!g)return!0;const v=g.balanceFactor();return v<-1||v>1?!1:f(g.left)&&f(g.right)};return f(this.c)}}e.$Ii=d}),define(le[7],he([0,1,39,90,9,3]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$uc=v,e.$vc=u,k=Ie(k);const T=/^\w[\w\d+.-]*$/,I=/^\//,p=/^\/\//;function c(l,S){if(!l.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!T.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(l,S){return!l&&!S?"file":l}function h(l,S){switch(l){case"https":case"http":case"file":S?S[0]!==w&&(S=w+S):S=w;break}return S}const d="",w="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(S){return S instanceof g?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,y,D,L,A,O=!1){typeof S=="object"?(this.scheme=S.scheme||d,this.authority=S.authority||d,this.path=S.path||d,this.query=S.query||d,this.fragment=S.fragment||d):(this.scheme=m(S,O),this.authority=y||d,this.path=h(this.scheme,D||d),this.query=L||d,this.fragment=A||d,c(this,O))}get fsPath(){return u(this,!1)}with(S){if(!S)return this;let{scheme:y,authority:D,path:L,query:A,fragment:O}=S;return y===void 0?y=this.scheme:y===null&&(y=d),D===void 0?D=this.authority:D===null&&(D=d),L===void 0?L=this.path:L===null&&(L=d),A===void 0?A=this.query:A===null&&(A=d),O===void 0?O=this.fragment:O===null&&(O=d),y===this.scheme&&D===this.authority&&L===this.path&&A===this.query&&O===this.fragment?this:new $(y,D,L,A,O)}static parse(S,y=!1){const D=f.exec(S);return D?new $(D[2]||d,a(D[4]||d),a(D[5]||d),a(D[7]||d),a(D[9]||d),y):new $(d,d,d,d,d)}static file(S){let y=d;if(R.$j&&(S=S.replace(/\\/g,w)),S[0]===w&&S[1]===w){const D=S.indexOf(w,2);D===-1?(y=S.substring(2),S=w):(y=S.substring(2,D),S=S.substring(D)||w)}return new $("file",y,S,d,d)}static from(S,y){return new $(S.scheme,S.authority,S.path,S.query,S.fragment,y)}static joinPath(S,...y){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return R.$j&&S.scheme==="file"?D=g.file(k.$ec.join(u(S,!0),...y)).path:D=k.$fc.join(S.path,...y),S.with({path:D})}toString(S=!1){return i(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof g)return S;{const y=new $(S);return y._formatted=S.external??null,y._fsPath=S._sep===b?S.fsPath??null:null,y}}else return S}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=g;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const b=R.$j?1:void 0;class $ extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(S=!1){return S?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const S={$mid:r.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=b),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const P={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function E(l,S,y){let D,L=-1;for(let A=0;A<l.length;A++){const O=l.charCodeAt(A);if(O>=n.CharCode.a&&O<=n.CharCode.z||O>=n.CharCode.A&&O<=n.CharCode.Z||O>=n.CharCode.Digit0&&O<=n.CharCode.Digit9||O===n.CharCode.Dash||O===n.CharCode.Period||O===n.CharCode.Underline||O===n.CharCode.Tilde||S&&O===n.CharCode.Slash||y&&O===n.CharCode.OpenSquareBracket||y&&O===n.CharCode.CloseSquareBracket||y&&O===n.CharCode.Colon)L!==-1&&(D+=encodeURIComponent(l.substring(L,A)),L=-1),D!==void 0&&(D+=l.charAt(A));else{D===void 0&&(D=l.substr(0,A));const W=P[O];W!==void 0?(L!==-1&&(D+=encodeURIComponent(l.substring(L,A)),L=-1),D+=W):L===-1&&(L=A)}}return L!==-1&&(D+=encodeURIComponent(l.substring(L))),D!==void 0?D:l}function t(l){let S;for(let y=0;y<l.length;y++){const D=l.charCodeAt(y);D===n.CharCode.Hash||D===n.CharCode.QuestionMark?(S===void 0&&(S=l.substr(0,y)),S+=P[D]):S!==void 0&&(S+=l[y])}return S!==void 0?S:l}function u(l,S){let y;return l.authority&&l.path.length>1&&l.scheme==="file"?y=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===n.CharCode.Slash&&(l.path.charCodeAt(1)>=n.CharCode.A&&l.path.charCodeAt(1)<=n.CharCode.Z||l.path.charCodeAt(1)>=n.CharCode.a&&l.path.charCodeAt(1)<=n.CharCode.z)&&l.path.charCodeAt(2)===n.CharCode.Colon?S?y=l.path.substr(1):y=l.path[1].toLowerCase()+l.path.substr(2):y=l.path,R.$j&&(y=y.replace(/\//g,"\\")),y}function i(l,S){const y=S?t:E;let D="",{scheme:L,authority:A,path:O,query:W,fragment:V}=l;if(L&&(D+=L,D+=":"),(A||L==="file")&&(D+=w,D+=w),A){let H=A.indexOf("@");if(H!==-1){const Y=A.substr(0,H);A=A.substr(H+1),H=Y.lastIndexOf(":"),H===-1?D+=y(Y,!1,!1):(D+=y(Y.substr(0,H),!1,!1),D+=":",D+=y(Y.substr(H+1),!1,!0)),D+="@"}A=A.toLowerCase(),H=A.lastIndexOf(":"),H===-1?D+=y(A,!1,!0):(D+=y(A.substr(0,H),!1,!0),D+=A.substr(H))}if(O){if(O.length>=3&&O.charCodeAt(0)===n.CharCode.Slash&&O.charCodeAt(2)===n.CharCode.Colon){const H=O.charCodeAt(1);H>=n.CharCode.A&&H<=n.CharCode.Z&&(O=`/${String.fromCharCode(H+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===n.CharCode.Colon){const H=O.charCodeAt(0);H>=n.CharCode.A&&H<=n.CharCode.Z&&(O=`${String.fromCharCode(H+32)}:${O.substr(2)}`)}D+=y(O,!0,!1)}return W&&(D+="?",D+=y(W,!1,!1)),V&&(D+="#",D+=S?V:E(V,!1,!1)),D}function o(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+o(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(l){return l.match(s)?l.replace(s,S=>o(S)):l}}),define(le[150],he([0,1,7]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=r,e.$br=k,e.$cr=R,e.log=I;function r(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}function k(c){const m=[];let h;try{const d=JSON.parse(c.arguments),w=d[d.length-1];w&&w.__$stack&&(d.pop(),h=w.__$stack),m.push(...d)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:h}}function R(c){if(typeof c!="string")return R(k(c).stack);const m=c;if(m){const h=T(m),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(d&&d.length===4)return{uri:n.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function T(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function I(c,m){const{args:h,stack:d}=k(c),w=typeof h[0]=="string"&&h.length===1;let f=T(d);f&&(f=`(${f.trim()})`);let g=[];if(typeof h[0]=="string"?f&&w?g=[`%c[${m}] %c${h[0]} %c${f}`,p("blue"),p(""),p("grey")]:g=[`%c[${m}] %c${h[0]}`,p("blue"),p(""),...h.slice(1)]:g=[`%c[${m}]%`,p("blue"),...h],f&&!w&&g.push(f),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,g)}function p(c){return`color: ${c}`}}),define(le[82],he([0,1,17,7,90]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=R,e.$$h=T,e.$_h=p;function R(c){return JSON.stringify(c,I)}function T(c){let m=JSON.parse(c);return m=p(m),m}function I(c,m){return m instanceof RegExp?{$mid:k.MarshalledId.Regexp,source:m.source,flags:m.flags}:m}function p(c,m=0){if(!c||m>200)return c;if(typeof c=="object"){switch(c.$mid){case k.MarshalledId.Uri:return r.URI.revive(c);case k.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case k.MarshalledId.Date:return new Date(c.source)}if(c instanceof n.$Le||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let h=0;h<c.length;++h)c[h]=p(c[h],m+1);else for(const h in c)Object.hasOwnProperty.call(c,h)&&(c[h]=p(c[h],m+1))}return c}}),define(le[11],he([0,1,15,3,25,7,9]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=p,e.$Mg=c,e.$Qg=h,n=Ie(n),r=Ie(r),T=Ie(T);var I;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(I||(e.Schemas=I={}));function p(f,g){return R.URI.isUri(f)?(0,k.$Df)(f.scheme,g):(0,k.$Ef)(f,g+":")}function c(f,...g){return g.some(v=>p(f,v))}e.$Ng="vscode-tkn",e.$Og="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,v){this.f=h(g,v)}getServerRootPath(){return this.f}get g(){return T.$fc.join(this.f,I.vscodeRemoteResource)}set(g,v,b){this.a[g]=v,this.b[g]=b}setConnectionToken(g,v){this.c[g]=v}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(t){return n.$Y(t),g}const v=g.authority;let b=this.a[v];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const $=this.b[v],P=this.c[v];let E=`path=${encodeURIComponent(g.path)}`;return typeof P=="string"&&(E+=`&${e.$Og}=${encodeURIComponent(P)}`),R.URI.from({scheme:r.$p?this.d:I.vscodeRemoteResource,authority:`${b}:${$}`,path:this.g,query:E})}}e.$Pg=new m;function h(f,g){return T.$fc.join(g??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class d{static{this.a=e.$Vg}asBrowserUri(g){const v=this.b(g,G);return this.uriToBrowserUri(v)}uriToBrowserUri(g){return g.scheme===I.vscodeRemote?e.$Pg.rewrite(g):g.scheme===I.file&&(r.$n||r.$r===`${I.vscodeFileResource}://${d.a}`)?g.with({scheme:I.vscodeFileResource,authority:g.authority||d.a,query:null,fragment:null}):g}asFileUri(g){const v=this.b(g,G);return this.uriToFileUri(v)}uriToFileUri(g){return g.scheme===I.vscodeFileResource?g.with({scheme:I.file,authority:g.authority!==d.a?g.authority:null,query:null,fragment:null}):g}b(g,v){return R.URI.isUri(g)?g:R.URI.parse(v.toUrl(g))}}e.$Wg=new d;var w;(function(f){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(g.get("3"));const v="vscode-coi";function b(P){let E;typeof P=="string"?E=new URL(P).searchParams:P instanceof URL?E=P.searchParams:R.URI.isUri(P)&&(E=new URL(P.toString(!0)).searchParams);const t=E?.get(v);if(t)return g.get(t)}f.getHeadersFromQuery=b;function $(P,E,t){if(!globalThis.crossOriginIsolated)return;const u=E&&t?"3":t?"2":"1";P instanceof URLSearchParams?P.set(v,u):P[v]=u}f.addSearchParam=$})(w||(e.COI=w={}))}),define(le[18],he([0,1,39,32,11,9,3,25,7]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=c,e.$mh=h,e.$nh=w,r=Ie(r),R=Ie(R);function c(f){return(0,p.$vc)(f,!0)}class m{constructor(g){this.a=g}compare(g,v,b=!1){return g===v?0:(0,I.$wf)(this.getComparisonKey(g,b),this.getComparisonKey(v,b))}isEqual(g,v,b=!1){return g===v?!0:!g||!v?!1:this.getComparisonKey(g,b)===this.getComparisonKey(v,b)}getComparisonKey(g,v=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,v,b=!1){if(g.scheme===v.scheme){if(g.scheme===k.Schemas.file)return r.$Bg(c(g),c(v),this.a(g))&&g.query===v.query&&(b||g.fragment===v.fragment);if((0,e.$ih)(g.authority,v.authority))return r.$Bg(g.path,v.path,this.a(g),"/")&&g.query===v.query&&(b||g.fragment===v.fragment)}return!1}joinPath(g,...v){return p.URI.joinPath(g,...v)}basenameOrAuthority(g){return(0,e.$ah)(g)||g.authority}basename(g){return R.$fc.basename(g.path)}extname(g){return R.$fc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let v;return g.scheme===k.Schemas.file?v=p.URI.file(R.$lc(c(g))).path:(v=R.$fc.dirname(g.path),g.authority&&v.length&&v.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),v="/")),g.with({path:v})}normalizePath(g){if(!g.path.length)return g;let v;return g.scheme===k.Schemas.file?v=p.URI.file(R.$gc(c(g))).path:v=R.$fc.normalize(g.path),g.with({path:v})}relativePath(g,v){if(g.scheme!==v.scheme||!(0,e.$ih)(g.authority,v.authority))return;if(g.scheme===k.Schemas.file){const P=R.$kc(c(g),c(v));return T.$j?r.$vg(P):P}let b=g.path||"/";const $=v.path||"/";if(this.a(g)){let P=0;for(const E=Math.min(b.length,$.length);P<E&&!(b.charCodeAt(P)!==$.charCodeAt(P)&&b.charAt(P).toLowerCase()!==$.charAt(P).toLowerCase());P++);b=$.substr(0,P)+b.substr(P)}return R.$fc.relative(b,$)}resolvePath(g,v){if(g.scheme===k.Schemas.file){const b=p.URI.file(R.$jc(c(g),v));return g.with({authority:b.authority,path:b.path})}return v=r.$wg(v),g.with({path:R.$fc.resolve(g.path,v)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,v){return g===v||g!==void 0&&v!==void 0&&(0,I.$Df)(g,v)}hasTrailingPathSeparator(g,v=R.sep){if(g.scheme===k.Schemas.file){const b=c(g);return b.length>r.$xg(b).length&&b[b.length-1]===v}else{const b=g.path;return b.length>1&&b.charCodeAt(b.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,v=R.sep){return(0,e.$jh)(g,v)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,v=R.sep){let b=!1;if(g.scheme===k.Schemas.file){const $=c(g);b=$!==void 0&&$.length===r.$xg($).length&&$[$.length-1]===v}else{v="/";const $=g.path;b=$.length===1&&$.charCodeAt($.length-1)===n.CharCode.Slash}return!b&&!(0,e.$jh)(g,v)?g.with({path:g.path+"/"}):g}}e.$5g=m,e.$6g=new m(()=>!1),e.$7g=new m(f=>f.scheme===k.Schemas.file?!T.$l:!0),e.$8g=new m(f=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function h(f,g){const v=[];for(let b=0;b<f.length;b++){const $=g(f[b]);f.some((P,E)=>E===b?!1:(0,e.$0g)($,g(P)))||v.push(f[b])}return v}var d;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function g(v){const b=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(E=>{const[t,u]=E.split(":");t&&u&&b.set(t,u)});const P=v.path.substring(0,v.path.indexOf(";"));return P&&b.set(f.META_DATA_MIME,P),b}f.parseMetaData=g})(d||(e.DataUri=d={}));function w(f,g,v){if(g){let b=f.path;return b&&b[0]!==R.$fc.sep&&(b=R.$fc.sep+b),f.with({scheme:v,authority:g,path:b})}return f.with({scheme:v})}}),define(le[8],he([0,1,22,15,4,2,18,3,147,65]),function(G,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=m,e.$ph=h,e.$qh=d,e.$rh=w,e.$sh=f,e.$th=g,e.$uh=v,e.$vh=b,e.$Dh=l,e.$Eh=S,e.$Fh=y,e.$Gh=D,e.$Hh=L,e.$Wh=j,e.$5h=z;function m(Q){return!!Q&&typeof Q.then=="function"}function h(Q){const q=new n.$ue,re=Q(q.token),de=new Promise((me,we)=>{const De=q.token.onCancellationRequested(()=>{De.dispose(),we(new r.$4)});Promise.resolve(re).then(ke=>{De.dispose(),q.dispose(),me(ke)},ke=>{De.dispose(),q.dispose(),we(ke)})});return new class{cancel(){q.cancel(),q.dispose()}then(me,we){return de.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function d(Q,q,re){return new Promise((de,me)=>{const we=q.onCancellationRequested(()=>{we.dispose(),de(re)});Q.then(de,me).finally(()=>we.dispose())})}function w(Q,q){return new Promise((re,de)=>{const me=q.onCancellationRequested(()=>{me.dispose(),de(new r.$4)});Q.then(re,de).finally(()=>me.dispose())})}async function f(Q){let q=-1;const re=Q.map((de,me)=>de.then(we=>(q=me,we)));try{return await Promise.race(re)}finally{Q.forEach((de,me)=>{me!==q&&de.cancel()})}}function g(Q,q,re){let de;const me=setTimeout(()=>{de?.(void 0),re?.()},q);return Promise.race([Q.finally(()=>clearTimeout(me)),new Promise(we=>de=we)])}function v(Q){return new Promise((q,re)=>{const de=Q();m(de)?de.then(q,re):q(de)})}function b(){let Q,q;return{promise:new Promise((de,me)=>{Q=de,q=me}),resolve:Q,reject:q}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const re=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(re,re).then(de)})}return new Promise((re,de)=>{this.b.then(re,de)})}return this.a=q(),new Promise((re,de)=>{this.a.then(me=>{this.a=null,re(me)},me=>{this.a=null,de(me)})})}dispose(){this.f=!0}}e.$wh=$;class P{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$xh=P;class E{constructor(){this.a=new Map}queue(q,re){const me=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(q)===me&&this.a.delete(q)});return this.a.set(q,me),me}}e.$yh=E;const t=(Q,q)=>{let re=!0;const de=setTimeout(()=>{re=!1,q()},Q);return{isTriggered:()=>re,dispose:()=>{clearTimeout(de),re=!1}}},u=Q=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,Q())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class i{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,re=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=re===p.$ee?u(de):t(re,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=i;class o{constructor(q){this.a=new i(q),this.b=new $}trigger(q,re){return this.a.trigger(()=>this.b.queue(q),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=o;class s{constructor(){this.a=!1,this.b=new Promise((q,re)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=s;class a extends s{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Ch=a;function l(Q,q){return q?new Promise((re,de)=>{const me=setTimeout(()=>{we.dispose(),re()},Q),we=q.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),de(new r.$4)})}):h(re=>l(Q,re))}function S(Q,q=0,re){const de=setTimeout(()=>{Q(),re&&me.dispose()},q),me=(0,R.$Rc)(()=>{clearTimeout(de),re?.deleteAndLeak(me)});return re?.add(me),me}function y(Q){const q=[];let re=0;const de=Q.length;function me(){return re<de?Q[re++]():null}function we(De){De!=null&&q.push(De);const ke=me();return ke?ke.then(we):Promise.resolve(q)}return Promise.resolve(null).then(we)}function D(Q,q=de=>!!de,re=null){let de=0;const me=Q.length,we=()=>{if(de>=me)return Promise.resolve(re);const De=Q[de++];return Promise.resolve(De()).then(Pe=>q(Pe)?Promise.resolve(Pe):we())};return we()}function L(Q,q=de=>!!de,re=null){if(Q.length===0)return Promise.resolve(re);let de=Q.length;const me=()=>{de=-1;for(const we of Q)we.cancel?.()};return new Promise((we,De)=>{for(const ke of Q)ke.then(Pe=>{--de>=0&&q(Pe)?(me(),we(Pe)):de===0&&we(re)}).catch(Pe=>{--de>=0&&(me(),De(Pe))})})}class A{constructor(q){this.a=0,this.b=!1,this.f=q,this.g=[],this.d=0,this.h=new k.$je}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,de)=>{this.g.push({factory:q,c:re,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const q=this.g.shift();this.d++;const re=q.factory();re.then(q.c,q.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=A;class O extends A{constructor(){super(1)}}e.$Jh=O;class W{constructor(){this.a=new C,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Kh=W;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new K;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueSize(q,re=T.$6g){const de=re.getComparisonKey(q);return this.a.get(de)?.size??0}queueFor(q,re,de=T.$6g){const me=de.getComparisonKey(q);let we=this.a.get(me);if(!we){we=new O;const De=this.f++,ke=k.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$3c),this.d.set(De,ke),this.a.set(me,we)}return we.queue(re)}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=V;class H{constructor(q,re){this.b=!1,this.a=-1,typeof q=="function"&&typeof re=="number"&&this.setIfNotSet(q,re)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,re){if(this.b)throw new r.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},re)}setIfNotSet(q,re){if(this.b)throw new r.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},re))}}e.$Mh=H;class Y{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(q,re,de=globalThis){if(this.f)throw new r.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{q()},re);this.d=(0,R.$Rc)(()=>{de.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=Y;class Z{constructor(q,re){this.b=-1,this.a=q,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=Z;class U{constructor(q,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=q,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=U;class te extends Z{constructor(q,re){super(q,re),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Qh=te;class x extends R.$Tc{constructor(q,re){super(),this.g=q,this.h=re,this.a=[],this.b=this.B(new R.$Uc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of q)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=x,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(Q,q)=>{(0,I.$C)(()=>{if(re)return;const de=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$Th=(Q,q,re)=>{const de=Q.requestIdleCallback(q,typeof re=="number"?{timeout:re}:void 0);let me=!1;return{dispose(){me||(me=!0,Q.cancelIdleCallback(de))}}},e.$Sh=Q=>(0,e.$Th)(globalThis,Q)}();class J{constructor(q,re){this.g=!1,this.d=()=>{try{this.j=re()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$Th)(q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=J;class B extends J{constructor(q){super(globalThis,q)}}e.$Vh=B;async function j(Q,q,re){let de;for(let me=0;me<re;me++)try{return await Q()}catch(we){de=we,await l(q)}throw de}class C{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,re,de){return this.a={taskId:q,cancel:()=>de?.(),promise:re},re.then(()=>this.d(q),()=>this.d(q)),re}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{const{promise:re,resolve:de,reject:me}=b();this.b={run:q,promise:re,promiseResolve:de,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=C;class X{constructor(q,re=()=>Date.now()){this.d=q,this.f=re,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$Yh=X;var ae;(function(Q){Q[Q.Resolved=0]="Resolved",Q[Q.Rejected=1]="Rejected"})(ae||(ae={}));class K{get isRejected(){return this.d?.outcome===ae.Rejected}get isResolved(){return this.d?.outcome===ae.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ae.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((q,re)=>{this.a=q,this.b=re})}complete(q){return new Promise(re=>{this.a(q),this.d={outcome:ae.Resolved,value:q},re()})}error(q){return new Promise(re=>{this.b(q),this.d={outcome:ae.Rejected,value:q},re()})}cancel(){return this.error(new r.$4)}}e.$Zh=K;var ce;(function(Q){async function q(de){let me;const we=await Promise.all(de.map(De=>De.then(ke=>ke,ke=>{me||(me=ke)})));if(typeof me<"u")throw me;return we}Q.settled=q;function re(de){return new Promise(async(me,we)=>{try{await de(me,we)}catch(De){we(De)}})}Q.withAsyncBody=re})(ce||(e.Promises=ce={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=q.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new r.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=se;class ie{constructor(q){this.b=q,this.a=new c.$T(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=ie;var M;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(M||(M={}));class F{static fromArray(q){return new F(re=>{re.emitMany(q)})}static fromPromise(q){return new F(async re=>{re.emitMany(await q)})}static fromPromises(q){return new F(async re=>{await Promise.all(q.map(async de=>re.emitOne(await de)))})}static merge(q){return new F(async re=>{await Promise.all(q.map(async de=>{for await(const me of de)re.emitOne(me)}))})}static{this.EMPTY=F.fromArray([])}constructor(q,re){this.a=M.Initial,this.b=[],this.d=null,this.f=re,this.g=new k.$je,queueMicrotask(async()=>{const de={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(q(de)),this.k()}catch(me){this.l(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===M.DoneError)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===M.DoneOK)return{done:!0,value:void 0};await k.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(q,re){return new F(async de=>{for await(const me of q)de.emitOne(re(me))})}map(q){return F.map(this,q)}static filter(q,re){return new F(async de=>{for await(const me of q)re(me)&&de.emitOne(me)})}filter(q){return F.filter(this,q)}static coalesce(q){return F.filter(q,re=>!!re)}coalesce(){return F.coalesce(this)}static async toPromise(q){const re=[];for await(const de of q)re.push(de);return re}toPromise(){return F.toPromise(this)}h(q){this.a===M.Initial&&(this.b.push(q),this.g.fire())}j(q){this.a===M.Initial&&(this.b=this.b.concat(q),this.g.fire())}k(){this.a===M.Initial&&(this.a=M.DoneOK,this.g.fire())}l(q){this.a===M.Initial&&(this.a=M.DoneError,this.d=q,this.g.fire())}}e.$3h=F;class N extends F{constructor(q,re){super(re),this.m=q}cancel(){this.m.cancel()}}e.$4h=N;function z(Q){const q=new n.$ue,re=Q(q.token);return new N(q,async de=>{const me=q.token.onCancellationRequested(()=>{me.dispose(),q.dispose(),de.reject(new r.$4)});try{for await(const we of re){if(q.token.isCancellationRequested)return;de.emitOne(we)}me.dispose(),q.dispose()}catch(we){me.dispose(),q.dispose(),de.reject(we)}})}class _{constructor(q){this.a=new K,this.b=new F(me=>{if(re){me.reject(re);return}return de&&me.emitMany(de),this.d=we=>me.reject(we),this.f=we=>me.emitOne(we),this.a.p},q);let re,de;this.f=me=>{de||(de=[]),de.push(me)},this.d=me=>{re||(re=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(q){this.d(q),this.a.complete()}emitOne(q){this.f(q)}}e.$6h=_}),define(le[111],he([0,1,21,8,39,32,31,9,3,25]),function(G,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$sk=m,e.$vk=g,e.$wk=W,e.$xk=V,e.$yk=H,e.$zk=Y,e.$Ak=Z,e.$Bk=J;function m(){return Object.create(null)}e.$tk="**",e.$uk="/";const h="[/\\\\]",d="[^/\\\\]",w=/\//g;function f(B,j){switch(B){case 0:return"";case 1:return`${d}*?`;default:return`(?:${h}|${d}+${h}${j?`|${h}${d}+`:""})*?`}}function g(B,j){if(!B)return[];const C=[];let X=!1,ae=!1,K="";for(const ce of B){switch(ce){case j:if(!X&&!ae){C.push(K),K="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}K+=ce}return K&&C.push(K),C}function v(B){if(!B)return"";let j="";const C=g(B,e.$uk);if(C.every(X=>X===e.$tk))j=".*";else{let X=!1;C.forEach((ae,K)=>{if(ae===e.$tk){if(X)return;j+=f(2,K===C.length-1)}else{let ce=!1,se="",ie=!1,M="";for(const F of ae){if(F!=="}"&&ce){se+=F;continue}if(ie&&(F!=="]"||!M)){let N;F==="-"?N=F:(F==="^"||F==="!")&&!M?N="^":F===e.$uk?N="":N=(0,c.$ff)(F),M+=N;continue}switch(F){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const z=`(?:${g(se,",").map(_=>v(_)).join("|")})`;j+=z,ce=!1,se="";break}case"]":{j+="["+M+"]",ie=!1,M="";break}case"?":j+=d;continue;case"*":j+=f(1);continue;default:j+=(0,c.$ff)(F)}}K<C.length-1&&(C[K+1]!==e.$tk||K+2<C.length)&&(j+=h)}X=ae===e.$tk})}return j}const b=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Cc(1e4),o=function(){return!1},s=function(){return null};function a(B,j){if(!B)return s;let C;typeof B!="string"?C=B.pattern:C=B,C=C.trim();const X=`${C}_${!!j.trimForExclusions}`;let ae=i.get(X);if(ae)return l(ae,B);let K;return b.test(C)?ae=y(C.substr(4),C):(K=$.exec(S(C,j)))?ae=D(K[1],C):(j.trimForExclusions?E:P).test(C)?ae=L(C,j):(K=t.exec(S(C,j)))?ae=A(K[1].substr(1),C,!0):(K=u.exec(S(C,j)))?ae=A(K[1],C,!1):ae=O(C),i.set(X,ae),l(ae,B)}function l(B,j){if(typeof j=="string")return B;const C=function(X,ae){return(0,R.$Bg)(X,j.base,!p.$l)?B((0,c.$kf)(X.substr(j.base.length),I.sep),ae):null};return C.allBasenames=B.allBasenames,C.allPaths=B.allPaths,C.basenames=B.basenames,C.patterns=B.patterns,C}function S(B,j){return j.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function y(B,j){return function(C,X){return typeof C=="string"&&C.endsWith(B)?j:null}}function D(B,j){const C=`/${B}`,X=`\\${B}`,ae=function(ce,se){return typeof ce!="string"?null:se?se===B?j:null:ce===B||ce.endsWith(C)||ce.endsWith(X)?j:null},K=[B];return ae.basenames=K,ae.patterns=[j],ae.allBasenames=K,ae}function L(B,j){const C=x(B.slice(1,-1).split(",").map(se=>a(se,j)).filter(se=>se!==s),B),X=C.length;if(!X)return s;if(X===1)return C[0];const ae=function(se,ie){for(let M=0,F=C.length;M<F;M++)if(C[M](se,ie))return B;return null},K=C.find(se=>!!se.allBasenames);K&&(ae.allBasenames=K.allBasenames);const ce=C.reduce((se,ie)=>ie.allPaths?se.concat(ie.allPaths):se,[]);return ce.length&&(ae.allPaths=ce),ae}function A(B,j,C){const X=I.sep===I.$fc.sep,ae=X?B:B.replace(w,I.sep),K=I.sep+ae,ce=I.$fc.sep+B;let se;return C?se=function(ie,M){return typeof ie=="string"&&(ie===ae||ie.endsWith(K)||!X&&(ie===B||ie.endsWith(ce)))?j:null}:se=function(ie,M){return typeof ie=="string"&&(ie===ae||!X&&ie===B)?j:null},se.allPaths=[(C?"*/":"./")+B],se}function O(B){try{const j=new RegExp(`^${v(B)}$`);return function(C){return j.lastIndex=0,typeof C=="string"&&j.test(C)?B:null}}catch{return s}}function W(B,j,C){return!B||typeof j!="string"?!1:V(B)(j,void 0,C)}function V(B,j={}){if(!B)return o;if(typeof B=="string"||H(B)){const C=a(B,j);if(C===s)return o;const X=function(ae,K){return!!C(ae,K)};return C.allBasenames&&(X.allBasenames=C.allBasenames),C.allPaths&&(X.allPaths=C.allPaths),X}return U(B,j)}function H(B){const j=B;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function Y(B){return B.allBasenames||[]}function Z(B){return B.allPaths||[]}function U(B,j){const C=x(Object.getOwnPropertyNames(B).map(se=>te(se,B[se],j)).filter(se=>se!==s)),X=C.length;if(!X)return s;if(!C.some(se=>!!se.requiresSiblings)){if(X===1)return C[0];const se=function(F,N){let z;for(let _=0,Q=C.length;_<Q;_++){const q=C[_](F,N);if(typeof q=="string")return q;(0,r.$oh)(q)&&(z||(z=[]),z.push(q))}return z?(async()=>{for(const _ of z){const Q=await _;if(typeof Q=="string")return Q}return null})():null},ie=C.find(F=>!!F.allBasenames);ie&&(se.allBasenames=ie.allBasenames);const M=C.reduce((F,N)=>N.allPaths?F.concat(N.allPaths):F,[]);return M.length&&(se.allPaths=M),se}const ae=function(se,ie,M){let F,N;for(let z=0,_=C.length;z<_;z++){const Q=C[z];Q.requiresSiblings&&M&&(ie||(ie=(0,I.$mc)(se)),F||(F=ie.substr(0,ie.length-(0,I.$nc)(se).length)));const q=Q(se,ie,F,M);if(typeof q=="string")return q;(0,r.$oh)(q)&&(N||(N=[]),N.push(q))}return N?(async()=>{for(const z of N){const _=await z;if(typeof _=="string")return _}return null})():null},K=C.find(se=>!!se.allBasenames);K&&(ae.allBasenames=K.allBasenames);const ce=C.reduce((se,ie)=>ie.allPaths?se.concat(ie.allPaths):se,[]);return ce.length&&(ae.allPaths=ce),ae}function te(B,j,C){if(j===!1)return s;const X=a(B,C);if(X===s)return s;if(typeof j=="boolean")return X;if(j){const ae=j.when;if(typeof ae=="string"){const K=(ce,se,ie,M)=>{if(!M||!X(ce,se))return null;const F=ae.replace("$(basename)",()=>ie),N=M(F);return(0,r.$oh)(N)?N.then(z=>z?B:null):N?B:null};return K.requiresSiblings=!0,K}}return X}function x(B,j){const C=B.filter(se=>!!se.basenames);if(C.length<2)return B;const X=C.reduce((se,ie)=>{const M=ie.basenames;return M?se.concat(M):se},[]);let ae;if(j){ae=[];for(let se=0,ie=X.length;se<ie;se++)ae.push(j)}else ae=C.reduce((se,ie)=>{const M=ie.patterns;return M?se.concat(M):se},[]);const K=function(se,ie){if(typeof se!="string")return null;if(!ie){let F;for(F=se.length;F>0;F--){const N=se.charCodeAt(F-1);if(N===k.CharCode.Slash||N===k.CharCode.Backslash)break}ie=se.substr(F)}const M=X.indexOf(ie);return M!==-1?ae[M]:null};K.basenames=X,K.patterns=ae,K.allBasenames=X;const ce=B.filter(se=>!se.basenames);return ce.push(K),ce}function J(B,j){return(0,n.$tb)(B,j,(C,X)=>typeof C=="string"&&typeof X=="string"?C===X:typeof C!="string"&&typeof X!="string"?C.base===X.base&&C.pattern===X.pattern:!1)}}),define(le[47],he([0,1,21,32,9,3,18,25]),function(G,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=p,e.$Xw=m,e.$Yw=d,e.$Zw=w,e.$1w=b,e.$2w=P,e.$3w=E,e.$4w=t,e.$5w=u,e.$6w=i;function p(s,a){const{os:l,tildify:S,relative:y}=a;if(y){const A=c(s,y,l);if(typeof A=="string")return A}let D=s.fsPath;if(l===R.OperatingSystem.Windows&&!R.$j?D=D.replace(/\//g,"\\"):l!==R.OperatingSystem.Windows&&R.$j&&(D=D.replace(/\\/g,"/")),l!==R.OperatingSystem.Windows&&S?.userHome){const A=S.userHome.fsPath;let O;s.scheme!==S.userHome.scheme&&s.path[0]===k.$fc.sep&&s.path[1]!==k.$fc.sep?O=S.userHome.with({path:s.path}).fsPath:O=D,D=d(O,A,l)}return(l===R.OperatingSystem.Windows?k.$ec:k.$fc).normalize(m(D,l===R.OperatingSystem.Windows))}function c(s,a,l){const S=l===R.OperatingSystem.Windows?k.$ec:k.$fc,y=l===R.OperatingSystem.Linux?T.$6g:T.$8g,D=a.getWorkspace(),L=(0,n.$Nb)(D.folders);if(!L)return;s.scheme!==L.uri.scheme&&s.path[0]===k.$fc.sep&&s.path[1]!==k.$fc.sep&&(s=L.uri.with({path:s.path}));const A=a.getWorkspaceFolder(s);if(!A)return;let O;if(y.isEqual(A.uri,s)?O="":O=y.relativePath(A.uri,s)??"",O&&(O=S.normalize(O)),D.folders.length>1&&!a.noPrefix){const W=A.name?A.name:y.basenameOrAuthority(A.uri);O=O?`${W} \u2022 ${O}`:W}return O}function m(s,a=R.$j){return(0,r.$Gg)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}let h=Object.create(null);function d(s,a,l=R.OS){if(l===R.OperatingSystem.Windows||!s||!a)return s;let S=h.original===a?h.normalized:void 0;S||(S=a,R.$j&&(S=(0,r.$vg)(S)),S=`${(0,I.$lf)(S,k.$fc.sep)}${k.$fc.sep}`,h={original:a,normalized:S});let y=s;return R.$j&&(y=(0,r.$vg)(y)),(l===R.OperatingSystem.Linux?y.startsWith(S):(0,I.$Ef)(y,S))?`~/${y.substr(S.length)}`:s}function w(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}const f="\u2026",g="\\\\",v="~";function b(s,a=k.sep){const l=new Array(s.length);let S=!1;for(let y=0;y<s.length;y++){const D=s[y];if(D===""){l[y]=`.${a}`;continue}if(!D){l[y]=D;continue}S=!0;let L="",A=D;A.indexOf(g)===0?(L=A.substr(0,A.indexOf(g)+g.length),A=A.substr(A.indexOf(g)+g.length)):A.indexOf(a)===0?(L=A.substr(0,A.indexOf(a)+a.length),A=A.substr(A.indexOf(a)+a.length)):A.indexOf(v)===0&&(L=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length));const O=A.split(a);for(let W=1;S&&W<=O.length;W++)for(let V=O.length-W;S&&V>=0;V--){S=!1;let H=O.slice(V,V+W).join(a);for(let Y=0;!S&&Y<s.length;Y++)if(Y!==y&&s[Y]&&s[Y].indexOf(H)>-1){const Z=V+W===O.length,U=V>0&&s[Y].indexOf(a)>-1?a+H:H,te=s[Y].endsWith(U);S=!Z||te}if(!S){let Y="";(O[0].endsWith(":")||L!=="")&&(V===1&&(V=0,W++,H=O[0]+a+H),V>0&&(Y=O[0]+a),Y=L+Y),V>0&&(Y=Y+f+a),Y=Y+H,V+W<O.length&&(Y=Y+a+f),l[y]=Y}}S&&(l[y]=D)}return l}var $;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})($||($={}));function P(s,a=Object.create(null)){const l=[];let S=!1,y="";for(const D of s)if(D==="$"||S&&D==="{")y&&l.push({value:y,type:$.TEXT}),y="",S=!0;else if(D==="}"&&S){const L=a[y];if(typeof L=="string")L.length&&l.push({value:L,type:$.VARIABLE});else if(L){const A=l[l.length-1];(!A||A.type!==$.SEPARATOR)&&l.push({value:L.label,type:$.SEPARATOR})}y="",S=!1}else y+=D;return y&&!S&&l.push({value:y,type:$.TEXT}),l.filter((D,L)=>{if(D.type===$.SEPARATOR){const A=l[L-1],O=l[L+1];return[A,O].every(W=>W&&(W.type===$.VARIABLE||W.type===$.TEXT)&&W.value.length>0)}return!0}).map(D=>D.value).join("")}function E(s,a){return R.$k||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function t(s,a){return R.$k||a?s.replace(/\(&&\w\)|&&/g,""):R.$j?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}function u(s){return s.replace(/&/g,"&&")}function i(s){if(s.endsWith("]")){const a=s.lastIndexOf(" [",s.length-2);if(a!==-1){const l=o(s.substring(0,a)),S=s.substring(a);return{name:l.name+S,parentPath:l.parentPath}}}return o(s)}function o(s){const a=s.indexOf("/")!==-1?k.$fc:k.$ec,l=a.basename(s),S=a.dirname(s);return l.length?{name:l,parentPath:S}:{name:S,parentPath:""}}}),define(le[151],he([0,1,17,90,7]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=p,e.$Mn=m,e.$Nn=h;function R(d){return d.toJSON()}class T{constructor(w){this.a=w}transformIncoming(w){const f=this.a.transformIncoming(w);return f===w?w:R(k.URI.from(f))}transformOutgoing(w){const f=this.a.transformOutgoing(w);return f===w?w:R(k.URI.from(f))}transformOutgoingURI(w){const f=this.a.transformOutgoing(w);return f===w?w:k.URI.from(f)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Jn=T,e.$Kn=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function I(d,w,f){if(!d||f>200)return null;if(typeof d=="object"){if(d instanceof k.URI)return w.transformOutgoing(d);for(const g in d)if(Object.hasOwnProperty.call(d,g)){const v=I(d[g],w,f+1);v!==null&&(d[g]=v)}}return null}function p(d,w){const f=I(d,w,0);return f===null?d:f}function c(d,w,f,g){if(!d||g>200)return null;if(typeof d=="object"){if(d.$mid===r.MarshalledId.Uri)return f?k.URI.revive(w.transformIncoming(d)):w.transformIncoming(d);if(d instanceof n.$Le)return null;for(const v in d)if(Object.hasOwnProperty.call(d,v)){const b=c(d[v],w,f,g+1);b!==null&&(d[v]=b)}}return null}function m(d,w){const f=c(d,w,!1,0);return f===null?d:f}function h(d,w){const f=c(d,w,!0,0);return f===null?d:f}}),define(le[33],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(k){return n.test(k)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(I){for(let p=0;p<I.length;p++)I[p]=Math.floor(Math.random()*256);return I};const R=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,c="";return c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c+="-",c+=T[R[p++]],c+=T[R[p++]],c+="-",c+=T[R[p++]],c+=T[R[p++]],c+="-",c+=T[R[p++]],c+=T[R[p++]],c+="-",c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c}}()}),define(le[152],he([0,1,91,26,89]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zX=R,n=Ie(n),r=Ie(r);async function R(T,I){if(await new Promise((m,h)=>{const d=r.createReadStream(T),w=n.createHash("sha256");d.pipe(w);const f=(0,k.$cb)((g,v)=>{d.removeAllListeners(),w.removeAllListeners(),g?h(g):m(v)});d.once("error",f),d.once("end",f),w.once("error",f),w.once("data",g=>f(void 0,g.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(le[153],he([0,1,27]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=R;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const I=T.replace(/\-/g,":").toLowerCase();return!r.has(I)}function R(){const T=(0,n.networkInterfaces)();for(const I in T){const p=T[I];if(p){for(const{mac:c}of p)if(k(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[92],he([0,1,27,60,33,153,3]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Qn=p,e.$Rn=h,e.$Sn=d,k=Ie(k),e.$Pn=new class{c(w){return this.a||(this.a=r.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,f=0;const g=(0,n.networkInterfaces)();for(const v in g){const b=g[v];if(b)for(const{mac:$,internal:P}of b)P||(f+=1,this.c($.toUpperCase())&&(w+=1))}this.b=f>0?w/f:0}return this.b}};let I;async function p(w){return I||(I=(async()=>await c(w)||k.$Yg())()),I}async function c(w){try{const f=await new Promise((v,b)=>{G(["crypto"],v,b)}).then(Ie),g=(0,R.$On)();return f.createHash("sha256").update(g,"utf8").digest("hex")}catch(f){w(f);return}}const m="Software\\Microsoft\\SQMClient";async function h(w){if(T.$j){const f=await new Promise((g,v)=>{G(["@vscode/windows-registry"],g,v)}).then(Ie);try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",m,"MachineId")||""}catch(g){return w(g),""}}return""}async function d(w){try{return await(await new Promise((v,b)=>{G(["@vscode/deviceid"],v,b)}).then(Ie)).getDeviceId()}catch(f){return w(f),""}}}),define(le[23],he([0,1,26,27,154,8,32,78,9,3,18,7]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=P,e.whenDeleted=u,e.configureFlushOnWrite=l,e.writeFileSync=y,n=Ie(n);var d;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function w(U,te=d.UNLINK,x){if((0,T.$Fg)(U))throw new Error("rimraf - will refuse to recursively delete root");return te===d.UNLINK?g(U):f(U,x)}async function f(U,te=(0,T.$Kg)((0,r.tmpdir)())){try{try{await n.promises.rename(U,te)}catch(x){return x.code==="ENOENT"?void 0:g(U)}g(te).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function g(U){return n.promises.rm(U,{recursive:!0,force:!0,maxRetries:3})}function v(U){if((0,T.$Fg)(U))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}async function b(U,te){return E(await(te?$(U):n.promises.readdir(U)))}async function $(U){try{return await n.promises.readdir(U,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const te=[],x=await b(U);for(const J of x){let B=!1,j=!1,C=!1;try{const X=await n.promises.lstat((0,p.$ic)(U,J));B=X.isFile(),j=X.isDirectory(),C=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}te.push({name:J,isFile:()=>B,isDirectory:()=>j,isSymbolicLink:()=>C})}return te}function P(U){return E(n.readdirSync(U))}function E(U){return U.map(te=>typeof te=="string"?c.$k?(0,I.$km)(te):te:(te.name=c.$k?(0,I.$km)(te.name):te.name,te))}async function t(U){const te=await b(U),x=[];for(const J of te)await i.existsDirectory((0,p.$ic)(U,J))&&x.push(J);return x}function u(U,te=1e3){return new Promise(x=>{let J=!1;const B=setInterval(()=>{J||(J=!0,n.access(U,j=>{J=!1,j&&(clearInterval(B),x(void 0))}))},te)})}var i;(function(U){async function te(B){let j;try{if(j=await n.promises.lstat(B),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await n.promises.stat(B),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(C){if(C.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(c.$j&&C.code==="EACCES")try{return{stat:await n.promises.stat(await n.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw X}throw C}}U.stat=te;async function x(B){try{const{stat:j,symbolicLink:C}=await U.stat(B);return j.isFile()&&C?.dangling!==!0}catch{}return!1}U.existsFile=x;async function J(B){try{const{stat:j,symbolicLink:C}=await U.stat(B);return j.isDirectory()&&C?.dangling!==!0}catch{}return!1}U.existsDirectory=J})(i||(e.SymlinkSupport=i={}));const o=new R.$Lh;function s(U,te,x){return o.queueFor(h.URI.file(U),()=>{const J=D(x);return new Promise((B,j)=>S(U,te,J,C=>C?j(C):B()))},m.$7g)}let a=!0;function l(U){a=U}function S(U,te,x,J){if(!a)return n.writeFile(U,te,{mode:x.mode,flag:x.flag},J);n.open(U,x.flag,x.mode,(B,j)=>{if(B)return J(B);n.writeFile(j,te,C=>{if(C)return n.close(j,()=>J(C));n.fdatasync(j,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),l(!1)),n.close(j,ae=>J(ae))))})})}function y(U,te,x){const J=D(x);if(!a)return n.writeFileSync(U,te,{mode:J.mode,flag:J.flag});const B=n.openSync(U,J.flag,J.mode);try{n.writeFileSync(B,te);try{n.fdatasyncSync(B)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),l(!1)}}finally{n.closeSync(B)}}function D(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function L(U,te,x=6e4){if(U!==te)try{c.$j&&typeof x=="number"?await A(U,te,Date.now(),x):await n.promises.rename(U,te)}catch(J){if(U.toLowerCase()!==te.toLowerCase()&&J.code==="EXDEV"||U.endsWith("."))await O(U,te,{preserveSymlinks:!1}),await w(U,d.MOVE);else throw J}}async function A(U,te,x,J,B=0){try{return await n.promises.rename(U,te)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-x>=J)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${j}`),j;if(B===0){let C=!1;try{const{stat:X}=await i.stat(te);X.isFile()||(C=!0)}catch{}if(C)throw j}return await(0,R.$Dh)(Math.min(100,B*10)),A(U,te,x,J,B+1)}}async function O(U,te,x){return V(U,te,{root:{source:U,target:te},options:x,handledSourcePaths:new Set})}const W=511;async function V(U,te,x){if(x.handledSourcePaths.has(U))return;x.handledSourcePaths.add(U);const{stat:J,symbolicLink:B}=await i.stat(U);if(B){if(x.options.preserveSymlinks)try{return await Z(U,te,x)}catch{}if(B.dangling)return}return J.isDirectory()?H(U,te,J.mode&W,x):Y(U,te,J.mode&W)}async function H(U,te,x,J){await n.promises.mkdir(te,{recursive:!0,mode:x});const B=await b(U);for(const j of B)await V((0,p.$ic)(U,j),(0,p.$ic)(te,j),J)}async function Y(U,te,x){await n.promises.copyFile(U,te),await n.promises.chmod(te,x)}async function Z(U,te,x){let J=await n.promises.readlink(U);(0,T.$Bg)(J,x.root.source,!c.$l)&&(J=(0,p.$ic)(x.root.target,J.substr(x.root.source.length+1))),await n.promises.symlink(J,te)}e.Promises=new class{get read(){return(U,te,x,J,B)=>new Promise((j,C)=>{n.read(U,te,x,J,B,(X,ae,K)=>X?C(X):j({bytesRead:ae,buffer:K}))})}get write(){return(U,te,x,J,B)=>new Promise((j,C)=>{n.write(U,te,x,J,B,(X,ae,K)=>X?C(X):j({bytesWritten:ae,buffer:K}))})}get fdatasync(){return(0,k.promisify)(n.fdatasync)}get open(){return(0,k.promisify)(n.open)}get close(){return(0,k.promisify)(n.close)}get realpath(){return(0,k.promisify)(n.realpath)}async exists(U){try{return await n.promises.access(U),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return w}get rename(){return L}get copy(){return O}}}),define(le[112],he([0,1,26,9,3,25,23]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=I,e.$jr=p,e.$kr=c,e.$lr=m,n=Ie(n);function I(d){if(k.$l)return d;const w=(0,r.$lc)(d);if(d===w)return d;const f=((0,r.$mc)(d)||d).toLowerCase();try{const v=(0,T.readdirSync)(w).filter(b=>b.toLowerCase()===f);if(v.length===1){const b=I(w);if(b)return(0,r.$ic)(b,v[0])}else if(v.length>1){const b=v.indexOf(f);if(b>=0){const $=I(w);if($)return(0,r.$ic)($,v[b])}}}catch{}return null}async function p(d,w){if(k.$l)return d;const f=(0,r.$lc)(d);if(d===f)return d;const g=((0,r.$mc)(d)||d).toLowerCase();try{if(w?.isCancellationRequested)return null;const b=(await T.Promises.readdir(f)).filter($=>$.toLowerCase()===g);if(b.length===1){const $=await p(f,w);if($)return(0,r.$ic)($,b[0])}else if(b.length>1){const $=b.indexOf(g);if($>=0){const P=await p(f,w);if(P)return(0,r.$ic)(P,b[$])}}}catch{}return null}async function c(d){try{return await T.Promises.realpath(d)}catch{const f=h(d);return await n.promises.access(f,n.constants.R_OK),f}}function m(d){try{return n.realpathSync(d)}catch{const f=h(d);return n.accessSync(f,n.constants.R_OK),f}}function h(d){return(0,R.$lf)((0,r.$gc)(d),r.sep)}}),define(le[113],he([0,1,93]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=r,e.$3g=R,n=Ie(n);function r(I,p,c,m=1){let h=!1;return new Promise(d=>{const w=setTimeout(()=>{if(!h)return h=!0,d(0)},c);k(I,p,m,f=>{if(!h)return h=!0,clearTimeout(w),d(f)})})}function k(I,p,c,m){if(p===0)return m(0);const h=new n.Socket;h.once("connect",()=>(T(h),k(I+c,p-1,c,m))),h.once("data",()=>{}),h.once("error",d=>(T(h),d.code!=="ECONNREFUSED"?k(I+c,p-1,c,m):m(I))),h.connect(I,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(I,p,c,m="127.0.0.1"){let h=!1,d,w=1;const f=n.createServer({pauseOnConnect:!0});function g(v,b){h||(h=!0,f.removeAllListeners(),f.close(),d&&clearTimeout(d),b(v))}return new Promise(v=>{d=setTimeout(()=>{g(0,v)},c),f.on("listening",()=>{g(I,v)}),f.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&w<p?(I++,w++,f.listen(I,m)):g(0,v)}),f.on("close",()=>{g(0,v)}),f.listen(I,m)})}function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(p){console.error(p)}}}),define(le[114],he([0,1,27,9,23]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=$,e.$um=P,n=Ie(n),r=Ie(r),k=Ie(k);const R=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var p;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(p||(p={}));let c;switch(process.arch){case"ia32":c=p.x86;break;case"arm":case"arm64":c=p.ARM;break;default:c=p.x64;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=p.x86:m=p.x64;class h{constructor(t,u,i){this.exePath=t,this.displayName=u,this.a=i}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:E=!1}={}){return E?c===p.x64?process.env["ProgramFiles(x86)"]||null:m===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:E=!1,findPreview:t=!1}={}){const u=d({useAlternateBitness:E});if(!u)return null;const i=r.$ic(u,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(i))return null;let o=-1,s=null;for(const S of await k.Promises.readdir(i)){let y=-1;if(t){const L=S.indexOf("-");if(L<0)continue;const A=S.substring(0,L);if(!R.test(A)||S.substring(L+1)!=="preview")continue;y=parseInt(A,10)}else{if(!R.test(S))continue;y=parseInt(S,10)}if(y<=o)continue;const D=r.$ic(i,S,"pwsh.exe");await k.SymlinkSupport.existsFile(D)&&(s=D,o=y)}if(!s)return null;const a=u.includes("x86")?" (x86)":"",l=t?" Preview":"";return new h(s,`PowerShell${l}${a}`,!0)}async function f({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const t=r.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:u,pwshMsixName:i}=E?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const o of await k.Promises.readdir(t))if(u.test(o)){const s=r.$ic(t,o,"pwsh.exe");return new h(s,i)}return null}function g(){const E=r.$ic(n.homedir(),".dotnet","tools","pwsh.exe");return new h(E,".NET Core PowerShell Global Tool")}function v(){const E=r.$ic(process.env.windir,c===p.x86&&m!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(E,"Windows PowerShell",!0)}async function*b(){let E=await w();E&&(yield E),E=await w({useAlternateBitness:!0}),E&&(yield E),E=await f(),E&&(yield E),E=g(),E&&(yield E),E=await w({findPreview:!0}),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await w({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=v(),E&&(yield E)}async function*$(){for await(const E of b())await E.exists()&&(yield E)}async function P(){for await(const E of $())return E;return null}}),define(le[94],he([0,1,26,9,3,36,79,12,23]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$vm=c,e.$wm=m,r=Ie(r),k=Ie(k),R=Ie(R),I=Ie(I),p=Ie(p),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function c(d=R.env){return d.comspec||"cmd.exe"}function m(d){let w=[],f=!1;const g=function(v){if(f){w.push(v);return}(!d.send(v,$=>{if($&&console.error($),f=!1,w.length>0){const P=w.slice(0);w=[],P.forEach(E=>g(E))}})||k.$j)&&(f=!0)};return{send:g}}var h;(function(d){async function w(f,g,v){if(r.$hc(f))return f;if(g===void 0&&(g=R.cwd()),r.$lc(f)!=="."||(v===void 0&&I.$cg(R.env.PATH)&&(v=R.env.PATH.split(r.$sc)),v===void 0||v.length===0))return r.$ic(g,f);async function $(P){if(await p.Promises.exists(P)){let E;try{E=await n.promises.stat(P)}catch(t){t.message.startsWith("EACCES")&&(E=await n.promises.lstat(P))}return E?!E.isDirectory():!1}return!1}for(const P of v){let E;if(r.$hc(P)?E=r.$ic(P,f):E=r.$ic(g,P,f),await $(E))return E;let t=E+".com";if(await $(t)||(t=E+".exe",await $(t)))return t}return r.$ic(g,f)}d.findExecutable=w})(h||(e.win32=h={}))}),define(le[115],he([0,1,48,11]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=k;function k(T){return new Promise((I,p)=>{let c;const m=new Map;function h(w,f,g,v,b){const $=m.get(f);if(w===T||$){const P={name:d(g),cmd:g,pid:w,ppid:f,load:v,mem:b};m.set(w,P),w===T&&(c=P),$&&($.children||($.children=[]),$.children.push(P),$.children.length>1&&($.children=$.children.sort((E,t)=>E.pid-t.pid)))}}function d(w){const f=/--utility-sub-type=network/i,g=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(g.exec(w))return"electron-crash-reporter";if(v.exec(w))return"winpty-agent";if(b.exec(w))return"conpty-agent";let P=$.exec(w);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?f.exec(w)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const E=/[a-zA-Z-]+\.js/g;let t="";do P=E.exec(w),P&&(t+=P+" ");while(P);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${t})`:w}if(process.platform==="win32"){const w=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,g)=>{G(["@vscode/windows-process-tree"],f,g)}).then(Ie).then(f=>{f.getProcessList(T,g=>{if(!g){p(new Error(`Root process ${T} not found`));return}f.getProcessCpuUsage(g,v=>{const b=new Map;v.forEach($=>{const P=w($.commandLine||"");b.set($.pid,{name:d(P),cmd:P,pid:$.pid,ppid:$.ppid,load:$.cpu||0,mem:$.memory||0})}),c=b.get(T),c?(b.forEach($=>{const P=b.get($.ppid);P&&(P.children||(P.children=[]),P.children.push($))}),b.forEach($=>{$.children&&($.children=$.children.sort((P,E)=>P.pid-E.pid))}),I(c)):p(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let w=function(){let f=[c];const g=[];for(;f.length;){const b=f.shift();b&&(g.push(b.pid),b.children&&(f=f.concat(b.children)))}let v=JSON.stringify(r.$Wg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+g.join(" "),(0,n.exec)(v,{},(b,$,P)=>{if(b||P)p(b||new Error(P.toString()));else{const E=$.toString().split(`
`);for(let t=0;t<g.length;t++){const u=m.get(g[t]);u.load=parseFloat(E[t])}if(!c){p(new Error(`Root process ${T} not found`));return}I(c)}})};(0,n.exec)("which ps",{},(f,g,v)=>{if(f||v)if(process.platform!=="linux")p(f||new Error(v.toString()));else{const b=JSON.stringify(r.$Wg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(b,{},($,P,E)=>{$||E?p($||new Error(E.toString())):(R(P,h),w())})}else{const b=g.toString().trim();(0,n.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,E,t)=>{P||t&&!t.includes("screen size is bogus")?p(P||new Error(t.toString())):(R(E,h),process.platform==="linux"?w():c?I(c):p(new Error(`Root process ${T} not found`)))})}})}})}function R(T,I){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=T.toString().split(`
`);for(const m of c){const h=p.exec(m.trim());h&&h.length===6&&I(parseInt(h[1]),parseInt(h[2]),h[5],parseFloat(h[3]),parseFloat(h[4]))}}}),define(le[116],he([0,1,27,3,114,94]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=T,r=Ie(r),R=Ie(R);async function T(h,d){return h===r.OperatingSystem.Windows?r.$j?m():R.$vm(d):p(h,d)}let I=null;function p(h,d){if(r.$l&&h===r.OperatingSystem.Macintosh||r.$k&&h===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(r.$j)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let c=null;async function m(){return c||(c=(await(0,k.$um)()).exePath),c}}),function(){function G(){function e(){return process.uncHostAllowlist}function n(p){const c=new Set;if(Array.isArray(p))for(const m of p)typeof m=="string"&&c.add(m);return Array.from(c)}function r(){const p=e();return p?Array.from(p):[]}function k(p){if(process.platform!=="win32")return;const c=e();if(c)if(typeof p=="string")c.add(p.toLowerCase());else for(const m of n(p))k(m)}function R(p){if(typeof p!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const h of c){if(p.indexOf(h)!==0)continue;const w=p.indexOf("\\",h.length);if(w===-1)continue;const f=p.substring(h.length,w);if(f){m=f;break}}return m}function T(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:k,getUNCHost:R,disableUNCAccessRestrictions:T,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return G()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=G():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[155],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FX=e.$EX=void 0,e.$EX="vscode:contextmenu",e.$FX="vscode:onCloseContextMenu"});var Ee=this&&this.__decorate||function(G,e,n,r){var k=arguments.length,R=k<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(G,e,n,r);else for(var I=G.length-1;I>=0;I--)(T=G[I])&&(R=(k<3?T(R):k>3?T(e,n,R):T(e,n))||R);return k>3&&R&&Object.defineProperty(e,n,R),R};define(le[44],he([0,1,21,8,17,22,53,15,4,2,82,25,12]),function(G,e,n,r,k,R,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=l,e.$di=S,e.$ii=W,e.$ji=V,h=Ie(h);var w;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(w||(w={}));function f(B){switch(B){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var g;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(g||(g={}));function v(B){switch(B){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var b;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(b||(b={}));function $(B){let j=0;for(let C=0;;C+=7){const X=B.read(1);if(j|=(X.buffer[0]&127)<<C,!(X.buffer[0]&128))return j}}const P=o(0);function E(B,j){if(j===0){B.write(P);return}let C=0;for(let ae=j;ae!==0;ae=ae>>>7)C++;const X=k.$Le.alloc(C);for(let ae=0;j!==0;ae++)X.buffer[ae]=j&127,j=j>>>7,j>0&&(X.buffer[ae]|=128);B.write(X)}class t{constructor(j){this.b=j,this.a=0}read(j){const C=this.b.slice(this.a,this.a+j);return this.a+=C.byteLength,C}}e.$ai=t;class u{constructor(){this.a=[]}get buffer(){return k.$Le.concat(this.a)}write(j){this.a.push(j)}}e.$bi=u;var i;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(i||(i={}));function o(B){const j=k.$Le.alloc(1);return j.writeUInt8(B,0),j}const s={Undefined:o(i.Undefined),String:o(i.String),Buffer:o(i.Buffer),VSBuffer:o(i.VSBuffer),Array:o(i.Array),Object:o(i.Object),Uint:o(i.Int)},a=typeof Buffer<"u";function l(B,j){if(typeof j>"u")B.write(s.Undefined);else if(typeof j=="string"){const C=k.$Le.fromString(j);B.write(s.String),E(B,C.byteLength),B.write(C)}else if(a&&Buffer.isBuffer(j)){const C=k.$Le.wrap(j);B.write(s.Buffer),E(B,C.byteLength),B.write(C)}else if(j instanceof k.$Le)B.write(s.VSBuffer),E(B,j.byteLength),B.write(j);else if(Array.isArray(j)){B.write(s.Array),E(B,j.length);for(const C of j)l(B,C)}else if(typeof j=="number"&&(j|0)===j)B.write(s.Uint),E(B,j);else{const C=k.$Le.fromString(JSON.stringify(j));B.write(s.Object),E(B,C.byteLength),B.write(C)}}function S(B){switch(B.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return B.read($(B)).toString();case i.Buffer:return B.read($(B)).buffer;case i.VSBuffer:return B.read($(B));case i.Array:{const C=$(B),X=[];for(let ae=0;ae<C;ae++)X.push(S(B));return X}case i.Object:return JSON.parse(B.read($(B)).toString());case i.Int:return $(B)}}class y{constructor(j,C,X=null,ae=1e3){this.h=j,this.j=C,this.k=X,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:g.Initialize})}registerChannel(j,C){this.b.set(j,C),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case g.Initialize:{const C=this.o([j.type]);this.k?.logOutgoing(C,0,D.OtherSide,v(j.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const C=this.o([j.type,j.id],j.data);this.k?.logOutgoing(C,j.id,D.OtherSide,v(j.type),j.data);return}}}o(j,C=void 0){const X=new u;return l(X,j),l(X,C),this.p(X.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const C=new t(j),X=S(C),ae=S(C),K=X[0];switch(K){case w.Promise:return this.k?.logIncoming(j.byteLength,X[1],D.OtherSide,`${f(K)}: ${X[2]}.${X[3]}`,ae),this.s({type:K,id:X[1],channelName:X[2],name:X[3],arg:ae});case w.EventListen:return this.k?.logIncoming(j.byteLength,X[1],D.OtherSide,`${f(K)}: ${X[2]}.${X[3]}`,ae),this.t({type:K,id:X[1],channelName:X[2],name:X[3],arg:ae});case w.PromiseCancel:return this.k?.logIncoming(j.byteLength,X[1],D.OtherSide,`${f(K)}`),this.u({type:K,id:X[1]});case w.EventDispose:return this.k?.logIncoming(j.byteLength,X[1],D.OtherSide,`${f(K)}`),this.u({type:K,id:X[1]})}}s(j){const C=this.b.get(j.channelName);if(!C){this.v(j);return}const X=new R.$ue;let ae;try{ae=C.call(this.j,j.name,j.arg,X.token)}catch(se){ae=Promise.reject(se)}const K=j.id;ae.then(se=>{this.m({id:K,data:se,type:g.PromiseSuccess})},se=>{se instanceof Error?this.m({id:K,data:{message:se.message,name:se.name,stack:se.stack?se.stack.split(`
`):void 0},type:g.PromiseError}):this.m({id:K,data:se,type:g.PromiseErrorObj})}).finally(()=>{ce.dispose(),this.d.delete(j.id)});const ce=(0,c.$Rc)(()=>X.cancel());this.d.set(j.id,ce)}t(j){const C=this.b.get(j.channelName);if(!C){this.v(j);return}const X=j.id,K=C.listen(this.j,j.name,j.arg)(ce=>this.m({id:X,data:ce,type:g.EventFire}));this.d.set(j.id,K)}u(j){const C=this.d.get(j.id);C&&(C.dispose(),this.d.delete(j.id))}v(j){let C=this.g.get(j.channelName);C||(C=[],this.g.set(j.channelName,C));const X=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===w.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:g.PromiseError})},this.l);C.push({request:j,timeoutTimer:X})}w(j){const C=this.g.get(j);if(C){for(const X of C)switch(clearTimeout(X.timeoutTimer),X.request.type){case w.Promise:this.s(X.request);break;case w.EventListen:this.t(X.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$ei=y;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class L{constructor(j,C=null){this.l=j,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=C}getChannel(j){const C=this;return{call(X,ae,K){return C.a?Promise.reject(new I.$4):C.m(j,X,ae,K)},listen(X,ae){return C.a?p.Event.None:C.o(j,X,ae)}}}m(j,C,X,ae=R.CancellationToken.None){const K=this.g++,ce=w.Promise,se={id:K,type:ce,channelName:j,name:C,arg:X};if(ae.isCancellationRequested)return Promise.reject(new I.$4);let ie;return new Promise((F,N)=>{if(ae.isCancellationRequested)return N(new I.$4);const z=()=>{const re=de=>{switch(de.type){case g.PromiseSuccess:this.f.delete(K),F(de.data);break;case g.PromiseError:{this.f.delete(K);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,N(me);break}case g.PromiseErrorObj:this.f.delete(K),N(de.data);break}};this.f.set(K,re),this.p(se)};let _=null;this.b===b.Idle?z():(_=(0,r.$ph)(re=>this.u()),_.then(()=>{_=null,z()}));const Q=()=>{_?(_.cancel(),_=null):this.p({id:K,type:w.PromiseCancel}),N(new I.$4)},q=ae.onCancellationRequested(Q);ie=(0,c.$Qc)((0,c.$Rc)(Q),q),this.d.add(ie)}).finally(()=>{ie.dispose(),this.d.delete(ie)})}o(j,C,X){const ae=this.g++,K=w.EventListen,ce={id:ae,type:K,channelName:j,name:C,arg:X};let se=null;const ie=new p.$je({onWillAddFirstListener:()=>{se=(0,r.$ph)(F=>this.u()),se.then(()=>{se=null,this.d.add(ie),this.p(ce)})},onDidRemoveLastListener:()=>{se?(se.cancel(),se=null):(this.d.delete(ie),this.p({id:ae,type:w.EventDispose}))}}),M=F=>ie.fire(F.data);return this.f.set(ae,M),ie.event}p(j){switch(j.type){case w.Promise:case w.EventListen:{const C=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(C,j.id,D.LocalSide,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case w.PromiseCancel:case w.EventDispose:{const C=this.q([j.type,j.id]);this.j?.logOutgoing(C,j.id,D.LocalSide,f(j.type));return}}}q(j,C=void 0){const X=new u;return l(X,j),l(X,C),this.r(X.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const C=new t(j),X=S(C),ae=S(C),K=X[0];switch(K){case g.Initialize:return this.j?.logIncoming(j.byteLength,0,D.LocalSide,v(K)),this.t({type:X[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,X[1],D.LocalSide,v(K),ae),this.t({type:X[0],id:X[1],data:ae})}}t(j){if(j.type===g.Initialize){this.b=b.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$fi=L,Ee([T.$7h],L.prototype,"onDidInitializePromise",null);class A{get connections(){const j=[];return this.f.forEach(C=>j.push(C)),j}constructor(j,C,X){this.a=new Map,this.f=new Set,this.g=new p.$je,this.onDidAddConnection=this.g.event,this.h=new p.$je,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(j(({protocol:ae,onDidClientDisconnect:K})=>{const ce=p.Event.once(ae.onMessage);this.j.add(ce(se=>{const ie=new t(se),M=S(ie),F=new y(ae,M,C,X),N=new L(ae,C);this.a.forEach((_,Q)=>F.registerChannel(Q,_));const z={channelServer:F,channelClient:N,ctx:M};this.f.add(z),this.g.fire(z),this.j.add(K(()=>{F.dispose(),N.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(j,C){const X=this;return{call(ae,K,ce){let se;if((0,d.$qg)(C)){const M=(0,n.$2b)(X.connections.filter(C));se=M?Promise.resolve(M):p.Event.toPromise(p.Event.filter(X.onDidAddConnection,C))}else se=C.routeCall(X,ae,K);const ie=se.then(M=>M.channelClient.getChannel(j));return W(ie).call(ae,K,ce)},listen(ae,K){if((0,d.$qg)(C))return X.k(j,C,ae,K);const ce=C.routeEvent(X,ae,K).then(se=>se.channelClient.getChannel(j));return W(ce).listen(ae,K)}}}k(j,C,X,ae){const K=this;let ce;const se=new p.$je({onWillAddFirstListener:()=>{ce=new c.$Sc;const ie=new p.$pe,M=new Map,F=z=>{const Q=z.channelClient.getChannel(j).listen(X,ae),q=ie.add(Q);M.set(z,q)},N=z=>{const _=M.get(z);_&&(_.dispose(),M.delete(z))};K.connections.filter(C).forEach(F),p.Event.filter(K.onDidAddConnection,C)(F,void 0,ce),K.onDidRemoveConnection(N,void 0,ce),ie.event(se.fire,se,ce),ce.add(ie)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return se.event}registerChannel(j,C){this.a.set(j,C);for(const X of this.f)X.channelServer.registerChannel(j,C)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=A;class O{constructor(j,C,X=null){const ae=new u;l(ae,C),j.send(ae.buffer),this.a=new L(j,X),this.d=new y(j,C,X)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,C){this.d.registerChannel(j,C)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=O;function W(B){return{call(j,C,X){return B.then(ae=>ae.call(j,C,X))},listen(j,C){const X=new p.$se;return B.then(ae=>X.input=ae.listen(j,C)),X.event}}}function V(B){let j=!1;return{call(C,X,ae){return j?B.call(C,X,ae):(0,r.$Dh)(0).then(()=>j=!0).then(()=>B.call(C,X,ae))},listen(C,X){if(j)return B.listen(C,X);const ae=new p.$se;return(0,r.$Dh)(0).then(()=>j=!0).then(()=>ae.input=B.listen(C,X)),ae.event}}}class H{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const C of j.connections)if(await Promise.resolve(this.a(C.ctx)))return Promise.resolve(C);return await p.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$ki=H;var Y;(function(B){function j(K,ce,se){const ie=K,M=se&&se.disableMarshalling,F=new Map;for(const N in ie)X(N)&&F.set(N,p.Event.buffer(ie[N],!0,void 0,ce));return new class{listen(N,z,_){const Q=F.get(z);if(Q)return Q;const q=ie[z];if(typeof q=="function"){if(ae(z))return q.call(ie,_);if(X(z))return F.set(z,p.Event.buffer(ie[z],!0,void 0,ce)),F.get(z)}throw new I.$ab(`Event not found: ${z}`)}call(N,z,_){const Q=ie[z];if(typeof Q=="function"){if(!M&&Array.isArray(_))for(let re=0;re<_.length;re++)_[re]=(0,m.$_h)(_[re]);let q=Q.apply(ie,_);return q instanceof Promise||(q=Promise.resolve(q)),q}throw new I.$ab(`Method not found: ${z}`)}}}B.fromService=j;function C(K,ce){const se=ce&&ce.disableMarshalling;return new Proxy({},{get(ie,M){if(typeof M=="string")return ce?.properties?.has(M)?ce.properties.get(M):ae(M)?function(F){return K.listen(M,F)}:X(M)?K.listen(M):async function(...F){let N;ce&&!(0,d.$lg)(ce.context)?N=[ce.context,...F]:N=F;const z=await K.call(M,N);return se?z:(0,m.$_h)(z)};throw new I.$ab(`Property not found: ${String(M)}`)}})}B.toService=C;function X(K){return K[0]==="o"&&K[1]==="n"&&h.$Cf(K.charCodeAt(2))}function ae(K){return/^onDynamic/.test(K)&&h.$Cf(K.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const j=B.toString();if(j!=="[object Object]")return j}return B}function te(B){return Array.isArray(B)?B.map(U):U(B)}function x(B,j,C,X,ae,K,ce){ce=te(ce);const se=Z[ae],ie=se[X%se.length];let M=[`%c[${B}]%c[${String(j).padStart(7," ")}]%c[len: ${String(C).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(K)?(M=M.concat(ce),M.push(")")):M.push(ce),console.log.apply(console,M)}class J{constructor(j,C){this.d=j,this.f=C,this.a=0,this.b=0}logOutgoing(j,C,X,ae,K){this.b+=j,x(this.d,this.b,j,C,X,ae,K)}logIncoming(j,C,X,ae,K){this.a+=j,x(this.f,this.a,j,C,X,ae,K)}}e.$li=J}),define(le[156],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MX=void 0;class n{constructor(k,R){this.a=k,this.onMessage=R}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$MX=n}),define(le[157],he([0,1,17,4,44]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KX=e.$JX=void 0;class R{constructor(p){this.a=p,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$Le.wrap(c.data):n.$Le.alloc(0)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}e.$JX=R;class T extends k.$hi{constructor(p,c){const m=new R(p);super(m,c),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$KX=T}),define(le[117],he([0,1,17,4,2,44]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let l=0;function S(D,L){if(!a.has(D)){const A=String(++l);a.set(D,A)}return a.get(D)}function y(D,L,A,O){if(!s.enableDiagnostics)return;const W=S(D,L);if(O instanceof n.$Le||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const V=n.$Le.alloc(O.byteLength);V.set(O),s.records.push({timestamp:Date.now(),id:W,label:L,type:A,buff:V})}else s.records.push({timestamp:Date.now(),id:W,label:L,type:A,data:O})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let c=null;function m(){return c||(c=n.$Le.alloc(0)),c}class h{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return m();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const L=this.a[0];return l&&(this.a.shift(),this.b-=a),L}if(this.a[0].byteLength>a){const L=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),L}const S=n.$Le.alloc(a);let y=0,D=0;for(;a>0;){const L=this.a[D];if(L.byteLength>a){const A=L.slice(0,a);S.set(A,y),y+=a,l&&(this.a[D]=L.slice(a),this.b-=a),a-=a}else S.set(L,y),y+=L.byteLength,l?(this.a.shift(),this.b-=L.byteLength):D++,a-=L.byteLength}return S}}e.$mi=h;var d;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(d||(d={}));function w(s){switch(s){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class g{constructor(a,l,S,y){this.type=a,this.id=l,this.ack=S,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends k.$Tc{constructor(a){super(),this.f=this.B(new r.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:f.HeaderLength,messageType:d.None,id:0,ack:0},this.a=a,this.b=!1,this.c=new h,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,y=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=f.HeaderLength,this.g.messageType=d.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,l),this.f.fire(new g(S,y,D,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$Le.alloc(f.HeaderLength);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:w(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,a.data),this.j(l,a.data)}g(a,l){const S=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,S}h(){const a=n.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:a.byteLength}),this.c.write(a)}}class $ extends k.$Tc{constructor(a){super(),this.f=new r.$je,this.onMessage=this.f.event,this.g=new r.$je,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new b(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(l=>{l.type===d.Regular&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new g(d.Regular,0,0,a))}}e.$ni=$;class P extends R.$hi{static fromSocket(a,l){return new P(new $(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,S=null){super(a,l,S),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$oi=P;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$pi=E;class t{constructor(a){this.data=a,this.next=null}}class u{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,S=this.a;for(;S;)a[l++]=S.data,S=S.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new t(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<i.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=i.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+i.a)*1e3;let S=0;for(let y=0;y<i.a;y++)a-this.c[y]<=l&&S++;return 1-S/i.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.d-this.f}constructor(a){this.v=new E,this.onControlMessage=this.v.event,this.w=new E,this.onMessage=this.w.event,this.x=new E,this.onDidDispose=this.x.event,this.y=new E,this.onSocketClose=this.y.event,this.z=new E,this.onSocketTimeout=this.z.event,this.t=a.loadEstimator??i.getInstance(),this.u=a.sendKeepAlive??!0,this.a=!1,this.c=new u,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new k.$Sc,this.p=a.socket,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(l=>this.A(l))),this.s.add(this.p.onClose(l=>this.y.fire(l))),a.initialChunk&&this.r.acceptChunk(a.initialChunk),this.u?this.m=setInterval(()=>{this.E()},f.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const a=new g(d.Disconnect,0,0,m());this.q.write(a),this.q.flush()}}sendPause(){const a=new g(d.Pause,0,0,m());this.q.write(a)}sendResume(){const a=new g(d.Resume,0,0,m());this.q.write(a)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.s.dispose(),this.s=new k.$Sc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=a,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(S=>this.A(S))),this.s.add(this.p.onClose(S=>this.y.fire(S))),this.r.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.j=this.h;const a=new g(d.Ack,0,this.j,m());this.q.write(a);const l=this.c.toArray();for(let S=0,y=l.length;S<y;S++)this.q.write(l[S]);this.C()}acceptDisconnect(){this.x.fire()}A(a){if(a.ack>this.f){this.f=a.ack;do{const l=this.c.peek();if(l&&l.id<=a.ack)this.c.pop();else break}while(!0)}switch(a.type){case d.None:break;case d.Regular:{if(a.id>this.h)if(a.id!==this.h+1){const l=Date.now();l-this.n>1e4&&(this.n=l,this.q.write(new g(d.ReplayRequest,0,0,m())))}else this.h=a.id,this.k=Date.now(),this.B(),this.w.fire(a.data);break}case d.Control:{this.v.fire(a.data);break}case d.Ack:break;case d.Disconnect:{this.x.fire();break}case d.ReplayRequest:{const l=this.c.toArray();for(let S=0,y=l.length;S<y;S++)this.q.write(l[S]);this.C();break}case d.Pause:{this.q.pause();break}case d.Resume:{this.q.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(a){const l=++this.d;this.j=this.h;const S=new g(d.Regular,l,this.j,a);this.c.push(S),this.a||(this.q.write(S),this.C())}sendControl(a){const l=new g(d.Control,0,0,a);this.q.write(l)}B(){if(this.h<=this.j||this.l)return;const a=Date.now()-this.k;if(a>=f.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},f.AcknowledgeTime-a+5)}C(){if(this.d<=this.f||this.g||this.a)return;const a=this.c.peek(),l=Date.now()-a.writtenTime,S=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(l>=f.TimeoutTime&&S>=f.TimeoutTime&&y>=f.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:S});return}const D=Math.max(f.TimeoutTime-l,f.TimeoutTime-S,f.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},D)}D(){if(this.h<=this.j)return;this.j=this.h;const a=new g(d.Ack,0,this.j,m());this.q.write(a)}E(){this.j=this.h;const a=new g(d.KeepAlive,0,this.j,m());this.q.write(a)}}e.$qi=o});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[35],he([0,1,13,15,11]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GX=void 0,n=Ge(n);class R{constructor(){this.a=new WeakMap}on(I,p){const c=(m,...h)=>{this.b(I,m)&&p(m,...h)};return this.a.set(p,c),n.default.ipcMain.on(I,c),this}once(I,p){return n.default.ipcMain.once(I,(c,...m)=>{this.b(I,c)&&p(c,...m)}),this}handle(I,p){return n.default.ipcMain.handle(I,(c,...m)=>this.b(I,c)?p(c,...m):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return n.default.ipcMain.removeHandler(I),this}removeListener(I,p){const c=this.a.get(p);return c&&(n.default.ipcMain.removeListener(I,c),this.a.delete(p)),this}b(I,p){if(!I||!I.startsWith("vscode:"))return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const c=p.senderFrame,m=c.url;if(!m||m==="about:blank")return!0;let h="unknown";try{h=new URL(m).host}catch{return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${m}'.`),!1}return h!==k.$Vg?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${h}'.`),!1):c.parent!==null?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${h}' is not a main frame.`),!1):!0}}e.$GX=new R}),define(le[158],he([0,1,13,35,155]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HX=R;function R(){r.$GX.on(k.$EX,(I,p,c,m,h)=>{const d=T(I,m,c);d.popup({x:h?h.x:void 0,y:h?h.y:void 0,positioningItem:h?h.positioningItem:void 0,callback:()=>{d&&I.sender.send(k.$FX,p)}})})}function T(I,p,c){const m=new n.Menu;return c.forEach(h=>{let d;h.type==="separator"?d=new n.MenuItem({type:h.type}):Array.isArray(h.submenu)?d=new n.MenuItem({submenu:T(I,p,h.submenu),label:h.label}):d=new n.MenuItem({label:h.label,type:h.type,accelerator:h.accelerator,checked:h.checked,enabled:h.enabled,visible:h.visible,click:(w,f,g)=>I.sender.send(p,h.id,g)}),m.append(d)}),m}}),define(le[159],he([0,1,35,17,4,2,44,156]),function(G,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NX=void 0;function p(m,h){const d=k.Event.fromNodeEventEmitter(n.$GX,h,(f,g)=>({event:f,message:g})),w=k.Event.filter(d,({event:f})=>f.sender.id===m);return k.Event.map(w,({message:f})=>f&&r.$Le.wrap(f))}class c extends T.$gi{static{this.b=new Map}static d(){const h=k.Event.fromNodeEventEmitter(n.$GX,"vscode:hello",({sender:d})=>d);return k.Event.map(h,d=>{const w=d.id;c.b.get(w)?.dispose();const g=new k.$je;c.b.set(w,(0,R.$Rc)(()=>g.fire()));const v=p(w,"vscode:message"),b=k.Event.any(k.Event.signal(p(w,"vscode:disconnect")),g.event);return{protocol:new I.$MX(d,v),onDidClientDisconnect:b}})}constructor(){super(c.d())}}e.$NX=c}),define(le[118],he([0,1,35,4,33,157]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OX=void 0,e.$PX=I;class T extends R.$KX{constructor(c,m){super({addEventListener:(h,d)=>c.addListener(h,d),removeEventListener:(h,d)=>c.removeListener(h,d),postMessage:h=>c.postMessage(h),start:()=>c.start(),close:()=>c.close()},m)}}e.$OX=T;async function I(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,k.$Yg)();p.webContents.send("vscode:createMessageChannel",c);const m=r.Event.fromNodeEventEmitter(n.$GX,"vscode:createMessageChannelResult",(d,w)=>({nonce:w,port:d.ports[0]})),{port:h}=await r.Event.toPromise(r.Event.once(r.Event.filter(m,d=>d.nonce===c)));return h}}),define(le[160],he([0,1,48,8,17,22,150,15,4,2,37,94,79,44]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0,I=Ie(I);class f extends w.$ei{constructor(b){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",$=>k.$Le.wrap(Buffer.from($,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$er=f;class g{constructor(b,$){this.i=b,this.j=$,this.c=new Set,this.g=new Map,this.h=new p.$je,this.onDidProcessExit=this.h.event;const P=$&&$.timeout?$.timeout:6e4;this.b=new r.$zh(P),this.d=null,this.f=null}getChannel(b){const $=this;return{call(P,E,t){return $.k(b,P,E,t)},listen(P,E){return $.l(b,P,E)}}}k(b,$,P,E=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(I.$5());this.b.cancel();const t=this.n(b),u=(0,r.$ph)(s=>t.call($,P,s)),i=E.onCancellationRequested(()=>u.cancel()),o=(0,c.$Rc)(()=>u.cancel());return this.c.add(o),u.finally(()=>{i.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),u}l(b,$,P){if(!this.b)return p.Event.None;this.b.cancel();let E;const t=new p.$je({onWillAddFirstListener:()=>{E=this.n(b).listen($,P)(t.fire,t),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,m.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,d.$jm)($.env),this.d=(0,n.fork)(this.i,b,$);const P=new p.$je,t=p.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,T.$ar)(l)){(0,T.log)(l,`IPC Library: ${this.j.serverName}`);return}P.fire(k.$Le.wrap(Buffer.from(l,"base64")))}),u=this.j.useQueue?(0,h.$wm)(this.d):this.d,i=l=>this.d&&this.d.connected&&u.send(l.buffer.toString("base64")),o=P.event,s={send:i,onMessage:o};this.f=new w.$fi(s);const a=()=>this.o();process.once("exit",a),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,S)=>{process.removeListener("exit",a),t.dispose(),this.c.forEach(y=>(0,c.$Oc)(y)),this.c.clear(),l!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:S})})}return this.f}n(b){let $=this.g.get(b);return $||($=this.m.getChannel(b),this.g.set(b,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fr=g}),define(le[119],he([0,1,8,4,2,82,12]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=p;var I;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function p(d){const w=d;return w?.changed instanceof Map||w?.deleted instanceof Set}var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class m extends k.$Tc{static{this.a=100}constructor(w,f=Object.create(null)){super(),this.r=w,this.s=f,this.b=this.B(new r.$me),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$Ah(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((f,g)=>this.w(g,f)),w.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(w,f){if(this.c===c.Closed)return;let g=!1;(0,T.$lg)(f)?g=this.f.delete(w):this.f.get(w)!==f&&(this.f.set(w,f),g=!0),g&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,f){const g=this.f.get(w);return(0,T.$lg)(g)?f:g}getBoolean(w,f){const g=this.get(w);return(0,T.$lg)(g)?f:g==="true"}getNumber(w,f){const g=this.get(w);return(0,T.$lg)(g)?f:parseInt(g,10)}getObject(w,f){const g=this.get(w);return(0,T.$lg)(g)?f:(0,R.$$h)(g)}async set(w,f,g=!1){if(this.c===c.Closed)return;if((0,T.$lg)(f))return this.delete(w,g);const v=(0,T.$eg)(f)||Array.isArray(f)?(0,R.$0h)(f):String(f);if(this.f.get(w)!==v)return this.f.set(w,v),this.j.set(w,v),this.h.delete(w),this.b.fire({key:w,external:g}),this.D()}async delete(w,f=!1){if(!(this.c===c.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:f}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===c.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$bq=m;class h{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((f,g)=>this.a.set(g,f)),w.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$cq=h}),define(le[161],he([0,1,26,8,4,31,9,23]),function(G,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_X=void 0,n=Ie(n);class p{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return k.Event.None}static{this.a=2e3}static{this.b=256}constructor(h,d=Object.create(null)){this.g=h,this.h=d,this.c=(0,T.$mc)(this.g),this.d=new c(this.h.logging),this.f=this.n(this.g)}async getItems(){const h=await this.f,d=new Map;return(await this.s(h,"SELECT * FROM ItemTable")).forEach(f=>d.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems(h){const d=await this.f;return this.j(d,h)}j(h,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,R.$xc)(d.insert):"0"}), delete(${d.delete?(0,R.$yc)(d.delete):"0"})`),this.t(h,()=>{const w=d.insert,f=d.delete;if(w&&w.size>0){const g=[];g.push([]);let v=0;w.forEach((b,$)=>{let P=g[v];P.length>p.b&&(v++,P=[],g.push(P)),P.push($,b)}),g.forEach(b=>{this.u(h,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,$=>$.run(b),()=>{const $=[];let P=0;return w.forEach((E,t)=>{$.push(t),P+=E.length}),`Keys: ${$.join(", ")} Length: ${P}`})})}if(f&&f.size){const g=[];g.push([]);let v=0;f.forEach(b=>{let $=g[v];$.length>p.b&&(v++,$=[],g.push($)),$.push(b)}),g.forEach(b=>{this.u(h,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,$=>$.run(b),()=>{const $=[];return f.forEach(P=>{$.push(P)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const h=await this.f;return this.q(h,"VACUUM")}async close(h){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,h)}k(h,d){return new Promise((w,f)=>{h.db.close(g=>(g&&this.o(h,`[storage ${this.c}] close(): ${g}`),this.g===p.IN_MEMORY_PATH?w():!h.isErroneous&&!h.isInMemory?this.l().then(w,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),w())):typeof d=="function"?n.promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const b=()=>this.k(v,void 0);return this.j(v,{insert:d()}).then(()=>b(),$=>(b(),Promise.reject($)))})).then(w,f):f(g||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const h=this.m(this.g);return I.Promises.copy(this.g,h,{preserveSymlinks:!1})}m(h){return`${h}.backup`}async checkIntegrity(h){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${h})`);const d=await this.f,w=await this.r(d,h?"PRAGMA integrity_check":"PRAGMA quick_check"),f=h?w.integrity_check:w.quick_check;return d.isErroneous?`${f} (last error: ${d.lastError})`:d.isInMemory?`${f} (in-memory!)`:f}async n(h,d=!0){this.d.trace(`[storage ${this.c}] open(${h}, retryOnBusy: ${d})`);try{return await this.p(h)}catch(w){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&d)return await(0,r.$Dh)(p.a),this.n(h,!1);try{await n.promises.unlink(h);try{await I.Promises.rename(this.m(h),h,!1)}catch{}return await this.p(h)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(p.IN_MEMORY_PATH)}}}o(h,d){h.isErroneous=!0,h.lastError=d,this.d.error(d)}p(h){return new Promise((d,w)=>{new Promise((f,g)=>{G(["@vscode/sqlite3"],f,g)}).then(Ie).then(f=>{const g=this.d.isTracing?f.verbose().Database:f.Database,v={db:new g(h,b=>b?v.db&&b.code!=="SQLITE_CANTOPEN"?v.db.close(()=>w(b)):w(b):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(v),$=>v.db.close(()=>w($)))),isInMemory:h===p.IN_MEMORY_PATH};v.db.on("error",b=>this.o(v,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&v.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},w)})}q(h,d){return new Promise((w,f)=>{h.db.exec(d,g=>g?(this.o(h,`[storage ${this.c}] exec(): ${g}`),f(g)):w())})}r(h,d){return new Promise((w,f)=>{h.db.get(d,(g,v)=>g?(this.o(h,`[storage ${this.c}] get(): ${g}`),f(g)):w(v))})}s(h,d){return new Promise((w,f)=>{h.db.all(d,(g,v)=>g?(this.o(h,`[storage ${this.c}] all(): ${g}`),f(g)):w(v))})}t(h,d){return new Promise((w,f)=>{h.db.serialize(()=>{h.db.run("BEGIN TRANSACTION"),d(),h.db.run("END TRANSACTION",g=>g?(this.o(h,`[storage ${this.c}] transaction(): ${g}`),f(g)):w())})})}u(h,d,w,f){const g=h.db.prepare(d),v=b=>{this.o(h,`[storage ${this.c}] prepare(): ${b} (${d}). Details: ${f()}`)};g.on("error",v),w(g),g.finalize(b=>{b&&v(b),g.removeListener("error",v)})}}e.$_X=p;class c{static{this.a="VSCODE_TRACE_STORAGE"}constructor(h){h&&typeof h.logTrace=="function"&&process.env[c.a]&&(this.b=h.logTrace),h&&typeof h.logError=="function"&&(this.c=h.logError)}get isTracing(){return!!this.b}trace(h){this.b?.(h)}error(h){this.c?.(h)}}}),define(le[10],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=k,e.localize2=T;const n=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function r(I,p){let c;return p.length===0?c=I:c=I.replace(/\{(\d+)\}/g,(m,h)=>{const d=h[0],w=p[d];let f=m;return typeof w=="string"?f=w:(typeof w=="number"||typeof w=="boolean"||w===void 0||w===null)&&(f=String(w)),f}),n&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function k(I,p,...c){return r(typeof I=="number"?R(I,p):p,c)}function R(I,p){const c=globalThis._VSCODE_NLS_MESSAGES?.[I];if(typeof c!="string"){if(typeof p=="string")return p;throw new Error(`!!! NLS MISSING: ${I} !!!`)}return c}function T(I,p,...c){let m;typeof I=="number"?m=R(I,p):m=p;const h=r(m,c);return{value:h,original:p===m?h:r(p,c)}}}),define(le[162],he([0,1,10]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=c,e.$Zm=m,e.$1m=h;const r=60,k=r*60,R=k*24,T=R*7,I=R*30,p=R*365;function c(d,w,f,g){typeof d!="number"&&(d=d.getTime());const v=Math.round((new Date().getTime()-d)/1e3);if(v<-30)return(0,n.localize)(12849,null,c(new Date().getTime()+v*1e3,!1));if(!g&&v<30)return(0,n.localize)(12850,null);let b;return v<r?(b=v,w?b===1?f?(0,n.localize)(12851,null,b):(0,n.localize)(12852,null,b):f?(0,n.localize)(12853,null,b):(0,n.localize)(12854,null,b):b===1?f?(0,n.localize)(12855,null,b):(0,n.localize)(12856,null,b):f?(0,n.localize)(12857,null,b):(0,n.localize)(12858,null,b)):v<k?(b=Math.floor(v/r),w?b===1?f?(0,n.localize)(12859,null,b):(0,n.localize)(12860,null,b):f?(0,n.localize)(12861,null,b):(0,n.localize)(12862,null,b):b===1?f?(0,n.localize)(12863,null,b):(0,n.localize)(12864,null,b):f?(0,n.localize)(12865,null,b):(0,n.localize)(12866,null,b)):v<R?(b=Math.floor(v/k),w?b===1?f?(0,n.localize)(12867,null,b):(0,n.localize)(12868,null,b):f?(0,n.localize)(12869,null,b):(0,n.localize)(12870,null,b):b===1?f?(0,n.localize)(12871,null,b):(0,n.localize)(12872,null,b):f?(0,n.localize)(12873,null,b):(0,n.localize)(12874,null,b)):v<T?(b=Math.floor(v/R),w?b===1?(0,n.localize)(12875,null,b):(0,n.localize)(12876,null,b):b===1?(0,n.localize)(12877,null,b):(0,n.localize)(12878,null,b)):v<I?(b=Math.floor(v/T),w?b===1?f?(0,n.localize)(12879,null,b):(0,n.localize)(12880,null,b):f?(0,n.localize)(12881,null,b):(0,n.localize)(12882,null,b):b===1?f?(0,n.localize)(12883,null,b):(0,n.localize)(12884,null,b):f?(0,n.localize)(12885,null,b):(0,n.localize)(12886,null,b)):v<p?(b=Math.floor(v/I),w?b===1?f?(0,n.localize)(12887,null,b):(0,n.localize)(12888,null,b):f?(0,n.localize)(12889,null,b):(0,n.localize)(12890,null,b):b===1?f?(0,n.localize)(12891,null,b):(0,n.localize)(12892,null,b):f?(0,n.localize)(12893,null,b):(0,n.localize)(12894,null,b)):(b=Math.floor(v/p),w?b===1?f?(0,n.localize)(12895,null,b):(0,n.localize)(12896,null,b):f?(0,n.localize)(12897,null,b):(0,n.localize)(12898,null,b):b===1?f?(0,n.localize)(12899,null,b):(0,n.localize)(12900,null,b):f?(0,n.localize)(12901,null,b):(0,n.localize)(12902,null,b))}function m(d,w){const f=Math.abs(d/1e3);return f<1?w?(0,n.localize)(12903,null,d):(0,n.localize)(12904,null,d):f<r?w?(0,n.localize)(12905,null,Math.round(d)/1e3):(0,n.localize)(12906,null,Math.round(d)/1e3):f<k?w?(0,n.localize)(12907,null,Math.round(d/(1e3*r))):(0,n.localize)(12908,null,Math.round(d/(1e3*r))):f<R?w?(0,n.localize)(12909,null,Math.round(d/(1e3*k))):(0,n.localize)(12910,null,Math.round(d/(1e3*k))):(0,n.localize)(12911,null,Math.round(d/(1e3*R)))}function h(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[54],he([0,1,21,12,10]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=p,e.$oj=c,e.$pj=m,n=Ie(n),r=Ie(r),k=Ie(k);function R(h,d){return d&&(h.stack||h.stacktrace)?k.localize(12843,null,I(h),T(h.stack)||T(h.stacktrace)):I(h)}function T(h){return Array.isArray(h)?h.join(`
`):h}function I(h){return h.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?k.localize(12844,null,h.message):h.message||k.localize(12845,null)}function p(h=null,d=!1){if(!h)return k.localize(12846,null);if(Array.isArray(h)){const w=n.$Gb(h),f=p(w[0],d);return w.length>1?k.localize(12847,null,f,w.length):f}if(r.$cg(h))return h;if(h.detail){const w=h.detail;if(w.error)return R(w.error,d);if(w.exception)return R(w.exception,d)}return h.stack?R(h,d):h.message?h.message:k.localize(12848,null)}function c(h){const d=h;return d instanceof Error&&Array.isArray(d.actions)}function m(h,d){let w;return typeof h=="string"?w=new Error(h):w=h,w.actions=d,w}}),define(le[163],he([0,1,10,43]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=k;function k(R){switch(R){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(12834,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(12835,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(12836,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(12837,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(12838,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(12839,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(12840,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(12841,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(12842,null);default:return""}}}),define(le[164],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whb=n,e.$Xhb=r;function n(k){return k&&k.hasOwnProperty("folderUri")}function r(k){return k&&k.hasOwnProperty("workspace")}}),define(le[165],he([0,1,7]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=r,e.$7ec=k,e.$8ec=R;function r(T){return typeof T?.backupFolder=="string"}function k(T){let I=[];try{Array.isArray(T.workspaces)&&(I=T.workspaces.map(p=>({workspace:{id:p.id,configPath:n.URI.parse(p.configURIPath)},remoteAuthority:p.remoteAuthority})))}catch{}return I}function R(T){let I=[];try{Array.isArray(T.folders)&&(I=T.folders.map(p=>({folderUri:n.URI.parse(p.folderUri),remoteAuthority:p.remoteAuthority})))}catch{}return I}}),define(le[166],he([0,1,39,15,10]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var R;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(R||(e.TokenType=R={}));function T(...m){switch(m.length){case 1:return(0,k.localize)(11450,null,m[0]);case 2:return(0,k.localize)(11451,null,m[0],m[1]);case 3:return(0,k.localize)(11452,null,m[0],m[1],m[2]);default:return}}const I=(0,k.localize)(11453,null),p=(0,k.localize)(11454,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return h.isTripleEq?"===":"==";case R.NotEq:return h.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return h.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return h.lexeme;case R.QuotedStr:return h.lexeme;case R.Error:return h.lexeme;case R.EOF:return"EOF";default:throw(0,r.$7)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(R.LParen);break;case n.CharCode.CloseParen:this.k(R.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const d=this.h(n.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:d})}else this.k(R.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const d=this.h(n.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:d})}else this.h(n.CharCode.Tilde)?this.k(R.RegexOp):this.l(T("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?R.LtEq:R.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?R.GtEq:R.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(R.And):this.l(T("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(R.Or):this.l(T("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const d=this.d,w=this.c.substring(this.d,this.e),f={type:R.Error,offset:this.d,lexeme:w};this.g.push({offset:d,lexeme:w,additionalInfo:h}),this.f.push(f)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const d=this.c.substring(this.d,this.e),w=c.b.get(d);w?this.k(w):this.f.push({type:R.Str,lexeme:d,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,d=!1,w=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(p);return}const g=this.c.charCodeAt(h);if(d)d=!1;else if(g===n.CharCode.Slash&&!w){h++;break}else g===n.CharCode.OpenSquareBracket?w=!0:g===n.CharCode.Backslash?d=!0:g===n.CharCode.CloseSquareBracket&&(w=!1);h++}for(;h<this.c.length&&c.a.has(this.c.charCodeAt(h));)h++;this.e=h;const f=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=c}),define(le[167],he([0,1,4,2]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=void 0;class k{constructor(){this.a=new n.$je,this.b=new n.$je,this.c=new n.$je,this.d=new n.$je}static{this.ChannelName="extensionhostdebugservice"}call(I,p,c){switch(p){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(I,p,c){switch(p){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Wo=k;class R extends r.$Tc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,p,c){this.b.call("attach",[I,p,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,p){this.b.call("terminate",[I,p])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,p){return this.b.call("openExtensionDevelopmentHostWindow",[I,p])}}e.$Xo=R}),define(le[168],he([0,1,162,53,11,9,36,18,7]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$4m=m,e.$5m=h,e.$2m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,R.$lc)(k.$Wg.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,R.$ic)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,I.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$ic)(this.userDataPath,"logs",w)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$dh)(p.URI.file((0,R.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,R.$ic)(w,"argv.json")):(0,I.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,R.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,R.$jc)(w):(0,R.$gc)((0,R.$ic)(k.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?p.URI.file((0,R.$jc)(w)):p.URI.file((0,R.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,R.$jc)(w);const f=T.env.VSCODE_EXTENSIONS;if(f)return f;const g=T.env.VSCODE_PORTABLE;return g?(0,R.$ic)(g,"extensions"):(0,I.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(f=>/^[^:/?#]+?:\/\//.test(f)?p.URI.parse(f):p.URI.file((0,R.$gc)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?p.URI.parse(w):p.URI.file((0,R.$gc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$2m.test(w))}get extensionLogLevel(){const w=[];for(const f of this.args.log||[]){const g=e.$2m.exec(f);g&&g[1]&&g[2]&&w.push([g[1],g[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$dh)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,R.$ic)(w,"policy.json")):(0,I.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,f,g){this.a=w,this.b=f,this.c=g,this.editSessionId=this.args.editSessionId}}e.$3m=c,Ee([r.$7h],c.prototype,"appRoot",null),Ee([r.$7h],c.prototype,"userHome",null),Ee([r.$7h],c.prototype,"userDataPath",null),Ee([r.$7h],c.prototype,"appSettingsHome",null),Ee([r.$7h],c.prototype,"tmpDir",null),Ee([r.$7h],c.prototype,"cacheHome",null),Ee([r.$7h],c.prototype,"stateResource",null),Ee([r.$7h],c.prototype,"userRoamingDataHome",null),Ee([r.$7h],c.prototype,"userDataSyncHome",null),Ee([r.$7h],c.prototype,"sync",null),Ee([r.$7h],c.prototype,"machineSettingsResource",null),Ee([r.$7h],c.prototype,"workspaceStorageHome",null),Ee([r.$7h],c.prototype,"localHistoryHome",null),Ee([r.$7h],c.prototype,"keyboardLayoutResource",null),Ee([r.$7h],c.prototype,"argvResource",null),Ee([r.$7h],c.prototype,"isExtensionDevelopment",null),Ee([r.$7h],c.prototype,"untitledWorkspacesHome",null),Ee([r.$7h],c.prototype,"builtinExtensionsPath",null),Ee([r.$7h],c.prototype,"extensionsPath",null),Ee([r.$7h],c.prototype,"extensionDevelopmentLocationURI",null),Ee([r.$7h],c.prototype,"extensionDevelopmentKind",null),Ee([r.$7h],c.prototype,"extensionTestsLocationURI",null),Ee([r.$7h],c.prototype,"debugExtensionHost",null),Ee([r.$7h],c.prototype,"logLevel",null),Ee([r.$7h],c.prototype,"extensionLogLevel",null),Ee([r.$7h],c.prototype,"serviceMachineIdResource",null),Ee([r.$7h],c.prototype,"disableTelemetry",null),Ee([r.$7h],c.prototype,"disableWorkspaceTrust",null),Ee([r.$7h],c.prototype,"useInMemorySecretStorage",null),Ee([r.$7h],c.prototype,"policyFile",null);function m(d,w){return h(d["inspect-extensions"],d["inspect-brk-extensions"],5870,w,d.debugId,d.extensionEnvironment)}function h(d,w,f,g,v,b){const P=Number(w||d)||(g?null:f),E=P?!!w:!1;let t;if(b)try{t=JSON.parse(b)}catch{}return{port:P,break:E,debugId:v,env:t}}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[120],he([0,1,280,3,10]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=void 0,e.$Am=I,e.$Bm=c,e.$Cm=w,e.$Dm=f,n=Ge(n);const R={o:(0,k.localize)(11387,null),e:(0,k.localize)(11388,null),t:(0,k.localize)(11389,null)};e.$ym=["tunnel","serve-web"],e.$zm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(11390,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(11391,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(11392,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(11393,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(11394,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(11395,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(11396,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(11397,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(11398,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11399,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11400,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(11401,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11402,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(11403,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(11404,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(11405,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,k.localize)(11406,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(11407,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(11408,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(11409,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(11410,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(11411,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(11412,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(11413,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(11414,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(11415,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(11416,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(11417,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(11418,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(11419,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(11420,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(11421,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,k.localize)(11422,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(11423,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,k.localize)(11424,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(11425,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(g,v,b=T){const $=g.find(l=>l.length>0&&l[0]!=="-"),P={},E=["_"],t=[],u={};let i;for(const l in v){const S=v[l];S.type==="subcommand"?l===$&&(i=S):(S.alias&&(P[l]=S.alias),S.type==="string"||S.type==="string[]"?(E.push(l),S.deprecates&&E.push(...S.deprecates)):S.type==="boolean"&&(t.push(l),S.deprecates&&t.push(...S.deprecates)),S.global&&(u[l]=S))}if(i&&$){const l=u;for(const L in i.options)l[L]=i.options[L];const S=g.filter(L=>L!==$),y=b.getSubcommandReporter?b.getSubcommandReporter($):void 0,D=I(S,l,y);return{[$]:D,_:[]}}const o=(0,n.default)(g,{string:E,boolean:t,alias:P}),s={},a=o;s._=o._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in v){const S=v[l];if(S.type==="subcommand")continue;S.alias&&delete a[S.alias];let y=a[l];if(S.deprecates)for(const D of S.deprecates)a.hasOwnProperty(D)&&(y||(y=a[D],y&&b.onDeprecatedOption(D,S.deprecationMessage||(0,k.localize)(11426,null,l))),delete a[D]);if(typeof y<"u"){if(S.type==="string[]"){if(Array.isArray(y)||(y=[y]),!S.allowEmptyValue){const D=y.filter(L=>L.length>0);D.length!==y.length&&(b.onEmptyValue(l),y=D.length>0?D:void 0)}}else S.type==="string"&&(Array.isArray(y)?(y=y.pop(),b.onMultipleValues(l,y)):!y&&!S.allowEmptyValue&&(b.onEmptyValue(l),y=void 0));s[l]=y,S.deprecationMessage&&b.onDeprecatedOption(l,S.deprecationMessage)}delete a[l]}for(const l in a)b.onUnknownOption(l);return s}function p(g,v){let b="";return v.args&&(Array.isArray(v.args)?b=` <${v.args.join("> <")}>`:b=` <${v.args}>`),v.alias?`-${v.alias} --${g}${b}`:`--${g}${b}`}function c(g,v){const b=[];for(const $ in g){const P=g[$],E=p($,P);b.push([E,P.description])}return m(b,v)}function m(g,v){const $=g.reduce((t,u)=>Math.max(t,u[0].length),12)+2+1;if(v-$<25)return g.reduce((t,u)=>t.concat([`  ${u[0]}`,`      ${u[1]}`]),[]);const P=v-$-1,E=[];for(const t of g){const u=t[0],i=d(t[1],P),o=h($-u.length-2);E.push("  "+u+o+i[0]);for(let s=1;s<i.length;s++)E.push(h($)+i[s])}return E}function h(g){return" ".repeat(g)}function d(g,v){const b=[];for(;g.length;){const $=g.length<v?g.length:g.lastIndexOf(" ",v),P=g.slice(0,$).trim();g=g.slice($),b.push(P)}return b}function w(g,v,b,$,P){const E=process.stdout.isTTY&&process.stdout.columns||80,t=P?.noInputFiles!==!0?`[${(0,k.localize)(11427,null)}...]`:"",u=[`${g} ${b}`];u.push(""),u.push(`${(0,k.localize)(11428,null)}: ${v} [${(0,k.localize)(11429,null)}]${t}`),u.push(""),P?.noPipe!==!0&&(r.$j?u.push((0,k.localize)(11430,null,v)):u.push((0,k.localize)(11431,null,v)),u.push(""));const i={},o=[];for(const s in $){const a=$[s];if(a.type==="subcommand")a.description&&o.push({command:s,description:a.description});else if(a.description&&a.cat){let l=i[a.cat];l||(i[a.cat]=l={}),l[s]=a}}for(const s in i){const a=s,l=i[a];l&&(u.push(R[a]),u.push(...c(l,E)),u.push(""))}return o.length&&(u.push((0,k.localize)(11432,null)),u.push(...m(o.map(s=>[s.command,s.description]),E)),u.push("")),u.join(`
`)}function f(g,v){return`${g||(0,k.localize)(11433,null)}
${v||(0,k.localize)(11434,null)}
${process.arch}`}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[68],he([0,1,281,10,120]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=I,e.$Fm=p,e.$Gm=c,e.$Hm=m,n=Ge(n);function R(h,d){const w=(P,E)=>{console.warn((0,r.localize)(11381,null,P,E))},f=P=>{console.warn((0,r.localize)(11382,null,P))},g=(P,E)=>{console.warn((0,r.localize)(11383,null,P,E))},v=P=>({onUnknownOption:E=>{k.$ym.includes(P)||console.warn((0,r.localize)(11384,null,E,P))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:g,getSubcommandReporter:k.$ym.includes(P)?v:void 0}),b={onUnknownOption:P=>{console.warn((0,r.localize)(11385,null,P))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:g,getSubcommandReporter:v},$=(0,k.$Am)(h,k.$zm,d?b:void 0);return $.goto&&$._.forEach(P=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(P),(0,r.localize)(11386,null))),$}function T(h){const d=h.findIndex(w=>!/^-/.test(w));if(d>-1)return[...h.slice(0,d),...h.slice(d+1)]}function I(h){let[,...d]=h;process.env.VSCODE_DEV&&(d=T(d)||[]);const w=!m(process.env);return R(d,w)}function p(h){let[,,...d]=h;return process.env.VSCODE_DEV&&(d=T(d)||[]),R(d,!0)}function c(h,...d){const w=h.indexOf("--");return w===-1?h.push(...d):h.splice(w,0,...d),h}function m(h){return h.VSCODE_CLI==="1"}}),function(){function G(e,n,r){function k(T,I){const p=R(T,I),c=[p];return e.isAbsolute(p)||c.unshift(r),e.resolve(...c)}function R(T,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const m=T["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const h=process.env.USERPROFILE;if(typeof h!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(h,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:k}}if(typeof define=="function")define(le[169],he([121,27,36]),function(e,n,r){return G(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=G(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[95],he([0,1,27,168,169]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0,e.$7m=T,e.$8m=I;class R extends r.$3m{constructor(c,m){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,k.getUserDataPath)(c,m.nameShort)},m)}}e.$6m=R;function T(p,c){return(0,r.$5m)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,c,p.extensionEnvironment)}function I(p,c){return(0,r.$5m)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,c,p.extensionEnvironment)}}),define(le[170],he([0,1,26,27,32]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=R;function R(T){const I=(0,k.$Kg)((0,r.tmpdir)());try{return(0,n.writeFileSync)(I,""),T&&console.log(`Marker file for --wait created: ${I}`),I}catch(p){T&&console.error(`Failed to create marker file for --wait: ${p}`);return}}}),define(le[171],he([0,1,12,10]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=k;function k(T,I,p,c){try{R(T,I,p,c)}catch(m){T.error(m?.message??m)}return I}function R(T,I,p,c){const m=(h,d,w)=>{const f=h[d];if((0,n.$cg)(f)){const g=f,v=g.length;if(v>1&&g[0]==="%"&&g[v-1]==="%"){const b=g.substr(1,v-2);let $=p[b];$===void 0&&c&&($=c[b]);const P=typeof $=="string"?$:$?.message,E=c?.[b],t=typeof E=="string"?E:E?.message;if(!P){t||T.warn(`[${I.name}]: ${(0,r.localize)(11333,null,b)}`);return}if(w&&(d==="title"||d==="category")&&t&&t!==P){const u={value:P,original:t};h[d]=u}else h[d]=P}}else if((0,n.$eg)(f))for(const g in f)f.hasOwnProperty(g)&&(g==="commands"?m(f,g,!0):m(f,g,w));else if(Array.isArray(f))for(let g=0;g<f.length;g++)m(f,g,w)};for(const h in I)I.hasOwnProperty(h)&&m(I,h)}}),define(le[172],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(le[83],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class n{constructor(k,R=[],T=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=T}}e.$zi=n}),define(le[173],he([0,1,83]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=R,e.$Ps=T;const r=[];var k;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function R(I,p,c){p instanceof n.$zi||(p=new n.$zi(p,[],!!c)),r.push([I,p])}function T(){return r}}),define(le[174],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class n{constructor(R,T){this.key=R,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$rr=n;class r{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const T of this.a.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const I=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(T);I.outgoing.set(p.key,p),p.incoming.set(I.key,I)}removeNode(R){const T=this.b(R);this.a.delete(T);for(const I of this.a.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(R){const T=this.b(R);let I=this.a.get(T);return I||(I=new n(T,R),this.a.set(T,I)),I}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[T,I]of this.a)R.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,T]of this.a){const I=new Set([R]),p=this.c(T,I);if(p)return p}}c(R,T){for(const[I,p]of R.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const c=this.c(p,T);if(c)return c;T.delete(I)}}}e.$sr=r}),define(le[6],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=k,e.$Di=R;var n;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(p){return p[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(n||(e._util=n={})),e.$Bi=k("instantiationService");function r(T,I,p){I[n.DI_TARGET]===I?I[n.DI_DEPENDENCIES].push({id:T,index:p}):(I[n.DI_DEPENDENCIES]=[{id:T,index:p}],I[n.DI_TARGET]=I)}function k(T){if(n.serviceIds.has(T))return n.serviceIds.get(T);const I=function(p,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,p,m)};return I.toString=()=>T,n.serviceIds.set(T,I),I}function R(T){return T}}),define(le[84],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0,e.$1fc=(0,n.$Ci)("auxiliaryWindowsMainService")}),define(le[69],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0,e.$9ec=(0,n.$Ci)("backupMainService")}),define(le[16],he([0,1,12,7,6]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=R,e.$$i=T,e.$_i=p,e.$aj=c,e.$bj=m,e.$cj=h,e.$dj=d,e.$ej=f,e.$fj=g,e.$gj=v,n=Ie(n),e.$9i=(0,k.$Ci)("configurationService");function R(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof r.URI)}function T(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof r.URI)}var I;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function p(b){switch(b){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function c(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function m(b,$){const P=Object.create(null);for(const E in b)h(P,E,b[E],$);return P}function h(b,$,P,E){const t=$.split("."),u=t.pop();let i=b;for(let o=0;o<t.length;o++){const s=t[o];let a=i[s];switch(typeof a){case"undefined":a=i[s]=Object.create(null);break;case"object":if(a===null){E(`Ignoring ${$} as ${t.slice(0,o+1).join(".")} is null`);return}break;default:E(`Ignoring ${$} as ${t.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}i=a}if(typeof i=="object"&&i!==null)try{i[u]=P}catch{E(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(i)}`)}else E(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(i)}`)}function d(b,$){const P=$.split(".");w(b,P)}function w(b,$){const P=$.shift();if($.length===0){delete b[P];return}if(Object.keys(b).indexOf(P)!==-1){const E=b[P];typeof E=="object"&&!Array.isArray(E)&&(w(E,$),Object.keys(E).length===0&&delete b[P])}}function f(b,$,P){function E(i,o){let s=i;for(const a of o){if(typeof s!="object"||s===null)return;s=s[a]}return s}const t=$.split("."),u=E(b,t);return typeof u>"u"?P:u}function g(b,$,P){Object.keys($).forEach(E=>{E!=="__proto__"&&(E in b?n.$eg(b[E])&&n.$eg($[E])?g(b[E],$[E],P):P&&(b[E]=$[E]):b[E]=$[E])})}function v(b){return b.replace(/[\[\]]/g,"")}}),define(le[122],he([0,1,39,3,25,166,6,10,15]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=m,e.$Bj=o,e.$Cj=s,e.$Vj=K;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",r.$k),c.set("isLinux",r.$l),c.set("isWindows",r.$j),c.set("isWeb",r.$p),c.set("isMacNative",r.$k&&!r.$p),c.set("isEdge",r.$I),c.set("isFirefox",r.$G),c.set("isChrome",r.$F),c.set("isSafari",r.$H);function m(ie,M){if(c.get(ie)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(ie,M)}const h=Object.prototype.hasOwnProperty;var d;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const w={regexParsingWithErrorRecovery:!0},f=(0,I.localize)(11464,null),g=(0,I.localize)(11465,null),v=(0,I.localize)(11466,null),b=(0,I.localize)(11467,null),$=(0,I.localize)(11468,null),P=(0,I.localize)(11469,null),E=(0,I.localize)(11470,null),t=(0,I.localize)(11471,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=w){this.k=M,this.d=new R.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const N=this.D(),z=N.type===R.TokenType.Str?P:void 0;throw this.h.push({message:$,offset:N.offset,lexeme:R.$xj.getLexeme(N),additionalInfo:z}),u.c}return F}catch(F){if(F!==u.c)throw F;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(R.TokenType.Or);){const F=this.o();M.push(F)}return M.length===1?M[0]:i.or(...M)}o(){const M=[this.s()];for(;this.y(R.TokenType.And);){const F=this.s();M.push(F)}return M.length===1?M[0]:i.and(...M)}s(){if(this.y(R.TokenType.Neg)){const M=this.D();switch(M.type){case R.TokenType.True:return this.z(),l.INSTANCE;case R.TokenType.False:return this.z(),S.INSTANCE;case R.TokenType.LParen:{this.z();const F=this.l();return this.A(R.TokenType.RParen,b),F?.negate()}case R.TokenType.Str:return this.z(),W.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case R.TokenType.True:return this.z(),i.true();case R.TokenType.False:return this.z(),i.false();case R.TokenType.LParen:{this.z();const F=this.l();return this.A(R.TokenType.RParen,b),F}case R.TokenType.Str:{const F=M.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==R.TokenType.RegexStr)throw this.B("REGEX",z);const _=z.lexeme,Q=_.lastIndexOf("/"),q=Q===_.length-1?void 0:this.w(_.substring(Q+1));let re;try{re=new RegExp(_.substring(1,Q),q)}catch{throw this.B("REGEX",z)}return te.create(F,re)}switch(z.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const _=[z.lexeme];this.z();let Q=this.D(),q=0;for(let De=0;De<z.lexeme.length;De++)z.lexeme.charCodeAt(De)===n.CharCode.OpenParen?q++:z.lexeme.charCodeAt(De)===n.CharCode.CloseParen&&q--;for(;!this.E()&&Q.type!==R.TokenType.And&&Q.type!==R.TokenType.Or;){switch(Q.type){case R.TokenType.LParen:q++;break;case R.TokenType.RParen:q--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let De=0;De<Q.lexeme.length;De++)Q.lexeme.charCodeAt(De)===n.CharCode.OpenParen?q++:z.lexeme.charCodeAt(De)===n.CharCode.CloseParen&&q--}if(q<0)break;_.push(R.$xj.getLexeme(Q)),this.z(),Q=this.D()}const re=_.join(""),de=re.lastIndexOf("/"),me=de===re.length-1?void 0:this.w(re.substring(de+1));let we;try{we=new RegExp(re.substring(1,de),me)}catch{throw this.B("REGEX",z)}return i.regex(F,we)}case R.TokenType.QuotedStr:{const _=z.lexeme;this.z();let Q=null;if(!(0,k.$af)(_)){const q=_.indexOf("/"),re=_.lastIndexOf("/");if(q!==re&&q>=0){const de=_.slice(q+1,re),me=_[re+1]==="i"?"i":"";try{Q=new RegExp(de,me)}catch{throw this.B("REGEX",z)}}}if(Q===null)throw this.B("REGEX",z);return te.create(F,Q)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,v);const z=this.u();return i.notIn(F,z)}switch(this.D().type){case R.TokenType.Eq:{this.z();const z=this.u();if(this.x().type===R.TokenType.QuotedStr)return i.equals(F,z);switch(z){case"true":return i.has(F);case"false":return i.not(F);default:return i.equals(F,z)}}case R.TokenType.NotEq:{this.z();const z=this.u();if(this.x().type===R.TokenType.QuotedStr)return i.notEquals(F,z);switch(z){case"true":return i.not(F);case"false":return i.has(F);default:return i.notEquals(F,z)}}case R.TokenType.Lt:return this.z(),Z.create(F,this.u());case R.TokenType.LtEq:return this.z(),U.create(F,this.u());case R.TokenType.Gt:return this.z(),H.create(F,this.u());case R.TokenType.GtEq:return this.z(),Y.create(F,this.u());case R.TokenType.In:return this.z(),i.in(F,this.u());default:return i.has(F)}}case R.TokenType.EOF:throw this.h.push({message:E,offset:M.offset,lexeme:"",additionalInfo:t}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),M.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,F){if(this.C(M))return this.z();throw this.B(F,this.D())}B(M,F,N){const z=(0,I.localize)(11472,null,M,R.$xj.getLexeme(F)),_=F.offset,Q=R.$xj.getLexeme(F);return this.h.push({message:z,offset:_,lexeme:Q,additionalInfo:N}),u.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$zj=u;class i{static false(){return l.INSTANCE}static true(){return S.INSTANCE}static has(M){return y.create(M)}static equals(M,F){return D.create(M,F)}static notEquals(M,F){return O.create(M,F)}static regex(M,F){return te.create(M,F)}static in(M,F){return L.create(M,F)}static notIn(M,F){return A.create(M,F)}static not(M){return W.create(M)}static and(...M){return B.create(M,null,!0)}static or(...M){return j.create(M,null,!0)}static greater(M,F){return H.create(M,F)}static greaterEquals(M,F){return Y.create(M,F)}static smaller(M,F){return Z.create(M,F)}static smallerEquals(M,F){return U.create(M,F)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Aj=i;function o(ie){const M=new u({regexParsingWithErrorRecovery:!1});return ie.map(F=>(M.parse(F),M.lexingErrors.length>0?M.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,I.localize)(11473,null,N.additionalInfo):(0,I.localize)(11474,null),offset:N.offset,length:N.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}function s(ie,M){const F=ie?ie.substituteConstants():void 0,N=M?M.substituteConstants():void 0;return!F&&!N?!0:!F||!N?!1:F.equals(N)}function a(ie,M){return ie.cmp(M)}class l{static{this.INSTANCE=new l}constructor(){this.type=d.False}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return S.INSTANCE}}e.$Dj=l;class S{static{this.INSTANCE=new S}constructor(){this.type=d.True}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return l.INSTANCE}}e.$Ej=S;class y{static create(M,F=null){const N=c.get(M);return typeof N=="boolean"?N?S.INSTANCE:l.INSTANCE:new y(M,F)}constructor(M,F){this.key=M,this.c=F,this.type=d.Defined}cmp(M){return M.type!==this.type?this.type-M.type:X(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=c.get(this.key);return typeof M=="boolean"?M?S.INSTANCE:l.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.$Fj=y;class D{static create(M,F,N=null){if(typeof F=="boolean")return F?y.create(M,N):W.create(M,N);const z=c.get(M);return typeof z=="boolean"?F===(z?"true":"false")?S.INSTANCE:l.INSTANCE:new D(M,F,N)}constructor(M,F,N){this.c=M,this.d=F,this.f=N,this.type=d.Equals}cmp(M){return M.type!==this.type?this.type-M.type:ae(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=c.get(this.c);if(typeof M=="boolean"){const F=M?"true":"false";return this.d===F?S.INSTANCE:l.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Gj=D;class L{static create(M,F){return new L(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=d.In,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:ae(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const F=M.getValue(this.f),N=M.getValue(this.d);return Array.isArray(F)?F.includes(N):typeof N=="string"&&typeof F=="object"&&F!==null?h.call(F,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Hj=L;class A{static create(M,F){return new A(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=d.NotIn,this.c=L.create(M,F)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=A;class O{static create(M,F,N=null){if(typeof F=="boolean")return F?W.create(M,N):y.create(M,N);const z=c.get(M);return typeof z=="boolean"?F===(z?"true":"false")?l.INSTANCE:S.INSTANCE:new O(M,F,N)}constructor(M,F,N){this.c=M,this.d=F,this.f=N,this.type=d.NotEquals}cmp(M){return M.type!==this.type?this.type-M.type:ae(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=c.get(this.c);if(typeof M=="boolean"){const F=M?"true":"false";return this.d===F?l.INSTANCE:S.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Jj=O;class W{static create(M,F=null){const N=c.get(M);return typeof N=="boolean"?N?l.INSTANCE:S.INSTANCE:new W(M,F)}constructor(M,F){this.c=M,this.d=F,this.type=d.Not}cmp(M){return M.type!==this.type?this.type-M.type:X(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=c.get(this.c);return typeof M=="boolean"?M?l.INSTANCE:S.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Kj=W;function V(ie,M){if(typeof ie=="string"){const F=parseFloat(ie);isNaN(F)||(ie=F)}return typeof ie=="string"||typeof ie=="number"?M(ie):l.INSTANCE}class H{static create(M,F,N=null){return V(F,z=>new H(M,z,N))}constructor(M,F,N){this.c=M,this.d=F,this.f=N,this.type=d.Greater}cmp(M){return M.type!==this.type?this.type-M.type:ae(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Lj=H;class Y{static create(M,F,N=null){return V(F,z=>new Y(M,z,N))}constructor(M,F,N){this.c=M,this.d=F,this.f=N,this.type=d.GreaterEquals}cmp(M){return M.type!==this.type?this.type-M.type:ae(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Mj=Y;class Z{static create(M,F,N=null){return V(F,z=>new Z(M,z,N))}constructor(M,F,N){this.c=M,this.d=F,this.f=N,this.type=d.Smaller}cmp(M){return M.type!==this.type?this.type-M.type:ae(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Nj=Z;class U{static create(M,F,N=null){return V(F,z=>new U(M,z,N))}constructor(M,F,N){this.c=M,this.d=F,this.f=N,this.type=d.SmallerEquals}cmp(M){return M.type!==this.type?this.type-M.type:ae(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$Oj=U;class te{static create(M,F){return new te(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=d.Regex,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const F=this.f?this.f.source:"",N=M.f?M.f.source:"";return F<N?-1:F>N?1:0}equals(M){if(M.type===this.type){const F=this.f?this.f.source:"",N=M.f?M.f.source:"";return this.d===M.d&&F===N}return!1}substituteConstants(){return this}evaluate(M){const F=M.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$Pj=te;class x{static create(M){return new x(M)}constructor(M){this.c=M,this.type=d.NotRegex}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new x(this.c.map(M))}negate(){return this.c}}e.$Qj=x;function J(ie){let M=null;for(let F=0,N=ie.length;F<N;F++){const z=ie[F].substituteConstants();if(ie[F]!==z&&M===null){M=[];for(let _=0;_<F;_++)M[_]=ie[_]}M!==null&&(M[F]=z)}return M===null?ie:M}class B{static create(M,F,N){return B.d(M,F,N)}constructor(M,F){this.expr=M,this.c=F,this.type=d.And}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const z=a(this.expr[F],M.expr[F]);if(z!==0)return z}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(M.expr[F]))return!1;return!0}return!1}substituteConstants(){const M=J(this.expr);return M===this.expr?this:B.create(M,this.c,!1)}evaluate(M){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(M))return!1;return!0}static d(M,F,N){const z=[];let _=!1;for(const Q of M)if(Q){if(Q.type===d.True){_=!0;continue}if(Q.type===d.False)return l.INSTANCE;if(Q.type===d.And){z.push(...Q.expr);continue}z.push(Q)}if(z.length===0&&_)return S.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(a);for(let Q=1;Q<z.length;Q++)z[Q-1].equals(z[Q])&&(z.splice(Q,1),Q--);if(z.length===1)return z[0];for(;z.length>1;){const Q=z[z.length-1];if(Q.type!==d.Or)break;z.pop();const q=z.pop(),re=z.length===0,de=j.create(Q.expr.map(me=>B.create([me,q],null,N)),null,re);de&&(z.push(de),z.sort(a))}if(z.length===1)return z[0];if(N){for(let Q=0;Q<z.length;Q++)for(let q=Q+1;q<z.length;q++)if(z[Q].negate().equals(z[q]))return l.INSTANCE;if(z.length===1)return z[0]}return new B(z,F)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const F of this.expr)M.push(...F.keys());return M}map(M){return new B(this.expr.map(F=>F.map(M)),null)}negate(){if(!this.c){const M=[];for(const F of this.expr)M.push(F.negate());this.c=j.create(M,this,!0)}return this.c}}e.$Rj=B;class j{static create(M,F,N){return j.d(M,F,N)}constructor(M,F){this.expr=M,this.c=F,this.type=d.Or}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const z=a(this.expr[F],M.expr[F]);if(z!==0)return z}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(M.expr[F]))return!1;return!0}return!1}substituteConstants(){const M=J(this.expr);return M===this.expr?this:j.create(M,this.c,!1)}evaluate(M){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(M))return!0;return!1}static d(M,F,N){let z=[],_=!1;if(M){for(let Q=0,q=M.length;Q<q;Q++){const re=M[Q];if(re){if(re.type===d.False){_=!0;continue}if(re.type===d.True)return S.INSTANCE;if(re.type===d.Or){z=z.concat(re.expr);continue}z.push(re)}}if(z.length===0&&_)return l.INSTANCE;z.sort(a)}if(z.length!==0){if(z.length===1)return z[0];for(let Q=1;Q<z.length;Q++)z[Q-1].equals(z[Q])&&(z.splice(Q,1),Q--);if(z.length===1)return z[0];if(N){for(let Q=0;Q<z.length;Q++)for(let q=Q+1;q<z.length;q++)if(z[Q].negate().equals(z[q]))return S.INSTANCE;if(z.length===1)return z[0]}return new j(z,F)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const F of this.expr)M.push(...F.keys());return M}map(M){return new j(this.expr.map(F=>F.map(M)),null)}negate(){if(!this.c){const M=[];for(const F of this.expr)M.push(F.negate());for(;M.length>1;){const F=M.shift(),N=M.shift(),z=[];for(const _ of se(F))for(const Q of se(N))z.push(B.create([_,Q],null,!1));M.unshift(j.create(z,null,!1))}this.c=j.create(M,this,!0)}return this.c}}e.$Sj=j;class C extends y{static{this.d=[]}static all(){return C.d.values()}constructor(M,F,N){super(M,null),this.f=F,typeof N=="object"?C.d.push({...N,key:M}):N!==!0&&C.d.push({key:M,description:N,type:F!=null?typeof F:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return D.create(this.key,M)}notEqualsTo(M){return O.create(this.key,M)}}e.$Tj=C,e.$Uj=(0,T.$Ci)("contextKeyService");function X(ie,M){return ie<M?-1:ie>M?1:0}function ae(ie,M,F,N){return ie<F?-1:ie>F?1:M<N?-1:M>N?1:0}function K(ie,M){if(ie.type===d.False||M.type===d.True)return!0;if(ie.type===d.Or)return M.type===d.Or?ce(ie.expr,M.expr):!1;if(M.type===d.Or){for(const F of M.expr)if(K(ie,F))return!0;return!1}if(ie.type===d.And){if(M.type===d.And)return ce(M.expr,ie.expr);for(const F of ie.expr)if(K(F,M))return!0;return!1}return ie.equals(M)}function ce(ie,M){let F=0,N=0;for(;F<ie.length&&N<M.length;){const z=ie[F].cmp(M[N]);if(z<0)return!1;z===0&&F++,N++}return F===ie.length}function se(ie){return ie.type===d.Or?ie.expr:[ie]}}),define(le[96],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Qm=e.ID=void 0,e.$Rm=r,e.ID="diagnosticsService",e.$Qm=(0,n.$Ci)(e.ID);function r(R){return!!R.hostName&&!!R.errorMessage}class k{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Sm=k});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[123],he([0,1,18,81,10,6,47,3,37]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$9w=e.$8w=e.$7w=void 0,e.$0w=w,e.$$w=f,r=Ge(r),e.$7w=(0,R.$Ci)("dialogService");var c;(function(g){g[g.Confirmation=1]="Confirmation",g[g.Prompt=2]="Prompt",g[g.Input=3]="Input"})(c||(c={}));class m{a(v){return this.d(v,c.Confirmation)}b(v){return this.d(v,c.Prompt)}c(v){return this.d(v,c.Input)}d(v,b){const $=[];switch(b){case c.Confirmation:{const P=v;P.primaryButton?$.push(P.primaryButton):$.push((0,k.localize)(11441,null)),P.cancelButton?$.push(P.cancelButton):$.push((0,k.localize)(11442,null));break}case c.Prompt:{const P=v;Array.isArray(P.buttons)&&P.buttons.length>0&&$.push(...P.buttons.map(E=>E.label)),P.cancelButton&&(P.cancelButton===!0?$.push((0,k.localize)(11443,null)):typeof P.cancelButton=="string"?$.push(P.cancelButton):P.cancelButton.label?$.push(P.cancelButton.label):$.push((0,k.localize)(11444,null))),$.length===0&&$.push((0,k.localize)(11445,null));break}case c.Input:{const P=v;P.primaryButton?$.push(P.primaryButton):$.push((0,k.localize)(11446,null)),P.cancelButton?$.push(P.cancelButton):$.push((0,k.localize)(11447,null));break}}return $}e(v){if(typeof v=="string")return v;if(typeof v=="number")return v===r.default.Info?"info":v===r.default.Error?"error":v===r.default.Warning?"warning":"none"}f(v,b,$){const P=[...v.buttons??[]];v.cancelButton&&typeof v.cancelButton!="string"&&typeof v.cancelButton!="boolean"&&P.push(v.cancelButton);let E=P[b]?.run({checkboxChecked:$});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:$}}}e.$8w=m,e.$9w=(0,R.$Ci)("fileDialogService");var h;(function(g){g[g.SAVE=0]="SAVE",g[g.DONT_SAVE=1]="DONT_SAVE",g[g.CANCEL=2]="CANCEL"})(h||(e.ConfirmResult=h={}));const d=10;function w(g){const v=[];return v.push(...g.slice(0,d).map(b=>typeof b=="string"?b:(0,n.$ah)(b))),g.length>d&&(g.length-d===1?v.push((0,k.localize)(11448,null)):v.push((0,k.localize)(11449,null,g.length-d))),v.push(""),v.join(`
`)}function f(g,v){const b=(0,p.$bo)(g);let $=(b.buttons??[]).map(u=>(0,T.$4w)(u)),P=(g.buttons||[]).map((u,i)=>i),E=0,t=b.cancelId??$.length-1;if($.length>1){const u=typeof t=="number"?$[t]:void 0;if(I.$l||I.$k){if(typeof u=="string"&&$.length>1&&t!==1){$.splice(t,1),$.splice(1,0,u);const i=P[t];P.splice(t,1),P.splice(1,0,i),t=1}I.$l&&$.length>1&&($=$.reverse(),P=P.reverse(),E=$.length-1,typeof u=="string"&&(t=E-1))}else if(I.$j&&typeof u=="string"&&$.length>1&&t!==$.length-1){$.splice(t,1),$.push(u);const i=P[t];P.splice(t,1),P.push(i),t=$.length-1}}return b.buttons=$,b.defaultId=E,b.cancelId=t,b.noLink=!0,b.title=b.title||v.nameLong,{options:b,buttonIndeces:P}}}),define(le[97],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$pY=e.$oY=void 0,e.$qY=R,e.$rY=T,e.$oY=(0,n.$Ci)("encryptionService"),e.$pY=(0,n.$Ci)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var k;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(k||(e.KnownStorageProvider=k={}));function R(I){return I===k.kwallet||I===k.kwallet5||I===k.kwallet6}function T(I){return I===k.gnomeAny||I===k.gnomeLibsecret||I===k.gnomeKeyring}}),define(le[38],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,n.$Ci)("environmentService"),e.$Ki=(0,n.$Di)(e.$Ji)}),define(le[175],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=void 0,e.$Pfc=(0,n.$Ci)("extensionHostStarter"),e.$Qfc="extensionHostStarter"}),define(le[176],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$79b=e.$69b=void 0,e.$69b=(0,n.$Ci)("externalTerminal"),e.$79b="Terminal.app"}),define(le[177],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0,e.$Sfc=(0,n.$Ci)("externalTerminal")}),define(le[178],he([0,1,48,53,11,9,3,79,23,94,10,176]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=e.$Ufc=e.$Tfc=void 0,n=Ie(n),R=Ie(R),T=Ie(T),p=Ie(p),c=Ie(c),m=Ie(m);const d=m.localize(11291,null);class w{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends w{static{this.b="cmd.exe"}openTerminal(t,u){return this.spawnTerminal(n,t,c.$vm(),u)}spawnTerminal(t,u,i,o){const s=u.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const a=R.$mc(s,".exe").toLowerCase();if(a==="cmder")return t.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push(s),l.push(s),a==="wt"&&l.push("-d ."),new Promise((S,y)=>{const D=b(process),L=t.spawn(i,l,{cwd:o,env:D,detached:!0});L.on("error",y),L.on("exit",()=>S())})}async runInTerminal(t,u,i,o,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows(),l=await f.f();return new Promise((S,y)=>{const D=`"${u} - ${d}"`,L=`"${i.join('" "')}" & pause`,A=Object.assign({},b(process),o);Object.keys(A).filter(Y=>A[Y]===null).forEach(Y=>delete A[Y]);const O={cwd:u,env:A,windowsVerbatimArguments:!0};let W,V;R.$mc(a,".exe")==="wt"?(W=a,V=["-d",".",f.b,"/c",L]):l?(W=l,V=["-d",".",a,"/c",L]):(W=f.b,V=["/c","start",D,"/wait",a,"/c",`"${L}"`]),n.spawn(W,V,O).on("error",Y=>{y($(Y))}),S(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await p.Promises.exists(t)?t:void 0}catch{return}}}e.$Tfc=f,Ee([r.$7h],f,"f",null);class g extends w{static{this.b="/usr/bin/osascript"}openTerminal(t,u){return this.spawnTerminal(n,t,u)}runInTerminal(t,u,i,o,s){const a=s.osxExec||h.$79b;return new Promise((l,S)=>{if(a===h.$79b||a==="iTerm.app"){const y=a===h.$79b?"TerminalHelper":"iTermHelper",L=[k.$Wg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||d,"-w",u];for(const W of i)L.push("-a"),L.push(W);if(o){const W=Object.assign({},b(process),o);for(const V in W){const H=W[V];H===null?(L.push("-u"),L.push(V)):(L.push("-e"),L.push(`${V}=${H}`))}}let A="";const O=n.spawn(g.b,L);O.on("error",W=>{S($(W))}),O.stderr.on("data",W=>{A+=W.toString()}),O.on("exit",W=>{if(W===0)l(void 0);else if(A){const V=A.split(`
`,1);S(new Error(V[0]))}else S(new Error(m.localize(11292,null,y,W)))})}else S(new Error(m.localize(11293,null,a)))})}spawnTerminal(t,u,i){const o=u.osxExec||h.$79b;return new Promise((s,a)=>{const l=["-a",o];i&&l.push(i);const S=b(process),y=t.spawn("/usr/bin/open",l,{cwd:i,env:S});y.on("error",a),y.on("exit",()=>s())})}}e.$Ufc=g;class v extends w{static{this.b=m.localize(11294,null)}openTerminal(t,u){return this.spawnTerminal(n,t,u)}runInTerminal(t,u,i,o,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((l,S)=>{const y=[];a.then(D=>{D.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const L=`${P(i)}; echo; read -p "${v.b}" -n1;`;y.push(`''${L}''`);const A=Object.assign({},b(process),o);Object.keys(A).filter(H=>A[H]===null).forEach(H=>delete A[H]);const O={cwd:u,env:A};let W="";const V=n.spawn(D,y,O);V.on("error",H=>{S($(H))}),V.stderr.on("data",H=>{W+=H.toString()}),V.on("exit",H=>{if(H===0)l(void 0);else if(W){const Y=W.split(`
`,1);S(new Error(Y[0]))}else S(new Error(m.localize(11295,null,D,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!T.$l)v.d=Promise.resolve("xterm");else{const t=await p.Promises.exists("/etc/debian_version");v.d=new Promise(u=>{t?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return v.d}spawnTerminal(t,u,i){const o=u.linuxExec?Promise.resolve(u.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{o.then(l=>{const S=b(process),y=t.spawn(l,[],{cwd:i,env:S});y.on("error",a),y.on("exit",()=>s())})})}}e.$Vfc=v;function b(E){const t={...E.env};return(0,I.$im)(t),t}function $(E){return"errno"in E&&E.errno==="ENOENT"&&"path"in E&&typeof E.path=="string"?new Error(m.localize(11296,null,E.path)):E}function P(E){let t="";for(const u of E)u.indexOf(" ")>=0?t+='"'+u+'"':t+=u,t+=" ";return t}}),define(le[14],he([0,1,60,9,25,12,7,10,6,3,11,65]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$Cl=e.FileKind=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.FileOperationResult=e.$ul=e.$tl=e.$sl=e.$ql=e.FileChangeType=e.$pl=e.FileOperation=e.$jl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$0k=void 0,e.$$k=d,e.$_k=v,e.$al=$,e.$bl=P,e.$cl=E,e.$dl=t,e.$el=u,e.$fl=i,e.$gl=o,e.$hl=s,e.$il=a,e.$kl=y,e.$ll=D,e.$ml=L,e.$nl=A,e.$ol=O,e.$rl=Z,e.$Dl=j,e.$El=C,e.$Gl=ae,e.$0k=(0,p.$Ci)("fileService");function d(K){return K.create===!0}var w;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var f;(function(K){K[K.Readonly=1]="Readonly",K[K.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var g;(function(K){K[K.UPDATED=2]="UPDATED",K[K.ADDED=4]="ADDED",K[K.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function v(K){const ce=K;return!!ce&&typeof ce.onDidChange=="function"}var b;(function(K){K[K.None=0]="None",K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileAtomicWrite=32768]="FileAtomicWrite",K[K.FileAtomicDelete=65536]="FileAtomicDelete",K[K.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function $(K){return!!(K.capabilities&b.FileReadWrite)}function P(K){return!!(K.capabilities&b.FileFolderCopy)}function E(K){return!!(K.capabilities&b.FileClone)}function t(K){return!!(K.capabilities&b.FileOpenReadWriteClose)}function u(K){return!!(K.capabilities&b.FileReadStream)}function i(K){return $(K)?!!(K.capabilities&b.FileAtomicRead):!1}function o(K){return $(K)?!!(K.capabilities&b.FileAtomicWrite):!1}function s(K){return!!(K.capabilities&b.FileAtomicDelete)}function a(K){return!!(K.capabilities&b.Readonly)}var l;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsStorageQuota="EntryExceedsStorageQuota",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class S extends Error{static create(ce,se){const ie=new S(ce.toString(),se);return L(ie,se),ie}constructor(ce,se){super(ce),this.code=se}}e.$jl=S;function y(K,ce){return S.create(K,ce)}function D(K){return K||y((0,I.localize)(11250,null),l.Unknown)}function L(K,ce){return K.name=ce?`${ce} (FileSystemError)`:"FileSystemError",K}function A(K){if(!K)return l.Unknown;if(K instanceof S)return K.code;const ce=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!ce)return l.Unknown;switch(ce[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function O(K){if(K instanceof U)return K.fileOperationResult;switch(A(K)){case l.FileNotFound:return J.FILE_NOT_FOUND;case l.FileIsADirectory:return J.FILE_IS_DIRECTORY;case l.FileNotADirectory:return J.FILE_NOT_DIRECTORY;case l.FileWriteLocked:return J.FILE_WRITE_LOCKED;case l.NoPermissions:return J.FILE_PERMISSION_DENIED;case l.FileExists:return J.FILE_MOVE_CONFLICT;case l.FileTooLarge:return J.FILE_TOO_LARGE;default:return J.FILE_OTHER_ERROR}}var W;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(W||(e.FileOperation=W={}));class V{constructor(ce,se,ie){this.resource=ce,this.operation=se,this.target=ie}isOperation(ce){return this.operation===ce}}e.$pl=V;var H;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(H||(e.FileChangeType=H={}));class Y{static{this.a=null}constructor(ce,se){this.c=se,this.b=void 0,this.d=new h.$T(()=>{const ie=n.$Ii.forUris(()=>this.c);return ie.fill(this.rawAdded.map(M=>[M,!0])),ie}),this.f=new h.$T(()=>{const ie=n.$Ii.forUris(()=>this.c);return ie.fill(this.rawUpdated.map(M=>[M,!0])),ie}),this.g=new h.$T(()=>{const ie=n.$Ii.forUris(()=>this.c);return ie.fill(this.rawDeleted.map(M=>[M,!0])),ie}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ie of ce){switch(ie.type){case H.ADDED:this.rawAdded.push(ie.resource);break;case H.UPDATED:this.rawUpdated.push(ie.resource);break;case H.DELETED:this.rawDeleted.push(ie.resource);break}this.b!==Y.a&&(typeof ie.cId=="number"?this.b===void 0?this.b=ie.cId:this.b!==ie.cId&&(this.b=Y.a):this.b!==void 0&&(this.b=Y.a))}}contains(ce,...se){return this.h(ce,{includeChildren:!1},...se)}affects(ce,...se){return this.h(ce,{includeChildren:!0},...se)}h(ce,se,...ie){if(!ce)return!1;const M=ie.length>0;return!!((!M||ie.includes(H.ADDED))&&(this.d.value.get(ce)||se.includeChildren&&this.d.value.findSuperstr(ce))||(!M||ie.includes(H.UPDATED))&&(this.f.value.get(ce)||se.includeChildren&&this.f.value.findSuperstr(ce))||(!M||ie.includes(H.DELETED))&&(this.g.value.findSubstr(ce)||se.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$ql=Y;function Z(K,ce,se){return!K||!ce||K===ce||ce.length>K.length?!1:(ce.charAt(ce.length-1)!==r.sep&&(ce+=r.sep),se?(0,k.$Ef)(K,ce):K.indexOf(ce)===0)}class U extends Error{constructor(ce,se,ie){super(ce),this.fileOperationResult=se,this.options=ie}}e.$sl=U;class te extends U{constructor(ce,se,ie,M){super(ce,se,M),this.fileOperationResult=se,this.size=ie}}e.$tl=te;class x extends U{constructor(ce,se,ie){super(ce,J.FILE_NOT_MODIFIED_SINCE,ie),this.stat=se}}e.$ul=x;var J;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$vl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$wl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$xl="files.associations",e.$yl="files.exclude",e.$zl="files.readonlyInclude",e.$Al="files.readonlyExclude",e.$Bl="files.readonlyFromPermissions";var B;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Cl="";function j(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}async function C(K,ce){if(!ce.hasProvider(T.URI.from({scheme:K.scheme})))return new Promise(se=>{const ie=ce.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===K.scheme&&M.added&&(ie.dispose(),se())})})}class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(ce){return(0,R.$gg)(ce)||(ce=0),ce<X.KB?(0,I.localize)(11251,null,ce.toFixed(0)):ce<X.MB?(0,I.localize)(11252,null,(ce/X.KB).toFixed(2)):ce<X.GB?(0,I.localize)(11253,null,(ce/X.MB).toFixed(2)):ce<X.TB?(0,I.localize)(11254,null,(ce/X.GB).toFixed(2)):(0,I.localize)(11255,null,(ce/X.TB).toFixed(2))}}e.$Fl=X;function ae(K){const ce=typeof K=="string"||K?.scheme===m.Schemas.vscodeRemote;return typeof K!="string"&&K?.scheme===m.Schemas.file?1024*X.MB:ce?10*X.MB:c.$p?50*X.MB:1024*X.MB}}),define(le[124],he([0,1,17,15,10,14]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=T;async function T(m,h,d,w,f,g){let v;try{await I(m,h,d,w,f,g)}catch(b){v=b}finally{v&&f.errorTransformer&&(v=f.errorTransformer(v)),typeof v<"u"&&d.error(v),d.end()}}async function I(m,h,d,w,f,g){p(g);const v=await m.open(h,{create:!1});try{p(g);let b=0,$=0,P=f&&typeof f.length=="number"?f.length:void 0,E=n.$Le.alloc(Math.min(f.bufferSize,typeof P=="number"?P:f.bufferSize)),t=f&&typeof f.position=="number"?f.position:0,u=0;do $=await m.read(v,t,E.buffer,u,E.byteLength-u),t+=$,u+=$,b+=$,typeof P=="number"&&(P-=$),u===E.byteLength&&(await d.write(w(E)),E=n.$Le.alloc(Math.min(f.bufferSize,typeof P=="number"?P:f.bufferSize)),u=0);while($>0&&(typeof P!="number"||P>0)&&p(g)&&c(b,f));if(u>0){let i=u;typeof P=="number"&&(i=Math.min(u,P)),d.write(w(E.slice(0,i)))}}catch(b){throw(0,R.$ll)(b)}finally{await m.close(v)}}function p(m){if(m.isCancellationRequested)throw(0,r.$5)();return!0}function c(m,h){if(typeof h?.limits?.size=="number"&&m>h.limits.size)throw(0,R.$kl)((0,k.localize)(11249,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[61],he([0,1,111,2,9,3,7,14]),function(G,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0,e.$1q=p,e.$2q=c,e.$6q=w,e.$7q=f,e.$8q=g,e.$9q=v,e.$0q=$,e.$$q=P;function p(E){return typeof E.correlationId=="number"}function c(E){return E.recursive===!0}class m extends r.$Tc{static{this.a=5}constructor(t,u,i,o){super(),this.h=t,this.j=u,this.m=i,this.n=o,this.c=this.B(new r.$Uc),this.f=void 0,this.g=0}s(){const t=new r.$Sc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(u=>this.h(u))),t.add(this.b.onDidLogMessage(u=>this.j(u))),t.add(this.b.onDidError(u=>this.t(u.error,u.request)))}t(t,u){this.u(t,u)?this.g<m.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,u){return!(!this.n.restartOnError||u||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3q=m;class h extends m{constructor(t,u,i){super(t,u,i,{type:"node.js",restartOnError:!1})}}e.$4q=h;class d extends m{constructor(t,u,i){super(t,u,i,{type:"universal",restartOnError:!0})}}e.$5q=d;function w(E){return E.map(t=>({type:t.type,resource:T.URI.revive(t.resource),cId:t.cId}))}function f(E){const t=new b;for(const u of E)t.processEvent(u);return t.coalesce()}function g(E,t){return typeof t=="string"&&!t.startsWith(n.$tk)&&!(0,k.$hc)(t)?{base:E,pattern:t}:t}function v(E,t){const u=[];for(const i of t)u.push((0,n.$xk)(g(E,i)));return u}class b{constructor(){this.a=new Set,this.b=new Map}c(t){return R.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const u=this.b.get(this.c(t));let i=!1;if(u){const o=u.type,s=t.type;u.resource.fsPath!==t.resource.fsPath&&(t.type===I.FileChangeType.DELETED||t.type===I.FileChangeType.ADDED)?i=!0:o===I.FileChangeType.ADDED&&s===I.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(u)):o===I.FileChangeType.DELETED&&s===I.FileChangeType.ADDED?u.type=I.FileChangeType.UPDATED:o===I.FileChangeType.ADDED&&s===I.FileChangeType.UPDATED||(u.type=s)}else i=!0;i&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],u=[];return Array.from(this.a).filter(i=>i.type!==I.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,o)=>i.resource.fsPath.length-o.resource.fsPath.length).filter(i=>u.some(o=>(0,I.$rl)(i.resource.fsPath,o,!R.$l))?!1:(u.push(i.resource.fsPath),!0)).concat(t)}}function $(E,t){if(typeof t=="number")switch(E.type){case I.FileChangeType.ADDED:return(t&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(t&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(t&I.FileChangeFilter.UPDATED)===0}return!1}function P(E){if(typeof E=="number"){const t=[];return E&I.FileChangeFilter.ADDED&&t.push("Added"),E&I.FileChangeFilter.DELETED&&t.push("Deleted"),E&I.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(le[179],he([0,1,17,54,15,4,2,67,33,14,61]),function(G,e,n,r,k,R,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=e.$dR=void 0,e.$dR="localFilesystem";class h extends T.$Tc{constructor(w,f){super(),this.a=w,this.b=f,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$je),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$je),this.onDidWatchError=this.g.event,this.h=(0,p.$Yg)(),this.j()}get capabilities(){return this.c||(this.c=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=c.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=c.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,f){const{buffer:g}=await this.a.call("readFile",[w,f]);return g}readFileStream(w,f,g){const v=(0,I.$ze)($=>n.$Le.concat($.map(P=>n.$Le.wrap(P))).buffer),b=new T.$Sc;return b.add(this.a.listen("readFileStream",[w,f])($=>{if($ instanceof n.$Le)v.write($.buffer);else{if($==="end")v.end();else{let P;if($ instanceof Error)P=$;else{const E=$;P=(0,c.$kl)(E.message??(0,r.$nj)(E),E.code??c.FileSystemProviderErrorCode.Unknown)}v.error(P),v.end()}b.dispose()}})),b.add(g.onCancellationRequested(()=>{v.error((0,k.$5)()),v.end(),b.dispose()})),v}writeFile(w,f,g){return this.a.call("writeFile",[w,n.$Le.wrap(f),g])}open(w,f){return this.a.call("open",[w,f])}close(w){return this.a.call("close",[w])}async read(w,f,g,v,b){const[$,P]=await this.a.call("read",[w,f,b]);return g.set($.buffer.slice(0,P),v),P}write(w,f,g,v,b){return this.a.call("write",[w,f,n.$Le.wrap(g),v,b])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,f){return this.a.call("delete",[w,f])}rename(w,f,g){return this.a.call("rename",[w,f,g])}copy(w,f,g){return this.a.call("copy",[w,f,g])}cloneFile(w,f){return this.a.call("cloneFile",[w,f])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const f=w;this.f.fire((0,m.$6q)(f))}else{const f=w;this.g.fire(f)}}))}watch(w,f){const g=(0,p.$Yg)();return this.a.call("watch",[this.h,g,w,f]),(0,T.$Rc)(()=>this.a.call("unwatch",[this.h,g]))}}e.$eR=h}),define(le[180],he([0,1,26,2,61,4,14,7,8]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class c extends r.$Tc{constructor(){super(),this.a=this.B(new R.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$3c),this.m=new Set,this.n=this.B(new p.$Ah(this.y())),this.r=5007,this.s=new p.$Zh,this.R=!1,this.B(this.f(h=>this.t(h)))}t(h){this.u(h)&&this.z(h)}u(h){return(0,k.$1q)(h)}async watch(h){this.s.isSettled||this.s.complete(),this.s=new p.$Zh;try{this.h.clear(),this.g.clear();for(const d of h)this.u(d)?this.h.set(d.correlationId,d):this.g.add(d);for(const[d]of this.j)this.h.has(d)||(this.j.deleteAndDispose(d),this.m.delete(d));return await this.w(!1)}finally{this.s.complete()}}w(h){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))]),h?this.y():0)}y(){return 800}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async z(h){if(this.j.has(h.correlationId))return;const d=new r.$Sc;this.j.set(h.correlationId,d),await this.s.p,!d.isDisposed&&(this.D(h,d),this.w(!0))}C(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.w(!1)}D(h,d){this.F(h,d)?(this.P(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.G(h,d),this.m.add(h.correlationId))}F(h,d){const w=this.O?.subscribe(h.path,(f,g)=>{d.isDisposed||(f?this.D(h,d):g?.type===T.FileChangeType.ADDED&&this.H(h))});return w?(d.add(w),!0):!1}G(h,d){let w=!1;const f=(g,v)=>{if(d.isDisposed)return;const b=this.I(g),$=this.I(v),P=w;w=b,!b&&($||P)&&this.H(h)};this.P(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,n.watchFile)(h.path,{persistent:!1,interval:this.r},f)}catch(g){this.Q(`fs.watchFile() failed with error ${g} on path ${h.path} (correlationId: ${h.correlationId})`)}d.add((0,r.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,n.unwatchFile)(h.path,f)}catch(g){this.Q(`fs.unwatchFile() failed with error ${g} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}H(h){this.P(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const d={resource:I.URI.file(h.path),type:T.FileChangeType.ADDED,cId:h.correlationId};this.a.fire([d]),this.J(d,h),this.C(h)}I(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(h,d){if(this.R){const w=` >> normalized ${h.type===T.FileChangeType.ADDED?"[ADDED]":h.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.L(w,d)}}L(h,d){this.R&&this.P(`${h}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}M(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,k.$$q)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.R=h}}e.$hr=c}),define(le[181],he([0,1,26,8,22,32,2,78,9,3,18,7,112,23,14,61]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0,e.$nr=b;class v extends T.$Tc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,E,t,u,i,o){super(),this.s=P,this.t=E,this.u=t,this.w=u,this.y=i,this.z=o,this.c=this.B(new r.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new r.$Qh(s=>this.M(s),v.b)),this.g=(0,g.$9q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,g.$9q)(this.s.path,this.s.includes):void 0,this.j=(0,g.$1q)(this.s)?this.s.filter:void 0,this.m=new k.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const E=await n.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,E.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let E=P.path;try{E=await w.Promises.realpath(P.path),P.path===E&&(E=await(0,d.$jr)(P.path,this.m.token)??P.path),P.path!==E&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${E})`)}catch{}return E}async G(P,E){const t=new T.$Sc;return this.H(P,E,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,E,t)),t}H(P,E,t){if(E)return!1;const u=h.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(o,s)=>{if(!t.isDisposed)if(o){const a=await this.G(P,E);t.isDisposed?a.dispose():t.add(a)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:u,type:s.type,cId:this.s.correlationId},!0)});return i?(t.add(i),!0):!1}async I(P,E,t){if(c.$k&&(0,R.$Bg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const u=new k.$ue(this.m.token);t.add((0,T.$Rc)(()=>u.dispose(!0)));const i=new T.$Sc;t.add(i);try{const o=h.URI.file(this.s.path),s=(0,p.$mc)(P),a=(0,n.watch)(P);i.add((0,T.$Rc)(()=>{a.removeAllListeners(),a.close()})),this.Q(`Started watching: '${P}'`);const l=new Set;if(E)try{for(const y of await w.Promises.readdir(P))l.add(y)}catch(y){this.O(y)}if(u.token.isCancellationRequested)return;const S=new Map;i.add((0,T.$Rc)(()=>{for(const[,y]of S)y.dispose();S.clear()})),a.on("error",(y,D)=>{u.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${y}, ${D})`),this.D())}),a.on("change",(y,D)=>{if(u.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${D}`);let L="";if(D&&(L=D.toString(),c.$k&&(L=(0,I.$km)(L))),!(!L||y!=="change"&&y!=="rename"))if(E)if(y==="rename"){S.get(L)?.dispose();const A=setTimeout(async()=>{if(S.delete(L),L===s&&!await w.Promises.exists(P)){this.J(o);return}if(u.token.isCancellationRequested)return;const O=await this.N((0,p.$ic)(P,L));if(u.token.isCancellationRequested)return;let W;O?l.has(L)?W=f.FileChangeType.UPDATED:(W=f.FileChangeType.ADDED,l.add(L)):(l.delete(L),W=f.FileChangeType.DELETED),this.L({resource:(0,m.$dh)(o,L),type:W,cId:this.s.correlationId})},v.a);S.set(L,(0,T.$Rc)(()=>clearTimeout(A)))}else{let A;l.has(L)?A=f.FileChangeType.UPDATED:(A=f.FileChangeType.ADDED,l.add(L)),this.L({resource:(0,m.$dh)(o,L),type:A,cId:this.s.correlationId})}else if(y==="rename"||L!==s){const A=setTimeout(async()=>{const O=await w.Promises.exists(P);u.token.isCancellationRequested||(O?(this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(P,!1))):this.J(o))},v.a);i.clear(),i.add((0,T.$Rc)(()=>clearTimeout(A)))}else this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){u.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${o.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:f.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,E=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===f.FileChangeType.ADDED?"[ADDED]":P.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!E&&this.g.some(t=>t(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!E&&this.h&&this.h.length>0&&!this.h.some(t=>t(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const E=(0,g.$7q)(P),t=[];for(const i of E){if((0,g.$0q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.z)for(const i of t)this.R(` >> normalized ${i.type===f.FileChangeType.ADDED?"[ADDED]":i.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(c.$l)return w.Promises.exists(P);try{const E=(0,p.$mc)(P);return(await w.Promises.readdir((0,p.$lc)(P))).some(u=>u===E)}catch(E){return this.Q(E),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$mr=v;async function b($,P,E,t,u=512){const i=await w.Promises.open($,"r"),o=Buffer.allocUnsafe(u),s=new k.$ue(t);let a,l=!1;const S={path:$,excludes:[],recursive:!1},y=new v(S,void 0,D=>{(async()=>{for(const{type:L}of D)if(L===f.FileChangeType.UPDATED){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:A}=await w.Promises.read(i,o,0,u,null);if(!A||s.token.isCancellationRequested)break;P(o.slice(0,A))}}catch(A){a=new Error(A),s.dispose(!0)}finally{l=!1}}})()});return await y.ready,E(),new Promise((D,L)=>{s.token.onCancellationRequested(async()=>{y.dispose();try{await w.Promises.close(i)}catch(A){a=new Error(A)}a?L(a):D()})})}}),define(le[182],he([0,1,4,111,180,3,181,32]),function(G,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class p extends k.$hr{constructor(m){super(),this.O=m,this.onDidError=n.Event.None,this.watchers=new Set}async N(m){m=this.Z(m);const h=[],d=new Set(Array.from(this.watchers));for(const w of m){const f=this.W(w);f&&(0,r.$Bk)(f.request.excludes,w.excludes)&&(0,r.$Bk)(f.request.includes,w.includes)?d.delete(f):h.push(w)}h.length&&this.P(`Request to start watching: ${h.map(w=>this.M(w)).join(",")}`),d.size&&this.P(`Request to stop watching: ${Array.from(d).map(w=>this.M(w.request)).join(",")}`);for(const w of d)this.Y(w);for(const w of h)this.X(w)}W(m){for(const h of this.watchers)if(typeof m.correlationId=="number"||typeof h.request.correlationId=="number"){if(h.request.correlationId===m.correlationId)return h}else if((0,I.$Ag)(h.request.path,m.path,!R.$l))return h}X(m){const h=new T.$mr(m,this.O,w=>this.a.fire(w),()=>this.c.fire(m),w=>this.b.fire(w),this.R),d={request:m,instance:h};this.watchers.add(d)}async stop(){await super.stop();for(const m of this.watchers)this.Y(m)}Y(m){this.P("stopping file watcher",m),this.watchers.delete(m),m.instance.dispose()}Z(m){const h=new Map;for(const d of m){const w=R.$l?d.path:d.path.toLowerCase();let f=h.get(d.correlationId);f||(f=new Map,h.set(d.correlationId,f)),f.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(d)}`),f.set(w,d)}return Array.from(h.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(m){super.setVerboseLogging(m);for(const h of this.watchers)h.instance.setVerboseLogging(m)}P(m,h){this.R&&this.b.fire({type:"trace",message:this.bb(m,h)})}Q(m){this.b.fire({type:"warn",message:this.bb(m)})}bb(m,h){return h?`[File Watcher (node.js)] ${m} (${this.M(h.request)})`:`[File Watcher (node.js)] ${m}`}}e.$or=p}),define(le[183],he([0,1,61,182]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class k extends n.$4q{constructor(T,I,p){super(T,I,p),this.s()}r(T){return T.add(new r.$or(void 0))}}e.$pr=k}),define(le[184],he([0,1,11,44,160,61]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class T extends R.$5q{constructor(p,c,m){super(p,c,m),this.s()}r(p){const c=p.add(new k.$fr(n.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(c.onDidProcessExit(({code:m,signal:h})=>this.t(`terminated by itself with code ${m}, signal: ${h} (ETERM)`))),r.ProxyChannel.toService((0,r.$ji)(c.getChannel("watcher")))}}e.$gr=T}),define(le[98],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class n{constructor(...k){this.a=new Map;for(const[R,T]of k)this.set(R,T)}set(k,R){const T=this.a.get(k);return this.a.set(k,R),T}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$Ai=n}),define(le[185],he([0,1,8,15,2,83,174,6,98,108]),function(G,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const m=!1;class h extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class d{constructor(v=new p.$Ai,b=!1,$,P=m){this.i=v,this.j=b,this.k=$,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Bi,this),this._globalGraph=P?$?._globalGraph??new T.$sr(E=>E):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Oc)(this.h),this.h.clear();for(const v of this.g)(0,k.$Nc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,b){this.m();const $=this,P=new class extends d{dispose(){$.h.delete(P),super.dispose()}}(v,this.j,this,this.l);return this.h.add(P),b?.add(P),P}invokeFunction(v,...b){this.m();const $=f.traceInvocation(this.l,v);let P=!1;try{return v({get:t=>{if(P)throw(0,r.$7)("service accessor is only valid during the invocation of its target method");const u=this.s(t,$);if(!u)throw new Error(`[invokeFunction] unknown service '${t}'`);return u}},...b)}finally{P=!0,$.stop()}}createInstance(v,...b){this.m();let $,P;return v instanceof R.$zi?($=f.traceCreation(this.l,v.ctor),P=this.o(v.ctor,v.staticArguments.concat(b),$)):($=f.traceCreation(this.l,v),P=this.o(v,b,$)),$.stop(),P}o(v,b=[],$){const P=I._util.getServiceDependencies(v).sort((u,i)=>u.index-i.index),E=[];for(const u of P){const i=this.s(u.id,$);i||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${u.id}.`,!1),E.push(i)}const t=P.length>0?P[0].index:b.length;if(b.length!==t){console.trace(`[createInstance] First service dependency of ${v.name} at position ${t+1} conflicts with ${b.length} static arguments`);const u=t-b.length;u>0?b=b.concat(new Array(u)):b=b.slice(0,t)}return Reflect.construct(v,b.concat(E))}q(v,b){if(this.i.get(v)instanceof R.$zi)this.i.set(v,b);else if(this.k)this.k.q(v,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const b=this.i.get(v);return!b&&this.k?this.k.r(v):b}s(v,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const $=this.r(v);return $ instanceof R.$zi?this.u(v,$,b.branch(v,!0)):(b.branch(v,!1),$)}u(v,b,$){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,b,$)}finally{this.t.delete(v)}}v(v,b,$){const P=new T.$sr(i=>i.id.toString());let E=0;const t=[{id:v,desc:b,_trace:$}],u=new Set;for(;t.length;){const i=t.pop();if(!u.has(String(i.id))){if(u.add(String(i.id)),P.lookupOrInsertNode(i),E++>1e3)throw new h(P);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof R.$zi){const a={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};P.insertEdge(i,a),t.push(a)}}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new h(P);break}for(const{data:o}of i){if(this.r(o.id)instanceof R.$zi){const a=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,a)}P.removeNode(o)}}return this.r(v)}w(v,b,$=[],P,E){if(this.i.get(v)instanceof R.$zi)return this.x(v,b,$,P,E,this.g);if(this.k)return this.k.w(v,b,$,P,E);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(v,b,$=[],P,E,t){if(P){const u=new d(void 0,this.j,this,this.l);u.c=String(v);const i=new Map,o=new n.$Vh(()=>{const s=u.o(b,$,E);for(const[a,l]of i){const S=s[a];if(typeof S=="function")for(const y of l)y.disposable=S.apply(s,y.listener)}return i.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,a){if(!o.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let y=i.get(a);return y||(y=new c.$4c,i.set(a,y)),(L,A,O)=>{if(o.isInitialized)return o.value[a](L,A,O);{const W={listener:[L,A,O],disposable:void 0},V=y.push(W);return(0,k.$Rc)(()=>{V(),W.disposable?.dispose()})}}}if(a in s)return s[a];const l=o.value;let S=l[a];return typeof S!="function"||(S=S.bind(l),s[a]=S),S},set(s,a,l){return o.value[a]=l,!0},getPrototypeOf(s){return b.prototype}})}else{const u=this.o(b,$,E);return t.add(u),u}}y(v,b){if(b&&console.warn(v),this.j)throw new Error(v)}}e.$tr=d;var w;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(w||(w={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,b){return v?new f(w.Invocation,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(v,b){return v?new f(w.Creation,b.name):f.c}static{this.f=0}constructor(v,b){this.type=v,this.name=b,this.g=Date.now(),this.h=[]}branch(v,b){const $=new f(w.Branch,v.toString());return this.h.push([v,b,$]),$}stop(){const v=Date.now()-this.g;f.f+=v;let b=!1;function $(E,t){const u=[],i=new Array(E+1).join("	");for(const[o,s,a]of t.h)if(s&&a){b=!0,u.push(`${i}CREATES -> ${o}`);const l=$(E+1,a);l&&u.push(l)}else u.push(`${i}uses -> ${o}`);return u.join(`
`)}const P=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(v>2||b)&&f.all.add(P.join(`
`))}}e.$ur=f}),define(le[186],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=e.$z_b=e.IssueSource=e.IssueType=void 0;var r;(function(R){R[R.Bug=0]="Bug",R[R.PerformanceIssue=1]="PerformanceIssue",R[R.FeatureRequest=2]="FeatureRequest"})(r||(e.IssueType=r={}));var k;(function(R){R.VSCode="vscode",R.Extension="extension",R.Marketplace="marketplace"})(k||(e.IssueSource=k={})),e.$z_b=(0,n.$Ci)("issueService"),e.$A_b=(0,n.$Ci)("processService")}),define(le[5],he([0,1,10,54,4,46,2,31,3,18,12,7,122,6]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$ak=e.LogLevel=e.$$j=e.$0j=void 0,e.$_j=g,e.log=b,e.$lk=S,e.$mk=y,e.$nk=D,e.$ok=L,n=Ie(n),e.$0j=(0,w.$Ci)("logService"),e.$$j=(0,w.$Ci)("loggerService");function f(){return new Date().toISOString()}function g(A){return(0,m.$gg)(A)}var v;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$ak=v.Info;function b(A,O,W){switch(O){case v.Trace:A.trace(W);break;case v.Debug:A.debug(W);break;case v.Info:A.info(W);break;case v.Warning:A.warn(W);break;case v.Error:A.error(W);break;case v.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function $(A,O=!1){let W="";for(let V=0;V<A.length;V++){let H=A[V];if(H instanceof Error&&(H=(0,r.$nj)(H,O)),typeof H=="object")try{H=JSON.stringify(H)}catch{}W+=(V>0?" ":"")+H}return W}class P extends T.$Tc{constructor(){super(...arguments),this.b=e.$ak,this.c=this.B(new k.$je),this.onDidChangeLogLevel=this.c.event}setLevel(O){this.b!==O&&(this.b=O,this.c.fire(this.b))}getLevel(){return this.b}f(O){return this.b!==v.Off&&this.b<=O}}e.$ck=P;class E extends P{constructor(O){super(),this.h=O}f(O){return this.h||super.f(O)}trace(O,...W){this.f(v.Trace)&&this.g(v.Trace,$([O,...W],!0))}debug(O,...W){this.f(v.Debug)&&this.g(v.Debug,$([O,...W]))}info(O,...W){this.f(v.Info)&&this.g(v.Info,$([O,...W]))}warn(O,...W){this.f(v.Warning)&&this.g(v.Warning,$([O,...W]))}error(O,...W){if(this.f(v.Error))if(O instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=O.stack,this.g(v.Error,$(V))}else this.g(v.Error,$([O,...W]))}flush(){}}e.$dk=E;class t extends P{constructor(O=e.$ak){super(),this.setLevel(O),this.g=!p.$j}trace(O,...W){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...W):console.log(`[main ${f()}]`,O,...W))}debug(O,...W){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...W):console.log(`[main ${f()}]`,O,...W))}info(O,...W){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...W):console.log(`[main ${f()}]`,O,...W))}warn(O,...W){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,O,...W):console.warn(`[main ${f()}]`,O,...W))}error(O,...W){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,O,...W):console.error(`[main ${f()}]`,O,...W))}flush(){}}e.$ek=t;class u extends P{constructor(O=e.$ak,W=!0){super(),this.g=W,this.setLevel(O)}trace(O,...W){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",O,...W):console.log(O,...W))}debug(O,...W){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",O,...W):console.log(O,...W))}info(O,...W){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",O,...W):console.log(O,...W))}warn(O,...W){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",O,...W):console.log(O,...W))}error(O,...W){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",O,...W):console.error(O,...W))}flush(){}}e.$fk=u;class i extends P{constructor(O,W=e.$ak){super(),this.g=O,this.setLevel(W)}trace(O,...W){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(O),...W])}debug(O,...W){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(O),...W])}info(O,...W){this.f(v.Info)&&this.g.log(v.Info,[this.h(O),...W])}warn(O,...W){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(O),...W])}error(O,...W){this.f(v.Error)&&this.g.log(v.Error,[this.h(O),...W])}h(O){return typeof O=="string"?O:(0,r.$nj)(O,this.f(v.Trace))}flush(){}}e.$gk=i;class o extends P{constructor(O){super(),this.g=O,O.length&&this.setLevel(O[0].getLevel())}setLevel(O){for(const W of this.g)W.setLevel(O);super.setLevel(O)}trace(O,...W){for(const V of this.g)V.trace(O,...W)}debug(O,...W){for(const V of this.g)V.debug(O,...W)}info(O,...W){for(const V of this.g)V.info(O,...W)}warn(O,...W){for(const V of this.g)V.warn(O,...W)}error(O,...W){for(const V of this.g)V.error(O,...W)}flush(){for(const O of this.g)O.flush()}dispose(){for(const O of this.g)O.dispose();super.dispose()}}e.$hk=o;class s extends T.$Tc{constructor(O,W,V){if(super(),this.h=O,this.j=W,this.b=new I.$zc,this.c=this.B(new k.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$je),this.onDidChangeVisibility=this.g.event,V)for(const H of V)this.b.set(H.resource,{logger:void 0,info:H})}m(O){return(0,m.$cg)(O)?[...this.b.values()].find(W=>W.info.id===O):this.b.get(O)}getLogger(O){return this.m(O)?.logger}createLogger(O,W){const V=this.n(O),H=(0,m.$cg)(O)?O:W?.id??(0,R.$qj)(V.toString()).toString(16);let Y=this.b.get(V)?.logger;const Z=W?.logLevel==="always"?v.Trace:W?.logLevel;Y||(Y=this.s(V,Z??this.getLogLevel(V)??this.h,{...W,id:H}));const U={logger:Y,info:{resource:V,id:H,logLevel:Z,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(U.info),this.b.set(V,U),Y}n(O){return(0,m.$cg)(O)?(0,c.$dh)(this.j,`${O}.log`):O}setLogLevel(O,W){if(h.URI.isUri(O)){const V=O,H=W,Y=this.b.get(V);Y&&H!==Y.info.logLevel&&(Y.info.logLevel=H===this.h?void 0:H,Y.logger?.setLevel(H),this.b.set(Y.info.resource,Y),this.f.fire([V,H]))}else{this.h=O;for(const[V,H]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&H.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(O,W){const V=this.m(O);V&&W!==!V.info.hidden&&(V.info.hidden=!W,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,W]))}getLogLevel(O){let W;return O&&(W=this.b.get(O)?.info.logLevel),W??this.h}registerLogger(O){const W=this.b.get(O.resource);W?W.info.hidden!==O.hidden&&this.setVisibility(O.resource,!O.hidden):(this.b.set(O.resource,{info:O,logger:void 0}),this.c.fire({added:[O],removed:[]}))}deregisterLogger(O){const W=this.b.get(O);W&&(W.logger&&W.logger.dispose(),this.b.delete(O),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const O of this.b.values())yield O.info}getRegisteredLogger(O){return this.b.get(O)?.info}dispose(){this.b.forEach(O=>O.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ik=s;class a{constructor(){this.onDidChangeLogLevel=new k.$je().event}setLevel(O){}getLevel(){return v.Info}trace(O,...W){}debug(O,...W){}info(O,...W){}warn(O,...W){}error(O,...W){}critical(O,...W){}dispose(){}flush(){}}e.$jk=a;class l extends a{}e.$kk=l;function S(A){if(A.verbose)return v.Trace;if(typeof A.logLevel=="string"){const O=L(A.logLevel.toLowerCase());if(O!==void 0)return O}return e.$ak}function y(A){switch(A){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function D(A){switch(A){case v.Trace:return{original:"Trace",value:n.localize(11183,null)};case v.Debug:return{original:"Debug",value:n.localize(11184,null)};case v.Info:return{original:"Info",value:n.localize(11185,null)};case v.Warning:return{original:"Warning",value:n.localize(11186,null)};case v.Error:return{original:"Error",value:n.localize(11187,null)};case v.Off:return{original:"Off",value:n.localize(11188,null)}}}function L(A){switch(A){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$pk=new d.$Tj("logLevel",y(v.Info))});var oe=this&&this.__param||function(G,e){return function(n,r){e(n,r,G)}};define(le[187],he([0,1,13,3,97,5]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;const T=n.safeStorage;let I=class{constructor(c){this.a=c,n.app.commandLine.getSwitchValue("password-store")===k.PasswordStoreCLIOption.basic&&T.setUsePlainTextEncryption?.(!0)}async encrypt(c){this.a.trace("[EncryptionMainService] Encrypting value.");try{const m=JSON.stringify(T.encryptString(c));return this.a.trace("[EncryptionMainService] Encrypted value."),m}catch(m){throw this.a.error(m),m}}async decrypt(c){let m;try{if(m=JSON.parse(c),!m.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${c}`);const h=Buffer.from(m.data);this.a.trace("[EncryptionMainService] Decrypting value.");const d=T.decryptString(h);return this.a.trace("[EncryptionMainService] Decrypted value."),d}catch(h){throw this.a.error(h),h}}isEncryptionAvailable(){return Promise.resolve(T.isEncryptionAvailable())}getKeyStorageProvider(){if(r.$j)return Promise.resolve(k.KnownStorageProvider.dplib);if(r.$k)return Promise.resolve(k.KnownStorageProvider.keychainAccess);if(T.getSelectedStorageBackend)try{const c=T.getSelectedStorageBackend();return Promise.resolve(c)}catch(c){this.a.error(c)}return Promise.resolve(k.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!T.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");T.setUsePlainTextEncryption(!0)}};e.$Ofc=I,e.$Ofc=I=Ee([oe(0,R.$0j)],I)}),define(le[188],he([0,1,21,8,15,4,32,2,9,61,5]),function(G,e,n,r,k,R,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class h extends I.$Tc{constructor(w,f){super(),this.a=w,this.b=f,this.c=this.B(new R.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Ah(0)),this.w=[],this.y=this.B(new r.$Ah(0))}watch(w,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(w,f):this.z(w,f)}n(w,f){const g={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.j,g);return this.r(),(0,I.$Rc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,k.$Y)(w))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,c.$6q)(f)),f=>this.G(f),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const f of this.j)(0,c.$2q)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const f of this.j)(0,c.$2q)(f)&&w.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,f){const g={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.w,g);return this.C(),(0,I.$Rc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,k.$Y)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,c.$6q)(w)),w=>this.G(w),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,p.$gc)(w.fsPath)}J(w){const f=this.I(w);return(0,T.$Eg)(f)}}e.$_q=h}),define(le[189],he([0,1,21,8,17,22,4,46,77,2,60,11,70,18,67,10,14,124,5,15]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;let t=class extends c.$Tc{static{E=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$je),this.Y=this.B(new T.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Lh)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${i}`);const s=new c.$Sc;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),s.add(o.onDidChangeFile(a=>{const l=new v.$ql(a,!this.S(o));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(a=>this.Z.fire(new Error(a)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,c.$Rc)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,c.$Oc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(s){o.push(s)}}),!this.h.has(i)&&await r.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return p.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,w.$hh)(i))throw new v.$sl((0,g.localize)(11256,null,this.sb(i)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const s=new P.$ab;throw s.message=(0,g.localize)(11257,null,i.toString()),s}return o}async m(i){const o=await this.j(i);if((0,v.$dl)(o)||(0,v.$al)(o)||(0,v.$el)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const o=await this.j(i);if((0,v.$dl)(o)||(0,v.$al)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.s(i,o)}catch(s){throw(0,v.$nl)(s)===v.FileSystemProviderErrorCode.FileNotFound?new v.$sl((0,g.localize)(11258,null,this.sb(i)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$ll)(s)}}async s(i,o){const s=await this.j(i),a=this.S(s),l=o?.resolveTo,S=o?.resolveSingleChildDescendants,y=o?.resolveMetadata,D=await s.stat(i);let L;return this.t(s,i,D,void 0,!!y,(A,O)=>(L||(L=m.$Ii.forUris(()=>!a),L.set(i,!0),l&&L.fill(!0,l)),L.get(A.resource)||L.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&S?O===1:!1))}async t(i,o,s,a,l,S){const{providerExtUri:y}=this.R(i),D={resource:o,name:y.basename(o),isFile:(s.type&v.FileType.File)!==0,isDirectory:(s.type&v.FileType.Directory)!==0,isSymbolicLink:(s.type&v.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&v.FilePermission.Readonly)||!!(i.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Dl)({mtime:s.mtime,size:s.size}),children:void 0};if(D.isDirectory&&S(D,a)){try{const L=await i.readdir(o),A=await r.Promises.settled(L.map(async([O,W])=>{try{const V=y.joinPath(o,O),H=l?await i.stat(V):{type:W};return await this.t(i,V,H,L.length,l,S)}catch(V){return this.b.trace(V),null}}));D.children=(0,n.$Gb)(A)}catch(L){this.b.trace(L),D.children=[]}return D}return D}async resolveAll(i){return r.Promises.settled(i.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),s=await o.stat(i);return this.t(o,i,s,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.u(i,o)}catch(s){return s}return!0}async u(i,o){if(!o?.overwrite&&await this.exists(i))throw new v.$sl((0,g.localize)(11259,null,this.sb(i)),v.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(i,o=k.$Le.fromString(""),s){await this.u(i,s);const a=await this.writeFile(i,o);return this.r.fire(new v.$pl(i,v.FileOperation.CREATE,a)),a}async writeFile(i,o,s){const a=this.qb(await this.n(i),i),{providerExtUri:l}=this.R(a);let S=s;if((0,v.$gl)(a)&&!S?.atomic){const y=a.enforceAtomicWriteFile?.(i);y&&(S={...s,atomic:y})}try{await this.w(a,i,S)||await this.U(a,l.dirname(i));let D;if((0,v.$al)(a)&&!(o instanceof k.$Le))if((0,f.$xe)(o)){const L=await(0,f.$Ee)(o,3);L.ended?D=k.$Le.concat(L.buffer):D=L}else D=(0,f.$Be)(o,L=>k.$Le.concat(L),3);else D=o;!(0,v.$dl)(a)||(0,v.$al)(a)&&D instanceof k.$Le||(0,v.$al)(a)&&(0,v.$gl)(a)&&S?.atomic?await this.hb(a,i,S,D):await this.db(a,i,S,D instanceof k.$Le?(0,k.$We)(D):D),this.r.fire(new v.$pl(i,v.FileOperation.WRITE))}catch(y){throw new v.$sl((0,g.localize)(11260,null,this.sb(i),(0,v.$ll)(y).toString()),(0,v.$ol)(y),S)}return this.resolve(i,{resolveMetadata:!0})}async w(i,o,s){const a=!!s?.unlock;if(a&&!(i.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(11261,null,this.sb(o)));if(!!s?.atomic){if(!(i.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(11262,null,this.sb(o)));if(!(i.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(11263,null,this.sb(o)));if(a)throw new Error((0,g.localize)(11264,null,this.sb(o)))}let S;try{S=await i.stat(o)}catch{return}if(S.type&v.FileType.Directory)throw new v.$sl((0,g.localize)(11265,null,this.sb(o)),v.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(o,S),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==v.$Cl&&typeof S.mtime=="number"&&typeof S.size=="number"&&s.mtime<S.mtime&&s.etag!==(0,v.$Dl)({mtime:s.mtime,size:S.size}))throw new v.$sl((0,g.localize)(11266,null),v.FileOperationResult.FILE_MODIFIED_SINCE,s);return S}async readFile(i,o,s){const a=await this.m(i);return o?.atomic?this.z(a,i,o,s):this.C(a,i,o,s)}async z(i,o,s,a){return new Promise((l,S)=>{this.cb.queueFor(o,async()=>{try{const y=await this.C(i,o,s,a);l(y)}catch(y){S(y)}},this.R(i).providerExtUri)})}async C(i,o,s,a){const l=await this.D(i,o,{...s,preferUnbuffered:!0},a);return{...l,value:await(0,k.$Xe)(l.value)}}async readFileStream(i,o,s){const a=await this.m(i);return this.D(a,i,o,s)}async D(i,o,s,a){const l=new R.$ue(a);let S=s;(0,v.$fl)(i)&&i.enforceAtomicReadFile?.(o)&&(S={...s,atomic:!0});const y=this.J(o,S).then(L=>L,L=>{throw l.dispose(!0),L});let D;try{return typeof S?.etag=="string"&&S.etag!==v.$Cl&&await y,S?.atomic&&(0,v.$fl)(i)||!((0,v.$dl)(i)||(0,v.$el)(i))||(0,v.$al)(i)&&S?.preferUnbuffered?D=this.I(i,o,S):(0,v.$el)(i)?D=this.G(i,o,l.token,S):D=this.H(i,o,l.token,S),D.on("end",()=>l.dispose()),D.on("error",()=>l.dispose()),{...await y,value:D}}catch(L){throw D&&await(0,f.$Ce)(D),this.F(L,o,S)}}F(i,o,s){const a=(0,g.localize)(11267,null,this.sb(o),(0,v.$ll)(i).toString());return i instanceof v.$ul?new v.$ul(a,i.stat,s):i instanceof v.$tl?new v.$tl(a,i.fileOperationResult,i.size,i.options):new v.$sl(a,(0,v.$ol)(i),s)}G(i,o,s,a=Object.create(null)){const l=i.readFileStream(o,a,s);return(0,f.$Ie)(l,{data:S=>S instanceof k.$Le?S:k.$Le.wrap(S),error:S=>this.F(S,o,a)},S=>k.$Le.concat(S))}H(i,o,s,a=Object.create(null)){const l=(0,k.$2e)();return(0,b.$Yq)(i,o,l,S=>S,{...a,bufferSize:this.a,errorTransformer:S=>this.F(S,o,a)},s),l}I(i,o,s){const a=(0,f.$ze)(l=>k.$Le.concat(l));return(async()=>{try{let l;s?.atomic&&(0,v.$fl)(i)?l=await i.readFile(o,{atomic:!0}):l=await i.readFile(o),typeof s?.position=="number"&&(l=l.slice(s.position)),typeof s?.length=="number"&&(l=l.slice(0,s.length)),this.L(o,l.byteLength,s),a.end(k.$Le.wrap(l))}catch(l){a.error(l),a.end()}})(),a}async J(i,o){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new v.$sl((0,g.localize)(11268,null,this.sb(i)),v.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==v.$Cl&&o.etag===s.etag)throw new v.$ul((0,g.localize)(11269,null),s,o);return this.L(i,s.size,o),s}L(i,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new v.$tl((0,g.localize)(11270,null,this.sb(i)),v.FileOperationResult.FILE_TOO_LARGE,o,s)}async canMove(i,o,s){return this.M(i,o,"move",s)}async canCopy(i,o,s){return this.M(i,o,"copy",s)}async M(i,o,s,a){if(i.toString()!==o.toString())try{const l=s==="move"?this.qb(await this.n(i),i):await this.m(i),S=this.qb(await this.n(o),o);await this.Q(l,i,S,o,s,a)}catch(l){return l}return!0}async move(i,o,s){const a=this.qb(await this.n(i),i),l=this.qb(await this.n(o),o),S=await this.N(a,i,l,o,"move",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$pl(i,S==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,y)),y}async copy(i,o,s){const a=await this.m(i),l=this.qb(await this.n(o),o),S=await this.N(a,i,l,o,"copy",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$pl(i,S==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,y)),y}async N(i,o,s,a,l,S){if(o.toString()===a.toString())return l;const{exists:y,isSameResourceWithDifferentPathCase:D}=await this.Q(i,o,s,a,l,S);if(y&&!D&&S&&await this.del(a,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(a)),l==="copy"){if(i===s&&(0,v.$bl)(i))await i.copy(o,a,{overwrite:S});else{const L=await this.resolve(o);L.isDirectory?await this.P(i,L,s,a):await this.O(i,o,s,a)}return l}else return i===s?(await i.rename(o,a,{overwrite:S}),l):(await this.N(i,o,s,a,"copy",S),await this.del(o,{recursive:!0}),"copy")}async O(i,o,s,a){if((0,v.$dl)(i)&&(0,v.$dl)(s))return this.jb(i,o,s,a);if((0,v.$dl)(i)&&(0,v.$al)(s))return this.pb(i,o,s,a);if((0,v.$al)(i)&&(0,v.$dl)(s))return this.nb(i,o,s,a);if((0,v.$al)(i)&&(0,v.$al)(s))return this.lb(i,o,s,a)}async P(i,o,s,a){await s.mkdir(a),Array.isArray(o.children)&&await r.Promises.settled(o.children.map(async l=>{const S=this.R(s).providerExtUri.joinPath(a,l.name);return l.isDirectory?this.P(i,await this.resolve(l.resource),s,S):this.O(i,l.resource,s,S)}))}async Q(i,o,s,a,l,S){let y=!1;if(i===s){const{providerExtUri:L,isPathCaseSensitive:A}=this.R(i);if(A||(y=L.isEqual(o,a)),y&&l==="copy")throw new Error((0,g.localize)(11271,null,this.sb(o),this.sb(a)));if(!y&&L.isEqualOrParent(a,o))throw new Error((0,g.localize)(11272,null,this.sb(o),this.sb(a)))}const D=await this.exists(a);if(D&&!y){if(!S)throw new v.$sl((0,g.localize)(11273,null,this.sb(o),this.sb(a)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(i===s){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(o,a))throw new Error((0,g.localize)(11274,null,this.sb(o),this.sb(a)))}}return{exists:D,isSameResourceWithDifferentPathCase:y}}R(i){const o=this.S(i);return{providerExtUri:o?w.$6g:w.$8g,isPathCaseSensitive:o}}S(i){return!!(i.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const o=this.qb(await this.j(i),i);await this.U(o,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new v.$pl(i,v.FileOperation.CREATE,s)),s}async U(i,o){const s=[],{providerExtUri:a}=this.R(i);for(;!a.isEqual(o,a.dirname(o));)try{if(!((await i.stat(o)).type&v.FileType.Directory))throw new Error((0,g.localize)(11275,null,this.sb(o)));break}catch(l){if((0,v.$nl)(l)!==v.FileSystemProviderErrorCode.FileNotFound)throw l;s.push(a.basename(o)),o=a.dirname(o)}for(let l=s.length-1;l>=0;l--){o=a.joinPath(o,s[l]);try{await i.mkdir(o)}catch(S){if((0,v.$nl)(S)!==v.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(i,o){try{await this.W(i,o)}catch(s){return s}return!0}async W(i,o){const s=this.qb(await this.j(i),i),a=!!o?.useTrash;if(a&&!(s.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(11276,null,this.sb(i)));const l=o?.atomic;if(l&&!(s.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(11277,null,this.sb(i)));if(a&&l)throw new Error((0,g.localize)(11278,null,this.sb(i)));let S;try{S=await s.stat(i)}catch{}if(S)this.rb(i,S);else throw new v.$sl((0,g.localize)(11279,null,this.sb(i)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const D=await this.resolve(i);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,g.localize)(11280,null,this.sb(i)))}return s}async del(i,o){const s=await this.W(i,o);let a=o;if((0,v.$hl)(s)&&!a?.atomic){const D=s.enforceAtomicDelete?.(i);D&&(a={...o,atomic:D})}const l=!!a?.useTrash,S=!!a?.recursive,y=a?.atomic??!1;await s.delete(i,{recursive:S,useTrash:l,atomic:y}),this.r.fire(new v.$pl(i,v.FileOperation.DELETE))}async cloneFile(i,o){const s=await this.j(i),a=this.qb(await this.n(o),o);if(!(s===a&&this.R(s).providerExtUri.isEqual(i,o)))return s===a&&(0,v.$cl)(s)?s.cloneFile(i,o):(await this.U(a,this.R(a).providerExtUri.dirname(o)),s===a&&(0,v.$bl)(s)?this.cb.queueFor(i,()=>s.copy(i,o,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(i,()=>this.O(s,i,a,o),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(i,o){return this.watch(i,{...o,correlationId:E.ab++})}watch(i,o={recursive:!1,excludes:[]}){const s=new c.$Sc;let a=!1,l=()=>{a=!0};s.add((0,c.$Rc)(()=>l())),(async()=>{try{const y=await this.bb(i,o);a?(0,c.$Oc)(y):l=()=>(0,c.$Oc)(y)}catch(y){this.b.error(y)}})();const S=o.correlationId;if(typeof S=="number"){const y=s.add(new T.$je);return s.add(this.X.event(L=>{L.correlates(S)&&y.fire(L)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(i,o){const s=await this.j(i),a=(0,I.$qj)([this.R(s).providerExtUri.getComparisonKey(i),o]);let l=this.$.get(a);return l||(l={count:0,disposable:s.watch(i,o)},this.$.set(a,l)),l.count+=1,(0,c.$Rc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Oc)(l.disposable),this.$.delete(a)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,c.$Oc)(i.disposable);this.$.clear()}async db(i,o,s,a){return this.cb.queueFor(o,async()=>{const l=await i.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,f.$xe)(a)||(0,f.$ye)(a)?await this.eb(i,l,a):await this.fb(i,l,a)}catch(S){throw(0,v.$ll)(S)}finally{await i.close(l)}},this.R(i).providerExtUri)}async eb(i,o,s){let a=0,l;if((0,f.$ye)(s)){if(s.buffer.length>0){const S=k.$Le.concat(s.buffer);await this.gb(i,o,S,S.byteLength,a,0),a+=S.byteLength}if(s.ended)return;l=s.stream}else l=s;return new Promise((S,y)=>{(0,f.$De)(l,{onData:async D=>{l.pause();try{await this.gb(i,o,D,D.byteLength,a,0)}catch(L){return y(L)}a+=D.byteLength,setTimeout(()=>l.resume())},onError:D=>y(D),onEnd:()=>S()})})}async fb(i,o,s){let a=0,l;for(;(l=s.read())!==null;)await this.gb(i,o,l,l.byteLength,a,0),a+=l.byteLength}async gb(i,o,s,a,l,S){let y=0;for(;y<a;){const D=await i.write(o,l+y,s.buffer,S+y,a-y);y+=D}}async hb(i,o,s,a){return this.cb.queueFor(o,()=>this.ib(i,o,s,a),this.R(i).providerExtUri)}async ib(i,o,s,a){let l;a instanceof k.$Le?l=a:(0,f.$xe)(a)?l=await(0,k.$Xe)(a):(0,f.$ye)(a)?l=await(0,k.$Ye)(a):l=(0,k.$Ve)(a),await i.writeFile(o,l.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,o,s,a){return this.cb.queueFor(a,()=>this.kb(i,o,s,a),this.R(s).providerExtUri)}async kb(i,o,s,a){let l,S;try{l=await i.open(o,{create:!1}),S=await s.open(a,{create:!0,unlock:!1});const y=k.$Le.alloc(this.a);let D=0,L=0,A=0;do A=await i.read(l,D,y.buffer,L,y.byteLength-L),await this.gb(s,S,y,A,D,L),D+=A,L+=A,L===y.byteLength&&(L=0);while(A>0)}catch(y){throw(0,v.$ll)(y)}finally{await r.Promises.settled([typeof l=="number"?i.close(l):Promise.resolve(),typeof S=="number"?s.close(S):Promise.resolve()])}}async lb(i,o,s,a){return this.cb.queueFor(a,()=>this.mb(i,o,s,a),this.R(s).providerExtUri)}async mb(i,o,s,a){return s.writeFile(a,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,o,s,a){return this.cb.queueFor(a,()=>this.ob(i,o,s,a),this.R(s).providerExtUri)}async ob(i,o,s,a){const l=await s.open(a,{create:!0,unlock:!1});try{const S=await i.readFile(o);await this.gb(s,l,k.$Le.wrap(S),S.byteLength,0,0)}catch(S){throw(0,v.$ll)(S)}finally{await s.close(l)}}async pb(i,o,s,a){const l=await(0,k.$Xe)(this.H(i,o,R.CancellationToken.None));await this.hb(s,a,void 0,l)}qb(i,o){if(i.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$sl((0,g.localize)(11281,null,this.sb(o)),v.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,o){if((o.permissions??0)&v.FilePermission.Readonly)throw new v.$sl((0,g.localize)(11282,null,this.sb(i)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===h.Schemas.file?i.fsPath:i.toString(!0)}};e.$Zq=t,e.$Zq=t=E=Ee([oe(0,$.$0j)],t)}),define(le[99],he([0,1,26,8,31,17,4,32,2,9,3,18,67,23,10,14,124,188,184,183]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class E extends b.$_q{static{this.L=!1}constructor(u,i){super(u,i),this.onDidChangeCapabilities=T.Event.None,this.P=new k.$zc(o=>h.$7g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,m.$l&&(this.M|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(u){try{const{stat:i,symbolicLink:o}=await w.SymlinkSupport.stat(this.I(u));return{type:this.O(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const i=await w.Promises.readdir(this.I(u),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,h.$dh)(u,s.name))).type:a=this.O(s),o.push([s.name,a])}catch(a){this.a.trace(a)}})),o}catch(i){throw this.hb(i)}}O(u,i){let o;return i?.dangling?o=g.FileType.Unknown:u.isFile()?o=g.FileType.File:u.isDirectory()?o=g.FileType.Directory:o=g.FileType.Unknown,i&&(o|=g.FileType.SymbolicLink),o}async Q(u){const i=this.I(u);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.P.get(u);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const s=new r.$Bh;return this.P.set(u,s),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,p.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(u)===s&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(u)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),s.open()})}async readFile(u,i){let o;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(u)})`),o=await this.Q(u));const s=this.I(u);return await n.promises.readFile(s)}catch(s){throw this.hb(s)}finally{o?.dispose()}}R(u){E.L&&this.a.trace(u)}readFileStream(u,i,o){const s=(0,d.$ze)(a=>R.$Le.concat(a.map(l=>R.$Le.wrap(l))).buffer);return(0,v.$Yq)(this,u,s,a=>a.buffer,{...i,bufferSize:256*1024},o),s}async writeFile(u,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(u)?this.U(u,(0,h.$dh)((0,h.$ch)(u),`${(0,h.$ah)(u)}${o.atomic.postfix}`),i,o):this.W(u,i,o)}async S(u){try{const i=this.I(u),{symbolicLink:o}=await w.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async U(u,i,o,s){const a=new p.$Sc;try{a.add(await this.Q(u)),a.add(await this.Q(i)),await this.W(i,o,s,!0);try{await this.rename(i,u,{overwrite:!0})}catch(l){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{a.dispose()}}async W(u,i,o,s){let a;try{const l=this.I(u);if(!o.create||!o.overwrite){if(await w.Promises.exists(l)){if(!o.overwrite)throw(0,g.$kl)((0,f.localize)(11240,null),g.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,g.$kl)((0,f.localize)(11241,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(u,{create:!0,unlock:o.unlock},s),await this.write(a,0,i,0,i.byteLength)}catch(l){throw await this.ib(u,l)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(u){E.$=u}async open(u,i,o){const s=this.I(u);let a;(0,g.$$k)(i)&&!o&&(a=await this.Q(u));let l;try{if((0,g.$$k)(i)&&i.unlock)try{const{stat:y}=await w.SymlinkSupport.stat(s);y.mode&128||await n.promises.chmod(s,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let S;if((0,g.$$k)(i)){if(m.$j)try{await n.promises.truncate(s,0),S="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}S||(S="w")}else S="r";l=await w.Promises.open(s,S)}catch(S){throw a?.dispose(),(0,g.$$k)(i)?await this.ib(u,S):this.hb(S)}if(this.X.set(l,0),(0,g.$$k)(i)&&this.Z.set(l,u),a){const S=this.Y.get(l);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.Y.set(l,a),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),S.dispose())}return l}async close(u){const i=this.Y.get(u);try{if(this.X.delete(u),this.Z.delete(u)&&E.$)try{await w.Promises.fdatasync(u)}catch(o){E.configureFlushOnWrite(!1),this.a.error(o)}return await w.Promises.close(u)}catch(o){throw this.hb(o)}finally{i&&(this.Y.get(u)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.Y.delete(u)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),i.dispose())}}async read(u,i,o,s,a){const l=this.ab(u,i);let S=null;try{S=(await w.Promises.read(u,o,s,a,l)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(u,l,S)}return S}ab(u,i){return i===this.X.get(u)?null:i}bb(u,i,o){const s=this.X.get(u);typeof s=="number"&&(typeof i=="number"||(typeof o=="number"?this.X.set(u,s+o):this.X.delete(u)))}async write(u,i,o,s,a){return(0,r.$Wh)(()=>this.cb(u,i,o,s,a),100,3)}async cb(u,i,o,s,a){const l=this.ab(u,i);let S=null;try{S=(await w.Promises.write(u,o,s,a,l)).bytesWritten}catch(y){throw await this.ib(this.Z.get(u),y)}finally{this.bb(u,l,S)}return S}async mkdir(u){try{await n.promises.mkdir(this.I(u))}catch(i){throw this.hb(i)}}async delete(u,i){try{const o=this.I(u);if(i.recursive){let s;i?.atomic!==!1&&i.atomic.postfix&&(s=(0,c.$ic)((0,c.$lc)(o),`${(0,c.$mc)(o)}${i.atomic.postfix}`)),await w.Promises.rm(o,w.RimRafMode.MOVE,s)}else try{await n.promises.unlink(o)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let a=!1;try{const{stat:l,symbolicLink:S}=await w.SymlinkSupport.stat(o);a=l.isDirectory()&&!S}catch{}if(a)await n.promises.rmdir(o);else throw s}else throw s}}catch(o){throw this.hb(o)}}async rename(u,i,o){const s=this.I(u),a=this.I(i);if(s!==a)try{await this.db(u,i,"move",o.overwrite),await w.Promises.rename(s,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11242,null,(0,c.$mc)(s),(0,c.$mc)((0,c.$lc)(a)),l.toString()))),this.hb(l)}}async copy(u,i,o){const s=this.I(u),a=this.I(i);if(s!==a)try{await this.db(u,i,"copy",o.overwrite),await w.Promises.copy(s,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11243,null,(0,c.$mc)(s),(0,c.$mc)((0,c.$lc)(a)),l.toString()))),this.hb(l)}}async db(u,i,o,s){const a=this.I(u),l=this.I(i);let S=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(S=(0,I.$Ag)(a,l,!0)),S){if(o==="copy")throw(0,g.$kl)((0,f.localize)(11244,null),g.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const D=await this.N(u);if(!D)throw(0,g.$kl)((0,f.localize)(11245,null),g.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(i);if(L){if(!s)throw(0,g.$kl)((0,f.localize)(11246,null),g.FileSystemProviderErrorCode.FileExists);D.type&g.FileType.File&&L.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,i){return this.eb(u,i,!1)}async eb(u,i,o){const s=this.I(u),a=this.I(i),l=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,I.$Ag)(s,a,!l))return;const S=new p.$Sc;try{S.add(await this.Q(u)),S.add(await this.Q(i)),o&&await n.promises.mkdir((0,c.$lc)(a),{recursive:!0}),await n.promises.copyFile(s,a)}catch(y){if(y.code==="ENOENT"&&!o)return this.eb(u,i,!0);throw this.hb(y)}finally{S.dispose()}}t(u,i,o){return new $.$gr(s=>u(s),s=>i(s),o)}F(u,i,o){return new P.$pr(s=>u(s),s=>i(s),o)}hb(u){if(u instanceof g.$jl)return u;let i=u,o;switch(u.code){case"ENOENT":o=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=g.FileSystemProviderErrorCode.Unknown;break;default:o=g.FileSystemProviderErrorCode.Unknown}return(0,g.$kl)(i,o)}async ib(u,i){let o=this.hb(i);if(u&&o.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await w.SymlinkSupport.stat(this.I(u));s.mode&128||(o=(0,g.$kl)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.a.trace(s)}return o}}e.$qr=E}),define(le[190],he([0,1,4,99,2,17,67,22]),function(G,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=void 0;class p extends k.$Tc{constructor(h,d){super(),this.a=h,this.b=d,this.F=new Map,this.G=new Map}call(h,d,w){const f=this.c(h);switch(d){case"stat":return this.g(f,w[0]);case"readdir":return this.h(f,w[0]);case"open":return this.r(f,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(f,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(f,w[0],w[1],w[2]);case"rename":return this.z(f,w[0],w[1],w[2]);case"copy":return this.C(f,w[0],w[1],w[2]);case"cloneFile":return this.D(f,w[0],w[1]);case"mkdir":return this.w(f,w[0]);case"delete":return this.y(f,w[0],w[1]);case"watch":return this.I(f,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${d} not found`)}listen(h,d,w){const f=this.c(h);switch(d){case"fileChange":return this.H(f,w[0]);case"readFileStream":return this.m(f,w[0],w[1])}throw new Error(`Unknown event ${d}`)}g(h,d){const w=this.f(h,d,!0);return this.a.stat(w)}h(h,d){const w=this.f(h,d);return this.a.readdir(w)}async j(h,d,w){const f=this.f(h,d,!0),g=await this.a.readFile(f,w);return R.$Le.wrap(g)}m(h,d,w){const f=this.f(h,d,!0),g=new I.$ue,v=new n.$je({onDidRemoveLastListener:()=>{g.cancel()}}),b=this.a.readFileStream(f,w,g.token);return(0,T.$De)(b,{onData:$=>v.fire(R.$Le.wrap($)),onError:$=>v.fire($),onEnd:()=>{v.fire("end"),v.dispose(),g.dispose()}}),v.event}n(h,d,w,f){const g=this.f(h,d);return this.a.writeFile(g,w.buffer,f)}r(h,d,w){const f=this.f(h,d,!0);return this.a.open(f,w)}s(h){return this.a.close(h)}async t(h,d,w){const f=R.$Le.alloc(w),v=await this.a.read(h,d,f.buffer,0,w);return[f,v]}u(h,d,w,f,g){return this.a.write(h,d,w.buffer,f,g)}w(h,d){const w=this.f(h,d);return this.a.mkdir(w)}y(h,d,w){const f=this.f(h,d);return this.a.delete(f,w)}z(h,d,w,f){const g=this.f(h,d),v=this.f(h,w);return this.a.rename(g,v,f)}C(h,d,w,f){const g=this.f(h,d),v=this.f(h,w);return this.a.copy(g,v,f)}D(h,d,w){const f=this.f(h,d),g=this.f(h,w);return this.a.cloneFile(f,g)}H(h,d){const w=new n.$je({onWillAddFirstListener:()=>{this.F.set(d,this.L(h,w))},onDidRemoveLastListener:()=>{(0,k.$Oc)(this.F.get(d)),this.F.delete(d)}});return w.event}async I(h,d,w,f,g){const v=this.F.get(d);if(v){const b=this.f(h,f),$=v.watch(w,b,g);this.G.set(d+w,$)}}async J(h,d){const w=h+d,f=this.G.get(w);f&&((0,k.$Oc)(f),this.G.delete(w))}dispose(){super.dispose();for(const[,h]of this.G)h.dispose();this.G.clear();for(const[,h]of this.F)h.dispose();this.F.clear()}}e.$1s=p;class c extends k.$Tc{constructor(h,d,w,f){super(),this.c=h,this.f=w,this.g=f,this.a=new Map,this.b=this.B(new r.$qr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(d)}h(h){const d=this.B(new n.$je);this.B(d.event(w=>{h.fire(w.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile(w=>d.fire(w))),this.B(this.b.onDidWatchError(w=>h.fire(w)))}j(h){}m(h){}watch(h,d,w){const f=this.m(this.g);return Array.isArray(f)&&(w.excludes=[...w.excludes,...f]),this.a.set(h,this.b.watch(d,w)),(0,k.$Rc)(()=>{(0,k.$Oc)(this.a.get(h)),this.a.delete(h)})}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),super.dispose()}}e.$2s=c}),define(le[191],he([0,1,13,10,3,7,14,9,190,151,54]),function(G,e,n,r,k,R,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=void 0;class h extends p.$1s{constructor(f,g,v){super(f,g),this.M=v}c(f){return c.$Kn}f(f,g){return R.URI.revive(g)}async y(f,g,v){if(!v.useTrash)return super.y(f,g,v);const b=this.f(f,g),$=(0,I.$gc)(b.fsPath);try{await n.shell.trashItem($)}catch(P){throw(0,T.$kl)(k.$j?(0,r.localize)(11247,null,(0,I.$mc)($),(0,m.$nj)(P)):(0,r.localize)(11248,null,(0,I.$mc)($),(0,m.$nj)(P)),T.FileSystemProviderErrorCode.Unknown)}}L(f,g){return new d(f,g,this.b,this.M)}}e.$Wfc=h;class d extends p.$2s{watch(f,g,v){if(v.recursive)throw(0,T.$kl)("Recursive file watching is not supported from main process for performance reasons.",T.FileSystemProviderErrorCode.Unavailable);return super.watch(f,g,v)}}}),define(le[192],he([0,1,5]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;class r extends n.$dk{constructor(R=n.$ak){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(T=>{this.n?.setLevel(T)}))}set logger(R){this.n=R;for(const{level:T,message:I}of this.m)(0,n.log)(R,T,I);this.m=[]}g(R,T){this.n?(0,n.log)(this.n,R,T):this.getLevel()<=R&&this.m.push({level:R,message:T})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$Ccc=r}),define(le[193],he([0,1,7,4,5,2]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=void 0;class T extends k.$ik{constructor(h,d,w,f,g){super(d,w,f),this.r=h,this.t=g,this.B(g.listen("onDidChangeLogLevel",h)(v=>{(0,k.$_j)(v)?super.setLogLevel(v):super.setLogLevel(n.URI.revive(v[0]),v[1])})),this.B(g.listen("onDidChangeVisibility",h)(([v,b])=>super.setVisibility(n.URI.revive(v),b))),this.B(g.listen("onDidChangeLoggers",h)(({added:v,removed:b})=>{for(const $ of v)super.registerLogger({...$,resource:n.URI.revive($.resource)});for(const $ of b)super.deregisterLogger($.resource)}))}createConsoleMainLogger(){return new k.$gk({log:(h,d)=>{this.t.call("consoleLog",[h,d])}})}registerLogger(h){super.registerLogger(h),this.t.call("registerLogger",[h,this.r])}deregisterLogger(h){super.deregisterLogger(h),this.t.call("deregisterLogger",[h,this.r])}setLogLevel(h,d){super.setLogLevel(h,d),this.t.call("setLogLevel",[h,d])}setVisibility(h,d){super.setVisibility(h,d),this.t.call("setVisibility",[this.n(h),d])}s(h,d,w){return new I(this.t,h,d,w,this.r)}static setLogLevel(h,d,w){return h.call("setLogLevel",[d,w])}}e.$qs=T;class I extends k.$dk{constructor(h,d,w,f,g){super(f?.logLevel==="always"),this.r=h,this.s=d,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[d,f,g]).then(()=>{this.u(this.n),this.m=!0})}g(h,d){const w=[[h,d]];this.m?this.u(w):this.n.push(...w)}u(h){this.r.call("log",[this.s,h])}}class p{constructor(h,d){this.a=h,this.b=d}listen(h,d){const w=this.b(h);switch(d){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(g=>this.c(g,w)),removed:[...f.removed].map(g=>this.c(g,w))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,f=>[w.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,f=>(0,k.$_j)(f)?f:[w.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${d}`)}async call(h,d,w){const f=this.b(h);switch(d){case"setLogLevel":return(0,k.$_j)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,f)))}throw new Error(`Call not found: ${d}`)}c(h,d){return{...h,resource:d.transformOutgoingURI(h.resource)}}}e.$rs=p;class c extends R.$Tc{constructor(h,d){super(),d.call("setLogLevel",[h.getLogLevel()]),this.B(h.onDidChangeLogLevel(w=>d.call("setLogLevel",[w]))),d.call("getRegisteredLoggers").then(w=>{for(const f of w)h.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(d.listen("onDidChangeVisibility")(([w,f])=>h.setVisibility(n.URI.revive(w),f))),this.B(d.listen("onDidChangeLoggers")(({added:w,removed:f})=>{for(const g of w)h.registerLogger({...g,resource:n.URI.revive(g.resource)});for(const g of f)h.deregisterLogger(g.resource)}))}}e.$ss=c}),define(le[194],he([0,1,2,5]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vR=void 0;class k extends n.$Tc{constructor(T,I=[]){super(),this.a=new r.$hk([T,...I]),this.B(T.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...I){this.a.trace(T,...I)}debug(T,...I){this.a.debug(T,...I)}info(T,...I){this.a.info(T,...I)}warn(T,...I){this.a.warn(T,...I)}error(T,...I){this.a.error(T,...I)}flush(){this.a.flush()}}e.$vR=k}),define(le[195],he([0,1,31,7,5]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class R{constructor(I){this.b=I,this.a=new n.$zc}listen(I,p,c){switch(p){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${p}`)}async call(I,p,c){switch(p){case"createLogger":this.c(r.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(r.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,k.$_j)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(r.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:r.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(c[0]))}throw new Error(`Call not found: ${p}`)}c(I,p,c){this.a.set(I,this.b.createLogger(I,p,c))}d(I,p){let c=console.log;switch(I){case k.LogLevel.Error:c=console.error;break;case k.LogLevel.Warning:c=console.warn;break;case k.LogLevel.Info:c=console.info;break}c.call(console,...p)}e(I,p){const c=this.a.get(I);if(!c)throw new Error("Create the logger before logging");for(const[m,h]of p)(0,k.log)(c,m,h)}}e.$Ugc=R}),define(le[196],he([0,1,14,5]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kR=void 0;var k;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(k||(k={}));async function R(c,m,h,d,w){try{const f=await new Promise((v,b)=>{G(["@vscode/spdlog"],v,b)}).then(Ie);f.setFlushOn(k.Trace);const g=await f.createAsyncRotatingLogger(c,m,h,d);return w?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(f){console.error(f)}return null}function T(c,m,h){switch(m){case r.LogLevel.Trace:c.trace(h);break;case r.LogLevel.Debug:c.debug(h);break;case r.LogLevel.Info:c.info(h);break;case r.LogLevel.Warning:c.warn(h);break;case r.LogLevel.Error:c.error(h);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function I(c,m){switch(m){case r.LogLevel.Trace:c.setLevel(k.Trace);break;case r.LogLevel.Debug:c.setLevel(k.Debug);break;case r.LogLevel.Info:c.setLevel(k.Info);break;case r.LogLevel.Warning:c.setLevel(k.Warning);break;case r.LogLevel.Error:c.setLevel(k.Error);break;case r.LogLevel.Off:c.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class p extends r.$dk{constructor(m,h,d,w,f){super(),this.m=[],this.setLevel(f),this.n=this.s(m,h,d,w),this.B(this.onDidChangeLogLevel(g=>{this.r&&I(this.r,g)}))}async s(m,h,d,w){const f=d?6:1,g=30/f*n.$Fl.MB,v=await R(m,h,g,f,w);if(v){this.r=v,I(this.r,this.getLevel());for(const{level:b,message:$}of this.m)T(this.r,b,$);this.m=[]}}g(m,h){this.r?T(this.r,m,h):this.getLevel()<=m&&this.m.push({level:m,message:h})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$kR=p}),define(le[197],he([0,1,33,5,196]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lR=void 0;class R extends r.$ik{s(I,p,c){return new k.$kR((0,n.$Yg)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,p)}}e.$lR=R}),define(le[71],he([0,1,31,4,6,5,197]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=e.$qfc=void 0,e.$qfc=(0,k.$Di)(R.$$j);class I extends T.$lR{constructor(){super(...arguments),this.u=new n.$zc}createLogger(c,m,h){h!==void 0&&this.u.set(this.n(c),h);try{return super.createLogger(c,m)}catch(d){throw this.u.delete(this.n(c)),d}}registerLogger(c,m){m!==void 0&&this.u.set(c.resource,m),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const m=[];for(const h of super.getRegisteredLoggers())c===this.u.get(h.resource)&&m.push(h);return m}getOnDidChangeLogLevelEvent(c){return r.Event.filter(this.onDidChangeLogLevel,m=>(0,R.$_j)(m)||this.w(m[0],c))}getOnDidChangeVisibilityEvent(c){return r.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,c))}getOnDidChangeLoggersEvent(c){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(d=>this.w(d.resource,c)),removed:[...m.removed].filter(d=>this.w(d.resource,c))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(c){for(const[m,h]of this.u)h===c&&this.deregisterLogger(m)}w(c,m){const h=this.u.get(c);return h===void 0||h===m}dispose(){super.dispose(),this.u.clear()}}e.$rfc=I}),define(le[198],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=n,e.$_fc=r,e.$agc=k,e.$bgc=R;function n(T){return T.submenu!==void 0}function r(T){return T.id==="vscode.menubar.separator"}function k(T){return T.uri!==void 0}function R(T){return!n(T)&&!r(T)&&!k(T)}}),define(le[40],he([0,1,4,77,2,6]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=void 0,e.$qo=(0,R.$Ci)("policy");class T extends k.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const m=Object.keys(this.f).length;return this.f={...c,...this.f},m!==Object.keys(this.f).length&&await this.j(c),r.Iterable.reduce(this.g.entries(),(h,[d,w])=>({...h,[d]:w}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(c,[m,h])=>({...c,[m]:{definition:h,value:this.g.get(m)}}),{})}}e.$ro=T;class I{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$so=I}),define(le[199],he([0,1,8,4,77,12,14,5,40]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;function c(h,d){const w=[];for(const f of new Set(k.Iterable.concat(h.keys(),d.keys())))h.get(f)!==d.get(f)&&w.push(f);return w}let m=class extends p.$ro{constructor(d,w,f){super(),this.m=d,this.n=w,this.s=f,this.c=this.B(new n.$Ah(500));const g=r.Event.filter(w.onDidFilesChange,v=>v.affects(d));this.B(w.watch(d)),this.B(g(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const w=await this.n.readFile(this.m),f=JSON.parse(w.value.toString());if(!(0,R.$eg)(f))throw new Error("Policy file isn't a JSON object");for(const g of Object.keys(f))this.f[g]&&d.set(g,f[g])}catch(w){w.fileOperationResult!==T.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return d}async w(){const d=await this.u(),w=c(this.g,d);this.g=d,w.length>0&&this.h.fire(w)}};e.$bhc=m,e.$bhc=m=Ee([oe(1,T.$0k),oe(2,I.$0j)],m)}),define(le[200],he([0,1,4,2,40]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=void 0;class R{constructor(p){this.b=p,this.a=new r.$Sc}listen(p,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,m=>m.reduce((h,d)=>({...h,[d]:this.b.getPolicyValue(d)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(p,c,m){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$Jgc=R;class T extends k.$ro{constructor(p,c){super(),this.a=c;for(const m in p){const{definition:h,value:d}=p[m];this.f[m]=h,d!==void 0&&this.g.set(m,d)}this.a.listen("onDidChange")(m=>{for(const h in m){const d=m[h];d===null?this.g.delete(h):this.g.set(h,d)}this.h.fire(Object.keys(m))})}async j(p){const c=await this.a.call("updatePolicyDefinitions",p);for(const m in c)this.g.set(m,c[m])}}e.$Kgc=T}),define(le[201],he([0,1,40,8,2,5]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;let T=class extends n.$ro{constructor(p,c){super(),this.m=p,this.n=c,this.a=new r.$wh,this.b=this.B(new k.$Uc)}async j(p){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(p).length} policy definitions`);const{createWatcher:c}=await new Promise((m,h)=>{G(["@vscode/policy-watcher"],m,h)}).then(Ie);await this.a.queue(()=>new Promise((m,h)=>{try{this.b.value=c(this.n,p,d=>{this.t(d),m()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),h(d)}}))}t(p){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(p)}`);for(const c in p){const m=p[c];m===void 0?this.g.delete(c):this.g.set(c,m)}this.h.fire(Object.keys(p))}};e.$ahc=T,e.$ahc=T=Ee([oe(0,R.$0j)],T)}),define(le[72],he([0,1,36]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.context<"u"){const R=k.context.configuration();if(R)r=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:R.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(le[28],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$qk=(0,n.$Ci)("productService"),e.$rk="vscode://schemas/vscode-product"}),define(le[202],he([0,1,8,5]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;let k=class{constructor(T,I,p){this.a=T,this.b=I,this.c=p}async inspect(T){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Dh)(T);const p=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),p.profile}async d(){const T=this.a.webContents.debugger;T.attach(),await T.sendCommand("Profiler.enable")}async e(){const T=this.a.webContents.debugger;await T.sendCommand("Profiler.disable"),T.detach()}};e.$Zfc=k,e.$Zfc=k=Ee([oe(2,r.$0j)],k)}),define(le[73],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0,e.$_ec=(0,n.$Ci)("protocolMainService")}),define(le[45],he([0,1,141,12]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,n=Ie(n),r=Ie(r);class k{constructor(){this.a=new Map}add(T,I){n.ok(r.$cg(T)),n.ok(r.$eg(I)),n.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,I)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$oo=new k}),define(le[203],he([0,1,4,143,45]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,k=Ie(k),e.$po={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class T{constructor(){this.b=new n.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,m){this.a[R(c)]=m,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const m=this.a[c];return m?(0,r.$5j)(m):void 0}hasSchemaContent(c){return!!this.a[c]}}const I=new T;k.$oo.add(e.$po.JSONContribution,I)}),define(le[55],he([0,1,21,4,12,10,16,203,45]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=g,e.$Fo=v,e.$Go=b,e.$Ho=P,e.$Io=E,e.$Jo=t,e.$Ko=u,k=Ie(k),R=Ie(R);var c;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$to={Configuration:"base.contributions.configuration"};var m;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const h=p.$oo.as(I.$po.JSONContribution);class d{constructor(){this.a=[],this.i=new Set,this.j=new r.$je,this.onDidSchemaChange=this.j.event,this.k=new r.$je,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:R.localize(11476,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},h.registerSchema(e.$Ao,this.h),this.z()}registerConfiguration(o,s=!0){this.registerConfigurations([o],s)}registerConfigurations(o,s=!0){const a=new Set;this.r(o,s,a),h.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:a})}deregisterConfigurations(o){const s=new Set;this.s(o,s),h.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:s})}updateConfigurations({add:o,remove:s}){const a=new Set;this.s(s,a),this.r(o,!1,a),h.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:a})}registerDefaultConfigurations(o){const s=new Set;this.l(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}l(o,s){this.a.push(...o);const a=[];for(const{overrides:l,source:S}of o)for(const y in l){s.add(y);const D=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),L=l[y];if(D.configurationDefaultOverrides.push({value:L,source:S}),e.$Do.test(y)){const A=this.o(y,L,S,D.configurationDefaultOverrideValue);if(!A)continue;D.configurationDefaultOverrideValue=A,this.n(y,A,S),a.push(...g(y))}else{const A=this.p(y,L,S,D.configurationDefaultOverrideValue);if(!A)continue;D.configurationDefaultOverrideValue=A;const O=this.e[y];O&&(this.A(y,O),this.w(y,O))}}this.q(a)}deregisterDefaultConfigurations(o){const s=new Set;this.m(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}m(o,s){for(const a of o){const l=this.a.indexOf(a);l!==-1&&this.a.splice(l,1)}for(const{overrides:a,source:l}of o)for(const S in a){const y=this.b.get(S);if(!y)continue;const D=y.configurationDefaultOverrides.findIndex(L=>l?L.source?.id===l.id:L.value===a[S]);if(D!==-1){if(y.configurationDefaultOverrides.splice(D,1),y.configurationDefaultOverrides.length===0&&this.b.delete(S),e.$Do.test(S)){let L;for(const A of y.configurationDefaultOverrides)L=this.o(S,A.value,A.source,L);L&&!k.$pg(L.value)?(y.configurationDefaultOverrideValue=L,this.n(S,L,l)):(this.b.delete(S),delete this.e[S],delete this.c.properties[S])}else{let L;for(const O of y.configurationDefaultOverrides)L=this.p(S,O.value,O.source,L);y.configurationDefaultOverrideValue=L;const A=this.e[S];A&&(this.A(S,A),this.w(S,A))}s.add(S)}}this.y()}n(o,s,a){const l={type:"object",default:s.value,description:R.localize(11477,null,(0,T.$gj)(o)),$ref:e.$Ao,defaultDefaultValue:s.value,source:a,defaultValueSource:a};this.e[o]=l,this.c.properties[o]=l}o(o,s,a,l){const S=l?.value||{},y=l?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const D of Object.keys(s)){const L=s[D];if(k.$eg(L)&&(k.$jg(S[D])||k.$eg(S[D]))){if(S[D]={...S[D]??{},...L},a)for(const O in L)y.set(`${D}.${O}`,a)}else S[D]=L,a?y.set(D,a):y.delete(D)}return{value:S,source:y}}p(o,s,a,l){const S=this.e[o],y=l?.value??S?.defaultDefaultValue;let D=a;if(k.$eg(s)&&(S!==void 0&&S.type==="object"||S===void 0&&(k.$jg(y)||k.$eg(y)))){if(D=l?.source??new Map,!(D instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in s)a&&D.set(`${o}.${A}`,a);s={...k.$eg(y)?y:{},...s}}return{value:s,source:D}}deltaConfiguration(o){let s=!1;const a=new Set;o.removedDefaults&&(this.m(o.removedDefaults,a),s=!0),o.addedDefaults&&(this.l(o.addedDefaults,a),s=!0),o.removedConfigurations&&this.s(o.removedConfigurations,a),o.addedConfigurations&&this.r(o.addedConfigurations,!1,a),this.j.fire(),this.k.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...o){this.j.fire()}registerOverrideIdentifiers(o){this.q(o),this.j.fire()}q(o){for(const s of o)this.i.add(s);this.y()}r(o,s,a){o.forEach(l=>{this.u(l,s,l.extensionInfo,l.restrictedProperties,void 0,a),this.d.push(l),this.v(l)})}s(o,s){const a=l=>{if(l.properties)for(const S in l.properties){s.add(S);const y=this.e[S];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[S],this.x(S,l.properties[S])}l.allOf?.forEach(S=>a(S))};for(const l of o){a(l);const S=this.d.indexOf(l);S!==-1&&this.d.splice(S,1)}}u(o,s=!0,a,l,S=m.WINDOW,y){S=k.$lg(o.scope)?S:o.scope;const D=o.properties;if(D)for(const A in D){const O=D[A];if(s&&P(A,O)){delete D[A];continue}if(O.source=a,O.defaultDefaultValue=D[A].default,this.A(A,O),e.$Do.test(A)?O.scope=void 0:(O.scope=k.$lg(O.scope)?S:O.scope,O.restricted=k.$lg(O.restricted)?!!l?.includes(A):O.restricted),D[A].hasOwnProperty("included")&&!D[A].included){this.g[A]=D[A],delete D[A];continue}else this.e[A]=D[A],D[A].policy?.name&&this.f.set(D[A].policy.name,A);!D[A].deprecationMessage&&D[A].markdownDeprecationMessage&&(D[A].deprecationMessage=D[A].markdownDeprecationMessage),y.add(A)}const L=o.allOf;if(L)for(const A of L)this.u(A,s,a,l,S,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[s,a]of this.b)a.configurationDefaultOverrideValue&&o.set(s,a.configurationDefaultOverrideValue);return o}v(o){const s=a=>{const l=a.properties;if(l)for(const y in l)this.w(y,l[y]);a.allOf?.forEach(s)};s(o)}w(o,s){switch(e.$uo.properties[o]=s,s.scope){case m.APPLICATION:e.$vo.properties[o]=s;break;case m.MACHINE:e.$wo.properties[o]=s;break;case m.MACHINE_OVERRIDABLE:e.$xo.properties[o]=s;break;case m.WINDOW:e.$yo.properties[o]=s;break;case m.RESOURCE:e.$zo.properties[o]=s;break;case m.LANGUAGE_OVERRIDABLE:e.$zo.properties[o]=s,this.h.properties[o]=s;break}}x(o,s){switch(delete e.$uo.properties[o],s.scope){case m.APPLICATION:delete e.$vo.properties[o];break;case m.MACHINE:delete e.$wo.properties[o];break;case m.MACHINE_OVERRIDABLE:delete e.$xo.properties[o];break;case m.WINDOW:delete e.$yo.properties[o];break;case m.RESOURCE:case m.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[o],delete this.h.properties[o];break}}y(){for(const o of this.i.values()){const s=`[${o}]`,a={type:"object",description:R.localize(11478,null),errorMessage:R.localize(11479,null),$ref:e.$Ao};this.A(s,a),e.$uo.properties[s]=a,e.$vo.properties[s]=a,e.$wo.properties[s]=a,e.$xo.properties[s]=a,e.$yo.properties[s]=a,e.$zo.properties[s]=a}}z(){const o={type:"object",description:R.localize(11480,null),errorMessage:R.localize(11481,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=o,e.$vo.patternProperties[e.$Co]=o,e.$wo.patternProperties[e.$Co]=o,e.$xo.patternProperties[e.$Co]=o,e.$yo.patternProperties[e.$Co]=o,e.$zo.patternProperties[e.$Co]=o,this.j.fire()}A(o,s){const a=this.b.get(o)?.configurationDefaultOverrideValue;let l,S;a&&(!s.disallowConfigurationDefault||!a.source)&&(l=a.value,S=a.source),k.$jg(l)&&(l=s.defaultDefaultValue,S=void 0),k.$jg(l)&&(l=b(s.type)),s.default=l,s.defaultValueSource=S}}const w="\\[([^\\]]+)\\]",f=new RegExp(w,"g");e.$Co=`^(${w})+$`,e.$Do=new RegExp(e.$Co);function g(i){const o=[];if(e.$Do.test(i)){let s=f.exec(i);for(;s?.length;){const a=s[1].trim();a&&o.push(a),s=f.exec(i)}}return(0,n.$Lb)(o)}function v(i){return i.reduce((o,s)=>`${o}[${s}]`,"")}function b(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new d;p.$oo.add(e.$to.Configuration,$);function P(i,o){return i.trim()?e.$Do.test(i)?R.localize(11483,null,i):$.getConfigurationProperties()[i]!==void 0?R.localize(11484,null,i):o.policy?.name&&$.getPolicyConfigurations().get(o.policy?.name)!==void 0?R.localize(11485,null,i,o.policy?.name,$.getPolicyConfigurations().get(o.policy?.name)):null:R.localize(11482,null)}function E(){const i=[],o=$.getConfigurationProperties();for(const s of Object.keys(o))i.push([s,o[s].scope]);return i.push(["launch",m.RESOURCE]),i.push(["task",m.RESOURCE]),i}function t(i){const o={};for(const s of i){const a=s.properties;if(k.$eg(a))for(const l in a)o[l]=a[l];s.allOf&&Object.assign(o,t(s.allOf))}return o}function u(i){switch(i){case"application":return m.APPLICATION;case"machine":return m.MACHINE;case"resource":return m.RESOURCE;case"machine-overridable":return m.MACHINE_OVERRIDABLE;case"language-overridable":return m.LANGUAGE_OVERRIDABLE;default:return m.WINDOW}}}),define(le[125],he([0,1,21,4,43,2,31,37,12,7,16,55,14,45]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=E,n=Ie(n),k=Ie(k),I=Ie(I),p=Ie(p);function f(o){return Object.isFrozen(o)?o:I.$co(o)}class g{static createEmptyModel(s){return new g({},[],[],void 0,s)}constructor(s,a,l,S,y){this.b=s,this.c=a,this.d=l,this.raw=S,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof g)return a;const l=new v("",this.f);return l.parseRaw(a),l.configurationModel});this.g=s.reduce((a,l)=>l===a?l:a.merge(l),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,m.$ej)(this.contents,s):this.contents}inspect(s,a){const l=this;return{get value(){return f(l.rawConfiguration.getValue(s))},get override(){return a?f(l.rawConfiguration.getOverrideValue(s,a)):void 0},get merged(){return f(a?l.rawConfiguration.override(a).getValue(s):l.rawConfiguration.getValue(s))},get overrides(){const S=[];for(const{contents:y,identifiers:D,keys:L}of l.rawConfiguration.overrides){const A=new g(y,L,[],void 0,l.f).getValue(s);A!==void 0&&S.push({identifiers:D,value:A})}return S.length?f(S):void 0}}}getOverrideValue(s,a){const l=this.j(a);return l?s?(0,m.$ej)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const l of this.overrides)l.identifiers.includes(s)&&a.push(...l.keys);return n.$Lb(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return n.$Lb(s)}override(s){let a=this.a.get(s);return a||(a=this.h(s),this.a.set(s,a)),a}merge(...s){const a=I.$bo(this.contents),l=I.$bo(this.overrides),S=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const D of s)if(y.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(a,D.contents);for(const L of D.overrides){const[A]=l.filter(O=>n.$tb(O.identifiers,L.identifiers));A?(this.i(A.contents,L.contents),A.keys.push(...L.keys),A.keys=n.$Lb(A.keys)):l.push(I.$bo(L))}for(const L of D.keys)S.indexOf(L)===-1&&S.push(L)}return new g(a,S,l,y.every(D=>D instanceof g)?void 0:y,this.f)}h(s){const a=this.j(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const l={};for(const S of n.$Lb([...Object.keys(this.contents),...Object.keys(a)])){let y=this.contents[S];const D=a[S];D&&(typeof y=="object"&&typeof D=="object"?(y=I.$bo(y),this.i(y,D)):y=D),l[S]=y}return new g(l,this.keys,this.overrides,void 0,this.f)}i(s,a){for(const l of Object.keys(a)){if(l in s&&p.$eg(s[l])&&p.$eg(a[l])){this.i(s[l],a[l]);continue}s[l]=I.$bo(a[l])}}j(s){let a=null,l=null;const S=y=>{y&&(l?this.i(l,y):l=I.$bo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===s?a=y.contents:y.identifiers.includes(s)&&S(y.contents);return S(a),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,a){this.k(s,a,!0)}setValue(s,a){this.k(s,a,!1)}removeValue(s){const a=this.keys.indexOf(s);a!==-1&&(this.keys.splice(a,1),(0,m.$dj)(this.contents,s),h.$Do.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>n.$tb(l.identifiers,(0,h.$Eo)(s))),1))}k(s,a,l){if((0,m.$cj)(this.contents,s,a,S=>this.f.error(S)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),h.$Do.test(s)){const S=(0,h.$Eo)(s),y={identifiers:S,keys:Object.keys(this.contents[s]),contents:(0,m.$bj)(this.contents[s],L=>this.f.error(L))},D=this.overrides.findIndex(L=>n.$tb(L.identifiers,S));D!==-1?this.overrides[D]=y:this.overrides.push(y)}}}e.$Lo=g;class v{constructor(s,a){this.f=s,this.g=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!p.$lg(s)){const l=this.h(s);this.parseRaw(l,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:l,keys:S,overrides:y,restricted:D,hasExcludedProperties:L}=this.i(s,a);this.b=new g(l,S,y,L?[s]:void 0,this.g),this.c=D||[]}h(s){let a={},l=null,S=[];const y=[],D=[];function L(O){Array.isArray(S)?S.push(O):l!==null&&(S[l]=O)}const A={onObjectBegin:()=>{const O={};L(O),y.push(S),S=O,l=null},onObjectProperty:O=>{l=O},onObjectEnd:()=>{S=y.pop()},onArrayBegin:()=>{const O=[];L(O),y.push(S),S=O,l=null},onArrayEnd:()=>{S=y.pop()},onLiteralValue:L,onError:(O,W,V)=>{D.push({error:O,offset:W,length:V})}};if(s)try{k.$3n(s,A),a=S[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return a}i(s,a){const l=w.$oo.as(h.$to.Configuration).getConfigurationProperties(),S=this.j(s,l,!0,a);s=S.raw;const y=(0,m.$bj)(s,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),D=Object.keys(s),L=this.l(s,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:y,keys:D,overrides:L,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(s,a,l,S){let y=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:y};const D={},L=[];for(const A in s)if(h.$Do.test(A)&&l){const O=this.j(s[A],a,!1,S);D[A]=O.raw,y=y||O.hasExcludedProperties,L.push(...O.restricted)}else{const O=a[A],W=O?typeof O.scope<"u"?O.scope:h.ConfigurationScope.WINDOW:void 0;O?.restricted&&L.push(A),!S.exclude?.includes(A)&&(S.include?.includes(A)||(W===void 0||S.scopes===void 0||S.scopes.includes(W))&&!(S.skipRestricted&&O?.restricted))?D[A]=s[A]:y=!0}return{raw:D,restricted:L,hasExcludedProperties:y}}l(s,a){const l=[];for(const S of Object.keys(s))if(h.$Do.test(S)){const y={};for(const D in s[S])y[D]=s[S][D];l.push({identifiers:(0,h.$Eo)(S),keys:Object.keys(y),contents:(0,m.$bj)(y,a)})}return l}}e.$Mo=v;class b extends R.$Tc{constructor(s,a,l,S,y){super(),this.c=s,this.f=a,this.g=S,this.h=y,this.b=this.B(new r.$je),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),y),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(d.FileOperation.CREATE)||D.isOperation(d.FileOperation.COPY)||D.isOperation(d.FileOperation.DELETE)||D.isOperation(d.FileOperation.WRITE))&&l.isEqual(D.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=b;class ${constructor(s,a,l,S,y,D,L,A,O,W,V,H,Y){this.a=s,this.b=a,this.c=l,this.overrideIdentifiers=S,this.d=y,this.f=D,this.g=L,this.h=A,this.i=O,this.j=W,this.k=V,this.l=H,this.m=Y}get value(){return f(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(s,a,l,S,y,D,L,A,O,W){this.j=s,this.l=a,this.m=l,this.n=S,this.p=y,this.q=D,this.r=L,this.s=A,this.t=O,this.u=W,this.h=null,this.i=new T.$zc,this.v=null}getValue(s,a,l){return this.w(s,a,l).getValue(s)}updateValue(s,a,l={}){let S;l.resource?(S=this.t.get(l.resource),S||(S=g.createEmptyModel(this.u),this.t.set(l.resource,S))):S=this.s,a===void 0?S.removeValue(s):S.setValue(s,a),l.resource||(this.h=null)}inspect(s,a,l){const S=this.w(s,a,l),y=this.A(a.resource,l),D=a.resource?this.t.get(a.resource)||this.s:this.s,L=new Set;for(const A of S.overrides)for(const O of A.identifiers)S.getOverrideValue(s,O)!==void 0&&L.add(O);return new $(s,a,S.getValue(s),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.q:void 0,y||void 0,D)}keys(s){const a=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,a){this.r.set(s,a),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const l=[];if(!a){const{added:S,updated:y,removed:D}=u(this.j,s);a=[...S,...y,...D]}for(const S of a)for(const y of(0,h.$Eo)(S)){const D=this.j.getKeysForOverrideIdentifier(y),L=s.getKeysForOverrideIdentifier(y),A=[...L.filter(O=>D.indexOf(O)===-1),...D.filter(O=>L.indexOf(O)===-1),...D.filter(O=>!I.$fo(this.j.override(y).getValue(O),s.override(y).getValue(O)))];l.push([y,A])}return this.updateDefaultConfiguration(s),{keys:a,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:l,removed:S}=u(this.l,s),y=[...a,...l,...S];return y.length&&this.updatePolicyConfiguration(s),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=u(this.applicationConfiguration,s),D=[...a,...l,...S];return D.length&&this.updateApplicationConfiguration(s),{keys:D,overrides:y}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=u(this.localUserConfiguration,s),D=[...a,...l,...S];return D.length&&this.updateLocalUserConfiguration(s),{keys:D,overrides:y}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=u(this.remoteUserConfiguration,s),D=[...a,...l,...S];return D.length&&this.updateRemoteUserConfiguration(s),{keys:D,overrides:y}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=u(this.workspaceConfiguration,s),D=[...a,...l,...S];return D.length&&this.updateWorkspaceConfiguration(s),{keys:D,overrides:y}}compareAndUpdateFolderConfiguration(s,a){const l=this.folderConfigurations.get(s),{added:S,updated:y,removed:D,overrides:L}=u(l,a),A=[...S,...y,...D];return(A.length||!l)&&this.updateFolderConfiguration(s,a),{keys:A,overrides:L}}compareAndDeleteFolderConfiguration(s){const a=this.folderConfigurations.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:S,removed:y,overrides:D}=u(a,void 0);return{keys:[...l,...S,...y],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,a,l){let S=this.x(a,l);return a.overrideIdentifier&&(S=S.override(a.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(S=S.merge(this.l)),S}x({resource:s},a){let l=this.y();if(a&&s){const S=a.getFolder(s);S&&(l=this.z(S.uri)||l);const y=this.t.get(s);y&&(l=l.merge(y))}return l}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let a=this.i.get(s);if(!a){const l=this.y(),S=this.r.get(s);S?(a=l.merge(S),this.i.set(s,a)):a=l}return a}A(s,a){if(a&&s){const l=a.getFolder(s);if(l)return this.r.get(l.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,a)=>{const{contents:l,overrides:S,keys:y}=this.r.get(a);return s.push([a,{contents:l,overrides:S,keys:y}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(a=>s.add(a)),this.userConfiguration.keys.forEach(a=>s.add(a)),this.q.keys.forEach(a=>s.add(a)),this.r.forEach(a=>a.keys.forEach(l=>s.add(l))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.q.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.r.forEach(a=>a.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}D(s){const a=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.q.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.r.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(S=>a.add(S))),[...a.values()]}static parse(s,a){const l=this.E(s.defaults,a),S=this.E(s.policy,a),y=this.E(s.application,a),D=this.E(s.user,a),L=this.E(s.workspace,a),A=s.folders.reduce((O,W)=>(O.set(c.URI.revive(W[0]),this.E(W[1],a)),O),new T.$zc);return new P(l,S,y,D,g.createEmptyModel(a),L,A,g.createEmptyModel(a),new T.$zc,a)}static E(s,a){return new g(s.contents,s.keys,s.overrides,void 0,a)}}e.$Oo=P;function E(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,a=new Map;for(const S of o)S.keys.forEach(y=>s.add(y)),S.overrides.forEach(([y,D])=>{const L=(0,T.$wc)(a,y,new Set);D.forEach(A=>L.add(A))});const l=[];return a.forEach((S,y)=>l.push([y,[...S.values()]])),{keys:[...s.values()],overrides:l}}class t{constructor(s,a,l,S,y){this.change=s,this.f=a,this.g=l,this.h=S,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of s.keys)this.affectedKeys.add(D);for(const[,D]of s.overrides)for(const L of D)this.affectedKeys.add(L);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,a){const l=this.a+s,S=this.d.indexOf(l);if(S<0)return!1;const y=S+l.length;if(y>=this.d.length)return!1;const D=this.d.charCodeAt(y);if(D!==this.b&&D!==this.c)return!1;if(a){const L=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,A=this.g.getValue(s,a,this.h);return!I.$fo(L,A)}return!0}}e.$Qo=t;function u(o,s){const{added:a,removed:l,updated:S}=i(s?.rawConfiguration,o?.rawConfiguration),y=[],D=o?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const A=L.filter(O=>!D.includes(O));for(const O of A)y.push([O,s.getKeysForOverrideIdentifier(O)])}if(o){const A=D.filter(O=>!L.includes(O));for(const O of A)y.push([O,o.getKeysForOverrideIdentifier(O)])}if(s&&o){for(const A of D)if(L.includes(A)){const O=i({contents:o.getOverrideValue(void 0,A)||{},keys:o.getKeysForOverrideIdentifier(A)},{contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)});y.push([A,[...O.added,...O.removed,...O.updated]])}}return{added:a,removed:l,updated:S,overrides:y}}function i(o,s){const a=o?s?o.keys.filter(y=>s.keys.indexOf(y)===-1):[...o.keys]:[],l=s?o?s.keys.filter(y=>o.keys.indexOf(y)===-1):[...s.keys]:[],S=[];if(o&&s){for(const y of s.keys)if(o.keys.indexOf(y)!==-1){const D=(0,m.$ej)(s.contents,y),L=(0,m.$ej)(o.contents,y);I.$fo(D,L)||S.push(y)}}return{added:a,removed:l,updated:S}}}),define(le[204],he([0,1,21,4,2,37,12,125,55,5,40,45]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=void 0;class d extends k.$Tc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new r.$je),this.onDidChangeConfiguration=this.a.event,this.b=I.$Lo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(h.$oo.as(p.$to.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:b})=>this.f(Array.from(v),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,b){this.j(v,h.$oo.as(p.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=I.$Lo.createEmptyModel(this.c);const v=h.$oo.as(p.$to.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,b){const $=this.g();for(const P of v){const E=$[P],t=b[P];E!==void 0?this.b.setValue(P,E):t?this.b.setValue(P,t.default):this.b.removeValue(P)}}}e.$Ro=d;class w{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$Lo.createEmptyModel(new c.$kk)}async initialize(){return this.configurationModel}}e.$So=w;let f=class extends k.$Tc{get configurationModel(){return this.b}constructor(v,b,$){super(),this.c=v,this.f=b,this.g=$,this.a=this.B(new r.$je),this.onDidChangeConfiguration=this.a.event,this.b=I.$Lo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const b={},$=[],P=h.$oo.as(p.$to.Configuration).getConfigurationProperties();for(const E of v){const t=P[E];if(!t){$.push(E);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}$.push(E),b[t.policy.name]={type:t.type}}}return(0,T.$pg)(b)||await this.f.updatePolicyDefinitions(b),$}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const b=h.$oo.as(p.$to.Configuration).getPolicyConfigurations(),$=(0,n.$Gb)(v.map(P=>b.get(P)));this.m($,!0)}m(v,b){this.g.trace("PolicyConfiguration#update",v);const $=h.$oo.as(p.$to.Configuration).getConfigurationProperties(),P=[],E=this.b.isEmpty();for(const t of v){const u=$[t]?.policy?.name;if(u){const i=this.f.getPolicyValue(u);(E?i!==void 0:!(0,R.$fo)(this.b.getValue(t),i))&&P.push([t,i])}else this.b.getValue(t)!==void 0&&P.push([t,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const t=this.b;this.b=I.$Lo.createEmptyModel(this.g);for(const u of t.keys)this.b.setValue(u,t.getValue(u));for(const[u,i]of P)i===void 0?this.b.removeValue(u):this.b.setValue(u,i);b&&this.a.fire(this.b)}}};e.$To=f,e.$To=f=Ee([oe(1,m.$qo),oe(2,c.$0j)],f)}),define(le[205],he([0,1,21,8,17,4,43,107,2,31,37,3,18,16,125,55,204,14,40]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0;class P extends p.$Tc{constructor(u,i,o,s){super(),this.m=u,this.n=s,this.h=this.B(new R.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$Ro(s)),this.c=o instanceof $.$so?new v.$So:this.B(new v.$To(this.b,o,s)),this.f=this.B(new f.$No(this.m,{},d.$7g,i,s)),this.a=new f.$Oo(this.b.configurationModel,this.c.configurationModel,f.$Lo.createEmptyModel(s),f.$Lo.createEmptyModel(s),f.$Lo.createEmptyModel(s),f.$Lo.createEmptyModel(s),new c.$zc,f.$Lo.createEmptyModel(s),new c.$zc,s),this.j=new E(u,i,this),this.g=this.B(new r.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:l})=>this.s(a,l))),this.B(this.c.onDidChangeConfiguration(a=>this.t(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,i,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$Oo(u,i,f.$Lo.createEmptyModel(this.n),o,f.$Lo.createEmptyModel(this.n),f.$Lo.createEmptyModel(this.n),new c.$zc,f.$Lo.createEmptyModel(this.n),new c.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(u,i){const o=typeof u=="string"?u:void 0,s=(0,w.$0i)(u)?u:(0,w.$0i)(i)?i:{};return this.a.getValue(o,s,void 0)}async updateValue(u,i,o,s,a){const l=(0,w.$$i)(o)?o:(0,w.$0i)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,S=l?s:o;if(S!==void 0&&S!==w.ConfigurationTarget.USER_LOCAL&&S!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${u} to target ${S}.`);l?.overrideIdentifiers&&(l.overrideIdentifiers=(0,n.$Lb)(l.overrideIdentifiers),l.overrideIdentifiers=l.overrideIdentifiers.length?l.overrideIdentifiers:void 0);const y=this.inspect(u,{resource:l?.resource,overrideIdentifier:l?.overrideIdentifiers?l.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,m.$fo)(i,y.defaultValue)&&(i=void 0),l?.overrideIdentifiers?.length&&l.overrideIdentifiers.length>1){const L=l.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(O=>(0,n.$tb)([...O.identifiers].sort(),L));A&&(l.overrideIdentifiers=A.identifiers)}const D=l?.overrideIdentifiers?.length?[(0,g.$Fo)(l.overrideIdentifiers),u]:[u];await this.j.write(D,i),await this.reloadConfiguration()}inspect(u,i={}){return this.a.inspect(u,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.r(u)}r(u){const i=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(u);this.u(o,i,w.ConfigurationTarget.USER)}s(u,i){const o=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(u,i);this.u(s,o,w.ConfigurationTarget.DEFAULT)}t(u){const i=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(u);this.u(o,i,w.ConfigurationTarget.DEFAULT)}u(u,i,o){const s=new f.$Qo(u,{data:i},this.a,void 0,this.n);s.source=o,this.h.fire(s)}}e.$Uo=P;class E{constructor(u,i,o){this.b=u,this.c=i,this.d=o,this.a=new r.$Jh}write(u,i){return this.a.queue(()=>this.e(u,i))}async e(u,i){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(l){if(l.fileOperationResult===b.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw l}const s=[];if((0,T.$Vn)(o,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const a=this.f(o,u,i);o=(0,I.$ao)(o,a),await this.c.writeFile(this.b,k.$Le.fromString(o))}f(u,i,o){const{tabSize:s,insertSpaces:a,eol:l}=this.h;if(!i.length){const S=JSON.stringify(o,null,a?" ".repeat(s):"	");return[{content:S,length:S.length,offset:0}]}return(0,I.$0n)(u,i,o,{tabSize:s,insertSpaces:a,eol:l})}get h(){if(!this.g){let u=h.OS===h.OperatingSystem.Linux||h.OS===h.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(u=i),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[206],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=e.$Zgc=void 0,e.$Zgc="request",e.$1gc="remoteResourceHandler";class n{async routeCall(k,R,T){if(R!==e.$Zgc)throw new Error(`Call not found: ${R}`);const I=T[0];if(I?.authority){const p=k.connections.find(c=>c.ctx===I.authority);if(p)return p}throw new Error("Caller not found")}routeEvent(k,R){throw new Error(`Event not found: ${R}`)}}e.$2gc=n}),define(le[207],he([0,1,15,6]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.RemoteAuthorityResolverErrorCode=e.$Ql=e.$Pl=e.RemoteConnectionType=e.$Ol=void 0,e.$Sl=c,e.$Ol=(0,r.$Ci)("remoteAuthorityResolverService");var k;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class R{constructor(h){this.id=h,this.type=k.Managed}toString(){return`Managed(${this.id})`}}e.$Pl=R;class T{constructor(h,d){this.host=h,this.port=d,this.type=k.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ql=T;var I;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class p extends n.$ab{static isNotAvailable(h){return h instanceof p&&h._code===I.NotAvailable}static isTemporarilyNotAvailable(h){return h instanceof p&&h._code===I.TemporarilyNotAvailable}static isNoResolverFound(h){return h instanceof p&&h._code===I.NoResolverFound}static isInvalidAuthority(h){return h instanceof p&&h._code===I.InvalidAuthority}static isHandled(h){return h instanceof p&&h.isHandled}constructor(h,d=I.Unknown,w){super(h),this._message=h,this._code=d,this._detail=w,this.isHandled=d===I.NotAvailable&&w===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Rl=p;function c(m){const h=m.indexOf("+");return h===-1?m:m.substring(0,h)}}),define(le[208],he([0,1,8,17,22,15,4,2,11,70,66,33,117,207]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Xl=y,e.$Yl=D,e.$Zl=A,c=Ie(c);const f=30*1e3;var g;(function(se){se[se.Management=1]="Management",se[se.ExtensionHost=2]="ExtensionHost",se[se.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function v(se){switch(se){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function b(se){const ie=new k.$ue;return setTimeout(()=>ie.cancel(),se),ie.token}function $(se,ie){if(se.isCancellationRequested||ie.isCancellationRequested)return k.CancellationToken.Cancelled;const M=new k.$ue;return se.onCancellationRequested(()=>M.cancel()),ie.onCancellationRequested(()=>M.cancel()),M.token}class P{get didTimeout(){return this.c==="timedout"}constructor(ie){this.c="pending",this.d=new I.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$vh)(),ie.isCancellationRequested?this.h():this.d.add(ie.onCancellationRequested(()=>this.h()))}registerDisposable(ie){this.c==="pending"?this.d.add(ie):ie.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const ie=new Error("Time limit reached");return ie.code="ETIMEDOUT",ie.syscall="connect",ie}resolve(ie){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(ie))}reject(ie){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(ie))}}function E(se,ie){const M=new P(ie);return M.registerDisposable(se.onControlMessage(F=>{const N=JSON.parse(F.toString()),z=j(N);z?M.reject(z):M.resolve(N)})),M.promise}function t(se,ie,M,F,N,z,_,Q){const q=new P(Q),re=m.$de.create(!1);return se.info(`Creating a socket (${_})...`),c.mark(`code/willCreateSocket/${z}`),ie.connect(M,F,N,_).then(de=>{q.didTimeout?(c.mark(`code/didCreateSocketError/${z}`),se.info(`Creating a socket (${_}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(c.mark(`code/didCreateSocketOK/${z}`),se.info(`Creating a socket (${_}) was successful after ${re.elapsed()} ms.`),q.resolve(de))},de=>{c.mark(`code/didCreateSocketError/${z}`),se.info(`Creating a socket (${_}) returned an error after ${re.elapsed()} ms.`),se.error(de),q.reject(de)}),q.promise}function u(se,ie){const M=new P(ie);return se.then(F=>{M.didTimeout||M.resolve(F)},F=>{M.didTimeout||M.reject(F)}),M.promise}async function i(se,ie,M,F){const N=K(se,ie);se.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let z;try{z=await t(se.logService,se.remoteSocketFactoryService,se.connectTo,p.$Pg.getServerRootPath(),`reconnectionToken=${se.reconnectionToken}&reconnection=${se.reconnectionProtocol?"true":"false"}`,v(ie),`renderer-${v(ie)}-${se.reconnectionToken}`,F)}catch(de){throw se.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),se.logService.error(de),de}se.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let _,Q;se.reconnectionProtocol?(se.reconnectionProtocol.beginAcceptReconnection(z,null),_=se.reconnectionProtocol,Q=!1):(_=new d.$qi({socket:z}),Q=!0),se.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const q=await u(se.signService.createNewMessage((0,h.$Yg)()),F),re={type:"auth",auth:se.connectionToken||"00000000000000000000",data:q.data};_.sendControl(r.$Le.fromString(JSON.stringify(re)));try{const de=await E(_,$(F,b(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(se.logService.trace(`${N} 4/6. received SignRequest control message.`),!await u(se.signService.validate(q,de.signedData),F)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const we=await u(se.signService.sign(de.data),F),De={type:"connectionType",commit:se.commit,signedData:we,desiredConnectionType:ie};return M&&(De.args=M),se.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(r.$Le.fromString(JSON.stringify(De))),{protocol:_,ownsProtocol:Q}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(se.logService.error(`${N} the handshake timed out. Error:`),se.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(se.logService.error(`${N} received error control message when negotiating connection. Error:`),se.logService.error(de)),Q&&B(_),de}}async function o(se,ie,M,F){const N=Date.now(),z=K(se,ie),{protocol:_,ownsProtocol:Q}=await i(se,ie,M,F),q=new P(F);return q.registerDisposable(_.onControlMessage(re=>{const de=JSON.parse(re.toString()),me=j(de);me?(se.logService.error(`${z} received error control message when negotiating connection. Error:`),se.logService.error(me),Q&&B(_),q.reject(me)):(se.reconnectionProtocol?.endAcceptReconnection(),se.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${ce(N)}!`),q.resolve({protocol:_,firstMessage:de}))})),q.promise}async function s(se,ie){const{protocol:M}=await o(se,g.Management,void 0,ie);return{protocol:M}}async function a(se,ie,M){const{protocol:F,firstMessage:N}=await o(se,g.ExtensionHost,ie,M),z=N&&N.debugPort;return{protocol:F,debugPort:z}}async function l(se,ie,M){const F=Date.now(),N=K(se,g.Tunnel),{protocol:z}=await i(se,g.Tunnel,ie,M);return se.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${ce(F)}!`),z}async function S(se,ie,M){const{connectTo:F,connectionToken:N}=await se.addressProvider.getAddress();return{commit:se.commit,quality:se.quality,connectTo:F,connectionToken:N,reconnectionToken:ie,reconnectionProtocol:M,remoteSocketFactoryService:se.remoteSocketFactoryService,signService:se.signService,logService:se.logService}}async function y(se,ie,M){return L(se,async F=>{const{protocol:N}=await s(F,k.CancellationToken.None);return new x(se,ie,M,F.reconnectionToken,N)})}async function D(se,ie){return L(se,async M=>{const{protocol:F,debugPort:N}=await a(M,ie,k.CancellationToken.None);return new J(se,ie,M.reconnectionToken,F,N)})}async function L(se,ie){for(let F=1;;F++)try{const N=(0,h.$Yg)(),z=await S(se,N,null);return await ie(z)}catch(N){if(F<5)se.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),se.logService.error(N);else throw se.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),se.logService.error(N),te.triggerPermanentFailure(0,0,w.$Rl.isHandled(N)),N}}async function A(se,ie,M){const F=await S(se,(0,h.$Yg)(),null);return await l(F,{host:ie,port:M},k.CancellationToken.None)}function O(se){return(0,n.$ph)(ie=>new Promise((M,F)=>{const N=setTimeout(M,se*1e3);ie.onCancellationRequested(()=>{clearTimeout(N),M()})}))}var W;(function(se){se[se.ConnectionLost=0]="ConnectionLost",se[se.ReconnectionWait=1]="ReconnectionWait",se[se.ReconnectionRunning=2]="ReconnectionRunning",se[se.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",se[se.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class V{constructor(ie,M){this.reconnectionToken=ie,this.millisSinceLastIncomingData=M,this.type=W.ConnectionLost}}e.$1l=V;class H{constructor(ie,M,F,N){this.reconnectionToken=ie,this.millisSinceLastIncomingData=M,this.durationSeconds=F,this.c=N,this.type=W.ReconnectionWait}skipWait(){this.c.cancel()}}e.$2l=H;class Y{constructor(ie,M,F){this.reconnectionToken=ie,this.millisSinceLastIncomingData=M,this.attempt=F,this.type=W.ReconnectionRunning}}e.$3l=Y;class Z{constructor(ie,M,F){this.reconnectionToken=ie,this.millisSinceLastIncomingData=M,this.attempt=F,this.type=W.ConnectionGain}}e.$4l=Z;class U{constructor(ie,M,F,N){this.reconnectionToken=ie,this.millisSinceLastIncomingData=M,this.attempt=F,this.handled=N,this.type=W.ReconnectionPermanentFailure}}e.$5l=U;class te extends I.$Tc{static triggerPermanentFailure(ie,M,F){this._permanentFailure=!0,this.f=ie,this.g=M,this.h=F,this.j.forEach(N=>N.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(ie=>ie.y())}static debugPauseSocketWriting(){this.j.forEach(ie=>ie.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||te._permanentFailure}constructor(ie,M,F,N,z){super(),this.t=ie,this.u=M,this.reconnectionToken=F,this.protocol=N,this.w=z,this.m=this.B(new T.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(N.onSocketClose(_=>{const Q=ae(this.t,this.reconnectionToken,!0);_?_.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${Q} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${Q} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${Q} received socket close event.`),this.y()})),this.B(N.onSocketTimeout(_=>{const Q=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Q} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),te.j.push(this),this.B((0,I.$Rc)(()=>{const _=te.j.indexOf(this);_>=0&&te.j.splice(_,1)})),this.n&&this.D(te.f,te.g,te.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const ie=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const N=F<M.length?M[F]:M[M.length-1];try{if(N>0){const _=O(N);this.m.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,_)),this.u.logService.info(`${ie} waiting for ${N} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${ie} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this.u.logService.info(`${ie} resolving connection...`);const z=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${ie} connecting to ${z.connectTo}...`),await this.G(z,b(f)),this.u.logService.info(`${ie} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${ie} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this.u.logService.error(`${ie} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(w.$Rl.isTemporarilyNotAvailable(z)){this.u.logService.info(`${ie} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${ie} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,R.$3)(z)){this.u.logService.info(`${ie} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof w.$Rl){this.u.logService.error(`${ie} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,w.$Rl.isHandled(z));break}this.u.logService.error(`${ie} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this.n&&!this.s)}C(ie,M,F){this.w?te.triggerPermanentFailure(ie,M,F):this.D(ie,M,F)}D(ie,M,F){this.m.fire(new U(this.reconnectionToken,ie,M,F)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6l=te;class x extends te{constructor(ie,M,F,N,z){super(g.Management,ie,N,z,!0),this.client=this.B(new d.$oi(z,{remoteAuthority:M,clientId:F},ie.ipcLogger))}async G(ie,M){await s(ie,M)}}e.$7l=x;class J extends te{constructor(ie,M,F,N,z){super(g.ExtensionHost,ie,F,N,!1),this.H=M,this.debugPort=z}async G(ie,M){await a(ie,this.H,M)}}e.$8l=J;function B(se){try{se.acceptDisconnect();const ie=se.getSocket();se.dispose(),ie.dispose()}catch(ie){(0,R.$Y)(ie)}}function j(se){if(se&&se.type==="error"){const ie=new Error(`Connection error: ${se.reason}`);return ie.code="VSCODE_CONNECTION_ERROR",ie}return null}function C(se,ie){for(;se.length<ie;)se+=" ";return se}function X(se,ie){return`[remote-connection][${C(v(se),13)}][${ie.substr(0,5)}\u2026]`}function ae(se,ie,M){return`${X(se,ie)}[${M?"reconnect":"initial"}]`}function K(se,ie){return`${ae(ie,se.reconnectionToken,!!se.reconnectionProtocol)}[${se.connectTo}]`}function ce(se){return`${Date.now()-se} ms`}}),define(le[74],he([0,1,11]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=r,e.$fn=k,e.$gn=R,e.$hn=T;function r(p){return p.scheme===n.Schemas.vscodeRemote?p.authority:void 0}function k(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function R(p){const{host:c,port:m}=I(p);if(typeof m>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:m}}function T(p,c){let{host:m,port:h}=I(p);return typeof h>"u"&&(h=c),{host:m,port:h}}function I(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const m=p.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const h=p.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:p,port:void 0}}}),define(le[85],he([0,1,25,6,74]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$qn=e.$pn=e.$on=e.TargetPlatform=e.ExtensionType=e.$nn=e.$ln=e.$kn=e.$jn=e.$in=void 0,e.$mn=R,e.$rn=h,e.$sn=d,e.$tn=w,e.$un=f,e.$vn=g,e.$wn=v,n=Ie(n),e.$in="extensions.user.cache",e.$jn="extensions.builtin.cache",e.$kn="undefined_publisher",e.$ln=["ui","workspace","web"];function R(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$nn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(T||(e.ExtensionType=T={}));var I;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class p{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,P){if(typeof $>"u"||$===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof $=="string"||typeof P=="string"){const E=typeof $=="string"?$:$.value,t=typeof P=="string"?P:P.value;return n.$Df(E,t)}return $._lower===P._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$on=p;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const P of $)this.add(P)}add($){this.c.add(p.toKey($))}delete($){return this.c.delete(p.toKey($))}has($){return this.c.has(p.toKey($))}}e.$pn=c;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(p.toKey($))}get($){return this.c.get(p.toKey($))}has($){return this.c.has(p.toKey($))}set($,P){this.c.set(p.toKey($),P)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$qn=m;function h(b){return d(b)}function d(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function w(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function f(b,$){if($){const P=`onResolveRemoteAuthority:${(0,k.$fn)($)}`;return!!b.activationEvents?.includes(P)}return!1}function g(b){return b.map($=>{const[P,E]=$.split("@");return{proposalName:P,version:E?parseInt(E):void 0}})}function v(b){return b.map($=>$.split("@")[0])}e.$xn=(0,r.$Ci)("IBuiltinExtensionsScannerService")}),define(le[126],he([0,1,3,10,85,6]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=I,e.$dp=p,e.$ep=c,e.$fp=m,e.$gp=h,e.$hp=d,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function I(t){switch(t){case k.TargetPlatform.WIN32_X64:return"Windows 64 bit";case k.TargetPlatform.WIN32_ARM64:return"Windows ARM";case k.TargetPlatform.LINUX_X64:return"Linux 64 bit";case k.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case k.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case k.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case k.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case k.TargetPlatform.DARWIN_X64:return"Mac";case k.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case k.TargetPlatform.WEB:return"Web";case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;case k.TargetPlatform.UNKNOWN:return k.TargetPlatform.UNKNOWN;case k.TargetPlatform.UNDEFINED:return k.TargetPlatform.UNDEFINED}}function p(t){switch(t){case k.TargetPlatform.WIN32_X64:return k.TargetPlatform.WIN32_X64;case k.TargetPlatform.WIN32_ARM64:return k.TargetPlatform.WIN32_ARM64;case k.TargetPlatform.LINUX_X64:return k.TargetPlatform.LINUX_X64;case k.TargetPlatform.LINUX_ARM64:return k.TargetPlatform.LINUX_ARM64;case k.TargetPlatform.LINUX_ARMHF:return k.TargetPlatform.LINUX_ARMHF;case k.TargetPlatform.ALPINE_X64:return k.TargetPlatform.ALPINE_X64;case k.TargetPlatform.ALPINE_ARM64:return k.TargetPlatform.ALPINE_ARM64;case k.TargetPlatform.DARWIN_X64:return k.TargetPlatform.DARWIN_X64;case k.TargetPlatform.DARWIN_ARM64:return k.TargetPlatform.DARWIN_ARM64;case k.TargetPlatform.WEB:return k.TargetPlatform.WEB;case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;default:return k.TargetPlatform.UNKNOWN}}function c(t,u){switch(t){case n.Platform.Windows:return u==="x64"?k.TargetPlatform.WIN32_X64:u==="arm64"?k.TargetPlatform.WIN32_ARM64:k.TargetPlatform.UNKNOWN;case n.Platform.Linux:return u==="x64"?k.TargetPlatform.LINUX_X64:u==="arm64"?k.TargetPlatform.LINUX_ARM64:u==="arm"?k.TargetPlatform.LINUX_ARMHF:k.TargetPlatform.UNKNOWN;case"alpine":return u==="x64"?k.TargetPlatform.ALPINE_X64:u==="arm64"?k.TargetPlatform.ALPINE_ARM64:k.TargetPlatform.UNKNOWN;case n.Platform.Mac:return u==="x64"?k.TargetPlatform.DARWIN_X64:u==="arm64"?k.TargetPlatform.DARWIN_ARM64:k.TargetPlatform.UNKNOWN;case n.Platform.Web:return k.TargetPlatform.WEB}}function m(t,u){return u===k.TargetPlatform.WEB&&!t.includes(k.TargetPlatform.WEB)}function h(t,u,i){return m(u,i)?!1:t===k.TargetPlatform.UNDEFINED||t===k.TargetPlatform.UNIVERSAL?!0:t===k.TargetPlatform.UNKNOWN?!1:t===i}function d(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var w;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var g;(function(t){t.Install="install",t.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var v;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$ip=(0,R.$Ci)("extensionGalleryService");var b;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(b||(e.ExtensionGalleryErrorCode=b={}));class $ extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$jp=$;var P;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class E extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$kp=E,e.$lp=(0,R.$Ci)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,R.$Ci)("IGlobalExtensionEnablementService"),e.$pp=(0,R.$Ci)("IExtensionTipsService"),e.$qp=(0,r.localize2)(11366,"Extensions"),e.$rp=(0,r.localize2)(11367,"Preferences")});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[209],he([0,1,18,81,10,210,85,172]),function(G,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=m,e.$Xp=h,e.$Yp=d,e.$Zp=w,e.$1p=f,e.$2p=g,e.$3p=v,e.$4p=b,r=Ge(r),k=Ie(k),R=Ie(R);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function m(E){return E=E.trim(),E==="*"||p.test(E)}function h(E){if(!m(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=E.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function d(E){if(!E)return null;const t=E.majorBase,u=E.majorMustEqual,i=E.minorBase;let o=E.minorMustEqual;const s=E.patchBase;let a=E.patchMustEqual;E.hasCaret&&(t===0||(o=!1),a=!1);let l=0;if(E.preRelease){const S=c.exec(E.preRelease);if(S){const[,y,D,L]=S;l=Date.UTC(Number(y),Number(D)-1,Number(L))}}return{majorBase:t,majorMustEqual:u,minorBase:i,minorMustEqual:o,patchBase:s,patchMustEqual:a,isMinimum:E.hasGreaterEquals,notBefore:l}}function w(E,t,u){let i;typeof E=="string"?i=d(h(E)):i=E;let o;t instanceof Date?o=t.getTime():typeof t=="string"&&(o=new Date(t).getTime());let s;if(typeof u=="string"?s=d(h(u)):s=u,!i||!s)return!1;const a=i.majorBase,l=i.minorBase,S=i.patchBase;let y=s.majorBase,D=s.minorBase,L=s.patchBase;const A=s.notBefore;let O=s.majorMustEqual,W=s.minorMustEqual,V=s.patchMustEqual;return s.isMinimum?a>y?!0:a<y?!1:l>D?!0:l<D||o&&o<A?!1:S>=L:(a===1&&y===0&&(!O||!W||!V)&&(y=1,D=0,L=0,O=!0,W=!1,V=!1),a<y?!1:a>y?!O:l<D?!1:l>D?!W:S<L?!1:S>L?!V:!(o&&o<A))}function f(E,t,u,i,o,s){const a=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return a.push([r.default.Error,k.localize(11297,null)]),a;if(typeof i.name!="string")return a.push([r.default.Error,k.localize(11298,null,"name")]),a;if(typeof i.version!="string")return a.push([r.default.Error,k.localize(11299,null,"version")]),a;if(!i.engines)return a.push([r.default.Error,k.localize(11300,null,"engines")]),a;if(typeof i.engines.vscode!="string")return a.push([r.default.Error,k.localize(11301,null,"engines.vscode")]),a;if(typeof i.extensionDependencies<"u"&&!P(i.extensionDependencies))return a.push([r.default.Error,k.localize(11302,null,"extensionDependencies")]),a;if(typeof i.activationEvents<"u"){if(!P(i.activationEvents))return a.push([r.default.Error,k.localize(11303,null,"activationEvents")]),a;if(typeof i.main>"u"&&typeof i.browser>"u")return a.push([r.default.Error,k.localize(11304,null,"activationEvents","main","browser")]),a}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&a.push([r.default.Warning,k.localize(11305,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return a.push([r.default.Error,k.localize(11306,null,"main")]),a;{const y=(0,n.$dh)(u,i.main);(0,n.$0g)(y,u)||a.push([r.default.Warning,k.localize(11307,null,y.path,u.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return a.push([r.default.Error,k.localize(11308,null,"browser")]),a;{const y=(0,n.$dh)(u,i.browser);(0,n.$0g)(y,u)||a.push([r.default.Warning,k.localize(11309,null,y.path,u.path)])}}if(!R.valid(i.version))return a.push([r.default.Error,k.localize(11310,null)]),a;const l=[];if(!g(E,t,i,o,l))for(const y of l)a.push([r.default.Error,y]);if(s&&i.enabledApiProposals?.length){const y=[];if(!b([...i.enabledApiProposals],y))for(const D of y)a.push([r.default.Error,D])}return a}function g(E,t,u,i,o){return i||typeof u.main>"u"&&typeof u.browser>"u"?!0:$(E,t,u.engines.vscode,o)}function v(E,t,u){return E==="*"||$(t,u,E)}function b(E,t){if(E.length===0)return!0;const u=Array.isArray(t)?t:void 0,i=(u?void 0:t)??I.allApiProposals,o=[],s=(0,T.$vn)(E);for(const{proposalName:a,version:l}of s){const S=i[a];S&&l&&S.version!==l&&o.push(k.localize(11311,null,a))}return u?.push(...o),o.length===0}function $(E,t,u,i=[]){const o=d(h(u));if(!o)return i.push(k.localize(11312,null,u)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return i.push(k.localize(11313,null,u)),!1}else if(!o.majorMustEqual)return i.push(k.localize(11314,null,u)),!1;return w(E,t,o)?!0:(i.push(k.localize(11315,null,E,u)),!1)}function P(E){if(!Array.isArray(E))return!1;for(let t=0,u=E.length;t<u;t++)if(typeof E[t]!="string")return!1;return!0}}),define(le[211],he([0,1,2,6]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=void 0,e.$Tl=(0,r.$Ci)("remoteSocketFactoryService");class k{constructor(){this.a={}}register(T,I){return this.a[T]??=[],this.a[T].push(I),(0,n.$Rc)(()=>{const p=this.a[T]?.indexOf(I);typeof p=="number"&&p>=0&&this.a[T]?.splice(p,1)})}b(T){return(this.a[T.type]||[]).find(p=>p.supports(T))}connect(T,I,p,c){const m=this.b(T);if(!m)throw new Error(`No socket factory found for ${T}`);return m.connect(T,I,p,c)}}e.$Ul=k}),define(le[212],he([0,1,26,27,48,121]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=I,n=Ie(n),r=Ie(r),k=Ie(k),R=Ie(R);let T;async function I(w=!1){return(T===void 0||w)&&(T=p()),T}async function p(){const w=c();if(w===void 0)return!1;if(w>=22e3){const f=h();if(f)return new Promise(g=>{k.execFile(f,["--status"],v=>g(!v))})}else{const f=d();if(f)try{if((await n.promises.stat(f)).isFile())return!0}catch{}}return!1}function c(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(r.release());if(w)return parseInt(w[3])}function m(w){const f=process.env.SystemRoot;if(f){const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(f,g?"Sysnative":"System32",w)}}function h(){return m("wsl.exe")}function d(){return m("lxss\\LxssManager.dll")}}),define(le[56],he([0,1,17,15,2,10,55,6,5,45]),function(G,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=d,e.$8p=w,e.$9p=f,e.$0p=g,e.$$p=v,e.$_p=b,e.$5p=(0,I.$Ci)("requestService");class m{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const u in this.b)u.toLowerCase()==="authorization"||u.toLowerCase()==="proxy-authorization"?t[u]="*****":t[u]=this.b[u];this.a=t}return this.a}}class h extends k.$Tc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,R.localize)(11084,null),when:p.$pk.isEqualTo((0,p.$mk)(p.LogLevel.Trace)).serialize()})}async c(t,u,i){const o=`${t} #${++this.b}: ${u.url}`;this.a.trace(`${o} - begin`,u.type,new m(u.headers??{}));try{const s=await i();return this.a.trace(`${o} - end`,u.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,u.type,(0,r.$9)(s)),s}}}e.$6p=h;function d(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function w(E){return E.res.statusCode===204}async function f(E){return w(E)?null:(await(0,n.$Xe)(E.stream)).toString()}async function g(E){if(!d(E))throw new Error("Server returned "+E.res.statusCode);return f(E)}async function v(E){if(!d(E))throw new Error("Server returned "+E.res.statusCode);if(w(E))return null;const u=(await(0,n.$Xe)(E.stream)).toString();try{return JSON.parse(u)}catch(i){throw i.message+=`:
`+u,i}}function b(E){P(E)}let $;function P(E){const t=c.$oo.as(T.$to.Configuration),u=$;$={id:"http",order:15,title:(0,R.localize)(11085,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(11086,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(11087,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(11088,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(11089,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(11090,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(11091,null),(0,R.localize)(11092,null),(0,R.localize)(11093,null),(0,R.localize)(11094,null)],default:"override",description:(0,R.localize)(11095,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11096,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(11097,null),restricted:!0}}},t.updateConfigurations({add:[$],remove:u?[u]:[]})}P(T.ConfigurationScope.APPLICATION)}),define(le[213],he([0,1,17,22]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=void 0;class k{constructor(I){this.a=I}listen(I,p){throw new Error("Invalid listen")}call(I,p,c,m=r.CancellationToken.None){switch(p){case"request":return this.a.request(c[0],m).then(async({res:h,stream:d})=>{const w=await(0,n.$Xe)(d);return[{statusCode:h.statusCode,headers:h.headers},w]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"lookupAuthorization":return this.a.lookupAuthorization(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$_r=k;class R{constructor(I){this.a=I}async request(I,p){const[c,m]=await this.a.call("request",[I],p);return{res:c,stream:(0,n.$Ze)(m)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async lookupAuthorization(I){return this.a.call("lookupAuthorization",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$as=R}),define(le[214],he([0,1,215,12]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=R;function k(T,I){return T.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:T.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function R(T,I,p={}){const c=(0,n.parse)(T),m=p.proxyUrl||k(c,I);if(!m)return null;const h=(0,n.parse)(m);if(!/^https?:$/.test(h.protocol||""))return null;const d={host:h.hostname||"",port:(h.port?+h.port:0)||(h.protocol==="https"?443:80),auth:h.auth,rejectUnauthorized:(0,r.$ig)(p.strictSSL)?p.strictSSL:!0};if(c.protocol==="http:"){const w=await new Promise((f,g)=>{G(["http-proxy-agent"],f,g)}).then(Ie);return new w.HttpProxyAgent(m,d)}else{const w=await new Promise((f,g)=>{G(["https-proxy-agent"],f,g)}).then(Ie);return new w.HttpsProxyAgent(m,d)}}}),define(le[216],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=e.$hgc=void 0,e.$hgc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$igc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$jgc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[100],he([0,1,48,9,10,22,54,15,3,33,116,68,8,144]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=g;let f;async function g(b,$,P,E){return P["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,h.$Hm)(E)&&!P["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,h.$Hm)(E)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=d.Promises.withAsyncBody(async(t,u)=>{const i=new R.$ue;let o=1e4;const s=b.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(o=(0,w.$Im)(s,1,120)*1e3);const a=setTimeout(()=>{i.dispose(!0),u(new Error((0,k.localize)(11081,null)))},o);try{t(await v($,i.token))}catch(l){!(0,I.$3)(l)&&!i.token.isCancellationRequested?u(new Error((0,k.localize)(11082,null,(0,T.$nj)(l)))):t({})}finally{clearTimeout(a),i.dispose()}})),f)}async function v(b,$){const P=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",P);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",E);const t=(0,c.$Yg)().replace(/-/g,"").substr(0,12),u=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",i);const o=await(0,m.$xm)(p.OS,i);return b.trace("getUnixShellEnvironment#shell",o),new Promise((s,a)=>{if($.isCancellationRequested)return a(new I.$4);const l=(0,r.$mc)(o);let S,y;const D="";/^pwsh(-preview)?$/.test(l)?(S=`& '${process.execPath}' ${D} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,y=["-Login","-Command"]):l==="nu"?(S=`^'${process.execPath}' ${D} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,y=["-i","-l","-c"]):l==="xonsh"?(S=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,y=["-i","-l","-c"]):(S=`'${process.execPath}' ${D} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,l==="tcsh"||l==="csh"?y=["-ic"]:y=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),S);const L=(0,n.spawn)(o,[...y,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});$.onCancellationRequested(()=>(L.kill(),a(new I.$4))),L.on("error",W=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,T.$nj)(W)),a(W)});const A=[];L.stdout.on("data",W=>A.push(W));const O=[];L.stderr.on("data",W=>O.push(W)),L.on("close",(W,V)=>{const H=Buffer.concat(A).toString("utf8");b.trace("getUnixShellEnvironment#raw",H);const Y=Buffer.concat(O).toString("utf8");if(Y.trim()&&b.trace("getUnixShellEnvironment#stderr",Y),W||V)return a(new Error((0,k.localize)(11083,null,W,V)));const Z=u.exec(H),U=Z?Z[1]:"{}";try{const te=JSON.parse(U);P?te.ELECTRON_RUN_AS_NODE=P:delete te.ELECTRON_RUN_AS_NODE,E?te.ELECTRON_NO_ATTACH_CONSOLE=E:delete te.ELECTRON_NO_ATTACH_CONSOLE,delete te.VSCODE_RESOLVING_ENVIRONMENT,delete te.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",te),s(te)}catch(te){b.error("getUnixShellEnvironment#errorCaught",(0,T.$nj)(te)),a(te)}})})}}),define(le[217],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(k){try{const R=await this.c();if(R){const T=String(n.a++);return this.b.set(T,R),{id:T,data:R.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const T=this.b.get(k.id);if(!T)return!1;this.b.delete(k.id);try{return T.validate(R)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(k){try{return await this.d(k)}catch{}return k}}e.$5bc=n}),define(le[101],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl="signService",e.$Wl=(0,n.$Ci)(e.$Vl)}),define(le[218],he([0,1,217]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class r extends n.$5bc{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(T=>new T.signer().sign(R))}h(){return new Promise((R,T)=>G(["vsda"],R,T))}}e.$_gc=r}),define(le[34],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=e.$mR=void 0,e.$mR=(0,n.$Ci)("stateReadService"),e.$nR=(0,n.$Ci)("stateService")}),define(le[127],he([0,1,8,17,2,12,38,14,5]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qR=e.$pR=e.$oR=e.SaveStrategy=void 0;var c;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class m extends k.$Tc{constructor(f,g,v,b){super(),this.h=f,this.j=g,this.m=v,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Ah(this.j===c.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(f)}}getItem(f,g){const v=this.a[f];return(0,R.$lg)(v)?g:v}setItem(f,g){this.setItems([{key:f,data:g}])}setItems(f){let g=!1;for(const{key:v,data:b}of f)this.a[v]!==b&&((0,R.$lg)(b)?(0,R.$jg)(this.a[v])||(this.a[v]=void 0,g=!0):(this.a[v]=b,g=!0));g&&this.s()}removeItem(f){(0,R.$jg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,r.$Le.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(g){this.m.error(g)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$oR=m;let h=class extends k.$Tc{constructor(f,g,v,b){super(),this.a=this.B(new m(g.stateResource,f,v,b))}async init(){await this.a.init()}getItem(f,g){return this.a.getItem(f,g)}};e.$pR=h,e.$pR=h=Ee([oe(1,T.$Ji),oe(2,p.$0j),oe(3,I.$0k)],h);class d extends h{setItem(f,g){this.a.setItem(f,g)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$qR=d}),define(le[128],he([0,1,3,36,33]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=T,e.$tp=I;function R(p){if(n.$v===n.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function T(p,c,m,h,d,w,f,g,v,b){const $=Object.create(null);$["common.machineId"]=w,$["common.sqmId"]=f,$["common.devDeviceId"]=g,$.sessionID=(0,k.$Yg)()+Date.now(),$.commitHash=h,$.version=d,$["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$i)(n.$v),$["common.nodePlatform"]=r.$cc,$["common.nodeArch"]=m,$["common.product"]=b||"desktop",v&&($["common.msftInternal"]=v);let P=0;const E=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-E,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),n.$m&&($["common.snap"]="true");const t=R(c);return t&&($["common.platformDetail"]=t),$}function I(p){const c=r.env.USERDNSDOMAIN;if(!c)return!1;const m=c.toLowerCase();return p.some(h=>m===h)}}),define(le[24],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=void 0,e.$9l=(0,n.$Ci)("telemetryService"),e.$0l=(0,n.$Ci)("customEndpointTelemetryService"),e.$$l="telemetry.currentSessionDate",e.$_l="telemetry.firstSessionDate",e.$am="telemetry.lastSessionDate",e.$bm="telemetry.machineId",e.$cm="telemetry.sqmId",e.$dm="telemetry.devDeviceId",e.$em="telemetry",e.$fm="telemetry.telemetryLevel",e.$gm="telemetry.enableCrashReporter",e.$hm="telemetry.enableTelemetry";var r;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(le[219],he([0,1,26,27,8,43,11,9,3,66,7,92,23,115,96,14,28,24]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Vs=P,e.$Ws=t,e.$Xs=u,n=Ie(n),r=Ie(r);const $=new Map;async function P(o,s){const a=`${o}::${s.join(":")}`,l=$.get(a);if(l)return l;const S=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],y=new Map,D=new Map,L=2e4;function A(W,V,H,Y){const Z=V.substring(W.length+1);return k.Promises.withAsyncBody(async U=>{let te;Y.readdirCount++;try{te=await d.Promises.readdir(V,{withFileTypes:!0})}catch{U();return}if(Y.count>=L){Y.count+=te.length,Y.maxReached=!0,U();return}let x=te.length;if(x===0){U();return}let J=te;Y.count+te.length>L&&(Y.maxReached=!0,x=L-Y.count,J=te.slice(0,x)),Y.count+=te.length;for(const B of J)if(B.isDirectory()){if(H.includes(B.name)||await A(W,(0,I.$ic)(V,B.name),H,Y),--x===0){U();return}}else{const j=B.name.lastIndexOf(".");if(j>=0){const C=B.name.substring(j+1);C&&y.set(C,(y.get(C)??0)+1)}for(const C of S)C.relativePathPattern?.test(Z)!==!1&&C.filePattern.test(B.name)&&D.set(C.tag,(D.get(C.tag)??0)+1);if(--x===0){U();return}}})}const O=k.Promises.withAsyncBody(async W=>{const V={count:0,maxReached:!1,readdirCount:0},H=new c.$de(!0);await A(o,o,s,V);const Y=await u(o);W({configFiles:E(D),fileTypes:E(y),fileCount:V.count,maxFilesReached:V.maxReached,launchConfigFiles:Y,totalScanTime:H.elapsed(),totalReaddirCount:V.readdirCount})});return $.set(a,O),O}function E(o){return Array.from(o.entries(),([s,a])=>({name:s,count:a})).sort((s,a)=>a.count-s.count)}function t(){const o={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/g.$Fl.GB).toFixed(2)}GB (${(r.freemem()/g.$Fl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.$Pn.value()*100)}%`},s=r.cpus();return s&&s.length>0&&(o.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),o}async function u(o){try{const s=new Map,a=(0,I.$ic)(o,".vscode","launch.json"),l=await n.promises.readFile(a),S=[],y=(0,R.$Vn)(l.toString(),S);if(S.length)return console.log(`Unable to parse ${a}`),[];if((0,R.$4n)(y)==="object"&&y.configurations)for(const D of y.configurations){const L=D.type;L&&(s.has(L)?s.set(L,s.get(L)+1):s.set(L,1))}return E(s)}catch{return[]}}let i=class{constructor(s,a){this.c=s,this.d=a}f(s){const a=[];return a.push(`OS Version:       ${s.os}`),a.push(`CPUs:             ${s.cpus}`),a.push(`Memory (System):  ${s.memory}`),a.push(`VM:               ${s.vmHint}`),a.join(`
`)}g(s){const a=[];a.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),a.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const l=r.cpus();return l&&l.length>0&&a.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),a.push(`Memory (System):  ${(r.totalmem()/g.$Fl.GB).toFixed(2)}GB (${(r.freemem()/g.$Fl.GB).toFixed(2)}GB free)`),p.$j||a.push(`Load (avg):       ${r.loadavg().map(S=>Math.round(S)).join(", ")}`),a.push(`VM:               ${Math.round(h.$Pn.value()*100)}%`),a.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${s.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(s,a){return Promise.all([(0,w.$Us)(s.mainPID),this.k(s)]).then(async l=>{let[S,y]=l,D=this.m(s,S);return a.forEach(L=>{if((0,f.$Rm)(L))D+=`
${L.errorMessage}`,y+=`
${L.errorMessage}`;else if(D+=`

Remote: ${L.hostName}`,L.processes&&(D+=`
${this.m(s,L.processes)}`),L.workspaceMetadata){y+=`
|  Remote: ${L.hostName}`;for(const A of Object.keys(L.workspaceMetadata)){const O=L.workspaceMetadata[A];let W=`${O.fileCount} files`;O.maxFilesReached&&(W=`more than ${W}`),y+=`|    Folder (${A}): ${W}`,y+=this.h(O)}}}),{processInfo:D,workspaceInfo:y}})}async getSystemInfo(s,a){const{memory:l,vmHint:S,os:y,cpus:D}=t(),L={os:y,memory:l,cpus:D,vmHint:S,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:a};return p.$j||(L.load=`${r.loadavg().map(A=>Math.round(A)).join(", ")}`),p.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(s,a){const l=[];return(0,w.$Us)(s.mainPID).then(async S=>(l.push(""),l.push(this.g(s)),l.push(""),l.push(this.m(s,S)),s.windows.some(y=>y.folderURIs&&y.folderURIs.length>0&&!y.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.k(s))),a.forEach(y=>{if((0,f.$Rm)(y))l.push(`
${y.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${y.hostName}`),l.push(this.f(y.machineInfo)),y.processes&&l.push(this.m(s,y.processes)),y.workspaceMetadata)for(const D of Object.keys(y.workspaceMetadata)){const L=y.workspaceMetadata[D];let A=`${L.fileCount} files`;L.maxFilesReached&&(A=`more than ${A}`),l.push(`Folder (${D}): ${A}`),l.push(this.h(L))}}),l.push(""),l.push(""),l.join(`
`)))}h(s){const a=[];let S=0;const y=(O,W)=>{const V=` ${O}(${W})`;S+V.length>60?(a.push(D),D="|                 ",S=D.length):S+=V.length,D+=V};let D="|      File types:";const L=10,A=s.fileTypes.length>L?L:s.fileTypes.length;for(let O=0;O<A;O++){const W=s.fileTypes[O];y(W.name,W.count)}if(a.push(D),s.configFiles.length>=0&&(D="|      Conf files:",S=0,s.configFiles.forEach(O=>{y(O.name,O.count)}),a.push(D)),s.launchConfigFiles.length>0){let O="|      Launch Configs:";s.launchConfigFiles.forEach(W=>{const V=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`;O+=V}),a.push(O)}return a.join(`
`)}j(s){const a=Math.max(...Object.keys(s).map(l=>l.length));return Object.keys(s).map(l=>`${l}:  ${" ".repeat(a-l.length)}  ${s[l]}`).join(`
                  `)}k(s){const a=[],l=[];return s.windows.forEach(S=>{S.folderURIs.length===0||S.remoteAuthority||(a.push(`|  Window (${S.title})`),S.folderURIs.forEach(y=>{const D=m.URI.revive(y);if(D.scheme===T.Schemas.file){const L=D.fsPath;l.push(P(L,["node_modules",".git"]).then(A=>{let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),a.push(`|    Folder (${(0,I.$mc)(L)}): ${O}`),a.push(this.h(A))}).catch(A=>{a.push(`|      Error: Unable to collect workspace stats for folder ${L} (${A.toString()})`)}))}else a.push(`|    Folder (${D.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(S=>a.join(`
`)).catch(S=>`Unable to collect workspace stats: ${S}`)}m(s,a){const l=new Map;s.windows.forEach(y=>l.set(y.pid,`window [${y.id}] (${y.title})`)),s.pidToNames.forEach(({pid:y,name:D})=>l.set(y,D));const S=[];return S.push("CPU %	Mem MB	   PID	Process"),a&&this.n(s.mainPID,l,S,a,0),S.join(`
`)}n(s,a,l,S,y){const D=y===0;let L;D?L=S.pid===s?`${this.d.applicationName} main`:"remote agent":a.has(S.pid)?L=a.get(S.pid):L=`${"  ".repeat(y)} ${S.name}`;const A=process.platform==="win32"?S.mem:r.totalmem()*(S.mem/100);l.push(`${S.load.toFixed(0).padStart(5," ")}	${(A/g.$Fl.MB).toFixed(0).padStart(6," ")}	${S.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(S.children)&&S.children.forEach(O=>this.n(s,a,l,O,y+1))}async getWorkspaceFileExtensions(s){const a=new Set;for(const{uri:l}of s.folders){const S=m.URI.revive(l);if(S.scheme!==T.Schemas.file)continue;const y=S.fsPath;try{(await P(y,["node_modules",".git"])).fileTypes.forEach(L=>a.add(L.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(s){for(const{uri:a}of s.folders){const l=m.URI.revive(a);if(l.scheme!==T.Schemas.file)continue;const S=l.fsPath;try{const y=await P(S,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),y.fileTypes.forEach(D=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),y.launchConfigFiles.forEach(D=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),y.configFiles.forEach(D=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:y.totalScanTime,reachedLimit:y.maxFilesReached,fileCount:y.fileCount,readdirCount:y.totalReaddirCount})}catch{}}}};e.$Ys=i,e.$Ys=i=Ee([oe(0,b.$9l),oe(1,v.$qk)],i)}),define(le[220],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=e.$mgc=void 0;class n{constructor(R){this.b=R}listen(R,T){throw new Error(`Event not found: ${T}`)}call(R,T,{eventName:I,data:p}){return this.b.forEach(c=>c.log(I,p)),Promise.resolve(null)}}e.$mgc=n;class r{constructor(R){this.b=R}log(R,T){return this.b.call("log",{eventName:R,data:T}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$ngc=r}),define(le[57],he([0,1,37,12,74,128,24]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=m,e.$Cp=h,e.$Dp=d,e.$Ep=w,e.$Fp=g,e.$Gp=b,e.$Hp=$,e.$Ip=t;class I{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$up=I;class p{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=p,e.$wp=new p;class c{async publicLog(i,o,s){}async publicLogError(i,o,s){}}e.$xp=c,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function m(u,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!u.enableTelemetry)}function h(u,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}function d(u){const i=u.getValue(T.$fm),o=u.getValue(T.$gm);if(u.getValue(T.$hm)===!1||o===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function w(u){const i={},o={},s={};v(u,s);for(let a in s){a=a.length>150?a.substr(a.length-149):a;const l=s[a];typeof l=="number"?o[a]=l:typeof l=="boolean"?o[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),i[a]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(i[a]=l)}return{properties:i,measurements:o}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(u){if(!u)return"none";const i=(0,k.$fn)(u);return f.has(i)?i:"other"}function v(u,i,o=0,s){if(u)for(const a of Object.getOwnPropertyNames(u)){const l=u[a],S=s?s+a:a;Array.isArray(l)?i[S]=(0,n.$go)(l):l instanceof Date?i[S]=l.toISOString():(0,r.$eg)(l)?o<2?v(l,i,o+1,S+"."):i[S]=(0,n.$go)(l):i[S]=l}}function b(u,i){const o=u.msftInternalDomains||[],s=i.getValue("telemetry.internalTesting");return(0,R.$tp)(o)||s}function $(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}function P(u,i){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let o=u;const s=[];for(const y of i)for(;;){const D=y.exec(u);if(!D)break;s.push([D.index,y.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(o="";;){const y=l.exec(u);if(!y)break;const D=s.some(([L,A])=>y.index<A&&L<l.lastIndex);!a.test(y[0])&&!D&&(o+=u.substring(S,y.index)+"<REDACTED: user-file-path>",S=l.lastIndex)}return S<u.length&&(o+=u.substr(S)),o}function E(u){if(!u)return u;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of i)if(o.regex.test(u))return`<REDACTED: ${o.label}>`;return u}function t(u,i){return(0,n.$do)(u,o=>{if(o instanceof I||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let s=o.replaceAll("%20"," ");s=P(s,i);for(const a of i)s=s.replace(a,"");return s=E(s),s}})}}),define(le[129],he([0,1,25,126,85,3,7,15,36,57]),function(G,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=m,e.$Lp=f,e.$Mp=g,e.$Np=v,e.$Op=b,e.$Pp=$,e.$Qp=P,e.$Rp=E,e.$Tp=t,e.$Up=i;function m(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,n.$yf)(o.id,s.id)===0}const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(s){const a=s.manifest?s.manifest.version:s.version,l=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new d(s.identifier,a,l)}static parse(s){const a=h.exec(s);return a&&a[1]&&a[2]?new d({id:a[1]},a[2],a[4]||void 0):null}constructor(s,a,l=k.TargetPlatform.UNDEFINED){this.identifier=s,this.version=a,this.targetPlatform=l,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==k.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof d?m(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Kp=d;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const s=w.exec(o);return s&&s[1]?[v(s[1]),s[2]]:[v(o),void 0]}function g(o,s){return`${o}.${s}`}function v(o){return o.toLowerCase()}function b(o,s){return v(g(o??k.$kn,s))}function $(o,s){const a=[],l=S=>{for(const y of a)if(y.some(D=>m(s(D),s(S))))return y;return null};for(const S of o){const y=l(S);y?y.push(S):a.push([S])}return a}function P(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function E(o){return{id:new c.$up(o.identifier.id),name:new c.$up(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Sp=new k.$on("pprice.better-merge");function t(o,s){const a=[],l=s.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const S=l.shift();if(S&&a.every(y=>!m(y.identifier,{id:S}))){const y=o.filter(D=>m(D.identifier,{id:S}));y.length===1&&(a.push(y[0]),l.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function u(o,s){if(!R.$l)return!1;let a;try{a=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){s.debug("Error while getting the os-release file.",(0,I.$9)(S))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(o,s){const a=await u(o,s),l=(0,r.$ep)(a?"alpine":R.$v,p.$dc);return s.debug("ComputeTargetPlatform:",l),l}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[221],he([0,1,2,37,3,25,10,16,55,72,28,45,24,57]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,c=Ge(c);let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,$,P){this.k=$,this.l=P,this.d={},this.i=new n.$Sc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=d.TelemetryLevel.USAGE,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,R.$ff)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$ff)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(d.$fm)||E.affectsConfiguration(d.$hm)||E.affectsConfiguration(d.$gm))&&this.m()}))}setExperimentProperty(b,$){this.d[b]=$}m(){let b=(0,w.$Dp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const P=$.usage?d.TelemetryLevel.USAGE:$.error?d.TelemetryLevel.ERROR:d.TelemetryLevel.NONE;b=Math.min(b,P)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,$,P){this.g<$||(P=(0,r.$eo)(P,this.d),P=(0,w.$Ip)(P,this.j),P=(0,r.$eo)(P,this.c),this.b.forEach(E=>E.log(b,P)))}publicLog(b,$){this.n(b,d.TelemetryLevel.USAGE,$)}publicLog2(b,$){this.publicLog(b,$)}publicLogError(b,$){this.h&&this.n(b,d.TelemetryLevel.ERROR,$)}publicLogError2(b,$){this.publicLogError(b,$)}};e.$es=f,e.$es=f=Ee([oe(1,I.$9i),oe(2,m.$qk)],f);function g(){const v=(0,T.localize)(11062,null,c.default.nameLong),b=c.default.privacyStatementUrl?(0,T.localize)(11064,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,T.localize)(11063,null,"https://aka.ms/vscode-telemetry"),$=k.$p?"":(0,T.localize)(11065,null),P=(0,T.localize)(11066,null),E=(0,T.localize)(11067,null),t=(0,T.localize)(11068,null),u=(0,T.localize)(11069,null),i=`
|       | ${P} | ${E} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,T.localize)(11070,null);return`
${v} ${b} ${$}

&nbsp;

${u}
${i}

&nbsp;

${o}
`}h.$oo.as(p.$to.Configuration).registerConfiguration({id:d.$em,order:1,type:"object",title:(0,T.localize)(11071,null),properties:{[d.$fm]:{type:"string",enum:[d.TelemetryConfiguration.ON,d.TelemetryConfiguration.ERROR,d.TelemetryConfiguration.CRASH,d.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(11072,null),(0,T.localize)(11073,null),(0,T.localize)(11074,null),(0,T.localize)(11075,null)],markdownDescription:g(),default:d.TelemetryConfiguration.ON,restricted:!0,scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),h.$oo.as(p.$to.Configuration).registerConfiguration({id:d.$em,order:110,type:"object",title:(0,T.localize)(11076,null),properties:{[d.$hm]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,T.localize)(11078,null,c.default.nameLong,c.default.privacyStatementUrl):(0,T.localize)(11077,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(11079,null,`\`#${d.$fm}#\``),scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[222],he([0,1,3,92,24]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=R,e.$Pgc=T,e.$Qgc=I;async function R(p,c){let m=p.getItem(k.$bm);return(typeof m!="string"||n.$k&&m==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(m=await(0,r.$Qn)(c.error.bind(c))),m}async function T(p,c){let m=p.getItem(k.$cm);return typeof m!="string"&&(m=await(0,r.$Rn)(c.error.bind(c))),m}async function I(p,c){let m=p.getItem(k.$dm);return typeof m!="string"&&(m=await(0,r.$Sn)(c.error.bind(c))),m}}),define(le[223],he([0,1,24,222]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=k,e.$Sgc=R,e.$Tgc=T;async function k(I,p){const c=await(0,r.$Ogc)(I,p);return I.setItem(n.$bm,c),c}async function R(I,p){const c=await(0,r.$Pgc)(I,p);return I.setItem(n.$cm,c),c}async function T(I,p){const c=await(0,r.$Qgc)(I,p);return I.setItem(n.$dm,c),c}}),define(le[130],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(le[224],he([0,1,3,130]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;const k=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((h,d)=>{this.d(h,d);const w=h.map.entries();let f=w.next();for(;!f.done;){const g=f.value[1],v=f.value[0];let b=this.a.get(v);if(b||(b=[],this.a.set(v,b)),b.length>0&&b[0].type===r.EnvironmentVariableMutatorType.Replace){f=w.next();continue}const $={extensionIdentifier:d,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};$.scope||delete $.scope,b.unshift($),f=w.next()}})}async applyToProcessEnvironment(m,h,d){let w;n.$j&&(w={},Object.keys(m).forEach(f=>w[f.toLowerCase()]=f));for(const[f,g]of this.getVariableMap(h)){const v=n.$j&&w[f.toLowerCase()]||f;for(const b of g){const $=d?await d(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case r.EnvironmentVariableMutatorType.Append:m[v]=(m[v]||"")+$;break;case r.EnvironmentVariableMutatorType.Prepend:m[v]=$+(m[v]||"");break;case r.EnvironmentVariableMutatorType.Replace:m[v]=$;break}if(b.options?.applyAtShellIntegration??!1){const P=`VSCODE_ENV_${k.get(b.type)}`;m[P]=(m[P]?m[P]+":":"")+f+"="+this.c($)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,h){const d=new Map,w=new Map,f=new Map;if(m.getVariableMap(h).forEach((g,v)=>{const b=this.getVariableMap(h).get(v),$=I(g,b);$&&d.set(v,$)}),this.getVariableMap(h).forEach((g,v)=>{const b=m.getVariableMap(h).get(v),$=I(g,b);$&&f.set(v,$)}),this.getVariableMap(h).forEach((g,v)=>{const b=m.getVariableMap(h).get(v),$=p(g,b);$&&w.set(v,$)}),!(d.size===0&&w.size===0&&f.size===0))return{added:d,changed:w,removed:f}}getVariableMap(m){const h=new Map;for(const d of this.a.values()){const w=d.filter(f=>T(f,m));w.length>0&&h.set(w[0].variable,w)}return h}getDescriptionMap(m){const h=new Map;for(const d of this.b.values()){const w=d.filter(f=>T(f,m,!0));for(const f of w)h.set(f.extensionIdentifier,f.description)}return h}d(m,h){if(!m.descriptionMap)return;const d=m.descriptionMap.entries();let w=d.next();for(;!w.done;){const f=w.value[1],g=w.value[0];let v=this.b.get(g);v||(v=[],this.b.set(g,v));const b={extensionIdentifier:h,scope:f.scope,description:f.description};b.scope||delete b.scope,v.push(b),w=d.next()}}}e.$Is=R;function T(c,m,h=!1){return c.scope?!!(c.scope.workspaceFolder&&m?.workspaceFolder&&c.scope.workspaceFolder.index===m.workspaceFolder.index):h?m===c.scope:!0}function I(c,m){if(!m)return c;const h=new Set;m.forEach(w=>h.add(w.extensionIdentifier));const d=[];return c.forEach(w=>{h.has(w.extensionIdentifier)||d.push(w)}),d.length===0?void 0:d}function p(c,m){if(!m)return;const h=new Map;m.forEach(w=>h.set(w.extensionIdentifier,w));const d=[];return c.forEach(w=>{const f=h.get(w.extensionIdentifier);f&&(w.type!==f.type||w.value!==f.value||w.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&d.push(f)}),d.length===0?void 0:d}}),define(le[225],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=n,e.$Ds=r,e.$Es=k,e.$Fs=R,e.$Gs=T,e.$Hs=I;function n(p){return[...p.entries()]}function r(p){return p?[...p.entries()]:[]}function k(p){return new Map(p)}function R(p){return new Map(p??[])}function T(p){return Array.from(p.entries()).map(c=>[c[0],n(c[1].map),r(c[1].descriptionMap)])}function I(p){return new Map(p.map(c=>[c[0],{map:k(c[1]),descriptionMap:R(c[2])}]))}}),define(le[226],he([0,1,8,22,4,2,5]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=void 0;let I=class extends R.$Tc{constructor(c,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new k.$je),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,R.$Rc)(()=>{for(const h of this.f.values())(0,R.$Oc)(h)}))}createRequest(c){return new Promise((m,h)=>{const d=++this.a;this.c.set(d,m),this.g.fire({requestId:d,...c});const w=new r.$ue;(0,n.$Dh)(this.b,w.token).then(()=>h(`Request ${d} timed out (${this.b}ms)`)),this.f.set(d,[(0,R.$Rc)(()=>w.cancel())])})}acceptReply(c,m){const h=this.c.get(c);h?(this.c.delete(c),(0,R.$Oc)(this.f.get(c)||[]),this.f.delete(c),h(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$ts=I,e.$ts=I=Ee([oe(1,T.$0j)],I)}),define(le[75],he([0,1,6,122,45]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ms=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ls=void 0,e.$ls=new r.$Tj("terminalTabFocusMode",!1,!0);var R;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var T;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var I;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(I||(e.PosixShellType=I={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var m;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var h;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(h||(e.ProcessPropertyType=h={})),e.$ms=(0,n.$Ci)("ptyService");var d;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d||(e.HeartbeatConstants=d={}));var w;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var f;(function(t){t.TerminalView="view",t.Editor="editor"})(f||(e.TerminalLocationString=f={}));var g;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var v;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(v||(e.FlowControlConstants=v={}));var b;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(b||(e.ProfileSource=b={}));var $;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})($||(e.ShellIntegrationStatus=$={}));var P;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(P||(e.TerminalExitReason=P={})),e.$ns={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(u){const i=this.b(u.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,u)}getTerminalBackend(u){return this.a.get(this.b(u))}b(u){return u?.toLowerCase()??""}}k.$oo.add(e.$ns.Backend,new E),e.$os=(0,n.$Ci)("localPtyService"),e.$ps=(0,n.$Ci)("terminalLogService")}),define(le[227],he([0,1,80,7,10,110]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=T,e.$vs=c,e.$ws=m,e.$xs=h;function T(d,w){const f=[{name:null,description:(0,k.localize)(11029,null)}];return f.push(...d.map(g=>({name:g.profileName,description:I(g)}))),w&&f.push(...w.map(g=>({name:g.title,description:p(g)}))),{values:f.map(g=>g.name),markdownDescriptions:f.map(g=>g.description)}}function I(d){let w=`$(${R.ThemeIcon.isThemeIcon(d.icon)?d.icon.id:d.icon?d.icon:n.$2j.terminal.id}) ${d.profileName}
- path: ${d.path}`;return d.args&&(typeof d.args=="string"?w+=`
- args: "${d.args}"`:w+=`
- args: [${d.args.length===0?"":`'${d.args.join("','")}'`}]`),d.overrideName!==void 0&&(w+=`
- overrideName: ${d.overrideName}`),d.color&&(w+=`
- color: ${d.color}`),d.env&&(w+=`
- env: ${JSON.stringify(d.env)}`),w}function p(d){return`$(${R.ThemeIcon.isThemeIcon(d.icon)?d.icon.id:d.icon?d.icon:n.$2j.terminal.id}) ${d.title}
- extensionIdentifier: ${d.extensionIdentifier}`}function c(d,w){if(!d&&!w)return!0;if(typeof d=="string"&&typeof w=="string")return d===w;if(Array.isArray(d)&&Array.isArray(w)){if(d.length!==w.length)return!1;for(let f=0;f<d.length;f++)if(d[f]!==w[f])return!1;return!0}return!1}function m(d,w){if(!d&&!w)return!0;if(!d||!w)return!1;if(R.ThemeIcon.isThemeIcon(d)&&R.ThemeIcon.isThemeIcon(w))return d.id===w.id&&d.color===w.color;if(typeof d=="object"&&"light"in d&&"dark"in d&&typeof w=="object"&&"light"in w&&"dark"in w){const f=d,g=w;if((r.URI.isUri(f.light)||h(f.light))&&(r.URI.isUri(f.dark)||h(f.dark))&&(r.URI.isUri(g.light)||h(g.light))&&(r.URI.isUri(g.dark)||h(g.dark)))return f.light.path===g.light.path&&f.dark.path===g.dark.path}if(r.URI.isUri(d)&&r.URI.isUri(w)||h(d)||h(w)){const f=d,g=w;return f.path===g.path&&f.scheme===g.scheme}return!1}function h(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}}),define(le[228],he([0,1,80,3,10,55,45,75,227]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=e.$ys=void 0,e.$As=f,e.$Bs=v,e.$ys={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$zs={type:"string",enum:Array.from((0,n.$Zj)(),b=>b.id),markdownEnumDescriptions:Array.from((0,n.$Zj)(),b=>`$(${b.id})`)};const c={args:{description:(0,k.localize)(11030,null),type:"array",items:{type:"string"}},overrideName:{description:(0,k.localize)(11031,null),type:"boolean"},icon:{description:(0,k.localize)(11032,null),...e.$zs},color:{description:(0,k.localize)(11033,null),...e.$ys},env:{markdownDescription:(0,k.localize)(11034,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(11035,null),type:["string","array"],items:{type:"string"}},...c}},h={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(11036,null),type:["string"],items:{type:"string"}},...c}};function d(b){const $=b===r.Platform.Linux?"linux":b===r.Platform.Mac?"osx":"windows";return(0,k.localize)(11037,null,(0,r.$i)(b),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,k.localize)(11038,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,k.localize)(11039,null),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,k.localize)(11040,null),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,k.localize)(11041,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:d(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,k.localize)(11042,null),enum:["PowerShell","Git Bash"]},...c}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(11043,null),type:"string"},id:{description:(0,k.localize)(11044,null),type:"string"},title:{description:(0,k.localize)(11045,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:d(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(11046,null),type:"string"},id:{description:(0,k.localize)(11047,null),type:"string"},title:{description:(0,k.localize)(11048,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:d(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(11049,null),type:"string"},id:{description:(0,k.localize)(11050,null),type:"string"},title:{description:(0,k.localize)(11051,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,k.localize)(11052,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:R.ConfigurationScope.APPLICATION,description:(0,k.localize)(11053,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:R.ConfigurationScope.APPLICATION,markdownDescription:(0,k.localize)(11054,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:R.ConfigurationScope.APPLICATION,description:(0,k.localize)(11055,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,k.localize)(11056,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){T.$oo.as(R.$to.Configuration).registerConfiguration(w),v()}let g;function v(b,$){const P=T.$oo.as(R.$to.Configuration);let E;b&&(E=(0,p.$us)(b?.profiles,$));const t=g;g={id:"terminal",order:100,title:(0,k.localize)(11057,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,k.localize)(11058,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Linux?E?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Linux?E?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,k.localize)(11059,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Macintosh?E?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Macintosh?E?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,k.localize)(11060,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Windows?E?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Windows?E?.markdownDescriptions:void 0}}},P.updateConfigurations({add:[g],remove:t?[t]:[]})}}),define(le[229],he([0,1,27,11,37,9,3,36,25,12,23,130,225,224]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=f,e.$Ks=g,e.$Ls=v,n=Ie(n),R=Ie(R),I=Ie(I),m=Ie(m);function f(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let S=0;return l&&l.length===4&&(S=parseInt(l[3])),S}async function g(l,S,y,D=I.env,L=m.Promises.exists){if(R.$hc(l))return await L(l)?l:void 0;if(S===void 0&&(S=I.cwd()),R.$lc(l)!=="."){const V=R.$ic(S,l);return await L(V)?V:void 0}const O=(0,k.$io)(D,"PATH");if(y===void 0&&(0,c.$cg)(O)&&(y=O.split(R.$sc)),y===void 0||y.length===0){const V=R.$ic(S,l);return await L(V)?V:void 0}for(const V of y){let H;if(R.$hc(V)?H=R.$ic(V,l):H=R.$ic(S,V,l),await L(H))return H;if(T.$j){let Y=H+".com";if(await L(Y)||(Y=H+".exe",await L(Y)))return Y}}const W=R.$ic(S,l);return await L(W)?W:void 0}function v(l,S,y,D,L){const A=T.$j&&(!S.windowsEnableConpty||f()<18309);if(!S.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||A)return;const O=l.args,W=I.$cc==="win32"?R.$mc(l.executable).toLowerCase():R.$mc(l.executable),V=R.$lc(r.$Wg.asFileUri("").fsPath);let H;const Y={VSCODE_INJECTION:"1"};if(S.shellIntegration.nonce&&(Y.VSCODE_NONCE=S.shellIntegration.nonce),T.$j){if(W==="pwsh.exe"||W==="powershell.exe")return!O||s(O)?H=P.get($.WindowsPwsh):o(O)&&(H=P.get($.WindowsPwshLogin)),H?(H=[...H],H[H.length-1]=(0,p.$bf)(H[H.length-1],V,""),Y.VSCODE_STABLE=L.quality==="stable"?"1":"0",S.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),{newArgs:H,envMixin:Y}):void 0;if(W==="bash.exe")return!O||O.length===0?H=P.get($.Bash):a(O)&&(Y.VSCODE_SHELL_LOGIN="1",b(S,Y),H=P.get($.Bash)),H?(H=[...H],H[H.length-1]=(0,p.$bf)(H[H.length-1],V),Y.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:H,envMixin:Y}):void 0;D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(W){case"bash":return!O||O.length===0?H=P.get($.Bash):a(O)&&(Y.VSCODE_SHELL_LOGIN="1",b(S,Y),H=P.get($.Bash)),H?(H=[...H],H[H.length-1]=(0,p.$bf)(H[H.length-1],V),Y.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:H,envMixin:Y}):void 0;case"fish":{const Z=y?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",U=R.$ic(V,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Y.XDG_DATA_DIRS=`${Z}:${U}`,b(S,Y),{newArgs:void 0,envMixin:Y}}case"pwsh":return!O||s(O)?H=P.get($.Pwsh):o(O)&&(H=P.get($.PwshLogin)),H?(S.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),H=[...H],H[H.length-1]=(0,p.$bf)(H[H.length-1],V,""),Y.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:H,envMixin:Y}):void 0;case"zsh":{if(!O||O.length===0?H=P.get($.Zsh):a(O)?(H=P.get($.ZshLogin),b(S,Y)):(O===P.get($.Zsh)||O===P.get($.ZshLogin))&&(H=O),!H)return;H=[...H],H[H.length-1]=(0,p.$bf)(H[H.length-1],V);let Z;try{Z=n.userInfo().username}catch{Z="unknown"}const U=R.$ic(n.tmpdir(),`${Z}-${L.applicationName}-zsh`);Y.ZDOTDIR=U;const te=y?.ZDOTDIR??n.homedir()??"~";Y.USER_ZDOTDIR=te;const x=[];return x.push({source:R.$ic(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$ic(U,".zshrc")}),x.push({source:R.$ic(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$ic(U,".zprofile")}),x.push({source:R.$ic(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$ic(U,".zshenv")}),x.push({source:R.$ic(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$ic(U,".zlogin")}),{newArgs:H,envMixin:Y,filesToCopy:x}}}D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function b(l,S){if(T.$k&&l.environmentVariableCollections){const y=(0,d.$Hs)(l.environmentVariableCollections),L=new w.$Is(y).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),A=[];if(L)for(const O of L)O.type===h.EnvironmentVariableMutatorType.Prepend&&A.push(O.value);A.length>0&&(S.VSCODE_PATH_PREFIX=A.join(""))}}var $;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})($||($={}));const P=new Map;P.set($.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),P.set($.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),P.set($.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),P.set($.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),P.set($.Zsh,["-i"]),P.set($.ZshLogin,["-il"]),P.set($.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],t=["--login","-l"],u=["-i","--interactive"],i=["-nol","-nologo"];function o(l){return typeof l=="string"?E.includes(l.toLowerCase()):l.length===1&&E.includes(l[0].toLowerCase())||l.length===2&&(E.includes(l[0].toLowerCase())||E.includes(l[1].toLowerCase()))&&(i.includes(l[0].toLowerCase())||i.includes(l[1].toLowerCase()))}function s(l){return typeof l=="string"?i.includes(l.toLowerCase()):l.length===0||l?.length===1&&i.includes(l[0].toLowerCase())}function a(l){return typeof l!="string"&&(l=l.filter(S=>!u.includes(S.toLowerCase()))),l==="string"&&t.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&t.includes(l[0].toLowerCase())}}),define(le[230],he([0,1,26,48,80,9,3,12,23,114,75,229,121]),function(G,e,n,r,k,R,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=v,n=Ie(n),r=Ie(r),p=Ie(p);var w;(function(y){y.UnixShellsPath="/etc/shells"})(w||(w={}));let f,g=!0;function v(y,D,L,A,O=process.env,W,V,H,Y){return W=W||{existsFile:p.SymlinkSupport.existsFile,readFile:n.promises.readFile},T.$j?b(L,W,O,V,A.getValue(m.TerminalSettingId.UseWslProfiles)!==!1,y&&typeof y=="object"?{...y}:A.getValue(m.TerminalSettingId.ProfilesWindows),typeof D=="string"?D:A.getValue(m.TerminalSettingId.DefaultProfileWindows),Y,H):a(W,V,L,y&&typeof y=="object"?{...y}:A.getValue(T.$l?m.TerminalSettingId.ProfilesLinux:m.TerminalSettingId.ProfilesMacOs),typeof D=="string"?D:A.getValue(T.$l?m.TerminalSettingId.DefaultProfileLinux:m.TerminalSettingId.DefaultProfileMacOs),Y,H,O)}async function b(y,D,L,A,O,W,V,H,Y){const Z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${Z?"Sysnative":"System32"}`;let te=!1;(0,h.$Js)()>=16299&&(te=!0),await t(H);const x=new Map;if(y){x.set("PowerShell",{source:m.ProfileSource.Pwsh,icon:k.$2j.terminalPowershell,isAutoDetected:!0}),x.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:k.$2j.terminalPowershell,isAutoDetected:!0}),x.set("Git Bash",{source:m.ProfileSource.GitBash,isAutoDetected:!0}),x.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:k.$2j.terminalCmd,isAutoDetected:!0}),x.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),x.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:k.$2j.terminalBash,isAutoDetected:!0});const B=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;x.set("Cmder",{path:`${U}\\cmd.exe`,args:["/K",B],requiresPath:process.env.CMDER_ROOT?B:{path:B,isUnsafe:!0},isAutoDetected:!0})}l(W,x);const J=await $(x.entries(),V,D,L,A,Y);if(y&&O)try{const B=await o(`${U}\\${te?"wsl":"bash"}.exe`,V);for(const j of B)(!W||!(j.profileName in W))&&J.push(j)}catch{g&&(A?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return J}async function $(y,D,L,A=process.env,O,W){const V=[];for(const[H,Y]of y)V.push(P(H,Y,D,L,A,O,W));return(await Promise.all(V)).filter(H=>!!H)}async function P(y,D,L,A,O=process.env,W,V){if(D===null)return;let H,Y,Z;if("source"in D&&!("path"in D)){const J=f?.get(D.source);if(!J)return;H=J.paths,Y=D.args||J.args,D.icon?Z=E(D.icon):J.icon&&(Z=J.icon)}else H=Array.isArray(D.path)?D.path:[D.path],Y=T.$j||Array.isArray(D.args)?D.args:void 0,Z=E(D.icon);let U;if(V){const J=H.map(j=>typeof j=="string"?j:j.path),B=await V(J);U=new Array(H.length);for(let j=0;j<H.length;j++)typeof H[j]=="string"?U[j]=B[j]:U[j]={path:B[j],isUnsafe:!0}}else U=H.slice();let te;if(D.requiresPath){let J;if((0,I.$cg)(D.requiresPath)?J=D.requiresPath:(J=D.requiresPath.path,D.requiresPath.isUnsafe&&(te=J)),!await A.existsFile(J))return}const x=await S(y,L,U,A,O,Y,D.env,D.overrideName,D.isAutoDetected,te);if(!x){W?.debug("Terminal profile not validated",y,H);return}return x.isAutoDetected=D.isAutoDetected,x.icon=Z,x.color=D.color,x}function E(y){return typeof y=="string"?{id:y}:y}async function t(y){if(f&&!y)return;const[D,L]=await Promise.all([u(),y||i()]);f=new Map,f.set(m.ProfileSource.GitBash,{profileName:"Git Bash",paths:D,args:["--login","-i"]}),f.set(m.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:k.$2j.terminalPowershell})}async function u(){const y=new Set,D=await(0,h.$Ks)("git.exe");if(D){const O=(0,d.dirname)(D);y.add((0,d.resolve)(O,"../.."))}function L(O,W){W&&O.add(W)}L(y,process.env.ProgramW6432),L(y,process.env.ProgramFiles),L(y,process.env["ProgramFiles(X86)"]),L(y,`${process.env.LocalAppData}\\Program`);const A=[];for(const O of y)A.push(`${O}\\Git\\bin\\bash.exe`,`${O}\\Git\\usr\\bin\\bash.exe`,`${O}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function i(){const y=[];for await(const D of(0,c.$tm)())y.push(D.exePath);return y}async function o(y,D){const L=[],A=await new Promise((V,H)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Y,Z)=>{if(Y)return H("Problem occurred when getting wsl distros");V(Z)})});if(!A)return[];const O=new RegExp(/[\r?\n]/),W=A.split(O).filter(V=>V.trim().length>0&&V!=="");for(const V of W){if(V===""||V.startsWith("docker-desktop"))continue;const H=`${V} (WSL)`,Y={profileName:H,path:y,args:["-d",`${V}`],isDefault:H===D,icon:s(V),isAutoDetected:!1};L.push(Y)}return L}function s(y){return y.includes("Ubuntu")?k.$2j.terminalUbuntu:y.includes("Debian")?k.$2j.terminalDebian:k.$2j.terminalLinux}async function a(y,D,L,A,O,W,V,H){const Y=new Map;if(L&&await y.existsFile(w.UnixShellsPath)){const Z=(await y.readFile(w.UnixShellsPath)).toString(),U=(W||Z.split(`
`)).map(x=>{const J=x.indexOf("#");return J===-1?x:x.substring(0,J)}).filter(x=>x.trim().length>0),te=new Map;for(const x of U){let J=(0,R.$mc)(x),B=te.get(J)||0;B++,B>1&&(J=`${J} (${B})`),te.set(J,B),Y.set(J,{path:x,isAutoDetected:!0})}}return l(A,Y),await $(Y.entries(),O,y,H,D,V)}function l(y,D){if(y)for(const[L,A]of Object.entries(y))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?D.delete(L):(A.icon=A.icon||D.get(L)?.icon,D.set(L,A))}async function S(y,D,L,A,O,W,V,H,Y,Z){if(L.length===0)return Promise.resolve(void 0);const U=L.shift();if(U==="")return S(y,D,L,A,O,W,V,H,Y);const te=typeof U!="string"&&U.isUnsafe,x=typeof U=="string"?U:U.path,J={profileName:y,path:x,args:W,env:V,overrideName:H,isAutoDetected:Y,isDefault:y===D,isUnsafePath:te,requiresUnsafePath:Z};if((0,R.$mc)(x)===x){const j=O.PATH?O.PATH.split(R.$sc):void 0,C=await(0,h.$Ks)(x,void 0,j,void 0,A.existsFile);return C?(J.path=C,J.isFromPath=!0,J):S(y,D,L,A,O,W)}return await A.existsFile((0,R.$gc)(x))?J:S(y,D,L,A,O,W,V,H,Y)}}),define(le[231],he([0,1,4,2,3,44,16,5,193,100,226,75,228,230,116,66]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0;var v;(function($){$[$.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let b=class extends r.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(P,E,t,u){super(),this.M=P,this.N=E,this.O=t,this.P=u,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$je),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$je),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$je),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$je),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$je),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$je),this.onProcessData=this.D.event,this.F=this.B(new n.$je),this.onProcessReady=this.F.event,this.G=this.B(new n.$je),this.onProcessReplay=this.G.event,this.H=this.B(new n.$je),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$je),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$je),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$je),this.onProcessExit=this.L.event,(0,d.$As)(),this.B(this.M),this.B((0,r.$Rc)(()=>this.W())),this.j=this.B(new m.$ts(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(h.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(k.$j)return process.env;try{return await(0,c.$Om)(this.N,this.O,{_:[]},process.env)}catch(P){return this.O.error("ptyHost was unable to resolve shell environment",P),{}}}U(){const P=this.M.start(),E=P.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(E.getChannel(h.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(P.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=v.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const u=R.ProxyChannel.toService(E.getChannel(h.TerminalIpcChannels.PtyHost));return this.B(u.onProcessData(i=>this.D.fire(i))),this.B(u.onProcessReady(i=>this.F.fire(i))),this.B(u.onProcessExit(i=>this.L.fire(i))),this.B(u.onDidChangeProperty(i=>this.J.fire(i))),this.B(u.onProcessReplay(i=>this.G.fire(i))),this.B(u.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(u.onDidRequestDetach(i=>this.I.fire(i))),this.B(new p.$ss(this.P,E.getChannel(h.TerminalIpcChannels.Logger))),this.a=P,this.b=u,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration(h.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[P,u]}async createProcess(P,E,t,u,i,o,s,a,l,S,y){const D=setTimeout(()=>this.$(),h.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(P,E,t,u,i,o,s,a,l,S,y);return clearTimeout(D),L}updateTitle(P,E,t){return this.f.updateTitle(P,E,t)}updateIcon(P,E,t,u){return this.f.updateIcon(P,E,t,u)}attachToProcess(P){return this.f.attachToProcess(P)}detachFromProcess(P,E){return this.f.detachFromProcess(P,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(P){return this.f.start(P)}shutdown(P,E){return this.f.shutdown(P,E)}input(P,E){return this.f.input(P,E)}processBinary(P,E){return this.f.processBinary(P,E)}resize(P,E,t){return this.f.resize(P,E,t)}clearBuffer(P){return this.f.clearBuffer(P)}acknowledgeDataEvent(P,E){return this.f.acknowledgeDataEvent(P,E)}setUnicodeVersion(P,E){return this.f.setUnicodeVersion(P,E)}getInitialCwd(P){return this.f.getInitialCwd(P)}getCwd(P){return this.f.getCwd(P)}async getLatency(){const P=new g.$de,E=await this.f.getLatency();return P.stop(),[{label:"ptyhostservice<->ptyhost",latency:P.elapsed()},...E]}orphanQuestionReply(P){return this.f.orphanQuestionReply(P)}installAutoReply(P,E){return this.f.installAutoReply(P,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(P){return this.f.uninstallAutoReply(P)}getDefaultSystemShell(P){return this.g?.getDefaultSystemShell(P)??(0,f.$xm)(P??k.OS,process.env)}async getProfiles(P,E,t,u=!1){const i=await this.S();return(0,w.$Ms)(E,t,u,this.N,i,void 0,this.O,this.bb.bind(this,P))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(P,E){return this.f.getWslPath(P,E)}getRevivedPtyNewId(P,E){return this.f.getRevivedPtyNewId(P,E)}setTerminalLayoutInfo(P){return this.f.setTerminalLayoutInfo(P)}async getTerminalLayoutInfo(P){return this.g?.getTerminalLayoutInfo(P)}async requestDetachInstance(P,E){return this.f.requestDetachInstance(P,E)}async acceptDetachInstanceReply(P,E){return this.f.acceptDetachInstanceReply(P,E)}async freePortKillProcess(P){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(P)}async serializeTerminalState(P){return this.f.serializeTerminalState(P)}async reviveTerminalProcesses(P,E,t){return this.f.reviveTerminalProcesses(P,E,t)}async refreshProperty(P,E){return this.f.refreshProperty(P,E)}async updateProperty(P,E,t){return this.f.updateProperty(P,E,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(P){this.ab(),this.s=setTimeout(()=>this.Y(),P?h.HeartbeatConstants.ConnectingBeatInterval:h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier+h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${h.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(P,E){return this.j.createRequest({workspaceId:P,originalText:E})}async acceptPtyHostResolvedVariables(P,E){this.j.acceptReply(P,E)}};e.$Ns=b,e.$Ns=b=Ee([oe(1,T.$9i),oe(2,I.$0j),oe(3,I.$$j)],b)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[76],he([0,1,13,4,2,3,16,6,34]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=void 0,n=Ge(n);const c="#FFFFFF",m="#1E1E1E",h="#000000",d="#FFFFFF",w="theme",f="themeBackground",g="windowSplash";var v;(function($){$.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",$.SYSTEM_COLOR_THEME="window.systemColorTheme"})(v||(v={})),e.$afc=(0,I.$Ci)("themeMainService");let b=class extends k.$Tc{constructor(P,E){super(),this.b=P,this.c=E,this.a=this.B(new r.$je),this.onDidChangeColorScheme=this.a.event,R.$l||this.B(this.c.onDidChangeConfiguration(t=>{(t.affectsConfiguration(v.SYSTEM_COLOR_THEME)||t.affectsConfiguration(v.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(n.default.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(R.$l||this.c.getValue(v.DETECT_COLOR_SCHEME))n.default.nativeTheme.themeSource="system";else switch(this.c.getValue(v.SYSTEM_COLOR_THEME)){case"dark":n.default.nativeTheme.themeSource="dark";break;case"light":n.default.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.default.nativeTheme.themeSource="light";break;case"vs-dark":n.default.nativeTheme.themeSource="dark";break;default:n.default.nativeTheme.themeSource="system"}break;default:n.default.nativeTheme.themeSource="system";break}}getColorScheme(){if(R.$j){if(n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$k){if(n.default.nativeTheme.shouldUseInvertedColorScheme||n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$l&&n.default.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const P=this.getColorScheme();if(P.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return P.dark?h:d;let E=this.b.getItem(f,null);if(!E)switch(this.g()){case"vs":E=c;break;case"hc-black":E=h;break;case"hc-light":E=d;break;default:E=m}return R.$k&&E.toUpperCase()===m&&(E="#171717"),E}g(){switch(this.b.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(P,E){this.b.setItems([{key:w,data:E.baseTheme},{key:f,data:E.colorInfo.background},{key:g,data:E}]),typeof P=="number"&&this.h(P,E),this.f()}h(P,E){for(const t of n.default.BrowserWindow.getAllWindows())if(t.id===P){t.setBackgroundColor(E.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(g)}};e.$bfc=b,e.$bfc=b=Ee([oe(0,p.$nR),oe(1,T.$9i)],b)}),define(le[131],he([0,1,4,2,3,7,16,6,5]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=h,e.$Ew=w,e.$Fw=f,e.$Hw=g,e.$Jw=v,e.$Kw=b,e.$Bw=(0,I.$Ci)("tunnelService"),e.$Cw=(0,I.$Ci)("sharedTunnelsService");var c;(function(E){E.Http="http",E.Https="https"})(c||(e.TunnelProtocol=c={}));var m;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(m||(e.TunnelPrivacyId=m={}));function h(E){return!!E.forwardPort}var d;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function w(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(t)return{address:t[1],port:+t[2]}}function f(E){if(E.scheme!=="http"&&E.scheme!=="https"||!E.query)return;const t=E.query.split("&");for(const u of t){const i=u.split("=")[1];if(/^https?:/.exec(i)){const o=w(R.URI.parse(i));if(o)return o}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(E){return e.$Gw.indexOf(E)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(E){return e.$Iw.indexOf(E)>=0}function b(E,t,u,i){if(u===k.OperatingSystem.Windows)return!1;if(u===k.OperatingSystem.Macintosh&&v(t)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(o?.length===4&&parseInt(o[1])>=18)return!1}return E<1024}class ${constructor(t,u,i){this.remoteAddress=t,this.localAddress=u,this.b=i,this.a=new n.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=$;let P=class extends r.$Tc{constructor(t,u){super(),this.r=t,this.s=u,this.a=new n.$je,this.onTunnelOpened=this.a.event,this.b=new n.$je,this.onTunnelClosed=this.b.event,this.c=new n.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],u=Array.from(this.f.values());for(const i of u){const o=Array.from(i.values());for(const s of o){const a=await s.value;a&&typeof a!="string"&&t.push(a)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:u}of t.values())await u.then(i=>typeof i!="string"?i?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,u,i,o,s){this.z(t,u,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:u,localAddress:i,privacy:o,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,u){(v(t)||g(t))&&(t=e.$Gw[0]);const i=this.D(t,u);if(i)return++i.refcount,i.value}openTunnel(t,u,i,o,s,a=!1,l,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${i} on local port ${s}.`);const y=this.g??t;if(!y)return;if(u||(u="localhost"),o||(o=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const D=this.F(y,u,i,o,s,a,l,S);return D?D.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(u,i),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(u,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const A=this.w(L);return(L.tunnelRemoteHost!==u||L.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&L.privacy!==l&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(A),A}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),D)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const u=this.f.get(t.tunnelRemoteHost);if(u){const i=u.get(t.tunnelRemotePort);i&&(i.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,i))}}}}async y(t,u,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${u}.`);const o=i.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(u),o}}async closeTunnel(t,u){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${u} `);const i=this.f.get(t);if(i&&i.has(u)){const o=i.get(u);o.refcount=0,await this.y(t,u,o)}}z(t,u,i){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(u,{refcount:1,value:i})}async C(t,u){const i=this.f.get(t);if(i){const o=i.get(u),s=o?await o.value:void 0;(!s||typeof s=="string")&&i.delete(u),i.size===0&&this.f.delete(t)}}D(t,u){const i=[t];g(t)?(i.push(...e.$Gw),i.push(...e.$Iw)):v(t)&&i.push(...e.$Iw);const o=i.map(s=>this.f.get(s));for(const s of o){const a=s?.get(u);if(a)return a}}canTunnel(t){return!!w(t)}G(t,u,i,o,s,a,l){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${i} on local port ${o}.`);const S=i;this.n.add(S);const y=o===void 0?i:o,D={elevationRequired:s?this.isPortPrivileged(y):!1},L={remoteAddress:{host:u,port:i},localAddressPort:o,privacy:a,public:a?a!==m.Private:void 0,protocol:l},A=t.forwardPort(L,D);return A?(this.z(u,i,A),A.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),A}};e.$Mw=P,e.$Mw=P=Ee([oe(0,p.$0j),oe(1,T.$9i)],P)}),define(le[49],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FY=e.$EY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(T){T.Uninitialized="uninitialized",T.Idle="idle",T.Disabled="disabled",T.CheckingForUpdates="checking for updates",T.AvailableForDownload="available for download",T.Downloading="downloading",T.Downloaded="downloaded",T.Updating="updating",T.Ready="ready"})(r||(e.StateType=r={}));var k;(function(T){T[T.Setup=0]="Setup",T[T.Archive=1]="Archive",T[T.Snap=2]="Snap"})(k||(e.UpdateType=k={}));var R;(function(T){T[T.NotBuilt=0]="NotBuilt",T[T.DisabledByEnvironment=1]="DisabledByEnvironment",T[T.ManuallyDisabled=2]="ManuallyDisabled",T[T.MissingConfiguration=3]="MissingConfiguration",T[T.InvalidConfiguration=4]="InvalidConfiguration",T[T.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$EY={Uninitialized:{type:r.Uninitialized},Disabled:T=>({type:r.Disabled,reason:T}),Idle:(T,I)=>({type:r.Idle,updateType:T,error:I}),CheckingForUpdates:T=>({type:r.CheckingForUpdates,explicit:T}),AvailableForDownload:T=>({type:r.AvailableForDownload,update:T}),Downloading:{type:r.Downloading},Downloaded:T=>({type:r.Downloaded,update:T}),Updating:T=>({type:r.Updating,update:T}),Ready:T=>({type:r.Ready,update:T})},e.$FY=(0,n.$Ci)("updateService")}),define(le[232],he([0,1,3,10,55,45]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$oo.as(k.$to.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(10943,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:k.ConfigurationScope.APPLICATION,description:(0,r.localize)(10944,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(10945,null),(0,r.localize)(10946,null),(0,r.localize)(10947,null),(0,r.localize)(10948,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:k.ConfigurationScope.APPLICATION,description:(0,r.localize)(10949,null),deprecationMessage:(0,r.localize)(10950,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:k.ConfigurationScope.APPLICATION,title:(0,r.localize)(10951,null),description:(0,r.localize)(10952,null),included:n.$j&&!n.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:k.ConfigurationScope.APPLICATION,description:(0,r.localize)(10953,null),tags:["usesOnlineServices"]}}})}),define(le[233],he([0,1,4,49]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0;class k{constructor(I){this.a=I}listen(I,p){switch(p){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${p}`)}call(I,p,c){switch(p){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${p}`)}}e.$ogc=k;class R{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new n.$je,this.onStateChange=this.a.event,this.b=r.$EY.Uninitialized,this.c.listen("onStateChange")(p=>this.state=p),this.c.call("_getInitialState").then(p=>this.state=p)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$pgc=R}),define(le[41],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=void 0,e.$Hl=(0,n.$Ci)("IUriIdentityService")}),define(le[234],he([0,1,41,173,14,18,145,4,2]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let m=class{constructor(d){this.g=d,this.c=new p.$Sc,this.f=2**16;const w=new Map,f=g=>{let v=w.get(g.scheme);return v===void 0&&(v=d.hasProvider(g)&&!this.g.hasCapability(g,k.FileSystemProviderCapabilities.PathCaseSensitive),w.set(g.scheme,v)),v};this.c.add(I.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(g=>{w.delete(g.scheme)})),this.extUri=new R.$5g(f),this.d=new T.$Qs((g,v)=>this.extUri.compare(g,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,R.$eh)(d));const w=this.d.get(d);return w?w.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((f,g)=>f[1].time<g[1].time?1:f[1].time>g[1].time?-1:0);c._clock=0,this.d.clear();const w=this.f*.5;for(let f=0;f<w;f++)this.d.set(d[f][0],d[f][1].touch())}};e.$Rs=m,e.$Rs=m=Ee([oe(0,k.$0k)],m),(0,r.$Os)(n.$Hl,m,r.InstantiationType.Delayed)}),define(le[132],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vY=void 0,e.$vY=(0,n.$Ci)("urlService")}),define(le[235],he([0,1,7]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=e.$xgc=e.$wgc=void 0;class r{constructor(I){this.a=I}listen(I,p){throw new Error(`Event not found: ${p}`)}call(I,p,c){switch(p){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${p}`)}}e.$wgc=r;class k{constructor(I){this.a=I}handleURL(I,p){return this.a.call("handleURL",[I.toJSON(),p])}}e.$xgc=k;class R{constructor(I,p){this.a=I,this.b=p}async routeCall(I,p,c,m){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(Array.isArray(c)&&c.length>0){const h=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",h.toString(!0)),h.query){const d=/\bwindowId=(\d+)/.exec(h.query);if(d){const w=d[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,h.toString(!0));const f=new RegExp(`window:${w}`),g=I.connections.find(v=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",v.ctx),f.test(v.ctx)));if(g)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",h.toString(!0)),g;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",h.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",h.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,p,c,m)}routeEvent(I,p){throw new Error(`Event not found: ${p}`)}}e.$ygc=R}),define(le[236],he([0,1,8,2,7,28]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xY=e.$wY=void 0;class T extends r.$Tc{constructor(){super(...arguments),this.a=new Set}open(c,m){const h=[...this.a.values()];return(0,n.$Gh)(h.map(d=>()=>d.handleURL(c,m)),void 0,!1).then(d=>d||!1)}registerHandler(c){return this.a.add(c),(0,r.$Rc)(()=>this.a.delete(c))}}e.$wY=T;let I=class extends T{constructor(c){super(),this.b=c}create(c){let{authority:m,path:h,query:d,fragment:w}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&h&&h.indexOf("/")!==0&&(h=`/${h}`),k.URI.from({scheme:this.b.urlProtocol,authority:m,path:h,query:d,fragment:w})}};e.$xY=I,e.$xY=I=Ee([oe(0,R.$qk)],I)}),define(le[237],he([0,1,13,8,4,2,3,7]),function(G,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class p extends R.$Tc{constructor(m,h,d,w,f,g){if(super(),this.c=h,this.f=g,this.a=[],this.b=0,m&&(g.trace("ElectronURLListener initialUrisToHandle:",m.map($=>$.originalUrl)),this.a=m),T.$j){const $=w.isBuilt?[]:[`"${w.appRoot}"`];$.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,$)}const v=k.Event.map(k.Event.fromNodeEventEmitter(n.app,"open-url",($,P)=>({event:$,url:P})),({event:$,url:P})=>($.preventDefault(),P));this.B(v($=>{const P=this.g($);P&&this.c.open(P,{originalUrl:$})})),d.getWindows().filter($=>$.isReady).length>0?(g.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(g.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(k.Event.once(d.onDidSignalReadyWindow)(()=>this.h())))}g(m){try{return I.URI.parse(m)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const h of this.a)await this.c.open(h.uri,{originalUrl:h.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",h.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",h.originalUrl),m.push(h));m.length!==0&&(this.a=m,(0,r.$Eh)(()=>this.h(),500,this.q))}}e.$zgc=p}),define(le[238],he([0,1,4,2,14,60,31]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class I extends r.$Tc{constructor(c,m,h,d,w,f){super(),this.f=c,this.g=m,this.h=h,this.j=d,this.m=w,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$je),this.onDidChangeFile=this.a.event,this.b=R.$Ii.forUris(()=>!(this.capabilities&k.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Ac(g=>this.m.extUri.getComparisonKey(this.t(g))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(g=>this.s(g)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,m){return this.g.open(this.t(c),m)}close(c){return this.g.close(c)}read(c,m,h,d,w){return this.g.read(c,m,h,d,w)}write(c,m,h,d,w){return this.g.write(c,m,h,d,w)}watch(c,m){this.b.set(c,c);const h=this.g.watch(this.t(c),m);return(0,r.$Rc)(()=>{this.b.delete(c),h.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,m,h){return this.g.rename(this.t(c),this.t(m),h)}readFile(c,m){return this.g.readFile(this.t(c),m)}readFileStream(c,m,h){return this.g.readFileStream(this.t(c),m,h)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,m,h){return this.g.writeFile(this.t(c),m,h)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,m){return this.g.delete(this.t(c),m)}copy(c,m,h){if((0,k.$bl)(this.g))return this.g.copy(this.t(c),this.t(m),h);throw new Error("copy not supported")}cloneFile(c,m){if((0,k.$cl)(this.g))return this.g.cloneFile(this.t(c),this.t(m));throw new Error("clone not supported")}s(c){const m=[];for(const h of c){if(h.resource.scheme!==this.f)continue;const d=this.u(h.resource);this.b.findSubstr(d)&&m.push({resource:d,type:h.type,cId:h.cId})}m.length&&(this.n.debug("User data changed"),this.a.fire(m))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$chc=I}),define(le[239],he([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0,e.$Vgc="utilityProcessWorker"}),define(le[240],he([0,1,6]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0,e.$Agc=(0,n.$Ci)("webviewManagerService")}),define(le[241],he([0,1,13,2,11,7]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class T extends r.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const p=this.b.bind(this);n.protocol.registerFileProtocol(k.Schemas.vscodeWebview,p)}b(p,c){try{const m=R.URI.parse(p.url),h=T.a.get(m.path);if(typeof h=="string"){const d=`vs/workbench/contrib/webview/browser/pre/${h}`,w=k.$Wg.asFileUri(d);return c({path:w.fsPath,headers:{...k.COI.getHeadersFromQuery(p.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$Bgc=T}),define(le[50],he([0,1,3]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7D=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$XD=void 0,e.$YD=r,e.$ZD=k,e.$1D=R,e.$2D=T,e.$3D=I,e.$4D=h,e.$5D=d,e.$6D=w,e.$8D=f,e.$9D=g,e.$0D=v,e.$XD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(b){return typeof b.parentId=="number"}function k(b){return!!b.workspaceUri}function R(b){return!!b.folderUri}function T(b){return!!b.fileUri}function I(b){const $=d(b),P=b.getValue("window.menuBarVisibility");return P==="default"||$&&P==="compact"||n.$k&&n.$n?"classic":P}var p;(function(b){b.TITLE_BAR_STYLE="window.titleBarStyle",b.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(p||(e.TitleBarSetting=p={}));var c;(function(b){b.NATIVE="native",b.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var m;(function(b){b.AUTO="auto",b.WINDOWED="windowed",b.NEVER="never"})(m||(e.CustomTitleBarVisibility=m={}));function h(b,$){return!0}function d(b,$){return $||($=w(b)),$===c.NATIVE}function w(b){if(n.$p)return c.CUSTOM;const $=b.getValue("window");if($){if(n.$k&&$.nativeTabs===!0||n.$k&&$.nativeFullScreen===!1)return c.NATIVE;const t=$.titleBarStyle;if(t===c.NATIVE||t===c.CUSTOM)return t}return n.$l?c.NATIVE:c.CUSTOM}e.$7D=35;function f(b){return!(!n.$j||n.$p||d(b))}function g(b){const $=b.getValue("window");return!$||typeof $.nativeFullScreen!="boolean"||$.nativeTabs?!0:$.nativeFullScreen!==!1}function v(b=0){return Math.pow(1.2,b)}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[51],he([0,1,13]),function(G,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$5ec=e.$4ec=e.UnloadReason=e.LoadReason=void 0,n=Ge(n);var r;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var k;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(k||(e.UnloadReason=k={}));const R=function(c=I.Normal){return{width:1024,height:768,mode:c}};e.$4ec=R;const T=function(){const h=n.default.screen.getPrimaryDisplay().workArea,d=Math.max(h.x+h.width/2-800/2,0),w=Math.max(h.y+h.height/2-600/2,0);return{x:d,y:w,width:800,height:600,mode:I.Normal}};e.$5ec=T;var I;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var p;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(p||(e.WindowError=p={}))}),define(le[242],he([0,1,8,4,2]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;class R extends k.$Tc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:p,getActiveWindowId:c}){super(),this.a=this.B(new k.$Sc),r.Event.latch(r.Event.any(I,p))(this.f,this,this.a),this.b=(0,n.$ph)(()=>c()),(async()=>{try{const h=await this.b;this.c=typeof this.c=="number"?this.c:h}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Hgc=R}),define(le[30],he([0,1,10,9,60,18,7,6,11]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=c,e.$Ni=m,e.$Qi=h,e.$Ri=d,e.$Si=w,e.$Ti=g,e.$Ui=v,e.$Xi=P,e.$3i=E,e.$4i=t,e.$6i=u,e.$7i=i,e.$8i=o,e.$Li=(0,I.$Ci)("contextService");function c(s){const a=s;return typeof a?.id=="string"&&T.URI.isUri(a.uri)}function m(s){return typeof s?.id=="string"&&!c(s)&&!d(s)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function h(s,a){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.$mc)(s)}:a?e.$Oi:e.$Pi;const l=s;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function d(s){const a=s;return typeof a?.id=="string"&&T.URI.isUri(a.configPath)}function w(s){const a=s;if(a?.uri)return{id:a.id,uri:T.URI.revive(a.uri)};const l=s;if(l?.configPath)return{id:l.id,configPath:T.URI.revive(l.configPath)};if(s?.id)return{id:s.id}}var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function g(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function v(s){const a=s;return!!(a&&typeof a=="object"&&T.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class b{constructor(a,l,S,y,D){this.h=a,this.j=S,this.k=y,this.l=D,this.c=k.$Ii.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=k.$Ii.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=b;class ${constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.$dh)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=$;function P(s){return new $({uri:s,index:0,name:(0,R.$_g)(s)},{uri:s.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,n.localize)(10895,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function E(s,a){return R.$7g.isEqualOrParent(s,a.untitledWorkspacesHome)}function t(s){let a;return T.URI.isUri(s)?a=s:a=s.configuration,a?.scheme===p.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function u(s){return s.id===e.$5i}function i(s,a){return!E(s,a)&&!t(s)}function o(s){return(typeof s=="string"?(0,r.$nc)(s):(0,R.$bh)(s))===e.$Zi}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[52],he([0,1,13,8,46,47,2,78,3,23,10,123,6,5,28,30]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=e.$0ec=void 0,n=Ge(n),e.$0ec=(0,d.$Ci)("dialogMainService");let v=class{constructor($,P){this.d=$,this.e=P,this.a=new Map,this.b=new Map,this.c=new r.$Jh}pickFileFolder($,P){return this.f({...$,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(11436,null)},P)}pickFolder($,P){return this.f({...$,pickFolders:!0,title:(0,m.localize)(11437,null)},P)}pickFile($,P){return this.f({...$,pickFiles:!0,title:(0,m.localize)(11438,null)},P)}pickWorkspace($,P){const E=(0,m.localize)(11439,null),t=(0,R.$4w)((0,m.localize)(11440,null)),u=g.$1i;return this.f({...$,pickFiles:!0,title:E,filters:u,buttonLabel:t},P)}async f($,P){const E={title:$.title,buttonLabel:$.buttonLabel,filters:$.filters,defaultPath:$.defaultPath};(typeof $.pickFiles=="boolean"||typeof $.pickFolders=="boolean")&&(E.properties=void 0,$.pickFiles&&$.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",$.pickFolders?"openDirectory":"openFile","createDirectory"]),p.$k&&E.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(E,(P||n.default.BrowserWindow.getFocusedWindow())??void 0);if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g($){if($){let P=this.b.get($.id);return P||(P=new r.$Jh,this.b.set($.id,P)),P}else return this.c}showMessageBox($,P){return this.g(P).queue(async()=>{const{options:E,buttonIndeces:t}=(0,h.$$w)($,this.e);let u;return P?u=await n.default.dialog.showMessageBox(P,E):u=await n.default.dialog.showMessageBox(E),{response:t[u.response],checkboxChecked:u.checkboxChecked}})}async showSaveDialog($,P){const E=this.j($,P);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(P).queue(async()=>{let t;return P?t=await n.default.dialog.showSaveDialog(P,$):t=await n.default.dialog.showSaveDialog($),t.filePath=this.h(t.filePath),t})}finally{(0,T.$Oc)(E)}}h($){return $&&p.$k&&($=(0,I.$km)($)),$}i($){return $.map(P=>this.h(P))}async showOpenDialog($,P){$.defaultPath&&(await c.Promises.exists($.defaultPath)||($.defaultPath=void 0));const E=this.j($,P);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(P).queue(async()=>{let t;return P?t=await n.default.dialog.showOpenDialog(P,$):t=await n.default.dialog.showOpenDialog($),t.filePaths=this.i(t.filePaths),t})}finally{(0,T.$Oc)(E)}}j($,P){if(!P)return T.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",$);let E=this.a.get(P.id);E||(E=new Set,this.a.set(P.id,E));const t=(0,k.$qj)($);if(!E.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",$),E.add(t),(0,T.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",$),E?.delete(t),E?.size===0&&this.a.delete(P.id)})}};e.$$ec=v,e.$$ec=v=Ee([oe(0,w.$0j),oe(1,f.$qk)],v)}),define(le[243],he([0,1,4,2,82,30]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class T extends r.$Tc{static{this.a=100}constructor(p,c){super(),this.f=p,this.g=c,this.b=this.B(new n.$je),this.c=new Map,this.h(c.applicationStorage,this.b)}h(p,c){this.B(n.Event.debounce(p.onDidChangeStorage,(m,h)=>(m?m.push(h):m=[h],m),T.a)(m=>{m.length&&c.fire(this.j(m,p))}))}j(p,c){const m=new Map,h=new Set;return p.forEach(d=>{const w=c.get(d.key);typeof w=="string"?m.set(d.key,w):h.add(d.key)}),{changed:Array.from(m.entries()),deleted:Array.from(h.values())}}listen(p,c,m){switch(c){case"onDidChangeStorage":{const h=m.profile?(0,k.$_h)(m.profile):void 0;if(!h)return this.b.event;let d=this.c.get(h.id);return d||(d=this.B(new n.$je),this.h(this.g.profileStorage(h),d),this.c.set(h.id,d)),d.event}}throw new Error(`Event not found: ${c}`)}async call(p,c,m){const h=m.profile?(0,k.$_h)(m.profile):void 0,d=(0,R.$Si)(m.workspace),w=await this.m(h,d);switch(c){case"getItems":return Array.from(w.items.entries());case"updateItems":{const f=m;if(f.insert)for(const[g,v]of f.insert)w.set(g,v);f.delete?.forEach(g=>w.delete(g));break}case"optimize":return w.optimize();case"isUsed":{const f=m.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${c}`)}}async m(p,c){let m;c?m=this.g.workspaceStorage(c):p?m=this.g.profileStorage(p):m=this.g.applicationStorage;try{await m.init()}catch(h){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":p?"profile":"application"} storage due to ${h}`)}return m}}e.$lgc=T}),define(le[42],he([0,1,46,4,2,18,7,10,38,14,6,5,30,31,41,8,33,25,12]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Jl=e.ProfileResourceType=void 0,e.$Il=E,e.$Kl=t,e.$Ll=u;var P;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function E(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&T.URI.isUri(a.location)&&T.URI.isUri(a.globalStorageHome)&&T.URI.isUri(a.settingsResource)&&T.URI.isUri(a.keybindingsResource)&&T.URI.isUri(a.tasksResource)&&T.URI.isUri(a.snippetsHome)&&T.URI.isUri(a.extensionsResource))}e.$Jl=(0,m.$Ci)("IUserDataProfilesService");function t(s,a){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:T.URI.revive(s.location).with({scheme:a}),globalStorageHome:T.URI.revive(s.globalStorageHome).with({scheme:a}),settingsResource:T.URI.revive(s.settingsResource).with({scheme:a}),keybindingsResource:T.URI.revive(s.keybindingsResource).with({scheme:a}),tasksResource:T.URI.revive(s.tasksResource).with({scheme:a}),snippetsHome:T.URI.revive(s.snippetsHome).with({scheme:a}),extensionsResource:T.URI.revive(s.extensionsResource).with({scheme:a}),cacheHome:T.URI.revive(s.cacheHome).with({scheme:a}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function u(s,a,l,S,y,D){return{id:s,name:a,location:l,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:D&&y?.useDefaultFlags?.globalState?D.globalStorageHome:(0,R.$dh)(l,"globalStorage"),settingsResource:D&&y?.useDefaultFlags?.settings?D.settingsResource:(0,R.$dh)(l,"settings.json"),keybindingsResource:D&&y?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,R.$dh)(l,"keybindings.json"),tasksResource:D&&y?.useDefaultFlags?.tasks?D.tasksResource:(0,R.$dh)(l,"tasks.json"),snippetsHome:D&&y?.useDefaultFlags?.snippets?D.snippetsHome:(0,R.$dh)(l,"snippets"),extensionsResource:D&&y?.useDefaultFlags?.extensions?D.extensionsResource:(0,R.$dh)(l,"extensions.json"),cacheHome:(0,R.$dh)(S,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let i=class extends k.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,l,S,y){super(),this.t=a,this.u=l,this.w=S,this.y=y,this.f=!0,this.h=this.B(new r.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$zc,workspaces:new w.$zc,emptyWindows:new Map},this.profilesHome=(0,R.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),l=[a];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,$.$cg)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}l.push(u((0,R.$ah)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},a))}}catch(D){this.y.error(D)}const S=new w.$zc,y=new Map;if(l.length)try{const D=this.Q();if(D.workspaces)for(const[L,A]of Object.entries(D.workspaces)){const O=T.URI.parse(L),W=l.find(V=>V.id===A);W&&S.set(O,W)}if(D.emptyWindows)for(const[L,A]of Object.entries(D.emptyWindows)){const O=l.find(W=>W.id===A);O&&y.set(L,O)}}catch(D){this.y.error(D)}this.z={profiles:l,workspaces:S,emptyWindows:y}}return this.z}D(){const a=u("__default__profile__",(0,I.localize)(10942,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",S=new RegExp(`${(0,b.$ff)(l)}\\s(\\d+)`);let y=0;for(const L of this.profiles){const A=S.exec(L.name),O=A?parseInt(A[1]):0;y=O>y?O:y}const D=`${l} ${y+1}`;return this.createProfile((0,n.$qj)((0,v.$Yg)()).toString(16),D,{transient:!0},a)}async createNamedProfile(a,l,S){return this.createProfile((0,n.$qj)((0,v.$Yg)()).toString(16),a,l,S)}async createProfile(a,l,S,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(a,l,S);return y&&await this.setProfileForWorkspace(y,D),D}async F(a,l,S){if(!(0,$.$cg)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(l);return y||(y=(async()=>{try{if(this.profiles.find(O=>O.name===l||O.id===a))throw new Error(`Profile with ${l} name already exists`);const L=u(a,l,(0,R.$dh)(this.profilesHome,a),this.g,S,this.defaultProfile);await this.u.createFolder(L.location);const A=[];return this.j.fire({profile:L,join(O){A.push(O)}}),await g.Promises.settled(A),this.I([L],[],[]),L}finally{this.r.delete(l)}})(),this.r.set(l,y)),y}async updateProfile(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(y=>y.id===a.id);if(!S)throw new Error(`Profile '${a.name}' does not exist`);return S=u(S.id,l.name??S.name,S.location,this.g,{shortName:l.shortName??S.shortName,icon:l.icon===null?void 0:l.icon??S.icon,transient:l.transient??S.isTransient,useDefaultFlags:l.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(y=>y.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const S=[];this.m.fire({profile:l,join(y){S.push(y)}});try{await Promise.allSettled(S)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(y){(0,c.$ol)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(y=>y.id===l.id);if(!S)throw new Error(`Profile '${l.name}' does not exist`);this.L(a,S)}unsetWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,l)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.G(a),S=T.URI.isUri(l)?this.C.workspaces.get(l):this.C.emptyWindows.get(l);return S||((0,d.$Mi)(a)?this.s.folders.get(a.uri):(0,d.$Ri)(a)?this.s.workspaces.get(a.configPath):this.s.emptyWindows.get(a.id))}G(a){return(0,d.$Mi)(a)?a.uri:(0,d.$Ri)(a)?a.configPath:a.id}H(a){return!!([...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.folders.values()].some(l=>this.w.extUri.isEqual(l.location,a.location)))}I(a,l,S){const y=[...this.profiles,...a],D=[],L=this.s.profiles;this.s.profiles=[];for(let A of y){if(A.isDefault||l.some(W=>A.id===W.id))continue;A=S.find(W=>A.id===W.id)??A;const O=L.find(W=>A.id===W.id);if(A.isTransient)this.s.profiles.push(A);else{if(O){for(const[W,V]of this.s.emptyWindows.entries())if(A.id===V.id){this.L({id:W},A);break}for(const[W,V]of this.s.workspaces.entries())if(A.id===V.id){this.L({id:"",configPath:W},A);break}for(const[W,V]of this.s.folders.entries())if(A.id===V.id){this.L({id:"",uri:W},A);break}}D.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.P(D),this.z=void 0,this.J(a,l,S)}J(a,l,S){this.h.fire({added:a,removed:l,updated:S,all:this.profiles})}L(a,l,S){if(S=l?.isTransient?!0:S,S)(0,d.$Mi)(a)?(this.s.folders.delete(a.uri),l&&this.s.folders.set(a.uri,l)):(0,d.$Ri)(a)?(this.s.workspaces.delete(a.configPath),l&&this.s.workspaces.set(a.configPath,l)):(this.s.emptyWindows.delete(a.id),l&&this.s.emptyWindows.set(a.id,l));else{this.L(a,void 0,!0);const y=this.G(a);T.URI.isUri(y)?(this.C.workspaces.delete(y),l&&this.C.workspaces.set(y,l)):(this.C.emptyWindows.delete(y),l&&this.C.emptyWindows.set(y,l)),this.M()}}M(){const a={};for(const[S,y]of this.C.workspaces.entries())a[S.toString()]=y.id;const l={};for(const[S,y]of this.C.emptyWindows.entries())l[S.toString()]=y.id;this.R({workspaces:a,emptyWindows:l}),this.z=void 0}N(a){const l={},S=this.D();if(a.workspaces)for(const[D,L]of Object.entries(a.workspaces)){const A=T.URI.parse(L);l[D]=this.w.extUri.isEqual(A,S.location)?S.id:this.w.extUri.basename(A)}const y={};if(a.emptyWindows)for(const[D,L]of Object.entries(a.emptyWindows)){const A=T.URI.parse(L);y[D]=this.w.extUri.isEqual(A,S.location)?S.id:this.w.extUri.basename(A)}return{workspaces:l,emptyWindows:y}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Ml=i,e.$Ml=i=Ee([oe(0,p.$Ji),oe(1,c.$0k),oe(2,f.$Hl),oe(3,h.$0j)],i);class o extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Nl=o}),define(le[86],he([0,1,8,17,2,4,31,7,126,129,14,6,5,42,41,12,15,24]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class P extends Error{constructor(o,s){super(o),this.code=s}}e.$Fq=P,e.$Gq=(0,h.$Ci)("IExtensionsProfileScannerService");let E=class extends k.$Tc{constructor(o,s,a,l,S,y){super(),this.j=o,this.m=s,this.n=a,this.r=l,this.s=S,this.t=y,this.b=this.B(new R.$je),this.onAddExtensions=this.b.event,this.c=this.B(new R.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$je),this.onDidRemoveExtensions=this.g.event,this.h=new T.$zc}scanProfileExtensions(o,s){return this.u(o,void 0,s)}async addExtensionsToProfile(o,s,a){const l=[],S=[];try{return await this.u(s,y=>{const D=[];if(a)D.push(...y);else for(const L of y)o.some(([A])=>(0,c.$Jp)(A.identifier,L.identifier)&&A.manifest.version!==L.version)?l.push(L):D.push(L);for(const[L,A]of o){const O=D.findIndex(V=>(0,c.$Jp)(V.identifier,L.identifier)&&V.version===L.manifest.version),W={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:A};O===-1?(S.push(W),D.push(W)):D.splice(O,1,W)}return S.length&&this.b.fire({extensions:S,profileLocation:s}),l.length&&this.f.fire({extensions:l,profileLocation:s}),D}),S.length&&this.c.fire({extensions:S,profileLocation:s}),l.length&&this.g.fire({extensions:l,profileLocation:s}),S}catch(y){throw S.length&&this.c.fire({extensions:S,error:y,profileLocation:s}),l.length&&this.g.fire({extensions:l,error:y,profileLocation:s}),y}}async updateMetadata(o,s){const a=[];return await this.u(s,l=>{const S=[];for(const y of l){const D=o.find(([L])=>(0,c.$Jp)(L.identifier,y.identifier)&&L.manifest.version===y.version);D&&(y.metadata={...y.metadata,...D[1]},a.push(y)),S.push(y)}return S}),a}async removeExtensionFromProfile(o,s){const a=[];try{await this.u(s,l=>{const S=[];for(const y of l)(0,c.$Jp)(y.identifier,o.identifier)?a.push(y):S.push(y);return a.length&&this.f.fire({extensions:a,profileLocation:s}),S}),a.length&&this.g.fire({extensions:a,profileLocation:s})}catch(l){throw a.length&&this.g.fire({extensions:a,error:l,profileLocation:s}),l}}async u(o,s,a){return this.F(o).queue(async()=>{let l=[],S;try{const y=await this.m.readFile(o);S=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,m.$ol)(y)!==m.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(S=await this.D()),!S&&a?.bailOutWhenFileNotFound)throw new P((0,v.$9)(y),$.ERROR_PROFILE_NOT_FOUND)}if(S){Array.isArray(S)||this.w(o);let y=!1;for(const D of S){t(D)||this.w(o);let L;if((0,g.$cg)(D.relativeLocation)&&D.relativeLocation)L=this.z(D.relativeLocation);else if((0,g.$cg)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{L=I.URI.revive(D.location);const A=this.y(L);A&&(y=!0,D.relativeLocation=A)}(0,g.$jg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(y=!0,D.metadata.hasPreReleaseVersion=!0),l.push({identifier:D.identifier,location:L,version:D.version,metadata:D.metadata})}y&&await this.m.writeFile(o,r.$Le.fromString(JSON.stringify(S)))}if(s){l=s(l);const y=l.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(o,r.$Le.fromString(JSON.stringify(y)))}return l})}w(o){const s=new P(`Invalid extensions content in ${o.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let a;try{a=(await this.m.readFile(o)).value.toString()}catch(S){if((0,m.$ol)(S)===m.FileOperationResult.FILE_NOT_FOUND)return;throw S}this.t.info("Migrating extensions from old default profile location",o.toString());let l;try{const S=JSON.parse(a);Array.isArray(S)&&S.every(y=>t(y))?l=S:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.t.error(S)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Le.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(S){if((0,m.$ol)(S)===m.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw S}try{await this.m.del(o)}catch(S){(0,m.$ol)(S)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}try{await this.m.del(s)}catch(S){(0,m.$ol)(S)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}return l})()),this.C}F(o){let s=this.h.get(o);return s||(s=new n.$Jh,this.h.set(o,s)),s}};e.$Hq=E,e.$Hq=E=Ee([oe(1,m.$0k),oe(2,w.$Jl),oe(3,f.$Hl),oe(4,b.$9l),oe(5,d.$0j)],E);function t(i){return(0,g.$eg)(i)&&(0,p.$hp)(i.identifier)&&(u(i.location)||(0,g.$cg)(i.location)&&i.location)&&((0,g.$jg)(i.relativeLocation)||(0,g.$cg)(i.relativeLocation))&&i.version&&(0,g.$cg)(i.version)}function u(i){return i?(0,g.$cg)(i.path)&&(0,g.$cg)(i.scheme):!1}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[133],he([0,1,21,8,37,17,15,43,163,2,11,9,3,18,210,81,12,7,10,38,129,85,209,14,6,5,28,4,82,86,42,41,171]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t,u,i,o,s,a,l,S,y,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Mq=e.$Lq=e.$Kq=e.Translations=void 0,e.$Nq=Z,k=Ie(k),h=Ie(h),d=Ie(d),f=Ie(f),g=Ge(g);var O;(function(te){function x(J,B){if(J===B)return!0;const j=Object.keys(J),C=new Set;for(const X of Object.keys(B))C.add(X);if(j.length!==C.size)return!1;for(const X of j){if(J[X]!==B[X])return!1;C.delete(X)}return C.size===0}te.equals=x})(O||(e.Translations=O={})),e.$Kq=(0,o.$Ci)("IExtensionsScannerService");let W=class extends c.$Tc{constructor(x,J,B,j,C,X,ae,K,ce,se,ie,M){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=J,this.r=B,this.s=j,this.t=C,this.u=X,this.w=ae,this.y=K,this.z=ce,this.C=se,this.D=ie,this.F=M,this.g=this.B(new l.$je),this.onDidChangeCache=this.g.event,this.h=(0,w.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Y,this.s,this.h)),this.m=this.B(this.F.createInstance(Y,this.s,this.h)),this.n=this.B(this.F.createInstance(H,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Up)(this.w,this.y)),this.G}async scanAllExtensions(x,J,B){const[j,C]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(J)]),X=B?await this.scanExtensionsUnderDevelopment(x,[...j,...C]):[];return this.L(j,C,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const J=[];J.push(this.M(!!x.useCache,x.language)),J.push(this.N(x.language,!!x.checkControlFile));const[B,j]=await Promise.all(J);return this.J([...B,...j],t.ExtensionType.System,x,!1)}async scanUserExtensions(x){const J=x.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const B=this.D.extUri.isEqual(x.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(J,!!x.profileLocation,t.ExtensionType.User,!x.includeUninstalled,x.language,!0,B,x.productVersion??this.R()),C=x.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let X;try{X=await C.scanExtensions(j)}catch(ae){if(ae instanceof y.$Fq&&ae.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),X=await C.scanExtensions(j);else throw ae}return X=await this.J(X,t.ExtensionType.User,x,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(x,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===m.Schemas.file).map(async j=>{const C=await this.P(j,!1,t.ExtensionType.User,!0,x.language,!1,void 0,x.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(C)).map(ae=>(ae.type=J.find(K=>(0,E.$Jp)(K.identifier,ae.identifier))?.type??ae.type,this.n.validate(ae,C)))}))).flat();return this.J(B,"development",x,!0)}return[]}async scanExistingExtension(x,J,B){const j=await this.P(x,!1,J,!0,B.language,!0,void 0,B.productVersion??this.R()),C=await this.n.scanExtension(j);return!C||!B.includeInvalid&&!C.isValid?null:C}async scanOneOrMultipleExtensions(x,J,B){const j=await this.P(x,!1,J,!0,B.language,!0,void 0,B.productVersion??this.R()),C=await this.n.scanOneOrMultipleExtensions(j);return this.J(C,J,B,!0)}async scanMultipleExtensions(x,J,B){const j=[];return await Promise.all(x.map(async C=>{const X=await this.scanOneOrMultipleExtensions(C,J,B);j.push(...X)})),this.J(j,J,B,!0)}async scanMetadata(x){const J=(0,w.$dh)(x,"package.json"),B=(await this.w.readFile(J)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(x,J){const B=(0,w.$dh)(x,"package.json"),j=(await this.w.readFile(B)).value.toString(),C=JSON.parse(j);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,C.__metadata={...C.__metadata,...J},await this.w.writeFile((0,w.$dh)(x,"package.json"),R.$Le.fromString(JSON.stringify(C,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof y.$Fq&&x.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw x}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.u.addExtensionsToProfile(x.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$Le.fromString(JSON.stringify([])))}catch(J){(0,i.$ol)(J)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$9)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.y.error(x)}finally{this.H=void 0}})()),this.H}async J(x,J,B,j){return B.includeAllVersions||(x=this.L(J===t.ExtensionType.System?x:void 0,J===t.ExtensionType.User?x:void 0,J==="development"?x:void 0,await this.getTargetPlatform(),j)),B.includeInvalid||(x=x.filter(C=>C.isValid)),x.sort((C,X)=>{const ae=h.$mc(C.location.fsPath),K=h.$mc(X.location.fsPath);return ae<K?-1:ae>K?1:0})}L(x,J,B,j,C){const X=(K,ce,se)=>{if(K.isValid&&!ce.isValid)return!1;if(K.isValid===ce.isValid){if(C&&f.gt(K.manifest.version,ce.manifest.version))return this.y.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(f.eq(K.manifest.version,ce.manifest.version)){if(K.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${ce.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===j)return this.y.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return se?this.y.warn(`Overwriting user extension ${K.location.path} with ${ce.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${ce.location.path}.`),!0},ae=new t.$qn;return x?.forEach(K=>{const ce=ae.get(K.identifier.id);(!ce||X(ce,K,!1))&&ae.set(K.identifier.id,K)}),J?.forEach(K=>{const ce=ae.get(K.identifier.id);if(!ce&&x&&K.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!ce||X(ce,K,!1))&&ae.set(K.identifier.id,K)}),B?.forEach(K=>{const ce=ae.get(K.identifier.id);(!ce||X(ce,K,!0))&&ae.set(K.identifier.id,K),ae.set(K.identifier.id,K)}),[...ae.values()]}async M(x,J){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,J,!0,void 0,this.R()),C=await(x&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",C.length),C}async N(x,J){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const j=J?await this.O():{},C=[],X=b.URI.file(h.$gc(h.$ic(m.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of B){const ce=j[K.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":C.push((0,w.$dh)(X,K.name));break;default:C.push(b.URI.file(ce));break}}const ae=await Promise.all(C.map(async K=>this.n.scanExtension(await this.P(K,!1,t.ExtensionType.System,!0,x,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ae.length),(0,n.$Gb)(ae)}async O(){try{const x=await this.w.readFile(this.r);return JSON.parse(x.value.toString())}catch{return{}}}async P(x,J,B,j,C,X,ae,K){const ce=await this.f(C??d.$x),se=await this.Q(x),ie=J&&!this.D.extUri.isEqual(x,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=ie?await this.Q(ie):void 0;return new V(x,se,ie,M,J,ae,B,j,X,K.version,K.date,this.C.commit,!this.z.isBuilt,C,ce)}async Q(x){try{const J=await this.w.stat(x);if(typeof J.mtime=="number")return J.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Lq=W,e.$Lq=W=Ee([oe(4,D.$Jl),oe(5,y.$Gq),oe(6,i.$0k),oe(7,s.$0j),oe(8,P.$Ji),oe(9,a.$qk),oe(10,L.$Hl),oe(11,o.$Bi)],W);class V{constructor(x,J,B,j,C,X,ae,K,ce,se,ie,M,F,N,z){this.location=x,this.mtime=J,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=j,this.profile=C,this.profileScanOptions=X,this.type=ae,this.excludeObsolete=K,this.validate=ce,this.productVersion=se,this.productDate=ie,this.productCommit=M,this.devMode=F,this.language=N,this.translations=z}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,J){return(0,w.$9g)(x.location,J.location)&&x.mtime===J.mtime&&(0,w.$9g)(x.applicationExtensionslocation,J.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&x.profile===J.profile&&k.$fo(x.profileScanOptions,J.profileScanOptions)&&x.type===J.type&&x.excludeObsolete===J.excludeObsolete&&x.validate===J.validate&&x.productVersion===J.productVersion&&x.productDate===J.productDate&&x.productCommit===J.productCommit&&x.devMode===J.devMode&&x.language===J.language&&O.equals(x.translations,J.translations)}}e.$Mq=V;let H=class extends c.$Tc{constructor(x,J,B,j,C,X,ae){super(),this.g=x,this.h=J,this.j=B,this.m=j,this.n=X,this.r=ae,this.f=C.extensionsEnabledWithApiProposalVersion?.map(K=>K.toLowerCase())??[]}async scanExtensions(x){const J=x.profile?await this.t(x):await this.s(x);let B={};if(x.excludeObsolete&&x.type===t.ExtensionType.User)try{const j=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(j)}catch{}return(0,v.$pg)(B)?J:J.filter(j=>!B[E.$Kp.create(j).toString()])}async s(x){const J=await this.m.resolve(x.location);if(!J.children?.length)return[];const B=await Promise.all(J.children.map(async j=>{if(!j.isDirectory||x.type===t.ExtensionType.User&&(0,w.$ah)(j.resource).indexOf(".")===0)return null;const C=new V(j.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(C)}));return(0,n.$Gb)(B).sort((j,C)=>j.location.path<C.location.path?-1:1)}async t(x){let J=await this.u(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.j.extUri.isEqual(x.location,x.applicationExtensionslocation)){J=J.filter(j=>!j.metadata?.isApplicationScoped);const B=await this.u(x.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,x);J.push(...B)}return J}async u(x,J,B){const j=await this.h.scanProfileExtensions(x,B.profileScanOptions);if(!j.length)return[];const C=await Promise.all(j.map(async X=>{if(J(X)){const ae=new V(X.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(ae,X.metadata)}return null}));return(0,n.$Gb)(C)}async scanOneOrMultipleExtensions(x){try{if(await this.m.exists((0,w.$dh)(x.location,"package.json"))){const J=await this.scanExtension(x);return J?[J]:[]}else return await this.scanExtensions(x)}catch(J){return this.r.error(`Error scanning extensions at ${x.location.path}:`,(0,T.$9)(J)),[]}}async scanExtension(x,J){try{let B=await this.w(x.location);if(B){B.publisher||(B.publisher=t.$kn),J=J??B.__metadata,delete B.__metadata;const j=(0,E.$Op)(B.publisher,B.name),C=J?.id?{id:j,uuid:J.id}:{id:j},X=J?.isSystem?t.ExtensionType.System:x.type,ae=X===t.ExtensionType.System||!!J?.isBuiltin;B=await this.y(x.location,B,V.createNlsConfiguration(x));let K={type:X,identifier:C,manifest:B,location:x.location,isBuiltin:ae,targetPlatform:J?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:J?.publisherDisplayName,metadata:J,isValid:!0,validations:[]};return x.validate&&(K=this.validate(K,x)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(j.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,t.$wn)([...B.enabledApiProposals])),K}}catch(B){x.type!==t.ExtensionType.System&&this.r.error(B)}return null}validate(x,J){let B=!0;const j=this.n.isBuilt&&this.f.includes(x.identifier.id.toLowerCase()),C=(0,u.$1p)(J.productVersion,J.productDate,J.location,x.manifest,x.isBuiltin,j);for(const[X,ae]of C)X===g.default.Error&&(B=!1,this.r.error(this.F(J.location,ae)));return x.isValid=B,x.validations=C,x}async w(x){const J=(0,w.$dh)(x,"package.json");let B;try{B=(await this.m.readFile(J)).value.toString()}catch(C){return(0,i.$ol)(C)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(x,(0,$.localize)(11326,null,J.path,C.message))),null}let j;try{j=JSON.parse(B)}catch{const X=[];(0,I.$Vn)(B,X);for(const ae of X)this.r.error(this.F(x,(0,$.localize)(11327,null,J.path,ae.offset,ae.length,(0,p.$Iq)(ae.error))));return null}return(0,I.$4n)(j)!=="object"?(this.r.error(this.F(x,(0,$.localize)(11328,null,J.path))),null):j}async y(x,J,B){const j=await this.z(x,J,B);if(j)try{const C=[],X=await this.C(j.default,C);if(C.length>0)return C.forEach(K=>{this.r.error(this.F(x,(0,$.localize)(11329,null,j.default?.path,(0,p.$Iq)(K.error))))}),J;if((0,I.$4n)(j)!=="object")return this.r.error(this.F(x,(0,$.localize)(11330,null,j.default?.path))),J;const ae=j.values||Object.create(null);return(0,A.$Jq)(this.r,J,ae,X)}catch{}return J}async z(x,J,B){const j=(0,w.$dh)(x,"package.nls.json"),C=(ce,se)=>{se.forEach(ie=>{this.r.error(this.F(x,(0,$.localize)(11331,null,ce?.path,(0,p.$Iq)(ie.error))))})},X=ce=>{this.r.error(this.F(x,(0,$.localize)(11332,null,ce?.path)))},ae=`${J.publisher}.${J.name}`,K=B.translations[ae];if(K)try{const ce=b.URI.file(K),se=(await this.m.readFile(ce)).value.toString(),ie=[],M=(0,I.$Vn)(se,ie);return ie.length>0?(C(ce,ie),{values:void 0,default:j}):(0,I.$4n)(M)!=="object"?(X(ce),{values:void 0,default:j}):{values:M.contents?M.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.m.exists(j))return;let se;try{se=await this.D(x,B)}catch{return}if(!se.localized)return{values:void 0,default:se.original};try{const ie=(await this.m.readFile(se.localized)).value.toString(),M=[],F=(0,I.$Vn)(ie,M);return M.length>0?(C(se.localized,M),{values:void 0,default:se.original}):(0,I.$4n)(F)!=="object"?(X(se.localized),{values:void 0,default:se.original}):{values:F,default:se.original}}catch{return{values:void 0,default:se.original}}}}async C(x,J){if(x)try{const B=(await this.m.readFile(x)).value.toString();return(0,I.$Vn)(B,J)}catch{}}D(x,J){return new Promise((B,j)=>{const C=X=>{const ae=(0,w.$dh)(x,`package.nls.${X}.json`);this.m.exists(ae).then(K=>{K&&B({localized:ae,original:(0,w.$dh)(x,"package.nls.json")});const ce=X.lastIndexOf("-");ce===-1?B({localized:(0,w.$dh)(x,"package.nls.json"),original:null}):(X=X.substring(0,ce),C(X))})};if(J.devMode||J.pseudo||!J.language)return B({localized:(0,w.$dh)(x,"package.nls.json"),original:null});C(J.language)})}F(x,J){return`[${x.path}]: ${J}`}};H=Ee([oe(1,y.$Gq),oe(2,L.$Hl),oe(3,i.$0k),oe(4,a.$qk),oe(5,P.$Ji),oe(6,s.$0j)],H);let Y=class extends H{constructor(x,J,B,j,C,X,ae,K,ce){super(J,j,C,X,ae,K,ce),this.J=x,this.L=B,this.H=this.B(new r.$Ah(3e3)),this.I=this.B(new l.$je),this.onDidChangeCache=this.I.event}async scanExtensions(x){const J=this.P(x),B=await this.M(J);if(this.G=x,B&&B.input&&V.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",x.type===t.ExtensionType.System?"system":"user",x.location.toString()),this.H.trigger(()=>this.O()),B.result.map(C=>(C.location=b.URI.revive(C.location),C));const j=await super.scanExtensions(x);return await this.N(J,{input:x,result:j}),j}async M(x){try{const J=await this.m.readFile(x),B=JSON.parse(J.value.toString());return{result:B.result,input:(0,S.$_h)(B.input)}}catch(J){this.r.debug("Error while reading the extension cache file:",x.path,(0,T.$9)(J))}return null}async N(x,J){try{await this.m.writeFile(x,R.$Le.fromString(JSON.stringify(J)))}catch(B){this.r.debug("Error while writing the extension cache file:",x.path,(0,T.$9)(B))}}async O(){if(!this.G)return;const x=this.P(this.G),J=await this.M(x);if(!J)return;const B=J.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!k.$fo(j,B))try{this.r.info("Invalidating Cache",B,j),await this.m.del(x),this.I.fire()}catch(C){this.r.error(C)}}P(x){const J=this.Q(x);return this.j.extUri.joinPath(J.cacheHome,x.type===t.ExtensionType.System?t.$jn:t.$in)}Q(x){return x.type===t.ExtensionType.System?this.L.defaultProfile:x.profile?this.j.extUri.isEqual(x.location,this.J.extensionsResource)?this.J:this.L.profiles.find(J=>this.j.extUri.isEqual(x.location,J.extensionsResource))??this.J:this.L.defaultProfile}};Y=Ee([oe(2,D.$Jl),oe(3,y.$Gq),oe(4,L.$Hl),oe(5,i.$0k),oe(6,a.$qk),oe(7,P.$Ji),oe(8,s.$0j)],Y);function Z(te,x){const J=(0,E.$Mp)(te.manifest.publisher,te.manifest.name);return{id:J,identifier:new t.$on(J),isBuiltin:te.type===t.ExtensionType.System,isUserBuiltin:te.type===t.ExtensionType.User&&te.isBuiltin,isUnderDevelopment:x,extensionLocation:te.location,uuid:te.identifier.uuid,targetPlatform:te.targetPlatform,publisherDisplayName:te.publisherDisplayName,...te.manifest}}class U extends W{constructor(x,J,B,j,C,X,ae,K,ce,se,ie,M){super(x,J,(0,w.$dh)(B,".vscode-oss-dev","extensions","control.json"),j,C,X,ae,K,ce,se,ie,M),this.S=(async()=>{if(d.$A)try{const F=await this.w.readFile(b.URI.file(d.$A));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(x){return this.S}}e.$Oq=U}),define(le[244],he([0,1,5,42,41,24,86,14,38,7]),function(G,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uR=void 0;let m=class extends T.$Hq{constructor(d,w,f,g,v,b){super(c.URI.file(d.extensionsPath),w,f,g,v,b)}};e.$uR=m,e.$uR=m=Ee([oe(0,p.$Ki),oe(1,I.$0k),oe(2,r.$Jl),oe(3,k.$Hl),oe(4,R.$9l),oe(5,n.$0j)],m)}),define(le[245],he([0,1,7,38,86,133,14,6,5,28,41,42]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;let d=class extends R.$Oq{constructor(f,g,v,b,$,P,E,t){super(n.URI.file($.builtinExtensionsPath),n.URI.file($.extensionsPath),$.userHome,f.defaultProfile,f,g,v,b,$,P,E,t)}};e.$Lgc=d,e.$Lgc=d=Ee([oe(0,h.$Jl),oe(1,k.$Gq),oe(2,T.$0k),oe(3,p.$0j),oe(4,r.$Ki),oe(5,c.$qk),oe(6,m.$Hl),oe(7,I.$Bi)],d)}),define(le[246],he([0,1,13,2,11,9,3,60,7,33,35,38,5,42]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;let f=class extends r.$Tc{constructor(v,b,$){super(),this.c=v,this.f=$,this.a=I.$Ii.forPaths(!T.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(v.appRoot),this.addValidFileRoot(v.extensionsPath),this.addValidFileRoot(b.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath),this.addValidFileRoot(v.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:v}=n.session;v.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(b,$)=>this.j(b,$)),v.protocol.interceptFileProtocol(k.Schemas.file,(b,$)=>this.h(b,$)),this.B((0,r.$Rc)(()=>{v.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),v.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(v){const b=(0,R.$gc)(v);return this.a.get(b)?r.$Tc.None:(this.a.set(b,!0),(0,r.$Rc)(()=>this.a.delete(b)))}h(v,b){const $=p.URI.parse(v.url);return this.f.error(`Refused to load resource ${$.fsPath} from ${k.Schemas.file}: protocol (original URL: ${v.url})`),b({error:-3})}j(v,b){const $=this.m(v);let P;return this.c.crossOriginIsolated&&((0,R.$mc)($)==="workbench.html"||(0,R.$mc)($)==="workbench-dev.html"?P=k.COI.CoopAndCoep:P=k.COI.getHeadersFromQuery(v.url)),this.a.findSubstr($)?b({path:$,headers:P}):this.b.has((0,R.$nc)($).toLowerCase())?b({path:$}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${$} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${v.url})`),b({error:-3}))}m(v){const b=p.URI.parse(v.url),$=k.$Wg.uriToFileUri(b);return(0,R.$gc)($.fsPath)}createIPCObjectUrl(){let v;const b=p.URI.from({scheme:"vscode",path:(0,c.$Yg)()}),$=b.toString(),P=async()=>v;return m.$GX.handle($,P),this.f.trace(`IPC Object URL: Registered new channel ${$}.`),{resource:b,update:E=>v=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${$}.`),m.$GX.removeHandler($)}}}};e.$6gc=f,e.$6gc=f=Ee([oe(0,h.$Ki),oe(1,w.$Jl),oe(2,d.$0j)],f)}),define(le[62],he([0,1,8,4,2,70,12,119,6,42]),function(G,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=w,e.$iq=g,e.$kq=b,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,p.$Ci)("storageService");var m;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var h;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(h||(e.StorageScope=h={}));var d;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function w($){const P=$.get(e.$eq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class f extends k.$Tc{static{this.a=60*1e3}constructor(P={flushInterval:f.a}){super(),this.m=P,this.b=this.B(new r.$me),this.c=this.B(new r.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$je),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,E,t){return r.Event.filter(this.b.event,u=>u.scope===P&&(E===void 0||u.key===E),t)}n(){this.j.value=(0,n.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,E){const{key:t,external:u}=E;if(t===e.$eq){switch(P){case h.APPLICATION:this.H=void 0;break;case h.PROFILE:this.F=void 0;break;case h.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:t,target:this.J(P)[t],external:u})}w(P){this.f.fire({reason:P})}get(P,E,t){return this.P(E)?.get(P,t)}getBoolean(P,E,t){return this.P(E)?.getBoolean(P,t)}getNumber(P,E,t){return this.P(E)?.getNumber(P,t)}getObject(P,E,t){return this.P(E)?.getObject(P,t)}storeAll(P,E){this.y(()=>{for(const t of P)this.store(t.key,t.value,t.scope,t.target,E)})}store(P,E,t,u,i=!1){if((0,T.$lg)(E)){this.remove(P,t,i);return}this.y(()=>{this.z(P,t,u),this.P(t)?.set(P,E,i)})}remove(P,E,t=!1){this.y(()=>{this.z(P,E,void 0),this.P(E)?.delete(P,t)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,E){const t=[],u=this.J(P);for(const i of Object.keys(u))u[i]===E&&t.push(i);return t}z(P,E,t,u=!1){const i=this.J(E);typeof t=="number"?i[P]!==t&&(i[P]=t,this.P(E)?.set(e.$eq,JSON.stringify(i),u)):typeof i[P]=="number"&&(delete i[P],this.P(E)?.set(e.$eq,JSON.stringify(i),u))}get D(){return this.C||(this.C=this.L(h.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(h.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(h.APPLICATION)),this.H}J(P){switch(P){case h.APPLICATION:return this.I;case h.PROFILE:return this.G;default:return this.D}}L(P){const E=this.P(P);return E?w(E):Object.create(null)}isNew(P){return this.getBoolean(e.$dq,P)===!0}async flush(P=m.NONE){this.f.fire({reason:P});const E=this.P(h.APPLICATION),t=this.P(h.PROFILE),u=this.P(h.WORKSPACE);switch(P){case m.NONE:await n.Promises.settled([E?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await n.Promises.settled([E?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(h.APPLICATION)?.items??new Map,E=this.P(h.PROFILE)?.items??new Map,t=this.P(h.WORKSPACE)?.items??new Map;return b(P,E,t,this.Q(h.APPLICATION)??"",this.Q(h.PROFILE)??"",this.Q(h.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,E){return this.w(m.NONE),(0,c.$Il)(P)?this.R(P,E):this.S(P,E)}M(P,E){return!(P.id===E.id||g(E)&&g(P))}N(P,E,t){this.y(()=>{const u=new Set;for(const[i,o]of P)u.add(i),E.get(i)!==o&&this.u(t,{key:i,external:!0});for(const[i]of E.items)u.has(i)||this.u(t,{key:i,external:!0})})}}e.$hq=f;function g($){return $.isDefault||!!$.useDefaultFlags?.globalState}class v extends f{constructor(){super(),this.U=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(h.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(h.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(h.APPLICATION,P)))}P(P){switch(P){case h.APPLICATION:return this.U;case h.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case h.APPLICATION:return"inMemory (application)";case h.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$jq=v;async function b($,P,E,t,u,i){const o=O=>{try{return JSON.parse(O)}catch{return O}},s=new Map,a=new Map;$.forEach((O,W)=>{s.set(W,O),a.set(W,o(O))});const l=new Map,S=new Map;P.forEach((O,W)=>{l.set(W,O),S.set(W,o(O))});const y=new Map,D=new Map;E.forEach((O,W)=>{y.set(W,O),D.set(W,o(O))}),console.group(t!==u?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const L=[];if(s.forEach((O,W)=>{L.push({key:W,value:O})}),console.table(L),console.groupEnd(),console.log(a),t!==u){console.group(`Storage: Profile (path: ${u}, profile specific)`);const O=[];l.forEach((W,V)=>{O.push({key:V,value:W})}),console.table(O),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${i})`);const A=[];y.forEach((O,W)=>{A.push({key:W,value:O})}),console.table(A),console.groupEnd(),console.log(D)}}),define(le[247],he([0,1,17,33,62]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=R;async function R(T,I,p){let c=p&&p.get("storage.serviceMachineId",k.StorageScope.APPLICATION)||null;if(c)return c;try{const h=(await I.readFile(T.serviceMachineIdResource)).value.toString();c=(0,r.$Xg)(h)?h:null}catch{c=null}if(!c){c=(0,r.$Yg)();try{await I.writeFile(T.serviceMachineIdResource,n.$Le.fromString(c))}catch{}}return p?.store("storage.serviceMachineId",c,k.StorageScope.APPLICATION,k.StorageTarget.MACHINE),c}}),define(le[248],he([0,1,247,24,57]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=R;async function R(T,I,p,c,m,h,d){const w={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${I.nameShort})`};if((0,k.$Bp)(I,p)&&(0,k.$Dp)(c)===r.TelemetryLevel.USAGE){const f=await(0,n.$lq)(p,m,h);w["X-Market-User-Id"]=f,w["VSCode-SessionId"]=d.machineId||f}return w}}),define(le[249],he([0,1,26,21,8,4,2,9,66,7,23,119,161,5,62,24,30,11]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=e.$xfc=void 0,n=Ie(n);class $ extends T.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(s,a){super(),this.m=s,this.n=a,this.b=this.B(new R.$je),this.onDidChangeStorage=this.b.event,this.c=this.B(new R.$je),this.onDidCloseStorage=this.c.event,this.f=this.B(new h.$bq(new h.$cq,{hint:h.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new k.$Zh,this.whenInit=this.h.p,this.j=h.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===h.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(l=>this.b.fire(l))),await this.s(s);const a=s.getBoolean(f.$dq);a===void 0?s.set(f.$dq,!0):a&&s.set(f.$dq,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=h.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===w.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,a){return this.f.get(s,a)}set(s,a){return this.f.set(s,a)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new p.$de(!1);await this.w(),s.stop(),s.elapsed()>$.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const a=(0,r.top)(Array.from(this.f.items.entries()).map(([S,y])=>({key:S,length:y.length})),(S,y)=>y.length-S.length,5).map(S=>`${S.key}:${S.length}`).join(", "),l=(await this.n.stat(c.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${l}b, Large Keys: ${a}`)}catch(a){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",a)}}async w(){this.g&&await this.g,this.j=h.StorageState.Closed,await this.f.close()}}class P extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$ic)(this.z.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,P.y)}constructor(s,a,l,S){super(l,S),this.z=s,this.C=a}async t(){return new h.$bq(new d.$_X(this.path??d.$_X.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:h.StorageHint.STORAGE_IN_MEMORY})}}class E extends P{constructor(s,a,l,S){super(s,a,l,S)}}e.$xfc=E;class t extends P{constructor(s,a,l,S){super(a.defaultProfile,s,l,S)}async s(s){await super.s(s),this.G(s)}G(s){s.get(g.$_l,void 0)===void 0&&s.set(g.$_l,new Date().toUTCString());const l=s.get(g.$$l,void 0),S=new Date().toUTCString();s.set(g.$am,typeof l>"u"?null:l),s.set(g.$$l,S)}}e.$yfc=t;class u extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$ic)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id,u.y)}constructor(s,a,l,S,y){super(l,y),this.C=s,this.D=a,this.F=S}async t(){const{storageFilePath:s,wasCreated:a}=await this.H();return new h.$bq(new d.$_X(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?h.StorageHint.STORAGE_IN_MEMORY:a?h.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:d.$_X.IN_MEMORY_PATH,wasCreated:!0};const s=(0,I.$ic)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id),a=(0,I.$ic)(s,u.y);return await m.Promises.exists(s)?{storageFilePath:a,wasCreated:!1}:(await n.promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:a,wasCreated:!0})}async I(s){let a;if((0,v.$Mi)(this.C)?a={folder:this.C.uri.toString()}:(0,v.$Ri)(this.C)&&(a={workspace:this.C.configPath.toString()}),a)try{const l=(0,I.$ic)(s,u.z);await m.Promises.exists(l)||await m.Promises.writeFile(l,JSON.stringify(a,void 0,2))}catch(l){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.$zfc=u;class i extends ${get path(){}async t(){return new h.$bq(new h.$cq,{hint:h.StorageHint.STORAGE_IN_MEMORY})}}e.$Afc=i}),define(le[250],he([0,1,4,2,62]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;class R extends r.$Tc{constructor(I,p,c){super(),this.b=I,this.c=p,this.f=c;const m=this.B(new r.$Uc);this.a=this.B(new n.$je({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Sc;return I.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(p,c)=>(p?p.push(c.key):p=[c.key],p),100)(p=>this.h(p))),I.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(p,c)=>{p||(p=new Map);let m=p.get(c.profile.id);return m||p.set(c.profile.id,m={profile:c.profile,keys:[],storage:c.storage}),m.keys.push(c.key),p},100)(p=>this.j(p))),I}h(I){const p=I.includes(k.$eq)?[this.c.defaultProfile]:[],c=[];if(I=I.filter(m=>m!==k.$eq),I.length){const m=(0,k.$gq)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:I.map(h=>({key:h,scope:k.StorageScope.PROFILE,target:m[h]}))})}this.m(p,c)}j(I){const p=[],c=new Map;for(const[m,h]of I.entries()){h.keys.includes(k.$eq)&&p.push(h.profile);const d=h.keys.filter(w=>w!==k.$eq);if(d.length){const w=(0,k.$gq)(h.storage.storage);c.set(m,{profile:h.profile,changes:d.map(f=>({key:f,scope:k.StorageScope.PROFILE,target:w[f]}))})}}this.m(p,[...c.values()])}m(I,p){(I.length||p.length)&&this.a.fire({valueChanges:p,targetChanges:I})}listen(I,p,c){switch(p){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${p}`)}async call(I,p){throw new Error(`Call not found: ${p}`)}}e.$Ngc=R}),define(le[251],he([0,1,7,38,14,5,34,41,42,12,127]),function(G,e,n,r,k,R,T,I,p,c,m){"use strict";var h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=e.$sR=e.$rR=void 0;let w=class extends p.$Ml{static{h=this}static{this.a="profileAssociationsMigration"}constructor(b,$,P,E,t){super(P,E,$,t),this.U=b,this.W=P}O(){return this.U.getItem(h.b,[]).map($=>({...$,location:(0,c.$cg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):n.URI.revive($.location)}))}Q(){const b=this.U.getItem(h.c,{});return this.U.getItem(h.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$rR=w,e.$rR=w=h=Ee([oe(0,T.$mR),oe(1,I.$Hl),oe(2,r.$Ki),oe(3,k.$0k),oe(4,R.$0j)],w);let f=d=class extends w{constructor(b,$,P,E,t){super(b,$,P,E,t),this.$=b}P(b){b.length?this.$.setItem(d.b,b.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(d.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem(d.c,b):this.$.removeItem(d.c)}Q(){const b="workspaceAndProfileInfo",$=this.$.getItem(b,void 0);if($){this.$.removeItem(b);const E=$.reduce((t,{workspace:u,profile:i})=>(t[n.URI.revive(u).toString()]=n.URI.revive(i).toString(),t),{});this.$.setItem(d.c,{workspaces:E})}const P=super.Q();return this.$.getItem(d.a,!1)||(this.R(P),this.$.setItem(d.a,!0)),P}};e.$sR=f,e.$sR=f=d=Ee([oe(0,T.$nR),oe(1,I.$Hl),oe(2,r.$Ki),oe(3,k.$0k),oe(4,R.$0j)],f);let g=class extends f{constructor(b,$,P,E){super(new m.$qR(m.SaveStrategy.IMMEDIATE,$,E,P),b,$,P,E)}async init(){return await this.$.init(),super.init()}};e.$tR=g,e.$tR=g=Ee([oe(0,I.$Hl),oe(1,r.$Ki),oe(2,k.$0k),oe(3,R.$0j)],g)}),define(le[58],he([0,1,38,14,6,5,41,42,251,34]),function(G,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=void 0,e.$ffc=(0,k.$Di)(I.$Jl);let m=class extends p.$sR{constructor(d,w,f,g,v){super(d,w,f,g,v)}getAssociatedEmptyWindows(){const d=[];for(const w of this.C.emptyWindows.keys())d.push({id:w});return d}};e.$gfc=m,e.$gfc=m=Ee([oe(0,c.$nR),oe(1,T.$Hl),oe(2,n.$Ki),oe(3,r.$0k),oe(4,R.$0j)],m)}),define(le[134],he([0,1,18,7,30]),function(G,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=R,e.$ifc=T,e.$jfc=I;async function R(p,c,m){for(const d of p){const w=d.openedWorkspace;if((0,k.$Ri)(w)){const f=await m(w);if(f){if(f.folders.some(g=>n.$7g.isEqualOrParent(c,g.uri)))return d}else if(n.$7g.isEqualOrParent(c,w.configPath))return d}}const h=p.filter(d=>(0,k.$Mi)(d.openedWorkspace)&&n.$7g.isEqualOrParent(c,d.openedWorkspace.uri));if(h.length)return h.sort((d,w)=>-(d.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function T(p,c){for(const m of p)if((0,k.$Ri)(m.openedWorkspace)&&n.$7g.isEqual(m.openedWorkspace.configPath,c)||(0,k.$Mi)(m.openedWorkspace)&&n.$7g.isEqual(m.openedWorkspace.uri,c))return m}function I(p,c){const m=h=>c.some(d=>n.$7g.isEqual(r.URI.file(d),r.URI.file(h)));for(const h of p)if(h.config?.extensionDevelopmentPath?.some(d=>m(d)))return h}}),define(le[102],he([0,1,32,43,107,47,11,9,3,18,7,6,74,30]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhb=void 0,e.$Zhb=f,e.$1hb=g,e.$2hb=v,e.$3hb=b,e.$4hb=E,e.$5hb=u,e.$6hb=i,e.$7hb=S,e.$8hb=y,r=Ie(r),k=Ie(k),e.$Yhb=(0,h.$Ci)("workspacesService");function f(D){return D.hasOwnProperty("workspace")}function g(D){return D.hasOwnProperty("folderUri")}function v(D){return D.hasOwnProperty("fileUri")}function b(D){return $(D)||P(D)}function $(D){const L=D;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function P(D){const L=D;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function E(D,L,A,O,W){if(D.scheme!==O.scheme)return{name:A,uri:D.toString(!0)};let V=L?void 0:W.relativePath(O,D);if(V!==void 0)V.length===0?V=".":p.$j&&(V=t(V));else if(D.scheme===T.Schemas.file)V=D.fsPath,p.$j&&(V=t(V));else if(W.isEqualAuthority(D.authority,O.authority))V=D.path;else return{name:A,uri:D.toString(!0)};return{name:A,path:V}}function t(D){return D=(0,R.$Xw)(D),(0,n.$yg)(D)||(D=(0,n.$vg)(D)),D}function u(D,L,A){const O=[],W=new Set,V=A.dirname(L);for(const H of D){let Y;if($(H))H.path&&(Y=A.resolvePath(V,H.path));else if(P(H))try{Y=m.URI.parse(H.uri),Y.path[0]!==I.$fc.sep&&(Y=Y.with({path:I.$fc.sep+Y.path}))}catch(Z){console.warn(Z)}if(Y){const Z=A.getComparisonKey(Y);if(!W.has(Z)){W.add(Z);const U=H.name||A.basenameOrAuthority(Y);O.push(new w.$Wi({uri:Y,name:U,index:O.length},H))}}}return O}function i(D,L,A,O,W){const V=o(L,D),H=W.dirname(L),Y=W.dirname(O),Z=[];for(const J of V.folders){const B=$(J)?W.resolvePath(H,J.path):m.URI.parse(J.uri);let j;A?j=!1:j=!$(J)||(0,I.$hc)(J.path),Z.push(E(B,j,J.name,Y,W))}const U={insertSpaces:!1,tabSize:4,eol:p.$l||p.$k?`
`:`\r
`},te=k.$0n(D,["folders"],Z,U);let x=k.$ao(D,te);return(0,c.$ih)(V.remoteAuthority,(0,d.$en)(O))&&(x=k.$ao(x,k.$9n(x,["remoteAuthority"],U))),x}function o(D,L){const A=r.$Vn(L);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(O=>b(O));else throw new Error(`${D} looks like an invalid workspace file.`);return A}function s(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function a(D){return typeof D.folderUri=="string"}function l(D){return typeof D.fileUri=="string"}function S(D,L){const A={workspaces:[],files:[]};if(D){const O=function(V,H){for(let Y=0;Y<V.length;Y++)try{H(V[Y],Y)}catch(Z){L.warn(`Error restoring recent entry ${JSON.stringify(V[Y])}: ${Z.toString()}. Skip entry.`)}},W=D;Array.isArray(W.entries)&&O(W.entries,V=>{const H=V.label,Y=V.remoteAuthority;s(V)?A.workspaces.push({label:H,remoteAuthority:Y,workspace:{id:V.workspace.id,configPath:m.URI.parse(V.workspace.configPath)}}):a(V)?A.workspaces.push({label:H,remoteAuthority:Y,folderUri:m.URI.parse(V.folderUri)}):l(V)&&A.files.push({label:H,remoteAuthority:Y,fileUri:m.URI.parse(V.fileUri)})})}return A}function y(D){const L={entries:[]};for(const A of D.workspaces)g(A)?L.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):L.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of D.files)L.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return L}}),define(le[103],he([0,1,91,11,3,18]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0,e.$lfc=T,e.$mfc=I,e.$nfc=p,e.$kfc=128/4;function T(c){function m(){let h=c.scheme===r.Schemas.file?(0,R.$4g)(c):c.toString();return k.$l||(h=h.toLowerCase()),(0,n.createHash)("md5").update(h).digest("hex")}return{id:m(),configPath:c}}function I(c,m){function h(){if(c.scheme!==r.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!m)return;let w;return k.$l?w=m.ino:k.$k?w=m.birthtime.getTime():k.$j&&(typeof m.birthtimeMs=="number"?w=Math.floor(m.birthtimeMs):w=m.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(w?String(w):"").digest("hex")}const d=h();if(typeof d=="string")return{id:d,uri:c}}function p(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[104],he([0,1,91,93,27,252,17,15,4,2,9,3,33,44,117]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=s,e.$vi=a,e.$xi=y,e.$yi=D;const g=3e4;class v{traceSocketEvent(A,O){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,O)}constructor(A,O=""){this.f=!0,this.debugLabel=O,this.socket=A,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=V=>{if(this.traceSocketEvent(f.SocketDiagnosticsEventType.Error,{code:V?.code,message:V?.message}),V){if(V.code==="EPIPE")return;(0,I.$Y)(V)}},this.socket.on("error",this.a);let W;this.b=V=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Close,{hadError:V}),this.f=!1,W&&clearTimeout(W)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,W=setTimeout(()=>A.destroy(),g)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(A){const O=W=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Read,W),A(T.$Le.wrap(W))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(A){const O=W=>{A({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:W,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(A){const O=()=>{A()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(A){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(f.SocketDiagnosticsEventType.Write,A),this.socket.write(A.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}}end(){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((A,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),A();return}const W=()=>{this.socket.off("close",W),this.socket.off("end",W),this.socket.off("error",W),this.socket.off("timeout",W),this.socket.off("drain",W),this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),A()};this.socket.on("close",W),this.socket.on("end",W),this.socket.on("error",W),this.socket.on("timeout",W),this.socket.on("drain",W)})}}e.$ri=v;var b;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var $;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})($||($={}));class P extends c.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(A,O){this.socket.traceSocketEvent(A,O)}constructor(A,O,W,V){super(),this.f=this.B(new p.$je),this.g=this.B(new p.$je),this.h=!1,this.j={state:$.PeekHeader,readLen:b.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=A,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:W?.byteLength||0,recordInflateBytes:V}),this.a=this.B(new E(this,O,W,V,this.f,(H,Y)=>this.m(H,Y))),this.B(this.a.onError(H=>{console.error(H),(0,I.$Y)(H),this.g.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:H})})),this.b=new f.$mi,this.B(this.socket.onData(H=>this.n(H))),this.B(this.socket.onClose(async H=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(H)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this.f.event(A)}onClose(A){return this.g.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){let O=0;for(;O<A.byteLength;)this.a.writeMessage(A.slice(O,Math.min(O+b.MaxWebSocketMessageLength,A.byteLength)),{compressed:!0,opcode:2}),O+=b.MaxWebSocketMessageLength}m(A,{compressed:O,opcode:W}){if(this.h)return;this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,A);let V=b.MinHeaderByteSize;A.byteLength<126?V+=0:A.byteLength<2**16?V+=2:V+=8;const H=T.$Le.alloc(V),Y=O?64:0,Z=W&15;if(H.writeUInt8(128|Y|Z,0),A.byteLength<126)H.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){H.writeUInt8(126,1);let U=1;H.writeUInt8(A.byteLength>>>8&255,++U),H.writeUInt8(A.byteLength>>>0&255,++U)}else{H.writeUInt8(127,1);let U=1;H.writeUInt8(0,++U),H.writeUInt8(0,++U),H.writeUInt8(0,++U),H.writeUInt8(0,++U),H.writeUInt8(A.byteLength>>>24&255,++U),H.writeUInt8(A.byteLength>>>16&255,++U),H.writeUInt8(A.byteLength>>>8&255,++U),H.writeUInt8(A.byteLength>>>0&255,++U)}this.socket.write(T.$Le.concat([H,A]))}end(){this.h=!0,this.socket.end()}n(A){if(A.byteLength!==0){for(this.b.acceptChunk(A);this.b.byteLength>=this.j.readLen;)if(this.j.state===$.PeekHeader){const O=this.b.peek(this.j.readLen),W=O.readUInt8(0),V=(W&128)>>>7,H=(W&64)>>>6,Y=W&15,Z=O.readUInt8(1),U=(Z&128)>>>7,te=Z&127;this.j.state=$.ReadHeader,this.j.readLen=b.MinHeaderByteSize+(U?4:0)+(te===126?2:0)+(te===127?8:0),this.j.fin=V,this.j.firstFrameOfMessage&&(this.j.compressed=!!H),this.j.firstFrameOfMessage=!!V,this.j.mask=0,this.j.opcode=Y,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===$.ReadHeader){const O=this.b.read(this.j.readLen),W=O.readUInt8(1),V=(W&128)>>>7;let H=W&127,Y=1;H===126?H=O.readUInt8(++Y)*2**8+O.readUInt8(++Y):H===127&&(H=O.readUInt8(++Y)*0+O.readUInt8(++Y)*0+O.readUInt8(++Y)*0+O.readUInt8(++Y)*0+O.readUInt8(++Y)*2**24+O.readUInt8(++Y)*2**16+O.readUInt8(++Y)*2**8+O.readUInt8(++Y));let Z=0;V&&(Z=O.readUInt8(++Y)*2**24+O.readUInt8(++Y)*2**16+O.readUInt8(++Y)*2**8+O.readUInt8(++Y)),this.j.state=$.ReadBody,this.j.readLen=H,this.j.mask=Z,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===$.ReadBody){const O=this.b.read(this.j.readLen);this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,O),i(O,this.j.mask),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,O),this.j.state=$.PeekHeader,this.j.readLen=b.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=P;class E extends c.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Le.alloc(0)}constructor(A,O,W,V,H,Y){super(),this.n=A,this.r=H,this.s=Y,this.a=this.B(new p.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new t(this.n,V,W,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(Z=>this.a.fire(Z))),this.B(this.f.onError(Z=>this.a.fire(Z)))):(this.b=null,this.f=null)}writeMessage(A,O){this.g.push({data:A,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:A,options:O}=this.g.shift();if(this.f&&O.compressed){const W=await this.w(this.f,A);this.s(W,O)}else this.s(A,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(A,O){return new Promise((W,V)=>{A.write(O),A.flush(H=>W(H))})}acceptFrame(A,O,W){this.h.push({data:A,isCompressed:O,isLastFrameOfMessage:W}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const A=this.h.shift();if(this.b&&A.isCompressed){const O=await this.C(this.b,A.data,A.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(A.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(A,O,W){return new Promise((V,H)=>{A.write(O),W&&A.write(T.$Le.fromByteArray([0,0,255,255])),A.flush(Y=>V(Y))})}}class t extends c.$Tc{get recordedInflateBytes(){return this.j?T.$Le.concat(this.f):T.$Le.alloc(0)}constructor(A,O,W,V){super(),this.h=A,this.j=O,this.a=this.B(new p.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(V),this.b.on("error",H=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateError,{message:H?.message,code:H?.code}),this.a.fire(H)}),this.b.on("data",H=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateData,H),this.g.push(T.$Le.wrap(H))}),W&&(this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialWrite,W.buffer),this.b.write(W.buffer),this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(A){this.j&&this.f.push(A.clone()),this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateWrite,A),this.b.write(A.buffer)}flush(A){this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateFlushFired);const O=T.$Le.concat(this.g);this.g.length=0,A(O)})}}class u extends c.$Tc{constructor(A,O){super(),this.g=A,this.a=this.B(new p.$je),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",W=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateError,{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateData,W),this.f.push(T.$Le.wrap(W))})}write(A){this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateWrite,A.buffer),this.b.write(A.buffer)}flush(A){this.b.flush(2,()=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateFlushFired);let O=T.$Le.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),A(O)})}}function i(L,A){if(A===0)return;const O=L.byteLength>>>2;for(let U=0;U<O;U++){const te=L.readUInt32BE(U*4);L.writeUInt32BE(te^A,U*4)}const W=O*4,V=L.byteLength-W,H=A>>>24&255,Y=A>>>16&255,Z=A>>>8&255;V>=1&&L.writeUInt8(L.readUInt8(W)^H,W),V>=2&&L.writeUInt8(L.readUInt8(W+1)^Y,W+1),V>=3&&L.writeUInt8(L.readUInt8(W+2)^Z,W+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const o={[h.Platform.Linux]:107,[h.Platform.Mac]:103};function s(){const L=(0,d.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const A=process.platform!=="darwin"&&e.$ti?e.$ti:(0,k.tmpdir)(),O=(0,m.$ic)(A,`vscode-ipc-${L}.sock`);return l(O),O}function a(L,A,O){const V=(0,n.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${V}-${O}-${A}-sock`;const H=O.substr(0,4),Y=A.substr(0,6);let Z;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?Z=(0,m.$ic)(e.$ti,`vscode-${V}-${H}-${Y}.sock`):Z=(0,m.$ic)(L,`${H}-${Y}.sock`),l(Z),Z}function l(L){const A=o[h.$v];typeof A=="number"&&L.length>=A&&console.warn(`WARNING: IPC handle "${L}" is longer than ${A} chars, try a shorter --user-data-dir`)}class S extends w.$gi{static b(A){const O=p.Event.fromNodeEventEmitter(A,"connection");return p.Event.map(O,W=>({protocol:new f.$ni(new v(W,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(W,"close"))}))}constructor(A){super(S.b(A)),this.d=A}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=S;function y(L){return new Promise((A,O)=>{const W=(0,r.createServer)();W.on("error",O),W.listen(L,()=>{W.removeListener("error",O),A(new S(W))})})}function D(L,A){return new Promise((O,W)=>{const V=(0,r.createConnection)(L,()=>{V.removeListener("error",W),O(f.$oi.fromSocket(new v(V,`ipc-client${A}`),A))});V.once("error",W)})}}),define(le[20],he([0,1,53,9,3,104,38,95,6]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0,e.$2ec=(0,p.$Di)(T.$Ji);class c extends I.$6m{constructor(){super(...arguments),this.d={}}get backupHome(){return(0,r.$ic)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$vi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$ic)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(k.$l){for(const h in process.env)if(h.endsWith("_VSCODE_SNAP_ORIG")){const d=h.slice(0,-17);if(this.d[d])continue;process.env[d]&&(this.d[d]=process.env[d]),process.env[h]?process.env[d]=process.env[h]:delete process.env[d]}}}restoreSnapExportedVariables(){if(k.$l)for(const h in this.d)process.env[h]=this.d[h],delete this.d[h]}}e.$3ec=c,Ee([n.$7h],c.prototype,"backupHome",null),Ee([n.$7h],c.prototype,"mainIPCHandle",null),Ee([n.$7h],c.prototype,"mainLockfile",null),Ee([n.$7h],c.prototype,"disableUpdates",null),Ee([n.$7h],c.prototype,"crossOriginIsolated",null),Ee([n.$7h],c.prototype,"codeCachePath",null),Ee([n.$7h],c.prototype,"useCodeCache",null)}),define(le[253],he([0,1,91,32,11,9,3,18,23,165,16,20,34,14,5,164,30,103]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;let P=class{static{$=this}static{this.a="backupWorkspaces"}constructor(t,u,i,o){this.j=t,this.k=u,this.l=i,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$7g,this.i={isEqual:(s,a)=>(0,r.$Ag)(s,a,!T.$l)}}async initialize(){const t=this.m.getItem($.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(t.emptyWindows),this.d=await this.u((0,c.$7ec)(t)),this.e=await this.v((0,c.$8ec)(t)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==w.$wl.OFF}q(){return this.s()===w.$wl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||w.$wl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(t,u){this.d.some(o=>t.workspace.id===o.workspace.id)||(this.d.push(t),this.C());const i=(0,R.$ic)(this.c,t.workspace.id);return u?this.t(i,u).then(()=>i):i}async t(t,u){if(await p.Promises.exists(t)&&await this.z(t),await p.Promises.exists(u))try{await p.Promises.rename(u,t,!1)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(t){return this.e.some(u=>this.h.isEqual(t.folderUri,u.folderUri))||(this.e.push(t),this.C()),(0,R.$ic)(this.c,this.D(t))}registerEmptyWindowBackup(t){return this.g.some(u=>!!u.backupFolder&&this.i.isEqual(u.backupFolder,t.backupFolder))||(this.g.push(t),this.C()),(0,R.$ic)(this.c,t.backupFolder)}async u(t){if(!Array.isArray(t))return[];const u=new Set,i=[];for(const o of t){const s=o.workspace;if(!(0,v.$Ri)(s))return[];if(!u.has(s.id)){u.add(s.id);const a=(0,R.$ic)(this.c,s.id);await this.B(a)?s.configPath.scheme!==k.Schemas.file||await p.Promises.exists(s.configPath.fsPath)?i.push(o):await this.z(a):await this.x(a)}}return i}async v(t){if(!Array.isArray(t))return[];const u=[],i=new Set;for(const o of t){const s=o.folderUri,a=this.h.getComparisonKey(s);if(!i.has(a)){i.add(a);const l=(0,R.$ic)(this.c,this.D(o));await this.B(l)?s.scheme!==k.Schemas.file||await p.Promises.exists(s.fsPath)?u.push(o):await this.z(l):await this.x(l)}}return u}async w(t){if(!Array.isArray(t))return[];const u=[],i=new Set;for(const o of t){const s=o.backupFolder;if(typeof s!="string")return[];if(!i.has(s)){i.add(s);const a=(0,R.$ic)(this.c,s);await this.B(a)?u.push(o):await this.x(a)}}return u}async x(t){try{await p.Promises.rm(t,p.RimRafMode.MOVE)}catch(u){this.l.error(`Backup: Could not delete stale backup: ${u.toString()}`)}}y(){let t=(0,b.$nfc)();for(;this.g.some(u=>!!u.backupFolder&&this.i.isEqual(u.backupFolder,t.id));)t=(0,b.$nfc)();return{backupFolder:t.id}}async z(t){const u=this.y(),i=(0,R.$ic)(this.c,u.backupFolder);try{await p.Promises.rename(t,i,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(u),!0}async getDirtyWorkspaces(){const t=[];for(const u of this.d)await this.A(u)&&t.push(u);for(const u of this.e)await this.A(u)&&t.push(u);return t}A(t){let u;return(0,c.$6ec)(t)?u=(0,R.$ic)(this.c,t.backupFolder):(0,g.$Whb)(t)?u=(0,R.$ic)(this.c,this.D(t)):u=(0,R.$ic)(this.c,t.workspace.id),this.B(u)}async B(t){try{const u=await p.Promises.readdir(t);for(const i of u)try{if((await p.Promises.readdir((0,R.$ic)(t,i))).length>0)return!0}catch{}}catch{}return!1}C(){const t={workspaces:this.d.map(({workspace:u,remoteAuthority:i})=>{const o={id:u.id,configURIPath:u.configPath.toString()};return i&&(o.remoteAuthority=i),o}),folders:this.e.map(({folderUri:u,remoteAuthority:i})=>{const o={folderUri:u.toString()};return i&&(o.remoteAuthority=i),o}),emptyWindows:this.g.map(({backupFolder:u,remoteAuthority:i})=>{const o={backupFolder:u};return i&&(o.remoteAuthority=i),o})};this.m.setItem($.a,t)}D(t){const u=t.folderUri;let i;return u.scheme===k.Schemas.file?i=T.$l?u.fsPath:u.fsPath.toLowerCase():i=u.toString().toLowerCase(),(0,n.createHash)("md5").update(i).digest("hex")}};e.$Hfc=P,e.$Hfc=P=$=Ee([oe(0,h.$2ec),oe(1,m.$9i),oe(2,f.$0j),oe(3,d.$nR)],P)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[19],he([0,1,13,35,8,4,2,3,36,12,6,5,34,51,20]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.LifecycleMainPhase=e.ShutdownReason=e.$vfc=void 0,n=Ge(n),e.$vfc=(0,m.$Ci)("lifecycleMainService");var v;(function(P){P[P.QUIT=1]="QUIT",P[P.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var b;(function(P){P[P.Starting=1]="Starting",P[P.Ready=2]="Ready",P[P.AfterWindowOpen=3]="AfterWindowOpen",P[P.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let $=class extends T.$Tc{static{g=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(E,t,u){super(),this.F=E,this.G=t,this.H=u,this.c=this.B(new R.$je),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$je),this.onWillShutdown=this.f.event,this.g=this.B(new R.$je),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$je),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=b.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(b.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(g.b),this.m&&this.G.removeItem(g.b)}J(){const E=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$k&&this.t===0&&this.L(v.QUIT))};n.default.app.addListener("before-quit",E);const t=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$k)&&n.default.app.quit()};n.default.app.addListener("window-all-closed",t),n.default.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(v.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.default.app.removeListener("before-quit",E),n.default.app.removeListener("window-all-closed",t),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.default.app.quit()})})}L(E){if(this.y)return this.y;const t=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:E,join(i,o){t.trace(`Lifecycle#onWillShutdown - begin '${i}'`),u.push(o.finally(()=>{t.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await k.Promises.settled(u)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===E)return;this.S(`lifecycle (main): phase changed (value: ${E})`),this.n=E;const t=this.C.get(this.n);t&&(t.open(),this.C.delete(this.n))}async when(E){if(E<=this.n)return;let t=this.C.get(E);t||(t=new k.$Bh,this.C.set(E,t)),await t.wait()}registerWindow(E){const t=new T.$Sc;this.t++,t.add(E.onWillLoad(i=>this.g.fire({window:E,workspace:i.workspace,reason:i.reason})));const u=(0,c.$ng)(E.win);t.add(R.Event.fromNodeEventEmitter(u,"close")(i=>{const o=E.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${E.id}`),i.preventDefault(),this.unload(E,w.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(E),E.close()})})),t.add(R.Event.fromNodeEventEmitter(u,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.t--,t.dispose(),this.t===0&&(!I.$k||this.j)&&this.L(v.QUIT)}))}registerAuxWindow(E){const t=(0,c.$ng)(E.win),u=new T.$Sc;u.add(R.Event.fromNodeEventEmitter(t,"close")(i=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${E.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),i.preventDefault())})),u.add(R.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${E.id}`),u.dispose()}))}async reload(E,t){await this.unload(E,w.UnloadReason.RELOAD)||E.reload(t)}unload(E,t){const u=this.z.get(E.id);if(u)return u;const i=this.M(E,t).finally(()=>{this.z.delete(E.id)});return this.z.set(E.id,i),i}async M(E,t){if(!E.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${E.id}`);const u=this.j?w.UnloadReason.QUIT:t,i=await this.P(E,u);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.N(i)):(await this.Q(E,u),!1)}N(E){return E?(this.O(!0),this.j=!1,!0):!1}O(E){this.w&&(this.w(E),this.w=void 0,this.u=void 0)}P(E,t){return new Promise(u=>{const i=this.s++,o=`vscode:ok${i}`,s=`vscode:cancel${i}`;r.$GX.once(o,()=>{u(!1)}),r.$GX.once(s,()=>{u(!0)}),E.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:t})})}Q(E,t){return new Promise(u=>{const o=`vscode:reply${this.s++}`;r.$GX.once(o,()=>u()),E.send("vscode:onWillUnload",{replyChannel:o,reason:t})})}quit(E){return this.R(E).then(t=>{if(!t&&E)try{if(I.$j){const u=(0,p.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return t})}R(E){return this.S(`Lifecycle#quit() - begin (willRestart: ${E})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(E&&this.G.setItem(g.b,!0),this.u=new Promise(t=>{this.w=t,this.S("Lifecycle#quit() - calling app.quit()"),n.default.app.quit()}),this.u)}S(E){this.H.args["enable-smoke-test-driver"]?this.F.info(E):this.F.trace(E)}setRelaunchHandler(E){this.D=E}async relaunch(E){this.S("Lifecycle#relaunch()");const t=process.argv.slice(1);if(E?.addArgs&&t.push(...E.addArgs),E?.removeArgs)for(const o of E.removeArgs){const s=t.indexOf(o);s>=0&&t.splice(s,1)}const u=()=>{this.D?.handleRelaunch(E)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.default.app.relaunch({args:t}))};n.default.app.once("quit",u),await this.quit(!0)&&n.default.app.removeListener("quit",u)}async kill(E){this.S("Lifecycle#kill()"),await this.L(v.KILL),await Promise.race([(0,k.$Dh)(1e3),(async()=>{for(const t of n.default.BrowserWindow.getAllWindows())if(t&&!t.isDestroyed()){let u;t.webContents&&!t.webContents.isDestroyed()?u=new Promise(i=>t.once("closed",i)):u=Promise.resolve(),t.destroy(),await u}})()]),n.default.app.exit(E)}};e.$wfc=$,e.$wfc=$=g=Ee([oe(0,h.$0j),oe(1,d.$nR),oe(2,f.$2ec)],$)}),define(le[254],he([0,1,3,4,2,6,19]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=void 0,n=Ie(n),e.$6fc=(0,R.$Ci)("keyboardLayoutMainService");let I=class extends k.$Tc{constructor(m){super(),this.a=this.B(new r.$je),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(T.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((h,d)=>{G(["native-keymap"],h,d)}).then(Ie);this.c=p(m),n.$u||m.onDidChangeKeyboardLayout(()=>{this.c=p(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$7fc=I,e.$7fc=I=Ee([oe(0,T.$vfc)],I);function p(c){const m=c.getKeyMap(),h=c.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:h}}}),define(le[255],he([0,1,215,8,17,15,12,16,38,100,5,56,214,252]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0,e.$ds=v;let f=class extends h.$6p{constructor($,P,E,t){super(t),this.m=$,this.n=P,this.r=E,this.s(),this.B($.onDidChangeConfiguration(u=>{u.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,P){const{f:E,g:t}=this;let u;try{u=await(0,c.$Om)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$9)(s)))}const i={...process.env,...u},o=$.agent?$.agent:await(0,d.$bs)($.url||"",i,{proxyUrl:E,strictSSL:t});return $.agent=o,$.strictSSL=t,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>v($,P))}async resolveProxy($){}async lookupAuthorization($){}async loadCertificates(){return(await new Promise((P,E)=>{G(["@vscode/proxy-agent"],P,E)}).then(Ie)).loadSystemCertificates({log:this.r})}};e.$cs=f,e.$cs=f=Ee([oe(0,I.$9i),oe(1,p.$Ki),oe(2,m.$0j),oe(3,m.$$j)],f);async function g(b){return((0,n.parse)(b.url).protocol==="https:"?await new Promise((E,t)=>{G(["https"],E,t)}).then(Ie):await new Promise((E,t)=>{G(["http"],E,t)}).then(Ie)).request}async function v(b,$){return r.Promises.withAsyncBody(async(P,E)=>{const t=(0,n.parse)(b.url),u=b.getRawRequest?b.getRawRequest(b):await g(b),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,T.$ig)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(i.auth=b.user+":"+b.password);const o=u(i,s=>{const a=(0,T.$gg)(b.followRedirects)?b.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&a>0&&s.headers.location)v({...b,url:s.headers.location,followRedirects:a-1},$).then(P,E);else{let l=s;!b.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,w.createGunzip)())),P({res:s,stream:(0,k.$1e)(l)})}});o.on("error",E),b.timeout&&o.setTimeout(b.timeout),b.isChromiumNetwork&&o.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&o.write(b.data),o.end(),$.onCancellationRequested(()=>{o.abort(),E(new R.$4)})})}}),define(le[256],he([0,1,13,255]),function(G,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;function k(T){return n.net.request}class R extends r.$cs{request(I,p){return super.request({...I||{},getRawRequest:k,isChromiumNetwork:!0},p)}}e.$$gc=R}),define(le[87],he([0,1,7,4,2,38,14,6,19,5,62,249,42,58,41,11]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=e.$Cfc=e.$Bfc=void 0,e.$Bfc=(0,I.$Ci)("storageMainService");let v=class extends k.$Tc{constructor(P,E,t,u,i,o){super(),this.c=P,this.f=E,this.g=t,this.h=u,this.j=i,this.m=o,this.a=void 0,this.b=this.B(new r.$je),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(p.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(P=>{P.window.profile&&this.profileStorage(P.window.profile).init(),P.workspace&&this.workspaceStorage(P.workspace).init()})),this.B(this.h.onWillShutdown(P=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=P.reason,P.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)P.join("profileStorage",E.close());for(const[,E]of this.w)P.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(P=>{P.join((async()=>{await this.j.exists(P.profile.globalStorageHome)||await this.j.createFolder(P.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(P=>{const E=this.t.get(P.profile.id);E&&P.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const P=new h.$yfc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(P.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),P}profileStorage(P){if((0,m.$iq)(P))return this.applicationStorage;let E=this.t.get(P.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${P.name})`),E=this.B(this.u(P)),this.t.set(P.id,E);const t=this.B(E.onDidChangeStorage(u=>this.b.fire({...u,storage:E,profile:P})));this.B(r.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${P.name})`),this.t.delete(P.id),t.dispose()}))}return E}u(P){return this.a===p.ShutdownReason.KILL?new h.$Afc(this.c,this.j):new h.$xfc(P,this.n(),this.c,this.j)}workspaceStorage(P){let E=this.w.get(P.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${P.id})`),E=this.B(this.y(P)),this.w.set(P.id,E),this.B(r.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${P.id})`),this.w.delete(P.id)}))),E}y(P){return this.a===p.ShutdownReason.KILL?new h.$Afc(this.c,this.j):new h.$zfc(P,this.n(),this.c,this.f,this.j)}isUsed(P){const E=n.URI.file(P);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(n.URI.file(t.path),E))return!0;return!1}};e.$Cfc=v,e.$Cfc=v=Ee([oe(0,c.$0j),oe(1,R.$Ji),oe(2,w.$ffc),oe(3,p.$vfc),oe(4,T.$0k),oe(5,f.$Hl)],v),e.$Dfc=(0,I.$Ci)("applicationStorageMainService");let b=class extends m.$hq{constructor(P,E){super(),this.s=P,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(P){if(P===m.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(P){if(P===m.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$Efc=b,e.$Efc=b=Ee([oe(0,d.$Jl),oe(1,e.$Bfc)],b)}),define(le[257],he([0,1,93,27,113,104,8,2,3,16,5,28,208,211,101,131,17]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=e.$8gc=e.$7gc=void 0,n=Ie(n),r=Ie(r);async function b(u,i,o,s,a){let l;for(let S=3;S&&(l?.dispose(),l=await new $(u,i,o,s,a).waitForReady(),!(a&&k.$2g[a]||!k.$2g[l.tunnelLocalPort]));S--);return l}class $ extends I.$Tc{constructor(i,o,s,a,l){super(),this.m=o,this.n=l,this.privacy=g.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=n.createServer(),this.c=new T.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,o=(0,g.$Jw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,k.$3g)(i,2,1e3,o),a=null;return this.b.listen(s,this.m),await this.c.wait(),a=this.b.address(),a||(s=0,this.b.listen(s,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(i){i.pause();const o=(0,g.$Hw)(this.tunnelRemoteHost)||(0,g.$Jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,d.$Zl)(this.a,o,this.tunnelRemotePort),a=s.getSocket(),l=s.readEntireBuffer();s.dispose(),l.byteLength>0&&i.write(l.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),a.end()}),i.on("close",()=>a.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),a instanceof R.$ri?a.socket.destroy():a.end()}),a instanceof R.$ri?this.t(i,a):this.s(i,a),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),a.end()})}s(i,o){o.onClose(()=>i.destroy()),o.onEnd(()=>i.end()),o.onData(s=>i.write(s.buffer)),i.on("data",s=>o.write(v.$Le.wrap(s))),i.resume()}t(i,o){const s=o.socket;s.on("end",()=>i.end()),s.on("close",()=>i.end()),s.on("error",()=>{i.destroy()}),s.pipe(i),i.pipe(s)}}e.$7gc=$;let P=class extends g.$Mw{constructor(i,o,s,a,l){super(o,l),this.H=i,this.I=s,this.J=a}isPortPrivileged(i){return(0,g.$Kw)(i,this.t,p.OS,r.release())}F(i,o,s,a,l,S,y,D){const L=this.D(o,s);if(L)return++L.refcount,L.value;if((0,g.$Dw)(i))return this.G(i,o,s,l,S,y,D);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${s} on local port ${l}.`);const A={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},O=b(A,a,o,s,l);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(o,s,O),O}}};e.$8gc=P,e.$8gc=P=Ee([oe(0,w.$Tl),oe(1,m.$0j),oe(2,f.$Wl),oe(3,h.$qk),oe(4,c.$9i)],P);let E=class extends P{constructor(i,o,s,a,l){super(i,o,s,a,l)}};e.$9gc=E,e.$9gc=E=Ee([oe(0,w.$Tl),oe(1,m.$0j),oe(2,f.$Wl),oe(3,h.$qk),oe(4,c.$9i)],E);let t=class extends I.$Tc{constructor(i,o,s,a,l){super(),this.b=i,this.c=o,this.f=s,this.g=a,this.h=l,this.a=new Map}async openTunnel(i,o,s,a,l,S,y,D,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${a} on local port ${S}.`),!this.a.has(i)){const A=new E(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(i,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(o,s,a,l,S,y,D,L)}};e.$0gc=t,e.$0gc=t=Ee([oe(0,w.$Tl),oe(1,m.$0j),oe(2,h.$qk),oe(3,f.$Wl),oe(4,c.$9i)],t)}),define(le[105],he([0,1,8,22,4,16,20,19,5,28,56,49]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0,e.$qgc=d;function d(f,g,v){return`${v.updateUrl}/api/update/${f}/${g}/${v.commit}`}let w=class{get state(){return this.b}d(g){this.j.info("update#setState",g.type),this.b=g,this.c.fire(g)}constructor(g,v,b,$,P,E){this.f=g,this.g=v,this.h=b,this.i=$,this.j=P,this.k=E,this.b=h.$EY.Uninitialized,this.c=new k.$je,this.onStateChange=this.c.event,g.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(h.$EY.Disabled(h.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(h.$EY.Disabled(h.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(h.$EY.Disabled(h.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.g.getValue("update.mode"),v=this.m(g);if(!v){this.d(h.$EY.Disabled(h.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(v),!this.a){this.d(h.$EY.Disabled(h.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const b=new URL(this.a);b.searchParams.set("prss","true"),this.a=b.toString()}if(this.d(h.$EY.Idle(this.q())),g==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,b=>this.j.error(b))}m(g){return g==="none"?void 0:this.k.quality}n(g=60*60*1e3){return(0,n.$Dh)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(g){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===h.StateType.Idle&&this.t(g)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===h.StateType.AvailableForDownload&&await this.o(this.state)}async o(g){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===h.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==h.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(v){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(v);return}}async _applySpecificUpdate(g){}q(){return h.UpdateType.Archive}r(){}};e.$rgc=w,e.$rgc=w=Ee([oe(0,I.$vfc),oe(1,R.$9i),oe(2,T.$2ec),oe(3,m.$5p),oe(4,p.$0j),oe(5,c.$qk)],w)}),define(le[258],he([0,1,13,53,4,46,2,16,20,19,5,28,56,24,49,105]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0,n=Ie(n);let v=class extends g.$rgc{get v(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"error",($,P)=>P)}get w(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",($,P,E,t)=>({version:E,productVersion:E,timestamp:t}))}constructor($,P,E,t,u,i,o){super($,P,t,u,i,o),this.z=E,this.u=new T.$Sc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!==f.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.z.publicLog2("update:error",{messageHash:String((0,R.$qj)(String($)))}),this.j.error("UpdateService error:",$);const P=this.state.type===f.StateType.CheckingForUpdates&&this.state.explicit?$:void 0;this.d(f.$EY.Idle(f.UpdateType.Archive,P))}s($){let P;this.k.darwinUniversalAssetId?P=this.k.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const E=(0,g.$qgc)(P,$,this.k);try{n.autoUpdater.setFeedURL({url:E})}catch(t){this.j.error("Failed to set update feed URL",t);return}return E}t($){this.d(f.$EY.CheckingForUpdates($)),n.autoUpdater.checkForUpdates()}E(){this.state.type===f.StateType.CheckingForUpdates&&this.d(f.$EY.Downloading)}F($){this.state.type===f.StateType.Downloading&&(this.d(f.$EY.Downloaded($)),this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$EY.Ready($)))}G(){this.state.type===f.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$EY.Idle(f.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$sgc=v,Ee([r.$7h],v.prototype,"v",null),Ee([r.$7h],v.prototype,"w",null),Ee([r.$7h],v.prototype,"x",null),Ee([r.$7h],v.prototype,"y",null),e.$sgc=v=Ee([oe(0,c.$vfc),oe(1,I.$9i),oe(2,w.$9l),oe(3,p.$2ec),oe(4,d.$5p),oe(5,m.$0j),oe(6,h.$qk)],v)}),define(le[259],he([0,1,48,26,8,4,9,20,19,5,24,49]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0,T=Ie(T);let d=class{get state(){return this.a}d(g){this.g.info("update#setState",g.type),this.a=g,this.b.fire(g)}constructor(g,v,b){if(this.f=g,this.g=b,this.a=h.$EY.Uninitialized,this.b=new R.$je,this.onStateChange=this.b.event,v.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(h.$EY.Idle(this.k())),this.h(30*1e3).then(void 0,$=>this.g.error($))}h(g=60*60*1e3){return(0,k.$Dh)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(g){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===h.StateType.Idle&&this.m(g)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===h.StateType.AvailableForDownload&&await this.i(this.state)}i(g){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===h.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==h.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return h.UpdateType.Snap}l(){}async _applySpecificUpdate(g){}};d=Ee([oe(0,p.$vfc),oe(1,I.$2ec),oe(2,c.$0j)],d);let w=class extends d{constructor(g,v,b,$,P,E){super(b,$,P),this.o=g,this.p=v,this.q=E;const t=(0,r.watch)(T.$lc(this.o)),u=R.Event.fromNodeEventEmitter(t,"change",(a,l)=>l),i=R.Event.filter(u,a=>a==="current"),s=R.Event.debounce(i,(a,l)=>l,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{s.dispose(),t.close()})}m(){this.d(h.$EY.CheckingForUpdates(!1)),this.u().then(g=>{g?this.d(h.$EY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(h.$EY.Idle(h.UpdateType.Snap)))},g=>{this.g.error(g),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(h.$EY.Idle(h.UpdateType.Snap,g.message||g))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+T.$mc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const g=await new Promise((b,$)=>(0,r.realpath)(`${T.$lc(this.o)}/current`,(P,E)=>P?$(P):b(E))),v=T.$mc(g);return this.p!==v}isLatestVersion(){return this.u().then(void 0,g=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$ugc=w,e.$ugc=w=Ee([oe(2,p.$vfc),oe(3,I.$2ec),oe(4,c.$0j),oe(5,m.$9l)],w)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[29],he([0,1,13,3,6,51,50,76,28,16,20,9,140]),function(G,e,n,r,k,R,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$cfc=void 0,e.$dfc=f,e.$efc=g,n=Ge(n),e.$cfc=(0,k.$Ci)("windowsMainService");var w;(function(b){b[b.CLI=0]="CLI",b[b.DOCK=1]="DOCK",b[b.MENU=2]="MENU",b[b.DIALOG=3]="DIALOG",b[b.DESKTOP=4]="DESKTOP",b[b.API=5]="API"})(w||(e.OpenContext=w={}));function f(b,$,P){const E=b.get(I.$afc),t=b.get(p.$qk),u=b.get(c.$9i),i=b.get(m.$2ec),o=u.getValue("window"),s={backgroundColor:E.getBackgroundColor(),minWidth:T.$XD.WIDTH,minHeight:T.$XD.HEIGHT,title:t.nameLong,show:$.mode!==R.WindowMode.Maximized&&$.mode!==R.WindowMode.Fullscreen,x:$.x,y:$.y,width:$.width,height:$.height,webPreferences:{...P,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,T.$0D)($.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(r.$l?s.icon=(0,h.$ic)(i.appRoot,"resources/linux/code.png"):r.$j&&!i.isBuilt&&(s.icon=(0,h.$ic)(i.appRoot,"resources/win32/code_150x150.png")),r.$k&&(s.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),r.$k&&!(0,T.$9D)(u)&&(s.fullscreenable=!1),r.$k&&o?.nativeTabs===!0&&(s.tabbingIdentifier=t.nameShort),!(0,T.$5D)(u)&&(s.titleBarStyle="hidden",r.$k||(s.frame=!1),(0,T.$8D)(u))){const S=E.getWindowSplash()?.colorInfo.titleBarBackground??E.getBackgroundColor(),y=d.$lu.fromHex(S).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:S,symbolColor:y}}return s}function g(b){let $,P=Number.MIN_VALUE;for(const E of b)E.lastFocusTime>P&&(P=E.lastFocusTime,$=E);return $}var v;(function(b){function $(E,t,u=n.default.screen.getAllDisplays()){if(E.trace(`window#validateWindowState: validating window state on ${u.length} display(s)`,t),typeof t.x!="number"||typeof t.y!="number"||typeof t.width!="number"||typeof t.height!="number"){E.trace("window#validateWindowState: unexpected type of state values");return}if(t.width<=0||t.height<=0){E.trace("window#validateWindowState: unexpected negative values");return}if(u.length===1){const s=P(u[0]);if(E.trace("window#validateWindowState: single monitor working area",s),s){let a=function(){!t||typeof t.x!="number"||typeof t.y!="number"||!s||(t.x<s.x&&(t.x=s.x),t.y<s.y&&(t.y=s.y))};a(),t.width>s.width&&(t.width=s.width),t.height>s.height&&(t.height=s.height),t.x>s.x+s.width-128&&(t.x=s.x+s.width-t.width),t.y>s.y+s.height-128&&(t.y=s.y+s.height-t.height),a()}return t}if(t.display&&t.mode===R.WindowMode.Fullscreen){const s=u.find(a=>a.id===t.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){E.trace("window#validateWindowState: restoring fullscreen to previous display");const a=(0,R.$4ec)(R.WindowMode.Fullscreen);return a.x=s.bounds.x,a.y=s.bounds.y,a}}let i,o;try{i=n.default.screen.getDisplayMatching({x:t.x,y:t.y,width:t.width,height:t.height}),o=P(i),E.trace("window#validateWindowState: multi-monitor working area",o)}catch(s){E.error("window#validateWindowState: error finding display for window state",s)}if(i&&o&&t.x+t.width>o.x&&t.y+t.height>o.y&&t.x<o.x+o.width&&t.y<o.y+o.height)return t;E.trace("window#validateWindowState: state is outside of the multi-monitor working area")}b.validateWindowState=$;function P(E){if(E.workArea.width>0&&E.workArea.height>0)return E.workArea;if(E.bounds.width>0&&E.bounds.height>0)return E.bounds}})(v||(e.WindowStateValidator=v={}))}),define(le[260],he([0,1,93,167,120,29]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;class T extends r.$Wo{constructor(p){super(),this.f=p}call(p,c,m){return c==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(p,c,m)}async g(p,c){const m=(0,k.$Am)(p,k.$zm);m.debugRenderer=c;const h=m.extensionDevelopmentPath;if(!h)return{success:!1};const[d]=await this.f.openExtensionDevelopmentHostWindow(h,{context:R.OpenContext.API,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!c)return{success:!0};const w=d.win;if(!w)return{success:!0};const f=w.webContents.debugger;let g=f.isAttached()?1/0:0;const v=(0,n.createServer)(b=>{g++===0&&f.attach();let $=!1;const P=u=>{$||b.write(JSON.stringify(u)+"\0")},E=(u,i,o,s)=>P({method:i,params:o,sessionId:s});w.on("close",()=>{f.removeListener("message",E),b.end(),$=!0}),f.addListener("message",E);let t=Buffer.alloc(0);b.on("data",u=>{t=Buffer.concat([t,u]);for(let i=t.indexOf(0);i!==-1;i=t.indexOf(0)){let o;try{const s=t.slice(0,i).toString("utf8");t=t.slice(i+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}f.sendCommand(o.method,o.params,o.sessionId).then(s=>P({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>P({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),b.on("error",u=>{console.error("error on cdp pipe:",u)}),b.on("close",()=>{$=!0,--g===0&&f.detach()})});return await new Promise(b=>v.listen(0,b)),w.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$Ifc=T}),define(le[261],he([0,1,13,21,3,7,23,16,68,6,5,132,29]),function(G,e,n,r,k,R,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=e.ID=void 0,e.ID="launchMainService",e.$9fc=(0,c.$Ci)(e.ID);let w=class{constructor(g,v,b,$){this.a=g,this.b=v,this.c=b,this.d=$}async start(g,v){this.a.trace("Received data from other instance: ",g,v),k.$k&&n.app.focus({steal:!0});const b=this.e(g);if(b.length){let $=Promise.resolve();if(this.b.getWindowCount()===0){const P=(0,r.$Nb)(await this.b.openEmptyWindow({context:d.OpenContext.DESKTOP}));P&&($=P.ready())}$.then(()=>{for(const{uri:P,originalUrl:E}of b)this.c.open(P,{originalUrl:E})})}else return this.f(g,v)}e(g){return g["open-url"]&&g._urls&&g._urls.length>0?(0,r.$Gb)(g._urls.map(v=>{try{return{uri:R.URI.parse(v),originalUrl:v}}catch{return null}})):[]}async f(g,v){const b=(0,p.$Hm)(v)?d.OpenContext.CLI:d.OpenContext.DESKTOP;let $=[];const P=g.wait&&g.waitMarkerFilePath?R.URI.file(g.waitMarkerFilePath):void 0,E=g.remote||void 0,t={context:b,cli:g,userEnv:g["preserve-env"]||b===d.OpenContext.CLI?v:void 0,waitMarkerFileURI:P,remoteAuthority:E,forceProfile:g.profile,forceTempProfile:g["profile-temp"]};if(g.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(g.extensionDevelopmentPath,t);else if(!g._.length&&!g["folder-uri"]&&!g["file-uri"]){let u=!1;if(g["new-window"]||t.forceProfile||t.forceTempProfile)u=!0;else if(g["reuse-window"])u=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!k.$k}if(u)$=await this.b.open({...t,forceNewWindow:!0,forceEmpty:!0});else{const i=this.b.getLastActiveWindow();i?(this.b.openExistingWindow(i,t),$=[i]):$=await this.b.open({...t,forceEmpty:!0})}}else $=await this.b.open({...t,forceNewWindow:g["new-window"],preferNewWindow:!g["reuse-window"]&&!g.wait,forceReuseWindow:g["reuse-window"],diffMode:g.diff,mergeMode:g.merge,addMode:g.add,noRecentEntry:!!g["skip-add-to-recently-opened"],gotoLineMode:g.goto});if(P&&$.length===1&&$[0])return Promise.race([$[0].whenClosedOrLoaded,(0,T.whenDeleted)(P.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$0fc=w,e.$0fc=w=Ee([oe(0,m.$0j),oe(1,d.$cfc),oe(2,h.$vY),oe(3,I.$9i)],w)}),define(le[135],he([0,1,13,22,4,46,2,7,33,16,97,20,6,5,62,87,29]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=void 0,e.$Ffc=(0,d.$Ci)("proxyAuthService");let b=class extends T.$Tc{constructor(P,E,t,u,i,o){super(),this.h=P,this.m=E,this.n=t,this.r=u,this.s=i,this.t=o,this.a="proxy-credentials://",this.b=new Map,this.c=void 0,this.f=new Set,this.g=new Map,this.u()}u(){const P=k.Event.fromNodeEventEmitter(n.app,"login",(E,t,u,i,o)=>({event:E,authInfo:{...i,attempt:u.firstAuthAttempt?1:2},callback:o}));this.B(P(this.w,this))}async lookupAuthorization(P){return this.w({authInfo:P})}async w({event:P,authInfo:E,callback:t}){if(!E.isProxy)return;P?.preventDefault();const u=String((0,R.$qj)({scheme:E.scheme,host:E.host,port:E.port}));let i,o=this.b.get(u);if(o)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),i=await o;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),o=this.y(E,u),this.b.set(u,o);try{i=await o}finally{this.b.delete(u)}}return t?.(i?.username,i?.password),i}async y(P,E){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const t=await this.z(P,E);if(t)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),t;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async z(P,E){if(this.h.trace("auth#doResolveProxyCredentials - enter",P),this.t.extensionTestsLocationURI){const a=this.s.getValue("integration-test.http.proxyAuth");if(a){const l=a.indexOf(":");return l!==-1?{username:a.substring(0,l),password:a.substring(l+1)}:{username:a,password:""}}return}const t=(this.s.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(t?.indexOf("@")!==-1){const a=I.URI.parse(t),l=a.authority.indexOf("@");if(l!==-1){if(P.attempt>1){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - ignoring previously used config/envvar credentials");return}this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found config/envvar credentials to use");const S=a.authority.substring(0,l),y=S.indexOf(":");return y!==-1?{username:S.substring(0,y),password:S.substring(y+1)}:{username:S,password:""}}}if(P.attempt===1&&this.g.has(E)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:a,password:l}=this.g.get(E);return{username:a,password:l}}let u,i;try{const a=this.r.get(this.a+E,f.StorageScope.APPLICATION);if(a){const l=JSON.parse(await this.n.decrypt(a));u=l.username,i=l.password}}catch(a){this.h.error(a)}if(P.attempt===1&&typeof u=="string"&&typeof i=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.g.set(E,{username:u,password:i}),{username:u,password:i};const o=this.c,s=this.c=(async()=>{await o;const a=await this.C(P,E,u,i);return this.c===s&&(this.c=void 0),a})();return s}async C(P,E,t,u){if(this.f.has(E)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const i=this.m.getFocusedWindow()||this.m.getLastActiveWindow();if(!i){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${i.id} to handle proxy login`);const o=this.g.get(E),s={authInfo:P,username:o?.username??t,password:o?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,p.$Yg)()}`};i.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,s);const a=await new Promise(l=>{const S=async(y,D,L)=>{if(D===s.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${i.id}`),i.win?.webContents.off("ipc-message",S),L){const A={username:L.username,password:L.password};try{if(L.remember){const O=await this.n.encrypt(JSON.stringify(A));this.r.store(this.a+E,O,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.r.remove(this.a+E,f.StorageScope.APPLICATION)}catch(O){this.h.error(O)}l({username:A.username,password:A.password})}else this.f.add(E),l(void 0)};i.win?.webContents.on("ipc-message",S)});return this.g.set(E,a),a}};e.$Gfc=b,e.$Gfc=b=Ee([oe(0,w.$0j),oe(1,v.$cfc),oe(2,m.$pY),oe(3,g.$Dfc),oe(4,c.$9i),oe(5,h.$2ec)],b)}),define(le[262],he([0,1,2,19,51,58,30,8,29]),function(G,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;let c=class extends n.$Tc{constructor(h,d,w){super(),this.a=d,this.b=w,this.B(h.onWillLoadWindow(f=>{f.reason===k.LoadReason.LOAD&&this.c(f.window)})),this.B(h.onBeforeCloseWindow(f=>this.c(f))),this.B(new I.$Oh(()=>this.g(),30*1e3)).schedule()}async c(h){const d=this.f(h),w=this.a.getProfileForWorkspace(d);w?.isTransient&&(this.a.unsetWorkspace(d,w.isTransient),w.isTransient&&await this.a.cleanUpTransientProfiles())}f(h){return h.openedWorkspace??(0,T.$Qi)(h.backupPath,h.isExtensionDevelopmentHost)}g(){const h=this.a.getAssociatedEmptyWindows();if(h.length===0)return;const d=this.b.getWindows().map(w=>this.f(w));for(const w of h)d.some(f=>f.id===w.id)||this.a.unsetWorkspace(w,!1)}};e.$Mgc=c,e.$Mgc=c=Ee([oe(0,r.$vfc),oe(1,R.$ffc),oe(2,p.$cfc)],c)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[63],he([0,1,13,2,4,5,282,8,11,29,81,24,19,79,37,3,106]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=e.$Jfc=void 0,m=Ge(m);function $(t){return typeof t.responseWindowId=="number"}let P=class extends r.$Tc{static{b=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(b.b.values())}constructor(u,i,o){super(),this.w=u,this.y=i,this.z=o,this.c=String(++b.a),this.f=this.B(new k.$je),this.onStdout=this.f.event,this.g=this.B(new k.$je),this.onStderr=this.g.event,this.h=this.B(new k.$je),this.onMessage=this.h.event,this.j=this.B(new k.$je),this.onSpawn=this.j.event,this.m=this.B(new k.$je),this.onExit=this.m.event,this.n=this.B(new k.$je),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(u,i){let o;switch(this.t?.correlationId?o=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${u}`:o=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${u}`,i){case m.default.Error:this.w.error(o);break;case m.default.Warning:this.w.warn(o);break;case m.default.Info:this.w.trace(o);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(u){const i=this.F(u);return i&&u.payload&&this.postMessage(u.payload)&&this.C("payload sent via postMessage()",m.default.Info),i}F(u){if(!this.D())return!1;this.t=u;const i=`${this.t.type}-${this.c}`,o=p.$Wg.asFileUri("bootstrap-fork.js").fsPath,s=this.t.args??[],a=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,S=this.t.forceAllocationsToV8Sandbox,y="pipe",D=this.G(u);return this.C("creating new...",m.default.Info),this.r=n.utilityProcess.fork(o,s,{serviceName:i,env:D,execArgv:a,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:S,stdio:y}),this.H(this.r,this.t,i),!0}G(u){const i=u.env?{...u.env}:{...(0,f.$bo)(process.env)};i.VSCODE_AMD_ENTRYPOINT=u.entryPoint,typeof u.parentLifecycleBound=="number"&&(i.VSCODE_PARENT_PID=String(u.parentLifecycleBound)),i.VSCODE_CRASH_REPORTER_PROCESS_TYPE=u.type,g.$j&&((0,v.isUNCAccessRestrictionsDisabled)()?i.NODE_DISABLE_UNC_ACCESS_CHECKS="1":i.NODE_UNC_HOST_ALLOWLIST=(0,v.getUNCHostAllowlist)().join("\\")),(0,w.$jm)(i);for(const o of Object.keys(i))i[o]=String(i[o]);return i}H(u,i,o){if(u.stdout){const s=new T.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(u.stdout,"data")(a=>this.f.fire(typeof a=="string"?a:s.write(a))))}if(u.stderr){const s=new T.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(u.stderr,"data")(a=>this.g.fire(typeof a=="string"?a:s.write(a))))}this.B(k.Event.fromNodeEventEmitter(u,"message")(s=>this.h.fire(s))),this.B(k.Event.fromNodeEventEmitter(u,"spawn")(()=>{this.s=u.pid,typeof u.pid=="number"&&b.b.set(u.pid,{pid:u.pid,name:$(i)?`${i.type} [${i.responseWindowId}]`:i.type}),this.C("successfully created",m.default.Info),this.j.fire(u.pid)})),this.B(k.Event.fromNodeEventEmitter(u,"exit")(s=>{const a=this.I(s)?0:s;this.C(`received exit event with code ${a}`,m.default.Info),this.m.fire({pid:this.s,code:a,signal:"unknown"}),this.J()})),this.B(k.Event.fromNodeEventEmitter(n.app,"child-process-gone",(s,a)=>({event:s,details:a}))(({details:s})=>{s.type==="Utility"&&s.name===o&&!this.I(s.exitCode)&&(this.C(`crashed with code ${s.exitCode} and reason '${s.reason}'`,m.default.Error),this.y.publicLog2("utilityprocesscrash",{type:i.type,reason:s.reason,code:s.exitCode}),this.n.fire({pid:this.s,code:s.exitCode,reason:s.reason}),this.J())}))}once(u,i){const o=this.B(this.h.event(s=>{s===u&&(o.dispose(),i())}))}postMessage(u,i){return this.r?(this.r.postMessage(u,i),!0):!1}connect(u){const{port1:i,port2:o}=new n.MessageChannelMain;return this.postMessage(u,[o]),i}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",m.default.Info);const u=process;return typeof u._debugProcess=="function"?(u._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",m.default.Info),this.r.kill()?(this.C("successfully killed the process",m.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",m.default.Warning)}I(u){return u===0?!0:this.u&&u===15}J(){typeof this.s=="number"&&b.b.delete(this.s),this.r=void 0}async waitForExit(u){this.r&&(this.C("waiting to exit...",m.default.Info),await Promise.race([k.Event.toPromise(this.onExit),(0,I.$Dh)(u)]),this.r&&(this.C(`did not exit within ${u}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$Jfc=P,e.$Jfc=P=b=Ee([oe(0,R.$0j),oe(1,h.$9l),oe(2,d.$vfc)],P);let E=class extends P{constructor(u,i,o,s){super(u,o,s),this.L=i}start(u){const i=this.L.getWindowById(u.responseWindowId);if(!i?.win||i.win.isDestroyed()||i.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.F(u))return!1;this.M(i.win,u);const s=this.connect(u.payload);return i.win.webContents.postMessage(u.responseChannel,u.responseNonce,[s]),!0}M(u,i){i.windowLifecycleBound&&(this.B(k.Event.filter(this.z.onWillLoadWindow,o=>o.window.win===u)(()=>this.kill())),this.B(k.Event.fromNodeEventEmitter(u,"closed")(()=>this.kill())))}};e.$Kfc=E,e.$Kfc=E=Ee([oe(0,R.$0j),oe(1,c.$cfc),oe(2,h.$9l),oe(3,d.$vfc)],E)}),define(le[263],he([0,1,8,15,4,2,19,5,24,63,29]),function(G,e,n,r,k,R,T,I,p,c,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;let d=class extends R.$Tc{static{h=this}static{this.a=0}constructor(f,g,v,b){super(),this.f=f,this.g=g,this.h=v,this.j=b,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(f){const g=this.b.get(f);if(!g)throw new Error("Unknown extension host!");return g}onDynamicStdout(f){return this.m(f).onStdout}onDynamicStderr(f){return this.m(f).onStderr}onDynamicMessage(f){return this.m(f).onMessage}onDynamicExit(f){return this.m(f).onExit}async createExtensionHost(){if(this.c)throw(0,r.$5)();const f=String(++h.a),g=new c.$Kfc(this.f,this.h,this.j,this.g);this.b.set(f,g);const v=g.onExit(({pid:b,code:$,signal:P})=>{v.dispose(),this.f.info(`Extension host with pid ${b} exited with code: ${$}, signal: ${P}.`),setTimeout(()=>{g.dispose(),this.b.delete(f)}),setTimeout(()=>{try{process.kill(b,0),this.f.error(`Extension host with pid ${b} still exists, forcefully killing it...`),process.kill(b)}catch{}},1e3)});return{id:f}}async start(f,g){if(this.c)throw(0,r.$5)();const v=this.m(f);return v.start({...g,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:g.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:f}),{pid:await k.Event.toPromise(v.onSpawn)}}async enableInspectPort(f){if(this.c)throw(0,r.$5)();const g=this.b.get(f);return g?g.enableInspectPort():!1}async kill(f){if(this.c)throw(0,r.$5)();const g=this.b.get(f);g&&g.kill()}async _killAllNow(){for(const[,f]of this.b)f.kill()}async _waitForAllExit(f){const g=[];for(const[,v]of this.b)g.push(v.waitForExit(f));return n.Promises.settled(g).then(()=>{})}};e.$Rfc=d,e.$Rfc=d=h=Ee([oe(0,I.$0j),oe(1,T.$vfc),oe(2,m.$cfc),oe(3,p.$9l)],d)}),define(le[264],he([0,1,35,8,2,20,19,5,42,40,71,63,57,95,12,216,4]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;let b=class extends k.$Tc{constructor(P,E,t,u,i,o,s,a,l){super(),this.g=P,this.h=E,this.j=t,this.m=u,this.n=i,this.r=o,this.s=s,this.t=a,this.u=l,this.a=new r.$Bh,this.b=void 0,this.c=void 0,this.f=this.B(new v.$je),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){n.$GX.on(g.$igc.request,(P,E)=>this.y(P,E,g.$igc.response)),n.$GX.on(g.$jgc.request,(P,E)=>this.y(P,E,g.$jgc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(P,E,t){this.s.trace(`[SharedProcess] onWindowConnection for: ${t}`),this.a.isOpen()||this.a.open(),await this.whenReady();const u=await this.connect(t);if(P.sender.isDestroyed())return u.close();P.sender.postMessage(t,E,[u])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(g.$hgc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const P=new r.$Zh;this.b?.once(g.$hgc.initDone,()=>P.complete()),await P.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const P=new r.$Zh;this.b?.once(g.$hgc.ipcReady,()=>P.complete()),await P.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new h.$Jfc(this.s,d.$wp,this.r)),this.c=this.b.onMessage(t=>{typeof t.warning=="string"?this.s.warn(t.warning):typeof t.error=="string"&&this.s.error(t.error)});const P=(0,w.$8m)(this.m.args,this.m.isBuilt);let E;P.port&&(E=["--nolazy"],P.break?E.push(`--inspect-brk=${P.port}`):E.push(`--inspect=${P.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:E}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(P){return await this.F,(0,f.$ng)(this.b).connect(P)}};e.$kgc=b,e.$kgc=b=Ee([oe(3,R.$2ec),oe(4,p.$Jl),oe(5,T.$vfc),oe(6,I.$0j),oe(7,m.$qfc),oe(8,c.$qo)],b)}),define(le[265],he([0,1,20,95,19,5,57,75,63,118,35,2,4,37,16,11]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;let v=class extends h.$Tc{constructor($,P,E,t,u){super(),this.f=$,this.g=P,this.h=E,this.j=t,this.m=u,this.a=void 0,this.b=new d.$je,this.onRequestConnection=this.b.event,this.c=new d.$je,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),m.$GX.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,h.$Rc)(()=>{m.$GX.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new p.$Jfc(this.m,T.$wp,this.j);const $=(0,r.$7m)(this.h.args,this.h.isBuilt),P=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:P,args:["--logsPath",this.h.logsHome.with({scheme:g.Schemas.file}).fsPath],env:this.n()});const E=this.a.connect(),t=new c.$OX(E,"ptyHost"),u=new h.$Sc;return u.add(t),u.add((0,h.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:t,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,w.$bo)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},P=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);P&&typeof P=="number"&&($.VSCODE_LATENCY=String(P));const E=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return E&&typeof E=="number"&&($.VSCODE_STARTUP_DELAY=String(E)),this.h.restoreSnapExportedVariables(),$}r($,P){this.b.fire();const E=this.a.connect();if($.sender.isDestroyed()){E.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",P,[E])}};e.$Ygc=v,e.$Ygc=v=Ee([oe(1,f.$9i),oe(2,n.$2ec),oe(3,k.$vfc),oe(4,R.$0j)],v)}),define(le[266],he([0,1,2,6,5,29,63,24,46,4,8,19]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=void 0,e.$Wgc=(0,r.$Ci)("utilityProcessWorker");let d=class extends n.$Tc{constructor(g,v,b,$){super(),this.b=g,this.c=v,this.f=b,this.g=$,this.a=new Map}async createWorker(g){const v=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${v})`);const b=this.h(g);this.a.has(b)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${v})`),this.disposeWorker(g));const $=new w(this.b,this.c,this.f,this.g,g);if(!$.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(b,$);const P=new m.$Zh;return c.Event.once($.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(b),P.complete({reason:E})}),P.p}h(g){return(0,p.$qj)({moduleId:g.process.moduleId,windowId:g.reply.windowId})}async disposeWorker(g){const v=this.h(g),b=this.a.get(v);b&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),b.kill(),b.dispose(),this.a.delete(v))}};e.$Xgc=d,e.$Xgc=d=Ee([oe(0,k.$0j),oe(1,R.$cfc),oe(2,I.$9l),oe(3,h.$vfc)],d);let w=class extends n.$Tc{constructor(g,v,b,$,P){super(),this.c=g,this.f=v,this.g=b,this.h=$,this.j=P,this.a=this.B(new c.$je),this.onDidTerminate=this.a.event,this.b=this.B(new T.$Kfc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(g=>this.a.fire({code:g.code,signal:g.signal}))),this.B(this.b.onCrash(g=>this.a.fire({code:g.code,signal:"ECRASH"})))}spawn(){const v=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:v,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};w=Ee([oe(0,k.$0j),oe(1,R.$cfc),oe(2,I.$9l),oe(3,h.$vfc)],w)}),define(le[267],he([0,1,13,4,2,241,29]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;let I=class extends k.$Tc{constructor(c){super(),this.b=c,this.a=this.B(new r.$je),this.onFoundInFrame=this.a.event,this.B(new R.$Bgc)}async setIgnoreMenuShortcuts(c,m){let h;if(typeof c.windowId=="number"){const{windowId:d}=c,w=this.b.getWindowById(d);if(!w?.win)throw new Error(`Invalid windowId: ${d}`);h=w.win.webContents}else{const{webContentsId:d}=c;if(h=n.webContents.fromId(d),!h)throw new Error(`Invalid webContentsId: ${d}`)}h.isDestroyed()||h.setIgnoreMenuShortcuts(m)}async findInFrame(c,m,h,d){const f=this.c(c,m);if(typeof f.findInFrame=="function"){f.findInFrame(h,{findNext:d.findNext,forward:d.forward});const g=(v,b)=>{b.finalUpdate&&(this.a.fire(b),f.removeListener("found-in-frame",g))};f.on("found-in-frame",g)}}async stopFindInFrame(c,m,h){const w=this.c(c,m);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(h.keepSelection?"keepSelection":"clearSelection")}c(c,m){const h=this.b.getWindowById(c.windowId);if(!h?.win)throw new Error(`Invalid windowId: ${c}`);const d=h.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===m);if(!d)throw new Error(`Unknown frame: ${m}`);return d}};e.$Cgc=I,e.$Cgc=I=Ee([oe(0,T.$cfc)],I)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[268],he([0,1,13,2,3,18,7,16,19,5,34,29,51,30]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0,e.$Egc=v,e.$Fgc=$,n=Ge(n);let g=class extends r.$Tc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(t,u,i,o,s){super(),this.g=t,this.h=u,this.j=i,this.m=o,this.n=s,this.b=v(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.default.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(t=>this.u(t))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(t=>{t.newCount-t.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(t=>this.u(t)))}s(){this.f=!0,this.t()}t(){const t=new Set,u={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!u.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),s&&(u.lastActiveWindow=this.w(s),u.lastActiveWindow.uiState.mode===d.WindowMode.Fullscreen&&t.add(u.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);i&&(u.lastPluginDevelopmentHostWindow=this.w(i),u.lastPluginDevelopmentHostWindow.uiState.mode===d.WindowMode.Fullscreen&&(t.has(u.lastPluginDevelopmentHostWindow.uiState.display)?k.$k&&!i.win?.isSimpleFullScreen()&&(u.lastPluginDevelopmentHostWindow.uiState.mode=d.WindowMode.Normal):t.add(u.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(u.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const a=this.w(s);return a.uiState.mode===d.WindowMode.Fullscreen&&(t.has(a.uiState.display)?k.$k&&a.windowId!==u.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(a.uiState.mode=d.WindowMode.Normal):t.add(a.uiState.display)),a}));const o=$(u);this.h.setItem(f.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(t){if(this.j.quitRequested)return;const u=this.w(t);t.isExtensionDevelopmentHost&&!t.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=u:!t.isExtensionDevelopmentHost&&t.openedWorkspace&&this.b.openedWindows.forEach(i=>{const o=(0,w.$Ri)(t.openedWorkspace)&&i.workspace?.id===t.openedWorkspace.id,s=(0,w.$Mi)(t.openedWorkspace)&&i.folderUri&&R.$7g.isEqual(i.folderUri,t.openedWorkspace.uri);(o||s)&&(i.uiState=u.uiState)}),this.g.getWindowCount()===1&&(this.c=u)}w(t){return{windowId:t.id,workspace:(0,w.$Ri)(t.openedWorkspace)?t.openedWorkspace:void 0,folderUri:(0,w.$Mi)(t.openedWorkspace)?t.openedWorkspace.uri:void 0,backupPath:t.backupPath,remoteAuthority:t.remoteAuthority,uiState:t.serializeWindowState()}}getNewWindowState(t){const u=this.z(t),i=this.n.getValue("window");if(u.mode===d.WindowMode.Fullscreen){let o;u.hasDefaultState?o=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||i?.restoreFullscreen),o||(u.mode=d.WindowMode.Normal)}return u}z(t){const u=this.g.getLastActiveWindow();if(!t.extensionTestsPath){if(t.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const S=t.workspace;if((0,w.$Ri)(S)){const D=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===S.id).map(L=>L.uiState);if(D.length)return D[0]}if((0,w.$Mi)(S)){const D=this.state.openedWindows.filter(L=>L.folderUri&&R.$7g.isEqual(L.folderUri,S.uri)).map(L=>L.uiState);if(D.length)return D[0]}else if(t.backupPath){const D=this.state.openedWindows.filter(L=>L.backupPath===t.backupPath).map(L=>L.uiState);if(D.length)return D[0]}const y=this.c||this.state.lastActiveWindow;if(!u&&y)return y.uiState}let i;const o=n.default.screen.getAllDisplays();if(o.length===1)i=o[0];else{if(k.$k){const S=n.default.screen.getCursorScreenPoint();i=n.default.screen.getDisplayNearestPoint(S)}!i&&u&&(i=n.default.screen.getDisplayMatching(u.getBounds())),i||(i=n.default.screen.getPrimaryDisplay()||o[0])}let s=(0,d.$4ec)();s.x=Math.round(i.bounds.x+i.bounds.width/2-s.width/2),s.y=Math.round(i.bounds.y+i.bounds.height/2-s.height/2);const a=this.n.getValue("window");let l=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")s.mode=d.WindowMode.Maximized,l=!1;else if(a.newWindowDimensions==="fullscreen")s.mode=d.WindowMode.Fullscreen,l=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&u){const S=u.serializeWindowState();S.mode===d.WindowMode.Fullscreen?s.mode=d.WindowMode.Fullscreen:s={...S,zoomLevel:void 0},l=s.mode!==d.WindowMode.Fullscreen&&a.newWindowDimensions==="offset"}}return l&&(s=this.C(s)),s.hasDefaultState=!0,s}C(t){if(this.g.getWindows().length===0)return t;t.x=typeof t.x=="number"?t.x:0,t.y=typeof t.y=="number"?t.y:0;const u=this.g.getWindows().map(i=>i.getBounds());for(;u.some(i=>i.x===t.x||i.y===t.y);)t.x+=30,t.y+=30;return t}};e.$Dgc=g,e.$Dgc=g=f=Ee([oe(0,h.$cfc),oe(1,m.$nR),oe(2,p.$vfc),oe(3,c.$0j),oe(4,I.$9i)],g);function v(E){const t={openedWindows:[]},u=E||{openedWindows:[]};return u.lastActiveWindow&&(t.lastActiveWindow=b(u.lastActiveWindow)),u.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=b(u.lastPluginDevelopmentHostWindow)),Array.isArray(u.openedWindows)&&(t.openedWindows=u.openedWindows.map(i=>b(i))),t}function b(E){const t={uiState:E.uiState};return E.backupPath&&(t.backupPath=E.backupPath),E.remoteAuthority&&(t.remoteAuthority=E.remoteAuthority),E.folder&&(t.folderUri=T.URI.parse(E.folder)),E.workspaceIdentifier&&(t.workspace={id:E.workspaceIdentifier.id,configPath:T.URI.parse(E.workspaceIdentifier.configURIPath)}),t}function $(E){return{lastActiveWindow:E.lastActiveWindow&&P(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&P(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(t=>P(t))}}function P(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[59],he([0,1,26,13,4,43,2,11,9,18,23,10,69,52,20,6,5,58,134,30,102,103]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=e.$ofc=void 0,n=Ie(n),r=Ge(r),e.$ofc=(0,g.$Ci)("workspacesManagementMainService");let u=class extends T.$Tc{constructor(o,s,a,l,S){super(),this.g=o,this.h=s,this.j=a,this.m=l,this.n=S,this.a=this.B(new k.$je),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new k.$je),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await m.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(s=>(0,c.$dh)(this.c,s,P.$2i));for(const s of o){const a=(0,t.$lfc)(s),l=await this.resolveLocalWorkspace(s);l?this.f.push({workspace:a,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,s=>n.promises.readFile(s,"utf8"))}r(o,s){if(this.s(o)&&o.scheme===I.Schemas.file)try{const a=s(o.fsPath);return a instanceof Promise?a.then(l=>this.t(o,l),l=>{}):this.t(o,a)}catch{return}}s(o){return(0,P.$3i)(o,this.g)||(0,P.$8i)(o)}t(o,s){try{const a=this.u(o,s),l=(0,t.$lfc)(o);return{id:l.id,configPath:l.configPath,folders:(0,E.$5hb)(a.folders,l.configPath,c.$7g),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.h.warn(a.toString())}}u(o,s){const a=(0,R.$Vn)(s);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(l=>(0,E.$3hb)(l));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(o,s){const{workspace:a,storedWorkspace:l}=this.w(o,s),S=a.configPath.fsPath;return await n.promises.mkdir((0,p.$lc)(S),{recursive:!0}),await m.Promises.writeFile(S,JSON.stringify(l,null,"	")),this.f.push({workspace:a,remoteAuthority:s}),a}w(o=[],s){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,c.$dh)(this.c,a),S=(0,c.$dh)(l,P.$2i),y=[];for(const D of o)y.push((0,E.$4hb)(D.uri,!0,D.name,l,c.$7g));return{workspace:(0,t.$lfc)(S),storedWorkspace:{folders:y,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,t.$lfc)(o)}isUntitledWorkspace(o){return(0,P.$3i)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const s=(0,c.$4g)(o.configPath);try{await m.Promises.rm((0,p.$lc)(s));const a=(0,p.$ic)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,o.id);await m.Promises.exists(a)&&await m.Promises.writeFile((0,p.$ic)(a,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==o.id)}catch(a){this.h.warn(`Unable to delete untitled workspace ${s} (${a}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,s,a){if(!o||!o.win||!o.isReady||!await this.z(o,s,a))return;const S=await this.C(o,(0,t.$lfc)(a));if(S)return this.b.fire({window:o,workspace:S.workspace}),S}async z(o,s,a){return a?(0,P.$Ri)(o.openedWorkspace)&&c.$7g.isEqual(o.openedWorkspace.configPath,a)?!1:(0,$.$ifc)(s,a)?(await this.n.showMessageBox({type:"info",buttons:[(0,h.localize)(10882,null)],message:(0,h.localize)(10883,null,(0,c.$ah)(a)),detail:(0,h.localize)(10884,null)},r.default.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,s){if(!o.config)return;o.focus();let a;return o.config.extensionDevelopmentPath||(o.config.backupPath?a=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):a=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,P.$Ri)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=a,{workspace:s,backupPath:a}}};e.$pfc=u,e.$pfc=u=Ee([oe(0,f.$2ec),oe(1,v.$0j),oe(2,b.$ffc),oe(3,d.$9ec),oe(4,w.$0ec)],u)}),define(le[136],he([0,1,13,35,22,6,29,30,59,12,5,63]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=e.ID=void 0,e.ID="diagnosticsMainService",e.$Mfc=(0,R.$Ci)(e.ID);let d=class{constructor(f,g,v){this.a=f,this.b=g,this.c=v}async getRemoteDiagnostics(f){const g=this.a.getWindows();return(await Promise.all(g.map(async b=>{const $=b.remoteAuthority;if(!$)return;const P=`vscode:getDiagnosticInfoResponse${b.id}`,E={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(t=>{b.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:P,args:E}),r.$GX.once(P,(u,i)=>{i||t({hostName:$,errorMessage:`Unable to resolve connection to '${$}'.`}),t(i)}),setTimeout(()=>{t({hostName:$,errorMessage:`Connection to '${$}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const v of n.BrowserWindow.getAllWindows()){const b=this.a.getWindowById(v.id);b?f.push(await this.d(b)):f.push(this.e(v))}const g=[];for(const{pid:v,name:b}of h.$Jfc.getAll())g.push({pid:v,name:b});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:g,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const g=await this.f(f),v=(0,c.$ng)(f.win);return this.e(v,g,f.remoteAuthority)}e(f,g=[],v){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:g,remoteAuthority:v}}async f(f){const g=[],v=f.openedWorkspace;if((0,I.$Mi)(v))g.push(v.uri);else if((0,I.$Ri)(v)){const b=await this.b.resolveLocalWorkspace(v.configPath);b&&b.folders.forEach(P=>{g.push(P.uri)})}return g}};e.$Nfc=d,e.$Nfc=d=Ee([oe(0,T.$cfc),oe(1,p.$ofc),oe(2,m.$0j)],d)}),define(le[64],he([0,1,26,48,13,27,154,53,4,2,11,9,3,7,112,92,23,113,10,52,20,6,19,5,28,76,29,30,59,17,212,202,84,15,16,135]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t,u,i,o,s,a,l,S,y,D,L,A,O,W,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=e.$2fc=void 0,n=Ie(n),e.$2fc=(0,t.$Ci)("nativeHostMainService");let H=class extends c.$Tc{constructor(Z,U,te,x,J,B,j,C,X,ae,K){super(),this.a=Z,this.b=U,this.c=te,this.f=x,this.g=J,this.h=B,this.j=j,this.m=C,this.n=X,this.r=ae,this.s=K,this.onDidOpenMainWindow=p.Event.map(this.a.onDidOpenWindow,ce=>ce.id),this.onDidTriggerWindowSystemContextMenu=p.Event.any(p.Event.map(this.a.onDidTriggerSystemContextMenu,({window:ce,x:se,y:ie})=>({windowId:ce.id,x:se,y:ie})),p.Event.map(this.b.onDidTriggerSystemContextMenu,({window:ce,x:se,y:ie})=>({windowId:ce.id,x:se,y:ie}))),this.onDidMaximizeWindow=p.Event.any(p.Event.map(this.a.onDidMaximizeWindow,ce=>ce.id),p.Event.map(this.b.onDidMaximizeWindow,ce=>ce.id)),this.onDidUnmaximizeWindow=p.Event.any(p.Event.map(this.a.onDidUnmaximizeWindow,ce=>ce.id),p.Event.map(this.b.onDidUnmaximizeWindow,ce=>ce.id)),this.onDidChangeWindowFullScreen=p.Event.any(p.Event.map(this.a.onDidChangeFullScreen,ce=>({windowId:ce.window.id,fullscreen:ce.fullscreen})),p.Event.map(this.b.onDidChangeFullScreen,ce=>({windowId:ce.window.id,fullscreen:ce.fullscreen}))),this.onDidBlurMainWindow=p.Event.filter(p.Event.fromNodeEventEmitter(k.app,"browser-window-blur",(ce,se)=>se.id),ce=>!!this.a.getWindowById(ce)),this.onDidFocusMainWindow=p.Event.any(p.Event.map(p.Event.filter(p.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),ce=>!!ce),ce=>ce.id),p.Event.filter(p.Event.fromNodeEventEmitter(k.app,"browser-window-focus",(ce,se)=>se.id),ce=>!!this.a.getWindowById(ce))),this.onDidBlurMainOrAuxiliaryWindow=p.Event.any(this.onDidBlurMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(k.app,"browser-window-blur",(ce,se)=>this.b.getWindowByWebContents(se.webContents)),ce=>!!ce),ce=>ce.id)),this.onDidFocusMainOrAuxiliaryWindow=p.Event.any(this.onDidFocusMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(k.app,"browser-window-focus",(ce,se)=>this.b.getWindowByWebContents(se.webContents)),ce=>!!ce),ce=>ce.id)),this.onDidResumeOS=p.Event.fromNodeEventEmitter(k.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.t=this.B(new p.$je),this.onDidChangePassword=this.t.event,this.onDidChangeDisplay=p.Event.debounce(p.Event.any(p.Event.filter(p.Event.fromNodeEventEmitter(k.screen,"display-metrics-changed",(ce,se,ie)=>ie),ce=>!(Array.isArray(ce)&&ce.length===1&&ce[0]==="workArea")),p.Event.fromNodeEventEmitter(k.screen,"display-added"),p.Event.fromNodeEventEmitter(k.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(Z,U){const te=this.a.getWindows().map(J=>({id:J.id,workspace:J.openedWorkspace??(0,l.$Qi)(J.backupPath,J.isExtensionDevelopmentHost),title:J.win?.getTitle()??"",filename:J.getRepresentedFilename(),dirty:J.isDocumentEdited()})),x=[];return U.includeAuxiliaryWindows&&x.push(...this.b.getWindows().map(J=>({id:J.id,parentId:J.parentId,title:J.win?.getTitle()??"",filename:J.getRepresentedFilename()}))),[...te,...x]}async getWindowCount(Z){return this.a.getWindowCount()}async getActiveWindowId(Z){const U=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(Z,U,te){return Array.isArray(U)?this.u(Z,U,te):this.w(Z,U)}async u(Z,U,te=Object.create(null)){U.length>0&&await this.a.open({context:a.OpenContext.API,contextWindowId:Z,urisToOpen:U,cli:this.g.args,forceNewWindow:te.forceNewWindow,forceReuseWindow:te.forceReuseWindow,preferNewWindow:te.preferNewWindow,diffMode:te.diffMode,mergeMode:te.mergeMode,addMode:te.addMode,gotoLineMode:te.gotoLineMode,noRecentEntry:te.noRecentEntry,waitMarkerFileURI:te.waitMarkerFileURI,remoteAuthority:te.remoteAuthority||void 0,forceProfile:te.forceProfile,forceTempProfile:te.forceTempProfile})}async w(Z,U){await this.a.openEmptyWindow({context:a.OpenContext.API,contextWindowId:Z},U)}async isFullScreen(Z,U){return this.G(U?.targetWindowId,Z)?.isFullScreen??!1}async toggleFullScreen(Z,U){this.G(U?.targetWindowId,Z)?.toggleFullScreen()}async handleTitleDoubleClick(Z,U){this.G(U?.targetWindowId,Z)?.handleTitleDoubleClick()}async getCursorScreenPoint(Z){const U=k.screen.getCursorScreenPoint(),te=k.screen.getDisplayNearestPoint(U);return{point:U,display:te.bounds}}async isMaximized(Z,U){return this.G(U?.targetWindowId,Z)?.win?.isMaximized()??!1}async maximizeWindow(Z,U){this.G(U?.targetWindowId,Z)?.win?.maximize()}async unmaximizeWindow(Z,U){this.G(U?.targetWindowId,Z)?.win?.unmaximize()}async minimizeWindow(Z,U){this.G(U?.targetWindowId,Z)?.win?.minimize()}async moveWindowTop(Z,U){this.G(U?.targetWindowId,Z)?.win?.moveTop()}async positionWindow(Z,U,te){const x=this.G(te?.targetWindowId,Z);if(x?.win){if(x.win.isFullScreen()){const J=p.Event.toPromise(p.Event.once(p.Event.fromNodeEventEmitter(x.win,"leave-full-screen")));x.win.setFullScreen(!1),await J}x.win.setBounds(U)}}async updateWindowControls(Z,U){this.G(U?.targetWindowId,Z)?.updateWindowControls(U)}async focusWindow(Z,U){this.G(U?.targetWindowId,Z)?.focus({force:U?.force??!1})}async setMinimumSize(Z,U,te){const x=this.H(Z);if(x?.win){const[J,B]=x.win.getSize(),[j,C]=x.win.getMinimumSize(),[X,ae]=[U??j,te??C],[K,ce]=[Math.max(J,X),Math.max(B,ae)];(j!==X||C!==ae)&&x.win.setMinimumSize(X,ae),(J!==K||B!==ce)&&x.win.setSize(K,ce)}}async saveWindowSplash(Z,U){this.m.saveWindowSplash(Z,U)}async installShellCommand(Z){const{source:U,target:te}=await this.z();try{const{symbolicLink:x}=await v.SymlinkSupport.stat(U);if(x&&!x.dangling){const J=await(0,f.$kr)(U);if(te===J)return}await n.promises.unlink(U)}catch(x){if(x.code!=="ENOENT")throw x}try{await n.promises.symlink(te,U)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:J}=await this.showMessageBox(Z,{type:"info",message:(0,$.localize)(11135,null,this.j.nameShort),buttons:[(0,$.localize)(11136,null),(0,$.localize)(11137,null)]});if(J===1)throw new O.$4;try{const B=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${te}' '${U}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(B)}catch{throw new Error((0,$.localize)(11138,null,U))}}}async uninstallShellCommand(Z){const{source:U}=await this.z();try{await n.promises.unlink(U)}catch(te){switch(te.code){case"EACCES":{const{response:x}=await this.showMessageBox(Z,{type:"info",message:(0,$.localize)(11139,null,this.j.nameShort),buttons:[(0,$.localize)(11140,null),(0,$.localize)(11141,null)]});if(x===1)throw new O.$4;try{const J=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(J)}catch{throw new Error((0,$.localize)(11142,null,U))}break}case"ENOENT":break;default:throw te}}}async z(){const Z=(0,h.$jc)(this.g.appRoot,"bin","code"),U=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(Z))throw new Error((0,$.localize)(11143,null,Z));return{source:U,target:Z}}async showMessageBox(Z,U){const te=this.G(U?.targetWindowId,Z);return this.c.showMessageBox(U,te?.win??void 0)}async showSaveDialog(Z,U){const te=this.G(U?.targetWindowId,Z);return this.c.showSaveDialog(U,te?.win??void 0)}async showOpenDialog(Z,U){const te=this.G(U?.targetWindowId,Z);return this.c.showOpenDialog(U,te?.win??void 0)}async pickFileFolderAndOpen(Z,U){const te=await this.c.pickFileFolder(U);te&&await this.C(await Promise.all(te.map(async x=>await v.SymlinkSupport.existsDirectory(x)?{folderUri:w.URI.file(x)}:{fileUri:w.URI.file(x)})),U,Z)}async pickFolderAndOpen(Z,U){const te=await this.c.pickFolder(U);te&&await this.C(te.map(x=>({folderUri:w.URI.file(x)})),U,Z)}async pickFileAndOpen(Z,U){const te=await this.c.pickFile(U);te&&await this.C(te.map(x=>({fileUri:w.URI.file(x)})),U,Z)}async pickWorkspaceAndOpen(Z,U){const te=await this.c.pickWorkspace(U);te&&await this.C(te.map(x=>({workspaceUri:w.URI.file(x)})),U,Z)}async C(Z,U,te){await this.a.open({context:a.OpenContext.DIALOG,contextWindowId:te,cli:this.g.args,urisToOpen:Z,forceNewWindow:U.forceNewWindow})}async showItemInFolder(Z,U){k.shell.showItemInFolder(U)}async setRepresentedFilename(Z,U,te){this.G(te?.targetWindowId,Z)?.setRepresentedFilename(U)}async setDocumentEdited(Z,U,te){this.G(te?.targetWindowId,Z)?.setDocumentEdited(U)}async openExternal(Z,U,te){this.g.unsetSnapExportedVariables();try{(0,m.$Mg)(U,m.Schemas.http,m.Schemas.https)?this.D(U,te):k.shell.openExternal(U)}finally{this.g.restoreSnapExportedVariables()}return!0}async D(Z,U){const te=U??this.r.getValue("workbench.externalBrowser");if(!te)return k.shell.openExternal(Z);if((te.includes(h.$fc.sep)||te.includes(h.$ec.sep))&&!await v.Promises.exists(te))return this.h.error(`Configured external browser path does not exist: ${te}`),k.shell.openExternal(Z);try{const{default:x}=await new Promise((J,B)=>{G(["open"],J,B)}).then(Ie);await x(Z,{app:{name:Object.hasOwn(x.apps,te)?x.apps[te]:te}})}catch(x){return this.h.error(`Unable to open external URL '${Z}' using browser '${te}' due to ${x}.`),k.shell.openExternal(Z)}}moveItemToTrash(Z,U){return k.shell.trashItem(U)}async isAdmin(){let Z;return d.$j?Z=(await new Promise((U,te)=>{G(["native-is-elevated"],U,te)}).then(Ie)).default():Z=process.getuid?.()===0,Z}async writeElevated(Z,U,te,x){const J=await new Promise((B,j)=>{G(["@vscode/sudo-prompt"],B,j)}).then(Ie);return new Promise((B,j)=>{const C=[`"${this.F}"`];x?.unlock&&C.push("--file-chmod"),C.push("--file-write",`"${U.fsPath}"`,`"${te.fsPath}"`);const X={name:this.j.nameLong.replace("-",""),icns:d.$k&&this.g.isBuilt?(0,h.$ic)((0,h.$lc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};J.exec(C.join(" "),X,(ae,K,ce)=>{K&&this.h.trace(`[sudo-prompt] received stdout: ${K}`),ce&&this.h.trace(`[sudo-prompt] received stderr: ${ce}`),ae?j(ae):B(void 0)})})}async isRunningUnderARM64Translation(){return d.$l||d.$j?!1:k.app.runningUnderARM64Translation}get F(){return d.$j?this.g.isBuilt?(0,h.$ic)((0,h.$lc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.bat"):d.$l?this.g.isBuilt?(0,h.$ic)((0,h.$lc)(process.execPath),"bin",`${this.j.applicationName}`):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,h.$ic)(this.g.appRoot,"bin","code"):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,R.totalmem)(),freemem:(0,R.freemem)(),loadavg:(0,R.loadavg)()}}async getOSProperties(){return{arch:(0,R.arch)(),platform:(0,R.platform)(),release:(0,R.release)(),type:(0,R.type)(),cpus:(0,R.cpus)()}}async getOSVirtualMachineHint(){return g.$Pn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return d.$j&&(0,D.$Yfc)()}async getProcessId(Z){return this.G(void 0,Z)?.win?.webContents.getOSProcessId()}async killProcess(Z,U,te){process.kill(U,te)}async readClipboardText(Z,U){return k.clipboard.readText(U)}async writeClipboardText(Z,U,te){return k.clipboard.writeText(U,te)}async readClipboardFindText(Z){return k.clipboard.readFindText()}async writeClipboardFindText(Z,U){return k.clipboard.writeFindText(U)}async writeClipboardBuffer(Z,U,te,x){return k.clipboard.writeBuffer(U,Buffer.from(te.buffer),x)}async readClipboardBuffer(Z,U){return y.$Le.wrap(k.clipboard.readBuffer(U))}async hasClipboard(Z,U,te){return k.clipboard.has(U,te)}async newWindowTab(){await this.a.open({context:a.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){k.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){k.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){k.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){k.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){k.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(Z,U){this.H(Z)?.updateTouchBar(U)}async notifyReady(Z){this.H(Z)?.setReady()}async relaunch(Z,U){return this.f.relaunch(U)}async reload(Z,U){const te=this.H(Z);if(te){if((0,l.$Ri)(te.openedWorkspace)){const x=te.openedWorkspace.configPath;if(x.scheme===m.Schemas.file&&(await this.n.resolveLocalWorkspace(x))?.transient)return this.openWindow(te.id,{forceReuseWindow:!0})}return this.f.reload(te,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(Z,U){return this.G(U?.targetWindowId,Z)?.win?.close()}async quit(Z){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.f.quit()}async exit(Z,U){await this.f.kill(U)}async resolveProxy(Z,U){if(this.g.extensionTestsLocationURI){const J=this.r.getValue("integration-test.http.proxy");if(J)return J}return this.H(Z)?.win?.webContents?.session?.resolveProxy(U)}async lookupAuthorization(Z,U){return this.s.lookupAuthorization(U)}async loadCertificates(Z){return(await new Promise((te,x)=>{G(["@vscode/proxy-agent"],te,x)}).then(Ie)).loadSystemCertificates({log:this.h})}findFreePort(Z,U,te,x,J=1){return(0,b.$1g)(U,te,x,J)}async openDevTools(Z,U){this.G(U?.targetWindowId,Z)?.win?.webContents.openDevTools(U?.mode?{mode:U.mode,activate:U.activate}:void 0)}async toggleDevTools(Z,U){this.G(U?.targetWindowId,Z)?.win?.webContents.toggleDevTools()}async profileRenderer(Z,U,te){const x=this.H(Z);if(!x||!x.win)throw new Error;return await new L.$Zfc(x.win,U,this.h).inspect(te)}async windowsGetStringRegKey(Z,U,te,x){if(!d.$j)return;const J=await new Promise((B,j)=>{G(["@vscode/windows-registry"],B,j)}).then(Ie);try{return J.GetStringRegKey(U,te,x)}catch{return}}G(Z,U){return this.H(Z)??this.I(Z)??this.H(U)}H(Z){if(typeof Z=="number")return this.a.getWindowById(Z)}I(Z){if(typeof Z!="number")return;const U=k.webContents.fromId(Z);if(U)return this.b.getWindowByWebContents(U)}};e.$3fc=H,Ee([I.$7h],H.prototype,"F",null),e.$3fc=H=Ee([oe(0,a.$cfc),oe(1,A.$1fc),oe(2,P.$0ec),oe(3,u.$vfc),oe(4,E.$2ec),oe(5,i.$0j),oe(6,o.$qk),oe(7,s.$afc),oe(8,S.$ofc),oe(9,W.$9i),oe(10,V.$Ffc)],H)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[269],he([0,1,13,27,8,22,2,11,3,35,10,52,20,5,64,72,73,50,29]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0,g=Ge(g);let E=class{static{P=this}static{this.a="#1E1E1E"}constructor(u,i,o,s,a,l,S){this.d=u,this.e=i,this.f=o,this.g=s,this.h=a,this.i=l,this.j=S,this.b=null,this.c=null}async openReporter(u){if(this.b)this.b&&this.k(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const i=new T.$Sc,o=i.add(this.i.createIPCObjectUrl()),s=this.m(this.c,700,800);this.b=this.l(s,o,{backgroundColor:u.styles.backgroundColor,title:(0,m.localize)(11232,null),zoomLevel:u.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:u,disableExtensions:!!this.e.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:g.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(I.$Wg.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,i.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,i.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(u){this.f.error(u)}}async $showConfirmCloseDialog(){if(this.b){const{response:u}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(11233,null),buttons:[(0,m.localize)(11234,null),(0,m.localize)(11235,null)]},this.b);u===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:u}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(11236,null),buttons:[(0,m.localize)(11237,null),(0,m.localize)(11238,null)]},this.b);return u===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const u=this.j.getWindowById(this.c.id);if(!u)throw new Error("Window not found");return u}async $sendReporterMenu(u,i){const o=this.issueReporterWindowCheck(),s="vscode:triggerReporterMenu",a=new R.$ue;return o.sendWhenReady(s,a.token,{replyChannel:s,extensionId:u,extensionName:i}),await(0,k.$th)(new Promise(S=>c.$GX.once(`vscode:triggerReporterMenuResponse:${u}`,(y,D)=>S(D))),5e3,()=>{this.f.error(`Error: Extension ${u} timed out waiting for menu response`),a.cancel()})}async $closeReporter(){this.b?.close()}k(u){u.isMinimized()&&u.restore(),u.focus()}l(u,i,o,s){const a=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:o.title,backgroundColor:o.backgroundColor||P.a,webPreferences:{preload:I.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.$0D)(o.zoomLevel),sandbox:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return a.setMenuBarVisibility(!1),a}m(u,i,o){let s;const a=n.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(p.$k){const y=n.screen.getCursorScreenPoint();s=n.screen.getDisplayNearestPoint(y)}!s&&u&&(s=n.screen.getDisplayMatching(u.getBounds())),s||(s=n.screen.getPrimaryDisplay()||a[0])}const l=s.bounds,S={width:i,height:o,x:l.x+l.width/2-i/2,y:l.y+l.height/2-o/2};return l.width>0&&l.height>0&&(S.x<l.x&&(S.x=l.x),S.y<l.y&&(S.y=l.y),S.x>l.x+l.width&&(S.x=l.x),S.y>l.y+l.height&&(S.y=l.y),S.width>l.width&&(S.width=l.width),S.height>l.height&&(S.height=l.height)),S}};e.$4fc=E,e.$4fc=E=P=Ee([oe(1,d.$2ec),oe(2,w.$0j),oe(3,h.$0ec),oe(4,f.$2fc),oe(5,v.$_ec),oe(6,$.$cfc)],E)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[270],he([0,1,13,32,2,11,3,115,35,10,96,136,52,20,5,64,72,28,73,34,63,50]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0,v=Ge(v);const i="issue.processExplorerWindowState";let o=class{static{u=this}static{this.a="#1E1E1E"}constructor(l,S,y,D,L,A,O,W,V,H){this.d=l,this.f=S,this.g=y,this.h=D,this.i=L,this.j=A,this.k=O,this.l=W,this.m=V,this.n=H,this.b=null,this.c=null,this.o()}o(){p.$GX.on("vscode:listProcesses",async l=>{const S=[];try{S.push({name:(0,c.localize)(11227,null),rootProcess:await(0,I.$Us)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(D=>{(0,m.$Rm)(D)?S.push({name:D.hostName,rootProcess:D}):D.processes&&S.push({name:D.hostName,rootProcess:D.processes})})}catch(y){this.g.error(`Listing processes failed: ${y}`)}this.s(l,"vscode:listProcessesResponse",S)}),p.$GX.on("vscode:workbenchCommand",(l,S)=>{const{id:y,from:D,args:L}=S;let A;switch(D){case"processExplorer":A=this.c;break;default:throw new Error(`Unexpected command source: ${D}`)}A?.webContents.send("vscode:runAction",{id:y,from:D,args:L})}),p.$GX.on("vscode:closeProcessExplorer",l=>{this.b?.close()}),p.$GX.on("vscode:pidToNameRequest",async l=>{const S=await this.i.getMainDiagnostics(),y=[];for(const D of S.windows)y.push([D.pid,`window [${D.id}] (${D.title})`]);for(const{pid:D,name:L}of E.$Jfc.getAll())y.push([D,L]);this.s(l,"vscode:pidToNameResponse",y)})}async openProcessExplorer(l){if(!this.b&&(this.c=n.BrowserWindow.getFocusedWindow(),this.c)){const S=new k.$Sc,y=S.add(this.l.createIPCObjectUrl()),D=this.n.getItem(i,void 0),L=s(D)?D:this.q(this.c,800,500);this.b=this.r(L,y,{backgroundColor:l.styles.backgroundColor,title:(0,c.localize)(11228,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),y.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:l,product:v.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(R.$Wg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,S.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,S.dispose())});const A=()=>{if(!this.b)return;const O=this.b.getSize(),W=this.b.getPosition();if(!O||!W)return;const V={width:O[0],height:O[1],x:W[0],y:W[1]};this.n.setItem(i,V)};this.b.on("moved",A),this.b.on("resized",A)}this.b&&this.p(this.b)}p(l){l.isMinimized()&&l.restore(),l.focus()}q(l,S,y){let D;const L=n.screen.getAllDisplays();if(L.length===1)D=L[0];else{if(T.$k){const W=n.screen.getCursorScreenPoint();D=n.screen.getDisplayNearestPoint(W)}!D&&l&&(D=n.screen.getDisplayMatching(l.getBounds())),D||(D=n.screen.getPrimaryDisplay()||L[0])}const A=D.bounds,O={width:S,height:y,x:A.x+A.width/2-S/2,y:A.y+A.height/2-y/2};return A.width>0&&A.height>0&&(O.x<A.x&&(O.x=A.x),O.y<A.y&&(O.y=A.y),O.x>A.x+A.width&&(O.x=A.x),O.y>A.y+A.height&&(O.y=A.y),O.width>A.width&&(O.width=A.width),O.height>A.height&&(O.height=A.height)),O}async stopTracing(){if(!this.f.args.trace)return;const l=await n.contentTracing.stopRecording(`${(0,r.$Kg)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,c.localize)(11229,null),detail:(0,c.localize)(11230,null,l),buttons:[(0,c.localize)(11231,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,l)}async getSystemStatus(){const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(l,S)}async $getSystemInfo(){const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(l,S)}async $getPerformanceInfo(){try{const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(l,S)}catch(l){throw this.g.warn("issueService#getPerformanceInfo ",l.message),l}}r(l,S,y,D){const L=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:y.title,backgroundColor:y.backgroundColor||u.a,webPreferences:{preload:R.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${S.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$0D)(y.zoomLevel),sandbox:!0},alwaysOnTop:y.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}s(l,S,...y){l.sender.isDestroyed()||l.sender.send(S,...y)}async closeProcessExplorer(){this.b?.close()}};e.$5fc=o,e.$5fc=o=u=Ee([oe(1,w.$2ec),oe(2,f.$0j),oe(3,m.$Qm),oe(4,h.$Mfc),oe(5,d.$0ec),oe(6,g.$2fc),oe(7,$.$_ec),oe(8,b.$qk),oe(9,P.$nR)],o);function s(a){return typeof a!="object"||a===null?!1:"x"in a&&"y"in a&&"width"in a&&"height"in a}}),define(le[271],he([0,1,22,16,20,19,5,64,28,56,24,49,105]),function(G,e,n,r,k,R,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;let w=class extends d.$rgc{constructor(g,v,b,$,P,E,t,u){super(g,v,$,P,E,u),this.e=b,this.u=t}s(g){return(0,d.$qgc)(`linux-${process.arch}`,g,this.k)}t(g){this.a&&(this.d(h.$EY.CheckingForUpdates(g)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$$p).then(v=>{!v||!v.url||!v.version||!v.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!g}),this.d(h.$EY.Idle(h.UpdateType.Archive))):this.d(h.$EY.AvailableForDownload(v))}).then(void 0,v=>{this.j.error(v);const b=g?v.message||v:void 0;this.d(h.$EY.Idle(h.UpdateType.Archive,b))}))}async o(g){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):g.update.url&&this.u.openExternal(void 0,g.update.url),this.d(h.$EY.Idle(h.UpdateType.Archive))}};e.$tgc=w,e.$tgc=w=Ee([oe(0,R.$vfc),oe(1,r.$9i),oe(2,m.$9l),oe(3,k.$2ec),oe(4,c.$5p),oe(5,T.$0j),oe(6,I.$2fc),oe(7,p.$qk)],w)}),define(le[272],he([0,1,48,26,27,8,22,53,46,9,7,152,23,16,20,14,19,5,64,28,56,24,49,105]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0,r=Ie(r),c=Ie(c),d=Ie(d);async function o(S,y=1e3){for(;!S();)await(0,R.$Dh)(y)}let s;function a(){return typeof s>"u"&&(s=r.existsSync(c.$ic(c.$lc(process.execPath),"unins000.exe"))?u.UpdateType.Setup:u.UpdateType.Archive),s}let l=class extends i.$rgc{get cachePath(){const y=c.$ic((0,k.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return r.promises.mkdir(y,{recursive:!0}).then(()=>y)}constructor(y,D,L,A,O,W,V,H,Y){super(y,D,A,O,W,Y),this.u=L,this.v=V,this.w=H,y.setRelaunchHandler(this)}handleRelaunch(y){return y?.addArgs||y?.removeArgs||this.state.type!==u.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$EY.Disabled(u.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(y){let D=`win32-${process.arch}`;return a()===u.UpdateType.Archive?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,i.$qgc)(D,y,this.k)}t(y){this.a&&(this.d(u.$EY.CheckingForUpdates(y)),this.i.request({url:this.a},T.CancellationToken.None).then(E.$$p).then(D=>{const L=a();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!y}),this.d(u.$EY.Idle(L)),Promise.resolve(null)):L===u.UpdateType.Archive?(this.d(u.$EY.AvailableForDownload(D)),Promise.resolve(null)):(this.d(u.$EY.Downloading),this.C(D.version).then(()=>this.B(D.version).then(A=>d.Promises.exists(A).then(O=>{if(O)return Promise.resolve(A);const W=`${A}.tmp`;return this.i.request({url:D.url},T.CancellationToken.None).then(V=>this.v.writeFile(m.URI.file(W),V.stream)).then(D.sha256hash?()=>(0,h.$zX)(W,D.sha256hash):()=>{}).then(()=>d.Promises.rename(W,A,!1)).then(()=>A)})).then(A=>{this.e={packagePath:A},this.d(u.$EY.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(u.$EY.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,p.$qj)(String(D)))}),this.j.error(D);const L=y?D.message||D:void 0;this.d(u.$EY.Idle(a(),L))}))}async o(y){y.update.url&&this.w.openExternal(void 0,y.update.url),this.d(u.$EY.Idle(a()))}async B(y){const D=await this.cachePath;return c.$ic(D,`CodeSetup-${this.k.quality}-${y}.exe`)}async C(y=null){const D=y?W=>!new RegExp(`${this.k.quality}-${y}\\.exe$`).test(W):()=>!0,L=await this.cachePath,O=(await d.Promises.readdir(L)).filter(D).map(async W=>{try{await r.promises.unlink(c.$ic(L,W))}catch{}});await Promise.all(O)}async p(){if(this.state.type!==u.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const y=this.state.update;this.d(u.$EY.Updating(y));const D=await this.cachePath;this.e.updateFilePath=c.$ic(D,`CodeSetup-${this.k.quality}-${y.version}.flag`),await d.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$EY.Idle(a()))});const A=`${this.k.win32MutexName}-ready`,O=await new Promise((W,V)=>{G(["@vscode/windows-mutex"],W,V)}).then(Ie);o(()=>O.isActive(A)).then(()=>this.d(u.$EY.Ready(y)))}r(){this.state.type!==u.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(y){if(this.state.type!==u.StateType.Idle)return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(u.$EY.Downloading),this.e={packagePath:y},this.d(u.$EY.Downloaded(L)),D?this.k.target==="user"&&this.p():this.d(u.$EY.Ready(L))}};e.$vgc=l,Ee([I.$7h],l.prototype,"cachePath",null),e.$vgc=l=Ee([oe(0,v.$vfc),oe(1,w.$9i),oe(2,t.$9l),oe(3,f.$2ec),oe(4,E.$5p),oe(5,b.$0j),oe(6,g.$0k),oe(7,$.$2fc),oe(8,P.$qk)],l)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[137],he([0,1,13,8,22,54,4,2,11,70,3,7,10,27,69,16,52,20,68,14,19,5,28,73,248,87,24,110,76,50,29,30,59,51,40,34,58,71,21,6]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t,u,i,o,s,a,l,S,y,D,L,A,O,W,V,H,Y,Z,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=void 0,n=Ge(n);var te;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(te||(te={}));class x extends I.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(T.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(T.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(T.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(T.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(T.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(T.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const C=!(0,y.$5D)(this.r);if(m.$k&&C&&j.setSheetOffset((0,m.$K)((0,w.release)())?28:22),C&&(m.$j&&(0,y.$8D)(this.r)||m.$k)){const X=this.s.getItem(x.D);X?this.updateWindowControls({height:X}):this.updateWindowControls({height:y.$7D})}m.$j&&C&&j.hookWindowMessage(278,()=>{const[ae,K]=j.getPosition(),ce=n.default.screen.getCursorScreenPoint(),se=ce.x-ae,ie=ce.y-K;return!(se>30&&ie>=0&&ie<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:se,y:ie})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),m.$k&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,C,X,ae){super(),this.r=j,this.s=C,this.t=X,this.u=ae,this.a=this.B(new T.$je),this.onDidClose=this.a.event,this.b=this.B(new T.$je),this.onDidMaximize=this.b.event,this.c=this.B(new T.$je),this.onDidUnmaximize=this.c.event,this.f=this.B(new T.$je),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new T.$je),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new T.$je),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,y.$8D)(this.r),this.G=void 0,this.H=void 0}w(j,C=n.default.screen.getAllDisplays().length>0){const X=this.r.getValue("window"),ae=m.$k&&X?.nativeTabs===!0;(m.$k||m.$j)&&C&&(!ae||n.default.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(K=>typeof K=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===O.WindowMode.Maximized||j.mode===O.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===O.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){m.$k?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return m.$k?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){m.$k&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return m.$k?!!this.win?.isDocumentEdited():!!this.C}focus(j){m.$k&&j?.force&&n.default.app.focus({steal:!0});const C=this.win;C&&(C.isMinimized()&&C.restore(),C.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(m.$k)switch(n.default.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const C=this.win;if(C){if(j.height&&this.s.setItem(J.D,j.height),m.$j&&this.F)C.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(m.$k&&j.height!==void 0){const X=(j.height-15)/2;X?C.setWindowButtonPosition({x:X,y:X}):C.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,C){(0,y.$9D)(this.r)?this.J(j,C):this.M(j)}get isFullScreen(){if(m.$k&&typeof this.G=="boolean")return this.G;const j=this.win,C=j?.isFullScreen(),X=j?.isSimpleFullScreen();return!!(C||X)}J(j,C){const X=this.win;X?.isSimpleFullScreen()&&X?.setSimpleFullScreen(!1),this.L(j,C)}L(j,C){if(m.$k){this.G=j;const ae=this.H=new r.$Zh;(async()=>{const K=await Promise.race([ae.p,(0,r.$Dh)(1e4).then(()=>!1)]);this.H===ae&&(this.G=void 0,this.H=void 0,!K&&j&&C&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const C=this.win;C?.isFullScreen()&&this.L(!1,!1),C?.setSimpleFullScreen(j),C?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$sfc=x;let J=class extends x{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(C=>C.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Qi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,C,X,ae,K,ce,se,ie,M,F,N,z,_,Q,q,re,de,me,we,De,ke){super(F,De,ae,C),this.fb=X,this.gb=K,this.hb=ce,this.ib=se,this.jb=ie,this.kb=M,this.lb=N,this.mb=z,this.nb=_,this.ob=Q,this.pb=q,this.qb=re,this.rb=de,this.sb=me,this.tb=we,this.N=this.B(new T.$je),this.onWillLoad=this.N.event,this.O=this.B(new T.$je),this.onDidSignalReady=this.O.event,this.P=this.B(new T.$je),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=te.NONE;{const[Pe,Re]=this.Eb(j.state);this.U=Pe,this.u.trace("window#ctor: using window state",Pe);const $e=ke.invokeFunction(D.$dfc,this.U,{preload:p.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.default.BrowserWindow($e),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Re),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=te.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===te.READY}get whenClosedOrLoaded(){return new Promise(j=>{function C(){X.dispose(),ae.dispose(),j()}const X=this.onDidClose(()=>C()),ae=this.onWillLoad(()=>C())})}vb(){this.B(T.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(O.WindowError.UNRESPONSIVE))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(C,X)=>X)(C=>this.yb(O.WindowError.PROCESS_GONE,{...C}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(C,X,ae)=>({exitCode:X,reason:ae}))(({exitCode:C,reason:X})=>this.yb(O.WindowError.LOAD,{reason:X,exitCode:C}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(C=>C.preventDefault())),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(C=>this.Bb(C))),this.B(this.mb.onDidDeleteUntitledWorkspace(C=>this.Ab(C)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(C,X)=>{const ae=await this.xb();X({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,ae)})})}xb(){return this.wb||(this.wb=(0,o.$mq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,C){switch(j){case O.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${C?.reason||"<unknown>"}, code: ${C?.exitCode||"<unknown>"})`);break;case O.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case O.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${C?.reason||"<unknown>"}, code: ${C?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:C?.reason,code:C?.exitCode}),j){case O.WindowError.UNRESPONSIVE:case O.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===O.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:X,checkboxChecked:ae}=await this.pb.showMessageBox({type:"warning",buttons:[(0,d.localize)(10907,null),(0,d.localize)(10908,null),(0,d.localize)(10909,null)],message:(0,d.localize)(10910,null),detail:(0,d.localize)(10911,null),checkboxLabel:this.S?.workspace?(0,d.localize)(10912,null):void 0},this.m);if(X!==2){const K=X===0;await this.zb(K,ae)}}else if(j===O.WindowError.PROCESS_GONE){let X;C?X=(0,d.localize)(10914,null,C.reason,C.exitCode??"<unknown>"):X=(0,d.localize)(10913,null);const{response:ae,checkboxChecked:K}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,d.localize)(10915,null):(0,d.localize)(10916,null),(0,d.localize)(10917,null)],message:X,detail:this.S?.workspace?(0,d.localize)(10918,null):(0,d.localize)(10919,null),checkboxLabel:this.S?.workspace?(0,d.localize)(10920,null):void 0},this.m),ce=ae===0;await this.zb(ce,K)}break}}async zb(j,C){const X=this.S?.workspace;if(C&&X)try{const ae=this.kb.workspaceStorage(X);await ae.init(),ae.delete("memento/workbench.parts.editor"),await ae.close()}catch(ae){this.u.error(ae)}this.P.fire();try{if(j&&this.S){let ae,K;(0,L.$Mi)(X)?ae={folderUri:X.uri}:(0,L.$Ri)(X)?ae={workspaceUri:X.configPath}:K=!0,(0,Z.$Nb)(await this.tb.open({context:D.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ae?[ae]:void 0,forceEmpty:K,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const C=this.Gb();C!==this.W&&(this.W=C,this.Hb(C))}if(!j||j.affectsConfiguration("http.proxy")||j.affectsConfiguration("http.noProxy")){let C=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(C?.indexOf("@")!==-1){const ae=h.URI.parse(C),K=ae.authority.indexOf("@");K!==-1&&(C=ae.with({authority:ae.authority.substring(K+1)}).toString())}C?.endsWith("/")&&(C=C.substr(0,C.length-1));const X=(this.r.getValue("http.noProxy")||[]).map(ae=>ae.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((C||"").indexOf("@")===-1&&(C!==this.Z||X!==this.$)){this.Z=C,this.$=X;const ae=C||"",K=X?`${X},<local>`:"<local>";this.u.trace(`Setting proxy to '${ae}', bypassing '${K}'`),this.m.webContents.session.setProxy({proxyRules:ae,proxyBypassRules:K,pacScript:""}),n.default.app.setProxy({proxyRules:ae,proxyBypassRules:K,pacScript:""})}}}addTabbedWindow(j){m.$k&&j.win&&this.m.addTabbedWindow(j.win)}load(j,C=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!C.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),C.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,C),this.ub===te.NONE?this.S=j:this.db=j,this.ub=te.NAVIGATING,this.m.loadURL(p.$Wg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const X=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Oh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:C.isReload?O.LoadReason.RELOAD:X?O.LoadReason.LOAD:O.LoadReason.INITIAL})}Cb(j,C){const X=(this.S??this.db)?.userEnv;if(X){const ae=(0,$.$Hm)(X)&&!(0,$.$Hm)(j.userEnv),K=this.isExtensionDevelopmentHost;(ae||K)&&(j.userEnv={...X,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),C.disableExtensions!==void 0&&(j["disable-extensions"]=C.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),j.perfMarks=(0,c.getMarks)(),this.bb.update(j)}async reload(j){const C=Object.assign({},this.S);C.workspace=await this.Db(C),delete C.filesToOpenOrCreate,delete C.filesToDiff,delete C.filesToMerge,delete C.filesToWait,this.isExtensionDevelopmentHost&&j&&(C.verbose=j.verbose,C.debugId=j.debugId,C.extensionEnvironment=j.extensionEnvironment,C["inspect-extensions"]=j["inspect-extensions"],C["inspect-brk-extensions"]=j["inspect-brk-extensions"],C["extensions-dir"]=j["extensions-dir"]),C.accessibilitySupport=n.default.app.isAccessibilitySupportEnabled(),C.isInitialStartup=!1,C.policiesData=this.gb.serialize(),C.continueOn=this.t.continueOn,C.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},C.logLevel=this.fb.getLogLevel(),C.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(C,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,L.$Ri)(j.workspace)){const C=j.workspace.configPath;if(C.scheme===p.Schemas.file&&!await this.ib.exists(C))return}else if((0,L.$Mi)(j.workspace)){const C=j.workspace.uri;if(C.scheme===p.Schemas.file&&!await this.ib.exists(C))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,O.$4ec)();if(this.isFullScreen){let X;try{X=n.default.screen.getDisplayMatching(this.getBounds())}catch{}const ae=(0,O.$4ec)();return{mode:O.WindowMode.Fullscreen,display:X?X.id:void 0,width:this.U.width||ae.width,height:this.U.height||ae.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let C;if(!m.$k&&this.m.isMaximized()?C=O.WindowMode.Maximized:C=O.WindowMode.Normal,C===O.WindowMode.Maximized?j.mode=O.WindowMode.Maximized:j.mode=O.WindowMode.Normal,C===O.WindowMode.Normal||C===O.WindowMode.Maximized){let X;C===O.WindowMode.Normal?X=this.getBounds():X=this.m.getNormalBounds(),j.x=X.x,j.y=X.y,j.width=X.width,j.height=X.height}return j.zoomLevel=this.ab,j}Eb(j){(0,c.mark)("code/willRestoreCodeWindowState");let C=!1;if(j){this.ab=j.zoomLevel;try{const X=n.default.screen.getAllDisplays();C=X.length>1,j=D.WindowStateValidator.validateWindowState(this.u,j,X)}catch(X){this.u.warn(`Unexpected error validating window state: ${X}
${X.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[j||(0,O.$4ec)(),C]}getBounds(){const[j,C]=this.m.getPosition(),[X,ae]=this.m.getSize();return{x:j,y:C,width:X,height:ae}}I(j,C){super.I(j,C),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,y.$3D)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,C=!0){m.$k||(j==="toggle"&&C&&this.send("vscode:showInfoMessage",(0,d.localize)(10921,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const C=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!C),this.m.autoHideMenuBar=C;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,C,...X){this.isReady?this.send(j,...X):this.ready().then(()=>{C.isCancellationRequested||this.send(j,...X)})}send(j,...C){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...C)}catch(X){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,R.$nj)(X)}`)}}}updateTouchBar(j){m.$k&&this.Y.forEach((C,X)=>{const ae=j[X];C.segments=this.Mb(ae)})}Kb(){if(m.$k){for(let j=0;j<10;j++){const C=this.Lb();this.Y.push(C)}this.m.setTouchBar(new n.default.TouchBar({items:this.Y}))}}Lb(j=[]){const C=this.Mb(j),X=new n.default.TouchBar.TouchBarSegmentedControl({segments:C,mode:"buttons",segmentStyle:"automatic",change:ae=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:X.segments[ae].id,from:"touchbar"})}});return X}Mb(j=[]){return j.map(X=>{let ae;X.icon&&!l.ThemeIcon.isThemeIcon(X.icon)&&X.icon?.dark?.scheme===p.Schemas.file&&(ae=n.default.nativeImage.createFromPath(h.URI.revive(X.icon.dark).fsPath),ae.isEmpty()&&(ae=void 0));let K;return typeof X.title=="string"?K=X.title:K=X.title.value,{id:X.id,label:ae?void 0:K,icon:ae}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$tfc=J,e.$tfc=J=Ee([oe(1,t.$0j),oe(2,Y.$qfc),oe(3,b.$2ec),oe(4,W.$qo),oe(5,H.$ffc),oe(6,P.$0k),oe(7,s.$Dfc),oe(8,s.$Bfc),oe(9,g.$9i),oe(10,S.$afc),oe(11,A.$ofc),oe(12,f.$9ec),oe(13,a.$9l),oe(14,v.$0ec),oe(15,E.$vfc),oe(16,u.$qk),oe(17,i.$_ec),oe(18,D.$cfc),oe(19,V.$nR),oe(20,U.$Bi)],J)}),define(le[273],he([0,1,13,3,16,20,19,5,34,50,51,137]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;let d=class extends h.$sfc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(f,g,v,b,$,P){super(b,$,g,v),this.O=f,this.P=P,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(f){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),f&&!this.N&&(this.N=!0,this.w({x:f.x,y:f.y,width:f.width,height:f.height,mode:f.show===!1?m.WindowMode.Maximized:m.WindowMode.Normal})))}Q(){if(this.m)return;const f=n.BrowserWindow.fromWebContents(this.O);f&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(f),f.setMenu(null),(r.$j||r.$l)&&(0,c.$5D)(this.r)&&f.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(f){return this.O.id===f.id}};e.$ufc=d,e.$ufc=d=Ee([oe(1,R.$2ec),oe(2,I.$0j),oe(3,k.$9i),oe(4,p.$nR),oe(5,T.$vfc)],d)}),define(le[274],he([0,1,13,4,2,11,35,273,6,5,51,29]),function(G,e,n,r,k,R,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;let d=class extends k.$Tc{constructor(f,g){super(),this.h=f,this.j=g,this.a=this.B(new r.$je),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$je),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$je),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$je),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,g)=>{const v=this.getWindowByWebContents(g.webContents);if(v)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),v.tryClaimWindow();else{const b=new k.$Sc;b.add(r.Event.fromNodeEventEmitter(g.webContents,"did-create-window",($,P)=>({browserWindow:$,details:P}))(({browserWindow:$,details:P})=>{const E=this.getWindowByWebContents($.webContents);E&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),E.tryClaimWindow(P.options))})),b.add(r.Event.fromNodeEventEmitter(g,"closed")(()=>b.dispose()))}}),T.$GX.handle("vscode:registerAuxiliaryWindow",async(f,g)=>{const v=this.getWindowByWebContents(f.sender);return v&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),v.parentId=g),f.sender.id})}createWindow(f){return this.h.invokeFunction(h.$dfc,this.n(f),{preload:R.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const g={},v=f.features.split(",");for(const $ of v){const[P,E]=$.split("=");switch(P){case"width":g.width=parseInt(E,10);break;case"height":g.height=parseInt(E,10);break;case"left":g.x=parseInt(E,10);break;case"top":g.y=parseInt(E,10);break;case"window-maximized":g.mode=m.WindowMode.Maximized;break;case"window-fullscreen":g.mode=m.WindowMode.Fullscreen;break}}const b=h.WindowStateValidator.validateWindowState(this.j,g)??(0,m.$5ec)();return this.j.trace("[aux window] using window state",b),b}registerWindow(f){const g=new k.$Sc,v=this.h.createInstance(I.$ufc,f);this.g.set(v.id,v),g.add((0,k.$Rc)(()=>this.g.delete(v.id))),g.add(v.onDidMaximize(()=>this.a.fire(v))),g.add(v.onDidUnmaximize(()=>this.b.fire(v))),g.add(v.onDidEnterFullScreen(()=>this.c.fire({window:v,fullscreen:!0}))),g.add(v.onDidLeaveFullScreen(()=>this.c.fire({window:v,fullscreen:!1}))),g.add(v.onDidTriggerSystemContextMenu(({x:b,y:$})=>this.f.fire({window:v,x:b,y:$}))),r.Event.once(v.onDidClose)(()=>g.dispose())}getWindowByWebContents(f){const g=this.g.get(f.id);return g?.matches(f)?g:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,h.$efc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$3gc=d,e.$3gc=d=Ee([oe(0,p.$Bi),oe(1,c.$0j)],d)}),define(le[88],he([0,1,13,21,8,4,47,2,11,3,18,7,23,10,6,19,5,62,87,102,30,59,31,52]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=e.$cgc=void 0,e.$cgc=(0,f.$Ci)("workspacesHistoryMainService");let s=class extends I.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(l,S,y,D,L){super(),this.f=l,this.g=S,this.h=y,this.j=D,this.m=L,this.c=this.B(new R.$je),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new k.$Ah(800)),this.n()}n(){this.h.when(g.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){let S=[],y=[];for(const L of l)if((0,P.$Zhb)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(S,L.workspace)&&S.push(L);else if((0,P.$1hb)(L))this.y(S,L.folderUri)||S.push(L);else{const A=this.z(y,L.fileUri),O=L.fileUri.scheme===p.Schemas.file&&o.G.indexOf((0,m.$ah)(L.fileUri))>=0;!A&&!O&&(y.push(L),c.$j&&L.fileUri.scheme===p.Schemas.file&&n.app.addRecentDocument(L.fileUri.fsPath))}const D=await this.r({workspaces:S,files:y});S=D.workspaces,y=D.files,S.length>o.a&&(S.length=o.a),y.length>o.a&&(y.length=o.a),await this.t({workspaces:S,files:y}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(l){const S=A=>{const O=this.u(A);for(const W of l)if(m.$7g.isEqual(W,O))return!1;return!0},y=await this.getRecentlyOpened(),D=y.workspaces.filter(S),L=y.files.filter(S);(D.length!==y.workspaces.length||L.length!==y.files.length)&&(await this.t({files:L,workspaces:D}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(l){if(l?.confirm){const{response:S}=await this.m.showMessageBox({type:"warning",buttons:[(0,w.localize)(10885,null),(0,w.localize)(10886,null)],message:(0,w.localize)(10887,null),detail:(0,w.localize)(10888,null),cancelId:1});if(S!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(l){const S=new u.$zc(L=>m.$7g.getComparisonKey(L));if(l?.workspaces)for(const L of l.workspaces)S.set(this.u(L),L);const y=new u.$zc(L=>m.$7g.getComparisonKey(L));if(l?.files)for(const L of l.files)y.set(this.u(L),L);const D=await this.s();for(const L of D.workspaces){const A=S.get(this.u(L));A?A.label=A.label??L.label:S.set(this.u(L),L)}for(const L of D.files){const A=y.get(this.u(L));A?A.label=A.label??L.label:y.set(this.u(L),L)}return{workspaces:[...S.values()],files:[...y.values()]}}async s(){await this.j.whenReady;let l;const S=this.j.get(o.b,b.StorageScope.APPLICATION);if(typeof S=="string")try{l=JSON.parse(S)}catch(y){this.f.error("Unexpected error parsing opened paths list",y)}return(0,P.$7hb)(l,this.f)}async t(l){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,P.$8hb)(l)),b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}u(l){return(0,P.$1hb)(l)?l.folderUri:(0,P.$2hb)(l)?l.fileUri:l.workspace.configPath}w(l,S){return!!l.find(y=>(0,P.$Zhb)(y)&&y.workspace.id===S.id)}y(l,S){return!!l.find(y=>(0,P.$1hb)(y)&&m.$7g.isEqual(y.folderUri,S))}z(l,S){return!!l.find(y=>m.$7g.isEqual(y.fileUri,S))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){c.$j&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$j)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(10889,null),description:(0,w.localize)(10890,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const S=[];for(const L of n.app.getJumpListSettings().removedItems){const A=L.args;if(A){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);O&&S.push(h.URI.parse(O[2]))}}await this.removeRecentlyOpened(S);let y=!1;const D=(0,r.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(L=>{const A=(0,P.$Zhb)(L)?L.workspace:L.folderUri,{title:O,description:W}=this.L(A,L.label);let V;return h.URI.isUri(A)?V=`--folder-uri "${A.toString()}"`:(y=!0,V=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:W.substr(0,255),program:process.execPath,args:V,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&l.push({type:"custom",name:y?(0,w.localize)(10891,null):(0,w.localize)(10892,null),items:D})}l.push({type:"recent"});try{const S=n.app.setJumpList(l);S&&S!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${S}`)}catch(S){this.f.warn("updateWindowsJumpList#setJumpList",S)}}L(l,S){if(S)return{title:(0,T.$6w)(S).name,description:S};if(h.URI.isUri(l))return{title:(0,m.$ah)(l),description:this.M(l)};if(this.g.isUntitledWorkspace(l))return{title:(0,w.localize)(10893,null),description:""};let y=(0,m.$ah)(l.configPath);return y.endsWith(E.$Yi)&&(y=y.substr(0,y.length-E.$Yi.length-1)),{title:(0,w.localize)(10894,null,y),description:this.M(l.configPath)}}M(l){return l.scheme==="file"?(0,T.$Xw)(l.fsPath):l.toString()}async N(){if(!c.$k)return;n.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),S=[];let y=0;for(let L=0;L<l.workspaces.length&&y<o.C;L++){const A=this.u(l.workspaces[L]);if(A.scheme===p.Schemas.file){const O=(0,m.$4g)(A);await d.Promises.exists(O)&&(S.push(O),y++)}}const D=[];for(let L=0;L<l.files.length&&y<o.D;L++){const A=this.u(l.files[L]);if(A.scheme===p.Schemas.file){const O=(0,m.$4g)(A);if(o.G.includes((0,m.$ah)(A))||S.includes(O))continue;await d.Promises.exists(O)&&(D.push(O),y++)}}D.reverse().forEach(L=>n.app.addRecentDocument(L)),S.reverse().forEach(L=>n.app.addRecentDocument(L))}};e.$dgc=s,e.$dgc=s=o=Ee([oe(0,v.$0j),oe(1,t.$ofc),oe(2,g.$vfc),oe(3,$.$Dfc),oe(4,i.$0ec)],s)}),define(le[275],he([0,1,13,8,22,47,3,7,10,84,16,20,19,5,198,64,28,34,24,49,50,29,88,2]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0,p=Ie(p);const s="menu";let a=class extends i.$Tc{static{o=this}static{this.a="lastKnownMenubarData"}constructor(y,D,L,A,O,W,V,H,Y,Z,U,te){super(),this.t=y,this.u=D,this.w=L,this.y=A,this.z=O,this.C=W,this.D=V,this.F=H,this.G=Y,this.H=Z,this.I=U,this.J=te,this.s=Object.create(null),this.h=new r.$Oh(()=>this.R(),0),this.j=new r.$Oh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(T.$k||(0,E.$5D)(D))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const y=this.D.getItem(o.a);y&&(y.menus&&(this.n=y.menus),y.keybindings&&(this.r=y.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(W,V,H)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:V?.id})},this.s["workbench.action.newWindow"]=(W,V,H)=>this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:V?.id}),this.s["workbench.action.files.openFileFolder"]=(W,V,H)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(H),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(W,V,H)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(H),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(W,V,H)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(H),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const y=this.I.youTubeUrl;y&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(y,"openYouTubeUrl"));const D=this.I.requestFeatureUrl;D&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(D,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const A=this.I.licenseUrl;A&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(T.$x){const W=A.indexOf("?")>0?"&":"?";this.ob(`${A}${W}lang=${T.$x}`,"openLicenseUrl")}else this.ob(A,"openLicenseUrl")});const O=this.I.privacyStatementUrl;O&&A&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(O,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(y=>this.S(y))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const y=this.u.getValue("window.enableMenuBarMnemonics");return typeof y!="boolean"?!0:y}get P(){if(!T.$k)return!1;const y=this.u.getValue("window.nativeTabs");return typeof y!="boolean"?!1:y}updateMenu(y,D){this.n=y.menus,this.r=y.keybindings,this.D.setItem(o.a,y),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(y){T.$k&&(y.oldCount===0&&y.newCount>0||y.oldCount>0&&y.newCount===0)&&(this.f=y.newCount===0,this.Q())}U(){if(!T.$k)return;const y=n.BrowserWindow.getFocusedWindow();this.g=!y||!!this.J.getWindowByWebContents(y.webContents),this.Q()}W(){const y=n.Menu.getApplicationMenu();if(y&&this.m.push(y),Object.keys(this.n).length===0){this.X(T.$k?new n.Menu:null);return}const D=new n.Menu;let L;if(T.$k){const O=new n.Menu;L=new n.MenuItem({label:this.I.nameShort,submenu:O}),this.Y(O),D.append(L)}if(T.$k&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.qb(p.localize(11144,null)),click:()=>this.w.openEmptyWindow({context:t.OpenContext.DOCK})})),n.app.dock.setMenu(O)}if(this.$("File")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11145,null)),submenu:O});this.bb(O,"File"),D.append(W)}if(this.$("Edit")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11146,null)),submenu:O});this.bb(O,"Edit"),D.append(W)}if(this.$("Selection")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11147,null)),submenu:O});this.bb(O,"Selection"),D.append(W)}if(this.$("View")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11148,null)),submenu:O});this.bb(O,"View"),D.append(W)}if(this.$("Go")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11149,null)),submenu:O});this.bb(O,"Go"),D.append(W)}if(this.$("Run")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11150,null)),submenu:O});this.bb(O,"Run"),D.append(W)}if(this.$("Terminal")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11151,null)),submenu:O});this.bb(O,"Terminal"),D.append(W)}let A;if(this.$("Window")){const O=new n.Menu;A=new n.MenuItem({label:this.qb(p.localize(11152,null)),submenu:O,role:"window"}),this.hb(O)}if(A&&D.append(A),this.$("Help")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11153,null)),submenu:O,role:"help"});this.bb(O,"Help"),D.append(W)}D.items&&D.items.length>0?this.X(D):this.X(null),this.j.schedule()}X(y){if(n.Menu.setApplicationMenu(y),y)for(const D of this.J.getWindows())D.win?.setMenu(null)}Y(y){const D=this.jb(p.localize(11154,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let A;if(this.$("Preferences")){const te=new n.Menu;this.bb(te,"Preferences"),A=new n.MenuItem({label:this.qb(p.localize(11155,null)),submenu:te})}const O=new n.Menu,W=new n.MenuItem({label:p.localize(11156,null),role:"services",submenu:O}),V=new n.MenuItem({label:p.localize(11157,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),H=new n.MenuItem({label:p.localize(11158,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Y=new n.MenuItem({label:p.localize(11159,null),role:"unhide"}),Z=new n.MenuItem(this.nb("workbench.action.quit",{label:p.localize(11160,null,this.I.nameLong),click:async(te,x,J)=>{const B=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||B?.win?.isMinimized())&&await this.Z(J)&&this.H.quit(void 0)}})),U=[D];U.push(...L),A&&U.push(l(),A),U.push(l(),W,l(),V,H,Y,l(),Z),U.forEach(te=>y.append(te))}async Z(y){if(this.w.getWindowCount()===0)return!0;const D=this.u.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.fb(y)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[p.localize(11161,null),p.localize(11162,null)],message:p.localize(11163,null)});return L===0}return!0}$(y){if(!T.$k&&!(0,E.$5D)(this.u))return!1;switch(y){case"File":case"Help":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[y];case"Window":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[y]}}ab(y,D){D.forEach(L=>{if((0,f.$_fc)(L))y.append(l());else if((0,f.$$fc)(L)){const A=new n.Menu,O=new n.MenuItem({label:this.qb(L.label),submenu:A});this.ab(A,L.submenu.items),y.append(O)}else(0,f.$agc)(L)?y.append(this.db(L)):(0,f.$bgc)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(y),T.$k?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?y.append(new n.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):y.append(this.jb(L.label,L.id,!1,L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(y,D){this.n&&this.n[D]&&this.ab(y,this.n[D].items)}cb(y){const D=this.ib();D.length&&(D.forEach(L=>y.append(L)),y.append(l()))}db(y){const D=I.URI.revive(y.uri),L=y.id,A=L==="openRecentFile"?{fileUri:D}:L==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new n.MenuItem(this.nb(L,{label:y.label,click:async(O,W,V)=>{const H=this.eb(V);(await this.w.open({context:t.OpenContext.MENU,cli:this.y.args,urisToOpen:[A],forceNewWindow:H,gotoLineMode:!1,remoteAuthority:y.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([D])}},!1))}eb(y){return!!(y&&(!T.$k&&(y.ctrlKey||y.shiftKey)||T.$k&&(y.metaKey||y.altKey)))}fb(y){return!!(y.triggeredByAccelerator||y.altKey||y.ctrlKey||y.metaKey||y.shiftKey)}gb(y,D,L){const A={label:this.qb(y),role:L,enabled:!0};return new n.MenuItem(this.mb(D,A))}hb(y){const D=new n.MenuItem({label:p.localize(11164,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new n.MenuItem({label:p.localize(11165,null),role:"zoom",enabled:this.w.getWindowCount()>0}),A=new n.MenuItem({label:p.localize(11166,null),role:"front",enabled:this.w.getWindowCount()>0}),O=this.jb(p.localize(11167,null),"workbench.action.switchWindow"),W=[];this.P&&(W.push(l()),W.push(this.jb(p.localize(11168,null),"workbench.action.newWindowTab")),W.push(this.gb(p.localize(11169,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),W.push(this.gb(p.localize(11170,null),"workbench.action.showNextWindowTab","selectNextTab")),W.push(this.gb(p.localize(11171,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),W.push(this.gb(p.localize(11172,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,L,l(),O,...W,l(),A].forEach(V=>y.append(V))}ib(){switch(this.t.state.type){case P.StateType.Idle:return[new n.MenuItem({label:this.qb(p.localize(11173,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case P.StateType.CheckingForUpdates:return[new n.MenuItem({label:p.localize(11174,null),enabled:!1})];case P.StateType.AvailableForDownload:return[new n.MenuItem({label:this.qb(p.localize(11175,null)),click:()=>{this.t.downloadUpdate()}})];case P.StateType.Downloading:return[new n.MenuItem({label:p.localize(11176,null),enabled:!1})];case P.StateType.Downloaded:return T.$k?[]:[new n.MenuItem({label:this.qb(p.localize(11177,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case P.StateType.Updating:return[new n.MenuItem({label:p.localize(11178,null),enabled:!1})];case P.StateType.Ready:return[new n.MenuItem({label:this.qb(p.localize(11179,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(y,D,L,A){const O=this.qb(y),W=typeof D=="function"?D:(U,te,x)=>{const J=U?U.userSettingsLabel:null;let B=D;Array.isArray(D)&&(B=this.eb(x)?D[1]:D[0]),J&&x.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:J}):this.lb({type:"commandId",commandId:B})},V=typeof L=="boolean"?L:this.w.getWindowCount()>0,H=typeof A=="boolean"?A:!1,Y={label:O,click:W,enabled:V};H&&(Y.type="checkbox",Y.checked=H);let Z;return typeof D=="string"?Z=D:Array.isArray(D)&&(Z=D[0]),T.$k&&(Z==="editor.action.clipboardCutAction"?Y.role="cut":Z==="editor.action.clipboardCopyAction"?Y.role="copy":Z==="editor.action.clipboardPasteAction"&&(Y.role="paste"),Z==="undo"?Y.click=this.kb(W,{inDevTools:U=>U.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):Z==="redo"?Y.click=this.kb(W,{inDevTools:U=>U.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):Z==="editor.action.selectAll"&&(Y.click=this.kb(W,{inDevTools:U=>U.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.mb(Z,Y))}kb(y,D){return(L,A,O)=>{const W=n.BrowserWindow.getFocusedWindow();if(!W)return D.inNoWindow();if(W.webContents.isDevToolsFocused()&&W.webContents.devToolsWebContents)return D.inDevTools(W.webContents.devToolsWebContents);y(L,A||W,O)}}lb(y){let D=n.BrowserWindow.getFocusedWindow();if(D){const A=this.J.getWindowByWebContents(D.webContents);A&&(D=this.w.getWindowById(A.parentId)?.win??null)}if(!D){const A=this.w.getLastActiveWindow();A?.win?.isMinimized()&&(D=A.win)}const L=D?this.w.getWindowById(D.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",y),T.$k&&!this.y.isBuilt&&!L.isReady&&(y.type==="commandId"&&y.commandId==="workbench.action.toggleDevTools"||y.type!=="commandId"&&y.userSettingsLabel==="alt+cmd+i"))return!1;if(y.type==="commandId"){const A={id:y.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",k.CancellationToken.None,A)}else{const A={userSettingsLabel:y.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,A)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",y),!1}mb(y,D){const L=typeof y=="string"?this.r[y]:void 0;if(L?.label){if(L.isNative!==!1)D.accelerator=L.label,D.userSettingsLabel=L.userSettingsLabel;else if(typeof D.label=="string"){const A=D.label.indexOf("[");A>=0?D.label=`${D.label.substr(0,A)} [${L.label}]`:D.label=`${D.label} [${L.label}]`}}else D.accelerator=void 0;return D}nb(y,D,L=!D.accelerator){L&&(D=this.mb(y,D));const A=D.click;return D.click=(O,W,V)=>{this.pb(y),A?.(O,W,V)},D}ob(y,D){this.H.openExternal(void 0,y),this.pb(D)}pb(y){this.z.publicLog2("workbenchActionExecuted",{id:y,from:s})}qb(y){return(0,R.$3w)(y,!this.O)}};e.$egc=a,e.$egc=a=o=Ee([oe(0,P.$FY),oe(1,m.$9i),oe(2,t.$cfc),oe(3,h.$2ec),oe(4,$.$9l),oe(5,u.$cgc),oe(6,b.$nR),oe(7,d.$vfc),oe(8,w.$0j),oe(9,g.$2fc),oe(10,v.$qk),oe(11,c.$1fc)],a);function l(){return new n.MenuItem({type:"separator"})}}),define(le[276],he([0,1,6,19,5,275,2]),function(G,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=void 0,e.$fgc=(0,n.$Ci)("menubarMainService");let I=class extends T.$Tc{constructor(c,m,h){super(),this.b=c,this.c=m,this.f=h,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(R.$egc))}async updateMenubar(c,m){this.f.trace("menubarService#updateMenubar",c),(await this.a).updateMenu(m,c)}};e.$ggc=I,e.$ggc=I=Ee([oe(0,n.$Bi),oe(1,r.$vfc),oe(2,k.$0j)],I)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[277],he([0,1,26,13,106,27,21,22,39,4,32,47,2,11,9,70,3,36,18,12,7,10,69,16,52,20,14,6,19,5,72,73,74,34,50,137,29,134,268,30,103,88,59,51,76,40,58,71,84]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t,u,i,o,s,a,l,S,y,D,L,A,O,W,V,H,Y,Z,U,te,x,J,B,j,C,X,ae,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0,n=Ie(n),D=Ge(D);function ce(M){return(0,U.$Ri)(M?.workspace)}function se(M){return(0,U.$Mi)(M?.workspace)}let ie=class extends d.$Tc{constructor(F,N,z,_,Q,q,re,de,me,we,De,ke,Pe,Re,$e,ee,ue,fe,be,Ae,Ne){super(),this.s=F,this.t=N,this.u=z,this.w=_,this.z=Q,this.C=q,this.D=re,this.F=de,this.G=me,this.H=we,this.I=De,this.J=ke,this.L=Pe,this.M=Re,this.N=$e,this.O=ee,this.P=ue,this.Q=fe,this.R=be,this.S=Ae,this.U=Ne,this.a=this.B(new c.$je),this.onDidOpenWindow=this.a.event,this.b=this.B(new c.$je),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new c.$je),this.onDidDestroyWindow=this.c.event,this.f=this.B(new c.$je),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new c.$je),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new c.$je),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new c.$je),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new c.$je),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new Z.$Dgc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(F=>this.b.fire(F.window))),this.B(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const N=new d.$Sc;if(N.add(c.Event.any(F.onDidClose,F.onDidDestroy)(()=>N.dispose())),F.config.extensionDevelopmentPath)for(const z of F.config.extensionDevelopmentPath)N.add(this.R.addValidFileRoot(z));F.config.extensionTestsPath&&N.add(this.R.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,N){const z=this.G.args,_=N?.remoteAuthority||void 0,Q=!0,q=N?.forceReuseWindow,re=!q;return this.open({...F,cli:z,forceEmpty:Q,forceNewWindow:re,forceReuseWindow:q,remoteAuthority:_,forceTempProfile:N?.forceTempProfile,forceProfile:N?.forceProfile})}openExistingWindow(F,N){F.focus(),this.X(N,[F])}async open(F){this.z.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const N=[],z=[],_=[],Q=[],q=[];let re,de=0;const me=await this.db(F);this.z.trace("windowsManager#open pathsToOpen",me);for(const Re of me)se(Re)?F.addMode?N.push(Re):z.push(Re):ce(Re)?_.push(Re):Re.fileUri?(re||(re={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Re.remoteAuthority}),re.filesToOpenOrCreate.push(Re)):Re.backupPath?q.push({backupFolder:(0,f.$mc)(Re.backupPath),remoteAuthority:Re.remoteAuthority}):de++;F.diffMode&&re&&re.filesToOpenOrCreate.length>=2&&(re.filesToDiff=re.filesToOpenOrCreate.slice(0,2),re.filesToOpenOrCreate=[]),F.mergeMode&&re&&re.filesToOpenOrCreate.length===4&&(re.filesToMerge=re.filesToOpenOrCreate.slice(0,4),re.filesToOpenOrCreate=[],re.filesToDiff=[]),re&&F.waitMarkerFileURI&&(re.filesToWait={paths:(0,T.$Gb)([...re.filesToDiff,re.filesToMerge[3],...re.filesToOpenOrCreate]),waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(Q.push(...this.N.getUntitledWorkspaces()),_.push(...Q),q.push(...this.J.getEmptyWindowBackups())):q.length=0;const{windows:we,filesOpenedInWindow:De}=await this.Y(F,_,z,q,de,re,N);if(this.z.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${_.length}, foldersToOpen: ${z.length}, emptyToRestore: ${q.length}, emptyToOpen: ${de})`),we.length>1)if(De)De.focus();else{const Re=this.r.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let $e=!0,ee=!0;if(Re){const ue=we.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),$e=!1,ee=!1)}if($e)for(let ue=we.length-1;ue>=0;ue--){const fe=we[ue];if(!(fe.openedWorkspace&&Q.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&q.some(be=>fe.backupPath&&be.backupFolder===(0,f.$mc)(fe.backupPath)))){fe.focus(),ee=!1;break}}ee&&we[we.length-1].focus()}const ke=re&&re.filesToDiff.length>0,Pe=re&&re.filesToMerge.length>0;if(!we.some(Re=>Re.isExtensionDevelopmentHost)&&!ke&&!Pe&&!F.noRecentEntry){const Re=[];for(const $e of me)ce($e)&&!$e.transient?Re.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):se($e)?Re.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&Re.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(Re)}return this.X(F,we),we}X(F,N){const z=F.waitMarkerFileURI;F.context===H.OpenContext.CLI&&z&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.Q.del(z)}catch{}})()}async Y(F,N,z,_,Q,q,re){const de=[];let me;function we(ue,fe){de.push(ue),fe&&(me=ue,q=void 0)}let{openFolderInNewWindow:De,openFilesInNewWindow:ke}=this.pb(F);if(!F.initialStartup&&re.length>0){const ue=re[0].remoteAuthority,fe=this.vb(ue);fe&&we(this.ab(fe,re.map(be=>be.workspace.uri)))}const Pe=z.length+N.length+_.length;if(q&&Pe===0){const ue=q.filesToOpenOrCreate[0]||q.filesToDiff[0]||q.filesToMerge[3],fe=this.getWindows().filter(Ae=>q&&(0,$.$ih)(Ae.remoteAuthority,q.remoteAuthority));let be;ue?.fileUri&&!ke&&((F.context===H.OpenContext.DESKTOP||F.context===H.OpenContext.CLI||F.context===H.OpenContext.DOCK)&&(be=await(0,Y.$hfc)(fe,ue.fileUri,async Ae=>Ae.configPath.scheme===w.Schemas.file?this.N.resolveLocalWorkspace(Ae.configPath):void 0)),be||(be=this.wb(fe))),be?(0,U.$Ri)(be.openedWorkspace)?N.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,U.$Mi)(be.openedWorkspace)?z.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):we(this.Z(F,be,q),!0):we(await this.qb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:q,forceNewWindow:!0,remoteAuthority:q.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile}),!0)}const Re=(0,T.$Lb)(N,ue=>ue.workspace.id);if(Re.length>0){const ue=(0,T.$Gb)(Re.map(fe=>(0,Y.$ifc)(this.getWindows(),fe.workspace.configPath)));if(ue.length>0){const fe=ue[0],be=(0,$.$ih)(q?.remoteAuthority,fe.remoteAuthority)?q:void 0;we(this.Z(F,fe,be),!!be),De=!0}for(const fe of Re){if(ue.some(Ne=>Ne.openedWorkspace&&Ne.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,Ae=(0,$.$ih)(q?.remoteAuthority,be)?q:void 0;we(await this.cb(F,fe,De,Ae),!!Ae),De=!0}}const $e=(0,T.$Lb)(z,ue=>$.$7g.getComparisonKey(ue.workspace.uri));if($e.length>0){const ue=(0,T.$Gb)($e.map(fe=>(0,Y.$ifc)(this.getWindows(),fe.workspace.uri)));if(ue.length>0){const fe=ue[0],be=(0,$.$ih)(q?.remoteAuthority,fe.remoteAuthority)?q:void 0;we(this.Z(F,fe,be),!!be),De=!0}for(const fe of $e){if(ue.some(Ne=>(0,U.$Mi)(Ne.openedWorkspace)&&$.$7g.isEqual(Ne.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,Ae=(0,$.$ih)(q?.remoteAuthority,be)?q:void 0;we(await this.cb(F,fe,De,Ae),!!Ae),De=!0}}const ee=(0,T.$Lb)(_,ue=>ue.backupFolder);if(ee.length>0)for(const ue of ee){const fe=ue.remoteAuthority,be=(0,$.$ih)(q?.remoteAuthority,fe)?q:void 0;we(await this.bb(F,!0,fe,be,ue),!!be),De=!0}if(de.length===0||q){q&&!Q&&Q++;const ue=q?q.remoteAuthority:F.remoteAuthority;for(let fe=0;fe<Q;fe++)we(await this.bb(F,De,ue,q),!!q),De=!0}return{windows:(0,T.$Lb)(de),filesOpenedInWindow:me}}Z(F,N,z){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:z}),this.$(N);const _={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToMerge:z?.filesToMerge,filesToWait:z?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",I.CancellationToken.None,_),N}$(F){let N=F;const z=r.BrowserWindow.getFocusedWindow();if(z&&z.id!==F.id){const _=this.U.getWindowByWebContents(z.webContents);_&&_.parentId===F.id&&(N=_)}N.focus()}ab(F,N){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),F.focus();const z={foldersToAdd:N};return F.sendWhenReady("vscode:addFolders",I.CancellationToken.None,z),F}bb(F,N,z,_,Q){this.z.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:z,filesToOpen:_,forceNewWindow:N});let q;return!N&&typeof F.contextWindowId=="number"&&(q=this.getWindowById(F.contextWindowId)),this.qb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:z,forceNewWindow:N,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:_,windowToUse:q,emptyWindowBackupInfo:Q,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}cb(F,N,z,_,Q){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:_}),!z&&!Q&&typeof F.contextWindowId=="number"&&(Q=this.getWindowById(F.contextWindowId)),this.qb({workspace:N.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:_,windowToUse:Q,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}async db(F){let N,z=!1,_=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(N=await this.eb(F),z=!0):F.forceEmpty?N=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(N=await this.fb(F.cli),N.length===0&&N.push(Object.create(null)),z=!0):(N=await this.hb(),N.length===0&&N.push(Object.create(null)),_=!0),!F.addMode&&z){const Q=N.filter(q=>se(q));if(Q.length>1){const q=Q[0].remoteAuthority;if(Q.every(re=>(0,$.$ih)(re.remoteAuthority,q))){const re=await this.N.createUntitledWorkspace(Q.map(de=>({uri:de.workspace.uri})));N.push({workspace:re,remoteAuthority:q}),N=N.filter(de=>!se(de))}}}if(F.initialStartup&&!_&&this.L.getValue("window")?.restoreWindows==="preserve"){const Q=await this.hb();N.unshift(...Q.filter(q=>ce(q)||se(q)||q.backupPath))}return N}async eb(F){const N={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority},z=await Promise.all((0,T.$Gb)(F.urisToOpen||[]).map(async _=>{const Q=await this.jb(_,N);if(Q)return Q.label=_.label,Q;const q=this.lb(_);this.P.showMessageBox({type:"info",buttons:[(0,t.localize)(10896,null)],message:q.scheme===w.Schemas.file?(0,t.localize)(10897,null):(0,t.localize)(10898,null),detail:q.scheme===w.Schemas.file?(0,t.localize)(10899,null,(0,h.$Ww)(q,{os:v.OS,tildify:this.G})):(0,t.localize)(10900,null,q.toString(!0))},r.BrowserWindow.getFocusedWindow()??void 0)}));return(0,T.$Gb)(z)}async fb(F){const N=[],z={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:F.diff&&F._.length===2||F.merge&&F._.length===4},_=F["folder-uri"];if(_){const re=await Promise.all(_.map(de=>{const me=this.gb(de);if(me)return this.jb({folderUri:me},z)}));N.push(...(0,T.$Gb)(re))}const Q=F["file-uri"];if(Q){const re=await Promise.all(Q.map(de=>{const me=this.gb(de);if(me)return this.jb((0,U.$8i)(de)?{workspaceUri:me}:{fileUri:me},z)}));N.push(...(0,T.$Gb)(re))}const q=await Promise.all(F._.map(re=>z.remoteAuthority?this.ob(re,z):this.mb(re,z)));return N.push(...(0,T.$Gb)(q)),N}gb(F){try{const N=E.URI.parse(F);if(!N.scheme){this.z.error(`Invalid URI input string, scheme missing: ${F}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.z.error(`Invalid URI input string: ${F}, ${N.message}`)}}async hb(){const F=this.ib();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];F!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const z=await Promise.all(N.map(async _=>{if(_.workspace){const Q=await this.jb({workspaceUri:_.workspace.configPath},{remoteAuthority:_.remoteAuthority,rejectTransientWorkspaces:!0});if(ce(Q))return Q}else if(_.folderUri){const Q=await this.jb({folderUri:_.folderUri},{remoteAuthority:_.remoteAuthority});if(se(Q))return Q}else if(F!=="folders"&&_.backupPath)return{backupPath:_.backupPath,remoteAuthority:_.remoteAuthority}}));return(0,T.$Gb)(z)}}}ib(){let F;return this.I.wasRestarted?F="all":(F=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}async jb(F,N=Object.create(null)){const z=this.lb(F);return z.scheme===w.Schemas.file?((0,W.$2D)(F)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.mb(z.fsPath,N)):this.kb(F,N)}kb(F,N){let z=this.lb(F);const _=(0,A.$en)(z)||N.remoteAuthority;if(z=(0,$.$kh)((0,$.$eh)(z)),(0,W.$2D)(F)){if(N.gotoLineMode){const{path:Q,line:q,column:re}=(0,m.$Jg)(z.path);return{fileUri:z.with({path:Q}),options:{selection:q?{startLineNumber:q,startColumn:re||1}:void 0},remoteAuthority:_}}return{fileUri:z,remoteAuthority:_}}else if((0,W.$ZD)(F))return{workspace:(0,te.$lfc)(z),remoteAuthority:_};return{workspace:(0,te.$mfc)(z),remoteAuthority:_}}lb(F){return(0,W.$ZD)(F)?F.workspaceUri:(0,W.$1D)(F)?F.folderUri:F.fileUri}async mb(F,N,z){let _,Q;N.gotoLineMode&&({path:F,line:_,column:Q}=(0,m.$Jg)(F)),F=(0,m.$Dg)((0,f.$gc)(F),(0,b.cwd)());try{const q=await n.promises.stat(F);if(q.isFile()){if(!N.forceOpenWorkspaceAsFile){const re=await this.N.resolveLocalWorkspace(E.URI.file(F));if(re)return re.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:re.id,configPath:re.configPath},type:a.FileType.File,exists:!0,remoteAuthority:re.remoteAuthority,transient:re.transient}}return{fileUri:E.URI.file(F),type:a.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:Q||1}:void 0}}}else{if(q.isDirectory())return{workspace:(0,te.$mfc)(E.URI.file(F),q),type:a.FileType.Directory,exists:!0};if(!v.$j&&F==="/dev/null")return{fileUri:E.URI.file(F),type:a.FileType.File,exists:!0}}}catch(q){if(q.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!z)return this.nb(F,N);const re=E.URI.file(F);if(this.M.removeRecentlyOpened([re]),N.ignoreFileNotFound)return{fileUri:re,type:a.FileType.File,exists:!1}}}async nb(F,N){const z=E.URI.file(F),{response:_,checkboxChecked:Q}=await this.P.showMessageBox({type:"warning",buttons:[(0,t.localize)(10901,null),(0,t.localize)(10902,null),(0,t.localize)(10903,null)],message:(0,t.localize)(10904,null,z.authority),detail:(0,t.localize)(10905,null,(0,h.$Ww)(z,{os:v.OS,tildify:this.G})),checkboxLabel:(0,t.localize)(10906,null,z.authority),cancelId:1});if(_===0){if((0,k.addUNCHostToAllowlist)(z.authority),Q){const q={channel:"vscode:configureAllowedUNCHost",args:z.authority};this.sendToFocused(q.channel,q.args),this.sendToOpeningWindow(q.channel,q.args)}return this.mb(F,N,!0)}if(_===2)return r.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(F,N)}ob(F,N){const z=F.charCodeAt(0),_=N.remoteAuthority;let Q,q;N.gotoLineMode&&({path:F,line:Q,column:q}=(0,m.$Jg)(F)),z!==p.CharCode.Slash&&((0,m.$Cg)(z)&&F.charCodeAt(F.charCodeAt(1))===p.CharCode.Colon&&(F=(0,m.$vg)(F)),F=`/${F}`);const re=E.URI.from({scheme:w.Schemas.vscodeRemote,authority:_,path:F});if(F.charCodeAt(F.length-1)!==p.CharCode.Slash){if((0,U.$8i)(F))return N.forceOpenWorkspaceAsFile?{fileUri:re,options:{selection:Q?{startLineNumber:Q,startColumn:q||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,te.$lfc)(re),remoteAuthority:_};if(N.gotoLineMode||f.$fc.basename(F).indexOf(".")!==-1)return{fileUri:re,options:{selection:Q?{startLineNumber:Q,startColumn:q||1}:void 0},remoteAuthority:_}}return{workspace:(0,te.$mfc)(re),remoteAuthority:_}}pb(F){const N=this.L.getValue("window"),z=N?.openFoldersInNewWindow||"default",_=N?.openFilesInNewWindow||"off";let Q=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(z==="on"||z==="off")&&(Q=z==="on");let q=!1;return F.forceNewWindow||F.forceReuseWindow?q=!!F.forceNewWindow&&!F.forceReuseWindow:(v.$k?F.context===H.OpenContext.DOCK&&(q=!0):F.context!==H.OpenContext.DIALOG&&F.context!==H.OpenContext.MENU&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(q=!0),!F.cli.extensionDevelopmentPath&&(_==="on"||_==="off")&&(q=_==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:q}}async openExtensionDevelopmentHostWindow(F,N){const z=(0,Y.$jfc)(this.getWindows(),F);if(z)return this.I.reload(z,N.cli),z.focus(),[z];let _=N.cli["folder-uri"]||[],Q=N.cli["file-uri"]||[],q=N.cli._;if(!q.length&&!_.length&&!Q.length&&!N.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(E.URI.isUri(we)?we.scheme===w.Schemas.file?q=[we.fsPath]:_=[we.toString()]:we.configPath.scheme===w.Schemas.file?q=[(0,$.$4g)(we.configPath)]:Q=[we.configPath.toString()])}let re=N.remoteAuthority;for(const me of F)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=E.URI.parse(me),De=(0,A.$en)(we);De&&(re?(0,$.$ih)(De,re)||this.z.error("more than one extension development path authority"):re=De)}q=q.filter(me=>{const we=E.URI.file(me);return(0,Y.$ifc)(this.getWindows(),we)?!1:(0,$.$ih)((0,A.$en)(we),re)}),_=_.filter(me=>{const we=this.gb(me);return we&&(0,Y.$ifc)(this.getWindows(),we)?!1:we?(0,$.$ih)((0,A.$en)(we),re):!1}),Q=Q.filter(me=>{const we=this.gb(me);return we&&(0,Y.$ifc)(this.getWindows(),we)?!1:we?(0,$.$ih)((0,A.$en)(we),re):!1}),N.cli._=q,N.cli["folder-uri"]=_,N.cli["file-uri"]=Q;const de={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!q.length&&!_.length&&!Q.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:re,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(de)}async qb(F){const N=this.L.getValue("window"),z=this.getLastActiveWindow(),Q=(N?.newWindowProfile?this.H.profiles.find(de=>de.name===N.newWindowProfile):void 0)??z?.profile??this.H.defaultProfile;let q;!F.forceNewWindow&&!F.forceNewTabbedWindow&&(q=F.windowToUse||z,q&&q.focus());const re={...this.G.args,...F.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,f.$ic)(this.G.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:Q},homeDir:this.G.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.w,...F.userEnv},nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToMerge:F.filesToOpen?.filesToMerge,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:w.Schemas.file}).fsPath,product:D.default,isInitialStartup:F.initialStartup,perfMarks:(0,g.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:r.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(q){const de=q.config;!re.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(re.extensionDevelopmentPath=de.extensionDevelopmentPath,re.extensionDevelopmentKind=de.extensionDevelopmentKind,re["enable-proposed-api"]=de["enable-proposed-api"],re.verbose=de.verbose,re["inspect-extensions"]=de["inspect-extensions"],re["inspect-brk-extensions"]=de["inspect-brk-extensions"],re.debugId=de.debugId,re.extensionEnvironment=de.extensionEnvironment,re["extensions-dir"]=de["extensions-dir"],re["disable-extensions"]=de["disable-extensions"]),re.loggers={global:re.loggers.global,window:de?.loggers.window??re.loggers.window}}else{const de=this.r.getNewWindowState(re);(0,g.mark)("code/willCreateCodeWindow");const me=q=this.O.createInstance(V.$tfc,{state:de,extensionDevelopmentPath:re.extensionDevelopmentPath,isExtensionTestHost:!!re.extensionTestsPath});(0,g.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new d.$Sc;we.add(me.onDidSignalReady(()=>this.b.fire(me))),we.add(c.Event.once(me.onDidClose)(()=>this.tb(me,we))),we.add(c.Event.once(me.onDidDestroy)(()=>this.ub(me))),we.add(me.onDidMaximize(()=>this.g.fire(me))),we.add(me.onDidUnmaximize(()=>this.h.fire(me))),we.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:ke,y:Pe})=>this.m.fire({window:me,x:ke,y:Pe})));const De=(0,P.$ng)(me.win?.webContents);De.removeAllListeners("devtools-reload-page"),we.add(c.Event.fromNodeEventEmitter(De,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return re.windowId=q.id,q.isReady?this.I.unload(q,B.UnloadReason.LOAD).then(async de=>{de||await this.rb(q,re,F,Q)}):await this.rb(q,re,F,Q),q}async rb(F,N,z,_){if(N.extensionDevelopmentPath||((0,U.$Ri)(N.workspace)?N.backupPath=this.J.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,U.$Mi)(N.workspace)?N.backupPath=this.J.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.J.registerEmptyWindowBackup({backupFolder:z.emptyWindowBackupInfo?.backupFolder??(0,te.$nfc)().id,remoteAuthority:N.remoteAuthority})),this.H.isEnabled()){const Q=N.workspace??(0,U.$Qi)(N.backupPath,!1),q=this.sb(z,Q,_),re=q instanceof Promise?await q:q;N.profiles.profile=re,N.extensionDevelopmentPath||await this.H.setProfileForWorkspace(Q,re)}F.load(N)}sb(F,N,z){return F.forceProfile?this.H.profiles.find(_=>_.name===F.forceProfile)??this.H.createNamedProfile(F.forceProfile):F.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(N)??z}tb(F,N){this.n.delete(F.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}ub(F){this.n.delete(F.id),this.c.fire(F)}getFocusedWindow(){const F=r.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(F){return this.wb(this.getWindows().filter(N=>(0,$.$ih)(N.remoteAuthority,F)))}wb(F){return(0,H.$efc)(F)}sendToFocused(F,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(F,I.CancellationToken.None,...N)}sendToOpeningWindow(F,...N){this.B(c.Event.once(this.onDidSignalReadyWindow)(z=>{z.sendWhenReady(F,I.CancellationToken.None,...N)}))}sendToAll(F,N,z){for(const _ of this.getWindows())z&&z.indexOf(_.id)>=0||_.sendWhenReady(F,I.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(F){return this.n.get(F)}getWindowByWebContents(F){const N=r.BrowserWindow.fromWebContents(F);if(!N)return;const z=this.getWindowById(N.id);return z?.matches(F)?z:void 0}};e.$Ggc=ie,e.$Ggc=ie=Ee([oe(4,y.$0j),oe(5,ae.$qfc),oe(6,O.$nR),oe(7,C.$qo),oe(8,s.$2ec),oe(9,X.$ffc),oe(10,S.$vfc),oe(11,u.$9ec),oe(12,i.$9i),oe(13,x.$cgc),oe(14,J.$ofc),oe(15,l.$Bi),oe(16,o.$0ec),oe(17,a.$0k),oe(18,L.$_ec),oe(19,j.$afc),oe(20,K.$1fc)],ie)}),define(le[278],he([0,1,69,29,88,59]),function(G,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;let T=class{constructor(p,c,m,h){this.a=p,this.b=c,this.c=m,this.d=h,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(p,c){const m=this.b.getWindowById(p);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),c)}createUntitledWorkspace(p,c,m){return this.a.createUntitledWorkspace(c,m)}deleteUntitledWorkspace(p,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(p,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(p){return this.c.getRecentlyOpened()}addRecentlyOpened(p,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(p,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(p){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$Igc=T,e.$Igc=T=Ee([oe(0,R.$ofc),oe(1,r.$cfc),oe(2,k.$cgc),oe(3,n.$9ec)],T)}),define(le[279],he([0,1,13,106,35,27,17,54,15,4,283,47,2,11,9,3,12,7,33,158,44,159,118,135,10,69,253,16,260,96,136,52,97,187,20,68,100,175,263,177,178,179,14,191,99,83,6,98,186,269,270,254,261,19,5,276,64,28,74,264,101,34,243,87,128,24,220,221,57,49,233,258,271,259,272,132,235,236,237,240,267,50,29,277,242,30,102,88,278,59,40,200,58,213,56,86,133,245,262,250,8,223,244,195,71,266,239,21,75,265,231,206,65,84,274,78]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t,u,i,o,s,a,l,S,y,D,L,A,O,W,V,H,Y,Z,U,te,x,J,B,j,C,X,ae,K,ce,se,ie,M,F,N,z,_,Q,q,re,de,me,we,De,ke,Pe,Re,$e,ee,ue,fe,be,Ae,Ne,Me,Oe,Be,Ke,Ze,qe,Qe,Je,Xe,Ce,ne,ge,pe,ye,We,Ue,_e,lt,rt,at,tt,ut,ct,ft,gt,Ot,mt,$t,Tt,Lt,jt,pt,Wt,Et,dt,Mt,Ft,wt,Ct,St,Nt,kt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;let yt=class extends d.$Tc{static{bt=this}static{this.a={[w.Schemas.file]:"security.promptForLocalFileProtocolHandling",[w.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Te,Le,je,ve,Se,He,Ve,Ye,Fe,xe,ze,et){super(),this.g=Te,this.h=Le,this.j=je,this.m=ve,this.n=Se,this.s=He,this.t=Ve,this.u=Ye,this.w=Fe,this.y=xe,this.z=ze,this.C=et,this.D(),this.F()}D(){const Te=Fe=>Fe?.startsWith(`${w.Schemas.vscodeWebview}://`),Le=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Fe,xe,ze,et)=>Te(et.requestingUrl)?ze(Le.has(xe)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Fe,xe,ze,et)=>Te(et.requestingUrl)?Le.has(xe):!1);const je=new Set([w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemoteResource,w.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Fe=>{for(let xe=Fe;xe;xe=xe.parent)if(xe.url.startsWith(`${w.Schemas.vscodeWebview}://`))return!0;return!1},Se=Fe=>Fe.resourceType==="xhr"||ve(Fe.frame),He=Fe=>{const xe=Fe.frame;if(!xe||!this.b)return!1;const ze=n.BrowserWindow.getAllWindows();for(const et of ze)if(xe.processId===et.webContents.mainFrame.processId)return!0;return!1},Ve=(Fe,xe)=>{if(Fe.path!=="/index.html")return!0;const ze=xe.frame;if(!ze||!this.b)return!1;for(const et of this.b.getWindows())if(et.win&&ze.processId===et.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Fe,xe)=>{const ze=b.URI.parse(Fe.url);return ze.scheme===w.Schemas.vscodeWebview&&!Ve(ze,Fe)?(this.m.error("Blocked vscode-webview request",Fe.url),xe({cancel:!0})):ze.scheme===w.Schemas.vscodeFileResource&&!He(Fe)?(this.m.error("Blocked vscode-file request",Fe.url),xe({cancel:!0})):ze.path.endsWith(".svg")&&!je.has(ze.scheme)?xe({cancel:!Se(Fe)}):xe({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{const ze=Fe.responseHeaders,et=ze["content-type"]||ze["Content-Type"];if(et&&Array.isArray(et)){const it=b.URI.parse(Fe.url);if(it.path.endsWith(".svg")&&je.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],xe({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(w.Schemas.vscodeRemoteResource)&&et.some(ot=>ot.toLowerCase().includes("image/svg")))return xe({cancel:!Se(Fe)})}return xe({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Fe.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],xe({cancel:!1,responseHeaders:ze})}return xe({cancel:!1})});const Ye=n.session.defaultSession;typeof Ye.setCodeCachePath=="function"&&this.s.codeCachePath&&Ye.setCodeCachePath((0,f.$ic)(this.s.codeCachePath,"chrome")),g.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,p.setUnexpectedErrorHandler)(je=>this.G(je)),process.on("uncaughtException",je=>{(0,p.$X)(je)||(0,p.$Y)(je)}),process.on("unhandledRejection",je=>(0,p.$Y)(je)),c.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,P.$HX)(),n.app.on("accessibility-support-changed",(je,ve)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",ve)}),n.app.on("activate",async(je,ve)=>{this.m.trace("app#activate"),ve||await this.b?.openEmptyWindow({context:Xe.OpenContext.DOCK})}),n.app.on("web-contents-created",(je,ve)=>{ve?.opener?.url.startsWith(`${w.Schemas.vscodeFileResource}://${w.$Vg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(ve)),ve.on("will-navigate",Se=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Se.preventDefault()}),ve.setWindowOpenHandler(Se=>Se.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Se)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Se.url}}`),this.f?.openExternal(void 0,Se.url),{action:"deny"}))});let Te=[],Le;n.app.on("open-file",(je,ve)=>{ve=(0,kt.$km)(ve),this.m.trace("app#open-file: ",ve),je.preventDefault(),Te.push((0,ge.$8i)(ve)?{workspaceUri:b.URI.file(ve)}:{fileUri:b.URI.file(ve)}),Le!==void 0&&(clearTimeout(Le),Le=void 0),Le=setTimeout(async()=>{await this.b?.open({context:Xe.OpenContext.DOCK,cli:this.s.args,urisToOpen:Te,gotoLineMode:!1,preferNewWindow:!0}),Te=[],Le=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Xe.OpenContext.DESKTOP})}),k.$GX.handle("vscode:fetchShellEnv",je=>{const ve=this.b?.getWindowByWebContents(je.sender);let Se,He;return ve?.config?(Se=ve.config,He={...process.env,...ve.config.userEnv}):(Se=this.s.args,He=process.env),this.W(Se,He,!1)}),k.$GX.on("vscode:toggleDevTools",je=>je.sender.toggleDevTools()),k.$GX.on("vscode:openDevTools",je=>je.sender.openDevTools()),k.$GX.on("vscode:reloadWindow",je=>je.sender.reload()),k.$GX.handle("vscode:notifyZoomLevel",async(je,ve)=>{const Se=this.b?.getWindowByWebContents(je.sender);Se&&Se.notifyZoomLevel(ve)})}G(Te){if(Te){const Le={message:`[uncaught exception in main]: ${Te.message}`,stack:Te.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.m.error(`[uncaught exception in main]: ${Te}`),Te.stack&&this.m.error(Te.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Te=this.z.win32AppUserModelId;g.$j&&Te&&n.app.setAppUserModelId(Te);try{g.$k&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Le=new t.$NX;c.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===F.ShutdownReason.KILL&&Le.dispose()}),this.m.trace("Resolving machine identifier...");const[je,ve,Se]=await Promise.all([(0,$t.$Rgc)(this.w,this.m),(0,$t.$Sgc)(this.w,this.m),(0,$t.$Tgc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${je}`);const{sharedProcessReady:He,sharedProcessClient:Ve}=this.O(je,ve,Se),Ye=await this.P(je,ve,Se,He);Ye.invokeFunction(ze=>ze.get(i.$Ffc)),this.B(Ye.createInstance(gt.$Mgc)),Ye.invokeFunction(ze=>this.Q(ze,Le,Ve));const Fe=await Ye.invokeFunction(ze=>this.H(ze,Le));this.I(Le),this.t.phase=F.LifecycleMainPhase.Ready,await Ye.invokeFunction(ze=>this.R(ze,Fe)),this.t.phase=F.LifecycleMainPhase.AfterWindowOpen,this.S(),this.B(new mt.$Oh(()=>{this.B((0,mt.$Sh)(()=>this.t.phase=F.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async H(Te,Le){const je=this.b=Te.get(Xe.$cfc),ve=Te.get(Oe.$vY),Se=this.f=Te.get(_.$2fc),He=Te.get(L.$0ec),Ve=this;ve.registerHandler({async handleURL(it,ot){return Ve.N(je,He,ve,it,ot)}});const Ye=this.B(new ne.$Hgc({onDidOpenMainWindow:Se.onDidOpenMainWindow,onDidFocusMainWindow:Se.onDidFocusMainWindow,getActiveWindowId:()=>Se.getActiveWindowId(-1)})),Fe=new E.$ki(it=>Ye.getActiveClientId().then(ot=>it===ot)),xe=new Be.$ygc(Fe,this.m),ze=Le.getChannel("urlHandler",xe);ve.registerHandler(new Be.$xgc(ze));const et=await this.J(je,He);return this.B(new Ze.$zgc(et?.urls,ve,je,this.s,this.z,this.m)),et}I(Te){const Le=()=>({statusCode:404,data:"Not found"}),je=new Ct.$T(()=>Te.getChannel(wt.$1gc,new wt.$2gc));n.protocol.registerBufferProtocol(w.Schemas.vscodeManagedRemoteResource,(ve,Se)=>{const He=b.URI.parse(ve.url);if(!He.authority.startsWith("window:"))return Se(Le());je.value.call(wt.$Zgc,[He]).then(Ve=>Se({...Ve,data:Buffer.from(Ve.body,"base64")}),Ve=>{this.m.warn("error dispatching remote resource call",Ve),Se({statusCode:500,data:String(Ve)})})})}async J(Te,Le){const je=this.s.args["open-url"]?this.s.args._urls||[]:[];je.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",je);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),je.length+ve.length===0)return;const Se=[...je,...ve].map(Ye=>{try{return{uri:b.URI.parse(Ye),originalUrl:Ye}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ye);return}}),He=[],Ve=[];for(const Ye of Se){if(!Ye)continue;const Fe=this.M(Ye.uri);if(Fe)if(await this.L(Fe,Te,Le)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ye.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ye.uri.toString(!0),Fe),He.push(Fe);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ye.uri.toString(!0)),Ve.push(Ye)}return{urls:Ve,openables:He}}async L(Te,Le,je){let ve,Se;if((0,Je.$ZD)(Te)?(ve=Te.workspaceUri,Se=(0,o.localize)(12803,null,ve.scheme===w.Schemas.file?(0,h.$Ww)(ve,{os:g.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(0,Je.$1D)(Te)?(ve=Te.folderUri,Se=(0,o.localize)(12804,null,ve.scheme===w.Schemas.file?(0,h.$Ww)(ve,{os:g.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(ve=Te.fileUri,Se=(0,o.localize)(12805,null,ve.scheme===w.Schemas.file?(0,h.$Ww)(ve,{os:g.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)),ve.scheme!==w.Schemas.file&&ve.scheme!==w.Schemas.vscodeRemote||this.u.getValue(bt.a[ve.scheme])===!1)return!1;const{response:Ve,checkboxChecked:Ye}=await je.showMessageBox({type:"warning",buttons:[(0,o.localize)(12806,null),(0,o.localize)(12807,null)],message:Se,detail:(0,o.localize)(12808,null),checkboxLabel:ve.scheme===w.Schemas.file?(0,o.localize)(12809,null):(0,o.localize)(12810,null),cancelId:1});if(Ve!==0)return!0;if(Ye){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===w.Schemas.file?"local":"remote"};Le.sendToFocused(Fe.channel,Fe.args),Le.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}M(Te){if(Te.path){if(Te.authority===w.Schemas.file){const Le=b.URI.file(Te.fsPath);return(0,ge.$8i)(Le)?{workspaceUri:Le}:{fileUri:Le}}else if(Te.authority===w.Schemas.vscodeRemote){const Le=Te.path.indexOf(f.$fc.sep,1);if(Le!==-1){const je=Te.path.substring(1,Le),ve=Te.path.substring(Le);let Se=Te.query;const He=new URLSearchParams(Te.query);He.get("windowId")==="_blank"&&(He.delete("windowId"),Se=He.toString());const Ve=b.URI.from({scheme:w.Schemas.vscodeRemote,authority:je,path:ve,query:Se,fragment:Te.fragment});return(0,ge.$8i)(ve)?{workspaceUri:Ve}:/:[\d]+$/.test(ve)?{fileUri:Ve}:{folderUri:Ve}}}}}async N(Te,Le,je,ve,Se){this.m.trace("app#handleProtocolUrl():",ve.toString(!0),Se),ve.scheme===this.z.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:b.URI.parse(ve.query).path,query:""}));let He=!1;const Ve=new URLSearchParams(ve.query);Ve.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Ve.delete("windowId"),ve=ve.with({query:Ve.toString()}),He=!0):g.$k&&Te.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),He=!0);const Ye=Ve.get("continueOn");Ye!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),Ve.delete("continueOn"),ve=ve.with({query:Ve.toString()}),this.s.continueOn=Ye??void 0);const Fe=this.M(ve);return Fe?await this.L(Fe,Te,Le)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,ve.toString(!0)),(0,Et.$Nb)(await Te.open({context:Xe.OpenContext.API,cli:{...this.s.args},urisToOpen:[Fe],forceNewWindow:He,gotoLineMode:!0}))?.focus(),!0):He?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,Et.$Nb)(await Te.open({context:Xe.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,q.$en)(ve)}))?.ready(),je.open(ve,Se)):(this.m.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Se),!1)}O(Te,Le,je){const ve=this.B(this.j.createInstance(re.$kgc,Te,Le,je));this.B(ve.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Se=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ve=await ve.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new u.$OX(Ve,"main")})();return{sharedProcessReady:(async()=>(await ve.whenReady(),Se))(),sharedProcessClient:Se}}async P(Te,Le,je,ve){const Se=new ae.$Ai;switch(process.platform){case"win32":Se.set(ue.$FY,new C.$zi(Me.$vgc));break;case"linux":g.$m?Se.set(ue.$FY,new C.$zi(Ne.$ugc,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(ue.$FY,new C.$zi(Ae.$tgc));break;case"darwin":Se.set(ue.$FY,new C.$zi(be.$sgc));break}Se.set(Xe.$cfc,new C.$zi(Ce.$Ggc,[Te,Le,je,this.h],!1)),Se.set(St.$1fc,new C.$zi(Nt.$3gc,void 0,!1));const He=new L.$$ec(this.m,this.z);Se.set(L.$0ec,He),Se.set(M.$9fc,new C.$zi(M.$0fc,void 0,!1)),Se.set(D.$Mfc,new C.$zi(D.$Nfc,void 0,!1)),Se.set(y.$Qm,E.ProxyChannel.toService((0,E.$ii)(ve.then(ze=>ze.getChannel("diagnostics"))))),Se.set(K.$z_b,new C.$zi(ce.$4fc,[this.h])),Se.set(K.$A_b,new C.$zi(se.$5fc,[this.h])),Se.set(A.$pY,new C.$zi(O.$Ofc)),Se.set(ie.$6fc,new C.$zi(ie.$7fc)),Se.set(_.$2fc,new C.$zi(_.$3fc,void 0,!1)),Se.set(qe.$Agc,new C.$zi(Qe.$Cgc)),Se.set(z.$fgc,new C.$zi(z.$ggc)),Se.set(Y.$Pfc,new C.$zi(Z.$Rfc)),Se.set(De.$Bfc,new C.$zi(De.$Cfc)),Se.set(De.$Dfc,new C.$zi(De.$Efc));const Ve=new Mt.$Ygc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ye=new Ft.$Ns(Ve,this.u,this.m,this.n);Se.set(dt.$os,Ye),g.$j?Se.set(U.$Sfc,new C.$zi(te.$Tfc)):g.$k?Se.set(U.$Sfc,new C.$zi(te.$Ufc)):g.$l&&Se.set(U.$Sfc,new C.$zi(te.$Vfc));const Fe=new a.$Hfc(this.s,this.u,this.m,this.w);Se.set(s.$9ec,Fe);const xe=new Ue.$pfc(this.s,this.m,this.C,Fe,He);if(Se.set(Ue.$ofc,xe),Se.set(pe.$Yhb,new C.$zi(We.$Igc,void 0,!1)),Se.set(ye.$cgc,new C.$zi(ye.$dgc,void 0,!1)),Se.set(Oe.$vY,new C.$zi(Ke.$xY,void 0,!1)),(0,ee.$Bp)(this.z,this.s)){const ze=(0,ee.$Gp)(this.z,this.u),et=(0,E.$ii)(ve.then(vt=>vt.getChannel("telemetryAppender"))),it=new Re.$ngc(et),ot=(0,ke.$sp)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,Te,Le,je,ze),nt=(0,ee.$Hp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Se.set(Pe.$9l,new C.$zi($e.$es,[ht],!1))}else Se.set(Pe.$9l,ee.$wp);return Se.set(ut.$Gq,new C.$zi(Tt.$uR,void 0,!0)),Se.set(ct.$Kq,new C.$zi(ft.$Lgc,void 0,!0)),Se.set(pt.$Wgc,new C.$zi(pt.$Xgc,void 0,!0)),Se.set(i.$Ffc,new C.$zi(i.$Gfc)),await mt.Promises.settled([Fe.initialize(),xe.initialize()]),this.j.createChild(Se)}Q(Te,Le,je){const ve=this.B(new d.$Sc),Se=E.ProxyChannel.fromService(Te.get(M.$9fc),ve,{disableMarshalling:!0});this.g.registerChannel("launch",Se);const He=E.ProxyChannel.fromService(Te.get(D.$Mfc),ve,{disableMarshalling:!0});this.g.registerChannel("diagnostics",He);const Ve=ve.add(new lt.$Jgc(Te.get(_e.$qo)));Le.registerChannel("policy",Ve),je.then(st=>st.registerChannel("policy",Ve));const Ye=this.y.getProvider(w.Schemas.file);(0,v.$mg)(Ye instanceof j.$qr);const Fe=ve.add(new B.$Wfc(Ye,this.m,this.s));Le.registerChannel(x.$dR,Fe),je.then(st=>st.registerChannel(x.$dR,Fe));const xe=E.ProxyChannel.fromService(Te.get(rt.$ffc),ve);Le.registerChannel("userDataProfiles",xe),je.then(st=>st.registerChannel("userDataProfiles",xe));const ze=new at.$_r(Te.get(tt.$5p));je.then(st=>st.registerChannel("request",ze));const et=new fe.$ogc(Te.get(ue.$FY));Le.registerChannel("update",et);const it=E.ProxyChannel.fromService(Te.get(K.$z_b),ve);Le.registerChannel("issue",it);const ot=E.ProxyChannel.fromService(Te.get(K.$A_b),ve);Le.registerChannel("process",ot);const nt=E.ProxyChannel.fromService(Te.get(A.$pY),ve);Le.registerChannel("encryption",nt);const ht=E.ProxyChannel.fromService(Te.get(de.$Wl),ve);Le.registerChannel("sign",ht);const vt=E.ProxyChannel.fromService(Te.get(ie.$6fc),ve);Le.registerChannel("keyboardLayout",vt),this.f=Te.get(_.$2fc);const Pt=E.ProxyChannel.fromService(this.f,ve);Le.registerChannel("nativeHost",Pt),je.then(st=>st.registerChannel("nativeHost",Pt));const Bt=E.ProxyChannel.fromService(Te.get(pe.$Yhb),ve);Le.registerChannel("workspaces",Bt);const Ut=E.ProxyChannel.fromService(Te.get(z.$fgc),ve);Le.registerChannel("menubar",Ut);const zt=E.ProxyChannel.fromService(Te.get(Oe.$vY),ve);Le.registerChannel("url",zt);const qt=E.ProxyChannel.fromService(Te.get(qe.$Agc),ve);Le.registerChannel("webview",qt);const It=ve.add(new we.$lgc(this.m,Te.get(De.$Bfc)));Le.registerChannel("storage",It),je.then(st=>st.registerChannel("storage",It));const Ht=ve.add(new Ot.$Ngc(Te.get(De.$Bfc),Te.get(rt.$ffc),this.m));je.then(st=>st.registerChannel("profileStorageListener",Ht));const xt=E.ProxyChannel.fromService(Te.get(dt.$os),ve);Le.registerChannel(dt.TerminalIpcChannels.LocalPty,xt);const Vt=E.ProxyChannel.fromService(Te.get(U.$Sfc),ve);Le.registerChannel("externalTerminal",Vt);const Dt=new Lt.$Ugc(Te.get(jt.$qfc));Le.registerChannel("logger",Dt),je.then(st=>st.registerChannel("logger",Dt));const Gt=new S.$Ifc(Te.get(Xe.$cfc));Le.registerChannel("extensionhostdebugservice",Gt);const Kt=E.ProxyChannel.fromService(Te.get(Y.$Pfc),ve);Le.registerChannel(Y.$Qfc,Kt);const Yt=E.ProxyChannel.fromService(Te.get(pt.$Wgc),ve);Le.registerChannel(Wt.$Vgc,Yt)}async R(Te,Le){const je=this.b=Te.get(Xe.$cfc);this.c=Te.get(St.$1fc);const ve=(0,V.$Hm)(process.env)?Xe.OpenContext.CLI:Xe.OpenContext.DESKTOP,Se=this.s.args;if(Le){if(Le.openables.length>0)return je.open({context:ve,cli:Se,urisToOpen:Le.openables,gotoLineMode:!0,initialStartup:!0});if(Le.urls.length>0)for(const nt of Le.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),je.open({context:ve,cli:Se,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const He=global.macOpenFiles,Ve=Se._.length,Ye=!!Se["folder-uri"],Fe=!!Se["file-uri"],xe=Se["skip-add-to-recently-opened"]===!0,ze=Se.wait&&Se.waitMarkerFilePath?b.URI.file(Se.waitMarkerFilePath):void 0,et=Se.remote||void 0,it=Se.profile,ot=Se["profile-temp"];if(!Ve&&!Ye&&!Fe){if(Se["new-window"]||it||ot)return je.open({context:ve,cli:Se,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:xe,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot});if(He.length)return je.open({context:Xe.OpenContext.DOCK,cli:Se,urisToOpen:He.map(nt=>(nt=(0,kt.$km)(nt),(0,ge.$8i)(nt)?{workspaceUri:b.URI.file(nt)}:{fileUri:b.URI.file(nt)})),noRecentEntry:xe,waitMarkerFileURI:ze,initialStartup:!0})}return je.open({context:ve,cli:Se,forceNewWindow:Se["new-window"],diffMode:Se.diff,mergeMode:Se.merge,noRecentEntry:xe,waitMarkerFileURI:ze,gotoLineMode:Se.goto,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot})}S(){this.U(),n.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Te,Le)=>{Le({url:Te.url.replace(/^vscode-remote-resource:/,"http:"),method:Te.method})}),this.W(this.s.args,process.env,!0),this.X(),g.$k&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Te=this.z.win32MutexName;if(g.$j&&Te)try{const Le=await new Promise((ve,Se)=>{G(["@vscode/windows-mutex"],ve,Se)}).then(Ie),je=new Le.Mutex(Te);c.Event.once(this.t.onWillShutdown)(()=>je.release())}catch(Le){this.m.error(Le)}}async W(Te,Le,je){try{return await(0,H.$Om)(this.u,this.m,Te,Le)}catch(ve){const Se=(0,I.$nj)(ve);je?this.b?.sendToFocused("vscode:showResolveShellEnvError",Se):this.m.error(Se)}return{}}async X(){try{const Le=(await this.y.readFile(this.s.argvResource)).value.toString(),je=(0,m.parse)(Le),Se=(0,ee.$Dp)(this.u)>=Pe.TelemetryLevel.CRASH;if(je["enable-crash-reporter"]===void 0){const He=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Se},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$Yg)()}"`,"}"],Ve=Le.substring(0,Le.length-2).concat(`,
`,He.join(`
`));await this.y.writeFile(this.s.argvResource,T.$Le.fromString(Ve))}else{const He=Le.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Se},`);He!==Le&&await this.y.writeFile(this.s.argvResource,T.$Le.fromString(He))}}catch(Te){this.m.error(Te),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$4gc=yt,e.$4gc=yt=bt=Ee([oe(2,X.$Bi),oe(3,N.$0j),oe(4,N.$$j),oe(5,W.$2ec),oe(6,F.$vfc),oe(7,l.$9i),oe(8,me.$nR),oe(9,J.$0k),oe(10,Q.$qk),oe(11,rt.$ffc)],yt)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[284],he([0,1,13,26,7,21,8,54,15,32,4,47,11,9,70,3,36,25,23,44,104,279,10,16,205,219,20,68,170,14,189,99,83,185,98,19,192,5,72,28,73,246,131,257,56,256,101,218,34,57,76,58,40,201,199,2,41,234,71,194,123,127,238,106,232]),function(G,e,n,r,k,R,T,I,p,c,m,h,d,w,f,g,v,b,$,P,E,t,u,i,o,s,a,l,S,y,D,L,A,O,W,V,H,Y,Z,U,te,x,J,B,j,C,X,ae,K,ce,se,ie,M,F,N,z,_,Q,q,re,de,me,we,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),Z=Ge(Z);class ke{main(){try{this.a()}catch($e){console.error($e.message),n.app.exit(1)}}async a(){(0,p.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[$e,ee,ue,fe,be,Ae,Ne,Me]=this.b();try{try{await this.d(ue,Me,fe,be,Ne)}catch(Oe){throw this.g(ue,Ne,Oe),Oe}await $e.invokeFunction(async Oe=>{const Be=Oe.get(Y.$0j),Ke=Oe.get(V.$vfc),Ze=Oe.get(y.$0k),qe=Oe.get(Y.$$j),Qe=await this.f(Be,ue,Ke,$e,Ne,!0);return $.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Je=>{Be.warn(`app#startup(): Error writing main lockfile: ${Je.stack}`)}),Ae.logger=qe.createLogger("main",{name:(0,u.localize)(12794,null)}),m.Event.once(Ke.onWillShutdown)(Je=>{Ze.dispose(),fe.dispose(),Je.join("instanceLockfile",r.promises.unlink(ue.mainLockfile).catch(()=>{}))}),$e.createInstance(t.$4gc,Qe,ee).startup()})}catch(Oe){$e.invokeFunction(this.j,Oe)}}b(){const $e=new W.$Ai,ee=new z.$Sc;process.once("exit",()=>ee.dispose());const ue={_serviceBrand:void 0,...Z.default};$e.set(U.$qk,ue);const fe=new a.$3ec(this.k(),ue),be=this.c(fe);$e.set(a.$2ec,fe);const Ae=new q.$rfc((0,Y.$lk)(fe),fe.logsHome);$e.set(q.$qfc,Ae);const Ne=new H.$Ccc(Ae.getLogLevel()),Me=ee.add(new re.$vR(Ne,[new Y.$ek(Ae.getLogLevel())]));$e.set(Y.$0j,Me);const Oe=new D.$Zq(Me);$e.set(y.$0k,Oe);const Be=new L.$qr(Me);Oe.registerProvider(d.Schemas.file,Be);const Ke=new Q.$Rs(Oe);$e.set(_.$Hl,Ke);const Ze=new me.$qR(me.SaveStrategy.DELAYED,fe,Me,Oe);$e.set(K.$mR,Ze),$e.set(K.$nR,Ze);const qe=new ie.$gfc(Ze,Ke,fe,Oe,Me);$e.set(ie.$ffc,qe),Oe.registerProvider(d.Schemas.vscodeUserData,new we.$chc(d.Schemas.file,Be,d.Schemas.vscodeUserData,qe,Ke,Me));const Qe=g.$j&&ue.win32RegValueName?ee.add(new F.$ahc(Me,ue.win32RegValueName)):fe.policyFile?ee.add(new N.$bhc(fe.policyFile,Oe,Me)):new M.$so;$e.set(M.$qo,Qe);const Je=new o.$Uo(qe.defaultProfile.settingsResource,Oe,Qe,Me);return $e.set(i.$9i,Je),$e.set(V.$vfc,new A.$zi(V.$wfc,void 0,!1)),$e.set(j.$5p,new A.$zi(C.$$gc,void 0,!0)),$e.set(se.$afc,new A.$zi(se.$bfc)),$e.set(X.$Wl,new A.$zi(ae.$_gc,void 0,!1)),$e.set(J.$Bw,new A.$zi(B.$9gc)),$e.set(te.$_ec,new x.$6gc(fe,qe,Me)),[new O.$tr($e,!0),be,fe,Je,Ze,Ne,ue,qe]}c($e){const ee={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const fe=process.env[ue];typeof fe=="string"&&(ee[ue]=fe)}),Object.assign(process.env,ee),ee}async d($e,ee,ue,fe,be){await T.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:d.Schemas.file}).fsPath,ee.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:d.Schemas.file}).fsPath,$e.backupHome].map(Ae=>Ae?r.promises.mkdir(Ae,{recursive:!0}):void 0)),fe.init(),ue.initialize()]),ee.init()}e($e){if(g.$j){const ee=(0,De.getUNCHost)($e);ee&&(0,De.addUNCHostToAllowlist)(ee)}return $e}async f($e,ee,ue,fe,be,Ae){let Ne;try{(0,f.mark)("code/willStartMainServer"),Ne=await(0,E.$xi)(ee.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),m.Event.once(ue.onWillShutdown)(()=>Ne.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(ee,be,Me),Me;let Oe;try{Oe=await(0,E.$yi)(ee.mainIPCHandle,"main")}catch(qe){if(!Ae||g.$j||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,u.localize)(12795,null,be.nameShort),(0,u.localize)(12796,null),be),qe;try{(0,r.unlinkSync)(ee.mainIPCHandle)}catch(Qe){throw $e.warn("Could not delete obsolete instance handle",Qe),Qe}return this.f($e,ee,ue,fe,be,!1)}if(ee.extensionTestsLocationURI&&!ee.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(qe),Oe.dispose(),new Error(qe)}let Be;!ee.args.wait&&!ee.args.status&&(Be=setTimeout(()=>{this.h((0,u.localize)(12797,null,be.nameShort),(0,u.localize)(12798,null),be)},1e4));const Ke=P.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Ze=P.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(ee.args.status)return fe.invokeFunction(async()=>{const qe=new s.$Ys(ce.$wp,be),Qe=await Ze.getMainDiagnostics(),Je=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Xe=await qe.getDiagnostics(Qe,Je);throw console.log(Xe),new p.$_});throw g.$j&&await this.i(Ke,$e),$e.trace("Sending env to running instance..."),await Ke.start(ee.args,process.env),Oe.dispose(),Be&&clearTimeout(Be),new p.$_("Sent env to running instance. Terminating...")}if(ee.args.status)throw console.log((0,u.localize)(12799,null,be.nameShort)),new p.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ne}g($e,ee,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const fe=(0,R.$Gb)([$e.userDataPath,$e.extensionsPath,E.$ti]).map(be=>(0,h.$Ww)(k.URI.file(be),{os:g.OS,tildify:$e}));this.h((0,u.localize)(12800,null),(0,u.localize)(12801,null,(0,I.$nj)(ue),fe.join(`
`)),ee)}}h($e,ee,ue){n.dialog.showMessageBoxSync((0,de.$$w)({type:"warning",buttons:[(0,u.localize)(12802,null)],message:$e,detail:ee},ue).options)}async i($e,ee){if(g.$j){const ue=await $e.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((fe,be)=>{G(["windows-foreground-love"],fe,be)}).then(Ie)).allowSetForegroundWindow(ue)}catch(fe){ee.error(fe)}}}j($e,ee){const ue=$e.get(Y.$0j),fe=$e.get(V.$vfc);let be=0;ee&&(ee.isExpected?ee.message&&ue.trace(ee.message):(be=1,ee.stack?ue.error(ee.stack):ue.error(`Startup error: ${ee.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,l.$Em)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const ee=(0,S.$5gc)($e.verbose);ee&&((0,l.$Gm)(process.argv,"--waitMarkerFilePath",ee),$e.waitMarkerFilePath=ee)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const ee=this.m($e._,$e.goto);$e._=ee}return $e}m($e,ee){const ue=(0,v.cwd)(),fe=$e.map(Ne=>{let Me=String(Ne),Oe;ee&&(Oe=(0,c.$Jg)(Me),Me=Oe.path),Me&&(Me=this.n(ue,Me));const Be=(0,c.$Dg)(Me,ue),Ke=(0,w.$mc)(Be);return Ke&&!(0,c.$zg)(Ke)?null:ee&&Oe?(Oe.path=Be,this.o(Oe)):Be}),be=g.$j||g.$k,Ae=(0,R.$Lb)(fe,Ne=>Ne&&be?Ne.toLowerCase():Ne||"");return(0,R.$Gb)(Ae)}n($e,ee){return g.$j&&(ee=(0,b.$lf)(ee,'"')),ee=(0,b.$jf)((0,b.$jf)(ee," "),"	"),g.$j&&(ee=(0,w.$jc)($e,ee),ee=(0,b.$lf)(ee,".")),ee}o($e){const ee=[$e.path];return typeof $e.line=="number"&&ee.push(String($e.line)),typeof $e.column=="number"&&ee.push(String($e.column)),ee.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/a35380d6f0ff65f7c35345baafcf1c3f8a378d38/core/vs/code/electron-main/main.js.map
