/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/map","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","vs/base/common/marshalling","net","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/jsonSchema","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/node/processes","vs/base/node/ps","vs/base/parts/sandbox/node/electronTypes","vs/base/parts/ipc/node/ipc.mp","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(oe){for(var e=[],R=0,c=oe.length;R<c;R++)e[R]=he[oe[R]];return e};define(he[128],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var R;(function(C){C[C.LoaderAvailable=1]="LoaderAvailable",C[C.BeginLoadingScript=10]="BeginLoadingScript",C[C.EndLoadingScriptOK=11]="EndLoadingScriptOK",C[C.EndLoadingScriptError=12]="EndLoadingScriptError",C[C.BeginInvokeFactory=21]="BeginInvokeFactory",C[C.EndInvokeFactory=22]="EndInvokeFactory",C[C.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",C[C.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",C[C.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",C[C.NodeEndNativeRequire=34]="NodeEndNativeRequire",C[C.CachedDataFound=60]="CachedDataFound",C[C.CachedDataMissed=61]="CachedDataMissed",C[C.CachedDataRejected=62]="CachedDataRejected",C[C.CachedDataCreated=63]="CachedDataCreated"})(R||(e.LoaderEventType=R={}));class c{static get(){const A=new Map,N=new Map,O=new Map,k=new Map;function b(l,m){l.has(m.detail)||l.set(m.detail,-m.timestamp)}function I(l,m){const E=l.get(m.detail);E&&(E>=0||l.set(m.detail,E+m.timestamp))}let $=[];typeof oe=="function"&&typeof oe.getStats=="function"&&($=oe.getStats().slice(0).sort((l,m)=>l.timestamp-m.timestamp));for(const l of $)switch(l.type){case R.BeginLoadingScript:b(A,l);break;case R.EndLoadingScriptOK:case R.EndLoadingScriptError:I(A,l);break;case R.BeginInvokeFactory:b(N,l);break;case R.EndInvokeFactory:I(N,l);break;case R.NodeBeginNativeRequire:b(O,l);break;case R.NodeEndNativeRequire:I(O,l);break;case R.NodeBeginEvaluatingScript:b(k,l);break;case R.NodeEndEvaluatingScript:I(k,l);break}let d=0;O.forEach(l=>d+=l);function g(l){const m=[];return l.forEach((E,f)=>m.push([f,E])),m}return{amdLoad:g(A),amdInvoke:g(N),nodeRequire:g(O),nodeEval:g(k),nodeRequireTotal:d}}static toMarkdownTable(A,N){let O="";const k=[];return A.forEach((b,I)=>{k[I]=b.length}),N.forEach(b=>{b.forEach((I,$)=>{typeof I>"u"&&(I=b[$]="-");const d=I.toString().length;k[$]=Math.max(d,k[$])})}),A.forEach((b,I)=>{O+=`| ${b+" ".repeat(k[I]-b.toString().length)} `}),O+=`|
`,A.forEach((b,I)=>{O+=`| ${"-".repeat(k[I])} `}),O+=`|
`,N.forEach(b=>{b.forEach((I,$)=>{typeof I<"u"&&(O+=`| ${I+" ".repeat(k[$]-I.toString().length)} `)}),O+=`|
`}),O}}e.$S=c}),define(he[129],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=R,e.$fb=c,e.$gb=C,e.$hb=A,e.$ib=N,e.$jb=O,e.$kb=k,e.$mb=I,e.$nb=$,e.$ob=d,e.$pb=g,e.$qb=l;function R(m,E){const f=c(m,E);if(f!==-1)return m[f]}function c(m,E,f=m.length-1){for(let w=f;w>=0;w--){const P=m[w];if(E(P))return w}return-1}function C(m,E){const f=A(m,E);return f===-1?void 0:m[f]}function A(m,E,f=0,w=m.length){let P=f,p=w;for(;P<p;){const o=Math.floor((P+p)/2);E(m[o])?P=o+1:p=o}return P-1}function N(m,E){const f=O(m,E);return f===m.length?void 0:m[f]}function O(m,E,f=0,w=m.length){let P=f,p=w;for(;P<p;){const o=Math.floor((P+p)/2);E(m[o])?p=o:P=o+1}return P}function k(m,E,f=0,w=m.length){const P=O(m,E,f,w);return P===m.length?-1:P}class b{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(b.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!E(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const f=A(this.e,E,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$lb=b;function I(m,E){if(m.length===0)return;let f=m[0];for(let w=1;w<m.length;w++){const P=m[w];E(P,f)>0&&(f=P)}return f}function $(m,E){if(m.length===0)return;let f=m[0];for(let w=1;w<m.length;w++){const P=m[w];E(P,f)>=0&&(f=P)}return f}function d(m,E){return I(m,(f,w)=>-E(f,w))}function g(m,E){if(m.length===0)return-1;let f=0;for(let w=1;w<m.length;w++){const P=m[w];E(P,m[f])>0&&(f=w)}return f}function l(m,E){for(const f of m){const w=E(f);if(w!==void 0)return w}}}),define(he[39],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var R;(function(c){c[c.Null=0]="Null",c[c.Backspace=8]="Backspace",c[c.Tab=9]="Tab",c[c.LineFeed=10]="LineFeed",c[c.CarriageReturn=13]="CarriageReturn",c[c.Space=32]="Space",c[c.ExclamationMark=33]="ExclamationMark",c[c.DoubleQuote=34]="DoubleQuote",c[c.Hash=35]="Hash",c[c.DollarSign=36]="DollarSign",c[c.PercentSign=37]="PercentSign",c[c.Ampersand=38]="Ampersand",c[c.SingleQuote=39]="SingleQuote",c[c.OpenParen=40]="OpenParen",c[c.CloseParen=41]="CloseParen",c[c.Asterisk=42]="Asterisk",c[c.Plus=43]="Plus",c[c.Comma=44]="Comma",c[c.Dash=45]="Dash",c[c.Period=46]="Period",c[c.Slash=47]="Slash",c[c.Digit0=48]="Digit0",c[c.Digit1=49]="Digit1",c[c.Digit2=50]="Digit2",c[c.Digit3=51]="Digit3",c[c.Digit4=52]="Digit4",c[c.Digit5=53]="Digit5",c[c.Digit6=54]="Digit6",c[c.Digit7=55]="Digit7",c[c.Digit8=56]="Digit8",c[c.Digit9=57]="Digit9",c[c.Colon=58]="Colon",c[c.Semicolon=59]="Semicolon",c[c.LessThan=60]="LessThan",c[c.Equals=61]="Equals",c[c.GreaterThan=62]="GreaterThan",c[c.QuestionMark=63]="QuestionMark",c[c.AtSign=64]="AtSign",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.OpenSquareBracket=91]="OpenSquareBracket",c[c.Backslash=92]="Backslash",c[c.CloseSquareBracket=93]="CloseSquareBracket",c[c.Caret=94]="Caret",c[c.Underline=95]="Underline",c[c.BackTick=96]="BackTick",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.OpenCurlyBrace=123]="OpenCurlyBrace",c[c.Pipe=124]="Pipe",c[c.CloseCurlyBrace=125]="CloseCurlyBrace",c[c.Tilde=126]="Tilde",c[c.NoBreakSpace=160]="NoBreakSpace",c[c.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",c[c.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",c[c.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",c[c.U_Combining_Tilde=771]="U_Combining_Tilde",c[c.U_Combining_Macron=772]="U_Combining_Macron",c[c.U_Combining_Overline=773]="U_Combining_Overline",c[c.U_Combining_Breve=774]="U_Combining_Breve",c[c.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",c[c.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",c[c.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",c[c.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",c[c.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",c[c.U_Combining_Caron=780]="U_Combining_Caron",c[c.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",c[c.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",c[c.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",c[c.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",c[c.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",c[c.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",c[c.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",c[c.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",c[c.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",c[c.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",c[c.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",c[c.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",c[c.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",c[c.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",c[c.U_Combining_Horn=795]="U_Combining_Horn",c[c.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",c[c.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",c[c.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",c[c.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",c[c.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",c[c.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",c[c.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",c[c.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",c[c.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",c[c.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",c[c.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",c[c.U_Combining_Cedilla=807]="U_Combining_Cedilla",c[c.U_Combining_Ogonek=808]="U_Combining_Ogonek",c[c.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",c[c.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",c[c.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",c[c.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",c[c.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",c[c.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",c[c.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",c[c.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",c[c.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",c[c.U_Combining_Low_Line=818]="U_Combining_Low_Line",c[c.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",c[c.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",c[c.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",c[c.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",c[c.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",c[c.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",c[c.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",c[c.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",c[c.U_Combining_Square_Below=827]="U_Combining_Square_Below",c[c.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",c[c.U_Combining_X_Above=829]="U_Combining_X_Above",c[c.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",c[c.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",c[c.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",c[c.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",c[c.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",c[c.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",c[c.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",c[c.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",c[c.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",c[c.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",c[c.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",c[c.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",c[c.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",c[c.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",c[c.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",c[c.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",c[c.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",c[c.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",c[c.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",c[c.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",c[c.U_Combining_Fermata=850]="U_Combining_Fermata",c[c.U_Combining_X_Below=851]="U_Combining_X_Below",c[c.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",c[c.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",c[c.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",c[c.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",c[c.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",c[c.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",c[c.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",c[c.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",c[c.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",c[c.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",c[c.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",c[c.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",c[c.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",c[c.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",c[c.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",c[c.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",c[c.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",c[c.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",c[c.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",c[c.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",c[c.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",c[c.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",c[c.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",c[c.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",c[c.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",c[c.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",c[c.LINE_SEPARATOR=8232]="LINE_SEPARATOR",c[c.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",c[c.NEXT_LINE=133]="NEXT_LINE",c[c.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",c[c.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",c[c.U_DIAERESIS=168]="U_DIAERESIS",c[c.U_MACRON=175]="U_MACRON",c[c.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",c[c.U_CEDILLA=184]="U_CEDILLA",c[c.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",c[c.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",c[c.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",c[c.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",c[c.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",c[c.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",c[c.U_BREVE=728]="U_BREVE",c[c.U_DOT_ABOVE=729]="U_DOT_ABOVE",c[c.U_RING_ABOVE=730]="U_RING_ABOVE",c[c.U_OGONEK=731]="U_OGONEK",c[c.U_SMALL_TILDE=732]="U_SMALL_TILDE",c[c.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",c[c.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",c[c.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",c[c.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",c[c.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",c[c.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",c[c.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",c[c.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",c[c.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",c[c.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",c[c.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",c[c.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",c[c.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",c[c.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",c[c.U_GREEK_TONOS=900]="U_GREEK_TONOS",c[c.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",c[c.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",c[c.U_GREEK_PSILI=8127]="U_GREEK_PSILI",c[c.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",c[c.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",c[c.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",c[c.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",c[c.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",c[c.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",c[c.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",c[c.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",c[c.U_GREEK_VARIA=8175]="U_GREEK_VARIA",c[c.U_GREEK_OXIA=8189]="U_GREEK_OXIA",c[c.U_GREEK_DASIA=8190]="U_GREEK_DASIA",c[c.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",c[c.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",c[c.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",c[c.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",c[c.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",c[c.U_OVERLINE=8254]="U_OVERLINE",c[c.UTF8_BOM=65279]="UTF8_BOM",c[c.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",c[c.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(R||(e.CharCode=R={}))}),define(he[130],ue([0,1]),function(oe,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=c,e.$d=C,e.$e=A,e.$f=N;function c(k,b){const I=Object.create(null);for(const $ of k){const d=b($);let g=I[d];g||(g=I[d]=[]),g.push($)}return I}function C(k,b){const I=[],$=[];for(const d of k)b.has(d)||I.push(d);for(const d of b)k.has(d)||$.push(d);return{removed:I,added:$}}function A(k,b){const I=[],$=[];for(const[d,g]of k)b.has(d)||I.push(g);for(const[d,g]of b)k.has(d)||$.push(g);return{removed:I,added:$}}function N(k,b){const I=new Set;for(const $ of b)k.has($)&&I.add($);return I}class O{static{R=Symbol.toStringTag}constructor(b,I){this.b=I,this.a=new Map,this[R]="SetWithKey";for(const $ of b)this.add($)}get size(){return this.a.size}add(b){const I=this.b(b);return this.a.set(I,b),this}delete(b){return this.a.delete(this.b(b))}has(b){return this.a.has(this.b(b))}*entries(){for(const b of this.a.values())yield[b,b]}keys(){return this.values()}*values(){for(const b of this.a.values())yield b}clear(){this.a.clear()}forEach(b,I){this.a.forEach($=>b.call(I,$,$,this))}[Symbol.iterator](){return this.values()}}e.$g=O}),define(he[87],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=c,e.$8h=C,e.$9h=A;function R(N){return(O,k,b)=>{let I=null,$=null;if(typeof b.value=="function"?(I="value",$=b.value):typeof b.get=="function"&&(I="get",$=b.get),!$)throw new Error("not supported");b[I]=N($,k)}}function c(N,O,k){let b=null,I=null;if(typeof k.value=="function"?(b="value",I=k.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(b="get",I=k.get),!I)throw new Error("not supported");const $=`$memoize$${O}`;k[b]=function(...d){return this.hasOwnProperty($)||Object.defineProperty(this,$,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[$]}}function C(N,O,k){return R((b,I)=>{const $=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...g){this[d]||(this[d]=k?k():void 0),clearTimeout(this[$]),O&&(this[d]=O(this[d],...g),g=[this[d]]),this[$]=setTimeout(()=>{b.apply(this,g),this[d]=k?k():void 0},N)}})}function A(N,O,k){return R((b,I)=>{const $=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,g=`$throttle$lastRun$${I}`,l=`$throttle$pending$${I}`;return function(...m){if(this[d]||(this[d]=k?k():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),O&&(this[d]=O(this[d],...m)),this[l])return;const E=this[g]+N;E<=Date.now()?(this[g]=Date.now(),b.apply(this,[this[d]]),this[d]=k?k():void 0):(this[l]=!0,this[$]=setTimeout(()=>{this[l]=!1,this[g]=Date.now(),b.apply(this,[this[d]]),this[d]=k?k():void 0},E-Date.now()))}})}}),define(he[8],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=c,e.$X=C,e.$Y=A,e.$Z=N,e.$1=O,e.$2=k,e.$3=I,e.$5=d,e.$6=g,e.$7=l,e.$9=E;class R{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?p.isErrorNoTelemetry(i)?new p(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(n=>{n(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=R,e.$V=new R;function c(u){e.$V.setUnexpectedErrorHandler(u)}function C(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function A(u){I(u)||e.$V.onUnexpectedError(u)}function N(u){I(u)||e.$V.onUnexpectedExternalError(u)}function O(u){if(u instanceof Error){const{name:i,message:n}=u,t=u.stacktrace||u.stack;return{$isError:!0,name:i,message:n,stack:t,noTelemetry:p.isErrorNoTelemetry(u)}}return u}function k(u){let i;return u.noTelemetry?i=new p:(i=new Error,i.name=u.name),i.message=u.message,i.stack=u.stack,i}const b="Canceled";function I(u){return u instanceof $?!0:u instanceof Error&&u.name===b&&u.message===b}class $ extends Error{constructor(){super(b),this.name=this.message}}e.$4=$;function d(){const u=new Error(b);return u.name=u.message,u}function g(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function l(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class m extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=m;function E(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class f extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=f;class w extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=w;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=P;class p extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof p)return i;const n=new p;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=p;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$bb=o}),define(he[17],ue([0,1,8,129]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=C,e.$sb=A,e.$tb=N,e.$ub=O,e.$vb=k,e.$wb=b,e.$xb=I,e.$yb=$,e.$zb=d,e.$Ab=g,e.$Bb=l,e.$Cb=m,e.$Db=E,e.top=f,e.$Fb=w,e.$Gb=p,e.$Hb=o,e.$Ib=u,e.$Jb=i,e.$Kb=n,e.$Lb=t,e.$Mb=s,e.$Nb=r,e.$Ob=a,e.$Pb=h,e.$Qb=y,e.$Rb=L,e.$Sb=S,e.$Tb=v,e.$Ub=T,e.$Vb=U,e.$Wb=F,e.$Xb=j,e.$Yb=G,e.$Zb=V,e.$1b=x,e.$2b=H,e.$3b=ie,e.$4b=z,e.$5b=ne,e.$6b=ce,e.$9b=K;function C(q,M=0){return q[q.length-(1+M)]}function A(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}function N(q,M,Q=(_,Y)=>_===Y){if(q===M)return!0;if(!q||!M||q.length!==M.length)return!1;for(let _=0,Y=q.length;_<Y;_++)if(!Q(q[_],M[_]))return!1;return!0}function O(q,M){const Q=q.length-1;M<Q&&(q[M]=q[Q]),q.pop()}function k(q,M,Q){return b(q.length,_=>Q(q[_],M))}function b(q,M){let Q=0,_=q-1;for(;Q<=_;){const Y=(Q+_)/2|0,re=M(Y);if(re<0)Q=Y+1;else if(re>0)_=Y-1;else return Y}return-(Q+1)}function I(q,M,Q){if(q=q|0,q>=M.length)throw new TypeError("invalid index");const _=M[Math.floor(M.length*Math.random())],Y=[],re=[],le=[];for(const ge of M){const pe=Q(ge,_);pe<0?Y.push(ge):pe>0?re.push(ge):le.push(ge)}return q<Y.length?I(q,Y,Q):q<Y.length+le.length?le[0]:I(q-(Y.length+le.length),re,Q)}function $(q,M){const Q=[];let _;for(const Y of q.slice(0).sort(M))!_||M(_[0],Y)!==0?(_=[Y],Q.push(_)):_.push(Y);return Q}function*d(q,M){let Q,_;for(const Y of q)_!==void 0&&M(_,Y)?Q.push(Y):(Q&&(yield Q),Q=[Y]),_=Y;Q&&(yield Q)}function g(q,M){for(let Q=0;Q<=q.length;Q++)M(Q===0?void 0:q[Q-1],Q===q.length?void 0:q[Q])}function l(q,M){for(let Q=0;Q<q.length;Q++)M(Q===0?void 0:q[Q-1],q[Q],Q+1===q.length?void 0:q[Q+1])}function m(q,M,Q){const _=[];function Y(ge,pe,Ee){if(pe===0&&Ee.length===0)return;const we=_[_.length-1];we&&we.start+we.deleteCount===ge?(we.deleteCount+=pe,we.toInsert.push(...Ee)):_.push({start:ge,deleteCount:pe,toInsert:Ee})}let re=0,le=0;for(;;){if(re===q.length){Y(re,0,M.slice(le));break}if(le===M.length){Y(re,q.length-re,[]);break}const ge=q[re],pe=M[le],Ee=Q(ge,pe);Ee===0?(re+=1,le+=1):Ee<0?(Y(re,1,[]),re+=1):Ee>0&&(Y(re,0,[pe]),le+=1)}return _}function E(q,M,Q){const _=m(q,M,Q),Y=[],re=[];for(const le of _)Y.push(...q.slice(le.start,le.start+le.deleteCount)),re.push(...le.toInsert);return{removed:Y,added:re}}function f(q,M,Q){if(Q===0)return[];const _=q.slice(0,Q).sort(M);return P(q,M,_,Q,q.length),_}function w(q,M,Q,_,Y){return Q===0?Promise.resolve([]):new Promise((re,le)=>{(async()=>{const ge=q.length,pe=q.slice(0,Q).sort(M);for(let Ee=Q,we=Math.min(Q+_,ge);Ee<ge;Ee=we,we=Math.min(we+_,ge)){if(Ee>Q&&await new Promise(be=>setTimeout(be)),Y&&Y.isCancellationRequested)throw new R.$4;P(q,M,pe,Ee,we)}return pe})().then(re,le)})}function P(q,M,Q,_,Y){for(const re=Q.length;_<Y;_++){const le=q[_];if(M(le,Q[re-1])<0){Q.pop();const ge=(0,c.$jb)(Q,pe=>M(le,pe)<0);Q.splice(ge,0,le)}}}function p(q){return q.filter(M=>!!M)}function o(q){let M=0;for(let Q=0;Q<q.length;Q++)q[Q]&&(q[M]=q[Q],M+=1);q.length=M}function u(q,M,Q){q.splice(Q,0,q.splice(M,1)[0])}function i(q){return!Array.isArray(q)||q.length===0}function n(q){return Array.isArray(q)&&q.length>0}function t(q,M=Q=>Q){const Q=new Set;return q.filter(_=>{const Y=M(_);return Q.has(Y)?!1:(Q.add(Y),!0)})}function s(q){const M=new Set;return Q=>{const _=q(Q);return M.has(_)?!1:(M.add(_),!0)}}function r(q,M){return q.length>0?q[0]:M}function a(q,M){return q.length>0?q[q.length-1]:M}function h(q,M,Q=(_,Y)=>_===Y){let _=0;for(let Y=0,re=Math.min(q.length,M.length);Y<re&&Q(q[Y],M[Y]);Y++)_++;return _}function y(q,M){let Q=typeof M=="number"?q:0;typeof M=="number"?Q=q:(Q=0,M=q);const _=[];if(Q<=M)for(let Y=Q;Y<M;Y++)_.push(Y);else for(let Y=Q;Y>M;Y--)_.push(Y);return _}function L(q,M,Q){return q.reduce((_,Y)=>(_[M(Y)]=Q?Q(Y):Y,_),Object.create(null))}function S(q,M){return q.push(M),()=>v(q,M)}function v(q,M){const Q=q.indexOf(M);if(Q>-1)return q.splice(Q,1),M}function T(q,M,Q){const _=q.slice(0,M),Y=q.slice(M);return _.concat(Q,Y)}function U(q,M){let Q;if(typeof M=="number"){let _=M;Q=()=>{const Y=Math.sin(_++)*179426549;return Y-Math.floor(Y)}}else Q=Math.random;for(let _=q.length-1;_>0;_-=1){const Y=Math.floor(Q()*(_+1)),re=q[_];q[_]=q[Y],q[Y]=re}}function F(q,M){const Q=q.indexOf(M);Q>-1&&(q.splice(Q,1),q.unshift(M))}function j(q,M){const Q=q.indexOf(M);Q>-1&&(q.splice(Q,1),q.push(M))}function G(q,M){for(const Q of M)q.push(Q)}function V(q,M){return Array.isArray(q)?q.map(M):M(q)}function x(q){return Array.isArray(q)?q:[q]}function H(q){return q[Math.floor(Math.random()*q.length)]}function ie(q,M,Q){const _=W(q,M),Y=q.length,re=Q.length;q.length=Y+re;for(let le=Y-1;le>=_;le--)q[le+re]=q[le];for(let le=0;le<re;le++)q[le+_]=Q[le]}function z(q,M,Q,_){const Y=W(q,M);let re=q.splice(Y,Q);return re===void 0&&(re=[]),ie(q,Y,_),re}function W(q,M){return M<0?Math.max(M+q.length,0):Math.min(M,q.length)}var ee;(function(q){function M(re){return re<0}q.isLessThan=M;function Q(re){return re<=0}q.isLessThanOrEqual=Q;function _(re){return re>0}q.isGreaterThan=_;function Y(re){return re===0}q.isNeitherLessOrGreaterThan=Y,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function ne(q,M){return(Q,_)=>M(q(Q),q(_))}function ce(...q){return(M,Q)=>{for(const _ of q){const Y=_(M,Q);if(!ee.isNeitherLessOrGreaterThan(Y))return Y}return ee.neitherLessOrGreaterThan}}const te=(q,M)=>q-M;e.$7b=te;const X=(q,M)=>(0,e.$7b)(q?1:0,M?1:0);e.$8b=X;function K(q){return(M,Q)=>-q(M,Q)}class B{constructor(M){this.g=M,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(M){let Q=this.c;for(;Q<this.g.length&&M(this.g[Q]);)Q++;const _=Q===this.c?null:this.g.slice(this.c,Q);return this.c=Q,_}takeFromEndWhile(M){let Q=this.d;for(;Q>=0&&M(this.g[Q]);)Q--;const _=Q===this.d?null:this.g.slice(Q+1,this.d+1);return this.d=Q,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const M=this.g[this.c];return this.c++,M}removeLast(){const M=this.g[this.d];return this.d--,M}takeCount(M){const Q=this.g.slice(this.c,this.c+M);return this.c+=M,Q}}e.$0b=B;class D{static{this.empty=new D(M=>{})}constructor(M){this.iterate=M}forEach(M){this.iterate(Q=>(M(Q),!0))}toArray(){const M=[];return this.iterate(Q=>(M.push(Q),!0)),M}filter(M){return new D(Q=>this.iterate(_=>M(_)?Q(_):!0))}map(M){return new D(Q=>this.iterate(_=>Q(M(_))))}some(M){let Q=!1;return this.iterate(_=>(Q=M(_),!Q)),Q}findFirst(M){let Q;return this.iterate(_=>M(_)?(Q=_,!1):!0),Q}findLast(M){let Q;return this.iterate(_=>(M(_)&&(Q=_),!0)),Q}findLastMaxBy(M){let Q,_=!0;return this.iterate(Y=>((_||ee.isGreaterThan(M(Y,Q)))&&(_=!1,Q=Y),!0)),Q}}e.$$b=D;class J{constructor(M){this.c=M}static createSortPermutation(M,Q){const _=Array.from(M.keys()).sort((Y,re)=>Q(M[Y],M[re]));return new J(_)}apply(M){return M.map((Q,_)=>M[this.c[_]])}inverse(){const M=this.c.slice();for(let Q=0;Q<this.c.length;Q++)M[this.c[Q]]=Q;return new J(M)}}e.$_b=J}),define(he[131],ue([0,1,8]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=c,e.$dd=C,e.$ed=A,e.$fd=N,e.$gd=O,e.$hd=k;function c(b,I){if(!b)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function C(b,I="Unreachable"){throw new Error(I)}function A(b,I="unexpected state"){if(!b)throw new R.$bb(`Assertion Failed: ${I}`)}function N(b){b||(0,R.$Y)(new R.$bb("Soft Assertion Failed"))}function O(b){if(!b()){debugger;b(),(0,R.$Y)(new R.$bb("Assertion Failed"))}}function k(b,I){let $=0;for(;$<b.length-1;){const d=b[$],g=b[$+1];if(!I(d,g))return!1;$++}return!0}}),define(he[88],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=R;function R(c,C){const A=this;let N=!1,O;return function(){if(N)return O;if(N=!0,C)try{O=c.apply(A,arguments)}finally{C()}else O=c.apply(A,arguments);return O}}}),define(he[63],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(c){function C(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}c.is=C;const A=Object.freeze([]);function N(){return A}c.empty=N;function*O(i){yield i}c.single=O;function k(i){return C(i)?i:O(i)}c.wrap=k;function b(i){return i||A}c.from=b;function*I(i){for(let n=i.length-1;n>=0;n--)yield i[n]}c.reverse=I;function $(i){return!i||i[Symbol.iterator]().next().done===!0}c.isEmpty=$;function d(i){return i[Symbol.iterator]().next().value}c.first=d;function g(i,n){let t=0;for(const s of i)if(n(s,t++))return!0;return!1}c.some=g;function l(i,n){for(const t of i)if(n(t))return t}c.find=l;function*m(i,n){for(const t of i)n(t)&&(yield t)}c.filter=m;function*E(i,n){let t=0;for(const s of i)yield n(s,t++)}c.map=E;function*f(i,n){let t=0;for(const s of i)yield*n(s,t++)}c.flatMap=f;function*w(...i){for(const n of i)yield*n}c.concat=w;function P(i,n,t){let s=t;for(const r of i)s=n(s,r);return s}c.reduce=P;function*p(i,n,t=i.length){for(n<0&&(n+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);n<t;n++)yield i[n]}c.slice=p;function o(i,n=Number.POSITIVE_INFINITY){const t=[];if(n===0)return[t,i];const s=i[Symbol.iterator]();for(let r=0;r<n;r++){const a=s.next();if(a.done)return[t,c.empty()];t.push(a.value)}return[t,{[Symbol.iterator](){return s}}]}c.consume=o;async function u(i){const n=[];for await(const t of i)n.push(t);return Promise.resolve(n)}c.asyncToArray=u})(R||(e.Iterable=R={}))}),define(he[36],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=N,e.$Un=$,e.$Vn=d,e.$Wn=g,e.$Xn=l,e.$Yn=m,e.$Zn=E,e.$1n=f,e.$2n=w,e.$3n=P,e.$4n=p;var R;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var c;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(c||(e.SyntaxKind=c={}));var C;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var A;(function(o){o.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function N(o,u=!1){let i=0;const n=o.length;let t="",s=0,r=c.Unknown,a=R.None;function h(F){let j=0,G=0;for(;j<F;){const V=o.charCodeAt(i);if(V>=I._0&&V<=I._9)G=G*16+V-I._0;else if(V>=I.A&&V<=I.F)G=G*16+V-I.A+10;else if(V>=I.a&&V<=I.f)G=G*16+V-I.a+10;else break;i++,j++}return j<F&&(G=-1),G}function y(F){i=F,t="",s=0,r=c.Unknown,a=R.None}function L(){const F=i;if(o.charCodeAt(i)===I._0)i++;else for(i++;i<o.length&&b(o.charCodeAt(i));)i++;if(i<o.length&&o.charCodeAt(i)===I.dot)if(i++,i<o.length&&b(o.charCodeAt(i)))for(i++;i<o.length&&b(o.charCodeAt(i));)i++;else return a=R.UnexpectedEndOfNumber,o.substring(F,i);let j=i;if(i<o.length&&(o.charCodeAt(i)===I.E||o.charCodeAt(i)===I.e))if(i++,(i<o.length&&o.charCodeAt(i)===I.plus||o.charCodeAt(i)===I.minus)&&i++,i<o.length&&b(o.charCodeAt(i))){for(i++;i<o.length&&b(o.charCodeAt(i));)i++;j=i}else a=R.UnexpectedEndOfNumber;return o.substring(F,j)}function S(){let F="",j=i;for(;;){if(i>=n){F+=o.substring(j,i),a=R.UnexpectedEndOfString;break}const G=o.charCodeAt(i);if(G===I.doubleQuote){F+=o.substring(j,i),i++;break}if(G===I.backslash){if(F+=o.substring(j,i),i++,i>=n){a=R.UnexpectedEndOfString;break}switch(o.charCodeAt(i++)){case I.doubleQuote:F+='"';break;case I.backslash:F+="\\";break;case I.slash:F+="/";break;case I.b:F+="\b";break;case I.f:F+="\f";break;case I.n:F+=`
`;break;case I.r:F+="\r";break;case I.t:F+="	";break;case I.u:{const x=h(4);x>=0?F+=String.fromCharCode(x):a=R.InvalidUnicode;break}default:a=R.InvalidEscapeCharacter}j=i;continue}if(G>=0&&G<=31)if(k(G)){F+=o.substring(j,i),a=R.UnexpectedEndOfString;break}else a=R.InvalidCharacter;i++}return F}function v(){if(t="",a=R.None,s=i,i>=n)return s=n,r=c.EOF;let F=o.charCodeAt(i);if(O(F)){do i++,t+=String.fromCharCode(F),F=o.charCodeAt(i);while(O(F));return r=c.Trivia}if(k(F))return i++,t+=String.fromCharCode(F),F===I.carriageReturn&&o.charCodeAt(i)===I.lineFeed&&(i++,t+=`
`),r=c.LineBreakTrivia;switch(F){case I.openBrace:return i++,r=c.OpenBraceToken;case I.closeBrace:return i++,r=c.CloseBraceToken;case I.openBracket:return i++,r=c.OpenBracketToken;case I.closeBracket:return i++,r=c.CloseBracketToken;case I.colon:return i++,r=c.ColonToken;case I.comma:return i++,r=c.CommaToken;case I.doubleQuote:return i++,t=S(),r=c.StringLiteral;case I.slash:{const j=i-1;if(o.charCodeAt(i+1)===I.slash){for(i+=2;i<n&&!k(o.charCodeAt(i));)i++;return t=o.substring(j,i),r=c.LineCommentTrivia}if(o.charCodeAt(i+1)===I.asterisk){i+=2;const G=n-1;let V=!1;for(;i<G;){if(o.charCodeAt(i)===I.asterisk&&o.charCodeAt(i+1)===I.slash){i+=2,V=!0;break}i++}return V||(i++,a=R.UnexpectedEndOfComment),t=o.substring(j,i),r=c.BlockCommentTrivia}return t+=String.fromCharCode(F),i++,r=c.Unknown}case I.minus:if(t+=String.fromCharCode(F),i++,i===n||!b(o.charCodeAt(i)))return r=c.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return t+=L(),r=c.NumericLiteral;default:for(;i<n&&T(F);)i++,F=o.charCodeAt(i);if(s!==i){switch(t=o.substring(s,i),t){case"true":return r=c.TrueKeyword;case"false":return r=c.FalseKeyword;case"null":return r=c.NullKeyword}return r=c.Unknown}return t+=String.fromCharCode(F),i++,r=c.Unknown}}function T(F){if(O(F)||k(F))return!1;switch(F){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function U(){let F;do F=v();while(F>=c.LineCommentTrivia&&F<=c.Trivia);return F}return{setPosition:y,getPosition:()=>i,scan:u?U:v,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>a}}function O(o){return o===I.space||o===I.tab||o===I.verticalTab||o===I.formFeed||o===I.nonBreakingSpace||o===I.ogham||o>=I.enQuad&&o<=I.zeroWidthSpace||o===I.narrowNoBreakSpace||o===I.mathematicalSpace||o===I.ideographicSpace||o===I.byteOrderMark}function k(o){return o===I.lineFeed||o===I.carriageReturn||o===I.lineSeparator||o===I.paragraphSeparator}function b(o){return o>=I._0&&o<=I._9}var I;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(I||(I={}));function $(o,u){const i=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function a(h,y,L,S){s.value=h,s.offset=y,s.length=L,s.type=S,s.colonOffset=void 0,t=s}try{P(o,{onObjectBegin:(h,y)=>{if(u<=h)throw n;t=void 0,r=u>h,i.push("")},onObjectProperty:(h,y,L)=>{if(u<y||(a(h,y,L,"property"),i[i.length-1]=h,u<=y+L))throw n},onObjectEnd:(h,y)=>{if(u<=h)throw n;t=void 0,i.pop()},onArrayBegin:(h,y)=>{if(u<=h)throw n;t=void 0,i.push(0)},onArrayEnd:(h,y)=>{if(u<=h)throw n;t=void 0,i.pop()},onLiteralValue:(h,y,L)=>{if(u<y||(a(h,y,L,p(h)),u<=y+L))throw n},onSeparator:(h,y,L)=>{if(u<=y)throw n;if(h===":"&&t&&t.type==="property")t.colonOffset=y,r=!1,t=void 0;else if(h===","){const S=i[i.length-1];typeof S=="number"?i[i.length-1]=S+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(h){if(h!==n)throw h}return{path:i,previousNode:t,isAtPropertyKey:r,matches:h=>{let y=0;for(let L=0;y<h.length&&L<i.length;L++)if(h[y]===i[L]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}function d(o,u=[],i=A.DEFAULT){let n=null,t=[];const s=[];function r(h){Array.isArray(t)?t.push(h):n!==null&&(t[n]=h)}return P(o,{onObjectBegin:()=>{const h={};r(h),s.push(t),t=h,n=null},onObjectProperty:h=>{n=h},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const h=[];r(h),s.push(t),t=h,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:r,onError:(h,y,L)=>{u.push({error:h,offset:y,length:L})}},i),t[0]}function g(o,u=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(h){n.type==="property"&&(n.length=h-n.offset,n=n.parent)}function s(h){return n.children.push(h),h}P(o,{onObjectBegin:h=>{n=s({type:"object",offset:h,length:-1,parent:n,children:[]})},onObjectProperty:(h,y,L)=>{n=s({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:h,offset:y,length:L,parent:n})},onObjectEnd:(h,y)=>{n.length=h+y-n.offset,n=n.parent,t(h+y)},onArrayBegin:(h,y)=>{n=s({type:"array",offset:h,length:-1,parent:n,children:[]})},onArrayEnd:(h,y)=>{n.length=h+y-n.offset,n=n.parent,t(h+y)},onLiteralValue:(h,y,L)=>{s({type:p(h),offset:y,length:L,parent:n,value:h}),t(y+L)},onSeparator:(h,y,L)=>{n.type==="property"&&(h===":"?n.colonOffset=y:h===","&&t(y))},onError:(h,y,L)=>{u.push({error:h,offset:y,length:L})}},i);const a=n.children[0];return a&&delete a.parent,a}function l(o,u){if(!o)return;let i=o;for(const n of u)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function m(o){if(!o.parent||!o.parent.children)return[];const u=m(o.parent);if(o.parent.type==="property"){const i=o.parent.children[0].value;u.push(i)}else if(o.parent.type==="array"){const i=o.parent.children.indexOf(o);i!==-1&&u.push(i)}return u}function E(o){switch(o.type){case"array":return o.children.map(E);case"object":{const u=Object.create(null);for(const i of o.children){const n=i.children[1];n&&(u[i.children[0].value]=E(n))}return u}case"null":case"string":case"number":case"boolean":return o.value;default:return}}function f(o,u,i=!1){return u>=o.offset&&u<o.offset+o.length||i&&u===o.offset+o.length}function w(o,u,i=!1){if(f(o,u,i)){const n=o.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=u;t++){const s=w(n[t],u,i);if(s)return s}return o}}function P(o,u,i=A.DEFAULT){const n=N(o,!1);function t(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(ne){return ne?ce=>ne(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=t(u.onObjectBegin),a=s(u.onObjectProperty),h=t(u.onObjectEnd),y=t(u.onArrayBegin),L=t(u.onArrayEnd),S=s(u.onLiteralValue),v=s(u.onSeparator),T=t(u.onComment),U=s(u.onError),F=i&&i.disallowComments,j=i&&i.allowTrailingComma;function G(){for(;;){const ne=n.scan();switch(n.getTokenError()){case R.InvalidUnicode:V(C.InvalidUnicode);break;case R.InvalidEscapeCharacter:V(C.InvalidEscapeCharacter);break;case R.UnexpectedEndOfNumber:V(C.UnexpectedEndOfNumber);break;case R.UnexpectedEndOfComment:F||V(C.UnexpectedEndOfComment);break;case R.UnexpectedEndOfString:V(C.UnexpectedEndOfString);break;case R.InvalidCharacter:V(C.InvalidCharacter);break}switch(ne){case c.LineCommentTrivia:case c.BlockCommentTrivia:F?V(C.InvalidCommentToken):T();break;case c.Unknown:V(C.InvalidSymbol);break;case c.Trivia:case c.LineBreakTrivia:break;default:return ne}}}function V(ne,ce=[],te=[]){if(U(ne),ce.length+te.length>0){let X=n.getToken();for(;X!==c.EOF;){if(ce.indexOf(X)!==-1){G();break}else if(te.indexOf(X)!==-1)break;X=G()}}}function x(ne){const ce=n.getTokenValue();return ne?S(ce):a(ce),G(),!0}function H(){switch(n.getToken()){case c.NumericLiteral:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(V(C.InvalidNumberFormat),ne=0)}catch{V(C.InvalidNumberFormat)}S(ne);break}case c.NullKeyword:S(null);break;case c.TrueKeyword:S(!0);break;case c.FalseKeyword:S(!1);break;default:return!1}return G(),!0}function ie(){return n.getToken()!==c.StringLiteral?(V(C.PropertyNameExpected,[],[c.CloseBraceToken,c.CommaToken]),!1):(x(!1),n.getToken()===c.ColonToken?(v(":"),G(),ee()||V(C.ValueExpected,[],[c.CloseBraceToken,c.CommaToken])):V(C.ColonExpected,[],[c.CloseBraceToken,c.CommaToken]),!0)}function z(){r(),G();let ne=!1;for(;n.getToken()!==c.CloseBraceToken&&n.getToken()!==c.EOF;){if(n.getToken()===c.CommaToken){if(ne||V(C.ValueExpected,[],[]),v(","),G(),n.getToken()===c.CloseBraceToken&&j)break}else ne&&V(C.CommaExpected,[],[]);ie()||V(C.ValueExpected,[],[c.CloseBraceToken,c.CommaToken]),ne=!0}return h(),n.getToken()!==c.CloseBraceToken?V(C.CloseBraceExpected,[c.CloseBraceToken],[]):G(),!0}function W(){y(),G();let ne=!1;for(;n.getToken()!==c.CloseBracketToken&&n.getToken()!==c.EOF;){if(n.getToken()===c.CommaToken){if(ne||V(C.ValueExpected,[],[]),v(","),G(),n.getToken()===c.CloseBracketToken&&j)break}else ne&&V(C.CommaExpected,[],[]);ee()||V(C.ValueExpected,[],[c.CloseBracketToken,c.CommaToken]),ne=!0}return L(),n.getToken()!==c.CloseBracketToken?V(C.CloseBracketExpected,[c.CloseBracketToken],[]):G(),!0}function ee(){switch(n.getToken()){case c.OpenBracketToken:return W();case c.OpenBraceToken:return z();case c.StringLiteral:return x(!0);default:return H()}}return G(),n.getToken()===c.EOF?i.allowEmptyContent?!0:(V(C.ValueExpected,[],[]),!1):ee()?(n.getToken()!==c.EOF&&V(C.EndOfFileExpected,[],[]),!0):(V(C.ValueExpected,[],[]),!1)}function p(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}}),define(he[45],ue([0,1,36]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=c,e.$6n=C,e.$7n=O,e.$8n=k;function c(b,I,$){let d,g,l,m,E;if(I){for(m=I.offset,E=m+I.length,l=m;l>0&&!k(b,l-1);)l--;let a=E;for(;a<b.length&&!k(b,a);)a++;g=b.substring(l,a),d=N(g,$)}else g=b,d=0,l=0,m=0,E=b.length;const f=O($,b);let w=!1,P=0,p;$.insertSpaces?p=A(" ",$.tabSize||4):p="	";const o=(0,R.$Tn)(g,!1);let u=!1;function i(){return f+A(p,d+P)}function n(){let a=o.scan();for(w=!1;a===R.SyntaxKind.Trivia||a===R.SyntaxKind.LineBreakTrivia;)w=w||a===R.SyntaxKind.LineBreakTrivia,a=o.scan();return u=a===R.SyntaxKind.Unknown||o.getTokenError()!==R.ScanError.None,a}const t=[];function s(a,h,y){!u&&h<E&&y>m&&b.substring(h,y)!==a&&t.push({offset:h,length:y-h,content:a})}let r=n();if(r!==R.SyntaxKind.EOF){const a=o.getTokenOffset()+l,h=A(p,d);s(h,l,a)}for(;r!==R.SyntaxKind.EOF;){let a=o.getTokenOffset()+o.getTokenLength()+l,h=n(),y="";for(;!w&&(h===R.SyntaxKind.LineCommentTrivia||h===R.SyntaxKind.BlockCommentTrivia);){const S=o.getTokenOffset()+l;s(" ",a,S),a=o.getTokenOffset()+o.getTokenLength()+l,y=h===R.SyntaxKind.LineCommentTrivia?i():"",h=n()}if(h===R.SyntaxKind.CloseBraceToken)r!==R.SyntaxKind.OpenBraceToken&&(P--,y=i());else if(h===R.SyntaxKind.CloseBracketToken)r!==R.SyntaxKind.OpenBracketToken&&(P--,y=i());else{switch(r){case R.SyntaxKind.OpenBracketToken:case R.SyntaxKind.OpenBraceToken:P++,y=i();break;case R.SyntaxKind.CommaToken:case R.SyntaxKind.LineCommentTrivia:y=i();break;case R.SyntaxKind.BlockCommentTrivia:w?y=i():y=" ";break;case R.SyntaxKind.ColonToken:y=" ";break;case R.SyntaxKind.StringLiteral:if(h===R.SyntaxKind.ColonToken){y="";break}case R.SyntaxKind.NullKeyword:case R.SyntaxKind.TrueKeyword:case R.SyntaxKind.FalseKeyword:case R.SyntaxKind.NumericLiteral:case R.SyntaxKind.CloseBraceToken:case R.SyntaxKind.CloseBracketToken:h===R.SyntaxKind.LineCommentTrivia||h===R.SyntaxKind.BlockCommentTrivia?y=" ":h!==R.SyntaxKind.CommaToken&&h!==R.SyntaxKind.EOF&&(u=!0);break;case R.SyntaxKind.Unknown:u=!0;break}w&&(h===R.SyntaxKind.LineCommentTrivia||h===R.SyntaxKind.BlockCommentTrivia)&&(y=i())}const L=o.getTokenOffset()+l;s(y,a,L),r=h}return t}function C(b,I){const $=JSON.stringify(b,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?$.replace(/\r\n|\r|\n/g,I.eol):$}function A(b,I){let $="";for(let d=0;d<I;d++)$+=b;return $}function N(b,I){let $=0,d=0;const g=I.tabSize||4;for(;$<b.length;){const l=b.charAt($);if(l===" ")d++;else if(l==="	")d+=g;else break;$++}return Math.floor(d/g)}function O(b,I){for(let $=0;$<I.length;$++){const d=I.charAt($);if(d==="\r")return $+1<I.length&&I.charAt($+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return b&&b.eol||`
`}function k(b,I){return`\r
`.indexOf(b.charAt(I))!==-1}}),define(he[64],ue([0,1,36,45]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=C,e.$0n=A,e.$$n=N,e.$_n=O,e.$ao=k;function C(b,I,$){return A(b,I,void 0,$)}function A(b,I,$,d,g){const l=I.slice(),m=[],E=(0,R.$Wn)(b,m);let f,w;for(;l.length>0&&(w=l.pop(),f=(0,R.$Xn)(E,l),f===void 0&&$!==void 0);)typeof w=="string"?$={[w]:$}:$=[$];if(f)if(f.type==="object"&&typeof w=="string"&&Array.isArray(f.children)){const P=(0,R.$Xn)(f,[w]);if(P!==void 0)if($===void 0){if(!P.parent)throw new Error("Malformed AST");const p=f.children.indexOf(P.parent);let o,u=P.parent.offset+P.parent.length;if(p>0){const i=f.children[p-1];o=i.offset+i.length}else o=f.offset+1,f.children.length>1&&(u=f.children[1].offset);return N(b,{offset:o,length:u-o,content:""},d)}else return N(b,{offset:P.offset,length:P.length,content:JSON.stringify($)},d);else{if($===void 0)return[];const p=`${JSON.stringify(w)}: ${JSON.stringify($)}`,o=g?g(f.children.map(i=>i.children[0].value)):f.children.length;let u;if(o>0){const i=f.children[o-1];u={offset:i.offset+i.length,length:0,content:","+p}}else f.children.length===0?u={offset:f.offset+1,length:0,content:p}:u={offset:f.offset+1,length:0,content:p+","};return N(b,u,d)}}else if(f.type==="array"&&typeof w=="number"&&Array.isArray(f.children))if($!==void 0){const P=`${JSON.stringify($)}`;let p;if(f.children.length===0||w===0)p={offset:f.offset+1,length:0,content:f.children.length===0?P:P+","};else{const o=w===-1||w>f.children.length?f.children.length:w,u=f.children[o-1];p={offset:u.offset+u.length,length:0,content:","+P}}return N(b,p,d)}else{const P=w,p=f.children[P];let o;if(f.children.length===1)o={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===P){const u=f.children[P-1],i=u.offset+u.length,n=f.offset+f.length;o={offset:i,length:n-2-i,content:""}}else o={offset:p.offset,length:f.children[P+1].offset-p.offset,content:""};return N(b,o,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${f.type}`);else return $===void 0?[]:N(b,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify($)},d)}function N(b,I,$){let d=O(b,I),g=I.offset,l=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;g>0&&!(0,c.$8n)(d,g-1);)g--;for(;l<d.length&&!(0,c.$8n)(d,l);)l++}const m=(0,c.$5n)(d,{offset:g,length:l-g},$);for(let f=m.length-1;f>=0;f--){const w=m[f];d=O(d,w),g=Math.min(g,w.offset),l=Math.max(l,w.offset+w.length),l+=w.content.length-w.length}const E=b.length-(d.length-l)-g;return[{offset:g,length:E,content:d.substring(g,l)}]}function O(b,I){return b.substring(0,I.offset)+I.content+b.substring(I.offset+I.length)}function k(b,I){const $=I.slice(0).sort((g,l)=>{const m=g.offset-l.offset;return m===0?g.length-l.length:m});let d=b.length;for(let g=$.length-1;g>=0;g--){const l=$[g];if(l.offset+l.length<=d)b=O(b,l);else throw new Error("Overlapping edit");d=l.offset}return b}}),define(he[132],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=R;function R(A){let N=!1;const O=new Map,k=new Map;if(C(A,m=>{if(A===m)return!0;const E=JSON.stringify(m);if(E.length<30)return!0;const f=O.get(E);if(!f){const w={schemas:[m]};return O.set(E,w),k.set(m,w),!0}return f.schemas.push(m),k.set(m,f),N=!0,!1}),O.clear(),!N)return JSON.stringify(A);let I="$defs";for(;A.hasOwnProperty(I);)I+="_";const $=[];function d(m){return JSON.stringify(m,(E,f)=>{if(f!==m){const w=k.get(f);if(w&&w.schemas.length>1)return w.id||(w.id=`_${$.length}`,$.push(w.schemas[0])),{$ref:`#/${I}/${w.id}`}}return f})}const g=d(A),l=[];for(let m=0;m<$.length;m++)l.push(`"_${m}":${d($[m])}`);return l.length?`${g.substring(0,g.length-1)},"${I}":{${l.join(",")}}}`:g}function c(A){return typeof A=="object"&&A!==null}function C(A,N){if(!A||typeof A!="object")return;const O=(...g)=>{for(const l of g)c(l)&&$.push(l)},k=(...g)=>{for(const l of g)if(c(l))for(const m in l){const E=l[m];c(E)&&$.push(E)}},b=(...g)=>{for(const l of g)if(Array.isArray(l))for(const m of l)c(m)&&$.push(m)},I=g=>{if(Array.isArray(g))for(const l of g)c(l)&&$.push(l);else c(g)&&$.push(g)},$=[A];let d=$.pop();for(;d;)N(d)&&(O(d.additionalItems,d.additionalProperties,d.not,d.contains,d.propertyNames,d.if,d.then,d.else,d.unevaluatedItems,d.unevaluatedProperties),k(d.definitions,d.$defs,d.properties,d.patternProperties,d.dependencies,d.dependentSchemas),b(d.anyOf,d.allOf,d.oneOf,d.prefixItems),I(d.items)),d=$.pop()}}),define(he[53],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class R{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=R}),define(he[89],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class R{static{this.Undefined=new R(void 0)}constructor(A){this.element=A,this.next=R.Undefined,this.prev=R.Undefined}}class c{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let A=this.a;for(;A!==R.Undefined;){const N=A.next;A.prev=R.Undefined,A.next=R.Undefined,A=N}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,N){const O=new R(A);if(this.a===R.Undefined)this.a=O,this.b=O;else if(N){const b=this.b;this.b=O,O.prev=b,b.next=O}else{const b=this.a;this.a=O,O.next=b,b.prev=O}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(O))}}shift(){if(this.a!==R.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==R.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==R.Undefined&&A.next!==R.Undefined){const N=A.prev;N.next=A.next,A.next.prev=N}else A.prev===R.Undefined&&A.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):A.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):A.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==R.Undefined;)yield A.element,A=A.next}}e.$4c=c}),define(he[31],ue([0,1]),function(oe,e){"use strict";var R,c,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=void 0,e.$wc=A,e.$xc=N,e.$yc=O,e.$Hc=p;function A(o,u,i){let n=o.get(u);return n===void 0&&(n=i,o.set(u,n)),n}function N(o){const u=[];return o.forEach((i,n)=>{u.push(`${n} => ${i}`)}),`Map(${o.size}) {${u.join(", ")}}`}function O(o){const u=[];return o.forEach(i=>{u.push(i)}),`Set(${o.size}) {${u.join(", ")}}`}class k{constructor(u,i){this.uri=u,this.value=i}}function b(o){return Array.isArray(o)}class I{static{this.c=u=>u.toString()}constructor(u,i){if(this[R]="ResourceMap",u instanceof I)this.d=new Map(u.d),this.e=i??I.c;else if(b(u)){this.d=new Map,this.e=i??I.c;for(const[n,t]of u)this.set(n,t)}else this.d=new Map,this.e=u??I.c}set(u,i){return this.d.set(this.e(u),new k(u,i)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,i){typeof i<"u"&&(u=u.bind(i));for(const[n,t]of this.d)u(t.value,t.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}e.$zc=I;class ${constructor(u,i){this[c]="ResourceSet",!u||typeof u=="function"?this.c=new I(u):(this.c=new I(i),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,i){this.c.forEach((n,t)=>u.call(i,t,t,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=$;var d;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class g{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,i=d.None){const n=this.c.get(u);if(n)return i!==d.None&&this.m(n,i),n.value}set(u,i,n=d.None){let t=this.c.get(u);if(t)t.value=i,n!==d.None&&this.m(t,n);else{switch(t={key:u,value:i,next:void 0,previous:void 0},n){case d.None:this.k(t);break;case d.AsOld:this.j(t);break;case d.AsNew:this.k(t);break;default:this.k(t);break}this.c.set(u,t),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const i=this.c.get(u);if(i)return this.c.delete(u),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,i){const n=this.g;let t=this.d;for(;t;){if(i?u.bind(i)(t.value,t.key,this):u(t.value,t.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const u=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.key,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}values(){const u=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.value,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}entries(){const u=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:[n.key,n.value],done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.d,n=this.size;for(;i&&n>u;)this.c.delete(i.key),i=i.next,n--;this.d=i,this.f=n,i&&(i.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.e,n=this.size;for(;i&&n>u;)this.c.delete(i.key),i=i.previous,n--;this.e=i,this.f=n,i&&(i.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const i=u.next,n=u.previous;if(!i||!n)throw new Error("Invalid list");i.previous=n,n.next=i}u.next=void 0,u.previous=void 0,this.g++}m(u,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==d.AsOld&&i!==d.AsNew)){if(i===d.AsOld){if(u===this.d)return;const n=u.next,t=u.previous;u===this.e?(t.next=void 0,this.e=t):(n.previous=t,t.next=n),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(i===d.AsNew){if(u===this.e)return;const n=u.next,t=u.previous;u===this.d?(n.previous=void 0,this.d=n):(n.previous=t,t.next=n),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((i,n)=>{u.push([n,i])}),u}fromJSON(u){this.clear();for(const[i,n]of u)this.set(i,n)}}e.$Bc=g;class l extends g{constructor(u,i=1){super(),this.n=u,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,i=d.AsNew){return super.get(u,i)}peek(u){return super.get(u,d.None)}set(u,i){return super.set(u,i,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends l{constructor(u,i=1){super(u,i)}q(u){this.h(u)}set(u,i){return super.set(u,i),this.p(),this}}e.$Cc=m;class E extends l{constructor(u,i=1){super(u,i)}q(u){this.i(u)}set(u,i){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,i),this}}e.$Dc=E;class f{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let i=this.c.get(u)||0;return i===0?!1:(i--,i===0?this.c.delete(u):this.c.set(u,i),!0)}has(u){return this.c.has(u)}}e.$Ec=f;class w{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[i,n]of u)this.set(i,n)}clear(){this.c.clear(),this.d.clear()}set(u,i){this.c.set(u,i),this.d.set(i,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const i=this.c.get(u);return i===void 0?!1:(this.c.delete(u),this.d.delete(i),!0)}forEach(u,i){this.c.forEach((n,t)=>{u.call(i,n,t,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=w;class P{constructor(){this.c=new Map}add(u,i){let n=this.c.get(u);n||(n=new Set,this.c.set(u,n)),n.add(i)}delete(u,i){const n=this.c.get(u);n&&(n.delete(i),n.size===0&&this.c.delete(u))}forEach(u,i){const n=this.c.get(u);n&&n.forEach(i)}get(u){const i=this.c.get(u);return i||new Set}}e.$Gc=P;function p(o,u){if(o===u)return!0;if(o.size!==u.size)return!1;for(const[i,n]of o)if(!u.has(i)||u.get(i)!==n)return!1;for(const[i]of u)if(!o.has(i))return!1;return!0}}),define(he[2],ue([0,1,17,130,31,88,63]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=I,e.$Kc=$,e.$Lc=d,e.$Mc=m,e.$Nc=E,e.$Oc=f,e.$Pc=w,e.$Qc=P,e.$Rc=p,e.$2c=y;const O=!1;let k=null;class b{constructor(){this.b=new Map}static{this.a=0}c(v){let T=this.b.get(v);return T||(T={parent:null,source:null,isSingleton:!1,value:v,idx:b.a++},this.b.set(v,T)),T}trackDisposable(v){const T=this.c(v);T.source||(T.source=new Error().stack)}setParent(v,T){const U=this.c(v);U.parent=T}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,T){const U=T.get(v);if(U)return U;const F=v.parent?this.f(this.c(v.parent),T):v;return T.set(v,F),F}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,v).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(v=10,T){let U;if(T)U=T;else{const x=new Map,H=[...this.b.values()].filter(z=>z.source!==null&&!this.f(z,x).isSingleton);if(H.length===0)return;const ie=new Set(H.map(z=>z.value));if(U=H.filter(z=>!(z.parent&&ie.has(z.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function F(x){function H(z,W){for(;z.length>0&&W.some(ee=>typeof ee=="string"?ee===z[0]:z[0].match(ee));)z.shift()}const ie=x.source.split(`
`).map(z=>z.trim().replace("at ","")).filter(z=>z!=="");return H(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const j=new C.$Gc;for(const x of U){const H=F(x);for(let ie=0;ie<=H.length;ie++)j.add(H.slice(0,ie).join(`
`),x)}U.sort((0,R.$5b)(x=>x.idx,R.$7b));let G="",V=0;for(const x of U.slice(0,v)){V++;const H=F(x),ie=[];for(let z=0;z<H.length;z++){let W=H[z];W=`(shared with ${j.get(H.slice(0,z+1).join(`
`)).size}/${U.length} leaks) at ${W}`;const ne=j.get(H.slice(0,z).join(`
`)),ce=(0,c.$c)([...ne].map(te=>F(te)[z]),te=>te);delete ce[H[z]];for(const[te,X]of Object.entries(ce))ie.unshift(`    - stacktraces of ${X.length} other leaks continue with ${te}`);ie.unshift(W)}G+=`


==================== Leaking disposable ${V}/${U.length}: ${x.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return U.length>v&&(G+=`


... and ${U.length-v} more leaking disposables

`),{leaks:U,details:G}}}e.$Ic=b;function I(S){k=S}if(O){const S="__is_disposable_tracked__";I(new class{trackDisposable(v){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[S]||console.log(T)},3e3)}setParent(v,T){if(v&&v!==u.None)try{v[S]=!0}catch{}}markAsDisposed(v){if(v&&v!==u.None)try{v[S]=!0}catch{}}markAsSingleton(v){}})}function $(S){return k?.trackDisposable(S),S}function d(S){k?.markAsDisposed(S)}function g(S,v){k?.setParent(S,v)}function l(S,v){if(k)for(const T of S)k.setParent(T,v)}function m(S){return k?.markAsSingleton(S),S}function E(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function f(S){if(N.Iterable.is(S)){const v=[];for(const T of S)if(T)try{T.dispose()}catch(U){v.push(U)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function w(S){for(const v of S)E(v)&&v.dispose();return[]}function P(...S){const v=p(()=>f(S));return l(S,v),v}function p(S){const v=$({dispose:(0,A.$cb)(()=>{d(v),S()})});return v}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return g(v,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),g(v,null))}}e.$Sc=o;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,$(this),g(this.q,this)}dispose(){d(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Tc=u;class i{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&g(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&g(v,null),v}}e.$Uc=i;class n{constructor(v){this.a=new i,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=n;class t{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=t;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(v){let T=v;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,d(this))},this}}e.$Xc=s;class r{constructor(){this.a=new Map}acquire(v,...T){let U=this.a.get(v);U||(U={counter:0,object:this.b(v,...T)},this.a.set(v,U));const{object:F}=U,j=(0,A.$cb)(()=>{--U.counter===0&&(this.c(v,U.object),this.a.delete(v))});return U.counter++,{object:F,dispose:j}}}e.$Yc=r;class a{constructor(v){this.a=v}async acquire(v,...T){const U=this.a.acquire(v,...T);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(F){throw U.dispose(),F}}}e.$Zc=a;class h{constructor(v){this.object=v}dispose(){}}e.$1c=h;function y(S){const v=new o;try{S(v)}finally{v.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,T,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(v)?.dispose(),this.a.set(v,T)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const T=this.a.get(v);return this.a.delete(v),T}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=L}),define(he[65],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var R;(function(c){c[c.Uri=1]="Uri",c[c.Regexp=2]="Regexp",c[c.ScmResource=3]="ScmResource",c[c.ScmResourceGroup=4]="ScmResourceGroup",c[c.ScmProvider=5]="ScmProvider",c[c.CommentController=6]="CommentController",c[c.CommentThread=7]="CommentThread",c[c.CommentThreadInstance=8]="CommentThreadInstance",c[c.CommentThreadReply=9]="CommentThreadReply",c[c.CommentNode=10]="CommentNode",c[c.CommentThreadNode=11]="CommentThreadNode",c[c.TimelineActionContext=12]="TimelineActionContext",c[c.NotebookCellActionContext=13]="NotebookCellActionContext",c[c.NotebookActionContext=14]="NotebookActionContext",c[c.TerminalContext=15]="TerminalContext",c[c.TestItemContext=16]="TestItemContext",c[c.Date=17]="Date",c[c.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(R||(e.MarshalledId=R={}))}),define(he[90],ue([0,1,31]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=void 0,e.$km=C,e.$lm=N;const c=new R.$Cc(1e4);function C(b){return k(b,"NFC",c)}const A=new R.$Cc(1e4);function N(b){return k(b,"NFD",A)}const O=/[^\u0000-\u0080]/;function k(b,I,$){if(!b)return b;const d=$.get(b);if(d)return d;let g;return O.test(b)?g=b.normalize(I):g=b,$.set(b,g),g}e.$mm=function(){const b=/[\u0300-\u036f]/g;return function(I){return N(I).replace(b,"")}}()}),function(){function oe(C){const A=[];typeof C=="number"&&A.push("code/timeOrigin",C);function N(k){A.push(k,Date.now())}function O(){const k=[];for(let b=0;b<A.length;b+=2)k.push({name:A[b],startTime:A[b+1]});return k}return{mark:N,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(C+N.startTime)});return A}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function R(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var c;typeof global=="object"?c=global:typeof self=="object"?c=self:c={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(c)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(c):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),c.perf=R(c))}(),define(he[5],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=u,e.$E=a,e.$K=h,e.$h="en";let R=!1,c=!1,C=!1,A=!1,N=!1,O=!1,k=!1,b=!1,I=!1,$=!1,d,g=e.$h,l=e.$h,m,E;const f=globalThis;let w;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?w=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const P=typeof w?.versions?.electron=="string",p=P&&w?.type==="renderer";if(typeof w=="object"){R=w.platform==="win32",c=w.platform==="darwin",C=w.platform==="linux",A=C&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,k=P,I=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$h,g=e.$h;const y=w.env.VSCODE_NLS_CONFIG;if(y)try{const L=JSON.parse(y);d=L.userLocale,l=L.osLocale,g=L.resolvedLanguage||e.$h,m=L.languagePack?.translationsConfigFile}catch{}N=!0}else typeof navigator=="object"&&!p?(E=navigator.userAgent,R=E.indexOf("Windows")>=0,c=E.indexOf("Macintosh")>=0,b=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=E.indexOf("Linux")>=0,$=E?.indexOf("Mobi")>=0,O=!0,g=globalThis._VSCODE_NLS_LANGUAGE||e.$h,d=navigator.language.toLowerCase(),l=d):console.error("Unable to resolve platform.");var o;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(o||(e.Platform=o={}));function u(y){switch(y){case o.Web:return"Web";case o.Mac:return"Mac";case o.Linux:return"Linux";case o.Windows:return"Windows"}}let i=o.Web;c?i=o.Mac:R?i=o.Windows:C&&(i=o.Linux),e.$j=R,e.$k=c,e.$l=C,e.$m=A,e.$n=N,e.$o=k,e.$p=O,e.$q=O&&typeof f.importScripts=="function",e.$r=e.$q?f.origin:void 0,e.$s=b,e.$t=$,e.$u=I,e.$v=i,e.$w=E,e.$x=g;var n;(function(y){function L(){return e.$x}y.value=L;function S(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}y.isDefaultVariant=S;function v(){return e.$x==="en"}y.isDefault=v})(n||(e.Language=n={})),e.$y=d,e.$z=l,e.$A=m,e.$B=typeof f.postMessage=="function"&&!f.importScripts,e.$C=(()=>{if(e.$B){const y=[];f.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let v=0,T=y.length;v<T;v++){const U=y[v];if(U.id===S.data.vscodeScheduleAsyncWork){y.splice(v,1),U.callback();return}}});let L=0;return S=>{const v=++L;y.push({id:v,callback:S}),f.postMessage({vscodeScheduleAsyncWork:v},"*")}}return y=>setTimeout(y)})();var t;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=c||b?t.Macintosh:R?t.Windows:t.Linux;let s=!0,r=!1;function a(){if(!r){r=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,s=new Uint16Array(y.buffer)[0]===513}return s}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function h(y){return parseFloat(y)>=20}}),define(he[37],ue([0,1,5]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let c;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const A=C.process;c={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?c={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:c={get platform(){return R.$j?"win32":R.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=c.cwd,e.env=c.env,e.$cc=c.platform,e.$dc=c.arch}),define(he[133],ue([0,1,37]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fX=N;var c;(function(O){O.UNKNOWN="UNKNOWN",O.CINNAMON="CINNAMON",O.DEEPIN="DEEPIN",O.GNOME="GNOME",O.KDE3="KDE3",O.KDE4="KDE4",O.KDE5="KDE5",O.KDE6="KDE6",O.PANTHEON="PANTHEON",O.UNITY="UNITY",O.XFCE="XFCE",O.UKUI="UKUI",O.LXQT="LXQT"})(c||(c={}));const C="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function N(){const O=R.env[C];if(O){const b=O.split(":").map(I=>I.trim()).filter(I=>I.length>0);for(const I of b)switch(I){case"Unity":{const $=R.env.DESKTOP_SESSION;return $&&$.includes("gnome-fallback")?c.GNOME:c.UNITY}case"Deepin":return c.DEEPIN;case"GNOME":return c.GNOME;case"X-Cinnamon":return c.CINNAMON;case"KDE":{const $=R.env[A];return $==="5"?c.KDE5:$==="6"?c.KDE6:c.KDE4}case"Pantheon":return c.PANTHEON;case"XFCE":return c.XFCE;case"UKUI":return c.UKUI;case"LXQt":return c.LXQT}}const k=R.env.DESKTOP_SESSION;if(k)switch(k){case"deepin":return c.DEEPIN;case"gnome":case"mate":return c.GNOME;case"kde4":case"kde-plasma":return c.KDE4;case"kde":return A in R.env?c.KDE4:c.KDE3;case"xfce":case"xubuntu":return c.XFCE;case"ukui":return c.UKUI}return"GNOME_DESKTOP_SESSION_ID"in R.env?c.GNOME:"KDE_FULL_SESSION"in R.env?A in R.env?c.KDE4:c.KDE3:c.UNKNOWN}});var Ot=this&&this.__createBinding||(Object.create?function(oe,e,R,c){c===void 0&&(c=R);var C=Object.getOwnPropertyDescriptor(e,R);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[R]}}),Object.defineProperty(oe,c,C)}:function(oe,e,R,c){c===void 0&&(c=R),oe[c]=e[R]}),At=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),ke=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var R in oe)R!=="default"&&Object.prototype.hasOwnProperty.call(oe,R)&&Ot(e,oe,R);return At(e,oe),e};define(he[13],ue([0,1,37]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0,R=ke(R);const c=65,C=97,A=90,N=122,O=46,k=47,b=92,I=58,$=63;class d extends Error{constructor(n,t,s){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const a=n.indexOf(".")!==-1?"property":"argument";let h=`The "${n}" ${a} ${r} of type ${t}`;h+=`. Received type ${typeof s}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,n){if(i===null||typeof i!="object")throw new d(n,"Object",i)}function l(i,n){if(typeof i!="string")throw new d(n,"string",i)}const m=R.$cc==="win32";function E(i){return i===k||i===b}function f(i){return i===k}function w(i){return i>=c&&i<=A||i>=C&&i<=N}function P(i,n,t,s){let r="",a=0,h=-1,y=0,L=0;for(let S=0;S<=i.length;++S){if(S<i.length)L=i.charCodeAt(S);else{if(s(L))break;L=k}if(s(L)){if(!(h===S-1||y===1))if(y===2){if(r.length<2||a!==2||r.charCodeAt(r.length-1)!==O||r.charCodeAt(r.length-2)!==O){if(r.length>2){const v=r.lastIndexOf(t);v===-1?(r="",a=0):(r=r.slice(0,v),a=r.length-1-r.lastIndexOf(t)),h=S,y=0;continue}else if(r.length!==0){r="",a=0,h=S,y=0;continue}}n&&(r+=r.length>0?`${t}..`:"..",a=2)}else r.length>0?r+=`${t}${i.slice(h+1,S)}`:r=i.slice(h+1,S),a=S-h-1;h=S,y=0}else L===O&&y!==-1?++y:y=-1}return r}function p(i){return i?`${i[0]==="."?"":"."}${i}`:""}function o(i,n){g(n,"pathObject");const t=n.dir||n.root,s=n.base||`${n.name||""}${p(n.ext)}`;return t?t===n.root?`${t}${s}`:`${t}${i}${s}`:s}e.$ec={resolve(...i){let n="",t="",s=!1;for(let r=i.length-1;r>=-1;r--){let a;if(r>=0){if(a=i[r],l(a,`paths[${r}]`),a.length===0)continue}else n.length===0?a=R.cwd():(a=R.env[`=${n}`]||R.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==n.toLowerCase()&&a.charCodeAt(2)===b)&&(a=`${n}\\`));const h=a.length;let y=0,L="",S=!1;const v=a.charCodeAt(0);if(h===1)E(v)&&(y=1,S=!0);else if(E(v))if(S=!0,E(a.charCodeAt(1))){let T=2,U=T;for(;T<h&&!E(a.charCodeAt(T));)T++;if(T<h&&T!==U){const F=a.slice(U,T);for(U=T;T<h&&E(a.charCodeAt(T));)T++;if(T<h&&T!==U){for(U=T;T<h&&!E(a.charCodeAt(T));)T++;(T===h||T!==U)&&(L=`\\\\${F}\\${a.slice(U,T)}`,y=T)}}}else y=1;else w(v)&&a.charCodeAt(1)===I&&(L=a.slice(0,2),y=2,h>2&&E(a.charCodeAt(2))&&(S=!0,y=3));if(L.length>0)if(n.length>0){if(L.toLowerCase()!==n.toLowerCase())continue}else n=L;if(s){if(n.length>0)break}else if(t=`${a.slice(y)}\\${t}`,s=S,S&&n.length>0)break}return t=P(t,!s,"\\",E),s?`${n}\\${t}`:`${n}${t}`||"."},normalize(i){l(i,"path");const n=i.length;if(n===0)return".";let t=0,s,r=!1;const a=i.charCodeAt(0);if(n===1)return f(a)?"\\":i;if(E(a))if(r=!0,E(i.charCodeAt(1))){let y=2,L=y;for(;y<n&&!E(i.charCodeAt(y));)y++;if(y<n&&y!==L){const S=i.slice(L,y);for(L=y;y<n&&E(i.charCodeAt(y));)y++;if(y<n&&y!==L){for(L=y;y<n&&!E(i.charCodeAt(y));)y++;if(y===n)return`\\\\${S}\\${i.slice(L)}\\`;y!==L&&(s=`\\\\${S}\\${i.slice(L,y)}`,t=y)}}}else t=1;else w(a)&&i.charCodeAt(1)===I&&(s=i.slice(0,2),t=2,n>2&&E(i.charCodeAt(2))&&(r=!0,t=3));let h=t<n?P(i.slice(t),!r,"\\",E):"";return h.length===0&&!r&&(h="."),h.length>0&&E(i.charCodeAt(n-1))&&(h+="\\"),s===void 0?r?`\\${h}`:h:r?`${s}\\${h}`:`${s}${h}`},isAbsolute(i){l(i,"path");const n=i.length;if(n===0)return!1;const t=i.charCodeAt(0);return E(t)||n>2&&w(t)&&i.charCodeAt(1)===I&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,t;for(let a=0;a<i.length;++a){const h=i[a];l(h,"path"),h.length>0&&(n===void 0?n=t=h:n+=`\\${h}`)}if(n===void 0)return".";let s=!0,r=0;if(typeof t=="string"&&E(t.charCodeAt(0))){++r;const a=t.length;a>1&&E(t.charCodeAt(1))&&(++r,a>2&&(E(t.charCodeAt(2))?++r:s=!1))}if(s){for(;r<n.length&&E(n.charCodeAt(r));)r++;r>=2&&(n=`\\${n.slice(r)}`)}return e.$ec.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n)return"";const t=e.$ec.resolve(i),s=e.$ec.resolve(n);if(t===s||(i=t.toLowerCase(),n=s.toLowerCase(),i===n))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===b;)r++;let a=i.length;for(;a-1>r&&i.charCodeAt(a-1)===b;)a--;const h=a-r;let y=0;for(;y<n.length&&n.charCodeAt(y)===b;)y++;let L=n.length;for(;L-1>y&&n.charCodeAt(L-1)===b;)L--;const S=L-y,v=h<S?h:S;let T=-1,U=0;for(;U<v;U++){const j=i.charCodeAt(r+U);if(j!==n.charCodeAt(y+U))break;j===b&&(T=U)}if(U!==v){if(T===-1)return s}else{if(S>v){if(n.charCodeAt(y+U)===b)return s.slice(y+U+1);if(U===2)return s.slice(y+U)}h>v&&(i.charCodeAt(r+U)===b?T=U:U===2&&(T=3)),T===-1&&(T=0)}let F="";for(U=r+T+1;U<=a;++U)(U===a||i.charCodeAt(U)===b)&&(F+=F.length===0?"..":"\\..");return y+=T,F.length>0?`${F}${s.slice(y,L)}`:(s.charCodeAt(y)===b&&++y,s.slice(y,L))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.$ec.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===b){if(n.charCodeAt(1)===b){const t=n.charCodeAt(2);if(t!==$&&t!==O)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(w(n.charCodeAt(0))&&n.charCodeAt(1)===I&&n.charCodeAt(2)===b)return`\\\\?\\${n}`;return i},dirname(i){l(i,"path");const n=i.length;if(n===0)return".";let t=-1,s=0;const r=i.charCodeAt(0);if(n===1)return E(r)?i:".";if(E(r)){if(t=s=1,E(i.charCodeAt(1))){let y=2,L=y;for(;y<n&&!E(i.charCodeAt(y));)y++;if(y<n&&y!==L){for(L=y;y<n&&E(i.charCodeAt(y));)y++;if(y<n&&y!==L){for(L=y;y<n&&!E(i.charCodeAt(y));)y++;if(y===n)return i;y!==L&&(t=s=y+1)}}}}else w(r)&&i.charCodeAt(1)===I&&(t=n>2&&E(i.charCodeAt(2))?3:2,s=t);let a=-1,h=!0;for(let y=n-1;y>=s;--y)if(E(i.charCodeAt(y))){if(!h){a=y;break}}else h=!1;if(a===-1){if(t===-1)return".";a=t}return i.slice(0,a)},basename(i,n){n!==void 0&&l(n,"suffix"),l(i,"path");let t=0,s=-1,r=!0,a;if(i.length>=2&&w(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(t=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let h=n.length-1,y=-1;for(a=i.length-1;a>=t;--a){const L=i.charCodeAt(a);if(E(L)){if(!r){t=a+1;break}}else y===-1&&(r=!1,y=a+1),h>=0&&(L===n.charCodeAt(h)?--h===-1&&(s=a):(h=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(a=i.length-1;a>=t;--a)if(E(i.charCodeAt(a))){if(!r){t=a+1;break}}else s===-1&&(r=!1,s=a+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=0,t=-1,s=0,r=-1,a=!0,h=0;i.length>=2&&i.charCodeAt(1)===I&&w(i.charCodeAt(0))&&(n=s=2);for(let y=i.length-1;y>=n;--y){const L=i.charCodeAt(y);if(E(L)){if(!a){s=y+1;break}continue}r===-1&&(a=!1,r=y+1),L===O?t===-1?t=y:h!==1&&(h=1):t!==-1&&(h=-1)}return t===-1||r===-1||h===0||h===1&&t===r-1&&t===s+1?"":i.slice(t,r)},format:o.bind(null,"\\"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.length;let s=0,r=i.charCodeAt(0);if(t===1)return E(r)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(E(r)){if(s=1,E(i.charCodeAt(1))){let T=2,U=T;for(;T<t&&!E(i.charCodeAt(T));)T++;if(T<t&&T!==U){for(U=T;T<t&&E(i.charCodeAt(T));)T++;if(T<t&&T!==U){for(U=T;T<t&&!E(i.charCodeAt(T));)T++;T===t?s=T:T!==U&&(s=T+1)}}}}else if(w(r)&&i.charCodeAt(1)===I){if(t<=2)return n.root=n.dir=i,n;if(s=2,E(i.charCodeAt(2))){if(t===3)return n.root=n.dir=i,n;s=3}}s>0&&(n.root=i.slice(0,s));let a=-1,h=s,y=-1,L=!0,S=i.length-1,v=0;for(;S>=s;--S){if(r=i.charCodeAt(S),E(r)){if(!L){h=S+1;break}continue}y===-1&&(L=!1,y=S+1),r===O?a===-1?a=S:v!==1&&(v=1):a!==-1&&(v=-1)}return y!==-1&&(a===-1||v===0||v===1&&a===y-1&&a===h+1?n.base=n.name=i.slice(h,y):(n.name=i.slice(h,a),n.base=i.slice(h,y),n.ext=i.slice(a,y))),h>0&&h!==s?n.dir=i.slice(0,h-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(m){const i=/\\/g;return()=>{const n=R.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>R.cwd()})();e.$fc={resolve(...i){let n="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const r=s>=0?i[s]:u();l(r,`paths[${s}]`),r.length!==0&&(n=`${r}/${n}`,t=r.charCodeAt(0)===k)}return n=P(n,!t,"/",f),t?`/${n}`:n.length>0?n:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===k,t=i.charCodeAt(i.length-1)===k;return i=P(i,!n,"/",f),i.length===0?n?"/":t?"./":".":(t&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===k},join(...i){if(i.length===0)return".";let n;for(let t=0;t<i.length;++t){const s=i[t];l(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.$fc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n||(i=e.$fc.resolve(i),n=e.$fc.resolve(n),i===n))return"";const t=1,s=i.length,r=s-t,a=1,h=n.length-a,y=r<h?r:h;let L=-1,S=0;for(;S<y;S++){const T=i.charCodeAt(t+S);if(T!==n.charCodeAt(a+S))break;T===k&&(L=S)}if(S===y)if(h>y){if(n.charCodeAt(a+S)===k)return n.slice(a+S+1);if(S===0)return n.slice(a+S)}else r>y&&(i.charCodeAt(t+S)===k?L=S:S===0&&(L=0));let v="";for(S=t+L+1;S<=s;++S)(S===s||i.charCodeAt(S)===k)&&(v+=v.length===0?"..":"/..");return`${v}${n.slice(a+L)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===k;let t=-1,s=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===k){if(!s){t=r;break}}else s=!1;return t===-1?n?"/":".":n&&t===1?"//":i.slice(0,t)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let t=0,s=-1,r=!0,a;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let h=n.length-1,y=-1;for(a=i.length-1;a>=0;--a){const L=i.charCodeAt(a);if(L===k){if(!r){t=a+1;break}}else y===-1&&(r=!1,y=a+1),h>=0&&(L===n.charCodeAt(h)?--h===-1&&(s=a):(h=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===k){if(!r){t=a+1;break}}else s===-1&&(r=!1,s=a+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=-1,t=0,s=-1,r=!0,a=0;for(let h=i.length-1;h>=0;--h){const y=i.charCodeAt(h);if(y===k){if(!r){t=h+1;break}continue}s===-1&&(r=!1,s=h+1),y===O?n===-1?n=h:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||s===-1||a===0||a===1&&n===s-1&&n===t+1?"":i.slice(n,s)},format:o.bind(null,"/"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.charCodeAt(0)===k;let s;t?(n.root="/",s=1):s=0;let r=-1,a=0,h=-1,y=!0,L=i.length-1,S=0;for(;L>=s;--L){const v=i.charCodeAt(L);if(v===k){if(!y){a=L+1;break}continue}h===-1&&(y=!1,h=L+1),v===O?r===-1?r=L:S!==1&&(S=1):r!==-1&&(S=-1)}if(h!==-1){const v=a===0&&t?1:a;r===-1||S===0||S===1&&r===h-1&&r===a+1?n.base=n.name=i.slice(v,h):(n.name=i.slice(v,r),n.base=i.slice(v,h),n.ext=i.slice(r,h))}return a>0?n.dir=i.slice(0,a-1):t&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=m?e.$ec.normalize:e.$fc.normalize,e.$hc=m?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=m?e.$ec.join:e.$fc.join,e.$jc=m?e.$ec.resolve:e.$fc.resolve,e.$kc=m?e.$ec.relative:e.$fc.relative,e.$lc=m?e.$ec.dirname:e.$fc.dirname,e.$mc=m?e.$ec.basename:e.$fc.basename,e.$nc=m?e.$ec.extname:e.$fc.extname,e.$oc=m?e.$ec.format:e.$fc.format,e.$pc=m?e.$ec.parse:e.$fc.parse,e.$qc=m?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=m?e.$ec.sep:e.$fc.sep,e.$sc=m?e.$ec.delimiter:e.$fc.delimiter}),define(he[134],ue([0,1,13]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$9s=A,e.$0s=N,e.$$s=O,e.$_s=b,e.$8s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const c={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const $=(0,R.$nc)(I),d=c[$.toLowerCase()];return d!==void 0?d:N(I)}function N(I){const $=(0,R.$nc)(I);return C[$.toLowerCase()]}function O(I){for(const $ in C)if(C[$]===I)return $}const k=/^(.+)\/(.+?)(;.+)?$/;function b(I,$){const d=k.exec(I);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:$?void 0:I}}),define(he[91],ue([0,1,5]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$im=A,e.$jm=N;var c;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(c||(e.Source=c={}));var C;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function A(O,...k){const b=k.reduce((d,g)=>(d[g]=!0,d),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(d=>!b[d]).forEach(d=>{for(let g=0;g<I.length;g++)if(d.search(I[g])!==-1){delete O[d];break}})}function N(O){O&&(delete O.DEBUG,R.$l&&delete O.LD_PRELOAD)}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var c in R)(typeof exports=="object"?exports:oe)[c]=R[c]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function R(c){if(e[c])return e[c].exports;var C=e[c]={i:c,l:!1,exports:{}};return oe[c].call(C.exports,C,C.exports,R),C.l=!0,C.exports}return R.m=oe,R.c=e,R.d=function(c,C,A){R.o(c,C)||Object.defineProperty(c,C,{enumerable:!0,get:A})},R.r=function(c){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(c,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(c,"__esModule",{value:!0})},R.t=function(c,C){if(1&C&&(c=R(c)),8&C||4&C&&typeof c=="object"&&c&&c.__esModule)return c;var A=Object.create(null);if(R.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:c}),2&C&&typeof c!="string")for(var N in c)R.d(A,N,function(O){return c[O]}.bind(null,N));return A},R.n=function(c){var C=c&&c.__esModule?function(){return c.default}:function(){return c};return R.d(C,"a",C),C},R.o=function(c,C){return Object.prototype.hasOwnProperty.call(c,C)},R.p="",R(R.s=0)}([function(oe,e,R){(function(c){var C;e=oe.exports=X,C=typeof c=="object"&&c.env&&c.env.NODE_DEBUG&&/\bsemver\b/i.test(c.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],k=e.src=[],b=0,I=b++;k[I]="0|[1-9]\\d*";var $=b++;k[$]="[0-9]+";var d=b++;k[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=b++;k[g]="("+k[I]+")\\.("+k[I]+")\\.("+k[I]+")";var l=b++;k[l]="("+k[$]+")\\.("+k[$]+")\\.("+k[$]+")";var m=b++;k[m]="(?:"+k[I]+"|"+k[d]+")";var E=b++;k[E]="(?:"+k[$]+"|"+k[d]+")";var f=b++;k[f]="(?:-("+k[m]+"(?:\\."+k[m]+")*))";var w=b++;k[w]="(?:-?("+k[E]+"(?:\\."+k[E]+")*))";var P=b++;k[P]="[0-9A-Za-z-]+";var p=b++;k[p]="(?:\\+("+k[P]+"(?:\\."+k[P]+")*))";var o=b++,u="v?"+k[g]+k[f]+"?"+k[p]+"?";k[o]="^"+u+"$";var i="[v=\\s]*"+k[l]+k[w]+"?"+k[p]+"?",n=b++;k[n]="^"+i+"$";var t=b++;k[t]="((?:<|>)?=?)";var s=b++;k[s]=k[$]+"|x|X|\\*";var r=b++;k[r]=k[I]+"|x|X|\\*";var a=b++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[f]+")?"+k[p]+"?)?)?";var h=b++;k[h]="[v=\\s]*("+k[s]+")(?:\\.("+k[s]+")(?:\\.("+k[s]+")(?:"+k[w]+")?"+k[p]+"?)?)?";var y=b++;k[y]="^"+k[t]+"\\s*"+k[a]+"$";var L=b++;k[L]="^"+k[t]+"\\s*"+k[h]+"$";var S=b++;k[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=b++;k[v]="(?:~>?)";var T=b++;k[T]="(\\s*)"+k[v]+"\\s+",O[T]=new RegExp(k[T],"g");var U=b++;k[U]="^"+k[v]+k[a]+"$";var F=b++;k[F]="^"+k[v]+k[h]+"$";var j=b++;k[j]="(?:\\^)";var G=b++;k[G]="(\\s*)"+k[j]+"\\s+",O[G]=new RegExp(k[G],"g");var V=b++;k[V]="^"+k[j]+k[a]+"$";var x=b++;k[x]="^"+k[j]+k[h]+"$";var H=b++;k[H]="^"+k[t]+"\\s*("+i+")$|^$";var ie=b++;k[ie]="^"+k[t]+"\\s*("+u+")$|^$";var z=b++;k[z]="(\\s*)"+k[t]+"\\s*("+i+"|"+k[a]+")",O[z]=new RegExp(k[z],"g");var W=b++;k[W]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var ee=b++;k[ee]="^\\s*("+k[h]+")\\s+-\\s+("+k[h]+")\\s*$";var ne=b++;k[ne]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)C(ce,k[ce]),O[ce]||(O[ce]=new RegExp(k[ce]));function te(ae,de){if(ae instanceof X)return ae;if(typeof ae!="string"||ae.length>A||!(de?O[n]:O[o]).test(ae))return null;try{return new X(ae,de)}catch{return null}}function X(ae,de){if(ae instanceof X){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof X))return new X(ae,de);C("SemVer",ae,de),this.loose=de;var me=ae.trim().match(de?O[n]:O[o]);if(!me)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Oe=+Pe;if(Oe>=0&&Oe<N)return Oe}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=te,e.valid=function(ae,de){var me=te(ae,de);return me?me.version:null},e.clean=function(ae,de){var me=te(ae.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(ae){return C("SemVer.compare",this.version,this.loose,ae),ae instanceof X||(ae=new X(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},X.prototype.compareMain=function(ae){return ae instanceof X||(ae=new X(ae,this.loose)),B(this.major,ae.major)||B(this.minor,ae.minor)||B(this.patch,ae.patch)},X.prototype.comparePre=function(ae){if(ae instanceof X||(ae=new X(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Pe=ae.prerelease[de];if(C("prerelease compare",de,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return B(me,Pe)}while(++de)},X.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new X(ae,me).inc(de,Pe).version}catch{return null}},e.diff=function(ae,de){if(M(ae,de))return null;var me=te(ae),Pe=te(de);if(me.prerelease.length||Pe.prerelease.length){for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return Oe},e.compareIdentifiers=B;var K=/^[0-9]+$/;function B(ae,de){var me=K.test(ae),Pe=K.test(de);return me&&Pe&&(ae=+ae,de=+de),me&&!Pe?-1:Pe&&!me?1:ae<de?-1:ae>de?1:0}function D(ae,de,me){return new X(ae,me).compare(new X(de,me))}function J(ae,de,me){return D(ae,de,me)>0}function q(ae,de,me){return D(ae,de,me)<0}function M(ae,de,me){return D(ae,de,me)===0}function Q(ae,de,me){return D(ae,de,me)!==0}function _(ae,de,me){return D(ae,de,me)>=0}function Y(ae,de,me){return D(ae,de,me)<=0}function re(ae,de,me,Pe){var Oe;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Oe=ae===me;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Oe=ae!==me;break;case"":case"=":case"==":Oe=M(ae,me,Pe);break;case"!=":Oe=Q(ae,me,Pe);break;case">":Oe=J(ae,me,Pe);break;case">=":Oe=_(ae,me,Pe);break;case"<":Oe=q(ae,me,Pe);break;case"<=":Oe=Y(ae,me,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Oe}function le(ae,de){if(ae instanceof le){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof le))return new le(ae,de);C("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ae,de){return B(de,ae)},e.major=function(ae,de){return new X(ae,de).major},e.minor=function(ae,de){return new X(ae,de).minor},e.patch=function(ae,de){return new X(ae,de).patch},e.compare=D,e.compareLoose=function(ae,de){return D(ae,de,!0)},e.rcompare=function(ae,de,me){return D(de,ae,me)},e.sort=function(ae,de){return ae.sort(function(me,Pe){return e.compare(me,Pe,de)})},e.rsort=function(ae,de){return ae.sort(function(me,Pe){return e.rcompare(me,Pe,de)})},e.gt=J,e.lt=q,e.eq=M,e.neq=Q,e.gte=_,e.lte=Y,e.cmp=re,e.Comparator=le;var ge={};function pe(ae,de){if(ae instanceof pe)return ae.loose===de?ae:new pe(ae.raw,de);if(ae instanceof le)return new pe(ae.value,de);if(!(this instanceof pe))return new pe(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ee(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function we(ae,de,me,Pe,Oe,Fe,Ne,Le,Ue,qe,He,je,Be){return((de=Ee(me)?"":Ee(Pe)?">="+me+".0.0":Ee(Oe)?">="+me+"."+Pe+".0":">="+de)+" "+(Le=Ee(Ue)?"":Ee(qe)?"<"+(+Ue+1)+".0.0":Ee(He)?"<"+Ue+"."+(+qe+1)+".0":je?"<="+Ue+"."+qe+"."+He+"-"+je:"<="+Le)).trim()}function be(ae,de){for(var me=0;me<ae.length;me++)if(!ae[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<ae.length;me++)if(C(ae[me].semver),ae[me].semver!==ge&&ae[me].semver.prerelease.length>0){var Pe=ae[me].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Se(ae,de,me){try{de=new pe(de,me)}catch{return!1}return de.test(ae)}function Re(ae,de,me,Pe){var Oe,Fe,Ne,Le,Ue;switch(ae=new X(ae,Pe),de=new pe(de,Pe),me){case">":Oe=J,Fe=Y,Ne=q,Le=">",Ue=">=";break;case"<":Oe=q,Fe=_,Ne=J,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(ae,de,Pe))return!1;for(var qe=0;qe<de.set.length;++qe){var He=de.set[qe],je=null,Be=null;if(He.forEach(function(ze){ze.semver===ge&&(ze=new le(">=0.0.0")),je=je||ze,Be=Be||ze,Oe(ze.semver,je.semver,Pe)?je=ze:Ne(ze.semver,Be.semver,Pe)&&(Be=ze)}),je.operator===Le||je.operator===Ue||(!Be.operator||Be.operator===Le)&&Fe(ae,Be.semver)||Be.operator===Ue&&Ne(ae,Be.semver))return!1}return!0}le.prototype.parse=function(ae){var de=this.loose?O[H]:O[ie],me=ae.match(de);if(!me)throw new TypeError("Invalid comparator: "+ae);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new X(me[2],this.loose):this.semver=ge},le.prototype.toString=function(){return this.value},le.prototype.test=function(ae){return C("Comparator.test",ae,this.loose),this.semver===ge||(typeof ae=="string"&&(ae=new X(ae,this.loose)),re(ae,this.operator,this.semver,this.loose))},le.prototype.intersects=function(ae,de){if(!(ae instanceof le))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(ae.value,de),Se(this.value,me,de);if(ae.operator==="")return me=new pe(this.value,de),Se(ae.semver,me,de);var Pe=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Fe=this.semver.version===ae.semver.version,Ne=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Le=re(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ue=re(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Pe||Oe||Fe&&Ne||Le||Ue},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),C("range",ae,de);var me=de?O[ee]:O[W];ae=ae.replace(me,we),C("hyphen replace",ae),ae=ae.replace(O[z],"$1$2$3"),C("comparator trim",ae,O[z]),ae=(ae=(ae=ae.replace(O[T],"$1~")).replace(O[G],"$1^")).split(/\s+/).join(" ");var Pe=de?O[H]:O[ie],Oe=ae.split(" ").map(function(Fe){return function(Ne,Le){return C("comp",Ne),Ne=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(je,Be){C("caret",je,Be);var ze=Be?O[x]:O[V];return je.replace(ze,function(We,Ce,se,fe,$e){var ye;return C("caret",je,We,Ce,se,fe,$e),Ee(Ce)?ye="":Ee(se)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ee(fe)?ye=Ce==="0"?">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+".0 <"+(+Ce+1)+".0.0":$e?(C("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+se+"."+(+fe+1):">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+fe+$e+" <"+(+Ce+1)+".0.0"):(C("no pr"),ye=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+fe+" <"+Ce+"."+se+"."+(+fe+1):">="+Ce+"."+se+"."+fe+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+fe+" <"+(+Ce+1)+".0.0"),C("caret return",ye),ye})}(He,qe)}).join(" ")}(Ne,Le),C("caret",Ne),Ne=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(je,Be){var ze=Be?O[F]:O[U];return je.replace(ze,function(We,Ce,se,fe,$e){var ye;return C("tilde",je,We,Ce,se,fe,$e),Ee(Ce)?ye="":Ee(se)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ee(fe)?ye=">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":$e?(C("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+(+se+1)+".0"):ye=">="+Ce+"."+se+"."+fe+" <"+Ce+"."+(+se+1)+".0",C("tilde return",ye),ye})}(He,qe)}).join(" ")}(Ne,Le),C("tildes",Ne),Ne=function(Ue,qe){return C("replaceXRanges",Ue,qe),Ue.split(/\s+/).map(function(He){return function(je,Be){je=je.trim();var ze=Be?O[L]:O[y];return je.replace(ze,function(We,Ce,se,fe,$e,ye){C("xRange",je,We,Ce,se,fe,$e,ye);var Ae=Ee(se),Te=Ae||Ee(fe),Me=Te||Ee($e);return Ce==="="&&Me&&(Ce=""),Ae?We=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Me?(Te&&(fe=0),Me&&($e=0),Ce===">"?(Ce=">=",Te?(se=+se+1,fe=0,$e=0):Me&&(fe=+fe+1,$e=0)):Ce==="<="&&(Ce="<",Te?se=+se+1:fe=+fe+1),We=Ce+se+"."+fe+"."+$e):Te?We=">="+se+".0.0 <"+(+se+1)+".0.0":Me&&(We=">="+se+"."+fe+".0 <"+se+"."+(+fe+1)+".0"),C("xRange return",We),We})}(He,qe)}).join(" ")}(Ne,Le),C("xrange",Ne),Ne=function(Ue,qe){return C("replaceStars",Ue,qe),Ue.trim().replace(O[ne],"")}(Ne,Le),C("stars",Ne),Ne}(Fe,de)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Fe){return!!Fe.match(Pe)})),Oe=Oe.map(function(Fe){return new le(Fe,de)})},pe.prototype.intersects=function(ae,de){if(!(ae instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return ae.set.some(function(Oe){return Oe.every(function(Fe){return Pe.intersects(Fe,de)})})})})},e.toComparators=function(ae,de){return new pe(ae,de).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new X(ae,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],ae))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(ae,de,me){var Pe=null,Oe=null;try{var Fe=new pe(de,me)}catch{return null}return ae.forEach(function(Ne){Fe.test(Ne)&&(Pe&&Oe.compare(Ne)!==-1||(Oe=new X(Pe=Ne,me)))}),Pe},e.minSatisfying=function(ae,de,me){var Pe=null,Oe=null;try{var Fe=new pe(de,me)}catch{return null}return ae.forEach(function(Ne){Fe.test(Ne)&&(Pe&&Oe.compare(Ne)!==1||(Oe=new X(Pe=Ne,me)))}),Pe},e.validRange=function(ae,de){try{return new pe(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,me){return Re(ae,de,"<",me)},e.gtr=function(ae,de,me){return Re(ae,de,">",me)},e.outside=Re,e.prerelease=function(ae,de){var me=te(ae,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(ae,de,me){return ae=new pe(ae,me),de=new pe(de,me),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof X)return ae;if(typeof ae!="string")return null;var de=ae.match(O[S]);return de==null?null:te((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(oe,e){var R,c,C=oe.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function O(E){if(R===setTimeout)return setTimeout(E,0);if((R===A||!R)&&setTimeout)return R=setTimeout,setTimeout(E,0);try{return R(E,0)}catch{try{return R.call(null,E,0)}catch{return R.call(this,E,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:A}catch{R=A}try{c=typeof clearTimeout=="function"?clearTimeout:N}catch{c=N}})();var k,b=[],I=!1,$=-1;function d(){I&&k&&(I=!1,k.length?b=k.concat(b):$=-1,b.length&&g())}function g(){if(!I){var E=O(d);I=!0;for(var f=b.length;f;){for(k=b,b=[];++$<f;)k&&k[$].run();$=-1,f=b.length}k=null,I=!1,function(w){if(c===clearTimeout)return clearTimeout(w);if((c===N||!c)&&clearTimeout)return c=clearTimeout,clearTimeout(w);try{c(w)}catch{try{return c.call(null,w)}catch{return c.call(this,w)}}}(E)}}function l(E,f){this.fun=E,this.array=f}function m(){}C.nextTick=function(E){var f=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)f[w-1]=arguments[w];b.push(new l(E,f)),b.length!==1||I||O(g)},l.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=m,C.addListener=m,C.once=m,C.off=m,C.removeListener=m,C.removeAllListeners=m,C.emit=m,C.prependListener=m,C.prependOnceListener=m,C.listeners=function(E){return[]},C.binding=function(E){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(E){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(he[135],ue([0,1]),function(oe,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class c{constructor(O,k,b){this.level=O,this.key=k,this.value=b,this.forward=[]}}const C=void 0;class A{constructor(O,k=2**16){this.comparator=O,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new c(this.c,C,C)}get size(){return this.f}clear(){this.e=new c(this.c,C,C),this.f=0}has(O){return!!A.g(this,O,this.comparator)}get(O){return A.g(this,O,this.comparator)?.value}set(O,k){return A.h(this,O,k,this.comparator)&&(this.f+=1),this}delete(O){const k=A.k(this,O,this.comparator);return k&&(this.f-=1),k}forEach(O,k){let b=this.e.forward[0];for(;b;)O.call(k,b.value,b.key,this),b=b.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",k=this.e.forward[0];for(;k;)O+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return O}static g(O,k,b){let I=O.e;for(let $=O.d-1;$>=0;$--)for(;I.forward[$]&&b(I.forward[$].key,k)<0;)I=I.forward[$];if(I=I.forward[0],I&&b(I.key,k)===0)return I}static h(O,k,b,I){const $=[];let d=O.e;for(let g=O.d-1;g>=0;g--){for(;d.forward[g]&&I(d.forward[g].key,k)<0;)d=d.forward[g];$[g]=d}if(d=d.forward[0],d&&I(d.key,k)===0)return d.value=b,!1;{const g=A.j(O);if(g>O.d){for(let l=O.d;l<g;l++)$[l]=O.e;O.d=g}d=new c(g,k,b);for(let l=0;l<g;l++)d.forward[l]=$[l].forward[l],$[l].forward[l]=d;return!0}}static j(O,k=.5){let b=1;for(;Math.random()<k&&b<O.c;)b+=1;return b}static k(O,k,b){const I=[];let $=O.e;for(let d=O.d-1;d>=0;d--){for(;$.forward[d]&&b($.forward[d].key,k)<0;)$=$.forward[d];I[d]=$}if($=$.forward[0],!$||b($.key,k)!==0)return!1;for(let d=0;d<O.d&&I[d].forward[d]===$;d++)I[d].forward[d]=$.forward[d];for(;O.d>0&&O.e.forward[O.d-1]===C;)O.d-=1;return!0}}e.$Qs=A}),define(he[54],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class c{static create(A){return new c(A)}constructor(A){this.c=R&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=c}),define(he[3],ue([0,1,8,88,2,89,54]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=g;const O=!1,k=!1,b=!1;var I;(function(F){F.None=()=>C.$Tc.None;function j(we){if(b){const{onDidAddListener:be}=we,Se=m.create();let Re=0;we.onDidAddListener=()=>{++Re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),be?.()}}}function G(we,be){return te(we,()=>{},0,void 0,!0,void 0,be)}F.defer=G;function V(we){return(be,Se=null,Re)=>{let ae=!1,de;return de=we(me=>{if(!ae)return de?de.dispose():ae=!0,be.call(Se,me)},null,Re),ae&&de.dispose(),de}}F.once=V;function x(we,be,Se){return ne((Re,ae=null,de)=>we(me=>Re.call(ae,be(me)),null,de),Se)}F.map=x;function H(we,be,Se){return ne((Re,ae=null,de)=>we(me=>{be(me),Re.call(ae,me)},null,de),Se)}F.forEach=H;function ie(we,be,Se){return ne((Re,ae=null,de)=>we(me=>be(me)&&Re.call(ae,me),null,de),Se)}F.filter=ie;function z(we){return we}F.signal=z;function W(...we){return(be,Se=null,Re)=>{const ae=(0,C.$Qc)(...we.map(de=>de(me=>be.call(Se,me))));return ce(ae,Re)}}F.any=W;function ee(we,be,Se,Re){let ae=Se;return x(we,de=>(ae=be(ae,de),ae),Re)}F.reduce=ee;function ne(we,be){let Se;const Re={onWillAddFirstListener(){Se=we(ae.fire,ae)},onDidRemoveLastListener(){Se?.dispose()}};be||j(Re);const ae=new i(Re);return be?.add(ae),ae.event}function ce(we,be){return be instanceof Array?be.push(we):be&&be.add(we),we}function te(we,be,Se=100,Re=!1,ae=!1,de,me){let Pe,Oe,Fe,Ne=0,Le;const Ue={leakWarningThreshold:de,onWillAddFirstListener(){Pe=we(He=>{Ne++,Oe=be(Oe,He),Re&&!Fe&&(qe.fire(Oe),Oe=void 0),Le=()=>{const je=Oe;Oe=void 0,Fe=void 0,(!Re||Ne>1)&&qe.fire(je),Ne=0},typeof Se=="number"?(clearTimeout(Fe),Fe=setTimeout(Le,Se)):Fe===void 0&&(Fe=0,queueMicrotask(Le))})},onWillRemoveListener(){ae&&Ne>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,Pe.dispose()}};me||j(Ue);const qe=new i(Ue);return me?.add(qe),qe.event}F.debounce=te;function X(we,be=0,Se){return F.debounce(we,(Re,ae)=>Re?(Re.push(ae),Re):[ae],be,void 0,!0,void 0,Se)}F.accumulate=X;function K(we,be=(Re,ae)=>Re===ae,Se){let Re=!0,ae;return ie(we,de=>{const me=Re||!be(de,ae);return Re=!1,ae=de,me},Se)}F.latch=K;function B(we,be,Se){return[F.filter(we,be,Se),F.filter(we,Re=>!be(Re),Se)]}F.split=B;function D(we,be=!1,Se=[],Re){let ae=Se.slice(),de=we(Oe=>{ae?ae.push(Oe):Pe.fire(Oe)});Re&&Re.add(de);const me=()=>{ae?.forEach(Oe=>Pe.fire(Oe)),ae=null},Pe=new i({onWillAddFirstListener(){de||(de=we(Oe=>Pe.fire(Oe)),Re&&Re.add(de))},onDidAddFirstListener(){ae&&(be?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Re&&Re.add(Pe),Pe.event}F.buffer=D;function J(we,be){return(Re,ae,de)=>{const me=be(new M);return we(function(Pe){const Oe=me.evaluate(Pe);Oe!==q&&Re.call(ae,Oe)},void 0,de)}}F.chain=J;const q=Symbol("HaltChainable");class M{constructor(){this.f=[]}map(be){return this.f.push(be),this}forEach(be){return this.f.push(Se=>(be(Se),Se)),this}filter(be){return this.f.push(Se=>be(Se)?Se:q),this}reduce(be,Se){let Re=Se;return this.f.push(ae=>(Re=be(Re,ae),Re)),this}latch(be=(Se,Re)=>Se===Re){let Se=!0,Re;return this.f.push(ae=>{const de=Se||!be(ae,Re);return Se=!1,Re=ae,de?ae:q}),this}evaluate(be){for(const Se of this.f)if(be=Se(be),be===q)break;return be}}function Q(we,be,Se=Re=>Re){const Re=(...Pe)=>me.fire(Se(...Pe)),ae=()=>we.on(be,Re),de=()=>we.removeListener(be,Re),me=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}F.fromNodeEventEmitter=Q;function _(we,be,Se=Re=>Re){const Re=(...Pe)=>me.fire(Se(...Pe)),ae=()=>we.addEventListener(be,Re),de=()=>we.removeEventListener(be,Re),me=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}F.fromDOMEventEmitter=_;function Y(we){return new Promise(be=>V(we)(be))}F.toPromise=Y;function re(we){const be=new i;return we.then(Se=>{be.fire(Se)},()=>{be.fire(void 0)}).finally(()=>{be.dispose()}),be.event}F.fromPromise=re;function le(we,be,Se){return be(Se),we(Re=>be(Re))}F.runAndSubscribe=le;class ge{constructor(be,Se){this._observable=be,this.f=0,this.g=!1;const Re={onWillAddFirstListener:()=>{be.addObserver(this)},onDidRemoveLastListener:()=>{be.removeObserver(this)}};Se||j(Re),this.emitter=new i(Re),Se&&Se.add(this.emitter)}beginUpdate(be){this.f++}handlePossibleChange(be){}handleChange(be,Se){this.g=!0}endUpdate(be){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(we,be){return new ge(we,be).emitter.event}F.fromObservable=pe;function Ee(we){return(be,Se,Re)=>{let ae=0,de=!1;const me={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(we.reportChanges(),de&&(de=!1,be.call(Se)))},handlePossibleChange(){},handleChange(){de=!0}};we.addObserver(me),we.reportChanges();const Pe={dispose(){we.removeObserver(me)}};return Re instanceof C.$Sc?Re.add(Pe):Array.isArray(Re)&&Re.push(Pe),Pe}}F.fromObservableLight=Ee})(I||(e.Event=I={}));class ${static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${$.f++}`,$.all.add(this)}start(j){this.g=new N.$de,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$fe=$;let d=-1;function g(F){const j=d;return d=F,{dispose(){d=j}}}class l{static{this.f=1}constructor(j,G,V=(l.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=G,this.name=V,this.h=0}dispose(){this.g?.clear()}check(j,G){const V=this.threshold;if(V<=0||G<V)return;this.g||(this.g=new Map);const x=this.g.get(j.value)||0;if(this.g.set(j.value,x+1),this.h-=1,this.h<=0){this.h=V*.5;const[H,ie]=this.getMostFrequentStack(),z=`[${this.name}] potential listener LEAK detected, having ${G} listeners already. MOST frequent listener (${ie}):`;console.warn(z),console.warn(H);const W=new E(z,H);this.j(W)}return()=>{const H=this.g.get(j.value)||0;this.g.set(j.value,H-1)}}getMostFrequentStack(){if(!this.g)return;let j,G=0;for(const[V,x]of this.g)(!j||G<x)&&(j=[V,x],G=x);return j}}class m{static create(){const j=new Error;return new m(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(j,G){super(j),this.name="ListenerLeakError",this.stack=G}}e.$he=E;class f extends Error{constructor(j,G){super(j),this.name="ListenerRefusalError",this.stack=G}}e.$ie=f;let w=0;class P{constructor(j){this.value=j,this.id=w++}}const p=2,o=(F,j)=>{if(F instanceof P)j(F);else for(let G=0;G<F.length;G++){const V=F[G];V&&j(V)}};let u;if(O){const F=[];setInterval(()=>{F.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(F.join(`
`)),F.length=0)},3e3),u=new FinalizationRegistry(j=>{typeof j=="string"&&F.push(j)})}class i{constructor(j){this.z=0,this.f=j,this.g=d>0||this.f?.leakWarningThreshold?new l(j?.onListenerError??R.$Y,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(k){const j=this.u;queueMicrotask(()=>{o(j,G=>G.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,G,V)=>{if(this.g&&this.z>this.g.threshold**2){const W=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(W);const ee=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new f(`${W}. HINT: Stack shows most frequent listener (${ee[1]}-times)`,ee[0]);return(this.f?.onListenerError||R.$Y)(ne),C.$Tc.None}if(this.m)return C.$Tc.None;G&&(j=j.bind(G));const x=new P(j);let H,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=m.create(),H=this.g.check(x.stack,this.z+1)),k&&(x.stack=ie??m.create()),this.u?this.u instanceof P?(this.w??=new t,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const z=(0,C.$Rc)(()=>{u?.unregister(z),H?.(),this.A(x)});if(V instanceof C.$Sc?V.add(z):Array.isArray(V)&&V.push(z),u){const W=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ee=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(W);u.register(z,ee?.[2]??W,z)}return z},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const G=this.u,V=G.indexOf(j);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,G[V]=void 0;const x=this.w.current===this;if(this.z*p<=G.length){let H=0;for(let ie=0;ie<G.length;ie++)G[ie]?G[H++]=G[ie]:x&&(this.w.end--,H<this.w.i&&this.w.i--);G.length=H}}B(j,G){if(!j)return;const V=this.f?.onListenerError||R.$Y;if(!V){j.value(G);return}try{j.value(G)}catch(x){V(x)}}C(j){const G=j.current.u;for(;j.i<j.end;)this.B(G[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,j);else{const G=this.w;G.enqueue(this,j,this.u.length),this.C(G)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=i;const n=()=>new t;e.$ke=n;class t{constructor(){this.i=-1,this.end=0}enqueue(j,G,V){this.i=0,this.end=V,this.current=j,this.value=G}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends i{async fireAsync(j,G,V){if(this.u)for(this.h||(this.h=new A.$4c),o(this.u,x=>this.h.push([x.value,j]));this.h.size>0&&!G.isCancellationRequested;){const[x,H]=this.h.shift(),ie=[],z={...H,token:G,waitUntil:W=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");V&&(W=V(W,x)),ie.push(W)}};try{x(z)}catch(W){(0,R.$Y)(W);continue}Object.freeze(ie),await Promise.allSettled(ie).then(W=>{for(const ee of W)ee.status==="rejected"&&(0,R.$Y)(ee.reason)})}}}e.$le=s;class r extends i{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new A.$4c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$me=r;class a extends r{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$ne=a;class h extends i{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(G=>super.fire(G)),this.h=[]}))}}e.$oe=h;class y{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const G={event:j,listener:null};this.h.push(G),this.g&&this.m(G);const V=()=>{this.g&&this.o(G);const x=this.h.indexOf(G);this.h.splice(x,1)};return(0,C.$Rc)((0,c.$cb)(V))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(G=>this.f.fire(G))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$pe=y;class L{constructor(j,G,V,x){this.f=new C.$Sc;const H=this.f.add(new y),ie=this.f.add(new C.$3c);function z(W){ie.set(W,H.add(x(W)))}for(const W of j)z(W);this.f.add(G(W=>{z(W)})),this.f.add(V(W=>{ie.deleteAndDispose(W)})),this.event=H.event}dispose(){this.f.dispose()}}e.$qe=L;class S{constructor(){this.f=[]}wrapEvent(j,G,V){return(x,H,ie)=>j(z=>{const W=this.f[this.f.length-1];if(!G){W?W.buffers.push(()=>x.call(H,z)):x.call(H,z);return}const ee=W;if(!ee){x.call(H,G(V,z));return}ee.items??=[],ee.items.push(z),ee.buffers.length===0&&W.buffers.push(()=>{ee.reducedResult??=V?ee.items.reduce(G,V):ee.items.reduce(G),x.call(H,ee.reducedResult)})},void 0,ie)}bufferEvents(j){const G={buffers:new Array};this.f.push(G);const V=j();return this.f.pop(),G.buffers.forEach(x=>x()),V}}e.$re=S;class v{constructor(){this.f=!1,this.g=I.None,this.h=C.$Tc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=v;class T{static const(j){return new U(j)}constructor(j){this.g=j,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$te=T;class U{constructor(j){this.value=j,this.onDidChange=I.None}}}),define(he[25],ue([0,1,3]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=O;const c=Object.freeze(function(k,b){const I=setTimeout(k.bind(b),0);return{dispose(){clearTimeout(I)}}});var C;(function(k){function b(I){return I===k.None||I===k.Cancelled||I instanceof A?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}k.isCancellationToken=b,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:c})})(C||(e.CancellationToken=C={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?c:(this.b||(this.b=new R.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=C.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=C.None}}e.$ue=N;function O(k){const b=new N;return k.add({dispose(){b.cancel()}}),b.token}}),define(he[136],ue([0,1,25]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=C;class c{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new R.$ue,b=this.b(k.token);return this.a={promise:b,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.$7e=c;function C(O){return O}class A{constructor(k,b){this.a=void 0,this.b=void 0,typeof k=="function"?(this.c=k,this.d=C):(this.c=b,this.d=k.getCacheKey)}get(k){const b=this.d(k);return this.b!==b&&(this.b=b,this.a=this.c(k)),this.a}}e.$9e=A;class N{get cachedValues(){return this.a}constructor(k,b){this.a=new Map,this.b=new Map,typeof k=="function"?(this.c=k,this.d=C):(this.c=b,this.d=k.getCacheKey)}get(k){const b=this.d(k);if(this.b.has(b))return this.b.get(b);const I=this.c(k);return this.a.set(k,I),this.b.set(b,I),I}}e.$0e=N}),define(he[50],ue([0,1,8,2]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=C,e.$xe=A,e.$ye=N,e.$ze=O,e.$Ae=b,e.$Be=I,e.$Ce=$,e.$De=d,e.$Ee=g,e.$Fe=l,e.$Ge=m,e.$He=E,e.$Ie=f,e.$Je=w,e.$Ke=P;function C(p){const o=p;return o?typeof o.read=="function":!1}function A(p){const o=p;return o?[o.on,o.pause,o.resume,o.destroy].every(u=>typeof u=="function"):!1}function N(p){const o=p;return o?A(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function O(p,o){return new k(p,o)}class k{constructor(o,u){this.e=o,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(u=>u(o))}h(o){this.c.error.length===0?(0,R.$Y)(o):this.c.error.slice(0).forEach(u=>u(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,u){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(o,u){if(this.a.destroyed)return;let i;switch(o){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const n=i.indexOf(u);n>=0&&i.splice(n,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(p,o){const u=[];let i;for(;(i=p.read())!==null;)u.push(i);return o(u)}function I(p,o,u){const i=[];let n;for(;(n=p.read())!==null&&i.length<u;)i.push(n);return n===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return p.read()}}}function $(p,o){return new Promise((u,i)=>{const n=[];d(p,{onData:t=>{o&&n.push(t)},onError:t=>{o?i(t):u(void 0)},onEnd:()=>{u(o?o(n):void 0)}})})}function d(p,o,u){p.on("error",i=>{u?.isCancellationRequested||o.onError(i)}),p.on("end",()=>{u?.isCancellationRequested||o.onEnd()}),p.on("data",i=>{u?.isCancellationRequested||o.onData(i)})}function g(p,o){return new Promise((u,i)=>{const n=new c.$Sc,t=[],s=h=>{if(t.push(h),t.length>o)return n.dispose(),p.pause(),u({stream:p,buffer:t,ended:!1})},r=h=>(n.dispose(),i(h)),a=()=>(n.dispose(),u({stream:p,buffer:t,ended:!0}));n.add((0,c.$Rc)(()=>p.removeListener("error",r))),p.on("error",r),n.add((0,c.$Rc)(()=>p.removeListener("end",a))),p.on("end",a),n.add((0,c.$Rc)(()=>p.removeListener("data",s))),p.on("data",s)})}function l(p,o){const u=O(o);return u.end(p),u}function m(){const p=O(()=>{throw new Error("not supported")});return p.end(),p}function E(p){let o=!1;return{read:()=>o?null:(o=!0,p)}}function f(p,o,u){const i=O(u);return d(p,{onData:n=>i.write(o.data(n)),onError:n=>i.error(o.error?o.error(n):n),onEnd:()=>i.end()}),i}function w(p,o,u){let i=!1;return{read:()=>{const n=o.read();return i?n:(i=!0,n!==null?u([p,n]):p)}}}function P(p,o,u){let i=!1;const n=O(u);return d(o,{onData:t=>i?n.write(t):(i=!0,n.write(u([p,t]))),onError:t=>n.error(t),onEnd:()=>{i||(i=!0,n.write(p)),n.end()}}),n}}),define(he[14],ue([0,1,53,50]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=b,e.$Ne=I,e.$Oe=$,e.$Pe=d,e.$Qe=g,e.$Re=l,e.$Se=m,e.$Te=E,e.$Ue=f,e.$Ve=w,e.$We=P,e.$Xe=p,e.$Ye=o,e.$Ze=u,e.$1e=i,e.$2e=n,e.$3e=t,e.$4e=s,e.$5e=r,e.$6e=y,c=ke(c);const C=typeof Buffer<"u",A=new R.$T(()=>new Uint8Array(256));let N,O;class k{static alloc(S){return C?new k(Buffer.allocUnsafe(S)):new k(new Uint8Array(S))}static wrap(S){return C&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new k(S)}static fromString(S,v){return!(v?.dontUseNodeBuffer||!1)&&C?new k(Buffer.from(S)):(N||(N=new TextEncoder),new k(N.encode(S)))}static fromByteArray(S){const v=k.alloc(S.length);for(let T=0,U=S.length;T<U;T++)v.buffer[T]=S[T];return v}static concat(S,v){if(typeof v>"u"){v=0;for(let F=0,j=S.length;F<j;F++)v+=S[F].byteLength}const T=k.alloc(v);let U=0;for(let F=0,j=S.length;F<j;F++){const G=S[F];T.set(G,U),U+=G.byteLength}return T}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=k.alloc(this.byteLength);return S.set(this),S}toString(){return C?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(S,v){return new k(this.buffer.subarray(S,v))}set(S,v){if(S instanceof k)this.buffer.set(S.buffer,v);else if(S instanceof Uint8Array)this.buffer.set(S,v);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),v);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return d(this.buffer,S)}writeUInt32BE(S,v){g(this.buffer,S,v)}readUInt32LE(S){return l(this.buffer,S)}writeUInt32LE(S,v){m(this.buffer,S,v)}readUInt8(S){return E(this.buffer,S)}writeUInt8(S,v){f(this.buffer,S,v)}indexOf(S,v=0){return b(this.buffer,S instanceof k?S.buffer:S,v)}}e.$Le=k;function b(L,S,v=0){const T=S.byteLength,U=L.byteLength;if(T===0)return 0;if(T===1)return L.indexOf(S[0]);if(T>U-v)return-1;const F=A.value;F.fill(S.length);for(let x=0;x<S.length;x++)F[S[x]]=S.length-x-1;let j=v+S.length-1,G=j,V=-1;for(;j<U;)if(L[j]===S[G]){if(G===0){V=j;break}j--,G--}else j+=Math.max(S.length-G,F[L[j]]),G=S.length-1;return V}function I(L,S){return L[S+0]<<0>>>0|L[S+1]<<8>>>0}function $(L,S,v){L[v+0]=S&255,S=S>>>8,L[v+1]=S&255}function d(L,S){return L[S]*2**24+L[S+1]*2**16+L[S+2]*2**8+L[S+3]}function g(L,S,v){L[v+3]=S,S=S>>>8,L[v+2]=S,S=S>>>8,L[v+1]=S,S=S>>>8,L[v]=S}function l(L,S){return L[S+0]<<0>>>0|L[S+1]<<8>>>0|L[S+2]<<16>>>0|L[S+3]<<24>>>0}function m(L,S,v){L[v+0]=S&255,S=S>>>8,L[v+1]=S&255,S=S>>>8,L[v+2]=S&255,S=S>>>8,L[v+3]=S&255}function E(L,S){return L[S]}function f(L,S,v){L[v]=S}function w(L){return c.$Ae(L,S=>k.concat(S))}function P(L){return c.$He(L)}function p(L){return c.$Ce(L,S=>k.concat(S))}async function o(L){return L.ended?k.concat(L.buffer):k.concat([...L.buffer,await p(L.stream)])}function u(L){return c.$Fe(L,S=>k.concat(S))}function i(L){return c.$Ie(L,{data:S=>typeof S=="string"?k.fromString(S):k.wrap(S)},S=>k.concat(S))}function n(L){return c.$ze(S=>k.concat(S),L)}function t(L,S){return c.$Je(L,S,v=>k.concat(v))}function s(L,S){return c.$Ke(L,S,v=>k.concat(v))}function r(L){let S=0,v=0,T=0;const U=new Uint8Array(Math.floor(L.length/4*3)),F=G=>{switch(v){case 3:U[T++]=S|G,v=0;break;case 2:U[T++]=S|G>>>2,S=G<<6,v=3;break;case 1:U[T++]=S|G>>>4,S=G<<4,v=2;break;default:S=G<<2,v=1}};for(let G=0;G<L.length;G++){const V=L.charCodeAt(G);if(V>=65&&V<=90)F(V-65);else if(V>=97&&V<=122)F(V-97+26);else if(V>=48&&V<=57)F(V-48+52);else if(V===43||V===45)F(62);else if(V===47||V===95)F(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${L[G]}`)}}const j=T;for(;v>0;)F(0);return k.wrap(U).slice(0,j)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:L},S=!0,v=!1){const T=v?h:a;let U="";const F=L.byteLength%3;let j=0;for(;j<L.byteLength-F;j+=3){const G=L[j+0],V=L[j+1],x=L[j+2];U+=T[G>>>2],U+=T[(G<<4|V>>>4)&63],U+=T[(V<<2|x>>>6)&63],U+=T[x&63]}if(F===1){const G=L[j+0];U+=T[G>>>2],U+=T[G<<4&63],S&&(U+="==")}else if(F===2){const G=L[j+0],V=L[j+1];U+=T[G>>>2],U+=T[(G<<4|V>>>4)&63],U+=T[V<<2&63],S&&(U+="=")}return U}}),define(he[137],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(he[12],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=R,e.$dg=c,e.$eg=C,e.$fg=A,e.$gg=N,e.$hg=O,e.$ig=k,e.$jg=b,e.$kg=I,e.$lg=$,e.$mg=d,e.$ng=g,e.$og=l,e.$pg=E,e.$qg=f,e.$rg=w,e.$sg=P,e.$tg=p;function R(o){return typeof o=="string"}function c(o){return Array.isArray(o)&&o.every(u=>R(u))}function C(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function A(o){const u=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof u}function N(o){return typeof o=="number"&&!isNaN(o)}function O(o){return!!o&&typeof o[Symbol.iterator]=="function"}function k(o){return o===!0||o===!1}function b(o){return typeof o>"u"}function I(o){return!$(o)}function $(o){return b(o)||o===null}function d(o,u){if(!o)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function g(o){if($(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function l(...o){const u=[];for(let i=0;i<o.length;i++){const n=o[i];if($(n))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);u.push(n)}return u}const m=Object.prototype.hasOwnProperty;function E(o){if(!C(o))return!1;for(const u in o)if(m.call(o,u))return!1;return!0}function f(o){return typeof o=="function"}function w(...o){return o.length>0&&o.every(f)}function P(o,u){const i=Math.min(o.length,u.length);for(let n=0;n<i;n++)p(o[n],u[n])}function p(o,u){if(R(u)){if(typeof o!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(f(u)){try{if(o instanceof u)return}catch{}if(!$(o)&&o.constructor===u||u.length===1&&u.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(he[29],ue([0,1,12]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=c,e.$co=C,e.$do=N,e.$eo=k,e.$fo=b,e.$go=I,e.$ho=$,e.$io=d,e.$jo=g,e.$ko=l,e.$lo=m,e.$mo=E,e.$no=f;function c(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const P=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([p,o])=>{P[p]=o&&typeof o=="object"?c(o):o}),P}function C(w){if(!w||typeof w!="object")return w;const P=[w];for(;P.length>0;){const p=P.shift();Object.freeze(p);for(const o in p)if(A.call(p,o)){const u=p[o];typeof u=="object"&&!Object.isFrozen(u)&&!(0,R.$fg)(u)&&P.push(u)}}return w}const A=Object.prototype.hasOwnProperty;function N(w,P){return O(w,P,new Set)}function O(w,P,p){if((0,R.$lg)(w))return w;const o=P(w);if(typeof o<"u")return o;if(Array.isArray(w)){const u=[];for(const i of w)u.push(O(i,P,p));return u}if((0,R.$eg)(w)){if(p.has(w))throw new Error("Cannot clone recursive data-structure");p.add(w);const u={};for(const i in w)A.call(w,i)&&(u[i]=O(w[i],P,p));return p.delete(w),u}return w}function k(w,P,p=!0){return(0,R.$eg)(w)?((0,R.$eg)(P)&&Object.keys(P).forEach(o=>{o in w?p&&((0,R.$eg)(w[o])&&(0,R.$eg)(P[o])?k(w[o],P[o],p):w[o]=P[o]):w[o]=P[o]}),w):P}function b(w,P){if(w===P)return!0;if(w==null||P===null||P===void 0||typeof w!=typeof P||typeof w!="object"||Array.isArray(w)!==Array.isArray(P))return!1;let p,o;if(Array.isArray(w)){if(w.length!==P.length)return!1;for(p=0;p<w.length;p++)if(!b(w[p],P[p]))return!1}else{const u=[];for(o in w)u.push(o);u.sort();const i=[];for(o in P)i.push(o);if(i.sort(),!b(u,i))return!1;for(p=0;p<u.length;p++)if(!b(w[u[p]],P[u[p]]))return!1}return!0}function I(w){const P=new Set;return JSON.stringify(w,(p,o)=>{if((0,R.$eg)(o)||Array.isArray(o)){if(P.has(o))return"[Circular]";P.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function $(w,P){const p=Object.create(null);return!w||!P||Object.keys(P).forEach(u=>{const i=w[u],n=P[u];b(i,n)||(p[u]=n)}),p}function d(w,P){const p=P.toLowerCase(),o=Object.keys(w).find(u=>u.toLowerCase()===p);return o?w[o]:w[P]}function g(w,P){const p=Object.create(null);for(const[o,u]of Object.entries(w))P(o,u)&&(p[o]=u);return p}function l(w){let P=[];for(;Object.prototype!==w;)P=P.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return P}function m(w){const P=[];for(const p of l(w))typeof w[p]=="function"&&P.push(p);return P}function E(w,P){const p=u=>function(){const i=Array.prototype.slice.call(arguments,0);return P(u,i)},o={};for(const u of w)o[u]=p(u);return o}function f(w,P){const p={};for(const[o,u]of Object.entries(w))p[o]=P(u,o);return p}}),define(he[138],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=c,e.$_e=C;var R;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(R||(e.Constants=R={}));function c(A){return A<0?0:A>R.MAX_UINT_8?R.MAX_UINT_8:A|0}function C(A){return A<0?0:A>R.MAX_UINT_32?R.MAX_UINT_32:A|0}}),define(he[26],ue([0,1,136,39,53,138]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=N,e.$bf=k,e.$cf=I,e.$df=$,e.$ef=d,e.$ff=g,e.$gf=l,e.$hf=m,e.$if=E,e.$jf=f,e.$kf=w,e.$lf=P,e.$mf=p,e.$nf=o,e.$of=u,e.$pf=i,e.$qf=n,e.$rf=t,e.$sf=s,e.$tf=r,e.$uf=a,e.$vf=h,e.$wf=y,e.$xf=L,e.$yf=S,e.$zf=v,e.$Af=T,e.$Bf=U,e.$Cf=F,e.$Df=j,e.$Ef=G,e.$Ff=V,e.$Gf=x,e.$Hf=H,e.$If=ie,e.$Jf=z,e.$Kf=W,e.$Nf=te,e.$Of=X,e.$Pf=K,e.$Qf=B,e.$Rf=q,e.$Sf=Q,e.$Uf=_,e.$Vf=Y,e.$Wf=re,e.$Xf=le,e.$Yf=pe,e.$Zf=Ee,e.$1f=be,e.$3f=Se,e.$4f=Re,e.$5f=ae,e.$6f=de,e.$7f=me,e.$8f=Pe,e.$9f=Oe,e.$0f=Fe,e.$$f=He;function N(se){return!se||typeof se!="string"?!0:se.trim().length===0}const O=/{(\d+)}/g;function k(se,...fe){return fe.length===0?se:se.replace(O,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=fe.length?$e:fe[Ae]})}const b=/{([^}]+)}/g;function I(se,fe){return Object.keys(fe).length===0?se:se.replace(b,($e,ye)=>fe[ye]??$e)}function $(se){return se.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function d(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function g(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(se,fe){let $e=0,ye=se.indexOf(fe);for(;ye!==-1;)$e++,ye=se.indexOf(fe,ye+fe.length);return $e}function m(se,fe,$e="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${$e}`}function E(se,fe,$e="\u2026"){if(se.length<=fe)return se;const ye=Math.ceil(fe/2)-$e.length/2,Ae=Math.floor(fe/2)-$e.length/2;return`${se.substr(0,ye)}${$e}${se.substr(se.length-Ae)}`}function f(se,fe=" "){const $e=w(se,fe);return P($e,fe)}function w(se,fe){if(!se||!fe)return se;const $e=fe.length;if($e===0||se.length===0)return se;let ye=0;for(;se.indexOf(fe,ye)===ye;)ye=ye+$e;return se.substring(ye)}function P(se,fe){if(!se||!fe)return se;const $e=fe.length,ye=se.length;if($e===0||ye===0)return se;let Ae=ye,Te=-1;for(;Te=se.lastIndexOf(fe,Ae-1),!(Te===-1||Te+$e!==Ae);){if(Te===0)return"";Ae=Te}return se.substring(0,Ae)}function p(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(se){return se.replace(/\*/g,"")}function u(se,fe,$e={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=g(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(se,ye)}function i(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function n(se){return se.split(/\r\n|\r|\n/)}function t(se){const fe=[],$e=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function s(se){for(let fe=0,$e=se.length;fe<$e;fe++){const ye=se.charCodeAt(fe);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return fe}return-1}function r(se,fe=0,$e=se.length){for(let ye=fe;ye<$e;ye++){const Ae=se.charCodeAt(ye);if(Ae!==c.CharCode.Space&&Ae!==c.CharCode.Tab)return se.substring(fe,ye)}return se.substring(fe,$e)}function a(se,fe=se.length-1){for(let $e=fe;$e>=0;$e--){const ye=se.charCodeAt($e);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return $e}return-1}function h(se,fe,$e){const ye=[];let Ae=0;for(const Te of se.matchAll(fe)){if(ye.push(se.slice(Ae,Te.index)),Te.index===void 0)throw new Error("match.index should be defined");Ae=Te.index+Te[0].length,ye.push($e(Te[0],...Te.slice(1),Te.index,se,Te.groups))}return ye.push(se.slice(Ae)),Promise.all(ye).then(Te=>Te.join(""))}function y(se,fe){return se<fe?-1:se>fe?1:0}function L(se,fe,$e=0,ye=se.length,Ae=0,Te=fe.length){for(;$e<ye&&Ae<Te;$e++,Ae++){const Je=se.charCodeAt($e),Ye=fe.charCodeAt(Ae);if(Je<Ye)return-1;if(Je>Ye)return 1}const Me=ye-$e,xe=Te-Ae;return Me<xe?-1:Me>xe?1:0}function S(se,fe){return v(se,fe,0,se.length,0,fe.length)}function v(se,fe,$e=0,ye=se.length,Ae=0,Te=fe.length){for(;$e<ye&&Ae<Te;$e++,Ae++){let Je=se.charCodeAt($e),Ye=fe.charCodeAt(Ae);if(Je===Ye)continue;if(Je>=128||Ye>=128)return L(se.toLowerCase(),fe.toLowerCase(),$e,ye,Ae,Te);U(Je)&&(Je-=32),U(Ye)&&(Ye-=32);const Ve=Je-Ye;if(Ve!==0)return Ve}const Me=ye-$e,xe=Te-Ae;return Me<xe?-1:Me>xe?1:0}function T(se){return se>=c.CharCode.Digit0&&se<=c.CharCode.Digit9}function U(se){return se>=c.CharCode.a&&se<=c.CharCode.z}function F(se){return se>=c.CharCode.A&&se<=c.CharCode.Z}function j(se,fe){return se.length===fe.length&&v(se,fe)===0}function G(se,fe){const $e=fe.length;return fe.length>se.length?!1:v(se,fe,0,$e)===0}function V(se,fe){const $e=Math.min(se.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(se.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function x(se,fe){const $e=Math.min(se.length,fe.length);let ye;const Ae=se.length-1,Te=fe.length-1;for(ye=0;ye<$e;ye++)if(se.charCodeAt(Ae-ye)!==fe.charCodeAt(Te-ye))return ye;return $e}function H(se){return 55296<=se&&se<=56319}function ie(se){return 56320<=se&&se<=57343}function z(se,fe){return(se-55296<<10)+(fe-56320)+65536}function W(se,fe,$e){const ye=se.charCodeAt($e);if(H(ye)&&$e+1<fe){const Ae=se.charCodeAt($e+1);if(ie(Ae))return z(ye,Ae)}return ye}function ee(se,fe){const $e=se.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=se.charCodeAt(fe-2);if(H(ye))return z(ye,$e)}return $e}class ne{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ee(this.c,this.e);return this.e-=fe>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=W(this.c,this.d,this.e);return this.e+=fe>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Lf=ne;class ce{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new ne(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Te=$e.offset,Me=fe.getGraphemeBreakType($e.nextCodePoint());if(Ne(Ae,Me)){$e.setOffset(Te);break}Ae=Me}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Te=$e.offset,Me=fe.getGraphemeBreakType($e.prevCodePoint());if(Ne(Me,Ae)){$e.setOffset(Te);break}Ae=Me}return ye-$e.offset}eol(){return this.c.eol()}}e.$Mf=ce;function te(se,fe){return new ce(se,fe).nextGraphemeLength()}function X(se,fe){return new ce(se,fe).prevGraphemeLength()}function K(se,fe){fe>0&&ie(se.charCodeAt(fe))&&fe--;const $e=fe+te(se,fe);return[$e-X(se,$e),$e]}function B(se){const fe=new ce(se);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let D;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(se){return D||(D=J()),D.test(se)}const M=/^[\t\n\r\x20-\x7E]*$/;function Q(se){return M.test(se)}e.$Tf=/[\u2028\u2029]/;function _(se){return e.$Tf.test(se)}function Y(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function re(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function le(se,fe,$e=""){const ye=se.trimStart();if(ye.length<fe)return ye;const Ae=/\b/g;let Te=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<fe);)Te=Ae.lastIndex,Ae.lastIndex+=1;return Te===0?ye:$e+ye.substring(Te).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(se){let fe=0;for(const $e of se.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:se.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==se.length&&(yield{isCode:!1,str:se.substring(fe)})}function Ee(se){return se&&(se=se.replace(ge,"")),se}const we=/\\\[.*?\\\]/g;function be(se){return Ee(se).replace(we,"")}e.$2f=String.fromCharCode(c.CharCode.UTF8_BOM);function Se(se){return!!(se&&se.length>0&&se.charCodeAt(0)===c.CharCode.UTF8_BOM)}function Re(se){return Se(se)?se.substr(1):se}function ae(se,fe){if(!se||!fe||se.length<fe.length)return!1;const $e=fe.length,ye=se.toLowerCase();let Ae=0,Te=-1;for(;Ae<$e;){const Me=ye.indexOf(fe[Ae],Te+1);if(Me<0)return!1;Te=Me,Ae++}return!0}function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Pe(se,fe=1){if(fe===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function Oe(se){const fe=c.CharCode.Z-c.CharCode.A+1;return se=se%(2*fe),se<fe?String.fromCharCode(c.CharCode.a+se):String.fromCharCode(c.CharCode.A+se-fe)}function Fe(se){return Ue.getInstance().getGraphemeBreakType(se)}function Ne(se,fe){return se===Le.Other?fe!==Le.Extend&&fe!==Le.SpacingMark:se===Le.CR&&fe===Le.LF?!1:se===Le.Control||se===Le.CR||se===Le.LF||fe===Le.Control||fe===Le.CR||fe===Le.LF?!0:!(se===Le.L&&(fe===Le.L||fe===Le.V||fe===Le.LV||fe===Le.LVT)||(se===Le.LV||se===Le.V)&&(fe===Le.V||fe===Le.T)||(se===Le.LVT||se===Le.T)&&fe===Le.T||fe===Le.Extend||fe===Le.ZWJ||fe===Le.SpacingMark||se===Le.Prepend||se===Le.ZWJ&&fe===Le.Extended_Pictographic||se===Le.Regional_Indicator&&fe===Le.Regional_Indicator)}var Le;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=qe()}getGraphemeBreakType(fe){if(fe<32)return fe===c.CharCode.LineFeed?Le.LF:fe===c.CharCode.CarriageReturn?Le.CR:Le.Control;if(fe<127)return Le.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(fe<$e[3*Ae])Ae=2*Ae;else if(fe>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Le.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(se,fe){if(se===0)return 0;const $e=je(se,fe);if($e!==void 0)return $e;const ye=new ne(fe,se);return ye.prevCodePoint(),ye.offset}function je(se,fe){const $e=new ne(fe,se);let ye=$e.prevCodePoint();for(;Be(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!re(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function Be(se){return 127995<=se&&se<=127999}var ze;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$_f="\xA0";class We{static{this.c=new C.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new R.$9e({getCacheKey:JSON.stringify},fe=>{function $e(Ve){const _e=new Map;for(let Qe=0;Qe<Ve.length;Qe+=2)_e.set(Ve[Qe],Ve[Qe+1]);return _e}function ye(Ve,_e){const Qe=new Map(Ve);for(const[nt,at]of _e)Qe.set(nt,at);return Qe}function Ae(Ve,_e){if(!Ve)return _e;const Qe=new Map;for(const[nt,at]of Ve)_e.has(nt)&&Qe.set(nt,at);return Qe}const Te=this.c.value;let Me=fe.filter(Ve=>!Ve.startsWith("_")&&Ve in Te);Me.length===0&&(Me=["_default"]);let xe;for(const Ve of Me){const _e=$e(Te[Ve]);xe=Ae(xe,_e)}const Je=$e(Te._common),Ye=ye(Je,xe);return new We(Ye)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new C.$T(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=We;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(fe){return Ce.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Ce.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ce.e()}}e.$bg=Ce}),define(he[41],ue([0,1,39,13,5,26,12]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=O,e.$vg=k,e.$wg=b,e.$xg=I,e.$yg=$,e.$zg=m,e.$Ag=E,e.$Bg=f,e.$Cg=w,e.$Dg=P,e.$Eg=p,e.$Fg=o,e.$Gg=u,e.$Hg=i,e.$Ig=n,e.$Jg=t,e.$Kg=a;function O(h){return h===R.CharCode.Slash||h===R.CharCode.Backslash}function k(h){return h.replace(/[\\/]/g,c.$fc.sep)}function b(h){return h.indexOf("/")===-1&&(h=k(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function I(h,y=c.$fc.sep){if(!h)return"";const L=h.length,S=h.charCodeAt(0);if(O(S)){if(O(h.charCodeAt(1))&&!O(h.charCodeAt(2))){let T=3;const U=T;for(;T<L&&!O(h.charCodeAt(T));T++);if(U!==T&&!O(h.charCodeAt(T+1))){for(T+=1;T<L;T++)if(O(h.charCodeAt(T)))return h.slice(0,T+1).replace(/[\\/]/g,y)}}return y}else if(w(S)&&h.charCodeAt(1)===R.CharCode.Colon)return O(h.charCodeAt(2))?h.slice(0,2)+y:h.slice(0,2);let v=h.indexOf("://");if(v!==-1){for(v+=3;v<L;v++)if(O(h.charCodeAt(v)))return h.slice(0,v+1)}return""}function $(h){if(!C.$j||!h||h.length<5)return!1;let y=h.charCodeAt(0);if(y!==R.CharCode.Backslash||(y=h.charCodeAt(1),y!==R.CharCode.Backslash))return!1;let L=2;const S=L;for(;L<h.length&&(y=h.charCodeAt(L),y!==R.CharCode.Backslash);L++);return!(S===L||(y=h.charCodeAt(L+1),isNaN(y)||y===R.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,g=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(h,y=C.$j){const L=y?d:g;return!(!h||h.length===0||/^\s+$/.test(h)||(L.lastIndex=0,L.test(h))||y&&l.test(h)||h==="."||h===".."||y&&h[h.length-1]==="."||y&&h.length!==h.trim().length||h.length>255)}function E(h,y,L){const S=h===y;return!L||S?S:!h||!y?!1:(0,A.$Df)(h,y)}function f(h,y,L,S=c.sep){if(h===y)return!0;if(!h||!y||y.length>h.length)return!1;if(L){if(!(0,A.$Ef)(h,y))return!1;if(y.length===h.length)return!0;let T=y.length;return y.charAt(y.length-1)===S&&T--,h.charAt(T)===S}return y.charAt(y.length-1)!==S&&(y+=S),h.indexOf(y)===0}function w(h){return h>=R.CharCode.A&&h<=R.CharCode.Z||h>=R.CharCode.a&&h<=R.CharCode.z}function P(h,y){return C.$j&&h.endsWith(":")&&(h+=c.sep),(0,c.$hc)(h)||(h=(0,c.$ic)(y,h)),h=(0,c.$gc)(h),p(h)}function p(h){return C.$j?(h=(0,A.$lf)(h,c.sep),h.endsWith(":")&&(h+=c.sep)):(h=(0,A.$lf)(h,c.sep),h||(h=c.sep)),h}function o(h){const y=(0,c.$gc)(h);return C.$j?h.length>3?!1:u(y)&&(h.length===2||y.charCodeAt(2)===R.CharCode.Backslash):y===c.$fc.sep}function u(h,y=C.$j){return y?w(h.charCodeAt(0))&&h.charCodeAt(1)===R.CharCode.Colon:!1}function i(h,y=C.$j){return u(h,y)?h[0]:void 0}function n(h,y,L){return y.length>h.length?-1:h===y?0:(L&&(h=h.toLowerCase(),y=y.toLowerCase()),h.indexOf(y))}function t(h){const y=h.split(":");let L,S,v;for(const T of y){const U=Number(T);(0,N.$gg)(U)?S===void 0?S=U:v===void 0&&(v=U):L=L?[L,T].join(":"):T}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:S!==void 0?S:void 0,column:v!==void 0?v:S!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(h,y,L=8){let S="";for(let T=0;T<L;T++){let U;T===0&&C.$j&&!y&&(L===3||L===4)?U=r:U=s,S+=U.charAt(Math.floor(Math.random()*U.length))}let v;return y?v=`${y}-${S}`:v=S,h?(0,c.$ic)(h,v):v}}),define(he[55],ue([0,1,26]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=c,e.$rj=C,e.$sj=A,e.$tj=O,e.$vj=m,R=ke(R);function c(f){return C(f,0)}function C(f,w){switch(typeof f){case"object":return f===null?A(349,w):Array.isArray(f)?k(f,w):b(f,w);case"string":return O(f,w);case"boolean":return N(f,w);case"number":return A(f,w);case"undefined":return A(937,w);default:return A(617,w)}}function A(f,w){return(w<<5)-w+f|0}function N(f,w){return A(f?433:863,w)}function O(f,w){w=A(149417,w);for(let P=0,p=f.length;P<p;P++)w=A(f.charCodeAt(P),w);return w}function k(f,w){return w=A(104579,w),f.reduce((P,p)=>C(p,P),w)}function b(f,w){return w=A(181387,w),Object.keys(f).sort().reduce((P,p)=>(P=O(p,P),C(f[p],P)),w)}class I{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=C(w,this.g),this.g}}e.$uj=I;var $;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function d(f,w,P=32){const p=P-w,o=~((1<<p)-1);return(f<<w|(o&f)>>>p)>>>0}function g(f,w=0,P=f.byteLength,p=0){for(let o=0;o<P;o++)f[w+o]=p}function l(f,w,P="0"){for(;f.length<w;)f=P+f;return f}function m(f,w=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(P=>P.toString(16).padStart(2,"0")).join(""):l((f>>>0).toString(16),w/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const P=w.length;if(P===0)return;const p=this.p;let o=this.r,u=this.u,i,n;for(u!==0?(i=u,n=-1,u=0):(i=w.charCodeAt(0),n=0);;){let t=i;if(R.$Hf(i))if(n+1<P){const s=w.charCodeAt(n+1);R.$If(s)?(n++,t=R.$Jf(i,s)):t=$.UNICODE_REPLACEMENT}else{u=i;break}else R.$If(i)&&(t=$.UNICODE_REPLACEMENT);if(o=this.w(p,o,t),n++,n<P)i=w.charCodeAt(n);else break}this.r=o,this.u=u}w(w,P,p){return p<128?w[P++]=p:p<2048?(w[P++]=192|(p&1984)>>>6,w[P++]=128|(p&63)>>>0):p<65536?(w[P++]=224|(p&61440)>>>12,w[P++]=128|(p&4032)>>>6,w[P++]=128|(p&63)>>>0):(w[P++]=240|(p&1835008)>>>18,w[P++]=128|(p&258048)>>>12,w[P++]=128|(p&4032)>>>6,w[P++]=128|(p&63)>>>0),P>=$.BLOCK_SIZE&&(this.y(),P-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,w[0]=w[$.BLOCK_SIZE+0],w[1]=w[$.BLOCK_SIZE+1],w[2]=w[$.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=E.g,P=this.q;for(let a=0;a<64;a+=4)w.setUint32(a,P.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,d(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let p=this.h,o=this.l,u=this.m,i=this.n,n=this.o,t,s,r;for(let a=0;a<80;a++)a<20?(t=o&u|~o&i,s=1518500249):a<40?(t=o^u^i,s=1859775393):a<60?(t=o&u|o&i|u&i,s=2400959708):(t=o^u^i,s=3395469782),r=d(p,5)+t+n+s+w.getUint32(a*4,!1)&4294967295,n=i,i=u,u=d(o,30),o=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+o&4294967295,this.m=this.m+u&4294967295,this.n=this.n+i&4294967295,this.o=this.o+n&4294967295}}e.$wj=E}),define(he[92],ue([0,1,26]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R=ke(R);var c;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(c||(c={})),function(C){const A="error",N="warning",O="warn",k="info",b="ignore";function I(d){return d?R.$Df(A,d)?C.Error:R.$Df(N,d)||R.$Df(O,d)?C.Warning:R.$Df(k,d)?C.Info:C.Ignore:C.Ignore}C.fromValue=I;function $(d){switch(d){case C.Error:return A;case C.Warning:return N;case C.Info:return k;default:return b}}C.toString=$}(c||(c={})),e.default=c}),define(he[51],ue([0,1,17,39,26]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const m=l.charCodeAt(0),E=this.b.charCodeAt(this.c);return m-E}value(){return this.b[this.c]}}e.$Ei=A;class N{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===c.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,C.$xf)(l,this.b,0,l.length,this.c,this.d):(0,C.$zf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=N;class O{constructor(l=!0,m=!0){this.f=l,this.g=m}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let m=l.length-1;m>=0;m--,this.c--){const E=this.b.charCodeAt(m);if(!(E===c.CharCode.Slash||this.f&&E===c.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===c.CharCode.Slash||this.f&&m===c.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,C.$xf)(l,this.b,0,l.length,this.d,this.e):(0,C.$zf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=O;var k;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(k||(k={}));class b{constructor(l,m){this.f=l,this.g=m,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(k.Scheme),this.c.authority&&this.d.push(k.Authority),this.c.path&&(this.b=new O(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(k.Path)),this.g(l)||(this.c.query&&this.d.push(k.Query),this.c.fragment&&this.d.push(k.Fragment)),this.e=0,this}next(){return this.d[this.e]===k.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===k.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===k.Scheme)return(0,C.$yf)(l,this.c.scheme);if(this.d[this.e]===k.Authority)return(0,C.$yf)(l,this.c.authority);if(this.d[this.e]===k.Path)return this.b.cmp(l);if(this.d[this.e]===k.Query)return(0,C.$wf)(l,this.c.query);if(this.d[this.e]===k.Fragment)return(0,C.$wf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===k.Scheme)return this.c.scheme;if(this.d[this.e]===k.Authority)return this.c.authority;if(this.d[this.e]===k.Path)return this.b.value();if(this.d[this.e]===k.Query)return this.c.query;if(this.d[this.e]===k.Fragment)return this.c.fragment;throw new Error}}e.$Hi=b;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})($||($={}));class d{static forUris(l=()=>!1,m=()=>!1){return new d(new b(l,m))}static forPaths(l=!1){return new d(new O(void 0,!l))}static forStrings(){return new d(new A)}static forConfigKeys(){return new d(new N)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,m){if(m){const E=m.slice(0);(0,R.$Vb)(E);for(const f of E)this.set(f,l)}else{const E=l.slice(0);(0,R.$Vb)(E);for(const f of E)this.set(f[0],f[1])}}set(l,m){const E=this.b.reset(l);let f;this.c||(this.c=new I,this.c.segment=E.value());const w=[];for(f=this.c;;){const p=E.cmp(f.segment);if(p>0)f.left||(f.left=new I,f.left.segment=E.value()),w.push([$.Left,f]),f=f.left;else if(p<0)f.right||(f.right=new I,f.right.segment=E.value()),w.push([$.Right,f]),f=f.right;else if(E.hasNext())E.next(),f.mid||(f.mid=new I,f.mid.segment=E.value()),w.push([$.Mid,f]),f=f.mid;else break}const P=f.value;f.value=m,f.key=l;for(let p=w.length-1;p>=0;p--){const o=w[p][1];o.updateHeight();const u=o.balanceFactor();if(u<-1||u>1){const i=w[p][0],n=w[p+1][0];if(i===$.Right&&n===$.Right)w[p][1]=o.rotateLeft();else if(i===$.Left&&n===$.Left)w[p][1]=o.rotateRight();else if(i===$.Right&&n===$.Left)o.right=w[p+1][1]=w[p+1][1].rotateRight(),w[p][1]=o.rotateLeft();else if(i===$.Left&&n===$.Right)o.left=w[p+1][1]=w[p+1][1].rotateLeft(),w[p][1]=o.rotateRight();else throw new Error;if(p>0)switch(w[p-1][0]){case $.Left:w[p-1][1].left=w[p][1];break;case $.Right:w[p-1][1].right=w[p][1];break;case $.Mid:w[p-1][1].mid=w[p][1];break}else this.c=w[0][1]}}return P}get(l){return this.d(l)?.value}d(l){const m=this.b.reset(l);let E=this.c;for(;E;){const f=m.cmp(E.segment);if(f>0)E=E.left;else if(f<0)E=E.right;else if(m.hasNext())m.next(),E=E.mid;else break}return E}has(l){const m=this.d(l);return!(m?.value===void 0&&m?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,m){const E=this.b.reset(l),f=[];let w=this.c;for(;w;){const P=E.cmp(w.segment);if(P>0)f.push([$.Left,w]),w=w.left;else if(P<0)f.push([$.Right,w]),w=w.right;else if(E.hasNext())E.next(),f.push([$.Mid,w]),w=w.mid;else break}if(w){if(m?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const P=this.f(w.right);if(P.key){const{key:p,value:o,segment:u}=P;this.e(P.key,!1),w.key=p,w.value=o,w.segment=u}}else{const P=w.left??w.right;if(f.length>0){const[p,o]=f[f.length-1];switch(p){case $.Left:o.left=P;break;case $.Mid:o.mid=P;break;case $.Right:o.right=P;break}}else this.c=P}for(let P=f.length-1;P>=0;P--){const p=f[P][1];p.updateHeight();const o=p.balanceFactor();if(o>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),f[P][1]=p.rotateLeft()):o<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),f[P][1]=p.rotateRight()),P>0)switch(f[P-1][0]){case $.Left:f[P-1][1].left=f[P][1];break;case $.Right:f[P-1][1].right=f[P][1];break;case $.Mid:f[P-1][1].mid=f[P][1];break}else this.c=f[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const m=this.b.reset(l);let E=this.c,f;for(;E;){const w=m.cmp(E.segment);if(w>0)E=E.left;else if(w<0)E=E.right;else if(m.hasNext())m.next(),f=E.value||f,E=E.mid;else break}return E&&E.value||f}findSuperstr(l){return this.g(l,!1)}g(l,m){const E=this.b.reset(l);let f=this.c;for(;f;){const w=E.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(E.hasNext())E.next(),f=f.mid;else return f.mid?this.h(f.mid):m?f.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[m,E]of this)l(E,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const m=[];return this.j(l,m),m[Symbol.iterator]()}j(l,m){l&&(l.left&&this.j(l.left,m),l.value&&m.push([l.key,l.value]),l.mid&&this.j(l.mid,m),l.right&&this.j(l.right,m))}_isBalanced(){const l=m=>{if(!m)return!0;const E=m.balanceFactor();return E<-1||E>1?!1:l(m.left)&&l(m.right)};return l(this.c)}}e.$Ii=d}),define(he[9],ue([0,1,39,65,13,5]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$uc=E,e.$vc=u,C=ke(C);const N=/^\w[\w\d+.-]*$/,O=/^\//,k=/^\/\//;function b(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!N.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!O.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(r,a){return!r&&!a?"file":r}function $(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==g&&(a=g+a):a=g;break}return a}const d="",g="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(a){return a instanceof m?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,h,y,L,S,v=!1){typeof a=="object"?(this.scheme=a.scheme||d,this.authority=a.authority||d,this.path=a.path||d,this.query=a.query||d,this.fragment=a.fragment||d):(this.scheme=I(a,v),this.authority=h||d,this.path=$(this.scheme,y||d),this.query=L||d,this.fragment=S||d,b(this,v))}get fsPath(){return u(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:y,path:L,query:S,fragment:v}=a;return h===void 0?h=this.scheme:h===null&&(h=d),y===void 0?y=this.authority:y===null&&(y=d),L===void 0?L=this.path:L===null&&(L=d),S===void 0?S=this.query:S===null&&(S=d),v===void 0?v=this.fragment:v===null&&(v=d),h===this.scheme&&y===this.authority&&L===this.path&&S===this.query&&v===this.fragment?this:new w(h,y,L,S,v)}static parse(a,h=!1){const y=l.exec(a);return y?new w(y[2]||d,s(y[4]||d),s(y[5]||d),s(y[7]||d),s(y[9]||d),h):new w(d,d,d,d,d)}static file(a){let h=d;if(A.$j&&(a=a.replace(/\\/g,g)),a[0]===g&&a[1]===g){const y=a.indexOf(g,2);y===-1?(h=a.substring(2),a=g):(h=a.substring(2,y),a=a.substring(y)||g)}return new w("file",h,a,d,d)}static from(a,h){return new w(a.scheme,a.authority,a.path,a.query,a.fragment,h)}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return A.$j&&a.scheme==="file"?y=m.file(C.$ec.join(u(a,!0),...h)).path:y=C.$fc.join(a.path,...h),a.with({path:y})}toString(a=!1){return i(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof m)return a;{const h=new w(a);return h._formatted=a.external??null,h._fsPath=a._sep===f?a.fsPath??null:null,h}}else return a}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=m;function E(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const f=A.$j?1:void 0;class w extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(a=!1){return a?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const a={$mid:c.MarshalledId.Uri};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=f),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const P={[R.CharCode.Colon]:"%3A",[R.CharCode.Slash]:"%2F",[R.CharCode.QuestionMark]:"%3F",[R.CharCode.Hash]:"%23",[R.CharCode.OpenSquareBracket]:"%5B",[R.CharCode.CloseSquareBracket]:"%5D",[R.CharCode.AtSign]:"%40",[R.CharCode.ExclamationMark]:"%21",[R.CharCode.DollarSign]:"%24",[R.CharCode.Ampersand]:"%26",[R.CharCode.SingleQuote]:"%27",[R.CharCode.OpenParen]:"%28",[R.CharCode.CloseParen]:"%29",[R.CharCode.Asterisk]:"%2A",[R.CharCode.Plus]:"%2B",[R.CharCode.Comma]:"%2C",[R.CharCode.Semicolon]:"%3B",[R.CharCode.Equals]:"%3D",[R.CharCode.Space]:"%20"};function p(r,a,h){let y,L=-1;for(let S=0;S<r.length;S++){const v=r.charCodeAt(S);if(v>=R.CharCode.a&&v<=R.CharCode.z||v>=R.CharCode.A&&v<=R.CharCode.Z||v>=R.CharCode.Digit0&&v<=R.CharCode.Digit9||v===R.CharCode.Dash||v===R.CharCode.Period||v===R.CharCode.Underline||v===R.CharCode.Tilde||a&&v===R.CharCode.Slash||h&&v===R.CharCode.OpenSquareBracket||h&&v===R.CharCode.CloseSquareBracket||h&&v===R.CharCode.Colon)L!==-1&&(y+=encodeURIComponent(r.substring(L,S)),L=-1),y!==void 0&&(y+=r.charAt(S));else{y===void 0&&(y=r.substr(0,S));const T=P[v];T!==void 0?(L!==-1&&(y+=encodeURIComponent(r.substring(L,S)),L=-1),y+=T):L===-1&&(L=S)}}return L!==-1&&(y+=encodeURIComponent(r.substring(L))),y!==void 0?y:r}function o(r){let a;for(let h=0;h<r.length;h++){const y=r.charCodeAt(h);y===R.CharCode.Hash||y===R.CharCode.QuestionMark?(a===void 0&&(a=r.substr(0,h)),a+=P[y]):a!==void 0&&(a+=r[h])}return a!==void 0?a:r}function u(r,a){let h;return r.authority&&r.path.length>1&&r.scheme==="file"?h=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===R.CharCode.Slash&&(r.path.charCodeAt(1)>=R.CharCode.A&&r.path.charCodeAt(1)<=R.CharCode.Z||r.path.charCodeAt(1)>=R.CharCode.a&&r.path.charCodeAt(1)<=R.CharCode.z)&&r.path.charCodeAt(2)===R.CharCode.Colon?a?h=r.path.substr(1):h=r.path[1].toLowerCase()+r.path.substr(2):h=r.path,A.$j&&(h=h.replace(/\//g,"\\")),h}function i(r,a){const h=a?o:p;let y="",{scheme:L,authority:S,path:v,query:T,fragment:U}=r;if(L&&(y+=L,y+=":"),(S||L==="file")&&(y+=g,y+=g),S){let F=S.indexOf("@");if(F!==-1){const j=S.substr(0,F);S=S.substr(F+1),F=j.lastIndexOf(":"),F===-1?y+=h(j,!1,!1):(y+=h(j.substr(0,F),!1,!1),y+=":",y+=h(j.substr(F+1),!1,!0)),y+="@"}S=S.toLowerCase(),F=S.lastIndexOf(":"),F===-1?y+=h(S,!1,!0):(y+=h(S.substr(0,F),!1,!0),y+=S.substr(F))}if(v){if(v.length>=3&&v.charCodeAt(0)===R.CharCode.Slash&&v.charCodeAt(2)===R.CharCode.Colon){const F=v.charCodeAt(1);F>=R.CharCode.A&&F<=R.CharCode.Z&&(v=`/${String.fromCharCode(F+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===R.CharCode.Colon){const F=v.charCodeAt(0);F>=R.CharCode.A&&F<=R.CharCode.Z&&(v=`${String.fromCharCode(F+32)}:${v.substr(2)}`)}y+=h(v,!0,!1)}return T&&(y+="?",y+=h(T,!1,!1)),U&&(y+="#",y+=a?U:p(U,!1,!1)),y}function n(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+n(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,a=>n(a)):r}}),define(he[139],ue([0,1,9]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=c,e.$br=C,e.$cr=A,e.log=O;function c(b){const I=b;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function C(b){const I=[];let $;try{const d=JSON.parse(b.arguments),g=d[d.length-1];g&&g.__$stack&&(d.pop(),$=g.__$stack),I.push(...d)}catch{I.push("Unable to log remote console arguments",b.arguments)}return{args:I,stack:$}}function A(b){if(typeof b!="string")return A(C(b).stack);const I=b;if(I){const $=N(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec($||"");if(d&&d.length===4)return{uri:R.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function N(b){if(!b)return b;const I=b.indexOf(`
`);return I===-1?b:b.substring(0,I)}function O(b,I){const{args:$,stack:d}=C(b),g=typeof $[0]=="string"&&$.length===1;let l=N(d);l&&(l=`(${l.trim()})`);let m=[];if(typeof $[0]=="string"?l&&g?m=[`%c[${I}] %c${$[0]} %c${l}`,k("blue"),k(""),k("grey")]:m=[`%c[${I}] %c${$[0]}`,k("blue"),k(""),...$.slice(1)]:m=[`%c[${I}]%`,k("blue"),...$],l&&!g&&m.push(l),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,m)}function k(b){return`color: ${b}`}}),define(he[66],ue([0,1,14,9,65]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=A,e.$$h=N,e.$_h=k;function A(b){return JSON.stringify(b,O)}function N(b){let I=JSON.parse(b);return I=k(I),I}function O(b,I){return I instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function k(b,I=0){if(!b||I>200)return b;if(typeof b=="object"){switch(b.$mid){case C.MarshalledId.Uri:return c.URI.revive(b);case C.MarshalledId.Regexp:return new RegExp(b.source,b.flags);case C.MarshalledId.Date:return new Date(b.source)}if(b instanceof R.$Le||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let $=0;$<b.length;++$)b[$]=k(b[$],I+1);else for(const $ in b)Object.hasOwnProperty.call(b,$)&&(b[$]=k(b[$],I+1))}return b}}),define(he[22],ue([0,1,8,5,26,9,13]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=k,e.$Mg=b,e.$Qg=$,R=ke(R),c=ke(c),N=ke(N);var O;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(O||(e.Schemas=O={}));function k(l,m){return A.URI.isUri(l)?(0,C.$Df)(l.scheme,m):(0,C.$Ef)(l,m+":")}function b(l,...m){return m.some(E=>k(l,E))}e.$Ng="vscode-tkn",e.$Og="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m,E){this.f=$(m,E)}getServerRootPath(){return this.f}get g(){return N.$fc.join(this.f,O.vscodeRemoteResource)}set(m,E,f){this.a[m]=E,this.b[m]=f}setConnectionToken(m,E){this.c[m]=E}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(o){return R.$Y(o),m}const E=m.authority;let f=this.a[E];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const w=this.b[E],P=this.c[E];let p=`path=${encodeURIComponent(m.path)}`;return typeof P=="string"&&(p+=`&${e.$Og}=${encodeURIComponent(P)}`),A.URI.from({scheme:c.$p?this.d:O.vscodeRemoteResource,authority:`${f}:${w}`,path:this.g,query:p})}}e.$Pg=new I;function $(l,m){return N.$fc.join(m??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class d{static{this.a=e.$Vg}asBrowserUri(m){const E=this.b(m,oe);return this.uriToBrowserUri(E)}uriToBrowserUri(m){return m.scheme===O.vscodeRemote?e.$Pg.rewrite(m):m.scheme===O.file&&(c.$n||c.$r===`${O.vscodeFileResource}://${d.a}`)?m.with({scheme:O.vscodeFileResource,authority:m.authority||d.a,query:null,fragment:null}):m}asFileUri(m){const E=this.b(m,oe);return this.uriToFileUri(E)}uriToFileUri(m){return m.scheme===O.vscodeFileResource?m.with({scheme:O.file,authority:m.authority!==d.a?m.authority:null,query:null,fragment:null}):m}b(m,E){return A.URI.isUri(m)?m:A.URI.parse(E.toUrl(m))}}e.$Wg=new d;var g;(function(l){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(m.get("3"));const E="vscode-coi";function f(P){let p;typeof P=="string"?p=new URL(P).searchParams:P instanceof URL?p=P.searchParams:A.URI.isUri(P)&&(p=new URL(P.toString(!0)).searchParams);const o=p?.get(E);if(o)return m.get(o)}l.getHeadersFromQuery=f;function w(P,p,o){if(!globalThis.crossOriginIsolated)return;const u=p&&o?"3":o?"2":"1";P instanceof URLSearchParams?P.set(E,u):P[E]=u}l.addSearchParam=w})(g||(e.COI=g={}))}),define(he[140],ue([0,1,128,22,5,12,9]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=$,e.$tE=d,C=ke(C);class O{constructor(l,m,E){this.id=l,this.dependencies=m,this.callback=E}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(l,m,E)=>{typeof l!="string"&&(E=m,m=l,l=null),(typeof m!="object"||!Array.isArray(m))&&(E=m,m=null),this.c.push(new O(l,m,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith("vscode-file://vscode-app"))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}})))}async load(l){this.g();const m=await(this.a?this.i(l):this.b?this.h(l):this.j(l));if(!m)throw new Error(`Did not receive a define call from script ${l}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(l){return new Promise((m,E)=>{const f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript");const w=()=>{f.removeEventListener("load",P),f.removeEventListener("error",p)},P=o=>{w(),m(this.c.pop())},p=o=>{w(),E(o)};f.addEventListener("load",P),f.addEventListener("error",p),this.f&&(l=this.f.createScriptURL(l)),f.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(f)})}i(l){return new Promise((m,E)=>{try{this.f&&(l=this.f.createScriptURL(l)),importScripts(l),m(this.c.pop())}catch(f){E(f)}})}async j(l){try{const m=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,f=globalThis._VSCODE_NODE_MODULES.module,w=N.URI.parse(l).fsPath,P=m.readFileSync(w).toString(),p=f.wrap(P.replace(/^#!.*/,""));return new E.Script(p).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}const b=new Map;let I={};typeof globalThis.require=="object"&&(I=globalThis.require.paths??{});async function $(g,l,m){if(R.$R){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),I[g]&&(g=I[g]);const E=l?`${g}/${l}`:g;if(b.has(E))return b.get(E);let f;if(/^\w[\w\d+.-]*:\/\//.test(E))f=E;else{const o=`${m&&!C.$p?c.$Tg:c.$Sg}/${E}`;f=c.$Wg.asBrowserUri(o).toString(!0)}const w=k.INSTANCE.load(f);return b.set(E,w),w}else return await new Promise((E,f)=>{oe([g],E,f)}).then(ke)}function d(g,l){(0,A.$mg)(R.$R);const f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!C.$p,w=`${g}/${l}`,p=`${f?c.$Tg:c.$Sg}/${w}`;return c.$Wg.asBrowserUri(p).toString(!0)}}),define(he[20],ue([0,1,39,41,22,13,5,26,9]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=b,e.$mh=$,e.$nh=g,c=ke(c),A=ke(A);function b(l){return(0,k.$vc)(l,!0)}class I{constructor(m){this.a=m}compare(m,E,f=!1){return m===E?0:(0,O.$wf)(this.getComparisonKey(m,f),this.getComparisonKey(E,f))}isEqual(m,E,f=!1){return m===E?!0:!m||!E?!1:this.getComparisonKey(m,f)===this.getComparisonKey(E,f)}getComparisonKey(m,E=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,E,f=!1){if(m.scheme===E.scheme){if(m.scheme===C.Schemas.file)return c.$Bg(b(m),b(E),this.a(m))&&m.query===E.query&&(f||m.fragment===E.fragment);if((0,e.$ih)(m.authority,E.authority))return c.$Bg(m.path,E.path,this.a(m),"/")&&m.query===E.query&&(f||m.fragment===E.fragment)}return!1}joinPath(m,...E){return k.URI.joinPath(m,...E)}basenameOrAuthority(m){return(0,e.$ah)(m)||m.authority}basename(m){return A.$fc.basename(m.path)}extname(m){return A.$fc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let E;return m.scheme===C.Schemas.file?E=k.URI.file(A.$lc(b(m))).path:(E=A.$fc.dirname(m.path),m.authority&&E.length&&E.charCodeAt(0)!==R.CharCode.Slash&&(console.error(`dirname("${m.toString})) resulted in a relative path`),E="/")),m.with({path:E})}normalizePath(m){if(!m.path.length)return m;let E;return m.scheme===C.Schemas.file?E=k.URI.file(A.$gc(b(m))).path:E=A.$fc.normalize(m.path),m.with({path:E})}relativePath(m,E){if(m.scheme!==E.scheme||!(0,e.$ih)(m.authority,E.authority))return;if(m.scheme===C.Schemas.file){const P=A.$kc(b(m),b(E));return N.$j?c.$vg(P):P}let f=m.path||"/";const w=E.path||"/";if(this.a(m)){let P=0;for(const p=Math.min(f.length,w.length);P<p&&!(f.charCodeAt(P)!==w.charCodeAt(P)&&f.charAt(P).toLowerCase()!==w.charAt(P).toLowerCase());P++);f=w.substr(0,P)+f.substr(P)}return A.$fc.relative(f,w)}resolvePath(m,E){if(m.scheme===C.Schemas.file){const f=k.URI.file(A.$jc(b(m),E));return m.with({authority:f.authority,path:f.path})}return E=c.$wg(E),m.with({path:A.$fc.resolve(m.path,E)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,E){return m===E||m!==void 0&&E!==void 0&&(0,O.$Df)(m,E)}hasTrailingPathSeparator(m,E=A.sep){if(m.scheme===C.Schemas.file){const f=b(m);return f.length>c.$xg(f).length&&f[f.length-1]===E}else{const f=m.path;return f.length>1&&f.charCodeAt(f.length-1)===R.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,E=A.sep){return(0,e.$jh)(m,E)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,E=A.sep){let f=!1;if(m.scheme===C.Schemas.file){const w=b(m);f=w!==void 0&&w.length===c.$xg(w).length&&w[w.length-1]===E}else{E="/";const w=m.path;f=w.length===1&&w.charCodeAt(w.length-1)===R.CharCode.Slash}return!f&&!(0,e.$jh)(m,E)?m.with({path:m.path+"/"}):m}}e.$5g=I,e.$6g=new I(()=>!1),e.$7g=new I(l=>l.scheme===C.Schemas.file?!N.$l:!0),e.$8g=new I(l=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function $(l,m){const E=[];for(let f=0;f<l.length;f++){const w=m(l[f]);l.some((P,p)=>p===f?!1:(0,e.$0g)(w,m(P)))||E.push(l[f])}return E}var d;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function m(E){const f=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(p=>{const[o,u]=p.split(":");o&&u&&f.set(o,u)});const P=E.path.substring(0,E.path.indexOf(";"));return P&&f.set(l.META_DATA_MIME,P),f}l.parseMetaData=m})(d||(e.DataUri=d={}));function g(l,m,E){if(m){let f=l.path;return f&&f[0]!==A.$fc.sep&&(f=A.$fc.sep+f),l.with({scheme:E,authority:m,path:f})}return l.with({scheme:E})}}),define(he[6],ue([0,1,25,8,3,2,20,5,137,53]),function(oe,e,R,c,C,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=I,e.$ph=$,e.$qh=d,e.$rh=g,e.$sh=l,e.$th=m,e.$uh=E,e.$vh=f,e.$Dh=r,e.$Eh=a,e.$Fh=h,e.$Gh=y,e.$Hh=L,e.$Wh=W,e.$5h=M;function I(_){return!!_&&typeof _.then=="function"}function $(_){const Y=new R.$ue,re=_(Y.token),le=new Promise((ge,pe)=>{const Ee=Y.token.onCancellationRequested(()=>{Ee.dispose(),pe(new c.$4)});Promise.resolve(re).then(we=>{Ee.dispose(),Y.dispose(),ge(we)},we=>{Ee.dispose(),Y.dispose(),pe(we)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ge,pe){return le.then(ge,pe)}catch(ge){return this.then(void 0,ge)}finally(ge){return le.finally(ge)}}}function d(_,Y,re){return new Promise((le,ge)=>{const pe=Y.onCancellationRequested(()=>{pe.dispose(),le(re)});_.then(le,ge).finally(()=>pe.dispose())})}function g(_,Y){return new Promise((re,le)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),le(new c.$4)});_.then(re,le).finally(()=>ge.dispose())})}async function l(_){let Y=-1;const re=_.map((le,ge)=>le.then(pe=>(Y=ge,pe)));try{return await Promise.race(re)}finally{_.forEach((le,ge)=>{ge!==Y&&le.cancel()})}}function m(_,Y,re){let le;const ge=setTimeout(()=>{le?.(void 0),re?.()},Y);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(pe=>le=pe)])}function E(_){return new Promise((Y,re)=>{const le=_();I(le)?le.then(Y,re):Y(le)})}function f(){let _,Y;return{promise:new Promise((le,ge)=>{_=le,Y=ge}),resolve:_,reject:Y}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const re=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(re,re).then(le)})}return new Promise((re,le)=>{this.b.then(re,le)})}return this.a=Y(),new Promise((re,le)=>{this.a.then(ge=>{this.a=null,re(ge)},ge=>{this.a=null,le(ge)})})}dispose(){this.f=!0}}e.$wh=w;class P{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$xh=P;class p{constructor(){this.a=new Map}queue(Y,re){const ge=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(Y)===ge&&this.a.delete(Y)});return this.a.set(Y,ge),ge}}e.$yh=p;const o=(_,Y)=>{let re=!0;const le=setTimeout(()=>{re=!1,Y()},_);return{isTriggered:()=>re,dispose:()=>{clearTimeout(le),re=!1}}},u=_=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,_())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class i{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,re=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((ge,pe)=>{this.d=ge,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=re===k.$ee?u(le):o(re,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new c.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=i;class n{constructor(Y){this.a=new i(Y),this.b=new w}trigger(Y,re){return this.a.trigger(()=>this.b.queue(Y),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=n;class t{constructor(){this.a=!1,this.b=new Promise((Y,re)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=t;class s extends t{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$Ch=s;function r(_,Y){return Y?new Promise((re,le)=>{const ge=setTimeout(()=>{pe.dispose(),re()},_),pe=Y.onCancellationRequested(()=>{clearTimeout(ge),pe.dispose(),le(new c.$4)})}):$(re=>r(_,re))}function a(_,Y=0,re){const le=setTimeout(()=>{_(),re&&ge.dispose()},Y),ge=(0,A.$Rc)(()=>{clearTimeout(le),re?.deleteAndLeak(ge)});return re?.add(ge),ge}function h(_){const Y=[];let re=0;const le=_.length;function ge(){return re<le?_[re++]():null}function pe(Ee){Ee!=null&&Y.push(Ee);const we=ge();return we?we.then(pe):Promise.resolve(Y)}return Promise.resolve(null).then(pe)}function y(_,Y=le=>!!le,re=null){let le=0;const ge=_.length,pe=()=>{if(le>=ge)return Promise.resolve(re);const Ee=_[le++];return Promise.resolve(Ee()).then(be=>Y(be)?Promise.resolve(be):pe())};return pe()}function L(_,Y=le=>!!le,re=null){if(_.length===0)return Promise.resolve(re);let le=_.length;const ge=()=>{le=-1;for(const pe of _)pe.cancel?.()};return new Promise((pe,Ee)=>{for(const we of _)we.then(be=>{--le>=0&&Y(be)?(ge(),pe(be)):le===0&&pe(re)}).catch(be=>{--le>=0&&(ge(),Ee(be))})})}class S{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new C.$je}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,le)=>{this.g.push({factory:Y,c:re,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const re=Y.factory();re.then(Y.c,Y.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=S;class v extends S{constructor(){super(1)}}e.$Jh=v;class T{constructor(){this.a=new ee,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$Kh=T;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new te;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,re=N.$6g){const le=re.getComparisonKey(Y);return this.a.get(le)?.size??0}queueFor(Y,re,le=N.$6g){const ge=le.getComparisonKey(Y);let pe=this.a.get(ge);if(!pe){pe=new v;const Ee=this.f++,we=C.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(Ee,we),this.a.set(ge,pe)}return pe.queue(re)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=U;class F{constructor(Y,re){this.b=!1,this.a=-1,typeof Y=="function"&&typeof re=="number"&&this.setIfNotSet(Y,re)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,re){if(this.b)throw new c.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},re)}setIfNotSet(Y,re){if(this.b)throw new c.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},re))}}e.$Mh=F;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,re,le=globalThis){if(this.f)throw new c.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=le.setInterval(()=>{Y()},re);this.d=(0,A.$Rc)(()=>{le.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=j;class G{constructor(Y,re){this.b=-1,this.a=Y,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=G;class V{constructor(Y,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=Y,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=V;class x extends G{constructor(Y,re){super(Y,re),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Qh=x;class H extends A.$Tc{constructor(Y,re){super(),this.g=Y,this.h=re,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of Y)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(_,Y)=>{(0,O.$C)(()=>{if(re)return;const le=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$Th=(_,Y,re)=>{const le=_.requestIdleCallback(Y,typeof re=="number"?{timeout:re}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(le))}}},e.$Sh=_=>(0,e.$Th)(globalThis,_)}();class ie{constructor(Y,re){this.g=!1,this.d=()=>{try{this.j=re()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Th)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=ie;class z extends ie{constructor(Y){super(globalThis,Y)}}e.$Vh=z;async function W(_,Y,re){let le;for(let ge=0;ge<re;ge++)try{return await _()}catch(pe){le=pe,await r(Y)}throw le}class ee{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,re,le){return this.a={taskId:Y,cancel:()=>le?.(),promise:re},re.then(()=>this.d(Y),()=>this.d(Y)),re}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:re,resolve:le,reject:ge}=f();this.b={run:Y,promise:re,promiseResolve:le,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=ee;class ne{constructor(Y,re=()=>Date.now()){this.d=Y,this.f=re,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$Yh=ne;var ce;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(ce||(ce={}));class te{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Y,re)=>{this.a=Y,this.b=re})}complete(Y){return new Promise(re=>{this.a(Y),this.d={outcome:ce.Resolved,value:Y},re()})}error(Y){return new Promise(re=>{this.b(Y),this.d={outcome:ce.Rejected,value:Y},re()})}cancel(){return this.error(new c.$4)}}e.$Zh=te;var X;(function(_){async function Y(le){let ge;const pe=await Promise.all(le.map(Ee=>Ee.then(we=>we,we=>{ge||(ge=we)})));if(typeof ge<"u")throw ge;return pe}_.settled=Y;function re(le){return new Promise(async(ge,pe)=>{try{await le(ge,pe)}catch(Ee){pe(Ee)}})}_.withAsyncBody=re})(X||(e.Promises=X={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new c.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=K;class B{constructor(Y){this.b=Y,this.a=new b.$T(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=B;var D;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(D||(D={}));class J{static fromArray(Y){return new J(re=>{re.emitMany(Y)})}static fromPromise(Y){return new J(async re=>{re.emitMany(await Y)})}static fromPromises(Y){return new J(async re=>{await Promise.all(Y.map(async le=>re.emitOne(await le)))})}static merge(Y){return new J(async re=>{await Promise.all(Y.map(async le=>{for await(const ge of le)re.emitOne(ge)}))})}static{this.EMPTY=J.fromArray([])}constructor(Y,re){this.a=D.Initial,this.b=[],this.d=null,this.f=re,this.g=new C.$je,queueMicrotask(async()=>{const le={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Y(le)),this.k()}catch(ge){this.l(ge)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,re){return new J(async le=>{for await(const ge of Y)le.emitOne(re(ge))})}map(Y){return J.map(this,Y)}static filter(Y,re){return new J(async le=>{for await(const ge of Y)re(ge)&&le.emitOne(ge)})}filter(Y){return J.filter(this,Y)}static coalesce(Y){return J.filter(Y,re=>!!re)}coalesce(){return J.coalesce(this)}static async toPromise(Y){const re=[];for await(const le of Y)re.push(le);return re}toPromise(){return J.toPromise(this)}h(Y){this.a===D.Initial&&(this.b.push(Y),this.g.fire())}j(Y){this.a===D.Initial&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(Y){this.a===D.Initial&&(this.a=D.DoneError,this.d=Y,this.g.fire())}}e.$3h=J;class q extends J{constructor(Y,re){super(re),this.m=Y}cancel(){this.m.cancel()}}e.$4h=q;function M(_){const Y=new R.$ue,re=_(Y.token);return new q(Y,async le=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),le.reject(new c.$4)});try{for await(const pe of re){if(Y.token.isCancellationRequested)return;le.emitOne(pe)}ge.dispose(),Y.dispose()}catch(pe){ge.dispose(),Y.dispose(),le.reject(pe)}})}class Q{constructor(Y){this.a=new te,this.b=new J(ge=>{if(re){ge.reject(re);return}return le&&ge.emitMany(le),this.d=pe=>ge.reject(pe),this.f=pe=>ge.emitOne(pe),this.a.p},Y);let re,le;this.f=ge=>{le||(le=[]),le.push(ge)},this.d=ge=>{re||(re=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$6h=Q}),define(he[93],ue([0,1,17,6,39,41,31,13,5,26]),function(oe,e,R,c,C,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$sk=I,e.$vk=m,e.$wk=T,e.$xk=U,e.$yk=F,e.$zk=j,e.$Ak=G,e.$Bk=ie;function I(){return Object.create(null)}e.$tk="**",e.$uk="/";const $="[/\\\\]",d="[^/\\\\]",g=/\//g;function l(z,W){switch(z){case 0:return"";case 1:return`${d}*?`;default:return`(?:${$}|${d}+${$}${W?`|${$}${d}+`:""})*?`}}function m(z,W){if(!z)return[];const ee=[];let ne=!1,ce=!1,te="";for(const X of z){switch(X){case W:if(!ne&&!ce){ee.push(te),te="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}te+=X}return te&&ee.push(te),ee}function E(z){if(!z)return"";let W="";const ee=m(z,e.$uk);if(ee.every(ne=>ne===e.$tk))W=".*";else{let ne=!1;ee.forEach((ce,te)=>{if(ce===e.$tk){if(ne)return;W+=l(2,te===ee.length-1)}else{let X=!1,K="",B=!1,D="";for(const J of ce){if(J!=="}"&&X){K+=J;continue}if(B&&(J!=="]"||!D)){let q;J==="-"?q=J:(J==="^"||J==="!")&&!D?q="^":J===e.$uk?q="":q=(0,b.$ff)(J),D+=q;continue}switch(J){case"{":X=!0;continue;case"[":B=!0;continue;case"}":{const M=`(?:${m(K,",").map(Q=>E(Q)).join("|")})`;W+=M,X=!1,K="";break}case"]":{W+="["+D+"]",B=!1,D="";break}case"?":W+=d;continue;case"*":W+=l(1);continue;default:W+=(0,b.$ff)(J)}}te<ee.length-1&&(ee[te+1]!==e.$tk||te+2<ee.length)&&(W+=$)}ne=ce===e.$tk})}return W}const f=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new N.$Cc(1e4),n=function(){return!1},t=function(){return null};function s(z,W){if(!z)return t;let ee;typeof z!="string"?ee=z.pattern:ee=z,ee=ee.trim();const ne=`${ee}_${!!W.trimForExclusions}`;let ce=i.get(ne);if(ce)return r(ce,z);let te;return f.test(ee)?ce=h(ee.substr(4),ee):(te=w.exec(a(ee,W)))?ce=y(te[1],ee):(W.trimForExclusions?p:P).test(ee)?ce=L(ee,W):(te=o.exec(a(ee,W)))?ce=S(te[1].substr(1),ee,!0):(te=u.exec(a(ee,W)))?ce=S(te[1],ee,!1):ce=v(ee),i.set(ne,ce),r(ce,z)}function r(z,W){if(typeof W=="string")return z;const ee=function(ne,ce){return(0,A.$Bg)(ne,W.base,!k.$l)?z((0,b.$kf)(ne.substr(W.base.length),O.sep),ce):null};return ee.allBasenames=z.allBasenames,ee.allPaths=z.allPaths,ee.basenames=z.basenames,ee.patterns=z.patterns,ee}function a(z,W){return W.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function h(z,W){return function(ee,ne){return typeof ee=="string"&&ee.endsWith(z)?W:null}}function y(z,W){const ee=`/${z}`,ne=`\\${z}`,ce=function(X,K){return typeof X!="string"?null:K?K===z?W:null:X===z||X.endsWith(ee)||X.endsWith(ne)?W:null},te=[z];return ce.basenames=te,ce.patterns=[W],ce.allBasenames=te,ce}function L(z,W){const ee=H(z.slice(1,-1).split(",").map(K=>s(K,W)).filter(K=>K!==t),z),ne=ee.length;if(!ne)return t;if(ne===1)return ee[0];const ce=function(K,B){for(let D=0,J=ee.length;D<J;D++)if(ee[D](K,B))return z;return null},te=ee.find(K=>!!K.allBasenames);te&&(ce.allBasenames=te.allBasenames);const X=ee.reduce((K,B)=>B.allPaths?K.concat(B.allPaths):K,[]);return X.length&&(ce.allPaths=X),ce}function S(z,W,ee){const ne=O.sep===O.$fc.sep,ce=ne?z:z.replace(g,O.sep),te=O.sep+ce,X=O.$fc.sep+z;let K;return ee?K=function(B,D){return typeof B=="string"&&(B===ce||B.endsWith(te)||!ne&&(B===z||B.endsWith(X)))?W:null}:K=function(B,D){return typeof B=="string"&&(B===ce||!ne&&B===z)?W:null},K.allPaths=[(ee?"*/":"./")+z],K}function v(z){try{const W=new RegExp(`^${E(z)}$`);return function(ee){return W.lastIndex=0,typeof ee=="string"&&W.test(ee)?z:null}}catch{return t}}function T(z,W,ee){return!z||typeof W!="string"?!1:U(z)(W,void 0,ee)}function U(z,W={}){if(!z)return n;if(typeof z=="string"||F(z)){const ee=s(z,W);if(ee===t)return n;const ne=function(ce,te){return!!ee(ce,te)};return ee.allBasenames&&(ne.allBasenames=ee.allBasenames),ee.allPaths&&(ne.allPaths=ee.allPaths),ne}return V(z,W)}function F(z){const W=z;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function j(z){return z.allBasenames||[]}function G(z){return z.allPaths||[]}function V(z,W){const ee=H(Object.getOwnPropertyNames(z).map(K=>x(K,z[K],W)).filter(K=>K!==t)),ne=ee.length;if(!ne)return t;if(!ee.some(K=>!!K.requiresSiblings)){if(ne===1)return ee[0];const K=function(J,q){let M;for(let Q=0,_=ee.length;Q<_;Q++){const Y=ee[Q](J,q);if(typeof Y=="string")return Y;(0,c.$oh)(Y)&&(M||(M=[]),M.push(Y))}return M?(async()=>{for(const Q of M){const _=await Q;if(typeof _=="string")return _}return null})():null},B=ee.find(J=>!!J.allBasenames);B&&(K.allBasenames=B.allBasenames);const D=ee.reduce((J,q)=>q.allPaths?J.concat(q.allPaths):J,[]);return D.length&&(K.allPaths=D),K}const ce=function(K,B,D){let J,q;for(let M=0,Q=ee.length;M<Q;M++){const _=ee[M];_.requiresSiblings&&D&&(B||(B=(0,O.$mc)(K)),J||(J=B.substr(0,B.length-(0,O.$nc)(K).length)));const Y=_(K,B,J,D);if(typeof Y=="string")return Y;(0,c.$oh)(Y)&&(q||(q=[]),q.push(Y))}return q?(async()=>{for(const M of q){const Q=await M;if(typeof Q=="string")return Q}return null})():null},te=ee.find(K=>!!K.allBasenames);te&&(ce.allBasenames=te.allBasenames);const X=ee.reduce((K,B)=>B.allPaths?K.concat(B.allPaths):K,[]);return X.length&&(ce.allPaths=X),ce}function x(z,W,ee){if(W===!1)return t;const ne=s(z,ee);if(ne===t)return t;if(typeof W=="boolean")return ne;if(W){const ce=W.when;if(typeof ce=="string"){const te=(X,K,B,D)=>{if(!D||!ne(X,K))return null;const J=ce.replace("$(basename)",()=>B),q=D(J);return(0,c.$oh)(q)?q.then(M=>M?z:null):q?z:null};return te.requiresSiblings=!0,te}}return ne}function H(z,W){const ee=z.filter(K=>!!K.basenames);if(ee.length<2)return z;const ne=ee.reduce((K,B)=>{const D=B.basenames;return D?K.concat(D):K},[]);let ce;if(W){ce=[];for(let K=0,B=ne.length;K<B;K++)ce.push(W)}else ce=ee.reduce((K,B)=>{const D=B.patterns;return D?K.concat(D):K},[]);const te=function(K,B){if(typeof K!="string")return null;if(!B){let J;for(J=K.length;J>0;J--){const q=K.charCodeAt(J-1);if(q===C.CharCode.Slash||q===C.CharCode.Backslash)break}B=K.substr(J)}const D=ne.indexOf(B);return D!==-1?ce[D]:null};te.basenames=ne,te.patterns=ce,te.allBasenames=ne;const X=z.filter(K=>!K.basenames);return X.push(te),X}function ie(z,W){return(0,R.$tb)(z,W,(ee,ne)=>typeof ee=="string"&&typeof ne=="string"?ee===ne:typeof ee!="string"&&typeof ne!="string"?ee.base===ne.base&&ee.pattern===ne.pattern:!1)}}),define(he[94],ue([0,1,14,65,9]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=k,e.$Mn=I,e.$Nn=$;function A(d){return d.toJSON()}class N{constructor(g){this.a=g}transformIncoming(g){const l=this.a.transformIncoming(g);return l===g?g:A(C.URI.from(l))}transformOutgoing(g){const l=this.a.transformOutgoing(g);return l===g?g:A(C.URI.from(l))}transformOutgoingURI(g){const l=this.a.transformOutgoing(g);return l===g?g:C.URI.from(l)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Jn=N,e.$Kn=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function O(d,g,l){if(!d||l>200)return null;if(typeof d=="object"){if(d instanceof C.URI)return g.transformOutgoing(d);for(const m in d)if(Object.hasOwnProperty.call(d,m)){const E=O(d[m],g,l+1);E!==null&&(d[m]=E)}}return null}function k(d,g){const l=O(d,g,0);return l===null?d:l}function b(d,g,l,m){if(!d||m>200)return null;if(typeof d=="object"){if(d.$mid===c.MarshalledId.Uri)return l?C.URI.revive(g.transformIncoming(d)):g.transformIncoming(d);if(d instanceof R.$Le)return null;for(const E in d)if(Object.hasOwnProperty.call(d,E)){const f=b(d[E],g,l,m+1);f!==null&&(d[E]=f)}}return null}function I(d,g){const l=b(d,g,!1,0);return l===null?d:l}function $(d,g){const l=b(d,g,!0,0);return l===null?d:l}}),define(he[32],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=c;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function c(C){return R.test(C)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(O){for(let k=0;k<O.length;k++)O[k]=Math.floor(Math.random()*256);return O};const A=new Uint8Array(16),N=[];for(let O=0;O<256;O++)N.push(O.toString(16).padStart(2,"0"));return function(){C(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let k=0,b="";return b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b}}()}),define(he[141],ue([0,1,38]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=A;const c=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(N){const O=N.replace(/\-/g,":").toLowerCase();return!c.has(O)}function A(){const N=(0,R.networkInterfaces)();for(const O in N){const k=N[O];if(k){for(const{mac:b}of k)if(C(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(he[142],ue([0,1,38,51,32,141,5]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Qn=k,e.$Rn=$,e.$Sn=d,C=ke(C),e.$Pn=new class{c(g){return this.a||(this.a=c.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,l=0;const m=(0,R.networkInterfaces)();for(const E in m){const f=m[E];if(f)for(const{mac:w,internal:P}of f)P||(l+=1,this.c(w.toUpperCase())&&(g+=1))}this.b=l>0?g/l:0}return this.b}};let O;async function k(g){return O||(O=(async()=>await b(g)||C.$Yg())()),O}async function b(g){try{const l=await new Promise((E,f)=>{oe(["crypto"],E,f)}).then(ke),m=(0,A.$On)();return l.createHash("sha256").update(m,"utf8").digest("hex")}catch(l){g(l);return}}const I="Software\\Microsoft\\SQMClient";async function $(g){if(N.$j){const l=await new Promise((m,E)=>{oe(["@vscode/windows-registry"],m,E)}).then(ke);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",I,"MachineId")||""}catch(m){return g(m),""}}return""}async function d(g){try{return await(await new Promise((E,f)=>{oe(["@vscode/deviceid"],E,f)}).then(ke)).getDeviceId()}catch(l){return g(l),""}}}),define(he[143],ue([0,1,240,14]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AX=void 0;class C extends R.Transform{constructor(N){if(super(),typeof N=="number")this.b=N,this.c=1;else{const O=Buffer.isBuffer(N)?N:Buffer.from(N);this.b=O.length===1?O[0]:O,this.c=O.length}}_transform(N,O,k){this.a?this.a=Buffer.concat([this.a,N]):this.a=N;let b=0;for(;b<this.a.length;){const I=typeof this.b=="number"?this.a.indexOf(this.b,b):(0,c.$Me)(this.a,this.b,b);if(I===-1)break;this.push(this.a.slice(b,I+this.c)),b=I+this.c}this.a=b===this.a.length?void 0:this.a.slice(b),k()}_flush(N){this.a&&this.push(this.a),N()}}e.$AX=C}),define(he[144],ue([0,1,33,13,37]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BX=b,e.$CX=I;const A="XDG_SESSION_TYPE",N="WAYLAND_DISPLAY",O="XDG_RUNTIME_DIR";var k;(function($){$.Wayland="wayland",$.XWayland="xwayland",$.X11="x11",$.Unknown="unknown"})(k||(k={}));async function b($){const d=C.env[A];if(d)return d===k.Wayland||d===k.X11?d:k.Unknown;if(C.env[N]){const l=C.env[O];if(l){const m=(0,c.$ic)(l,"wayland-0");try{return await R.promises.access(m,R.constants.R_OK),k.Wayland}catch(E){return $(E),k.Unknown}}else return k.Unknown}else return k.X11}function I($,d){if(d)switch(d){case"auto":return $;case"x11":return $===k.Wayland?k.XWayland:k.X11;case"wayland":return k.Wayland;default:return k.Unknown}else return $===k.Wayland?k.XWayland:k.X11}}),define(he[145],ue([0,1,33,241,5]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=A,C=ke(C);async function A(N){if(C.$k||C.$j)return;let O;for(const k of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{O=await R.promises.open(k,R.constants.R_OK);break}catch{}if(!O){N("Unable to retrieve release information from known identifier paths.");return}try{const k=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),b={id:"unknown"};for await(const I of(0,c.createInterface)({input:O.createReadStream(),crlfDelay:1/0})){if(!I.includes("="))continue;const $=I.split("=")[0].toUpperCase().trim();if(k.has($)){const d=I.split("=")[1].replace(/"/g,"").toLowerCase().trim();$==="ID"||$==="DISTRIB_ID"?b.id=d:$==="ID_LIKE"?b.id_like=d:($==="VERSION_ID"||$==="DISTRIB_RELEASE")&&(b.version_id=d)}}return b}catch(k){N(k)}}}),define(he[30],ue([0,1,33,38,242,6,41,90,13,5,20,9]),function(oe,e,R,c,C,A,N,O,k,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=E,e.readdirSync=P,e.whenDeleted=u,e.configureFlushOnWrite=r,e.writeFileSync=h,R=ke(R);var d;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function g(V,x=d.UNLINK,H){if((0,N.$Fg)(V))throw new Error("rimraf - will refuse to recursively delete root");return x===d.UNLINK?m(V):l(V,H)}async function l(V,x=(0,N.$Kg)((0,c.tmpdir)())){try{try{await R.promises.rename(V,x)}catch(H){return H.code==="ENOENT"?void 0:m(V)}m(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function m(V){return R.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function E(V){if((0,N.$Fg)(V))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function f(V,x){return p(await(x?w(V):R.promises.readdir(V)))}async function w(V){try{return await R.promises.readdir(V,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const x=[],H=await f(V);for(const ie of H){let z=!1,W=!1,ee=!1;try{const ne=await R.promises.lstat((0,k.$ic)(V,ie));z=ne.isFile(),W=ne.isDirectory(),ee=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:ie,isFile:()=>z,isDirectory:()=>W,isSymbolicLink:()=>ee})}return x}function P(V){return p(R.readdirSync(V))}function p(V){return V.map(x=>typeof x=="string"?b.$k?(0,O.$km)(x):x:(x.name=b.$k?(0,O.$km)(x.name):x.name,x))}async function o(V){const x=await f(V),H=[];for(const ie of x)await i.existsDirectory((0,k.$ic)(V,ie))&&H.push(ie);return H}function u(V,x=1e3){return new Promise(H=>{let ie=!1;const z=setInterval(()=>{ie||(ie=!0,R.access(V,W=>{ie=!1,W&&(clearInterval(z),H(void 0))}))},x)})}var i;(function(V){async function x(z){let W;try{if(W=await R.promises.lstat(z),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await R.promises.stat(z),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(b.$j&&ee.code==="EACCES")try{return{stat:await R.promises.stat(await R.promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ne}throw ee}}V.stat=x;async function H(z){try{const{stat:W,symbolicLink:ee}=await V.stat(z);return W.isFile()&&ee?.dangling!==!0}catch{}return!1}V.existsFile=H;async function ie(z){try{const{stat:W,symbolicLink:ee}=await V.stat(z);return W.isDirectory()&&ee?.dangling!==!0}catch{}return!1}V.existsDirectory=ie})(i||(e.SymlinkSupport=i={}));const n=new A.$Lh;function t(V,x,H){return n.queueFor($.URI.file(V),()=>{const ie=y(H);return new Promise((z,W)=>a(V,x,ie,ee=>ee?W(ee):z()))},I.$7g)}let s=!0;function r(V){s=V}function a(V,x,H,ie){if(!s)return R.writeFile(V,x,{mode:H.mode,flag:H.flag},ie);R.open(V,H.flag,H.mode,(z,W)=>{if(z)return ie(z);R.writeFile(W,x,ee=>{if(ee)return R.close(W,()=>ie(ee));R.fdatasync(W,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),R.close(W,ce=>ie(ce))))})})}function h(V,x,H){const ie=y(H);if(!s)return R.writeFileSync(V,x,{mode:ie.mode,flag:ie.flag});const z=R.openSync(V,ie.flag,ie.mode);try{R.writeFileSync(z,x);try{R.fdatasyncSync(z)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{R.closeSync(z)}}function y(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function L(V,x,H=6e4){if(V!==x)try{b.$j&&typeof H=="number"?await S(V,x,Date.now(),H):await R.promises.rename(V,x)}catch(ie){if(V.toLowerCase()!==x.toLowerCase()&&ie.code==="EXDEV"||V.endsWith("."))await v(V,x,{preserveSymlinks:!1}),await g(V,d.MOVE);else throw ie}}async function S(V,x,H,ie,z=0){try{return await R.promises.rename(V,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-H>=ie)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${W}`),W;if(z===0){let ee=!1;try{const{stat:ne}=await i.stat(x);ne.isFile()||(ee=!0)}catch{}if(ee)throw W}return await(0,A.$Dh)(Math.min(100,z*10)),S(V,x,H,ie,z+1)}}async function v(V,x,H){return U(V,x,{root:{source:V,target:x},options:H,handledSourcePaths:new Set})}const T=511;async function U(V,x,H){if(H.handledSourcePaths.has(V))return;H.handledSourcePaths.add(V);const{stat:ie,symbolicLink:z}=await i.stat(V);if(z){if(H.options.preserveSymlinks)try{return await G(V,x,H)}catch{}if(z.dangling)return}return ie.isDirectory()?F(V,x,ie.mode&T,H):j(V,x,ie.mode&T)}async function F(V,x,H,ie){await R.promises.mkdir(x,{recursive:!0,mode:H});const z=await f(V);for(const W of z)await U((0,k.$ic)(V,W),(0,k.$ic)(x,W),ie)}async function j(V,x,H){await R.promises.copyFile(V,x),await R.promises.chmod(x,H)}async function G(V,x,H){let ie=await R.promises.readlink(V);(0,N.$Bg)(ie,H.root.source,!b.$l)&&(ie=(0,k.$ic)(H.root.target,ie.substr(H.root.source.length+1))),await R.promises.symlink(ie,x)}e.Promises=new class{get read(){return(V,x,H,ie,z)=>new Promise((W,ee)=>{R.read(V,x,H,ie,z,(ne,ce,te)=>ne?ee(ne):W({bytesRead:ce,buffer:te}))})}get write(){return(V,x,H,ie,z)=>new Promise((W,ee)=>{R.write(V,x,H,ie,z,(ne,ce,te)=>ne?ee(ne):W({bytesWritten:ce,buffer:te}))})}get fdatasync(){return(0,C.promisify)(R.fdatasync)}get open(){return(0,C.promisify)(R.open)}get close(){return(0,C.promisify)(R.close)}get realpath(){return(0,C.promisify)(R.realpath)}async exists(V){try{return await R.promises.access(V),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return o}get writeFile(){return t}get rm(){return g}get rename(){return L}get copy(){return v}}}),define(he[146],ue([0,1,33,13,5,26,30]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=O,e.$jr=k,e.$kr=b,e.$lr=I,R=ke(R);function O(d){if(C.$l)return d;const g=(0,c.$lc)(d);if(d===g)return d;const l=((0,c.$mc)(d)||d).toLowerCase();try{const E=(0,N.readdirSync)(g).filter(f=>f.toLowerCase()===l);if(E.length===1){const f=O(g);if(f)return(0,c.$ic)(f,E[0])}else if(E.length>1){const f=E.indexOf(l);if(f>=0){const w=O(g);if(w)return(0,c.$ic)(w,E[f])}}}catch{}return null}async function k(d,g){if(C.$l)return d;const l=(0,c.$lc)(d);if(d===l)return d;const m=((0,c.$mc)(d)||d).toLowerCase();try{if(g?.isCancellationRequested)return null;const f=(await N.Promises.readdir(l)).filter(w=>w.toLowerCase()===m);if(f.length===1){const w=await k(l,g);if(w)return(0,c.$ic)(w,f[0])}else if(f.length>1){const w=f.indexOf(m);if(w>=0){const P=await k(l,g);if(P)return(0,c.$ic)(P,f[w])}}}catch{}return null}async function b(d){try{return await N.Promises.realpath(d)}catch{const l=$(d);return await R.promises.access(l,R.constants.R_OK),l}}function I(d){try{return R.realpathSync(d)}catch{const l=$(d);return R.accessSync(l,R.constants.R_OK),l}}function $(d){return(0,A.$lf)((0,c.$gc)(d),c.sep)}}),define(he[147],ue([0,1,67]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=c,e.$3g=A,R=ke(R);function c(O,k,b,I=1){let $=!1;return new Promise(d=>{const g=setTimeout(()=>{if(!$)return $=!0,d(0)},b);C(O,k,I,l=>{if(!$)return $=!0,clearTimeout(g),d(l)})})}function C(O,k,b,I){if(k===0)return I(0);const $=new R.Socket;$.once("connect",()=>(N($),C(O+b,k-1,b,I))),$.once("data",()=>{}),$.once("error",d=>(N($),d.code!=="ECONNREFUSED"?C(O+b,k-1,b,I):I(O))),$.connect(O,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(O,k,b,I="127.0.0.1"){let $=!1,d,g=1;const l=R.createServer({pauseOnConnect:!0});function m(E,f){$||($=!0,l.removeAllListeners(),l.close(),d&&clearTimeout(d),f(E))}return new Promise(E=>{d=setTimeout(()=>{m(0,E)},b),l.on("listening",()=>{m(O,E)}),l.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&g<k?(O++,g++,l.listen(O,I)):m(0,E)}),l.on("close",()=>{m(0,E)}),l.listen(O,I)})}function N(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch(k){console.error(k)}}}),define(he[148],ue([0,1,33,13,5,37,91,12,30]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$vm=b,e.$wm=I,c=ke(c),C=ke(C),A=ke(A),O=ke(O),k=ke(k),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function b(d=A.env){return d.comspec||"cmd.exe"}function I(d){let g=[],l=!1;const m=function(E){if(l){g.push(E);return}(!d.send(E,w=>{if(w&&console.error(w),l=!1,g.length>0){const P=g.slice(0);g=[],P.forEach(p=>m(p))}})||C.$j)&&(l=!0)};return{send:m}}var $;(function(d){async function g(l,m,E){if(c.$hc(l))return l;if(m===void 0&&(m=A.cwd()),c.$lc(l)!=="."||(E===void 0&&O.$cg(A.env.PATH)&&(E=A.env.PATH.split(c.$sc)),E===void 0||E.length===0))return c.$ic(m,l);async function w(P){if(await k.Promises.exists(P)){let p;try{p=await R.promises.stat(P)}catch(o){o.message.startsWith("EACCES")&&(p=await R.promises.lstat(P))}return p?!p.isDirectory():!1}return!1}for(const P of E){let p;if(c.$hc(P)?p=c.$ic(P,l):p=c.$ic(m,P,l),await w(p))return p;let o=p+".com";if(await w(o)||(o=p+".exe",await w(o)))return o}return c.$ic(m,l)}d.findExecutable=g})($||(e.win32=$={}))}),define(he[149],ue([0,1,68,22]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=C;function C(N){return new Promise((O,k)=>{let b;const I=new Map;function $(g,l,m,E,f){const w=I.get(l);if(g===N||w){const P={name:d(m),cmd:m,pid:g,ppid:l,load:E,mem:f};I.set(g,P),g===N&&(b=P),w&&(w.children||(w.children=[]),w.children.push(P),w.children.length>1&&(w.children=w.children.sort((p,o)=>p.pid-o.pid)))}}function d(g){const l=/--utility-sub-type=network/i,m=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(m.exec(g))return"electron-crash-reporter";if(E.exec(g))return"winpty-agent";if(f.exec(g))return"conpty-agent";let P=w.exec(g);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?l.exec(g)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const p=/[a-zA-Z-]+\.js/g;let o="";do P=p.exec(g),P&&(o+=P+" ");while(P);return o&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${o})`:g}if(process.platform==="win32"){const g=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,m)=>{oe(["@vscode/windows-process-tree"],l,m)}).then(ke).then(l=>{l.getProcessList(N,m=>{if(!m){k(new Error(`Root process ${N} not found`));return}l.getProcessCpuUsage(m,E=>{const f=new Map;E.forEach(w=>{const P=g(w.commandLine||"");f.set(w.pid,{name:d(P),cmd:P,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),b=f.get(N),b?(f.forEach(w=>{const P=f.get(w.ppid);P&&(P.children||(P.children=[]),P.children.push(w))}),f.forEach(w=>{w.children&&(w.children=w.children.sort((P,p)=>P.pid-p.pid))}),O(b)):k(new Error(`Root process ${N} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let g=function(){let l=[b];const m=[];for(;l.length;){const f=l.shift();f&&(m.push(f.pid),f.children&&(l=l.concat(f.children)))}let E=JSON.stringify(c.$Wg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+m.join(" "),(0,R.exec)(E,{},(f,w,P)=>{if(f||P)k(f||new Error(P.toString()));else{const p=w.toString().split(`
`);for(let o=0;o<m.length;o++){const u=I.get(m[o]);u.load=parseFloat(p[o])}if(!b){k(new Error(`Root process ${N} not found`));return}O(b)}})};(0,R.exec)("which ps",{},(l,m,E)=>{if(l||E)if(process.platform!=="linux")k(l||new Error(E.toString()));else{const f=JSON.stringify(c.$Wg.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(f,{},(w,P,p)=>{w||p?k(w||new Error(p.toString())):(A(P,$),g())})}else{const f=m.toString().trim();(0,R.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,p,o)=>{P||o&&!o.includes("screen size is bogus")?k(P||new Error(o.toString())):(A(p,$),process.platform==="linux"?g():b?O(b):k(new Error(`Root process ${N} not found`)))})}})}})}function A(N,O){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=N.toString().split(`
`);for(const I of b){const $=k.exec(I.trim());$&&$.length===6&&O(parseInt($[1]),parseInt($[2]),$[5],parseFloat($[3]),parseFloat($[4]))}}});var ve=this&&this.__decorate||function(oe,e,R,c){var C=arguments.length,A=C<3?e:c===null?c=Object.getOwnPropertyDescriptor(e,R):c,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(oe,e,R,c);else for(var O=oe.length-1;O>=0;O--)(N=oe[O])&&(A=(C<3?N(A):C>3?N(e,R,A):N(e,R))||A);return C>3&&A&&Object.defineProperty(e,R,A),A};define(he[42],ue([0,1,17,6,14,25,87,8,3,2,66,26,12]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=r,e.$di=a,e.$ii=T,e.$ji=U,$=ke($);var g;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(g||(g={}));function l(z){switch(z){case g.Promise:return"req";case g.PromiseCancel:return"cancel";case g.EventListen:return"subscribe";case g.EventDispose:return"unsubscribe"}}var m;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(m||(m={}));function E(z){switch(z){case m.Initialize:return"init";case m.PromiseSuccess:return"reply:";case m.PromiseError:case m.PromiseErrorObj:return"replyErr:";case m.EventFire:return"event:"}}var f;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(f||(f={}));function w(z){let W=0;for(let ee=0;;ee+=7){const ne=z.read(1);if(W|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return W}}const P=n(0);function p(z,W){if(W===0){z.write(P);return}let ee=0;for(let ce=W;ce!==0;ce=ce>>>7)ee++;const ne=C.$Le.alloc(ee);for(let ce=0;W!==0;ce++)ne.buffer[ce]=W&127,W=W>>>7,W>0&&(ne.buffer[ce]|=128);z.write(ne)}class o{constructor(W){this.b=W,this.a=0}read(W){const ee=this.b.slice(this.a,this.a+W);return this.a+=ee.byteLength,ee}}e.$ai=o;class u{constructor(){this.a=[]}get buffer(){return C.$Le.concat(this.a)}write(W){this.a.push(W)}}e.$bi=u;var i;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(i||(i={}));function n(z){const W=C.$Le.alloc(1);return W.writeUInt8(z,0),W}const t={Undefined:n(i.Undefined),String:n(i.String),Buffer:n(i.Buffer),VSBuffer:n(i.VSBuffer),Array:n(i.Array),Object:n(i.Object),Uint:n(i.Int)},s=typeof Buffer<"u";function r(z,W){if(typeof W>"u")z.write(t.Undefined);else if(typeof W=="string"){const ee=C.$Le.fromString(W);z.write(t.String),p(z,ee.byteLength),z.write(ee)}else if(s&&Buffer.isBuffer(W)){const ee=C.$Le.wrap(W);z.write(t.Buffer),p(z,ee.byteLength),z.write(ee)}else if(W instanceof C.$Le)z.write(t.VSBuffer),p(z,W.byteLength),z.write(W);else if(Array.isArray(W)){z.write(t.Array),p(z,W.length);for(const ee of W)r(z,ee)}else if(typeof W=="number"&&(W|0)===W)z.write(t.Uint),p(z,W);else{const ee=C.$Le.fromString(JSON.stringify(W));z.write(t.Object),p(z,ee.byteLength),z.write(ee)}}function a(z){switch(z.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return z.read(w(z)).toString();case i.Buffer:return z.read(w(z)).buffer;case i.VSBuffer:return z.read(w(z));case i.Array:{const ee=w(z),ne=[];for(let ce=0;ce<ee;ce++)ne.push(a(z));return ne}case i.Object:return JSON.parse(z.read(w(z)).toString());case i.Int:return w(z)}}class h{constructor(W,ee,ne=null,ce=1e3){this.h=W,this.j=ee,this.k=ne,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:m.Initialize})}registerChannel(W,ee){this.b.set(W,ee),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case m.Initialize:{const ee=this.o([W.type]);this.k?.logOutgoing(ee,0,y.OtherSide,E(W.type));return}case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:{const ee=this.o([W.type,W.id],W.data);this.k?.logOutgoing(ee,W.id,y.OtherSide,E(W.type),W.data);return}}}o(W,ee=void 0){const ne=new u;return r(ne,W),r(ne,ee),this.p(ne.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const ee=new o(W),ne=a(ee),ce=a(ee),te=ne[0];switch(te){case g.Promise:return this.k?.logIncoming(W.byteLength,ne[1],y.OtherSide,`${l(te)}: ${ne[2]}.${ne[3]}`,ce),this.s({type:te,id:ne[1],channelName:ne[2],name:ne[3],arg:ce});case g.EventListen:return this.k?.logIncoming(W.byteLength,ne[1],y.OtherSide,`${l(te)}: ${ne[2]}.${ne[3]}`,ce),this.t({type:te,id:ne[1],channelName:ne[2],name:ne[3],arg:ce});case g.PromiseCancel:return this.k?.logIncoming(W.byteLength,ne[1],y.OtherSide,`${l(te)}`),this.u({type:te,id:ne[1]});case g.EventDispose:return this.k?.logIncoming(W.byteLength,ne[1],y.OtherSide,`${l(te)}`),this.u({type:te,id:ne[1]})}}s(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=new A.$ue;let ce;try{ce=ee.call(this.j,W.name,W.arg,ne.token)}catch(K){ce=Promise.reject(K)}const te=W.id;ce.then(K=>{this.m({id:te,data:K,type:m.PromiseSuccess})},K=>{K instanceof Error?this.m({id:te,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split(`
`):void 0},type:m.PromiseError}):this.m({id:te,data:K,type:m.PromiseErrorObj})}).finally(()=>{X.dispose(),this.d.delete(W.id)});const X=(0,b.$Rc)(()=>ne.cancel());this.d.set(W.id,X)}t(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=W.id,te=ee.listen(this.j,W.name,W.arg)(X=>this.m({id:ne,data:X,type:m.EventFire}));this.d.set(W.id,te)}u(W){const ee=this.d.get(W.id);ee&&(ee.dispose(),this.d.delete(W.id))}v(W){let ee=this.g.get(W.channelName);ee||(ee=[],this.g.set(W.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===g.Promise&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:m.PromiseError})},this.l);ee.push({request:W,timeoutTimer:ne})}w(W){const ee=this.g.get(W);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case g.Promise:this.s(ne.request);break;case g.EventListen:this.t(ne.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Oc)(this.d.values()),this.d.clear()}}e.$ei=h;var y;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class L{constructor(W,ee=null){this.l=W,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(W){const ee=this;return{call(ne,ce,te){return ee.a?Promise.reject(new O.$4):ee.m(W,ne,ce,te)},listen(ne,ce){return ee.a?k.Event.None:ee.o(W,ne,ce)}}}m(W,ee,ne,ce=A.CancellationToken.None){const te=this.g++,X=g.Promise,K={id:te,type:X,channelName:W,name:ee,arg:ne};if(ce.isCancellationRequested)return Promise.reject(new O.$4);let B;return new Promise((J,q)=>{if(ce.isCancellationRequested)return q(new O.$4);const M=()=>{const re=le=>{switch(le.type){case m.PromiseSuccess:this.f.delete(te),J(le.data);break;case m.PromiseError:{this.f.delete(te);const ge=new Error(le.data.message);ge.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,ge.name=le.data.name,q(ge);break}case m.PromiseErrorObj:this.f.delete(te),q(le.data);break}};this.f.set(te,re),this.p(K)};let Q=null;this.b===f.Idle?M():(Q=(0,c.$ph)(re=>this.u()),Q.then(()=>{Q=null,M()}));const _=()=>{Q?(Q.cancel(),Q=null):this.p({id:te,type:g.PromiseCancel}),q(new O.$4)},Y=ce.onCancellationRequested(_);B=(0,b.$Qc)((0,b.$Rc)(_),Y),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(W,ee,ne){const ce=this.g++,te=g.EventListen,X={id:ce,type:te,channelName:W,name:ee,arg:ne};let K=null;const B=new k.$je({onWillAddFirstListener:()=>{K=(0,c.$ph)(J=>this.u()),K.then(()=>{K=null,this.d.add(B),this.p(X)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(B),this.p({id:ce,type:g.EventDispose}))}}),D=J=>B.fire(J.data);return this.f.set(ce,D),B.event}p(W){switch(W.type){case g.Promise:case g.EventListen:{const ee=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(ee,W.id,y.LocalSide,`${l(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case g.PromiseCancel:case g.EventDispose:{const ee=this.q([W.type,W.id]);this.j?.logOutgoing(ee,W.id,y.LocalSide,l(W.type));return}}}q(W,ee=void 0){const ne=new u;return r(ne,W),r(ne,ee),this.r(ne.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const ee=new o(W),ne=a(ee),ce=a(ee),te=ne[0];switch(te){case m.Initialize:return this.j?.logIncoming(W.byteLength,0,y.LocalSide,E(te)),this.t({type:ne[0]});case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:return this.j?.logIncoming(W.byteLength,ne[1],y.LocalSide,E(te),ce),this.t({type:ne[0],id:ne[1],data:ce})}}t(W){if(W.type===m.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Oc)(this.d.values()),this.d.clear()}}e.$fi=L,ve([N.$7h],L.prototype,"onDidInitializePromise",null);class S{get connections(){const W=[];return this.f.forEach(ee=>W.push(ee)),W}constructor(W,ee,ne){this.a=new Map,this.f=new Set,this.g=new k.$je,this.onDidAddConnection=this.g.event,this.h=new k.$je,this.onDidRemoveConnection=this.h.event,this.j=new b.$Sc,this.j.add(W(({protocol:ce,onDidClientDisconnect:te})=>{const X=k.Event.once(ce.onMessage);this.j.add(X(K=>{const B=new o(K),D=a(B),J=new h(ce,D,ee,ne),q=new L(ce,ee);this.a.forEach((Q,_)=>J.registerChannel(_,Q));const M={channelServer:J,channelClient:q,ctx:D};this.f.add(M),this.g.fire(M),this.j.add(te(()=>{J.dispose(),q.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(W,ee){const ne=this;return{call(ce,te,X){let K;if((0,d.$qg)(ee)){const D=(0,R.$2b)(ne.connections.filter(ee));K=D?Promise.resolve(D):k.Event.toPromise(k.Event.filter(ne.onDidAddConnection,ee))}else K=ee.routeCall(ne,ce,te);const B=K.then(D=>D.channelClient.getChannel(W));return T(B).call(ce,te,X)},listen(ce,te){if((0,d.$qg)(ee))return ne.k(W,ee,ce,te);const X=ee.routeEvent(ne,ce,te).then(K=>K.channelClient.getChannel(W));return T(X).listen(ce,te)}}}k(W,ee,ne,ce){const te=this;let X;const K=new k.$je({onWillAddFirstListener:()=>{X=new b.$Sc;const B=new k.$pe,D=new Map,J=M=>{const _=M.channelClient.getChannel(W).listen(ne,ce),Y=B.add(_);D.set(M,Y)},q=M=>{const Q=D.get(M);Q&&(Q.dispose(),D.delete(M))};te.connections.filter(ee).forEach(J),k.Event.filter(te.onDidAddConnection,ee)(J,void 0,X),te.onDidRemoveConnection(q,void 0,X),B.event(K.fire,K,X),X.add(B)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return K.event}registerChannel(W,ee){this.a.set(W,ee);for(const ne of this.f)ne.channelServer.registerChannel(W,ee)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=S;class v{constructor(W,ee,ne=null){const ce=new u;r(ce,ee),W.send(ce.buffer),this.a=new L(W,ne),this.d=new h(W,ee,ne)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,ee){this.d.registerChannel(W,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=v;function T(z){return{call(W,ee,ne){return z.then(ce=>ce.call(W,ee,ne))},listen(W,ee){const ne=new k.$se;return z.then(ce=>ne.input=ce.listen(W,ee)),ne.event}}}function U(z){let W=!1;return{call(ee,ne,ce){return W?z.call(ee,ne,ce):(0,c.$Dh)(0).then(()=>W=!0).then(()=>z.call(ee,ne,ce))},listen(ee,ne){if(W)return z.listen(ee,ne);const ce=new k.$se;return(0,c.$Dh)(0).then(()=>W=!0).then(()=>ce.input=z.listen(ee,ne)),ce.event}}}class F{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const ee of W.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await k.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$ki=F;var j;(function(z){function W(te,X,K){const B=te,D=K&&K.disableMarshalling,J=new Map;for(const q in B)ne(q)&&J.set(q,k.Event.buffer(B[q],!0,void 0,X));return new class{listen(q,M,Q){const _=J.get(M);if(_)return _;const Y=B[M];if(typeof Y=="function"){if(ce(M))return Y.call(B,Q);if(ne(M))return J.set(M,k.Event.buffer(B[M],!0,void 0,X)),J.get(M)}throw new O.$ab(`Event not found: ${M}`)}call(q,M,Q){const _=B[M];if(typeof _=="function"){if(!D&&Array.isArray(Q))for(let re=0;re<Q.length;re++)Q[re]=(0,I.$_h)(Q[re]);let Y=_.apply(B,Q);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new O.$ab(`Method not found: ${M}`)}}}z.fromService=W;function ee(te,X){const K=X&&X.disableMarshalling;return new Proxy({},{get(B,D){if(typeof D=="string")return X?.properties?.has(D)?X.properties.get(D):ce(D)?function(J){return te.listen(D,J)}:ne(D)?te.listen(D):async function(...J){let q;X&&!(0,d.$lg)(X.context)?q=[X.context,...J]:q=J;const M=await te.call(D,q);return K?M:(0,I.$_h)(M)};throw new O.$ab(`Property not found: ${String(D)}`)}})}z.toService=ee;function ne(te){return te[0]==="o"&&te[1]==="n"&&$.$Cf(te.charCodeAt(2))}function ce(te){return/^onDynamic/.test(te)&&$.$Cf(te.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const W=z.toString();if(W!=="[object Object]")return W}return z}function x(z){return Array.isArray(z)?z.map(V):V(z)}function H(z,W,ee,ne,ce,te,X){X=x(X);const K=G[ce],B=K[ne%K.length];let D=[`%c[${z}]%c[${String(W).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(te)?(D=D.concat(X),D.push(")")):D.push(X),console.log.apply(console,D)}class ie{constructor(W,ee){this.d=W,this.f=ee,this.a=0,this.b=0}logOutgoing(W,ee,ne,ce,te){this.b+=W,H(this.d,this.b,W,ee,ne,ce,te)}logIncoming(W,ee,ne,ce,te){this.a+=W,H(this.f,this.a,W,ee,ne,ce,te)}}e.$li=ie}),define(he[69],ue([0,1,14,3,2,42]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var N;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(N||(e.SocketDiagnosticsEventType=N={}));var O;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let r=0;function a(y,L){if(!s.has(y)){const S=String(++r);s.set(y,S)}return s.get(y)}function h(y,L,S,v){if(!t.enableDiagnostics)return;const T=a(y,L);if(v instanceof R.$Le||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const U=R.$Le.alloc(v.byteLength);U.set(v),t.records.push({timestamp:Date.now(),id:T,label:L,type:S,buff:U})}else t.records.push({timestamp:Date.now(),id:T,label:L,type:S,data:v})}t.traceSocketEvent=h})(O||(e.SocketDiagnostics=O={}));var k;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let b=null;function I(){return b||(b=R.$Le.alloc(0)),b}class ${get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,r){if(s===0)return I();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const L=this.a[0];return r&&(this.a.shift(),this.b-=s),L}if(this.a[0].byteLength>s){const L=this.a[0].slice(0,s);return r&&(this.a[0]=this.a[0].slice(s),this.b-=s),L}const a=R.$Le.alloc(s);let h=0,y=0;for(;s>0;){const L=this.a[y];if(L.byteLength>s){const S=L.slice(0,s);a.set(S,h),h+=s,r&&(this.a[y]=L.slice(s),this.b-=s),s-=s}else a.set(L,h),h+=L.byteLength,r?(this.a.shift(),this.b-=L.byteLength):y++,s-=L.byteLength}return a}}e.$mi=$;var d;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(d||(d={}));function g(t){switch(t){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class m{constructor(s,r,a,h){this.type=s,this.id=r,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends C.$Tc{constructor(s){super(),this.f=this.B(new c.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:d.None,id:0,ack:0},this.a=s,this.b=!1,this.c=new $,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent(N.ProtocolHeaderRead,{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,h=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=d.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(N.ProtocolMessageRead,r),this.f.fire(new m(a,h,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=R.$Le.alloc(l.HeaderLength);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent(N.ProtocolHeaderWrite,{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent(N.ProtocolMessageWrite,s.data),this.j(r,s.data)}g(s,r){const a=this.f===0;return this.d.push(s,r),this.f+=s.byteLength+r.byteLength,a}h(){const s=R.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,r){this.g(s,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent(N.ProtocolWrite,{byteLength:s.byteLength}),this.c.write(s)}}class w extends C.$Tc{constructor(s){super(),this.f=new c.$je,this.onMessage=this.f.event,this.g=new c.$je,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new f(this.a)),this.c=this.B(new E(this.a)),this.B(this.c.onMessage(r=>{r.type===d.Regular&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new m(d.Regular,0,0,s))}}e.$ni=w;class P extends A.$hi{static fromSocket(s,r){return new P(new w(s),r)}get onDidDispose(){return this.b.onDidDispose}constructor(s,r,a=null){super(s,r,a),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$oi=P;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new c.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$pi=p;class o{constructor(s){this.data=s,this.next=null}}class u{constructor(){this.a=null,this.b=null}length(){let s=0,r=this.a;for(;r;)r=r.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let r=0,a=this.a;for(;a;)s[r++]=a.data,a=a.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const r=new o(s);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const s=Date.now();for(let r=0;r<i.a;r++)this.c[r]=s-1e3*r;setInterval(()=>{for(let r=i.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),r=(1+i.a)*1e3;let a=0;for(let h=0;h<i.a;h++)s-this.c[h]<=r&&a++;return 1-a/i.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.d-this.f}constructor(s){this.v=new p,this.onControlMessage=this.v.event,this.w=new p,this.onMessage=this.w.event,this.x=new p,this.onDidDispose=this.x.event,this.y=new p,this.onSocketClose=this.y.event,this.z=new p,this.onSocketTimeout=this.z.event,this.t=s.loadEstimator??i.getInstance(),this.u=s.sendKeepAlive??!0,this.a=!1,this.c=new u,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new C.$Sc,this.p=s.socket,this.q=this.s.add(new f(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(r=>this.A(r))),this.s.add(this.p.onClose(r=>this.y.fire(r))),s.initialChunk&&this.r.acceptChunk(s.initialChunk),this.u?this.m=setInterval(()=>{this.E()},l.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const s=new m(d.Disconnect,0,0,I());this.q.write(s),this.q.flush()}}sendPause(){const s=new m(d.Pause,0,0,I());this.q.write(s)}sendResume(){const s=new m(d.Resume,0,0,I());this.q.write(s)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(s,r){this.a=!0,this.s.dispose(),this.s=new C.$Sc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=s,this.q=this.s.add(new f(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(a=>this.A(a))),this.s.add(this.p.onClose(a=>this.y.fire(a))),this.r.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.j=this.h;const s=new m(d.Ack,0,this.j,I());this.q.write(s);const r=this.c.toArray();for(let a=0,h=r.length;a<h;a++)this.q.write(r[a]);this.C()}acceptDisconnect(){this.x.fire()}A(s){if(s.ack>this.f){this.f=s.ack;do{const r=this.c.peek();if(r&&r.id<=s.ack)this.c.pop();else break}while(!0)}switch(s.type){case d.None:break;case d.Regular:{if(s.id>this.h)if(s.id!==this.h+1){const r=Date.now();r-this.n>1e4&&(this.n=r,this.q.write(new m(d.ReplayRequest,0,0,I())))}else this.h=s.id,this.k=Date.now(),this.B(),this.w.fire(s.data);break}case d.Control:{this.v.fire(s.data);break}case d.Ack:break;case d.Disconnect:{this.x.fire();break}case d.ReplayRequest:{const r=this.c.toArray();for(let a=0,h=r.length;a<h;a++)this.q.write(r[a]);this.C();break}case d.Pause:{this.q.pause();break}case d.Resume:{this.q.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(s){const r=++this.d;this.j=this.h;const a=new m(d.Regular,r,this.j,s);this.c.push(a),this.a||(this.q.write(a),this.C())}sendControl(s){const r=new m(d.Control,0,0,s);this.q.write(r)}B(){if(this.h<=this.j||this.l)return;const s=Date.now()-this.k;if(s>=l.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},l.AcknowledgeTime-s+5)}C(){if(this.d<=this.f||this.g||this.a)return;const s=this.c.peek(),r=Date.now()-s.writtenTime,a=Date.now()-this.r.lastReadTime,h=Date.now()-this.o;if(r>=l.TimeoutTime&&a>=l.TimeoutTime&&h>=l.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const y=Math.max(l.TimeoutTime-r,l.TimeoutTime-a,l.TimeoutTime-h,500);this.g=setTimeout(()=>{this.g=null,this.C()},y)}D(){if(this.h<=this.j)return;this.j=this.h;const s=new m(d.Ack,0,this.j,I());this.q.write(s)}E(){this.j=this.h;const s=new m(d.KeepAlive,0,this.j,I());this.q.write(s)}}e.$qi=n}),define(he[95],ue([0,1,68,6,14,25,139,8,3,2,29,148,91,42]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0,O=ke(O);class l extends g.$ei{constructor(f){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",w=>C.$Le.wrap(Buffer.from(w,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$er=l;class m{constructor(f,w){this.i=f,this.j=w,this.c=new Set,this.g=new Map,this.h=new k.$je,this.onDidProcessExit=this.h.event;const P=w&&w.timeout?w.timeout:6e4;this.b=new c.$zh(P),this.d=null,this.f=null}getChannel(f){const w=this;return{call(P,p,o){return w.k(f,P,p,o)},listen(P,p){return w.l(f,P,p)}}}k(f,w,P,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(O.$5());this.b.cancel();const o=this.n(f),u=(0,c.$ph)(t=>o.call(w,P,t)),i=p.onCancellationRequested(()=>u.cancel()),n=(0,b.$Rc)(()=>u.cancel());return this.c.add(n),u.finally(()=>{i.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),u}l(f,w,P){if(!this.b)return k.Event.None;this.b.cancel();let p;const o=new k.$je({onWillAddFirstListener:()=>{p=this.n(f).listen(w,P)(o.fire,o),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,I.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,d.$jm)(w.env),this.d=(0,R.fork)(this.i,f,w);const P=new k.$je,o=k.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,N.$ar)(r)){(0,N.log)(r,`IPC Library: ${this.j.serverName}`);return}P.fire(C.$Le.wrap(Buffer.from(r,"base64")))}),u=this.j.useQueue?(0,$.$wm)(this.d):this.d,i=r=>this.d&&this.d.connected&&u.send(r.buffer.toString("base64")),n=P.event,t={send:i,onMessage:n};this.f=new g.$fi(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",s),o.dispose(),this.c.forEach(h=>(0,b.$Oc)(h)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(f){let w=this.g.get(f);return w||(w=this.m.getChannel(f),this.g.set(f,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fr=m}),define(he[150],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SX=R;function R(c){return!!c.parentPort}}),define(he[151],ue([0,1,150,14,42,3,12,17]),function(oe,e,R,c,C,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TX=void 0,e.$UX=I;class k{constructor(d){this.a=d,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",g=>g.data?c.$Le.wrap(g.data):c.$Le.alloc(0)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}class b extends C.$gi{static b(d){(0,N.$mg)((0,R.$SX)(process),"Electron Utility Process");const g=new A.$je;return process.parentPort.on("message",l=>{if(d?.handledClientConnection(l))return;const m=(0,O.$Nb)(l.ports);m&&g.fire(m)}),A.Event.map(g.event,l=>({protocol:new k(l),onDidClientDisconnect:A.Event.fromNodeEventEmitter(l,"close")}))}constructor(d){super(b.b(d))}}e.$TX=b;function I($,d,g){const l=m=>{m.data===d&&($.removeListener("message",l),g())};$.on("message",l)}}),define(he[70],ue([0,1,6,3,2,66,12]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=k;var O;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function k(d){const g=d;return g?.changed instanceof Map||g?.deleted instanceof Set}var b;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(b||(e.StorageState=b={}));class I extends C.$Tc{static{this.a=100}constructor(g,l=Object.create(null)){super(),this.r=g,this.s=l,this.b=this.B(new c.$me),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new R.$Ah(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((l,m)=>this.w(m,l)),g.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(g,l){if(this.c===b.Closed)return;let m=!1;(0,N.$lg)(l)?m=this.f.delete(g):this.f.get(g)!==l&&(this.f.set(g,l),m=!0),m&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,l){const m=this.f.get(g);return(0,N.$lg)(m)?l:m}getBoolean(g,l){const m=this.get(g);return(0,N.$lg)(m)?l:m==="true"}getNumber(g,l){const m=this.get(g);return(0,N.$lg)(m)?l:parseInt(m,10)}getObject(g,l){const m=this.get(g);return(0,N.$lg)(m)?l:(0,A.$$h)(m)}async set(g,l,m=!1){if(this.c===b.Closed)return;if((0,N.$lg)(l))return this.delete(g,m);const E=(0,N.$eg)(l)||Array.isArray(l)?(0,A.$0h)(l):String(l);if(this.f.get(g)!==E)return this.f.set(g,E),this.j.set(g,E),this.h.delete(g),this.b.fire({key:g,external:m}),this.D()}async delete(g,l=!1){if(!(this.c===b.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:l}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(!(this.c===b.Closed||this.m))return this.D(g)}async D(g){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$bq=I;class ${constructor(){this.onDidChangeItemsExternal=c.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((l,m)=>this.a.set(m,l)),g.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$cq=$}),define(he[11],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=C,e.localize2=N;const R=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function c(O,k){let b;return k.length===0?b=O:b=O.replace(/\{(\d+)\}/g,(I,$)=>{const d=$[0],g=k[d];let l=I;return typeof g=="string"?l=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(l=String(g)),l}),R&&(b="\uFF3B"+b.replace(/[aouei]/g,"$&$&")+"\uFF3D"),b}function C(O,k,...b){return c(typeof O=="number"?A(O,k):k,b)}function A(O,k){const b=globalThis._VSCODE_NLS_MESSAGES?.[O];if(typeof b!="string"){if(typeof k=="string")return k;throw new Error(`!!! NLS MISSING: ${O} !!!`)}return b}function N(O,k,...b){let I;typeof O=="number"?I=A(O,k):I=k;const $=c(I,b);return{value:$,original:k===I?$:c(k,b)}}}),define(he[71],ue([0,1,11]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=b,e.$Zm=I,e.$1m=$;const c=60,C=c*60,A=C*24,N=A*7,O=A*30,k=A*365;function b(d,g,l,m){typeof d!="number"&&(d=d.getTime());const E=Math.round((new Date().getTime()-d)/1e3);if(E<-30)return(0,R.localize)(12849,null,b(new Date().getTime()+E*1e3,!1));if(!m&&E<30)return(0,R.localize)(12850,null);let f;return E<c?(f=E,g?f===1?l?(0,R.localize)(12851,null,f):(0,R.localize)(12852,null,f):l?(0,R.localize)(12853,null,f):(0,R.localize)(12854,null,f):f===1?l?(0,R.localize)(12855,null,f):(0,R.localize)(12856,null,f):l?(0,R.localize)(12857,null,f):(0,R.localize)(12858,null,f)):E<C?(f=Math.floor(E/c),g?f===1?l?(0,R.localize)(12859,null,f):(0,R.localize)(12860,null,f):l?(0,R.localize)(12861,null,f):(0,R.localize)(12862,null,f):f===1?l?(0,R.localize)(12863,null,f):(0,R.localize)(12864,null,f):l?(0,R.localize)(12865,null,f):(0,R.localize)(12866,null,f)):E<A?(f=Math.floor(E/C),g?f===1?l?(0,R.localize)(12867,null,f):(0,R.localize)(12868,null,f):l?(0,R.localize)(12869,null,f):(0,R.localize)(12870,null,f):f===1?l?(0,R.localize)(12871,null,f):(0,R.localize)(12872,null,f):l?(0,R.localize)(12873,null,f):(0,R.localize)(12874,null,f)):E<N?(f=Math.floor(E/A),g?f===1?(0,R.localize)(12875,null,f):(0,R.localize)(12876,null,f):f===1?(0,R.localize)(12877,null,f):(0,R.localize)(12878,null,f)):E<O?(f=Math.floor(E/N),g?f===1?l?(0,R.localize)(12879,null,f):(0,R.localize)(12880,null,f):l?(0,R.localize)(12881,null,f):(0,R.localize)(12882,null,f):f===1?l?(0,R.localize)(12883,null,f):(0,R.localize)(12884,null,f):l?(0,R.localize)(12885,null,f):(0,R.localize)(12886,null,f)):E<k?(f=Math.floor(E/O),g?f===1?l?(0,R.localize)(12887,null,f):(0,R.localize)(12888,null,f):l?(0,R.localize)(12889,null,f):(0,R.localize)(12890,null,f):f===1?l?(0,R.localize)(12891,null,f):(0,R.localize)(12892,null,f):l?(0,R.localize)(12893,null,f):(0,R.localize)(12894,null,f)):(f=Math.floor(E/k),g?f===1?l?(0,R.localize)(12895,null,f):(0,R.localize)(12896,null,f):l?(0,R.localize)(12897,null,f):(0,R.localize)(12898,null,f):f===1?l?(0,R.localize)(12899,null,f):(0,R.localize)(12900,null,f):l?(0,R.localize)(12901,null,f):(0,R.localize)(12902,null,f))}function I(d,g){const l=Math.abs(d/1e3);return l<1?g?(0,R.localize)(12903,null,d):(0,R.localize)(12904,null,d):l<c?g?(0,R.localize)(12905,null,Math.round(d)/1e3):(0,R.localize)(12906,null,Math.round(d)/1e3):l<C?g?(0,R.localize)(12907,null,Math.round(d/(1e3*c))):(0,R.localize)(12908,null,Math.round(d/(1e3*c))):l<A?g?(0,R.localize)(12909,null,Math.round(d/(1e3*C))):(0,R.localize)(12910,null,Math.round(d/(1e3*C))):(0,R.localize)(12911,null,Math.round(d/(1e3*A)))}function $(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[43],ue([0,1,17,12,11]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=k,e.$oj=b,e.$pj=I,R=ke(R),c=ke(c),C=ke(C);function A($,d){return d&&($.stack||$.stacktrace)?C.localize(12843,null,O($),N($.stack)||N($.stacktrace)):O($)}function N($){return Array.isArray($)?$.join(`
`):$}function O($){return $.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${$.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof $.code=="string"&&typeof $.errno=="number"&&typeof $.syscall=="string"?C.localize(12844,null,$.message):$.message||C.localize(12845,null)}function k($=null,d=!1){if(!$)return C.localize(12846,null);if(Array.isArray($)){const g=R.$Gb($),l=k(g[0],d);return g.length>1?C.localize(12847,null,l,g.length):l}if(c.$cg($))return $;if($.detail){const g=$.detail;if(g.error)return A(g.error,d);if(g.exception)return A(g.exception,d)}return $.stack?A($,d):$.message?$.message:C.localize(12848,null)}function b($){const d=$;return d instanceof Error&&Array.isArray(d.actions)}function I($,d){let g;return typeof $=="string"?g=new Error($):g=$,g.actions=d,g}}),define(he[152],ue([0,1,11,36]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=C;function C(A){switch(A){case c.ParseErrorCode.InvalidSymbol:return(0,R.localize)(12834,null);case c.ParseErrorCode.InvalidNumberFormat:return(0,R.localize)(12835,null);case c.ParseErrorCode.PropertyNameExpected:return(0,R.localize)(12836,null);case c.ParseErrorCode.ValueExpected:return(0,R.localize)(12837,null);case c.ParseErrorCode.ColonExpected:return(0,R.localize)(12838,null);case c.ParseErrorCode.CommaExpected:return(0,R.localize)(12839,null);case c.ParseErrorCode.CloseBraceExpected:return(0,R.localize)(12840,null);case c.ParseErrorCode.CloseBracketExpected:return(0,R.localize)(12841,null);case c.ParseErrorCode.EndOfFileExpected:return(0,R.localize)(12842,null);default:return""}}}),define(he[72],ue([0,1,33,6,13,12,30,11]),function(oe,e,R,c,C,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0,e.zip=E,e.$Aq=f,e.$Bq=P,C=ke(C),O=ke(O),e.$xq="end of central directory record signature not found";const k=new RegExp(e.$xq);class b extends Error{constructor(o,u){let i=u.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=u}}e.$yq=b;function I(p){const o=p.externalFileAttributes>>16||33188;return[448,56,7].map(u=>o&u).reduce((u,i)=>u+i,o&61440)}function $(p){if(p instanceof b)return p;let o;return k.test(p.message)&&(o="CorruptZip"),new b(o,p)}function d(p,o,u,i,n,t){const s=C.$lc(o),r=C.$ic(i,s);if(!r.startsWith(i))return Promise.reject(new Error(O.localize(12811,null,o)));const a=C.$ic(i,o);let h;return t.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(R.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,L)=>{if(!t.isCancellationRequested)try{h=(0,R.createWriteStream)(a,{mode:u}),h.once("close",()=>y()),h.once("error",L),p.once("error",L),p.pipe(h)}catch(S){L(S)}}))}function g(p,o,u,i){let n=(0,c.$ph)(()=>Promise.resolve()),t=0;const s=i.onCancellationRequested(()=>{n.cancel(),p.close()});return new Promise((r,a)=>{const h=new c.$xh,y=L=>{L.isCancellationRequested||(t++,p.readEntry())};p.once("error",a),p.once("close",()=>n.then(()=>{i.isCancellationRequested||p.entryCount===t?r():a(new b("Incomplete",new Error(O.localize(12812,null,t,p.entryCount))))},a)),p.readEntry(),p.on("entry",L=>{if(i.isCancellationRequested)return;if(!u.sourcePathRegex.test(L.fileName)){y(i);return}const S=L.fileName.replace(u.sourcePathRegex,"");if(/\/$/.test(S)){const U=C.$ic(o,S);n=(0,c.$ph)(F=>R.promises.mkdir(U,{recursive:!0}).then(()=>y(F)).then(void 0,a));return}const v=m(p,L),T=I(L);n=(0,c.$ph)(U=>h.queue(()=>v.then(F=>d(F,S,T,o,u,U).then(()=>y(U)))).then(null,a))})}).finally(()=>s.dispose())}async function l(p,o=!1){const{open:u}=await new Promise((i,n)=>{oe(["yauzl"],i,n)}).then(ke);return new Promise((i,n)=>{u(p,o?{lazyEntries:!0}:void 0,(t,s)=>{t?n($(t)):i((0,A.$ng)(s))})})}function m(p,o){return new Promise((u,i)=>{p.openReadStream(o,(n,t)=>{n?i($(n)):u((0,A.$ng)(t))})})}async function E(p,o){const{ZipFile:u}=await new Promise((i,n)=>{oe(["yazl"],i,n)}).then(ke);return new Promise((i,n)=>{const t=new u;o.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const s=(0,R.createWriteStream)(p);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>i(p))})}function f(p,o,u={},i){const n=new RegExp(u.sourcePath?`^${u.sourcePath}`:"");let t=l(p,!0);return u.overwrite&&(t=t.then(s=>N.Promises.rm(o).then(()=>s))),t.then(s=>g(s,o,{sourcePathRegex:n},i))}function w(p,o){return l(p).then(u=>new Promise((i,n)=>{u.on("entry",t=>{t.fileName===o&&m(u,t).then(s=>i(s),s=>n(s))}),u.once("close",()=>n(new Error(O.localize(12813,null,o))))}))}function P(p,o){return w(p,o).then(u=>new Promise((i,n)=>{const t=[];u.once("error",n),u.on("data",s=>t.push(s)),u.on("end",()=>i(Buffer.concat(t)))}))}}),define(he[153],ue([0,1,39,8,11]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var A;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(A||(e.TokenType=A={}));function N(...I){switch(I.length){case 1:return(0,C.localize)(11450,null,I[0]);case 2:return(0,C.localize)(11451,null,I[0],I[1]);case 3:return(0,C.localize)(11452,null,I[0],I[1],I[2]);default:return}}const O=(0,C.localize)(11453,null),k=(0,C.localize)(11454,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return $.isTripleEq?"===":"==";case A.NotEq:return $.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return $.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return $.lexeme;case A.QuotedStr:return $.lexeme;case A.Error:return $.lexeme;case A.EOF:return"EOF";default:throw(0,c.$7)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case R.CharCode.OpenParen:this.k(A.LParen);break;case R.CharCode.CloseParen:this.k(A.RParen);break;case R.CharCode.ExclamationMark:if(this.h(R.CharCode.Equals)){const d=this.h(R.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:d})}else this.k(A.Neg);break;case R.CharCode.SingleQuote:this.o();break;case R.CharCode.Slash:this.q();break;case R.CharCode.Equals:if(this.h(R.CharCode.Equals)){const d=this.h(R.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:d})}else this.h(R.CharCode.Tilde)?this.k(A.RegexOp):this.l(N("==","=~"));break;case R.CharCode.LessThan:this.k(this.h(R.CharCode.Equals)?A.LtEq:A.Lt);break;case R.CharCode.GreaterThan:this.k(this.h(R.CharCode.Equals)?A.GtEq:A.Gt);break;case R.CharCode.Ampersand:this.h(R.CharCode.Ampersand)?this.k(A.And):this.l(N("&&"));break;case R.CharCode.Pipe:this.h(R.CharCode.Pipe)?this.k(A.Or):this.l(N("||"));break;case R.CharCode.Space:case R.CharCode.CarriageReturn:case R.CharCode.Tab:case R.CharCode.LineFeed:case R.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?R.CharCode.Null:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const d=this.d,g=this.c.substring(this.d,this.e),l={type:A.Error,offset:this.d,lexeme:g};this.g.push({offset:d,lexeme:g,additionalInfo:$}),this.f.push(l)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const d=this.c.substring(this.d,this.e),g=b.b.get(d);g?this.k(g):this.f.push({type:A.Str,lexeme:d,offset:this.d})}}o(){for(;this.j()!==R.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,d=!1,g=!1;for(;;){if($>=this.c.length){this.e=$,this.l(k);return}const m=this.c.charCodeAt($);if(d)d=!1;else if(m===R.CharCode.Slash&&!g){$++;break}else m===R.CharCode.OpenSquareBracket?g=!0:m===R.CharCode.Backslash?d=!0:m===R.CharCode.CloseSquareBracket&&(g=!1);$++}for(;$<this.c.length&&b.a.has(this.c.charCodeAt($));)$++;this.e=$;const l=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=b}),define(he[154],ue([0,1,71,87,22,13,37,20,9]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$4m=I,e.$5m=$,e.$2m=/^([^.]+\..+)[:=](.+)$/;class b{get appRoot(){return(0,A.$lc)(C.$Wg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,O.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:C.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,R.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",g)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$dh)(k.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=N.env.VSCODE_PORTABLE;return g?k.URI.file((0,A.$ic)(g,"argv.json")):(0,O.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,A.$jc)(g):(0,A.$gc)((0,A.$ic)(C.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?k.URI.file((0,A.$jc)(g)):k.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,A.$jc)(g);const l=N.env.VSCODE_EXTENSIONS;if(l)return l;const m=N.env.VSCODE_PORTABLE;return m?(0,A.$ic)(m,"extensions"):(0,O.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(l=>/^[^:/?#]+?:\/\//.test(l)?k.URI.parse(l):k.URI.file((0,A.$gc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?k.URI.parse(g):k.URI.file((0,A.$gc)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$2m.test(g))}get extensionLogLevel(){const g=[];for(const l of this.args.log||[]){const m=e.$2m.exec(l);m&&m[1]&&m[2]&&g.push([m[1],m[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,O.$dh)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=N.env.VSCODE_PORTABLE;return g?k.URI.file((0,A.$ic)(g,"policy.json")):(0,O.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,l,m){this.a=g,this.b=l,this.c=m,this.editSessionId=this.args.editSessionId}}e.$3m=b,ve([c.$7h],b.prototype,"appRoot",null),ve([c.$7h],b.prototype,"userHome",null),ve([c.$7h],b.prototype,"userDataPath",null),ve([c.$7h],b.prototype,"appSettingsHome",null),ve([c.$7h],b.prototype,"tmpDir",null),ve([c.$7h],b.prototype,"cacheHome",null),ve([c.$7h],b.prototype,"stateResource",null),ve([c.$7h],b.prototype,"userRoamingDataHome",null),ve([c.$7h],b.prototype,"userDataSyncHome",null),ve([c.$7h],b.prototype,"sync",null),ve([c.$7h],b.prototype,"machineSettingsResource",null),ve([c.$7h],b.prototype,"workspaceStorageHome",null),ve([c.$7h],b.prototype,"localHistoryHome",null),ve([c.$7h],b.prototype,"keyboardLayoutResource",null),ve([c.$7h],b.prototype,"argvResource",null),ve([c.$7h],b.prototype,"isExtensionDevelopment",null),ve([c.$7h],b.prototype,"untitledWorkspacesHome",null),ve([c.$7h],b.prototype,"builtinExtensionsPath",null),ve([c.$7h],b.prototype,"extensionsPath",null),ve([c.$7h],b.prototype,"extensionDevelopmentLocationURI",null),ve([c.$7h],b.prototype,"extensionDevelopmentKind",null),ve([c.$7h],b.prototype,"extensionTestsLocationURI",null),ve([c.$7h],b.prototype,"debugExtensionHost",null),ve([c.$7h],b.prototype,"logLevel",null),ve([c.$7h],b.prototype,"extensionLogLevel",null),ve([c.$7h],b.prototype,"serviceMachineIdResource",null),ve([c.$7h],b.prototype,"disableTelemetry",null),ve([c.$7h],b.prototype,"disableWorkspaceTrust",null),ve([c.$7h],b.prototype,"useInMemorySecretStorage",null),ve([c.$7h],b.prototype,"policyFile",null);function I(d,g){return $(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId,d.extensionEnvironment)}function $(d,g,l,m,E,f){const P=Number(g||d)||(m?null:l),p=P?!!g:!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:P,break:p,debugId:E,env:o}}}),function(){function oe(e,R,c){function C(N,O){const k=A(N,O),b=[k];return e.isAbsolute(k)||b.unshift(c),e.resolve(...b)}function A(N,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,O);const I=N["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const $=process.env.USERPROFILE;if(typeof $!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join($,"AppData","Roaming")}break;case"darwin":b=e.join(R.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,O)}return{getUserDataPath:C}}if(typeof define=="function")define(he[155],ue([243,38,37]),function(e,R,c){return oe(e,R,c.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=oe(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[156],ue([0,1,38,154,155]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0,e.$7m=N,e.$8m=O;class A extends c.$3m{constructor(b,I){super(b,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,C.getUserDataPath)(b,I.nameShort)},I)}}e.$6m=A;function N(k,b){return(0,c.$5m)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,b,k.extensionEnvironment)}function O(k,b){return(0,c.$5m)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,b,k.extensionEnvironment)}}),define(he[157],ue([0,1,12,11]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=C;function C(N,O,k,b){try{A(N,O,k,b)}catch(I){N.error(I?.message??I)}return O}function A(N,O,k,b){const I=($,d,g)=>{const l=$[d];if((0,R.$cg)(l)){const m=l,E=m.length;if(E>1&&m[0]==="%"&&m[E-1]==="%"){const f=m.substr(1,E-2);let w=k[f];w===void 0&&b&&(w=b[f]);const P=typeof w=="string"?w:w?.message,p=b?.[f],o=typeof p=="string"?p:p?.message;if(!P){o||N.warn(`[${O.name}]: ${(0,c.localize)(11333,null,f)}`);return}if(g&&(d==="title"||d==="category")&&o&&o!==P){const u={value:P,original:o};$[d]=u}else $[d]=P}}else if((0,R.$eg)(l))for(const m in l)l.hasOwnProperty(m)&&(m==="commands"?I(l,m,!0):I(l,m,g));else if(Array.isArray(l))for(let m=0;m<l.length;m++)I(l,m,g)};for(const $ in O)O.hasOwnProperty($)&&I(O,$)}}),define(he[158],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=e.$Zhc=void 0;class R{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Zhc=R;class c{constructor(A){this.a=A}listen(A,N){throw new Error(`Event not found: ${N}`)}call(A,N,O){switch(N){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(O[0])}throw new Error(`Call not found: ${N}`)}}e.$1hc=c}),define(he[159],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const R={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(R)}),define(he[73],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class R{constructor(C,A=[],N=!1){this.ctor=C,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.$zi=R}),define(he[160],ue([0,1,73]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=A,e.$Ps=N;const c=[];var C;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function A(O,k,b){k instanceof R.$zi||(k=new R.$zi(k,[],!!b)),c.push([O,k])}function N(){return c}}),define(he[161],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class R{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$rr=R;class c{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const N of this.a.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const O=this.lookupOrInsertNode(A),k=this.lookupOrInsertNode(N);O.outgoing.set(k.key,k),k.incoming.set(O.key,O)}removeNode(A){const N=this.b(A);this.a.delete(N);for(const O of this.a.values())O.outgoing.delete(N),O.incoming.delete(N)}lookupOrInsertNode(A){const N=this.b(A);let O=this.a.get(N);return O||(O=new R(N,A),this.a.set(N,O)),O}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[N,O]of this.a)A.push(`${N}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this.a){const O=new Set([A]),k=this.c(N,O);if(k)return k}}c(A,N){for(const[O,k]of A.outgoing){if(N.has(O))return[...N,O].join(" -> ");N.add(O);const b=this.c(k,N);if(b)return b;N.delete(O)}}}e.$sr=c}),define(he[4],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=C,e.$Di=A;var R;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function O(k){return k[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=O})(R||(e._util=R={})),e.$Bi=C("instantiationService");function c(N,O,k){O[R.DI_TARGET]===O?O[R.DI_DEPENDENCIES].push({id:N,index:k}):(O[R.DI_DEPENDENCIES]=[{id:N,index:k}],O[R.DI_TARGET]=O)}function C(N){if(R.serviceIds.has(N))return R.serviceIds.get(N);const O=function(k,b,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");c(O,k,I)};return O.toString=()=>N,R.serviceIds.set(N,O),O}function A(N){return N}}),define(he[162],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0,e.$zhc=(0,R.$Ci)("checksumService")}),define(he[21],ue([0,1,12,9,4]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=A,e.$$i=N,e.$_i=k,e.$aj=b,e.$bj=I,e.$cj=$,e.$dj=d,e.$ej=l,e.$fj=m,e.$gj=E,R=ke(R),e.$9i=(0,C.$Ci)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof c.URI)}function N(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof c.URI)}var O;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function k(f){switch(f){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function b(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function I(f,w){const P=Object.create(null);for(const p in f)$(P,p,f[p],w);return P}function $(f,w,P,p){const o=w.split("."),u=o.pop();let i=f;for(let n=0;n<o.length;n++){const t=o[n];let s=i[t];switch(typeof s){case"undefined":s=i[t]=Object.create(null);break;case"object":if(s===null){p(`Ignoring ${w} as ${o.slice(0,n+1).join(".")} is null`);return}break;default:p(`Ignoring ${w} as ${o.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[u]=P}catch{p(`Ignoring ${w} as ${o.join(".")} is ${JSON.stringify(i)}`)}else p(`Ignoring ${w} as ${o.join(".")} is ${JSON.stringify(i)}`)}function d(f,w){const P=w.split(".");g(f,P)}function g(f,w){const P=w.shift();if(w.length===0){delete f[P];return}if(Object.keys(f).indexOf(P)!==-1){const p=f[P];typeof p=="object"&&!Array.isArray(p)&&(g(p,w),Object.keys(p).length===0&&delete f[P])}}function l(f,w,P){function p(i,n){let t=i;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const o=w.split("."),u=p(f,o);return typeof u>"u"?P:u}function m(f,w,P){Object.keys(w).forEach(p=>{p!=="__proto__"&&(p in f?R.$eg(f[p])&&R.$eg(w[p])?m(f[p],w[p],P):P&&(f[p]=w[p]):f[p]=w[p])})}function E(f){return f.replace(/[\[\]]/g,"")}}),define(he[96],ue([0,1,39,5,26,153,4,11,8]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=I,e.$Bj=n,e.$Cj=t,e.$Vj=te;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",c.$k),b.set("isLinux",c.$l),b.set("isWindows",c.$j),b.set("isWeb",c.$p),b.set("isMacNative",c.$k&&!c.$p),b.set("isEdge",c.$I),b.set("isFirefox",c.$G),b.set("isChrome",c.$F),b.set("isSafari",c.$H);function I(B,D){if(b.get(B)!==void 0)throw(0,k.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(B,D)}const $=Object.prototype.hasOwnProperty;var d;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const g={regexParsingWithErrorRecovery:!0},l=(0,O.localize)(11464,null),m=(0,O.localize)(11465,null),E=(0,O.localize)(11466,null),f=(0,O.localize)(11467,null),w=(0,O.localize)(11468,null),P=(0,O.localize)(11469,null),p=(0,O.localize)(11470,null),o=(0,O.localize)(11471,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=g){this.k=D,this.d=new A.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const q=this.D(),M=q.type===A.TokenType.Str?P:void 0;throw this.h.push({message:w,offset:q.offset,lexeme:A.$xj.getLexeme(q),additionalInfo:M}),u.c}return J}catch(J){if(J!==u.c)throw J;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(A.TokenType.Or);){const J=this.o();D.push(J)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(A.TokenType.And);){const J=this.s();D.push(J)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(A.TokenType.Neg)){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),r.INSTANCE;case A.TokenType.False:return this.z(),a.INSTANCE;case A.TokenType.LParen:{this.z();const J=this.l();return this.A(A.TokenType.RParen,f),J?.negate()}case A.TokenType.Str:return this.z(),T.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),i.true();case A.TokenType.False:return this.z(),i.false();case A.TokenType.LParen:{this.z();const J=this.l();return this.A(A.TokenType.RParen,f),J}case A.TokenType.Str:{const J=D.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==A.TokenType.RegexStr)throw this.B("REGEX",M);const Q=M.lexeme,_=Q.lastIndexOf("/"),Y=_===Q.length-1?void 0:this.w(Q.substring(_+1));let re;try{re=new RegExp(Q.substring(1,_),Y)}catch{throw this.B("REGEX",M)}return x.create(J,re)}switch(M.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const Q=[M.lexeme];this.z();let _=this.D(),Y=0;for(let Ee=0;Ee<M.lexeme.length;Ee++)M.lexeme.charCodeAt(Ee)===R.CharCode.OpenParen?Y++:M.lexeme.charCodeAt(Ee)===R.CharCode.CloseParen&&Y--;for(;!this.E()&&_.type!==A.TokenType.And&&_.type!==A.TokenType.Or;){switch(_.type){case A.TokenType.LParen:Y++;break;case A.TokenType.RParen:Y--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let Ee=0;Ee<_.lexeme.length;Ee++)_.lexeme.charCodeAt(Ee)===R.CharCode.OpenParen?Y++:M.lexeme.charCodeAt(Ee)===R.CharCode.CloseParen&&Y--}if(Y<0)break;Q.push(A.$xj.getLexeme(_)),this.z(),_=this.D()}const re=Q.join(""),le=re.lastIndexOf("/"),ge=le===re.length-1?void 0:this.w(re.substring(le+1));let pe;try{pe=new RegExp(re.substring(1,le),ge)}catch{throw this.B("REGEX",M)}return i.regex(J,pe)}case A.TokenType.QuotedStr:{const Q=M.lexeme;this.z();let _=null;if(!(0,C.$af)(Q)){const Y=Q.indexOf("/"),re=Q.lastIndexOf("/");if(Y!==re&&Y>=0){const le=Q.slice(Y+1,re),ge=Q[re+1]==="i"?"i":"";try{_=new RegExp(le,ge)}catch{throw this.B("REGEX",M)}}}if(_===null)throw this.B("REGEX",M);return x.create(J,_)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,E);const M=this.u();return i.notIn(J,M)}switch(this.D().type){case A.TokenType.Eq:{this.z();const M=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.equals(J,M);switch(M){case"true":return i.has(J);case"false":return i.not(J);default:return i.equals(J,M)}}case A.TokenType.NotEq:{this.z();const M=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.notEquals(J,M);switch(M){case"true":return i.not(J);case"false":return i.has(J);default:return i.notEquals(J,M)}}case A.TokenType.Lt:return this.z(),G.create(J,this.u());case A.TokenType.LtEq:return this.z(),V.create(J,this.u());case A.TokenType.Gt:return this.z(),F.create(J,this.u());case A.TokenType.GtEq:return this.z(),j.create(J,this.u());case A.TokenType.In:return this.z(),i.in(J,this.u());default:return i.has(J)}}case A.TokenType.EOF:throw this.h.push({message:p,offset:D.offset,lexeme:"",additionalInfo:o}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),D.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,J){if(this.C(D))return this.z();throw this.B(J,this.D())}B(D,J,q){const M=(0,O.localize)(11472,null,D,A.$xj.getLexeme(J)),Q=J.offset,_=A.$xj.getLexeme(J);return this.h.push({message:M,offset:Q,lexeme:_,additionalInfo:q}),u.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$zj=u;class i{static false(){return r.INSTANCE}static true(){return a.INSTANCE}static has(D){return h.create(D)}static equals(D,J){return y.create(D,J)}static notEquals(D,J){return v.create(D,J)}static regex(D,J){return x.create(D,J)}static in(D,J){return L.create(D,J)}static notIn(D,J){return S.create(D,J)}static not(D){return T.create(D)}static and(...D){return z.create(D,null,!0)}static or(...D){return W.create(D,null,!0)}static greater(D,J){return F.create(D,J)}static greaterEquals(D,J){return j.create(D,J)}static smaller(D,J){return G.create(D,J)}static smallerEquals(D,J){return V.create(D,J)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Aj=i;function n(B){const D=new u({regexParsingWithErrorRecovery:!1});return B.map(J=>(D.parse(J),D.lexingErrors.length>0?D.lexingErrors.map(q=>({errorMessage:q.additionalInfo?(0,O.localize)(11473,null,q.additionalInfo):(0,O.localize)(11474,null),offset:q.offset,length:q.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(q=>({errorMessage:q.additionalInfo?`${q.message}. ${q.additionalInfo}`:q.message,offset:q.offset,length:q.lexeme.length})):[]))}function t(B,D){const J=B?B.substituteConstants():void 0,q=D?D.substituteConstants():void 0;return!J&&!q?!0:!J||!q?!1:J.equals(q)}function s(B,D){return B.cmp(D)}class r{static{this.INSTANCE=new r}constructor(){this.type=d.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return a.INSTANCE}}e.$Dj=r;class a{static{this.INSTANCE=new a}constructor(){this.type=d.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$Ej=a;class h{static create(D,J=null){const q=b.get(D);return typeof q=="boolean"?q?a.INSTANCE:r.INSTANCE:new h(D,J)}constructor(D,J){this.key=D,this.c=J,this.type=d.Defined}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=b.get(this.key);return typeof D=="boolean"?D?a.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$Fj=h;class y{static create(D,J,q=null){if(typeof J=="boolean")return J?h.create(D,q):T.create(D,q);const M=b.get(D);return typeof M=="boolean"?J===(M?"true":"false")?a.INSTANCE:r.INSTANCE:new y(D,J,q)}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=d.Equals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?a.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Gj=y;class L{static create(D,J){return new L(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=d.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.f),q=D.getValue(this.d);return Array.isArray(J)?J.includes(q):typeof q=="string"&&typeof J=="object"&&J!==null?$.call(J,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Hj=L;class S{static create(D,J){return new S(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=d.NotIn,this.c=L.create(D,J)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=S;class v{static create(D,J,q=null){if(typeof J=="boolean")return J?T.create(D,q):h.create(D,q);const M=b.get(D);return typeof M=="boolean"?J===(M?"true":"false")?r.INSTANCE:a.INSTANCE:new v(D,J,q)}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=d.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?r.INSTANCE:a.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Jj=v;class T{static create(D,J=null){const q=b.get(D);return typeof q=="boolean"?q?r.INSTANCE:a.INSTANCE:new T(D,J)}constructor(D,J){this.c=D,this.d=J,this.type=d.Not}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=b.get(this.c);return typeof D=="boolean"?D?r.INSTANCE:a.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.$Kj=T;function U(B,D){if(typeof B=="string"){const J=parseFloat(B);isNaN(J)||(B=J)}return typeof B=="string"||typeof B=="number"?D(B):r.INSTANCE}class F{static create(D,J,q=null){return U(J,M=>new F(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=d.Greater}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Lj=F;class j{static create(D,J,q=null){return U(J,M=>new j(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=d.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Mj=j;class G{static create(D,J,q=null){return U(J,M=>new G(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=d.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Nj=G;class V{static create(D,J,q=null){return U(J,M=>new V(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=d.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Oj=V;class x{static create(D,J){return new x(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=d.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const J=this.f?this.f.source:"",q=D.f?D.f.source:"";return J<q?-1:J>q?1:0}equals(D){if(D.type===this.type){const J=this.f?this.f.source:"",q=D.f?D.f.source:"";return this.d===D.d&&J===q}return!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Pj=x;class H{static create(D){return new H(D)}constructor(D){this.c=D,this.type=d.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new H(this.c.map(D))}negate(){return this.c}}e.$Qj=H;function ie(B){let D=null;for(let J=0,q=B.length;J<q;J++){const M=B[J].substituteConstants();if(B[J]!==M&&D===null){D=[];for(let Q=0;Q<J;Q++)D[Q]=B[Q]}D!==null&&(D[J]=M)}return D===null?B:D}class z{static create(D,J,q){return z.d(D,J,q)}constructor(D,J){this.expr=D,this.c=J,this.type=d.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,q=this.expr.length;J<q;J++){const M=s(this.expr[J],D.expr[J]);if(M!==0)return M}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,q=this.expr.length;J<q;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:z.create(D,this.c,!1)}evaluate(D){for(let J=0,q=this.expr.length;J<q;J++)if(!this.expr[J].evaluate(D))return!1;return!0}static d(D,J,q){const M=[];let Q=!1;for(const _ of D)if(_){if(_.type===d.True){Q=!0;continue}if(_.type===d.False)return r.INSTANCE;if(_.type===d.And){M.push(..._.expr);continue}M.push(_)}if(M.length===0&&Q)return a.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(s);for(let _=1;_<M.length;_++)M[_-1].equals(M[_])&&(M.splice(_,1),_--);if(M.length===1)return M[0];for(;M.length>1;){const _=M[M.length-1];if(_.type!==d.Or)break;M.pop();const Y=M.pop(),re=M.length===0,le=W.create(_.expr.map(ge=>z.create([ge,Y],null,q)),null,re);le&&(M.push(le),M.sort(s))}if(M.length===1)return M[0];if(q){for(let _=0;_<M.length;_++)for(let Y=_+1;Y<M.length;Y++)if(M[_].negate().equals(M[Y]))return r.INSTANCE;if(M.length===1)return M[0]}return new z(M,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new z(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());this.c=W.create(D,this,!0)}return this.c}}e.$Rj=z;class W{static create(D,J,q){return W.d(D,J,q)}constructor(D,J){this.expr=D,this.c=J,this.type=d.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,q=this.expr.length;J<q;J++){const M=s(this.expr[J],D.expr[J]);if(M!==0)return M}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,q=this.expr.length;J<q;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:W.create(D,this.c,!1)}evaluate(D){for(let J=0,q=this.expr.length;J<q;J++)if(this.expr[J].evaluate(D))return!0;return!1}static d(D,J,q){let M=[],Q=!1;if(D){for(let _=0,Y=D.length;_<Y;_++){const re=D[_];if(re){if(re.type===d.False){Q=!0;continue}if(re.type===d.True)return a.INSTANCE;if(re.type===d.Or){M=M.concat(re.expr);continue}M.push(re)}}if(M.length===0&&Q)return r.INSTANCE;M.sort(s)}if(M.length!==0){if(M.length===1)return M[0];for(let _=1;_<M.length;_++)M[_-1].equals(M[_])&&(M.splice(_,1),_--);if(M.length===1)return M[0];if(q){for(let _=0;_<M.length;_++)for(let Y=_+1;Y<M.length;Y++)if(M[_].negate().equals(M[Y]))return a.INSTANCE;if(M.length===1)return M[0]}return new W(M,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new W(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());for(;D.length>1;){const J=D.shift(),q=D.shift(),M=[];for(const Q of K(J))for(const _ of K(q))M.push(z.create([Q,_],null,!1));D.unshift(W.create(M,null,!1))}this.c=W.create(D,this,!0)}return this.c}}e.$Sj=W;class ee extends h{static{this.d=[]}static all(){return ee.d.values()}constructor(D,J,q){super(D,null),this.f=J,typeof q=="object"?ee.d.push({...q,key:D}):q!==!0&&ee.d.push({key:D,description:q,type:J!=null?typeof J:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return y.create(this.key,D)}notEqualsTo(D){return v.create(this.key,D)}}e.$Tj=ee,e.$Uj=(0,N.$Ci)("contextKeyService");function ne(B,D){return B<D?-1:B>D?1:0}function ce(B,D,J,q){return B<J?-1:B>J?1:D<q?-1:D>q?1:0}function te(B,D){if(B.type===d.False||D.type===d.True)return!0;if(B.type===d.Or)return D.type===d.Or?X(B.expr,D.expr):!1;if(D.type===d.Or){for(const J of D.expr)if(te(B,J))return!0;return!1}if(B.type===d.And){if(D.type===d.And)return X(D.expr,B.expr);for(const J of B.expr)if(te(J,D))return!0;return!1}return B.equals(D)}function X(B,D){let J=0,q=0;for(;J<B.length&&q<D.length;){const M=B[J].cmp(D[q]);if(M<0)return!1;M===0&&J++,q++}return J===B.length}function K(B){return B.type===d.Or?B.expr:[B]}}),define(he[97],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Qm=e.ID=void 0,e.$Rm=c,e.ID="diagnosticsService",e.$Qm=(0,R.$Ci)(e.ID);function c(A){return!!A.hostName&&!!A.errorMessage}class C{async getPerformanceInfo(N,O){return{}}async getSystemInfo(N,O){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,O){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}e.$Sm=C}),define(he[98],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=void 0,e.$Yo=(0,R.$Ci)("downloadService")}),define(he[15],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,R.$Ci)("environmentService"),e.$Ki=(0,R.$Di)(e.$Ji)}),define(he[74],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$X6b=C;var c;(function(N){N[N.FILE=1]="FILE",N[N.WORKSPACE=2]="WORKSPACE",N[N.EXE=3]="EXE"})(c||(e.RecommendationSource=c={}));function C(N){switch(N){case c.FILE:return"file";case c.WORKSPACE:return"workspace";case c.EXE:return"exe"}}var A;(function(N){N.Ignored="ignored",N.Cancelled="cancelled",N.TooMany="toomany",N.IncompatibleWindow="incompatibleWindow",N.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$Y6b=(0,R.$Ci)("IExtensionRecommendationNotificationService")}),define(he[7],ue([0,1,51,13,26,12,9,11,4,5,22,53]),function(oe,e,R,c,C,A,N,O,k,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$Cl=e.FileKind=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.FileOperationResult=e.$ul=e.$tl=e.$sl=e.$ql=e.FileChangeType=e.$pl=e.FileOperation=e.$jl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$0k=void 0,e.$$k=d,e.$_k=E,e.$al=w,e.$bl=P,e.$cl=p,e.$dl=o,e.$el=u,e.$fl=i,e.$gl=n,e.$hl=t,e.$il=s,e.$kl=h,e.$ll=y,e.$ml=L,e.$nl=S,e.$ol=v,e.$rl=G,e.$Dl=W,e.$El=ee,e.$Gl=ce,e.$0k=(0,k.$Ci)("fileService");function d(te){return te.create===!0}var g;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var l;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var m;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(m||(e.FileChangeFilter=m={}));function E(te){const X=te;return!!X&&typeof X.onDidChange=="function"}var f;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function w(te){return!!(te.capabilities&f.FileReadWrite)}function P(te){return!!(te.capabilities&f.FileFolderCopy)}function p(te){return!!(te.capabilities&f.FileClone)}function o(te){return!!(te.capabilities&f.FileOpenReadWriteClose)}function u(te){return!!(te.capabilities&f.FileReadStream)}function i(te){return w(te)?!!(te.capabilities&f.FileAtomicRead):!1}function n(te){return w(te)?!!(te.capabilities&f.FileAtomicWrite):!1}function t(te){return!!(te.capabilities&f.FileAtomicDelete)}function s(te){return!!(te.capabilities&f.Readonly)}var r;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class a extends Error{static create(X,K){const B=new a(X.toString(),K);return L(B,K),B}constructor(X,K){super(X),this.code=K}}e.$jl=a;function h(te,X){return a.create(te,X)}function y(te){return te||h((0,O.localize)(11250,null),r.Unknown)}function L(te,X){return te.name=X?`${X} (FileSystemError)`:"FileSystemError",te}function S(te){if(!te)return r.Unknown;if(te instanceof a)return te.code;const X=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!X)return r.Unknown;switch(X[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function v(te){if(te instanceof V)return te.fileOperationResult;switch(S(te)){case r.FileNotFound:return ie.FILE_NOT_FOUND;case r.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case r.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case r.NoPermissions:return ie.FILE_PERMISSION_DENIED;case r.FileExists:return ie.FILE_MOVE_CONFLICT;case r.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var T;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class U{constructor(X,K,B){this.resource=X,this.operation=K,this.target=B}isOperation(X){return this.operation===X}}e.$pl=U;var F;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class j{static{this.a=null}constructor(X,K){this.c=K,this.b=void 0,this.d=new $.$T(()=>{const B=R.$Ii.forUris(()=>this.c);return B.fill(this.rawAdded.map(D=>[D,!0])),B}),this.f=new $.$T(()=>{const B=R.$Ii.forUris(()=>this.c);return B.fill(this.rawUpdated.map(D=>[D,!0])),B}),this.g=new $.$T(()=>{const B=R.$Ii.forUris(()=>this.c);return B.fill(this.rawDeleted.map(D=>[D,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of X){switch(B.type){case F.ADDED:this.rawAdded.push(B.resource);break;case F.UPDATED:this.rawUpdated.push(B.resource);break;case F.DELETED:this.rawDeleted.push(B.resource);break}this.b!==j.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(X,...K){return this.h(X,{includeChildren:!1},...K)}affects(X,...K){return this.h(X,{includeChildren:!0},...K)}h(X,K,...B){if(!X)return!1;const D=B.length>0;return!!((!D||B.includes(F.ADDED))&&(this.d.value.get(X)||K.includeChildren&&this.d.value.findSuperstr(X))||(!D||B.includes(F.UPDATED))&&(this.f.value.get(X)||K.includeChildren&&this.f.value.findSuperstr(X))||(!D||B.includes(F.DELETED))&&(this.g.value.findSubstr(X)||K.includeChildren&&this.g.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.b===X}hasCorrelation(){return typeof this.b=="number"}}e.$ql=j;function G(te,X,K){return!te||!X||te===X||X.length>te.length?!1:(X.charAt(X.length-1)!==c.sep&&(X+=c.sep),K?(0,C.$Ef)(te,X):te.indexOf(X)===0)}class V extends Error{constructor(X,K,B){super(X),this.fileOperationResult=K,this.options=B}}e.$sl=V;class x extends V{constructor(X,K,B,D){super(X,K,D),this.fileOperationResult=K,this.size=B}}e.$tl=x;class H extends V{constructor(X,K,B){super(X,ie.FILE_NOT_MODIFIED_SINCE,B),this.stat=K}}e.$ul=H;var ie;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$vl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$wl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$xl="files.associations",e.$yl="files.exclude",e.$zl="files.readonlyInclude",e.$Al="files.readonlyExclude",e.$Bl="files.readonlyFromPermissions";var z;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(z||(e.FileKind=z={})),e.$Cl="";function W(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function ee(te,X){if(!X.hasProvider(N.URI.from({scheme:te.scheme})))return new Promise(K=>{const B=X.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===te.scheme&&D.added&&(B.dispose(),K())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(X){return(0,A.$gg)(X)||(X=0),X<ne.KB?(0,O.localize)(11251,null,X.toFixed(0)):X<ne.MB?(0,O.localize)(11252,null,(X/ne.KB).toFixed(2)):X<ne.GB?(0,O.localize)(11253,null,(X/ne.MB).toFixed(2)):X<ne.TB?(0,O.localize)(11254,null,(X/ne.GB).toFixed(2)):(0,O.localize)(11255,null,(X/ne.TB).toFixed(2))}}e.$Fl=ne;function ce(te){const X=typeof te=="string"||te?.scheme===I.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===I.Schemas.file?1024*ne.MB:X?10*ne.MB:b.$p?50*ne.MB:1024*ne.MB}});var Z=this&&this.__param||function(oe,e){return function(R,c){e(R,c,oe)}};define(he[163],ue([0,1,75,50,7]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;let A=class{constructor(O){this.a=O}async checksum(O){const k=(await this.a.readFileStream(O)).value;return new Promise((b,I)=>{const $=(0,R.createHash)("sha256");(0,c.$De)(k,{onData:d=>$.update(d.buffer),onError:d=>I(d),onEnd:()=>b($.digest("base64").replace(/=+$/,""))})})}};e.$Ahc=A,e.$Ahc=A=ve([Z(0,C.$0k)],A)}),define(he[99],ue([0,1,14,8,11,7]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=N;async function N(I,$,d,g,l,m){let E;try{await O(I,$,d,g,l,m)}catch(f){E=f}finally{E&&l.errorTransformer&&(E=l.errorTransformer(E)),typeof E<"u"&&d.error(E),d.end()}}async function O(I,$,d,g,l,m){k(m);const E=await I.open($,{create:!1});try{k(m);let f=0,w=0,P=l&&typeof l.length=="number"?l.length:void 0,p=R.$Le.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),o=l&&typeof l.position=="number"?l.position:0,u=0;do w=await I.read(E,o,p.buffer,u,p.byteLength-u),o+=w,u+=w,f+=w,typeof P=="number"&&(P-=w),u===p.byteLength&&(await d.write(g(p)),p=R.$Le.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),u=0);while(w>0&&(typeof P!="number"||P>0)&&k(m)&&b(f,l));if(u>0){let i=u;typeof P=="number"&&(i=Math.min(u,P)),d.write(g(p.slice(0,i)))}}catch(f){throw(0,A.$ll)(f)}finally{await I.close(E)}}function k(I){if(I.isCancellationRequested)throw(0,c.$5)();return!0}function b(I,$){if(typeof $?.limits?.size=="number"&&I>$.limits.size)throw(0,A.$kl)((0,C.localize)(11249,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(he[46],ue([0,1,93,2,13,5,9,7]),function(oe,e,R,c,C,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0,e.$1q=k,e.$2q=b,e.$6q=g,e.$7q=l,e.$8q=m,e.$9q=E,e.$0q=w,e.$$q=P;function k(p){return typeof p.correlationId=="number"}function b(p){return p.recursive===!0}class I extends c.$Tc{static{this.a=5}constructor(o,u,i,n){super(),this.h=o,this.j=u,this.m=i,this.n=n,this.c=this.B(new c.$Uc),this.f=void 0,this.g=0}s(){const o=new c.$Sc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(u=>this.h(u))),o.add(this.b.onDidLogMessage(u=>this.j(u))),o.add(this.b.onDidError(u=>this.t(u.error,u.request)))}t(o,u){this.u(o,u)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${o}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${o}`):this.y(o)}u(o,u){return!(!this.n.restartOnError||u||o.indexOf("No space left on device")!==-1||o.indexOf("EMFILE")!==-1)}w(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}y(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}z(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3q=I;class $ extends I{constructor(o,u,i){super(o,u,i,{type:"node.js",restartOnError:!1})}}e.$4q=$;class d extends I{constructor(o,u,i){super(o,u,i,{type:"universal",restartOnError:!0})}}e.$5q=d;function g(p){return p.map(o=>({type:o.type,resource:N.URI.revive(o.resource),cId:o.cId}))}function l(p){const o=new f;for(const u of p)o.processEvent(u);return o.coalesce()}function m(p,o){return typeof o=="string"&&!o.startsWith(R.$tk)&&!(0,C.$hc)(o)?{base:p,pattern:o}:o}function E(p,o){const u=[];for(const i of o)u.push((0,R.$xk)(m(p,i)));return u}class f{constructor(){this.a=new Set,this.b=new Map}c(o){return A.$l?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const u=this.b.get(this.c(o));let i=!1;if(u){const n=u.type,t=o.type;u.resource.fsPath!==o.resource.fsPath&&(o.type===O.FileChangeType.DELETED||o.type===O.FileChangeType.ADDED)?i=!0:n===O.FileChangeType.ADDED&&t===O.FileChangeType.DELETED?(this.b.delete(this.c(o)),this.a.delete(u)):n===O.FileChangeType.DELETED&&t===O.FileChangeType.ADDED?u.type=O.FileChangeType.UPDATED:n===O.FileChangeType.ADDED&&t===O.FileChangeType.UPDATED||(u.type=t)}else i=!0;i&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],u=[];return Array.from(this.a).filter(i=>i.type!==O.FileChangeType.DELETED?(o.push(i),!1):!0).sort((i,n)=>i.resource.fsPath.length-n.resource.fsPath.length).filter(i=>u.some(n=>(0,O.$rl)(i.resource.fsPath,n,!A.$l))?!1:(u.push(i.resource.fsPath),!0)).concat(o)}}function w(p,o){if(typeof o=="number")switch(p.type){case O.FileChangeType.ADDED:return(o&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(o&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(o&O.FileChangeFilter.UPDATED)===0}return!1}function P(p){if(typeof p=="number"){const o=[];return p&O.FileChangeFilter.ADDED&&o.push("Added"),p&O.FileChangeFilter.DELETED&&o.push("Deleted"),p&O.FileChangeFilter.UPDATED&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(he[164],ue([0,1,14,43,8,3,2,50,32,7,46]),function(oe,e,R,c,C,A,N,O,k,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=e.$dR=void 0,e.$dR="localFilesystem";class $ extends N.$Tc{constructor(g,l){super(),this.a=g,this.b=l,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$je),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$je),this.onDidWatchError=this.g.event,this.h=(0,k.$Yg)(),this.j()}get capabilities(){return this.c||(this.c=b.FileSystemProviderCapabilities.FileReadWrite|b.FileSystemProviderCapabilities.FileOpenReadWriteClose|b.FileSystemProviderCapabilities.FileReadStream|b.FileSystemProviderCapabilities.FileFolderCopy|b.FileSystemProviderCapabilities.FileWriteUnlock|b.FileSystemProviderCapabilities.FileAtomicRead|b.FileSystemProviderCapabilities.FileAtomicWrite|b.FileSystemProviderCapabilities.FileAtomicDelete|b.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=b.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=b.FileSystemProviderCapabilities.Trash)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,l){const{buffer:m}=await this.a.call("readFile",[g,l]);return m}readFileStream(g,l,m){const E=(0,O.$ze)(w=>R.$Le.concat(w.map(P=>R.$Le.wrap(P))).buffer),f=new N.$Sc;return f.add(this.a.listen("readFileStream",[g,l])(w=>{if(w instanceof R.$Le)E.write(w.buffer);else{if(w==="end")E.end();else{let P;if(w instanceof Error)P=w;else{const p=w;P=(0,b.$kl)(p.message??(0,c.$nj)(p),p.code??b.FileSystemProviderErrorCode.Unknown)}E.error(P),E.end()}f.dispose()}})),f.add(m.onCancellationRequested(()=>{E.error((0,C.$5)()),E.end(),f.dispose()})),E}writeFile(g,l,m){return this.a.call("writeFile",[g,R.$Le.wrap(l),m])}open(g,l){return this.a.call("open",[g,l])}close(g){return this.a.call("close",[g])}async read(g,l,m,E,f){const[w,P]=await this.a.call("read",[g,l,f]);return m.set(w.buffer.slice(0,P),E),P}write(g,l,m,E,f){return this.a.call("write",[g,l,R.$Le.wrap(m),E,f])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,l){return this.a.call("delete",[g,l])}rename(g,l,m){return this.a.call("rename",[g,l,m])}copy(g,l,m){return this.a.call("copy",[g,l,m])}cloneFile(g,l){return this.a.call("cloneFile",[g,l])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const l=g;this.f.fire((0,I.$6q)(l))}else{const l=g;this.g.fire(l)}}))}watch(g,l){const m=(0,k.$Yg)();return this.a.call("watch",[this.h,m,g,l]),(0,N.$Rc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$eR=$}),define(he[165],ue([0,1,33,2,46,3,7,9,6]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class b extends c.$Tc{constructor(){super(),this.a=this.B(new A.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new c.$3c),this.m=new Set,this.n=this.B(new k.$Ah(this.y())),this.r=5007,this.s=new k.$Zh,this.R=!1,this.B(this.f($=>this.t($)))}t($){this.u($)&&this.z($)}u($){return(0,C.$1q)($)}async watch($){this.s.isSettled||this.s.complete(),this.s=new k.$Zh;try{this.h.clear(),this.g.clear();for(const d of $)this.u(d)?this.h.set(d.correlationId,d):this.g.add(d);for(const[d]of this.j)this.h.has(d)||(this.j.deleteAndDispose(d),this.m.delete(d));return await this.w(!1)}finally{this.s.complete()}}w($){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))]),$?this.y():0)}y(){return 800}isSuspended($){return typeof $.correlationId!="number"?!1:this.m.has($.correlationId)?"polling":this.j.has($.correlationId)}async z($){if(this.j.has($.correlationId))return;const d=new c.$Sc;this.j.set($.correlationId,d),await this.s.p,!d.isDisposed&&(this.D($,d),this.w(!0))}C($){this.j.deleteAndDispose($.correlationId),this.m.delete($.correlationId),this.w(!1)}D($,d){this.F($,d)?(this.P(`reusing an existing recursive watcher to monitor ${$.path}`),this.m.delete($.correlationId)):(this.G($,d),this.m.add($.correlationId))}F($,d){const g=this.O?.subscribe($.path,(l,m)=>{d.isDisposed||(l?this.D($,d):m?.type===N.FileChangeType.ADDED&&this.H($))});return g?(d.add(g),!0):!1}G($,d){let g=!1;const l=(m,E)=>{if(d.isDisposed)return;const f=this.I(m),w=this.I(E),P=g;g=f,!f&&(w||P)&&this.H($)};this.P(`starting fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,R.watchFile)($.path,{persistent:!1,interval:this.r},l)}catch(m){this.Q(`fs.watchFile() failed with error ${m} on path ${$.path} (correlationId: ${$.correlationId})`)}d.add((0,c.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,R.unwatchFile)($.path,l)}catch(m){this.Q(`fs.unwatchFile() failed with error ${m} on path ${$.path} (correlationId: ${$.correlationId})`)}}))}H($){this.P(`detected ${$.path} exists again, resuming watcher (correlationId: ${$.correlationId})`);const d={resource:O.URI.file($.path),type:N.FileChangeType.ADDED,cId:$.correlationId};this.a.fire([d]),this.J(d,$),this.C($)}I($){return $.ctimeMs===0&&$.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J($,d){if(this.R){const g=` >> normalized ${$.type===N.FileChangeType.ADDED?"[ADDED]":$.type===N.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${$.resource.fsPath}`;this.L(g,d)}}L($,d){this.R&&this.P(`${$}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}M($){return`${$.path} (excludes: ${$.excludes.length>0?$.excludes:"<none>"}, includes: ${$.includes&&$.includes.length>0?JSON.stringify($.includes):"<all>"}, filter: ${(0,C.$$q)($.filter)}, correlationId: ${typeof $.correlationId=="number"?$.correlationId:"<none>"})`}async setVerboseLogging($){this.R=$}}e.$hr=b}),define(he[166],ue([0,1,33,6,25,41,2,90,13,5,20,9,146,30,7,46]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0,e.$nr=f;class E extends N.$Tc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,p,o,u,i,n){super(),this.s=P,this.t=p,this.u=o,this.w=u,this.y=i,this.z=n,this.c=this.B(new c.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.u(t))),this.f=this.B(new c.$Qh(t=>this.M(t),E.b)),this.g=(0,m.$9q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,m.$9q)(this.s.path,this.s.includes):void 0,this.j=(0,m.$1q)(this.s)?this.s.filter:void 0,this.m=new C.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const p=await R.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,p.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let p=P.path;try{p=await g.Promises.realpath(P.path),P.path===p&&(p=await(0,d.$jr)(P.path,this.m.token)??P.path),P.path!==p&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${p})`)}catch{}return p}async G(P,p){const o=new N.$Sc;return this.H(P,p,o)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,p,o)),o}H(P,p,o){if(p)return!1;const u=$.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(n,t)=>{if(!o.isDisposed)if(n){const s=await this.G(P,p);o.isDisposed?s.dispose():o.add(s)}else t&&(typeof t.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:u,type:t.type,cId:this.s.correlationId},!0)});return i?(o.add(i),!0):!1}async I(P,p,o){if(b.$k&&(0,A.$Bg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const u=new C.$ue(this.m.token);o.add((0,N.$Rc)(()=>u.dispose(!0)));const i=new N.$Sc;o.add(i);try{const n=$.URI.file(this.s.path),t=(0,k.$mc)(P),s=(0,R.watch)(P);i.add((0,N.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${P}'`);const r=new Set;if(p)try{for(const h of await g.Promises.readdir(P))r.add(h)}catch(h){this.O(h)}if(u.token.isCancellationRequested)return;const a=new Map;i.add((0,N.$Rc)(()=>{for(const[,h]of a)h.dispose();a.clear()})),s.on("error",(h,y)=>{u.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${h}, ${y})`),this.D())}),s.on("change",(h,y)=>{if(u.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${h}"] ${y}`);let L="";if(y&&(L=y.toString(),b.$k&&(L=(0,O.$km)(L))),!(!L||h!=="change"&&h!=="rename"))if(p)if(h==="rename"){a.get(L)?.dispose();const S=setTimeout(async()=>{if(a.delete(L),L===t&&!await g.Promises.exists(P)){this.J(n);return}if(u.token.isCancellationRequested)return;const v=await this.N((0,k.$ic)(P,L));if(u.token.isCancellationRequested)return;let T;v?r.has(L)?T=l.FileChangeType.UPDATED:(T=l.FileChangeType.ADDED,r.add(L)):(r.delete(L),T=l.FileChangeType.DELETED),this.L({resource:(0,I.$dh)(n,L),type:T,cId:this.s.correlationId})},E.a);a.set(L,(0,N.$Rc)(()=>clearTimeout(S)))}else{let S;r.has(L)?S=l.FileChangeType.UPDATED:(S=l.FileChangeType.ADDED,r.add(L)),this.L({resource:(0,I.$dh)(n,L),type:S,cId:this.s.correlationId})}else if(h==="rename"||L!==t){const S=setTimeout(async()=>{const v=await g.Promises.exists(P);u.token.isCancellationRequested||(v?(this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(P,!1))):this.J(n))},E.a);i.clear(),i.add((0,N.$Rc)(()=>clearTimeout(S)))}else this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(n){u.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${n.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,p=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===l.FileChangeType.ADDED?"[ADDED]":P.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!p&&this.g.some(o=>o(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!p&&this.h&&this.h.length>0&&!this.h.some(o=>o(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const p=(0,m.$7q)(P),o=[];for(const i of p){if((0,m.$0q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}o.push(i)}if(o.length===0)return;if(this.z)for(const i of o)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(b.$l)return g.Promises.exists(P);try{const p=(0,k.$mc)(P);return(await g.Promises.readdir((0,k.$lc)(P))).some(u=>u===p)}catch(p){return this.Q(p),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$mr=E;async function f(w,P,p,o,u=512){const i=await g.Promises.open(w,"r"),n=Buffer.allocUnsafe(u),t=new C.$ue(o);let s,r=!1;const a={path:w,excludes:[],recursive:!1},h=new E(a,void 0,y=>{(async()=>{for(const{type:L}of y)if(L===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await g.Promises.read(i,n,0,u,null);if(!S||t.token.isCancellationRequested)break;P(n.slice(0,S))}}catch(S){s=new Error(S),t.dispose(!0)}finally{r=!1}}})()});return await h.ready,p(),new Promise((y,L)=>{t.token.onCancellationRequested(async()=>{h.dispose();try{await g.Promises.close(i)}catch(S){s=new Error(S)}s?L(s):y()})})}}),define(he[167],ue([0,1,3,93,165,5,166,41]),function(oe,e,R,c,C,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class k extends C.$hr{constructor(I){super(),this.O=I,this.onDidError=R.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const $=[],d=new Set(Array.from(this.watchers));for(const g of I){const l=this.W(g);l&&(0,c.$Bk)(l.request.excludes,g.excludes)&&(0,c.$Bk)(l.request.includes,g.includes)?d.delete(l):$.push(g)}$.length&&this.P(`Request to start watching: ${$.map(g=>this.M(g)).join(",")}`),d.size&&this.P(`Request to stop watching: ${Array.from(d).map(g=>this.M(g.request)).join(",")}`);for(const g of d)this.Y(g);for(const g of $)this.X(g)}W(I){for(const $ of this.watchers)if(typeof I.correlationId=="number"||typeof $.request.correlationId=="number"){if($.request.correlationId===I.correlationId)return $}else if((0,O.$Ag)($.request.path,I.path,!A.$l))return $}X(I){const $=new N.$mr(I,this.O,g=>this.a.fire(g),()=>this.c.fire(I),g=>this.b.fire(g),this.R),d={request:I,instance:$};this.watchers.add(d)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const $=new Map;for(const d of I){const g=A.$l?d.path:d.path.toLowerCase();let l=$.get(d.correlationId);l||(l=new Map,$.set(d.correlationId,l)),l.has(g)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(d)}`),l.set(g,d)}return Array.from($.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const $ of this.watchers)$.instance.setVerboseLogging(I)}P(I,$){this.R&&this.b.fire({type:"trace",message:this.bb(I,$)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,$){return $?`[File Watcher (node.js)] ${I} (${this.M($.request)})`:`[File Watcher (node.js)] ${I}`}}e.$or=k}),define(he[168],ue([0,1,46,167]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class C extends R.$4q{constructor(N,O,k){super(N,O,k),this.s()}r(N){return N.add(new c.$or(void 0))}}e.$pr=C}),define(he[169],ue([0,1,22,42,95,46]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class N extends A.$5q{constructor(k,b,I){super(k,b,I),this.s()}r(k){const b=k.add(new C.$fr(R.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(b.onDidProcessExit(({code:I,signal:$})=>this.t(`terminated by itself with code ${I}, signal: ${$} (ETERM)`))),c.ProxyChannel.toService((0,c.$ji)(b.getChannel("watcher")))}}e.$gr=N}),define(he[76],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class R{constructor(...C){this.a=new Map;for(const[A,N]of C)this.set(A,N)}set(C,A){const N=this.a.get(C);return this.a.set(C,A),N}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Ai=R}),define(he[170],ue([0,1,6,8,2,73,161,4,76,89]),function(oe,e,R,c,C,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const I=!1;class $ extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class d{constructor(E=new k.$Ai,f=!1,w,P=I){this.i=E,this.j=f,this.k=w,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Bi,this),this._globalGraph=P?w?._globalGraph??new N.$sr(p=>p):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Oc)(this.h),this.h.clear();for(const E of this.g)(0,C.$Nc)(E)&&E.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(E,f){this.m();const w=this,P=new class extends d{dispose(){w.h.delete(P),super.dispose()}}(E,this.j,this,this.l);return this.h.add(P),f?.add(P),P}invokeFunction(E,...f){this.m();const w=l.traceInvocation(this.l,E);let P=!1;try{return E({get:o=>{if(P)throw(0,c.$7)("service accessor is only valid during the invocation of its target method");const u=this.s(o,w);if(!u)throw new Error(`[invokeFunction] unknown service '${o}'`);return u}},...f)}finally{P=!0,w.stop()}}createInstance(E,...f){this.m();let w,P;return E instanceof A.$zi?(w=l.traceCreation(this.l,E.ctor),P=this.o(E.ctor,E.staticArguments.concat(f),w)):(w=l.traceCreation(this.l,E),P=this.o(E,f,w)),w.stop(),P}o(E,f=[],w){const P=O._util.getServiceDependencies(E).sort((u,i)=>u.index-i.index),p=[];for(const u of P){const i=this.s(u.id,w);i||this.y(`[createInstance] ${E.name} depends on UNKNOWN service ${u.id}.`,!1),p.push(i)}const o=P.length>0?P[0].index:f.length;if(f.length!==o){console.trace(`[createInstance] First service dependency of ${E.name} at position ${o+1} conflicts with ${f.length} static arguments`);const u=o-f.length;u>0?f=f.concat(new Array(u)):f=f.slice(0,o)}return Reflect.construct(E,f.concat(p))}q(E,f){if(this.i.get(E)instanceof A.$zi)this.i.set(E,f);else if(this.k)this.k.q(E,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(E){const f=this.i.get(E);return!f&&this.k?this.k.r(E):f}s(E,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const w=this.r(E);return w instanceof A.$zi?this.u(E,w,f.branch(E,!0)):(f.branch(E,!1),w)}u(E,f,w){if(this.t.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.t.add(E);try{return this.v(E,f,w)}finally{this.t.delete(E)}}v(E,f,w){const P=new N.$sr(i=>i.id.toString());let p=0;const o=[{id:E,desc:f,_trace:w}],u=new Set;for(;o.length;){const i=o.pop();if(!u.has(String(i.id))){if(u.add(String(i.id)),P.lookupOrInsertNode(i),p++>1e3)throw new $(P);for(const n of O._util.getServiceDependencies(i.desc.ctor)){const t=this.r(n.id);if(t||this.y(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof A.$zi){const s={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};P.insertEdge(i,s),o.push(s)}}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new $(P);break}for(const{data:n}of i){if(this.r(n.id)instanceof A.$zi){const s=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,s)}P.removeNode(n)}}return this.r(E)}w(E,f,w=[],P,p){if(this.i.get(E)instanceof A.$zi)return this.x(E,f,w,P,p,this.g);if(this.k)return this.k.w(E,f,w,P,p);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(E,f,w=[],P,p,o){if(P){const u=new d(void 0,this.j,this,this.l);u.c=String(E);const i=new Map,n=new R.$Vh(()=>{const t=u.o(f,w,p);for(const[s,r]of i){const a=t[s];if(typeof a=="function")for(const h of r)h.disposable=a.apply(t,h.listener)}return i.clear(),o.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let h=i.get(s);return h||(h=new b.$4c,i.set(s,h)),(L,S,v)=>{if(n.isInitialized)return n.value[s](L,S,v);{const T={listener:[L,S,v],disposable:void 0},U=h.push(T);return(0,C.$Rc)(()=>{U(),T.disposable?.dispose()})}}}if(s in t)return t[s];const r=n.value;let a=r[s];return typeof a!="function"||(a=a.bind(r),t[s]=a),a},set(t,s,r){return n.value[s]=r,!0},getPrototypeOf(t){return f.prototype}})}else{const u=this.o(f,w,p);return o.add(u),u}}y(E,f){if(f&&console.warn(E),this.j)throw new Error(E)}}e.$tr=d;var g;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(g||(g={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(g.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,f){return E?new l(g.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(E,f){return E?new l(g.Creation,f.name):l.c}static{this.f=0}constructor(E,f){this.type=E,this.name=f,this.g=Date.now(),this.h=[]}branch(E,f){const w=new l(g.Branch,E.toString());return this.h.push([E,f,w]),w}stop(){const E=Date.now()-this.g;l.f+=E;let f=!1;function w(p,o){const u=[],i=new Array(p+1).join("	");for(const[n,t,s]of o.h)if(t&&s){f=!0,u.push(`${i}CREATES -> ${n}`);const r=w(p+1,s);r&&u.push(r)}else u.push(`${i}uses -> ${n}`);return u.join(`
`)}const P=[`${this.type===g.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(E>2||f)&&l.all.add(P.join(`
`))}}e.$ur=l}),define(he[56],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=e.$dhc=void 0,e.$dhc=(0,R.$Ci)("mainProcessService");class c{constructor(A,N){this.a=A,this.b=N}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,N){this.a.registerChannel(A,N)}}e.$ehc=c}),define(he[10],ue([0,1,11,43,3,55,2,31,5,20,12,9,96,4]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$ak=e.LogLevel=e.$$j=e.$0j=void 0,e.$_j=m,e.log=f,e.$lk=a,e.$mk=h,e.$nk=y,e.$ok=L,R=ke(R),e.$0j=(0,g.$Ci)("logService"),e.$$j=(0,g.$Ci)("loggerService");function l(){return new Date().toISOString()}function m(S){return(0,I.$gg)(S)}var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$ak=E.Info;function f(S,v,T){switch(v){case E.Trace:S.trace(T);break;case E.Debug:S.debug(T);break;case E.Info:S.info(T);break;case E.Warning:S.warn(T);break;case E.Error:S.error(T);break;case E.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function w(S,v=!1){let T="";for(let U=0;U<S.length;U++){let F=S[U];if(F instanceof Error&&(F=(0,c.$nj)(F,v)),typeof F=="object")try{F=JSON.stringify(F)}catch{}T+=(U>0?" ":"")+F}return T}class P extends N.$Tc{constructor(){super(...arguments),this.b=e.$ak,this.c=this.B(new C.$je),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==E.Off&&this.b<=v}}e.$ck=P;class p extends P{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...T){this.f(E.Trace)&&this.g(E.Trace,w([v,...T],!0))}debug(v,...T){this.f(E.Debug)&&this.g(E.Debug,w([v,...T]))}info(v,...T){this.f(E.Info)&&this.g(E.Info,w([v,...T]))}warn(v,...T){this.f(E.Warning)&&this.g(E.Warning,w([v,...T]))}error(v,...T){if(this.f(E.Error))if(v instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=v.stack,this.g(E.Error,w(U))}else this.g(E.Error,w([v,...T]))}flush(){}}e.$dk=p;class o extends P{constructor(v=e.$ak){super(),this.setLevel(v),this.g=!k.$j}trace(v,...T){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...T):console.log(`[main ${l()}]`,v,...T))}debug(v,...T){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...T):console.log(`[main ${l()}]`,v,...T))}info(v,...T){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...T):console.log(`[main ${l()}]`,v,...T))}warn(v,...T){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,v,...T):console.warn(`[main ${l()}]`,v,...T))}error(v,...T){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,v,...T):console.error(`[main ${l()}]`,v,...T))}flush(){}}e.$ek=o;class u extends P{constructor(v=e.$ak,T=!0){super(),this.g=T,this.setLevel(v)}trace(v,...T){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...T):console.log(v,...T))}debug(v,...T){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...T):console.log(v,...T))}info(v,...T){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...T):console.log(v,...T))}warn(v,...T){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...T):console.log(v,...T))}error(v,...T){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...T):console.error(v,...T))}flush(){}}e.$fk=u;class i extends P{constructor(v,T=e.$ak){super(),this.g=v,this.setLevel(T)}trace(v,...T){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(v),...T])}debug(v,...T){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(v),...T])}info(v,...T){this.f(E.Info)&&this.g.log(E.Info,[this.h(v),...T])}warn(v,...T){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(v),...T])}error(v,...T){this.f(E.Error)&&this.g.log(E.Error,[this.h(v),...T])}h(v){return typeof v=="string"?v:(0,c.$nj)(v,this.f(E.Trace))}flush(){}}e.$gk=i;class n extends P{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const T of this.g)T.setLevel(v);super.setLevel(v)}trace(v,...T){for(const U of this.g)U.trace(v,...T)}debug(v,...T){for(const U of this.g)U.debug(v,...T)}info(v,...T){for(const U of this.g)U.info(v,...T)}warn(v,...T){for(const U of this.g)U.warn(v,...T)}error(v,...T){for(const U of this.g)U.error(v,...T)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$hk=n;class t extends N.$Tc{constructor(v,T,U){if(super(),this.h=v,this.j=T,this.b=new O.$zc,this.c=this.B(new C.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$je),this.onDidChangeVisibility=this.g.event,U)for(const F of U)this.b.set(F.resource,{logger:void 0,info:F})}m(v){return(0,I.$cg)(v)?[...this.b.values()].find(T=>T.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,T){const U=this.n(v),F=(0,I.$cg)(v)?v:T?.id??(0,A.$qj)(U.toString()).toString(16);let j=this.b.get(U)?.logger;const G=T?.logLevel==="always"?E.Trace:T?.logLevel;j||(j=this.s(U,G??this.getLogLevel(U)??this.h,{...T,id:F}));const V={logger:j,info:{resource:U,id:F,logLevel:G,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(V.info),this.b.set(U,V),j}n(v){return(0,I.$cg)(v)?(0,b.$dh)(this.j,`${v}.log`):v}setLogLevel(v,T){if($.URI.isUri(v)){const U=v,F=T,j=this.b.get(U);j&&F!==j.info.logLevel&&(j.info.logLevel=F===this.h?void 0:F,j.logger?.setLevel(F),this.b.set(j.info.resource,j),this.f.fire([U,F]))}else{this.h=v;for(const[U,F]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,T){const U=this.m(v);U&&T!==!U.info.hidden&&(U.info.hidden=!T,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,T]))}getLogLevel(v){let T;return v&&(T=this.b.get(v)?.info.logLevel),T??this.h}registerLogger(v){const T=this.b.get(v.resource);T?T.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const T=this.b.get(v);T&&(T.logger&&T.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ik=t;class s{constructor(){this.onDidChangeLogLevel=new C.$je().event}setLevel(v){}getLevel(){return E.Info}trace(v,...T){}debug(v,...T){}info(v,...T){}warn(v,...T){}error(v,...T){}critical(v,...T){}dispose(){}flush(){}}e.$jk=s;class r extends s{}e.$kk=r;function a(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const v=L(S.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ak}function h(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function y(S){switch(S){case E.Trace:return{original:"Trace",value:R.localize(11183,null)};case E.Debug:return{original:"Debug",value:R.localize(11184,null)};case E.Info:return{original:"Info",value:R.localize(11185,null)};case E.Warning:return{original:"Warning",value:R.localize(11186,null)};case E.Error:return{original:"Error",value:R.localize(11187,null)};case E.Off:return{original:"Off",value:R.localize(11188,null)}}}function L(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$pk=new d.$Tj("logLevel",h(E.Info))}),define(he[171],ue([0,1,6,8,2,22,13,20,30,15,10]),function(oe,e,R,c,C,A,N,O,k,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;let $=class extends C.$Tc{constructor(g,l){super(),this.a=g,this.b=l,this.B(new R.$Oh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const g=(0,O.$ah)(this.a.logsHome),l=(0,O.$ch)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,f=(await k.Promises.readdir(l)).filter(P=>/^\d{8}T\d{6}$/.test(P)).sort().filter(P=>P!==g),w=f.slice(0,Math.max(0,f.length-9));w.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(P=>k.Promises.rm((0,N.$ic)(l,P)))))}catch(g){(0,c.$Y)(g)}}};e.$xhc=$,e.$xhc=$=ve([Z(0,b.$Ji),Z(1,I.$0j)],$)}),define(he[172],ue([0,1,17,6,8,3,41,2,13,46,10]),function(oe,e,R,c,C,A,N,O,k,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class $ extends O.$Tc{constructor(g,l){super(),this.a=g,this.b=l,this.c=this.B(new A.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new c.$Ah(0)),this.w=[],this.y=this.B(new c.$Ah(0))}watch(g,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(g,l):this.z(g,l)}n(g,l){const m={path:this.J(g),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},E=(0,R.$Sb)(this.j,m);return this.r(),(0,O.$Rc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,C.$Y)(g))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,b.$6q)(l)),l=>this.G(l),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const l of this.j)(0,b.$2q)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const l of this.j)(0,b.$2q)(l)&&g.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,l){const m={path:this.J(g),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},E=(0,R.$Sb)(this.w,m);return this.C(),(0,O.$Rc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,C.$Y)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,b.$6q)(g)),g=>this.G(g),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.H(g)}H(g){this.a[g.type](g.message)}I(g){return(0,k.$gc)(g.fsPath)}J(g){const l=this.I(g);return(0,N.$Eg)(l)}}e.$_q=$}),define(he[173],ue([0,1,17,6,14,25,3,55,63,2,51,22,100,20,50,11,7,99,10,8]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;let o=class extends b.$Tc{static{p=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new N.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$je),this.Y=this.B(new N.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new N.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new c.$Lh)}registerProvider(i,n){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${i}`);const t=new b.$Sc;return this.h.set(i,n),this.c.fire({added:!0,scheme:i,provider:n}),t.add(n.onDidChangeFile(s=>{const r=new E.$ql(s,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:i}))),(0,b.$Rc)(()=>{this.c.fire({added:!1,scheme:i,provider:n}),this.h.delete(i),(0,b.$Oc)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const n=[];this.f.fire({scheme:i,join(t){n.push(t)}}),!this.h.has(i)&&await c.Promises.settled(n)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,n){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return k.Iterable.map(this.h,([i,n])=>({scheme:i,capabilities:n.capabilities}))}async j(i){if(!(0,g.$hh)(i))throw new E.$sl((0,m.localize)(11256,null,this.sb(i)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const n=this.h.get(i.scheme);if(!n){const t=new P.$ab;throw t.message=(0,m.localize)(11257,null,i.toString()),t}return n}async m(i){const n=await this.j(i);if((0,E.$dl)(n)||(0,E.$al)(n)||(0,E.$el)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const n=await this.j(i);if((0,E.$dl)(n)||(0,E.$al)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,n){try{return await this.s(i,n)}catch(t){throw(0,E.$nl)(t)===E.FileSystemProviderErrorCode.FileNotFound?new E.$sl((0,m.localize)(11258,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.$ll)(t)}}async s(i,n){const t=await this.j(i),s=this.S(t),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,h=n?.resolveMetadata,y=await t.stat(i);let L;return this.t(t,i,y,void 0,!!h,(S,v)=>(L||(L=I.$Ii.forUris(()=>!s),L.set(i,!0),r&&L.fill(!0,r)),L.get(S.resource)||L.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&a?v===1:!1))}async t(i,n,t,s,r,a){const{providerExtUri:h}=this.R(i),y={resource:n,name:h.basename(n),isFile:(t.type&E.FileType.File)!==0,isDirectory:(t.type&E.FileType.Directory)!==0,isSymbolicLink:(t.type&E.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&E.FilePermission.Readonly)||!!(i.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&E.FilePermission.Locked),etag:(0,E.$Dl)({mtime:t.mtime,size:t.size}),children:void 0};if(y.isDirectory&&a(y,s)){try{const L=await i.readdir(n),S=await c.Promises.settled(L.map(async([v,T])=>{try{const U=h.joinPath(n,v),F=r?await i.stat(U):{type:T};return await this.t(i,U,F,L.length,r,a)}catch(U){return this.b.trace(U),null}}));y.children=(0,R.$Gb)(S)}catch(L){this.b.trace(L),y.children=[]}return y}return y}async resolveAll(i){return c.Promises.settled(i.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const n=await this.j(i),t=await n.stat(i);return this.t(n,i,t,void 0,!0,()=>!1)}async exists(i){const n=await this.j(i);try{return!!await n.stat(i)}catch{return!1}}async canCreateFile(i,n){try{await this.u(i,n)}catch(t){return t}return!0}async u(i,n){if(!n?.overwrite&&await this.exists(i))throw new E.$sl((0,m.localize)(11259,null,this.sb(i)),E.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(i,n=C.$Le.fromString(""),t){await this.u(i,t);const s=await this.writeFile(i,n);return this.r.fire(new E.$pl(i,E.FileOperation.CREATE,s)),s}async writeFile(i,n,t){const s=this.qb(await this.n(i),i),{providerExtUri:r}=this.R(s);let a=t;if((0,E.$gl)(s)&&!a?.atomic){const h=s.enforceAtomicWriteFile?.(i);h&&(a={...t,atomic:h})}try{await this.w(s,i,a)||await this.U(s,r.dirname(i));let y;if((0,E.$al)(s)&&!(n instanceof C.$Le))if((0,l.$xe)(n)){const L=await(0,l.$Ee)(n,3);L.ended?y=C.$Le.concat(L.buffer):y=L}else y=(0,l.$Be)(n,L=>C.$Le.concat(L),3);else y=n;!(0,E.$dl)(s)||(0,E.$al)(s)&&y instanceof C.$Le||(0,E.$al)(s)&&(0,E.$gl)(s)&&a?.atomic?await this.hb(s,i,a,y):await this.db(s,i,a,y instanceof C.$Le?(0,C.$We)(y):y),this.r.fire(new E.$pl(i,E.FileOperation.WRITE))}catch(h){throw new E.$sl((0,m.localize)(11260,null,this.sb(i),(0,E.$ll)(h).toString()),(0,E.$ol)(h),a)}return this.resolve(i,{resolveMetadata:!0})}async w(i,n,t){const s=!!t?.unlock;if(s&&!(i.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,m.localize)(11261,null,this.sb(n)));if(!!t?.atomic){if(!(i.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,m.localize)(11262,null,this.sb(n)));if(!(i.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,m.localize)(11263,null,this.sb(n)));if(s)throw new Error((0,m.localize)(11264,null,this.sb(n)))}let a;try{a=await i.stat(n)}catch{return}if(a.type&E.FileType.Directory)throw new E.$sl((0,m.localize)(11265,null,this.sb(n)),E.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(n,a),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==E.$Cl&&typeof a.mtime=="number"&&typeof a.size=="number"&&t.mtime<a.mtime&&t.etag!==(0,E.$Dl)({mtime:t.mtime,size:a.size}))throw new E.$sl((0,m.localize)(11266,null),E.FileOperationResult.FILE_MODIFIED_SINCE,t);return a}async readFile(i,n,t){const s=await this.m(i);return n?.atomic?this.z(s,i,n,t):this.C(s,i,n,t)}async z(i,n,t,s){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const h=await this.C(i,n,t,s);r(h)}catch(h){a(h)}},this.R(i).providerExtUri)})}async C(i,n,t,s){const r=await this.D(i,n,{...t,preferUnbuffered:!0},s);return{...r,value:await(0,C.$Xe)(r.value)}}async readFileStream(i,n,t){const s=await this.m(i);return this.D(s,i,n,t)}async D(i,n,t,s){const r=new A.$ue(s);let a=t;(0,E.$fl)(i)&&i.enforceAtomicReadFile?.(n)&&(a={...t,atomic:!0});const h=this.J(n,a).then(L=>L,L=>{throw r.dispose(!0),L});let y;try{return typeof a?.etag=="string"&&a.etag!==E.$Cl&&await h,a?.atomic&&(0,E.$fl)(i)||!((0,E.$dl)(i)||(0,E.$el)(i))||(0,E.$al)(i)&&a?.preferUnbuffered?y=this.I(i,n,a):(0,E.$el)(i)?y=this.G(i,n,r.token,a):y=this.H(i,n,r.token,a),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await h,value:y}}catch(L){throw y&&await(0,l.$Ce)(y),this.F(L,n,a)}}F(i,n,t){const s=(0,m.localize)(11267,null,this.sb(n),(0,E.$ll)(i).toString());return i instanceof E.$ul?new E.$ul(s,i.stat,t):i instanceof E.$tl?new E.$tl(s,i.fileOperationResult,i.size,i.options):new E.$sl(s,(0,E.$ol)(i),t)}G(i,n,t,s=Object.create(null)){const r=i.readFileStream(n,s,t);return(0,l.$Ie)(r,{data:a=>a instanceof C.$Le?a:C.$Le.wrap(a),error:a=>this.F(a,n,s)},a=>C.$Le.concat(a))}H(i,n,t,s=Object.create(null)){const r=(0,C.$2e)();return(0,f.$Yq)(i,n,r,a=>a,{...s,bufferSize:this.a,errorTransformer:a=>this.F(a,n,s)},t),r}I(i,n,t){const s=(0,l.$ze)(r=>C.$Le.concat(r));return(async()=>{try{let r;t?.atomic&&(0,E.$fl)(i)?r=await i.readFile(n,{atomic:!0}):r=await i.readFile(n),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(n,r.byteLength,t),s.end(C.$Le.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async J(i,n){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new E.$sl((0,m.localize)(11268,null,this.sb(i)),E.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==E.$Cl&&n.etag===t.etag)throw new E.$ul((0,m.localize)(11269,null),t,n);return this.L(i,t.size,n),t}L(i,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new E.$tl((0,m.localize)(11270,null,this.sb(i)),E.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(i,n,t){return this.M(i,n,"move",t)}async canCopy(i,n,t){return this.M(i,n,"copy",t)}async M(i,n,t,s){if(i.toString()!==n.toString())try{const r=t==="move"?this.qb(await this.n(i),i):await this.m(i),a=this.qb(await this.n(n),n);await this.Q(r,i,a,n,t,s)}catch(r){return r}return!0}async move(i,n,t){const s=this.qb(await this.n(i),i),r=this.qb(await this.n(n),n),a=await this.N(s,i,r,n,"move",!!t),h=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$pl(i,a==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,h)),h}async copy(i,n,t){const s=await this.m(i),r=this.qb(await this.n(n),n),a=await this.N(s,i,r,n,"copy",!!t),h=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$pl(i,a==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,h)),h}async N(i,n,t,s,r,a){if(n.toString()===s.toString())return r;const{exists:h,isSameResourceWithDifferentPathCase:y}=await this.Q(i,n,t,s,r,a);if(h&&!y&&a&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),r==="copy"){if(i===t&&(0,E.$bl)(i))await i.copy(n,s,{overwrite:a});else{const L=await this.resolve(n);L.isDirectory?await this.P(i,L,t,s):await this.O(i,n,t,s)}return r}else return i===t?(await i.rename(n,s,{overwrite:a}),r):(await this.N(i,n,t,s,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(i,n,t,s){if((0,E.$dl)(i)&&(0,E.$dl)(t))return this.jb(i,n,t,s);if((0,E.$dl)(i)&&(0,E.$al)(t))return this.pb(i,n,t,s);if((0,E.$al)(i)&&(0,E.$dl)(t))return this.nb(i,n,t,s);if((0,E.$al)(i)&&(0,E.$al)(t))return this.lb(i,n,t,s)}async P(i,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await c.Promises.settled(n.children.map(async r=>{const a=this.R(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.P(i,await this.resolve(r.resource),t,a):this.O(i,r.resource,t,a)}))}async Q(i,n,t,s,r,a){let h=!1;if(i===t){const{providerExtUri:L,isPathCaseSensitive:S}=this.R(i);if(S||(h=L.isEqual(n,s)),h&&r==="copy")throw new Error((0,m.localize)(11271,null,this.sb(n),this.sb(s)));if(!h&&L.isEqualOrParent(s,n))throw new Error((0,m.localize)(11272,null,this.sb(n),this.sb(s)))}const y=await this.exists(s);if(y&&!h){if(!a)throw new E.$sl((0,m.localize)(11273,null,this.sb(n),this.sb(s)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(n,s))throw new Error((0,m.localize)(11274,null,this.sb(n),this.sb(s)))}}return{exists:y,isSameResourceWithDifferentPathCase:h}}R(i){const n=this.S(i);return{providerExtUri:n?g.$6g:g.$8g,isPathCaseSensitive:n}}S(i){return!!(i.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const n=this.qb(await this.j(i),i);await this.U(n,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new E.$pl(i,E.FileOperation.CREATE,t)),t}async U(i,n){const t=[],{providerExtUri:s}=this.R(i);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await i.stat(n)).type&E.FileType.Directory))throw new Error((0,m.localize)(11275,null,this.sb(n)));break}catch(r){if((0,E.$nl)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(n)),n=s.dirname(n)}for(let r=t.length-1;r>=0;r--){n=s.joinPath(n,t[r]);try{await i.mkdir(n)}catch(a){if((0,E.$nl)(a)!==E.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(i,n){try{await this.W(i,n)}catch(t){return t}return!0}async W(i,n){const t=this.qb(await this.j(i),i),s=!!n?.useTrash;if(s&&!(t.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,m.localize)(11276,null,this.sb(i)));const r=n?.atomic;if(r&&!(t.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,m.localize)(11277,null,this.sb(i)));if(s&&r)throw new Error((0,m.localize)(11278,null,this.sb(i)));let a;try{a=await t.stat(i)}catch{}if(a)this.rb(i,a);else throw new E.$sl((0,m.localize)(11279,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const y=await this.resolve(i);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,m.localize)(11280,null,this.sb(i)))}return t}async del(i,n){const t=await this.W(i,n);let s=n;if((0,E.$hl)(t)&&!s?.atomic){const y=t.enforceAtomicDelete?.(i);y&&(s={...n,atomic:y})}const r=!!s?.useTrash,a=!!s?.recursive,h=s?.atomic??!1;await t.delete(i,{recursive:a,useTrash:r,atomic:h}),this.r.fire(new E.$pl(i,E.FileOperation.DELETE))}async cloneFile(i,n){const t=await this.j(i),s=this.qb(await this.n(n),n);if(!(t===s&&this.R(t).providerExtUri.isEqual(i,n)))return t===s&&(0,E.$cl)(t)?t.cloneFile(i,n):(await this.U(s,this.R(s).providerExtUri.dirname(n)),t===s&&(0,E.$bl)(t)?this.cb.queueFor(i,()=>t.copy(i,n,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(i,()=>this.O(t,i,s,n),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(i,n){return this.watch(i,{...n,correlationId:p.ab++})}watch(i,n={recursive:!1,excludes:[]}){const t=new b.$Sc;let s=!1,r=()=>{s=!0};t.add((0,b.$Rc)(()=>r())),(async()=>{try{const h=await this.bb(i,n);s?(0,b.$Oc)(h):r=()=>(0,b.$Oc)(h)}catch(h){this.b.error(h)}})();const a=n.correlationId;if(typeof a=="number"){const h=t.add(new N.$je);return t.add(this.X.event(L=>{L.correlates(a)&&h.fire(L)})),{onDidChange:h.event,dispose:()=>t.dispose()}}return t}async bb(i,n){const t=await this.j(i),s=(0,O.$qj)([this.R(t).providerExtUri.getComparisonKey(i),n]);let r=this.$.get(s);return r||(r={count:0,disposable:t.watch(i,n)},this.$.set(s,r)),r.count+=1,(0,b.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,b.$Oc)(r.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,b.$Oc)(i.disposable);this.$.clear()}async db(i,n,t,s){return this.cb.queueFor(n,async()=>{const r=await i.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,l.$xe)(s)||(0,l.$ye)(s)?await this.eb(i,r,s):await this.fb(i,r,s)}catch(a){throw(0,E.$ll)(a)}finally{await i.close(r)}},this.R(i).providerExtUri)}async eb(i,n,t){let s=0,r;if((0,l.$ye)(t)){if(t.buffer.length>0){const a=C.$Le.concat(t.buffer);await this.gb(i,n,a,a.byteLength,s,0),s+=a.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((a,h)=>{(0,l.$De)(r,{onData:async y=>{r.pause();try{await this.gb(i,n,y,y.byteLength,s,0)}catch(L){return h(L)}s+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>h(y),onEnd:()=>a()})})}async fb(i,n,t){let s=0,r;for(;(r=t.read())!==null;)await this.gb(i,n,r,r.byteLength,s,0),s+=r.byteLength}async gb(i,n,t,s,r,a){let h=0;for(;h<s;){const y=await i.write(n,r+h,t.buffer,a+h,s-h);h+=y}}async hb(i,n,t,s){return this.cb.queueFor(n,()=>this.ib(i,n,t,s),this.R(i).providerExtUri)}async ib(i,n,t,s){let r;s instanceof C.$Le?r=s:(0,l.$xe)(s)?r=await(0,C.$Xe)(s):(0,l.$ye)(s)?r=await(0,C.$Ye)(s):r=(0,C.$Ve)(s),await i.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(i,n,t,s){return this.cb.queueFor(s,()=>this.kb(i,n,t,s),this.R(t).providerExtUri)}async kb(i,n,t,s){let r,a;try{r=await i.open(n,{create:!1}),a=await t.open(s,{create:!0,unlock:!1});const h=C.$Le.alloc(this.a);let y=0,L=0,S=0;do S=await i.read(r,y,h.buffer,L,h.byteLength-L),await this.gb(t,a,h,S,y,L),y+=S,L+=S,L===h.byteLength&&(L=0);while(S>0)}catch(h){throw(0,E.$ll)(h)}finally{await c.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async lb(i,n,t,s){return this.cb.queueFor(s,()=>this.mb(i,n,t,s),this.R(t).providerExtUri)}async mb(i,n,t,s){return t.writeFile(s,await i.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,n,t,s){return this.cb.queueFor(s,()=>this.ob(i,n,t,s),this.R(t).providerExtUri)}async ob(i,n,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const a=await i.readFile(n);await this.gb(t,r,C.$Le.wrap(a),a.byteLength,0,0)}catch(a){throw(0,E.$ll)(a)}finally{await t.close(r)}}async pb(i,n,t,s){const r=await(0,C.$Xe)(this.H(i,n,A.CancellationToken.None));await this.hb(t,s,void 0,r)}qb(i,n){if(i.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.$sl((0,m.localize)(11281,null,this.sb(n)),E.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.$sl((0,m.localize)(11282,null,this.sb(i)),E.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===$.Schemas.file?i.fsPath:i.toString(!0)}};e.$Zq=o,e.$Zq=o=p=ve([Z(0,w.$0j)],o)}),define(he[174],ue([0,1,33,6,31,14,3,41,2,13,5,20,50,30,11,7,99,172,169,168]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class p extends f.$_q{static{this.L=!1}constructor(u,i){super(u,i),this.onDidChangeCapabilities=N.Event.None,this.P=new C.$zc(n=>$.$7g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=m.FileSystemProviderCapabilities.FileReadWrite|m.FileSystemProviderCapabilities.FileOpenReadWriteClose|m.FileSystemProviderCapabilities.FileReadStream|m.FileSystemProviderCapabilities.FileFolderCopy|m.FileSystemProviderCapabilities.FileWriteUnlock|m.FileSystemProviderCapabilities.FileAtomicRead|m.FileSystemProviderCapabilities.FileAtomicWrite|m.FileSystemProviderCapabilities.FileAtomicDelete|m.FileSystemProviderCapabilities.FileClone,I.$l&&(this.M|=m.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(u){try{const{stat:i,symbolicLink:n}=await g.SymlinkSupport.stat(this.I(u));return{type:this.O(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:m.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const i=await g.Promises.readdir(this.I(u),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,$.$dh)(u,t.name))).type:s=this.O(t),n.push([t.name,s])}catch(s){this.a.trace(s)}})),n}catch(i){throw this.hb(i)}}O(u,i){let n;return i?.dangling?n=m.FileType.Unknown:u.isFile()?n=m.FileType.File:u.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,i&&(n|=m.FileType.SymbolicLink),n}async Q(u){const i=this.I(u);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.P.get(u);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const t=new c.$Bh;return this.P.set(u,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,k.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(u)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(u)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(u,i){let n;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(u)})`),n=await this.Q(u));const t=this.I(u);return await R.promises.readFile(t)}catch(t){throw this.hb(t)}finally{n?.dispose()}}R(u){p.L&&this.a.trace(u)}readFileStream(u,i,n){const t=(0,d.$ze)(s=>A.$Le.concat(s.map(r=>A.$Le.wrap(r))).buffer);return(0,E.$Yq)(this,u,t,s=>s.buffer,{...i,bufferSize:256*1024},n),t}async writeFile(u,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(u)?this.U(u,(0,$.$dh)((0,$.$ch)(u),`${(0,$.$ah)(u)}${n.atomic.postfix}`),i,n):this.W(u,i,n)}async S(u){try{const i=this.I(u),{symbolicLink:n}=await g.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async U(u,i,n,t){const s=new k.$Sc;try{s.add(await this.Q(u)),s.add(await this.Q(i)),await this.W(i,n,t,!0);try{await this.rename(i,u,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{s.dispose()}}async W(u,i,n,t){let s;try{const r=this.I(u);if(!n.create||!n.overwrite){if(await g.Promises.exists(r)){if(!n.overwrite)throw(0,m.$kl)((0,l.localize)(11240,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.$kl)((0,l.localize)(11241,null),m.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(u,{create:!0,unlock:n.unlock},t),await this.write(s,0,i,0,i.byteLength)}catch(r){throw await this.ib(u,r)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(u){p.$=u}async open(u,i,n){const t=this.I(u);let s;(0,m.$$k)(i)&&!n&&(s=await this.Q(u));let r;try{if((0,m.$$k)(i)&&i.unlock)try{const{stat:h}=await g.SymlinkSupport.stat(t);h.mode&128||await R.promises.chmod(t,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}let a;if((0,m.$$k)(i)){if(I.$j)try{await R.promises.truncate(t,0),a="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}a||(a="w")}else a="r";r=await g.Promises.open(t,a)}catch(a){throw s?.dispose(),(0,m.$$k)(i)?await this.ib(u,a):this.hb(a)}if(this.X.set(r,0),(0,m.$$k)(i)&&this.Z.set(r,u),s){const a=this.Y.get(r);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.Y.set(r,s),a&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),a.dispose())}return r}async close(u){const i=this.Y.get(u);try{if(this.X.delete(u),this.Z.delete(u)&&p.$)try{await g.Promises.fdatasync(u)}catch(n){p.configureFlushOnWrite(!1),this.a.error(n)}return await g.Promises.close(u)}catch(n){throw this.hb(n)}finally{i&&(this.Y.get(u)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.Y.delete(u)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),i.dispose())}}async read(u,i,n,t,s){const r=this.ab(u,i);let a=null;try{a=(await g.Promises.read(u,n,t,s,r)).bytesRead}catch(h){throw this.hb(h)}finally{this.bb(u,r,a)}return a}ab(u,i){return i===this.X.get(u)?null:i}bb(u,i,n){const t=this.X.get(u);typeof t=="number"&&(typeof i=="number"||(typeof n=="number"?this.X.set(u,t+n):this.X.delete(u)))}async write(u,i,n,t,s){return(0,c.$Wh)(()=>this.cb(u,i,n,t,s),100,3)}async cb(u,i,n,t,s){const r=this.ab(u,i);let a=null;try{a=(await g.Promises.write(u,n,t,s,r)).bytesWritten}catch(h){throw await this.ib(this.Z.get(u),h)}finally{this.bb(u,r,a)}return a}async mkdir(u){try{await R.promises.mkdir(this.I(u))}catch(i){throw this.hb(i)}}async delete(u,i){try{const n=this.I(u);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,b.$ic)((0,b.$lc)(n),`${(0,b.$mc)(n)}${i.atomic.postfix}`)),await g.Promises.rm(n,g.RimRafMode.MOVE,t)}else try{await R.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:r,symbolicLink:a}=await g.SymlinkSupport.stat(n);s=r.isDirectory()&&!a}catch{}if(s)await R.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.hb(n)}}async rename(u,i,n){const t=this.I(u),s=this.I(i);if(t!==s)try{await this.db(u,i,"move",n.overwrite),await g.Promises.rename(t,s)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11242,null,(0,b.$mc)(t),(0,b.$mc)((0,b.$lc)(s)),r.toString()))),this.hb(r)}}async copy(u,i,n){const t=this.I(u),s=this.I(i);if(t!==s)try{await this.db(u,i,"copy",n.overwrite),await g.Promises.copy(t,s,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11243,null,(0,b.$mc)(t),(0,b.$mc)((0,b.$lc)(s)),r.toString()))),this.hb(r)}}async db(u,i,n,t){const s=this.I(u),r=this.I(i);let a=!1;if(!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)||(a=(0,O.$Ag)(s,r,!0)),a){if(n==="copy")throw(0,m.$kl)((0,l.localize)(11244,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const y=await this.N(u);if(!y)throw(0,m.$kl)((0,l.localize)(11245,null),m.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(i);if(L){if(!t)throw(0,m.$kl)((0,l.localize)(11246,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&L.type&m.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,i){return this.eb(u,i,!1)}async eb(u,i,n){const t=this.I(u),s=this.I(i),r=!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Ag)(t,s,!r))return;const a=new k.$Sc;try{a.add(await this.Q(u)),a.add(await this.Q(i)),n&&await R.promises.mkdir((0,b.$lc)(s),{recursive:!0}),await R.promises.copyFile(t,s)}catch(h){if(h.code==="ENOENT"&&!n)return this.eb(u,i,!0);throw this.hb(h)}finally{a.dispose()}}t(u,i,n){return new w.$gr(t=>u(t),t=>i(t),n)}F(u,i,n){return new P.$pr(t=>u(t),t=>i(t),n)}hb(u){if(u instanceof m.$jl)return u;let i=u,n;switch(u.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.$kl)(i,n)}async ib(u,i){let n=this.hb(i);if(u&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await g.SymlinkSupport.stat(this.I(u));t.mode&128||(n=(0,m.$kl)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return n}}e.$qr=p}),define(he[101],ue([0,1,3,2,4,10]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=e.$Whc=void 0,e.$Whc=(0,C.$Ci)("sharedProcessLifecycleService");let N=class extends c.$Tc{constructor(k){super(),this.b=k,this.a=this.B(new R.$je),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Xhc=N,e.$Xhc=N=ve([Z(0,A.$0j)],N)}),define(he[175],ue([0,1,9,3,10,2]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=void 0;class N extends C.$ik{constructor($,d,g,l,m){super(d,g,l),this.r=$,this.t=m,this.B(m.listen("onDidChangeLogLevel",$)(E=>{(0,C.$_j)(E)?super.setLogLevel(E):super.setLogLevel(R.URI.revive(E[0]),E[1])})),this.B(m.listen("onDidChangeVisibility",$)(([E,f])=>super.setVisibility(R.URI.revive(E),f))),this.B(m.listen("onDidChangeLoggers",$)(({added:E,removed:f})=>{for(const w of E)super.registerLogger({...w,resource:R.URI.revive(w.resource)});for(const w of f)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new C.$gk({log:($,d)=>{this.t.call("consoleLog",[$,d])}})}registerLogger($){super.registerLogger($),this.t.call("registerLogger",[$,this.r])}deregisterLogger($){super.deregisterLogger($),this.t.call("deregisterLogger",[$,this.r])}setLogLevel($,d){super.setLogLevel($,d),this.t.call("setLogLevel",[$,d])}setVisibility($,d){super.setVisibility($,d),this.t.call("setVisibility",[this.n($),d])}s($,d,g){return new O(this.t,$,d,g,this.r)}static setLogLevel($,d,g){return $.call("setLogLevel",[d,g])}}e.$qs=N;class O extends C.$dk{constructor($,d,g,l,m){super(l?.logLevel==="always"),this.r=$,this.s=d,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[d,l,m]).then(()=>{this.u(this.n),this.m=!0})}g($,d){const g=[[$,d]];this.m?this.u(g):this.n.push(...g)}u($){this.r.call("log",[this.s,$])}}class k{constructor($,d){this.a=$,this.b=d}listen($,d){const g=this.b($);switch(d){case"onDidChangeLoggers":return c.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(m=>this.c(m,g)),removed:[...l.removed].map(m=>this.c(m,g))}));case"onDidChangeVisibility":return c.Event.map(this.a.onDidChangeVisibility,l=>[g.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return c.Event.map(this.a.onDidChangeLogLevel,l=>(0,C.$_j)(l)?l:[g.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${d}`)}async call($,d,g){const l=this.b($);switch(d){case"setLogLevel":return(0,C.$_j)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(R.URI.revive(l.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,l)))}throw new Error(`Call not found: ${d}`)}c($,d){return{...$,resource:d.transformOutgoingURI($.resource)}}}e.$rs=k;class b extends A.$Tc{constructor($,d){super(),d.call("setLogLevel",[$.getLogLevel()]),this.B($.onDidChangeLogLevel(g=>d.call("setLogLevel",[g]))),d.call("getRegisteredLoggers").then(g=>{for(const l of g)$.registerLogger({...l,resource:R.URI.revive(l.resource)})}),this.B(d.listen("onDidChangeVisibility")(([g,l])=>$.setVisibility(R.URI.revive(g),l))),this.B(d.listen("onDidChangeLoggers")(({added:g,removed:l})=>{for(const m of g)$.registerLogger({...m,resource:R.URI.revive(m.resource)});for(const m of l)$.deregisterLogger(m.resource)}))}}e.$ss=b}),define(he[176],ue([0,1,2,10]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vR=void 0;class C extends R.$Tc{constructor(N,O=[]){super(),this.a=new c.$hk([N,...O]),this.B(N.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...O){this.a.trace(N,...O)}debug(N,...O){this.a.debug(N,...O)}info(N,...O){this.a.info(N,...O)}warn(N,...O){this.a.warn(N,...O)}error(N,...O){this.a.error(N,...O)}flush(){this.a.flush()}}e.$vR=C}),define(he[57],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=void 0,e.$Xfc=(0,R.$Ci)("nativeHostService")}),define(he[177],ue([0,1,42,56]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;let C=class{constructor(N,O){return this.windowId=N,R.ProxyChannel.toService(O.getChannel("nativeHost"),{context:N,properties:(()=>{const k=new Map;return k.set("windowId",N),k})()})}};e.$ghc=C,e.$ghc=C=ve([Z(1,c.$dhc)],C)}),define(he[58],ue([0,1,3,63,2,4]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=void 0,e.$qo=(0,A.$Ci)("policy");class N extends C.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const I=Object.keys(this.f).length;return this.f={...b,...this.f},I!==Object.keys(this.f).length&&await this.j(b),c.Iterable.reduce(this.g.entries(),($,[d,g])=>({...$,[d]:g}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return c.Iterable.reduce(Object.entries(this.f),(b,[I,$])=>({...b,[I]:{definition:$,value:this.g.get(I)}}),{})}}e.$ro=N;class O{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$so=O}),define(he[178],ue([0,1,3,2,58]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=void 0;class A{constructor(k){this.b=k,this.a=new c.$Sc}listen(k,b){switch(b){case"onDidChange":return R.Event.map(this.b.onDidChange,I=>I.reduce(($,d)=>({...$,[d]:this.b.getPolicyValue(d)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(k,b,I){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.$Jgc=A;class N extends C.$ro{constructor(k,b){super(),this.a=b;for(const I in k){const{definition:$,value:d}=k[I];this.f[I]=$,d!==void 0&&this.g.set(I,d)}this.a.listen("onDidChange")(I=>{for(const $ in I){const d=I[$];d===null?this.g.delete($):this.g.set($,d)}this.h.fire(Object.keys(I))})}async j(k){const b=await this.a.call("updatePolicyDefinitions",k);for(const I in b)this.g.set(I,b[I])}}e.$Kgc=N}),define(he[102],ue([0,1,37]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const A=C.context.configuration();if(A)c=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(c=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:A.version})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(he[23],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$qk=(0,R.$Ci)("productService"),e.$rk="vscode://schemas/vscode-product"}),define(he[179],ue([0,1,33,6,8,2,13,30,10,23]),function(oe,e,R,c,C,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0,R=ke(R);let I=class extends A.$Tc{constructor(d,g,l){super(),this.b=g,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,d&&this.B(new c.$Oh(()=>{this.f(d)},3e4)).schedule()}async f(d){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),l=(0,N.$lc)(d),m=(0,N.$mc)(d),E=await O.Promises.readdir(l);await Promise.all(E.map(async f=>{if(f===m)return;const w=(0,N.$ic)(l,f),P=await R.promises.stat(w);if(P.isDirectory()&&g-P.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),O.Promises.rm(w)}))}catch(g){(0,C.$Y)(g)}}};e.$uhc=I,e.$uhc=I=ve([Z(1,b.$qk),Z(2,k.$0j)],I)}),define(he[180],ue([0,1,33,6,8,2,13,30,15,10,23]),function(oe,e,R,c,C,A,N,O,k,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0,R=ke(R);let $=class extends A.$Tc{constructor(g,l,m){super(),this.b=g,this.c=l,this.f=m,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new c.$Oh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),l=JSON.parse(await R.promises.readFile((0,N.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const P of Object.keys(l)){const p=l[P];g[`${p.hash}.${P}`]=!0}const m=(0,N.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists(m))return;const f=await O.Promises.readdir(m);for(const P of f){if(g[P]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${P}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${P}`),await O.Promises.rm((0,N.$ic)(m,P))}const w=Date.now();for(const P of Object.keys(g)){const p=(0,N.$ic)(m,P),o=await O.Promises.readdir(p);for(const u of o){if(u==="tcf.json")continue;const i=(0,N.$ic)(p,u),n=await R.promises.stat(i);n.isDirectory()&&w-n.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,N.$ic)(P,u)}`),await O.Promises.rm(i))}}}catch(g){(0,C.$Y)(g)}}};e.$vhc=$,e.$vhc=$=ve([Z(0,k.$Ki),Z(1,b.$0j),Z(2,I.$qk)],$)}),define(he[181],ue([0,1,13,4]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$PG=void 0,e.$PG=(0,c.$Ci)("IV8InspectProfilingService");var C;(function(A){function N(k){return!!(k.samples&&k.timeDeltas)}A.isValidProfile=N;function O(k,b="noAbsolutePaths"){for(const I of k.nodes)I.callFrame&&I.callFrame.url&&((0,R.$hc)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,R.$ic)(b,(0,R.$mc)(I.callFrame.url)));return k}A.rewriteAbsolutePaths=O})(C||(e.Utils=C={}))}),define(he[182],ue([0,1,32]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class c{constructor(){this.a=new Map}async startProfiling(A){const O=await(await new Promise((b,I)=>{oe(["v8-inspect-profiler"],b,I)}).then(ke)).startProfiling({host:A.host,port:A.port,checkForPaused:!0}),k=(0,R.$Yg)();return this.a.set(k,O),k}async stopProfiling(A){const N=this.a.get(A);if(!N)throw new Error(`UNKNOWN session '${A}'`);const O=await N.stop();return this.a.delete(A),O.profile}}e.$Mhc=c}),define(he[44],ue([0,1,131,12]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,R=ke(R),c=ke(c);class C{constructor(){this.a=new Map}add(N,O){R.ok(c.$cg(N)),R.ok(c.$eg(O)),R.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,O)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$oo=new C}),define(he[103],ue([0,1,3,132,44]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,C=ke(C),e.$po={JSONContribution:"base.contributions.json"};function A(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class N{constructor(){this.b=new R.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,I){this.a[A(b)]=I,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(b){const I=this.a[b];return I?(0,c.$5j)(I):void 0}hasSchemaContent(b){return!!this.a[b]}}const O=new N;C.$oo.add(e.$po.JSONContribution,O)}),define(he[47],ue([0,1,17,3,12,11,21,103,44]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=m,e.$Fo=E,e.$Go=f,e.$Ho=P,e.$Io=p,e.$Jo=o,e.$Ko=u,C=ke(C),A=ke(A);var b;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$to={Configuration:"base.contributions.configuration"};var I;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const $=k.$oo.as(O.$po.JSONContribution);class d{constructor(){this.a=[],this.i=new Set,this.j=new c.$je,this.onDidSchemaChange=this.j.event,this.k=new c.$je,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:A.localize(11476,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},$.registerSchema(e.$Ao,this.h),this.z()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.r(n,t,s),$.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.s(n,t),$.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.s(t,s),this.r(n,!1,s),$.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.l(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(n,t){this.a.push(...n);const s=[];for(const{overrides:r,source:a}of n)for(const h in r){t.add(h);const y=this.b.get(h)??this.b.set(h,{configurationDefaultOverrides:[]}).get(h),L=r[h];if(y.configurationDefaultOverrides.push({value:L,source:a}),e.$Do.test(h)){const S=this.o(h,L,a,y.configurationDefaultOverrideValue);if(!S)continue;y.configurationDefaultOverrideValue=S,this.n(h,S,a),s.push(...m(h))}else{const S=this.p(h,L,a,y.configurationDefaultOverrideValue);if(!S)continue;y.configurationDefaultOverrideValue=S;const v=this.e[h];v&&(this.A(h,v),this.w(h,v))}}this.q(s)}deregisterDefaultConfigurations(n){const t=new Set;this.m(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(n,t){for(const s of n){const r=this.a.indexOf(s);r!==-1&&this.a.splice(r,1)}for(const{overrides:s,source:r}of n)for(const a in s){const h=this.b.get(a);if(!h)continue;const y=h.configurationDefaultOverrides.findIndex(L=>r?L.source?.id===r.id:L.value===s[a]);if(y!==-1){if(h.configurationDefaultOverrides.splice(y,1),h.configurationDefaultOverrides.length===0&&this.b.delete(a),e.$Do.test(a)){let L;for(const S of h.configurationDefaultOverrides)L=this.o(a,S.value,S.source,L);L&&!C.$pg(L.value)?(h.configurationDefaultOverrideValue=L,this.n(a,L,r)):(this.b.delete(a),delete this.e[a],delete this.c.properties[a])}else{let L;for(const v of h.configurationDefaultOverrides)L=this.p(a,v.value,v.source,L);h.configurationDefaultOverrideValue=L;const S=this.e[a];S&&(this.A(a,S),this.w(a,S))}t.add(a)}}this.y()}n(n,t,s){const r={type:"object",default:t.value,description:A.localize(11477,null,(0,N.$gj)(n)),$ref:e.$Ao,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[n]=r,this.c.properties[n]=r}o(n,t,s,r){const a=r?.value||{},h=r?.source??new Map;if(!(h instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const y of Object.keys(t)){const L=t[y];if(C.$eg(L)&&(C.$jg(a[y])||C.$eg(a[y]))){if(a[y]={...a[y]??{},...L},s)for(const v in L)h.set(`${y}.${v}`,s)}else a[y]=L,s?h.set(y,s):h.delete(y)}return{value:a,source:h}}p(n,t,s,r){const a=this.e[n],h=r?.value??a?.defaultDefaultValue;let y=s;if(C.$eg(t)&&(a!==void 0&&a.type==="object"||a===void 0&&(C.$jg(h)||C.$eg(h)))){if(y=r?.source??new Map,!(y instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const S in t)s&&y.set(`${n}.${S}`,s);t={...C.$eg(h)?h:{},...t}}return{value:t,source:y}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.m(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.l(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.s(n.removedConfigurations,s),n.addedConfigurations&&this.r(n.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this.j.fire()}registerOverrideIdentifiers(n){this.q(n),this.j.fire()}q(n){for(const t of n)this.i.add(t);this.y()}r(n,t,s){n.forEach(r=>{this.u(r,t,r.extensionInfo,r.restrictedProperties,void 0,s),this.d.push(r),this.v(r)})}s(n,t){const s=r=>{if(r.properties)for(const a in r.properties){t.add(a);const h=this.e[a];h?.policy?.name&&this.f.delete(h.policy.name),delete this.e[a],this.x(a,r.properties[a])}r.allOf?.forEach(a=>s(a))};for(const r of n){s(r);const a=this.d.indexOf(r);a!==-1&&this.d.splice(a,1)}}u(n,t=!0,s,r,a=I.WINDOW,h){a=C.$lg(n.scope)?a:n.scope;const y=n.properties;if(y)for(const S in y){const v=y[S];if(t&&P(S,v)){delete y[S];continue}if(v.source=s,v.defaultDefaultValue=y[S].default,this.A(S,v),e.$Do.test(S)?v.scope=void 0:(v.scope=C.$lg(v.scope)?a:v.scope,v.restricted=C.$lg(v.restricted)?!!r?.includes(S):v.restricted),y[S].hasOwnProperty("included")&&!y[S].included){this.g[S]=y[S],delete y[S];continue}else this.e[S]=y[S],y[S].policy?.name&&this.f.set(y[S].policy.name,S);!y[S].deprecationMessage&&y[S].markdownDeprecationMessage&&(y[S].deprecationMessage=y[S].markdownDeprecationMessage),h.add(S)}const L=n.allOf;if(L)for(const S of L)this.u(S,t,s,r,a,h)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}v(n){const t=s=>{const r=s.properties;if(r)for(const h in r)this.w(h,r[h]);s.allOf?.forEach(t)};t(n)}w(n,t){switch(e.$uo.properties[n]=t,t.scope){case I.APPLICATION:e.$vo.properties[n]=t;break;case I.MACHINE:e.$wo.properties[n]=t;break;case I.MACHINE_OVERRIDABLE:e.$xo.properties[n]=t;break;case I.WINDOW:e.$yo.properties[n]=t;break;case I.RESOURCE:e.$zo.properties[n]=t;break;case I.LANGUAGE_OVERRIDABLE:e.$zo.properties[n]=t,this.h.properties[n]=t;break}}x(n,t){switch(delete e.$uo.properties[n],t.scope){case I.APPLICATION:delete e.$vo.properties[n];break;case I.MACHINE:delete e.$wo.properties[n];break;case I.MACHINE_OVERRIDABLE:delete e.$xo.properties[n];break;case I.WINDOW:delete e.$yo.properties[n];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[n],delete this.h.properties[n];break}}y(){for(const n of this.i.values()){const t=`[${n}]`,s={type:"object",description:A.localize(11478,null),errorMessage:A.localize(11479,null),$ref:e.$Ao};this.A(t,s),e.$uo.properties[t]=s,e.$vo.properties[t]=s,e.$wo.properties[t]=s,e.$xo.properties[t]=s,e.$yo.properties[t]=s,e.$zo.properties[t]=s}}z(){const n={type:"object",description:A.localize(11480,null),errorMessage:A.localize(11481,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=n,e.$vo.patternProperties[e.$Co]=n,e.$wo.patternProperties[e.$Co]=n,e.$xo.patternProperties[e.$Co]=n,e.$yo.patternProperties[e.$Co]=n,e.$zo.patternProperties[e.$Co]=n,this.j.fire()}A(n,t){const s=this.b.get(n)?.configurationDefaultOverrideValue;let r,a;s&&(!t.disallowConfigurationDefault||!s.source)&&(r=s.value,a=s.source),C.$jg(r)&&(r=t.defaultDefaultValue,a=void 0),C.$jg(r)&&(r=f(t.type)),t.default=r,t.defaultValueSource=a}}const g="\\[([^\\]]+)\\]",l=new RegExp(g,"g");e.$Co=`^(${g})+$`,e.$Do=new RegExp(e.$Co);function m(i){const n=[];if(e.$Do.test(i)){let t=l.exec(i);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=l.exec(i)}}return(0,R.$Lb)(n)}function E(i){return i.reduce((n,t)=>`${n}[${t}]`,"")}function f(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new d;k.$oo.add(e.$to.Configuration,w);function P(i,n){return i.trim()?e.$Do.test(i)?A.localize(11483,null,i):w.getConfigurationProperties()[i]!==void 0?A.localize(11484,null,i):n.policy?.name&&w.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(11485,null,i,n.policy?.name,w.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(11482,null)}function p(){const i=[],n=w.getConfigurationProperties();for(const t of Object.keys(n))i.push([t,n[t].scope]);return i.push(["launch",I.RESOURCE]),i.push(["task",I.RESOURCE]),i}function o(i){const n={};for(const t of i){const s=t.properties;if(C.$eg(s))for(const r in s)n[r]=s[r];t.allOf&&Object.assign(n,o(t.allOf))}return n}function u(i){switch(i){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(he[77],ue([0,1,17,3,36,2,31,29,12,9,21,47,7,44]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=p,R=ke(R),C=ke(C),O=ke(O),k=ke(k);function l(n){return Object.isFrozen(n)?n:O.$co(n)}class m{static createEmptyModel(t){return new m({},[],[],void 0,t)}constructor(t,s,r,a,h){this.b=t,this.c=s,this.d=r,this.raw=a,this.f=h,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof m)return s;const r=new E("",this.f);return r.parseRaw(s),r.configurationModel});this.g=t.reduce((s,r)=>r===s?r:s.merge(r),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,I.$ej)(this.contents,t):this.contents}inspect(t,s){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return s?l(r.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return l(s?r.rawConfiguration.override(s).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const a=[];for(const{contents:h,identifiers:y,keys:L}of r.rawConfiguration.overrides){const S=new m(h,L,[],void 0,r.f).getValue(t);S!==void 0&&a.push({identifiers:y,value:S})}return a.length?l(a):void 0}}}getOverrideValue(t,s){const r=this.j(s);return r?t?(0,I.$ej)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const r of this.overrides)r.identifiers.includes(t)&&s.push(...r.keys);return R.$Lb(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return R.$Lb(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=O.$bo(this.contents),r=O.$bo(this.overrides),a=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const y of t)if(h.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(s,y.contents);for(const L of y.overrides){const[S]=r.filter(v=>R.$tb(v.identifiers,L.identifiers));S?(this.i(S.contents,L.contents),S.keys.push(...L.keys),S.keys=R.$Lb(S.keys)):r.push(O.$bo(L))}for(const L of y.keys)a.indexOf(L)===-1&&a.push(L)}return new m(s,a,r,h.every(y=>y instanceof m)?void 0:h,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const r={};for(const a of R.$Lb([...Object.keys(this.contents),...Object.keys(s)])){let h=this.contents[a];const y=s[a];y&&(typeof h=="object"&&typeof y=="object"?(h=O.$bo(h),this.i(h,y)):h=y),r[a]=h}return new m(r,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const r of Object.keys(s)){if(r in t&&k.$eg(t[r])&&k.$eg(s[r])){this.i(t[r],s[r]);continue}t[r]=O.$bo(s[r])}}j(t){let s=null,r=null;const a=h=>{h&&(r?this.i(r,h):r=O.$bo(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===t?s=h.contents:h.identifiers.includes(t)&&a(h.contents);return a(s),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,I.$dj)(this.contents,t),$.$Do.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>R.$tb(r.identifiers,(0,$.$Eo)(t))),1))}k(t,s,r){if((0,I.$cj)(this.contents,t,s,a=>this.f.error(a)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),$.$Do.test(t)){const a=(0,$.$Eo)(t),h={identifiers:a,keys:Object.keys(this.contents[t]),contents:(0,I.$bj)(this.contents[t],L=>this.f.error(L))},y=this.overrides.findIndex(L=>R.$tb(L.identifiers,a));y!==-1?this.overrides[y]=h:this.overrides.push(h)}}}e.$Lo=m;class E{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!k.$lg(t)){const r=this.h(t);this.parseRaw(r,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:r,keys:a,overrides:h,restricted:y,hasExcludedProperties:L}=this.i(t,s);this.b=new m(r,a,h,L?[t]:void 0,this.g),this.c=y||[]}h(t){let s={},r=null,a=[];const h=[],y=[];function L(v){Array.isArray(a)?a.push(v):r!==null&&(a[r]=v)}const S={onObjectBegin:()=>{const v={};L(v),h.push(a),a=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const v=[];L(v),h.push(a),a=v,r=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:L,onError:(v,T,U)=>{y.push({error:v,offset:T,length:U})}};if(t)try{C.$3n(t,S),s=a[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return s}i(t,s){const r=g.$oo.as($.$to.Configuration).getConfigurationProperties(),a=this.j(t,r,!0,s);t=a.raw;const h=(0,I.$bj)(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`)),y=Object.keys(t),L=this.l(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:h,keys:y,overrides:L,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(t,s,r,a){let h=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:h};const y={},L=[];for(const S in t)if($.$Do.test(S)&&r){const v=this.j(t[S],s,!1,a);y[S]=v.raw,h=h||v.hasExcludedProperties,L.push(...v.restricted)}else{const v=s[S],T=v?typeof v.scope<"u"?v.scope:$.ConfigurationScope.WINDOW:void 0;v?.restricted&&L.push(S),!a.exclude?.includes(S)&&(a.include?.includes(S)||(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&!(a.skipRestricted&&v?.restricted))?y[S]=t[S]:h=!0}return{raw:y,restricted:L,hasExcludedProperties:h}}l(t,s){const r=[];for(const a of Object.keys(t))if($.$Do.test(a)){const h={};for(const y in t[a])h[y]=t[a][y];r.push({identifiers:(0,$.$Eo)(a),keys:Object.keys(h),contents:(0,I.$bj)(h,s)})}return r}}e.$Mo=E;class f extends A.$Tc{constructor(t,s,r,a,h){super(),this.c=t,this.f=s,this.g=a,this.h=h,this.b=this.B(new c.$je),this.onDidChange=this.b.event,this.a=new E(this.c.toString(),h),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(c.Event.any(c.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),c.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(d.FileOperation.CREATE)||y.isOperation(d.FileOperation.COPY)||y.isOperation(d.FileOperation.DELETE)||y.isOperation(d.FileOperation.WRITE))&&r.isEqual(y.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=f;class w{constructor(t,s,r,a,h,y,L,S,v,T,U,F,j){this.a=t,this.b=s,this.c=r,this.overrideIdentifiers=a,this.d=h,this.f=y,this.g=L,this.h=S,this.i=v,this.j=T,this.k=U,this.l=F,this.m=j}get value(){return l(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(t,s,r,a,h,y,L,S,v,T){this.j=t,this.l=s,this.m=r,this.n=a,this.p=h,this.q=y,this.r=L,this.s=S,this.t=v,this.u=T,this.h=null,this.i=new N.$zc,this.v=null}getValue(t,s,r){return this.w(t,s,r).getValue(t)}updateValue(t,s,r={}){let a;r.resource?(a=this.t.get(r.resource),a||(a=m.createEmptyModel(this.u),this.t.set(r.resource,a))):a=this.s,s===void 0?a.removeValue(t):a.setValue(t,s),r.resource||(this.h=null)}inspect(t,s,r){const a=this.w(t,s,r),h=this.A(s.resource,r),y=s.resource?this.t.get(s.resource)||this.s:this.s,L=new Set;for(const S of a.overrides)for(const v of S.identifiers)a.getOverrideValue(t,v)!==void 0&&L.add(v);return new w(t,s,a.getValue(t),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,h||void 0,y)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=[];if(!s){const{added:a,updated:h,removed:y}=u(this.j,t);s=[...a,...h,...y]}for(const a of s)for(const h of(0,$.$Eo)(a)){const y=this.j.getKeysForOverrideIdentifier(h),L=t.getKeysForOverrideIdentifier(h),S=[...L.filter(v=>y.indexOf(v)===-1),...y.filter(v=>L.indexOf(v)===-1),...y.filter(v=>!O.$fo(this.j.override(h).getValue(v),t.override(h).getValue(v)))];r.push([h,S])}return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:r,removed:a}=u(this.l,t),h=[...s,...r,...a];return h.length&&this.updatePolicyConfiguration(t),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:r,removed:a,overrides:h}=u(this.applicationConfiguration,t),y=[...s,...r,...a];return y.length&&this.updateApplicationConfiguration(t),{keys:y,overrides:h}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:a,overrides:h}=u(this.localUserConfiguration,t),y=[...s,...r,...a];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:a,overrides:h}=u(this.remoteUserConfiguration,t),y=[...s,...r,...a];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:a,overrides:h}=u(this.workspaceConfiguration,t),y=[...s,...r,...a];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:h}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:a,updated:h,removed:y,overrides:L}=u(r,s),S=[...a,...h,...y];return(S.length||!r)&&this.updateFolderConfiguration(t,s),{keys:S,overrides:L}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:a,removed:h,overrides:y}=u(s,void 0);return{keys:[...r,...a,...h],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,r){let a=this.x(s,r);return s.overrideIdentifier&&(a=a.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(a=a.merge(this.l)),a}x({resource:t},s){let r=this.y();if(s&&t){const a=s.getFolder(t);a&&(r=this.z(a.uri)||r);const h=this.t.get(t);h&&(r=r.merge(h))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const r=this.y(),a=this.r.get(t);a?(s=r.merge(a),this.i.set(t,s)):s=r}return s}A(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:r,overrides:a,keys:h}=this.r.get(s);return t.push([s,{contents:r,overrides:a,keys:h}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(r=>t.add(r))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.q.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(a=>s.add(a))),[...s.values()]}static parse(t,s){const r=this.E(t.defaults,s),a=this.E(t.policy,s),h=this.E(t.application,s),y=this.E(t.user,s),L=this.E(t.workspace,s),S=t.folders.reduce((v,T)=>(v.set(b.URI.revive(T[0]),this.E(T[1],s)),v),new N.$zc);return new P(r,a,h,y,m.createEmptyModel(s),L,S,m.createEmptyModel(s),new N.$zc,s)}static E(t,s){return new m(t.contents,t.keys,t.overrides,void 0,s)}}e.$Oo=P;function p(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const a of n)a.keys.forEach(h=>t.add(h)),a.overrides.forEach(([h,y])=>{const L=(0,N.$wc)(s,h,new Set);y.forEach(S=>L.add(S))});const r=[];return s.forEach((a,h)=>r.push([h,[...a.values()]])),{keys:[...t.values()],overrides:r}}class o{constructor(t,s,r,a,h){this.change=t,this.f=s,this.g=r,this.h=a,this.i=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of t.keys)this.affectedKeys.add(y);for(const[,y]of t.overrides)for(const L of y)this.affectedKeys.add(L);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const r=this.a+t,a=this.d.indexOf(r);if(a<0)return!1;const h=a+r.length;if(h>=this.d.length)return!1;const y=this.d.charCodeAt(h);if(y!==this.b&&y!==this.c)return!1;if(s){const L=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,S=this.g.getValue(t,s,this.h);return!O.$fo(L,S)}return!0}}e.$Qo=o;function u(n,t){const{added:s,removed:r,updated:a}=i(t?.rawConfiguration,n?.rawConfiguration),h=[],y=n?.getAllOverrideIdentifiers()||[],L=t?.getAllOverrideIdentifiers()||[];if(t){const S=L.filter(v=>!y.includes(v));for(const v of S)h.push([v,t.getKeysForOverrideIdentifier(v)])}if(n){const S=y.filter(v=>!L.includes(v));for(const v of S)h.push([v,n.getKeysForOverrideIdentifier(v)])}if(t&&n){for(const S of y)if(L.includes(S)){const v=i({contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)},{contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)});h.push([S,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:r,updated:a,overrides:h}}function i(n,t){const s=n?t?n.keys.filter(h=>t.keys.indexOf(h)===-1):[...n.keys]:[],r=t?n?t.keys.filter(h=>n.keys.indexOf(h)===-1):[...t.keys]:[],a=[];if(n&&t){for(const h of t.keys)if(n.keys.indexOf(h)!==-1){const y=(0,I.$ej)(t.contents,h),L=(0,I.$ej)(n.contents,h);O.$fo(y,L)||a.push(h)}}return{added:s,removed:r,updated:a}}}),define(he[183],ue([0,1,17,3,2,29,12,77,47,10,58,44]),function(oe,e,R,c,C,A,N,O,k,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=void 0;class d extends C.$Tc{get configurationModel(){return this.b}constructor(E){super(),this.c=E,this.a=this.B(new c.$je),this.onDidChangeConfiguration=this.a.event,this.b=O.$Lo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B($.$oo.as(k.$to.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:f})=>this.f(Array.from(E),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(E,f){this.j(E,$.$oo.as(k.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}g(){return{}}h(){this.b=O.$Lo.createEmptyModel(this.c);const E=$.$oo.as(k.$to.Configuration).getConfigurationProperties();this.j(Object.keys(E),E)}j(E,f){const w=this.g();for(const P of E){const p=w[P],o=f[P];p!==void 0?this.b.setValue(P,p):o?this.b.setValue(P,o.default):this.b.removeValue(P)}}}e.$Ro=d;class g{constructor(){this.onDidChangeConfiguration=c.Event.None,this.configurationModel=O.$Lo.createEmptyModel(new b.$kk)}async initialize(){return this.configurationModel}}e.$So=g;let l=class extends C.$Tc{get configurationModel(){return this.b}constructor(E,f,w){super(),this.c=E,this.f=f,this.g=w,this.a=this.B(new c.$je),this.onDidChangeConfiguration=this.a.event,this.b=O.$Lo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const f={},w=[],P=$.$oo.as(k.$to.Configuration).getConfigurationProperties();for(const p of E){const o=P[p];if(!o){w.push(p);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.g.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}w.push(p),f[o.policy.name]={type:o.type}}}return(0,N.$pg)(f)||await this.f.updatePolicyDefinitions(f),w}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const f=$.$oo.as(k.$to.Configuration).getPolicyConfigurations(),w=(0,R.$Gb)(E.map(P=>f.get(P)));this.m(w,!0)}m(E,f){this.g.trace("PolicyConfiguration#update",E);const w=$.$oo.as(k.$to.Configuration).getConfigurationProperties(),P=[],p=this.b.isEmpty();for(const o of E){const u=w[o]?.policy?.name;if(u){const i=this.f.getPolicyValue(u);(p?i!==void 0:!(0,A.$fo)(this.b.getValue(o),i))&&P.push([o,i])}else this.b.getValue(o)!==void 0&&P.push([o,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const o=this.b;this.b=O.$Lo.createEmptyModel(this.g);for(const u of o.keys)this.b.setValue(u,o.getValue(u));for(const[u,i]of P)i===void 0?this.b.removeValue(u):this.b.setValue(u,i);f&&this.a.fire(this.b)}}};e.$To=l,e.$To=l=ve([Z(1,I.$qo),Z(2,b.$0j)],l)}),define(he[184],ue([0,1,17,6,14,3,36,64,2,31,29,5,20,21,77,47,183,7,58]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0;class P extends k.$Tc{constructor(u,i,n,t){super(),this.m=u,this.n=t,this.h=this.B(new A.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.$Ro(t)),this.c=n instanceof w.$so?new E.$So:this.B(new E.$To(this.b,n,t)),this.f=this.B(new l.$No(this.m,{},d.$7g,i,t)),this.a=new l.$Oo(this.b.configurationModel,this.c.configurationModel,l.$Lo.createEmptyModel(t),l.$Lo.createEmptyModel(t),l.$Lo.createEmptyModel(t),l.$Lo.createEmptyModel(t),new b.$zc,l.$Lo.createEmptyModel(t),new b.$zc,t),this.j=new p(u,i,this),this.g=this.B(new c.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:r})=>this.s(s,r))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,i,n]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Oo(u,i,l.$Lo.createEmptyModel(this.n),n,l.$Lo.createEmptyModel(this.n),l.$Lo.createEmptyModel(this.n),new b.$zc,l.$Lo.createEmptyModel(this.n),new b.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(u,i){const n=typeof u=="string"?u:void 0,t=(0,g.$0i)(u)?u:(0,g.$0i)(i)?i:{};return this.a.getValue(n,t,void 0)}async updateValue(u,i,n,t,s){const r=(0,g.$$i)(n)?n:(0,g.$0i)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,a=r?t:n;if(a!==void 0&&a!==g.ConfigurationTarget.USER_LOCAL&&a!==g.ConfigurationTarget.USER)throw new Error(`Unable to write ${u} to target ${a}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,R.$Lb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const h=this.inspect(u,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(h.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,I.$fo)(i,h.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const L=r.overrideIdentifiers.sort(),S=this.a.localUserConfiguration.overrides.find(v=>(0,R.$tb)([...v.identifiers].sort(),L));S&&(r.overrideIdentifiers=S.identifiers)}const y=r?.overrideIdentifiers?.length?[(0,m.$Fo)(r.overrideIdentifiers),u]:[u];await this.j.write(y,i),await this.reloadConfiguration()}inspect(u,i={}){return this.a.inspect(u,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.r(u)}r(u){const i=this.a.toData(),n=this.a.compareAndUpdateLocalUserConfiguration(u);this.u(n,i,g.ConfigurationTarget.USER)}s(u,i){const n=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(u,i);this.u(t,n,g.ConfigurationTarget.DEFAULT)}t(u){const i=this.a.toData(),n=this.a.compareAndUpdatePolicyConfiguration(u);this.u(n,i,g.ConfigurationTarget.DEFAULT)}u(u,i,n){const t=new l.$Qo(u,{data:i},this.a,void 0,this.n);t.source=n,this.h.fire(t)}}e.$Uo=P;class p{constructor(u,i,n){this.b=u,this.c=i,this.d=n,this.a=new c.$Jh}write(u,i){return this.a.queue(()=>this.e(u,i))}async e(u,i){let n;try{n=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw r}const t=[];if((0,N.$Vn)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(n,u,i);n=(0,O.$ao)(n,s),await this.c.writeFile(this.b,C.$Le.fromString(n))}f(u,i,n){const{tabSize:t,insertSpaces:s,eol:r}=this.h;if(!i.length){const a=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:a,length:a.length,offset:0}]}return(0,O.$0n)(u,i,n,{tabSize:t,insertSpaces:s,eol:r})}get h(){if(!this.g){let u=$.OS===$.OperatingSystem.Linux||$.OS===$.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(u=i),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(he[185],ue([0,1,14,3,2,69]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jxb=e.$hxb=e.$gxb=void 0,e.$ixb=O;const N=(b,I,$)=>{const d=new Uint8Array(16);for(let m=0;m<16;m++)d[m]=Math.round(Math.random()*256);const g=(0,R.$6e)(R.$Le.wrap(d));return[`GET ws://localhost${b}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`].join(`\r
`)+`\r
\r
`};e.$gxb=N,e.$hxb=R.$Le.fromString(`\r
\r
`);async function O(b,I,$,d,g){b.write(R.$Le.fromString((0,e.$gxb)(I,$,d)));const l=new C.$Sc;try{return await new Promise((m,E)=>{let f;l.add(b.onData(w=>{f?f=R.$Le.concat([f,w],f.byteLength+w.byteLength):f=w;const P=f.indexOf(e.$hxb);if(P===-1)return;m(b),b.pauseData();const p=f.slice(P+e.$hxb.byteLength);p.byteLength&&g.onData.fire(p)})),l.add(b.onClose(w=>E(w??new Error("socket closed")))),l.add(b.onEnd(()=>E(new Error("socket ended"))))})}catch(m){throw b.dispose(),m}finally{l.dispose()}}class k extends C.$Tc{constructor(I,$){super(),this.g=I,this.a=this.B(new c.$me),this.onData=(...d)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...d)),this.b=this.B(new c.$je),this.onDidDispose=this.b.event,this.f=!1,this.B($.onData),this.B($.onData.event(d=>this.a.fire(d))),this.onClose=this.B($.onClose).event,this.onEnd=this.B($.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,$){A.SocketDiagnostics.traceSocketEvent(this,this.g,I,$)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$jxb=k}),define(he[104],ue([0,1,8,4]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.RemoteAuthorityResolverErrorCode=e.$Ql=e.$Pl=e.RemoteConnectionType=e.$Ol=void 0,e.$Sl=b,e.$Ol=(0,c.$Ci)("remoteAuthorityResolverService");var C;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class A{constructor($){this.id=$,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Pl=A;class N{constructor($,d){this.host=$,this.port=d,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ql=N;var O;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class k extends R.$ab{static isNotAvailable($){return $ instanceof k&&$._code===O.NotAvailable}static isTemporarilyNotAvailable($){return $ instanceof k&&$._code===O.TemporarilyNotAvailable}static isNoResolverFound($){return $ instanceof k&&$._code===O.NoResolverFound}static isInvalidAuthority($){return $ instanceof k&&$._code===O.InvalidAuthority}static isHandled($){return $ instanceof k&&$.isHandled}constructor($,d=O.Unknown,g){super($),this._message=$,this._code=d,this._detail=g,this.isHandled=d===O.NotAvailable&&g===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Rl=k;function b(I){const $=I.indexOf("+");return $===-1?I:I.substring(0,$)}}),define(he[186],ue([0,1,6,14,25,8,3,2,22,100,54,32,69,104]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Xl=h,e.$Yl=y,e.$Zl=S,b=ke(b);const l=30*1e3;var m;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function E(K){switch(K){case m.Management:return"Management";case m.ExtensionHost:return"ExtensionHost";case m.Tunnel:return"Tunnel"}}function f(K){const B=new C.$ue;return setTimeout(()=>B.cancel(),K),B.token}function w(K,B){if(K.isCancellationRequested||B.isCancellationRequested)return C.CancellationToken.Cancelled;const D=new C.$ue;return K.onCancellationRequested(()=>D.cancel()),B.onCancellationRequested(()=>D.cancel()),D.token}class P{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new O.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,R.$vh)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function p(K,B){const D=new P(B);return D.registerDisposable(K.onControlMessage(J=>{const q=JSON.parse(J.toString()),M=W(q);M?D.reject(M):D.resolve(q)})),D.promise}function o(K,B,D,J,q,M,Q,_){const Y=new P(_),re=I.$de.create(!1);return K.info(`Creating a socket (${Q})...`),b.mark(`code/willCreateSocket/${M}`),B.connect(D,J,q,Q).then(le=>{Y.didTimeout?(b.mark(`code/didCreateSocketError/${M}`),K.info(`Creating a socket (${Q}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(b.mark(`code/didCreateSocketOK/${M}`),K.info(`Creating a socket (${Q}) was successful after ${re.elapsed()} ms.`),Y.resolve(le))},le=>{b.mark(`code/didCreateSocketError/${M}`),K.info(`Creating a socket (${Q}) returned an error after ${re.elapsed()} ms.`),K.error(le),Y.reject(le)}),Y.promise}function u(K,B){const D=new P(B);return K.then(J=>{D.didTimeout||D.resolve(J)},J=>{D.didTimeout||D.reject(J)}),D.promise}async function i(K,B,D,J){const q=te(K,B);K.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let M;try{M=await o(K.logService,K.remoteSocketFactoryService,K.connectTo,k.$Pg.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,E(B),`renderer-${E(B)}-${K.reconnectionToken}`,J)}catch(le){throw K.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),K.logService.error(le),le}K.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let Q,_;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(M,null),Q=K.reconnectionProtocol,_=!1):(Q=new d.$qi({socket:M}),_=!0),K.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const Y=await u(K.signService.createNewMessage((0,$.$Yg)()),J),re={type:"auth",auth:K.connectionToken||"00000000000000000000",data:Y.data};Q.sendControl(c.$Le.fromString(JSON.stringify(re)));try{const le=await p(Q,w(J,f(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(K.logService.trace(`${q} 4/6. received SignRequest control message.`),!await u(K.signService.validate(Y,le.signedData),J)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const pe=await u(K.signService.sign(le.data),J),Ee={type:"connectionType",commit:K.commit,signedData:pe,desiredConnectionType:B};return D&&(Ee.args=D),K.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(c.$Le.fromString(JSON.stringify(Ee))),{protocol:Q,ownsProtocol:_}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(K.logService.error(`${q} the handshake timed out. Error:`),K.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${q} received error control message when negotiating connection. Error:`),K.logService.error(le)),_&&z(Q),le}}async function n(K,B,D,J){const q=Date.now(),M=te(K,B),{protocol:Q,ownsProtocol:_}=await i(K,B,D,J),Y=new P(J);return Y.registerDisposable(Q.onControlMessage(re=>{const le=JSON.parse(re.toString()),ge=W(le);ge?(K.logService.error(`${M} received error control message when negotiating connection. Error:`),K.logService.error(ge),_&&z(Q),Y.reject(ge)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${X(q)}!`),Y.resolve({protocol:Q,firstMessage:le}))})),Y.promise}async function t(K,B){const{protocol:D}=await n(K,m.Management,void 0,B);return{protocol:D}}async function s(K,B,D){const{protocol:J,firstMessage:q}=await n(K,m.ExtensionHost,B,D),M=q&&q.debugPort;return{protocol:J,debugPort:M}}async function r(K,B,D){const J=Date.now(),q=te(K,m.Tunnel),{protocol:M}=await i(K,m.Tunnel,B,D);return K.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${X(J)}!`),M}async function a(K,B,D){const{connectTo:J,connectionToken:q}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:J,connectionToken:q,reconnectionToken:B,reconnectionProtocol:D,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function h(K,B,D){return L(K,async J=>{const{protocol:q}=await t(J,C.CancellationToken.None);return new H(K,B,D,J.reconnectionToken,q)})}async function y(K,B){return L(K,async D=>{const{protocol:J,debugPort:q}=await s(D,B,C.CancellationToken.None);return new ie(K,B,D.reconnectionToken,J,q)})}async function L(K,B){for(let J=1;;J++)try{const q=(0,$.$Yg)(),M=await a(K,q,null);return await B(M)}catch(q){if(J<5)K.logService.error(`[remote-connection][attempt ${J}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(q);else throw K.logService.error(`[remote-connection][attempt ${J}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(q),x.triggerPermanentFailure(0,0,g.$Rl.isHandled(q)),q}}async function S(K,B,D){const J=await a(K,(0,$.$Yg)(),null);return await r(J,{host:B,port:D},C.CancellationToken.None)}function v(K){return(0,R.$ph)(B=>new Promise((D,J)=>{const q=setTimeout(D,K*1e3);B.onCancellationRequested(()=>{clearTimeout(q),D()})}))}var T;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class U{constructor(B,D){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.type=T.ConnectionLost}}e.$1l=U;class F{constructor(B,D,J,q){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.durationSeconds=J,this.c=q,this.type=T.ReconnectionWait}skipWait(){this.c.cancel()}}e.$2l=F;class j{constructor(B,D,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=T.ReconnectionRunning}}e.$3l=j;class G{constructor(B,D,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=T.ConnectionGain}}e.$4l=G;class V{constructor(B,D,J,q){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.attempt=J,this.handled=q,this.type=T.ReconnectionPermanentFailure}}e.$5l=V;class x extends O.$Tc{static triggerPermanentFailure(B,D,J){this._permanentFailure=!0,this.f=B,this.g=D,this.h=J,this.j.forEach(q=>q.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(B,D,J,q,M){super(),this.t=B,this.u=D,this.reconnectionToken=J,this.protocol=q,this.w=M,this.m=this.B(new N.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new G(this.reconnectionToken,0,0)),this.B(q.onSocketClose(Q=>{const _=ce(this.t,this.reconnectionToken,!0);Q?Q.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${_} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this.u.logService.error(Q.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this.u.logService.error(Q.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(q.onSocketTimeout(Q=>{const _=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,O.$Rc)(()=>{const Q=x.j.indexOf(this);Q>=0&&x.j.splice(Q,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let J=-1;do{J++;const q=J<D.length?D[J]:D[D.length-1];try{if(q>0){const Q=v(q);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,Q)),this.u.logService.info(`${B} waiting for ${q} seconds before reconnecting...`);try{await Q}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1)),this.u.logService.info(`${B} resolving connection...`);const M=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${M.connectTo}...`),await this.G(M,f(l)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1));break}catch(M){if(M.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(J>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(g.$Rl.isTemporarilyNotAvailable(M)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if((M.code==="ETIMEDOUT"||M.code==="ENETUNREACH"||M.code==="ECONNREFUSED"||M.code==="ECONNRESET")&&M.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if((0,A.$3)(M)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if(M instanceof g.$Rl){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,g.$Rl.isHandled(M));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}}while(!this.n&&!this.s)}C(B,D,J){this.w?x.triggerPermanentFailure(B,D,J):this.D(B,D,J)}D(B,D,J){this.m.fire(new V(this.reconnectionToken,B,D,J)),z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6l=x;class H extends x{constructor(B,D,J,q,M){super(m.Management,B,q,M,!0),this.client=this.B(new d.$oi(M,{remoteAuthority:D,clientId:J},B.ipcLogger))}async G(B,D){await t(B,D)}}e.$7l=H;class ie extends x{constructor(B,D,J,q,M){super(m.ExtensionHost,B,J,q,!1),this.H=D,this.debugPort=M}async G(B,D){await s(B,this.H,D)}}e.$8l=ie;function z(K){try{K.acceptDisconnect();const B=K.getSocket();K.dispose(),B.dispose()}catch(B){(0,A.$Y)(B)}}function W(K){if(K&&K.type==="error"){const B=new Error(`Connection error: ${K.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function ee(K,B){for(;K.length<B;)K+=" ";return K}function ne(K,B){return`[remote-connection][${ee(E(K),13)}][${B.substr(0,5)}\u2026]`}function ce(K,B,D){return`${ne(K,B)}[${D?"reconnect":"initial"}]`}function te(K,B){return`${ce(B,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function X(K){return`${Date.now()-K} ms`}}),define(he[105],ue([0,1,22]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=c,e.$fn=C,e.$gn=A,e.$hn=N;function c(k){return k.scheme===R.Schemas.vscodeRemote?k.authority:void 0}function C(k){if(!k)return;const b=k.indexOf("+");return b<0?k:k.substr(0,b)}function A(k){const{host:b,port:I}=O(k);if(typeof I>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:b,port:I}}function N(k,b){let{host:I,port:$}=O(k);return typeof $>"u"&&($=b),{host:I,port:$}}function O(k){const b=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const I=k.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const $=k.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:k,port:void 0}}}),define(he[34],ue([0,1,26,4,105]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$qn=e.$pn=e.$on=e.TargetPlatform=e.ExtensionType=e.$nn=e.$ln=e.$kn=e.$jn=e.$in=void 0,e.$mn=A,e.$rn=$,e.$sn=d,e.$tn=g,e.$un=l,e.$vn=m,e.$wn=E,R=ke(R),e.$in="extensions.user.cache",e.$jn="extensions.builtin.cache",e.$kn="undefined_publisher",e.$ln=["ui","workspace","web"];function A(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$nn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(N||(e.ExtensionType=N={}));var O;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class k{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,P){if(typeof w>"u"||w===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof w=="string"||typeof P=="string"){const p=typeof w=="string"?w:w.value,o=typeof P=="string"?P:P.value;return R.$Df(p,o)}return w._lower===P._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$on=k;class b{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const P of w)this.add(P)}add(w){this.c.add(k.toKey(w))}delete(w){return this.c.delete(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}}e.$pn=b;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(k.toKey(w))}get(w){return this.c.get(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}set(w,P){this.c.set(k.toKey(w),P)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$qn=I;function $(f){return d(f)}function d(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}function g(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}function l(f,w){if(w){const P=`onResolveRemoteAuthority:${(0,C.$fn)(w)}`;return!!f.activationEvents?.includes(P)}return!1}function m(f){return f.map(w=>{const[P,p]=w.split("@");return{proposalName:P,version:p?parseInt(p):void 0}})}function E(f){return f.map(w=>w.split("@")[0])}e.$xn=(0,c.$Ci)("IBuiltinExtensionsScannerService")}),define(he[27],ue([0,1,5,11,34,4]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=O,e.$dp=k,e.$ep=b,e.$fp=I,e.$gp=$,e.$hp=d,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var N;(function(o){o.COMMAND="command",o.SETTINGS_SYNC="settingsSync"})(N||(e.ExtensionInstallSource=N={}));function O(o){switch(o){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function k(o){switch(o){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function b(o,u){switch(o){case R.Platform.Windows:return u==="x64"?C.TargetPlatform.WIN32_X64:u==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case R.Platform.Linux:return u==="x64"?C.TargetPlatform.LINUX_X64:u==="arm64"?C.TargetPlatform.LINUX_ARM64:u==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return u==="x64"?C.TargetPlatform.ALPINE_X64:u==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case R.Platform.Mac:return u==="x64"?C.TargetPlatform.DARWIN_X64:u==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case R.Platform.Web:return C.TargetPlatform.WEB}}function I(o,u){return u===C.TargetPlatform.WEB&&!o.includes(C.TargetPlatform.WEB)}function $(o,u,i){return I(u,i)?!1:o===C.TargetPlatform.UNDEFINED||o===C.TargetPlatform.UNIVERSAL?!0:o===C.TargetPlatform.UNKNOWN?!1:o===i}function d(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}var g;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var l;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var m;(function(o){o.Install="install",o.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var E;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$ip=(0,A.$Ci)("extensionGalleryService");var f;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed",o.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class w extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$jp=w;var P;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleApi="IncompatibleApi",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.DownloadFailedWriting="DownloadFailedWriting",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.ScanningExtension="ScanningExtension",o.ReadUninstalled="ReadUninstalled",o.UnsetUninstalled="UnsetUninstalled",o.Delete="Delete",o.Rename="Rename",o.IntializeDefaultProfile="IntializeDefaultProfile",o.AddToProfile="AddToProfile",o.InstalledExtensionNotFound="InstalledExtensionNotFound",o.PostInstall="PostInstall",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Cancelled="Cancelled",o.Unknown="Unknown",o.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class p extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$kp=p,e.$lp=(0,A.$Ci)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,A.$Ci)("IGlobalExtensionEnablementService"),e.$pp=(0,A.$Ci)("IExtensionTipsService"),e.$qp=(0,c.localize2)(11366,"Extensions"),e.$rp=(0,c.localize2)(11367,"Preferences")}),define(he[187],ue([0,1,3,2,29,9,94,27]),function(oe,e,R,c,C,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=void 0;function k(E,f){return E?A.URI.revive(f?f.transformIncoming(E):E):void 0}function b(E,f){return f?f.transformOutgoingURI(E):E}function I(E,f){f=f||N.$Kn;const w=E.manifest;return{...(0,N.$Nn)({...E,manifest:void 0},f),manifest:w}}function $(E,f){return E?.profileLocation?(0,N.$Nn)(E,f??N.$Kn):E}function d(E,f){return f?(0,C.$do)(E,w=>w instanceof A.URI?f.transformOutgoingURI(w):void 0):E}class g{constructor(f,w){this.a=f,this.b=w,this.onInstallExtension=R.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,w){const P=this.b(f);switch(w){case"onInstallExtension":return R.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,P):p.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,p=>p.map(o=>({...o,local:o.local?d(o.local,P):o.local,profileLocation:o.profileLocation?b(o.profileLocation,P):o.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,P):p.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,P):p.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,p=>({local:d(p.local,P),profileLocation:b(p.profileLocation,P)}))}throw new Error("Invalid listen")}async call(f,w,P){const p=this.b(f);switch(w){case"zip":{const o=I(P[0],p),u=await this.a.zip(o);return b(u,p)}case"install":return this.a.install(k(P[0],p),$(P[1],p));case"installFromLocation":return this.a.installFromLocation(k(P[0],p),k(P[1],p));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(P[0],k(P[1],p),k(P[2],p));case"getManifest":return this.a.getManifest(k(P[0],p));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(P[0]);case"installFromGallery":return this.a.installFromGallery(P[0],$(P[1],p));case"installGalleryExtensions":{const o=P[0];return this.a.installGalleryExtensions(o.map(({extension:u,options:i})=>({extension:u,options:$(i,p)??{}})))}case"uninstall":return this.a.uninstall(I(P[0],p),$(P[1],p));case"uninstallExtensions":{const o=P[0];return this.a.uninstallExtensions(o.map(({extension:u,options:i})=>({extension:I(u,p),options:$(i,p)})))}case"reinstallFromGallery":return this.a.reinstallFromGallery(I(P[0],p));case"getInstalled":return(await this.a.getInstalled(P[0],k(P[1],p),P[2])).map(u=>d(u,p));case"toggleAppliationScope":{const o=await this.a.toggleAppliationScope(I(P[0],p),k(P[1],p));return d(o,p)}case"copyExtensions":return this.a.copyExtensions(k(P[0],p),k(P[1],p));case"updateMetadata":{const o=await this.a.updateMetadata(I(P[0],p),P[1],k(P[2],p));return d(o,p)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(P[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(P[0],P[1],P[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$uq=g;class l extends c.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new R.$je),this.f=this.B(new R.$je),this.g=this.B(new R.$je),this.h=this.B(new R.$je),this.j=this.B(new R.$je),this.B(this.m.listen("onInstallExtension")(w=>this.n(this.c,{...w,source:this.r(w.source)?A.URI.revive(w.source):w.source,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(w=>this.n(this.f,w.map(P=>({...P,local:P.local?I(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(w=>this.n(this.g,{...w,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(w=>this.n(this.h,{...w,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(w=>this.n(this.j,{profileLocation:A.URI.revive(w.profileLocation),local:I(w.local,null)})))}n(f,w){f.fire(w)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const w=await this.getTargetPlatform();return f.allTargetPlatforms.some(P=>(0,O.$gp)(P,f.allTargetPlatforms,w))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(w=>A.URI.revive(w)))}install(f,w){return Promise.resolve(this.m.call("install",[f,w])).then(P=>I(P,null))}installFromLocation(f,w){return Promise.resolve(this.m.call("installFromLocation",[f,w])).then(P=>I(P,null))}async installExtensionsFromProfile(f,w,P){return(await this.m.call("installExtensionsFromProfile",[f,w,P])).map(o=>I(o,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,w){return Promise.resolve(this.m.call("installFromGallery",[f,w])).then(P=>I(P,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(P=>({...P,local:P.local?I(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))}uninstall(f,w){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,w]))}uninstallExtensions(f){if(f.some(w=>w.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstallExtensions",[f]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(w=>I(w,null))}getInstalled(f=null,w,P){return Promise.resolve(this.m.call("getInstalled",[f,w,P])).then(p=>p.map(o=>I(o,null)))}updateMetadata(f,w,P){return Promise.resolve(this.m.call("updateMetadata",[f,w,P])).then(p=>I(p,null))}resetPinnedStateForAllUserExtensions(f){return this.m.call("resetPinnedStateForAllUserExtensions",[f])}toggleAppliationScope(f,w){return this.m.call("toggleAppliationScope",[f,w]).then(P=>I(P,null))}copyExtensions(f,w){return this.m.call("copyExtensions",[f,w])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,w,P){const p=await this.m.call("download",[f,w,P]);return A.URI.revive(p)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$vq=l;class m{constructor(f){this.a=f}listen(f,w){throw new Error("Invalid listen")}call(f,w,P){switch(w){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(P[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$wq=m}),define(he[188],ue([0,1,2,34,7]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class A extends R.$Tc{constructor(O,k,b,I,$){super(),this.a=O,this.b=k,this.c=b,this.f=$,this.B(I.onDidInstallExtensions(d=>this.g(d))),this.B(I.onDidUninstallExtension(d=>this.h(d)))}g(O){for(const k of O)k.local&&this.invalidate(k.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,O)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,c.$in))}catch(k){(0,C.$ol)(k)!==C.FileOperationResult.FILE_NOT_FOUND&&this.f.error(k)}}}e.$Tq=A});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[59],ue([0,1,20,92,11,60,34,159]),function(oe,e,R,c,C,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=I,e.$Xp=$,e.$Yp=d,e.$Zp=g,e.$1p=l,e.$2p=m,e.$3p=E,e.$4p=f,c=it(c),C=ke(C),A=ke(A);const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function I(p){return p=p.trim(),p==="*"||k.test(p)}function $(p){if(!I(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=p.match(k);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}function d(p){if(!p)return null;const o=p.majorBase,u=p.majorMustEqual,i=p.minorBase;let n=p.minorMustEqual;const t=p.patchBase;let s=p.patchMustEqual;p.hasCaret&&(o===0||(n=!1),s=!1);let r=0;if(p.preRelease){const a=b.exec(p.preRelease);if(a){const[,h,y,L]=a;r=Date.UTC(Number(h),Number(y)-1,Number(L))}}return{majorBase:o,majorMustEqual:u,minorBase:i,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:p.hasGreaterEquals,notBefore:r}}function g(p,o,u){let i;typeof p=="string"?i=d($(p)):i=p;let n;o instanceof Date?n=o.getTime():typeof o=="string"&&(n=new Date(o).getTime());let t;if(typeof u=="string"?t=d($(u)):t=u,!i||!t)return!1;const s=i.majorBase,r=i.minorBase,a=i.patchBase;let h=t.majorBase,y=t.minorBase,L=t.patchBase;const S=t.notBefore;let v=t.majorMustEqual,T=t.minorMustEqual,U=t.patchMustEqual;return t.isMinimum?s>h?!0:s<h?!1:r>y?!0:r<y||n&&n<S?!1:a>=L:(s===1&&h===0&&(!v||!T||!U)&&(h=1,y=0,L=0,v=!0,T=!1,U=!1),s<h?!1:s>h?!v:r<y?!1:r>y?!T:a<L?!1:a>L?!U:!(n&&n<S))}function l(p,o,u,i,n,t){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([c.default.Error,C.localize(11297,null)]),s;if(typeof i.name!="string")return s.push([c.default.Error,C.localize(11298,null,"name")]),s;if(typeof i.version!="string")return s.push([c.default.Error,C.localize(11299,null,"version")]),s;if(!i.engines)return s.push([c.default.Error,C.localize(11300,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([c.default.Error,C.localize(11301,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!P(i.extensionDependencies))return s.push([c.default.Error,C.localize(11302,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!P(i.activationEvents))return s.push([c.default.Error,C.localize(11303,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([c.default.Error,C.localize(11304,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([c.default.Warning,C.localize(11305,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([c.default.Error,C.localize(11306,null,"main")]),s;{const h=(0,R.$dh)(u,i.main);(0,R.$0g)(h,u)||s.push([c.default.Warning,C.localize(11307,null,h.path,u.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([c.default.Error,C.localize(11308,null,"browser")]),s;{const h=(0,R.$dh)(u,i.browser);(0,R.$0g)(h,u)||s.push([c.default.Warning,C.localize(11309,null,h.path,u.path)])}}if(!A.valid(i.version))return s.push([c.default.Error,C.localize(11310,null)]),s;const r=[];if(!m(p,o,i,n,r))for(const h of r)s.push([c.default.Error,h]);if(t&&i.enabledApiProposals?.length){const h=[];if(!f([...i.enabledApiProposals],h))for(const y of h)s.push([c.default.Error,y])}return s}function m(p,o,u,i,n){return i||typeof u.main>"u"&&typeof u.browser>"u"?!0:w(p,o,u.engines.vscode,n)}function E(p,o,u){return p==="*"||w(o,u,p)}function f(p,o){if(p.length===0)return!0;const u=Array.isArray(o)?o:void 0,i=(u?void 0:o)??O.allApiProposals,n=[],t=(0,N.$vn)(p);for(const{proposalName:s,version:r}of t){const a=i[s];a&&r&&a.version!==r&&n.push(C.localize(11311,null,s))}return u?.push(...n),n.length===0}function w(p,o,u,i=[]){const n=d($(u));if(!n)return i.push(C.localize(11312,null,u)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return i.push(C.localize(11313,null,u)),!1}else if(!n.majorMustEqual)return i.push(C.localize(11314,null,u)),!1;return g(p,o,n)?!0:(i.push(C.localize(11315,null,p,u)),!1)}function P(p){if(!Array.isArray(p))return!1;for(let o=0,u=p.length;o<u;o++)if(typeof p[o]!="string")return!1;return!0}}),define(he[78],ue([0,1,25,2,5,11,27,4]),function(oe,e,R,c,C,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=void 0,e.$8r=k;function k(I){return I.tags.find($=>$.startsWith("lp-"))?.split("lp-")[1]}e.$9r=(0,O.$Ci)("languagePackService");let b=class extends c.$Tc{constructor($){super(),this.c=$}async getAvailableLanguages(){const $=new R.$ue;setTimeout(()=>$.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},$.token)}catch{return[]}const l=d.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(E=>E.startsWith("lp-"))).map(m=>{const E=m.properties.localizedLanguages?.[0],f=k(m);return{...this.f(f,E,m),extensionId:m.identifier.id,galleryExtension:m}});return l.push(this.f("en","English")),l}f($,d,g){const l=d??$;let m;if(l!==$&&(m=`(${$})`),$.toLowerCase()===C.$x.toLowerCase()&&(m??="",m+=(0,A.localize)(11219,null)),g?.installCount){m??="";const E=g.installCount;let f;E>1e6?f=`${Math.floor(E/1e5)/10}M`:E>1e3?f=`${Math.floor(E/1e3)}K`:f=String(E),m+=` $(cloud-download) ${f}`}return{id:$,label:l,description:m}}};e.$0r=b,e.$0r=b=ve([Z(0,N.$ip)],b)}),define(he[189],ue([0,1,2,78]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;let C=class extends R.$Tc{constructor(N){super(),this.a=N,this.b()}b(){this.a.update()}};e.$whc=C,e.$whc=C=ve([Z(0,c.$9r)],C)}),define(he[106],ue([0,1,2,4]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=void 0,e.$Tl=(0,c.$Ci)("remoteSocketFactoryService");class C{constructor(){this.a={}}register(N,O){return this.a[N]??=[],this.a[N].push(O),(0,R.$Rc)(()=>{const k=this.a[N]?.indexOf(O);typeof k=="number"&&k>=0&&this.a[N]?.splice(k,1)})}b(N){return(this.a[N.type]||[]).find(k=>k.supports(N))}connect(N,O,k,b){const I=this.b(N);if(!I)throw new Error(`No socket factory found for ${N}`);return I.connect(N,O,k,b)}}e.$Ul=C}),define(he[190],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=e.$Jhc=void 0,e.$Jhc=(0,R.$Ci)("sharedProcessTunnelService"),e.$Khc="sharedProcessTunnel"}),define(he[107],ue([0,1,4,11]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=e.$Thc=e.$Shc=e.$Rhc=e.$Qhc=e.TunnelStates=e.$Phc=e.$Ohc=void 0,e.$Ohc=(0,R.$Ci)("IRemoteTunnelService"),e.$Phc={active:!1};var C;(function(A){A.disconnected=N=>({type:"disconnected",onTokenFailed:N}),A.connected=(N,O)=>({type:"connected",info:N,serviceInstallFailed:O}),A.connecting=N=>({type:"connecting",progress:N}),A.uninitialized={type:"uninitialized"}})(C||(e.TunnelStates=C={})),e.$Qhc="remote.tunnels.access",e.$Rhc=e.$Qhc+".hostNameOverride",e.$Shc=e.$Qhc+".preventSleep",e.$Thc="remoteTunnelService",e.$Uhc=(0,c.localize)(11103,null)}),define(he[61],ue([0,1,14,8,2,11,47,4,10,44]),function(oe,e,R,c,C,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=d,e.$8p=g,e.$9p=l,e.$0p=m,e.$$p=E,e.$_p=f,e.$5p=(0,O.$Ci)("requestService");class I{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const u in this.b)u.toLowerCase()==="authorization"||u.toLowerCase()==="proxy-authorization"?o[u]="*****":o[u]=this.b[u];this.a=o}return this.a}}class $ extends C.$Tc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,A.localize)(11084,null),when:k.$pk.isEqualTo((0,k.$mk)(k.LogLevel.Trace)).serialize()})}async c(o,u,i){const n=`${o} #${++this.b}: ${u.url}`;this.a.trace(`${n} - begin`,u.type,new I(u.headers??{}));try{const t=await i();return this.a.trace(`${n} - end`,u.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${n} - error`,u.type,(0,c.$9)(t)),t}}}e.$6p=$;function d(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}function g(p){return p.res.statusCode===204}async function l(p){return g(p)?null:(await(0,R.$Xe)(p.stream)).toString()}async function m(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);return l(p)}async function E(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);if(g(p))return null;const u=(await(0,R.$Xe)(p.stream)).toString();try{return JSON.parse(u)}catch(i){throw i.message+=`:
`+u,i}}function f(p){P(p)}let w;function P(p){const o=b.$oo.as(N.$to.Configuration),u=w;w={id:"http",order:15,title:(0,A.localize)(11085,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(11086,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(11087,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(11088,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(11089,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(11090,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(11091,null),(0,A.localize)(11092,null),(0,A.localize)(11093,null),(0,A.localize)(11094,null)],default:"override",description:(0,A.localize)(11095,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11096,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(11097,null),restricted:!0}}},o.updateConfigurations({add:[w],remove:u?[u]:[]})}P(N.ConfigurationScope.APPLICATION)}),define(he[191],ue([0,1,25,22,7,61]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KR=void 0;let N=class{constructor(k,b){this.a=k,this.b=b}async download(k,b,I=R.CancellationToken.None){if(k.scheme===c.Schemas.file||k.scheme===c.Schemas.vscodeRemote){await this.b.copy(k,b);return}const $={type:"GET",url:k.toString(!0)},d=await this.a.request($,I);if(d.res.statusCode===200)await this.b.writeFile(b,d.stream);else{const g=await(0,A.$0p)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${g}`)}}};e.$KR=N,e.$KR=N=ve([Z(0,A.$5p),Z(1,C.$0k)],N)}),define(he[192],ue([0,1,14,25]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=void 0;class C{constructor(O){this.a=O}listen(O,k){throw new Error("Invalid listen")}call(O,k,b,I=c.CancellationToken.None){switch(k){case"request":return this.a.request(b[0],I).then(async({res:$,stream:d})=>{const g=await(0,R.$Xe)(d);return[{statusCode:$.statusCode,headers:$.headers},g]});case"resolveProxy":return this.a.resolveProxy(b[0]);case"lookupAuthorization":return this.a.lookupAuthorization(b[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$_r=C;class A{constructor(O){this.a=O}async request(O,k){const[b,I]=await this.a.call("request",[O],k);return{res:b,stream:(0,R.$Ze)(I)}}async resolveProxy(O){return this.a.call("resolveProxy",[O])}async lookupAuthorization(O){return this.a.call("lookupAuthorization",[O])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$as=A}),define(he[193],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=e.$hgc=void 0,e.$hgc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$igc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$jgc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(he[194],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;class R{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(C){try{const A=await this.c();if(A){const N=String(R.a++);return this.b.set(N,A),{id:N,data:A.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,A){if(!C.id)return!0;const N=this.b.get(C.id);if(!N)return!1;this.b.delete(C.id);try{return N.validate(A)==="ok"}catch{return!1}finally{N.dispose?.()}}async sign(C){try{return await this.d(C)}catch{}return C}}e.$5bc=R}),define(he[108],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl="signService",e.$Wl=(0,R.$Ci)(e.$Vl)}),define(he[195],ue([0,1,194]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class c extends R.$5bc{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(N=>new N.signer().sign(A))}h(){return new Promise((A,N)=>oe(["vsda"],A,N))}}e.$_gc=c}),define(he[79],ue([0,1,3,2]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QMb=e.$PMb=e.$OMb=e.$NMb=void 0;class C extends c.$Tc{constructor($,d,g){super(),this.a=$,this.b=d,this.c=g}async getItems(){const $={profile:this.b,workspace:this.c},d=await this.a.call("getItems",$);return new Map(d)}updateItems($){const d={profile:this.b,workspace:this.c};return $.insert&&(d.insert=Array.from($.insert.entries())),$.delete&&(d.delete=Array.from($.delete.values())),this.a.call("updateItems",d)}optimize(){const $={profile:this.b,workspace:this.c};return this.a.call("optimize",$)}}class A extends C{constructor($,d){super($,d,void 0),this.f=this.B(new R.$je),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})($=>this.h($)))}h($){(Array.isArray($.changed)||Array.isArray($.deleted))&&this.f.fire({changed:$.changed?new Map($.changed):void 0,deleted:$.deleted?new Set($.deleted):void 0})}}class N extends A{constructor($){super($,void 0)}async close(){this.dispose()}}e.$NMb=N;class O extends A{constructor($,d){super($,d)}async close(){this.dispose()}}e.$OMb=O;class k extends C{constructor($,d){super($,void 0,d),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.$PMb=k;class b{constructor($){this.a=$}isUsed($){const d={payload:$,profile:void 0,workspace:void 0};return this.a.call("isUsed",d)}}e.$QMb=b}),define(he[109],ue([0,1,5,37,32]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=N,e.$tp=O;function A(k){if(R.$v===R.Platform.Linux&&/^penguin(\.|$)/i.test(k))return"chromebook"}function N(k,b,I,$,d,g,l,m,E,f){const w=Object.create(null);w["common.machineId"]=g,w["common.sqmId"]=l,w["common.devDeviceId"]=m,w.sessionID=(0,C.$Yg)()+Date.now(),w.commitHash=$,w.version=d,w["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,R.$i)(R.$v),w["common.nodePlatform"]=c.$cc,w["common.nodeArch"]=I,w["common.product"]=f||"desktop",E&&(w["common.msftInternal"]=E);let P=0;const p=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),R.$m&&(w["common.snap"]="true");const o=A(b);return o&&(w["common.platformDetail"]=o),w}function O(k){const b=c.env.USERDNSDOMAIN;if(!b)return!1;const I=b.toLowerCase();return k.some($=>I===$)}}),define(he[18],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=void 0,e.$9l=(0,R.$Ci)("telemetryService"),e.$0l=(0,R.$Ci)("customEndpointTelemetryService"),e.$$l="telemetry.currentSessionDate",e.$_l="telemetry.firstSessionDate",e.$am="telemetry.lastSessionDate",e.$bm="telemetry.machineId",e.$cm="telemetry.sqmId",e.$dm="telemetry.devDeviceId",e.$em="telemetry",e.$fm="telemetry.telemetryLevel",e.$gm="telemetry.enableCrashReporter",e.$hm="telemetry.enableTelemetry";var c;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(c||(e.TelemetryLevel=c={}));var C;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(he[196],ue([0,1,33,38,6,36,22,13,5,54,9,142,30,149,97,7,23,18]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Vs=P,e.$Ws=o,e.$Xs=u,R=ke(R),c=ke(c);const w=new Map;async function P(n,t){const s=`${n}::${t.join(":")}`,r=w.get(s);if(r)return r;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],h=new Map,y=new Map,L=2e4;function S(T,U,F,j){const G=U.substring(T.length+1);return C.Promises.withAsyncBody(async V=>{let x;j.readdirCount++;try{x=await d.Promises.readdir(U,{withFileTypes:!0})}catch{V();return}if(j.count>=L){j.count+=x.length,j.maxReached=!0,V();return}let H=x.length;if(H===0){V();return}let ie=x;j.count+x.length>L&&(j.maxReached=!0,H=L-j.count,ie=x.slice(0,H)),j.count+=x.length;for(const z of ie)if(z.isDirectory()){if(F.includes(z.name)||await S(T,(0,O.$ic)(U,z.name),F,j),--H===0){V();return}}else{const W=z.name.lastIndexOf(".");if(W>=0){const ee=z.name.substring(W+1);ee&&h.set(ee,(h.get(ee)??0)+1)}for(const ee of a)ee.relativePathPattern?.test(G)!==!1&&ee.filePattern.test(z.name)&&y.set(ee.tag,(y.get(ee.tag)??0)+1);if(--H===0){V();return}}})}const v=C.Promises.withAsyncBody(async T=>{const U={count:0,maxReached:!1,readdirCount:0},F=new b.$de(!0);await S(n,n,t,U);const j=await u(n);T({configFiles:p(y),fileTypes:p(h),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:j,totalScanTime:F.elapsed(),totalReaddirCount:U.readdirCount})});return w.set(s,v),v}function p(n){return Array.from(n.entries(),([t,s])=>({name:t,count:s})).sort((t,s)=>s.count-t.count)}function o(){const n={os:`${c.type()} ${c.arch()} ${c.release()}`,memory:`${(c.totalmem()/m.$Fl.GB).toFixed(2)}GB (${(c.freemem()/m.$Fl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$Pn.value()*100)}%`},t=c.cpus();return t&&t.length>0&&(n.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),n}async function u(n){try{const t=new Map,s=(0,O.$ic)(n,".vscode","launch.json"),r=await R.promises.readFile(s),a=[],h=(0,A.$Vn)(r.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,A.$4n)(h)==="object"&&h.configurations)for(const y of h.configurations){const L=y.type;L&&(t.has(L)?t.set(L,t.get(L)+1):t.set(L,1))}return p(t)}catch{return[]}}let i=class{constructor(t,s){this.c=t,this.d=s}f(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}g(t){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${c.type()} ${c.arch()} ${c.release()}`);const r=c.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(c.totalmem()/m.$Fl.GB).toFixed(2)}GB (${(c.freemem()/m.$Fl.GB).toFixed(2)}GB free)`),k.$j||s.push(`Load (avg):       ${c.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round($.$Pn.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,g.$Us)(t.mainPID),this.k(t)]).then(async r=>{let[a,h]=r,y=this.m(t,a);return s.forEach(L=>{if((0,l.$Rm)(L))y+=`
${L.errorMessage}`,h+=`
${L.errorMessage}`;else if(y+=`

Remote: ${L.hostName}`,L.processes&&(y+=`
${this.m(t,L.processes)}`),L.workspaceMetadata){h+=`
|  Remote: ${L.hostName}`;for(const S of Object.keys(L.workspaceMetadata)){const v=L.workspaceMetadata[S];let T=`${v.fileCount} files`;v.maxFilesReached&&(T=`more than ${T}`),h+=`|    Folder (${S}): ${T}`,h+=this.h(v)}}}),{processInfo:y,workspaceInfo:h}})}async getSystemInfo(t,s){const{memory:r,vmHint:a,os:h,cpus:y}=o(),L={os:h,memory:r,cpus:y,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return k.$j||(L.load=`${c.loadavg().map(S=>Math.round(S)).join(", ")}`),k.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(t,s){const r=[];return(0,g.$Us)(t.mainPID).then(async a=>(r.push(""),r.push(this.g(t)),r.push(""),r.push(this.m(t,a)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(t))),s.forEach(h=>{if((0,l.$Rm)(h))r.push(`
${h.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${h.hostName}`),r.push(this.f(h.machineInfo)),h.processes&&r.push(this.m(t,h.processes)),h.workspaceMetadata)for(const y of Object.keys(h.workspaceMetadata)){const L=h.workspaceMetadata[y];let S=`${L.fileCount} files`;L.maxFilesReached&&(S=`more than ${S}`),r.push(`Folder (${y}): ${S}`),r.push(this.h(L))}}),r.push(""),r.push(""),r.join(`
`)))}h(t){const s=[];let a=0;const h=(v,T)=>{const U=` ${v}(${T})`;a+U.length>60?(s.push(y),y="|                 ",a=y.length):a+=U.length,y+=U};let y="|      File types:";const L=10,S=t.fileTypes.length>L?L:t.fileTypes.length;for(let v=0;v<S;v++){const T=t.fileTypes[v];h(T.name,T.count)}if(s.push(y),t.configFiles.length>=0&&(y="|      Conf files:",a=0,t.configFiles.forEach(v=>{h(v.name,v.count)}),s.push(y)),t.launchConfigFiles.length>0){let v="|      Launch Configs:";t.launchConfigFiles.forEach(T=>{const U=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`;v+=U}),s.push(v)}return s.join(`
`)}j(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}k(t){const s=[],r=[];return t.windows.forEach(a=>{a.folderURIs.length===0||a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(h=>{const y=I.URI.revive(h);if(y.scheme===N.Schemas.file){const L=y.fsPath;r.push(P(L,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),s.push(`|    Folder (${(0,O.$mc)(L)}): ${v}`),s.push(this.h(S))}).catch(S=>{s.push(`|      Error: Unable to collect workspace stats for folder ${L} (${S.toString()})`)}))}else s.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(t,s){const r=new Map;t.windows.forEach(h=>r.set(h.pid,`window [${h.id}] (${h.title})`)),t.pidToNames.forEach(({pid:h,name:y})=>r.set(h,y));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.n(t.mainPID,r,a,s,0),a.join(`
`)}n(t,s,r,a,h){const y=h===0;let L;y?L=a.pid===t?`${this.d.applicationName} main`:"remote agent":s.has(a.pid)?L=s.get(a.pid):L=`${"  ".repeat(h)} ${a.name}`;const S=process.platform==="win32"?a.mem:c.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(S/m.$Fl.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(a.children)&&a.children.forEach(v=>this.n(t,s,r,v,h+1))}async getWorkspaceFileExtensions(t){const s=new Set;for(const{uri:r}of t.folders){const a=I.URI.revive(r);if(a.scheme!==N.Schemas.file)continue;const h=a.fsPath;try{(await P(h,["node_modules",".git"])).fileTypes.forEach(L=>s.add(L.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=I.URI.revive(s);if(r.scheme!==N.Schemas.file)continue;const a=r.fsPath;try{const h=await P(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(y=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),h.launchConfigFiles.forEach(y=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),h.configFiles.forEach(y=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:h.totalScanTime,reachedLimit:h.maxFilesReached,fileCount:h.fileCount,readdirCount:h.totalReaddirCount})}catch{}}}};e.$Ys=i,e.$Ys=i=ve([Z(0,f.$9l),Z(1,E.$qk)],i)}),define(he[110],ue([0,1,8,4,10,18]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.ExtensionSignatureVerificationCode=e.$qq=void 0,e.$qq=(0,c.$Ci)("IExtensionSignatureVerificationService");var N;(function(b){b.Success="Success",b.RequiredArgumentMissing="RequiredArgumentMissing",b.InvalidArgument="InvalidArgument",b.PackageIsUnreadable="PackageIsUnreadable",b.UnhandledException="UnhandledException",b.SignatureManifestIsMissing="SignatureManifestIsMissing",b.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",b.SignatureIsMissing="SignatureIsMissing",b.SignatureIsUnreadable="SignatureIsUnreadable",b.CertificateIsUnreadable="CertificateIsUnreadable",b.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",b.FileAlreadyExists="FileAlreadyExists",b.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",b.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",b.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",b.SignatureIsInvalid="SignatureIsInvalid",b.SignatureManifestIsInvalid="SignatureManifestIsInvalid",b.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",b.EntryIsMissing="EntryIsMissing",b.EntryIsTampered="EntryIsTampered",b.Untrusted="Untrusted",b.CertificateRevoked="CertificateRevoked",b.SignatureIsNotValid="SignatureIsNotValid",b.UnknownError="UnknownError",b.PackageIsInvalidZip="PackageIsInvalidZip",b.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(N||(e.ExtensionSignatureVerificationCode=N={}));class O extends Error{constructor(I){super(I),this.code=I}}e.$rq=O;let k=class{constructor(I,$){this.b=I,this.c=$}d(){return this.a||(this.a=new Promise((I,$)=>oe(["@vscode/vsce-sign"],async d=>I(d),$))),this.a}async verify(I,$,d,g){let l;const m=I.identifier.id;try{l=await this.d()}catch(P){return this.b.error("Could not load vsce-sign module",(0,R.$9)(P)),this.b.info(`Extension signature verification is not done: ${m}`),!1}const E=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${m}...`),f=await l.verify($,d,this.b.getLevel()===C.LogLevel.Trace)}catch(P){f={code:N.UnknownError,didExecute:!1,output:(0,R.$9)(P)}}const w=new Date().getTime()-E;if(this.b.info(`Extension signature verification result for ${m}: ${f.code}. Executed: ${f.didExecute}. Duration: ${w}ms.`),this.b.trace(`Extension signature verification output for ${m}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:m,extensionVersion:I.version,code:f.code,internalCode:f.internalCode,duration:w,didExecute:f.didExecute,clientTargetPlatform:g}),f.code===N.Success)return!0;throw new O(f.code)}};e.$sq=k,e.$sq=k=ve([Z(0,C.$0j),Z(1,A.$9l)],k)}),define(he[111],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=e.$mgc=void 0;class R{constructor(A){this.b=A}listen(A,N){throw new Error(`Event not found: ${N}`)}call(A,N,{eventName:O,data:k}){return this.b.forEach(b=>b.log(O,k)),Promise.resolve(null)}}e.$mgc=R;class c{constructor(A){this.b=A}log(A,N){return this.b.call("log",{eventName:A,data:N}).then(void 0,O=>`Failed to log telemetry: ${console.warn(O)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$ngc=c}),define(he[48],ue([0,1,29,12,105,109,18]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=I,e.$Cp=$,e.$Dp=d,e.$Ep=g,e.$Fp=m,e.$Gp=f,e.$Hp=w,e.$Ip=o;class O{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$up=O;class k{constructor(){this.telemetryLevel=N.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=k,e.$wp=new k;class b{async publicLog(i,n,t){}async publicLogError(i,n,t){}}e.$xp=b,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function I(u,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!u.enableTelemetry)}function $(u,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}function d(u){const i=u.getValue(N.$fm),n=u.getValue(N.$gm);if(u.getValue(N.$hm)===!1||n===!1)return N.TelemetryLevel.NONE;switch(i??N.TelemetryConfiguration.ON){case N.TelemetryConfiguration.ON:return N.TelemetryLevel.USAGE;case N.TelemetryConfiguration.ERROR:return N.TelemetryLevel.ERROR;case N.TelemetryConfiguration.CRASH:return N.TelemetryLevel.CRASH;case N.TelemetryConfiguration.OFF:return N.TelemetryLevel.NONE}}function g(u){const i={},n={},t={};E(u,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const r=t[s];typeof r=="number"?n[s]=r:typeof r=="boolean"?n[s]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${r.length}`),i[s]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[s]=r)}return{properties:i,measurements:n}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(u){if(!u)return"none";const i=(0,C.$fn)(u);return l.has(i)?i:"other"}function E(u,i,n=0,t){if(u)for(const s of Object.getOwnPropertyNames(u)){const r=u[s],a=t?t+s:s;Array.isArray(r)?i[a]=(0,R.$go)(r):r instanceof Date?i[a]=r.toISOString():(0,c.$eg)(r)?n<2?E(r,i,n+1,a+"."):i[a]=(0,R.$go)(r):i[a]=r}}function f(u,i){const n=u.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,A.$tp)(n)||t}function w(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}function P(u,i){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let n=u;const t=[];for(const h of i)for(;;){const y=h.exec(u);if(!y)break;t.push([y.index,h.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const h=r.exec(u);if(!h)break;const y=t.some(([L,S])=>h.index<S&&L<r.lastIndex);!s.test(h[0])&&!y&&(n+=u.substring(a,h.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<u.length&&(n+=u.substr(a)),n}function p(u){if(!u)return u;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of i)if(n.regex.test(u))return`<REDACTED: ${n.label}>`;return u}function o(u,i){return(0,R.$do)(u,n=>{if(n instanceof O||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=P(t,i);for(const s of i)t=t.replace(s,"");return t=p(t),t}})}}),define(he[35],ue([0,1,26,27,34,5,9,8,37,48]),function(oe,e,R,c,C,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=I,e.$Lp=l,e.$Mp=m,e.$Np=E,e.$Op=f,e.$Pp=w,e.$Qp=P,e.$Rp=p,e.$Tp=o,e.$Up=i;function I(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,R.$yf)(n.id,t.id)===0}const $=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new d(t.identifier,s,r)}static parse(t){const s=$.exec(t);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r=C.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof d?I(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Kp=d;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(n){const t=g.exec(n);return t&&t[1]?[E(t[1]),t[2]]:[E(n),void 0]}function m(n,t){return`${n}.${t}`}function E(n){return n.toLowerCase()}function f(n,t){return E(m(n??C.$kn,t))}function w(n,t){const s=[],r=a=>{for(const h of s)if(h.some(y=>I(t(y),t(a))))return h;return null};for(const a of n){const h=r(a);h?h.push(a):s.push([a])}return s}function P(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function p(n){return{id:new b.$up(n.identifier.id),name:new b.$up(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Sp=new C.$on("pprice.better-merge");function o(n,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&s.every(h=>!I(h.identifier,{id:a}))){const h=n.filter(y=>I(y.identifier,{id:a}));h.length===1&&(s.push(h[0]),r.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function u(n,t){if(!A.$l)return!1;let s;try{s=(await n.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){t.debug("Error while getting the os-release file.",(0,O.$9)(a))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(n,t){const s=await u(n,t),r=(0,c.$ep)(s?"alpine":A.$v,k.$dc);return t.debug("ComputeTargetPlatform:",r),r}}),define(he[197],ue([0,1,25,27,35,34]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=N;async function N(O,k,b,I,$){try{const d=await O.getExtensionsControlManifest();if(!d.deprecated)return;const g=await O.getInstalled(A.ExtensionType.User);for(const[l,m]of Object.entries(d.deprecated)){if(!m?.extension)continue;const{id:E,autoMigrate:f,preRelease:w}=m.extension;if(!f)continue;const P=g.find(o=>(0,C.$Jp)(o.identifier,{id:l}));if(!P)continue;const p=(await k.getExtensions([{id:E,preRelease:w}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!p){$.info(`Skipping migrating '${P.identifier.id}' extension because, the comaptible target '${E}' extension is not found`);continue}try{$.info(`Migrating '${P.identifier.id}' extension to '${E}' extension...`);const o=!I.getDisabledExtensions().some(i=>(0,C.$Jp)(i,P.identifier));await O.uninstall(P),$.info(`Uninstalled the unsupported extension '${P.identifier.id}'`);let u=g.find(i=>(0,C.$Jp)(i.identifier,{id:E}));(!u||!u.isPreReleaseVersion&&o)&&(u=await O.installFromGallery(p,{installPreReleaseVersion:!0,isMachineScoped:P.isMachineScoped,operation:c.InstallOperation.Migrate}),$.info(`Installed the pre-release extension '${u.identifier.id}'`),o||(await I.disableExtension(u.identifier),$.info(`Disabled the pre-release extension '${u.identifier.id}' because the unsupported extension '${P.identifier.id}' is disabled`)),f.storage&&(b.addToMigrationList((0,C.$Mp)(P.manifest.publisher,P.manifest.name),(0,C.$Mp)(u.manifest.publisher,u.manifest.name)),$.info("Added pre-release extension to the storage migration list"))),$.info(`Migrated '${P.identifier.id}' extension to '${E}' extension.`)}catch(o){$.error(o)}}}catch(d){$.error(d)}}}),define(he[198],ue([0,1,8,3,2,31,35,34,7]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class b extends C.$Tc{constructor($,d,g,l,m,E,f){super(),this.f=$,this.g=d,this.h=g,this.j=l,this.m=m,this.n=E,this.r=f,this.a=this.B(new c.$je),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new C.$3c),this.s().then(null,w=>f.error("Error while initializing Extensions Watcher",(0,R.$9)(w)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(d=>(this.c.set(d.id,(0,C.$Qc)(this.n.watch(this.m.extUri.dirname(d.extensionsResource)),this.n.watch(d.extensionsResource))),this.G(d.extensionsResource))))}catch(d){throw this.r.error(d),d}}async w($){for(const d of $.extensions)this.I(this.L(d.identifier,d.version),$.profileLocation)}async y($){for(const d of $.extensions){const g=this.L(d.identifier,d.version);$.error?this.J(g,$.profileLocation):this.I(g,$.profileLocation)}}async z($){for(const d of $.extensions)this.J(this.L(d.identifier,d.version),$.profileLocation)}async C($){const d=[],g=[];for(const l of $.extensions){const m=this.L(l.identifier,l.version);$.error?this.I(m,$.profileLocation):(this.J(m,$.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",l.identifier.id,l.version),g.push(this.f.scanInstalledExtensionAtLocation(l.location).then(E=>{E?d.push(E):this.r.info("Extension not found at the location",l.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(g),d.length&&await this.H(d)}catch(l){this.r.error(l)}}D($){for(const d of this.h.profiles)$.contains(d.extensionsResource,k.FileChangeType.UPDATED,k.FileChangeType.ADDED)&&this.F(d.extensionsResource)}async F($){const d=[],g=[],l=await this.j.scanProfileExtensions($),m=new Set,E=new Set;for(const[f,w]of this.b)w.has($)&&E.add(f);for(const f of l){const w=this.L(f.identifier,f.version);m.add(w),E.has(w)||(d.push(f.identifier),this.I(w,$))}for(const f of E)if(!m.has(f)){const w=this.M(f);w&&(g.push(w.identifier),this.J(f,$))}(d.length||g.length)&&this.a.fire({added:d.length?{extensions:d,profileLocation:$}:void 0,removed:g.length?{extensions:g,profileLocation:$}:void 0})}async G($){const d=await this.j.scanProfileExtensions($);for(const g of d)this.I(this.L(g.identifier,g.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(g=>!this.b.has(this.L(g.identifier,g.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,d){let g=this.b.get($);g||this.b.set($,g=new A.$Ac(l=>this.m.extUri.getComparisonKey(l))),g.add(d)}J($,d){const g=this.b.get($);g&&g.delete(d),g?.size||this.b.delete($)}L($,d){return`${O.$on.toKey($.id)}@${d}`}M($){const[d,g]=(0,N.$Lp)($);return g?{identifier:{id:d},version:g}:void 0}}e.$Uq=b}),define(he[199],ue([0,1,33,75,17,6,2,22,13,30,15,27,35,10,78,9]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0,R=ke(R);let E=class extends l.$0r{constructor(p,o,u,i){super(u),this.h=p,this.j=i,this.g=this.B(new f(o,i)),this.h.registerParticipant({postInstall:async n=>this.m(n),postUninstall:async n=>this.n(n)})}async getBuiltInExtensionTranslationsUri(p,o){const i=(await this.g.getLanguagePacks())[o];if(!i){this.j.warn(`No language pack found for ${o}`);return}const n=i.translations[p];return n?m.URI.file(n):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),o=Object.keys(p).map(u=>{const i=p[u];return{...this.f(u,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return o.push(this.f("en","English")),o.sort((u,i)=>u.label.localeCompare(i.label)),o}async m(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",p.identifier.id),await this.update())}async n(p){const o=await this.g.getLanguagePacks();Object.keys(o).some(u=>o[u]&&o[u].extensions.some(i=>(0,d.$Jp)(i.extensionIdentifier,p.identifier)))&&(this.j.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,o]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),u=await this.g.update(o);return!(0,C.$tb)(Object.keys(p),Object.keys(u))}};e.$$r=E,e.$$r=E=ve([Z(0,$.$lp),Z(1,I.$Ki),Z(2,$.$ip),Z(3,g.$0j)],E);let f=class extends N.$Tc{constructor(p,o){super(),this.j=o,this.c={},this.f=(0,k.$ic)(p.userDataPath,"languagepacks.json"),this.g=new A.$Jh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.s(o=>{Object.keys(o).forEach(u=>delete o[u]),this.m(o,...p)}).then(()=>this.c)}m(p,...o){for(const u of o)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.n(p,u);Object.keys(p).forEach(u=>this.r(p[u]))}n(p,o){const u=o.identifier,i=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const n of i)if(o.location.scheme===O.Schemas.file&&w(n)){let t=p[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},p[n.languageId]=t);const s=t.extensions.filter(r=>(0,d.$Jp)(r.extensionIdentifier,u))[0];s?s.version=o.manifest.version:t.extensions.push({extensionIdentifier:u,version:o.manifest.version});for(const r of n.translations)t.translations[r.id]=(0,k.$ic)(o.location.fsPath,r.path)}}r(p){if(p){const o=(0,c.createHash)("md5");for(const u of p.extensions)o.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);p.hash=o.digest("hex")}}s(p=()=>null){return this.g.queue(()=>{let o=null;return R.promises.readFile(this.f,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(o=p(u),u)).then(u=>{for(const n of Object.keys(u))u[n]||delete u[n];this.c=u,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),b.Promises.writeFile(this.f,i)}).then(()=>o,u=>this.j.error(u))})}};f=ve([Z(0,I.$Ki),Z(1,g.$0j)],f);function w(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const p of P.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}}),define(he[200],ue([0,1,140,8,29,48]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iR=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function k(I,$,d){const g=await(0,R.$sE)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,R.$sE)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new g.AppInsightsCore,E=new l.PostChannel,f={instrumentationKey:I,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(d){f.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};f.extensionConfig[E.identifier]=w}return m.initialize(f,[]),m.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',$&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),m}class b{constructor($,d,g,l,m){this.e=$,this.f=d,this.g=g,this.h=m,this.c=N,this.d=O,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i($){if(this.a){if(typeof this.a!="string"){$(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(d=>{$(d)},d=>{(0,c.$Y)(d),console.error(d)})}}log($,d){if(!this.a)return;d=(0,C.$eo)(d,this.g),d=(0,A.$Ep)(d);const g=this.f+"/"+$;try{this.i(l=>{l.pluginVersionString=d?.properties.version??"Unknown",l.track({name:g,baseData:{name:g,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise($=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,$(void 0)})})}):Promise.resolve(void 0)}}e.$iR=b}),define(he[112],ue([0,1,2,11,15,10,23,48]),function(oe,e,R,c,C,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;let k=class extends R.$Tc{constructor(I,$,d,g,l=""){super(),this.b=l;const m=$.getLogger(O.$yp);if(m)this.a=this.B(m);else{const f=(0,O.$Cp)(g,d)?" (Not Sent)":"",w=()=>(0,O.$Bp)(g,d)&&I.getLevel()===A.LogLevel.Trace;this.a=this.B($.createLogger(O.$yp,{name:(0,c.localize)(11080,null,f),hidden:!w()})),this.B(I.onDidChangeLogLevel(()=>$.setVisibility(O.$yp,w()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(I,$){this.a.trace(`${this.b}telemetry/${I}`,(0,O.$Ep)($))}};e.$Bdc=k,e.$Bdc=k=ve([Z(0,A.$0j),Z(1,A.$$j),Z(2,C.$Ji),Z(3,N.$qk)],k)});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[113],ue([0,1,2,29,5,26,11,21,47,102,23,44,18,48]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,b=it(b);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,w,P){this.k=w,this.l=P,this.d={},this.i=new R.$Sc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=d.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$ff)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$ff)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(d.$fm)||p.affectsConfiguration(d.$hm)||p.affectsConfiguration(d.$gm))&&this.m()}))}setExperimentProperty(f,w){this.d[f]=w}m(){let f=(0,g.$Dp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const P=w.usage?d.TelemetryLevel.USAGE:w.error?d.TelemetryLevel.ERROR:d.TelemetryLevel.NONE;f=Math.min(f,P)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,w,P){this.g<w||(P=(0,c.$eo)(P,this.d),P=(0,g.$Ip)(P,this.j),P=(0,c.$eo)(P,this.c),this.b.forEach(p=>p.log(f,P)))}publicLog(f,w){this.n(f,d.TelemetryLevel.USAGE,w)}publicLog2(f,w){this.publicLog(f,w)}publicLogError(f,w){this.h&&this.n(f,d.TelemetryLevel.ERROR,w)}publicLogError2(f,w){this.publicLogError(f,w)}};e.$es=l,e.$es=l=ve([Z(1,O.$9i),Z(2,I.$qk)],l);function m(){const E=(0,N.localize)(11062,null,b.default.nameLong),f=b.default.privacyStatementUrl?(0,N.localize)(11064,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,N.localize)(11063,null,"https://aka.ms/vscode-telemetry"),w=C.$p?"":(0,N.localize)(11065,null),P=(0,N.localize)(11066,null),p=(0,N.localize)(11067,null),o=(0,N.localize)(11068,null),u=(0,N.localize)(11069,null),i=`
|       | ${P} | ${p} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,N.localize)(11070,null);return`
${E} ${f} ${w}

&nbsp;

${u}
${i}

&nbsp;

${n}
`}$.$oo.as(k.$to.Configuration).registerConfiguration({id:d.$em,order:1,type:"object",title:(0,N.localize)(11071,null),properties:{[d.$fm]:{type:"string",enum:[d.TelemetryConfiguration.ON,d.TelemetryConfiguration.ERROR,d.TelemetryConfiguration.CRASH,d.TelemetryConfiguration.OFF],enumDescriptions:[(0,N.localize)(11072,null),(0,N.localize)(11073,null),(0,N.localize)(11074,null),(0,N.localize)(11075,null)],markdownDescription:m(),default:d.TelemetryConfiguration.ON,restricted:!0,scope:k.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),$.$oo.as(k.$to.Configuration).registerConfiguration({id:d.$em,order:110,type:"object",title:(0,N.localize)(11076,null),properties:{[d.$hm]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,N.localize)(11078,null,b.default.nameLong,b.default.privacyStatementUrl):(0,N.localize)(11077,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(11079,null,`\`#${d.$fm}#\``),scope:k.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(he[201],ue([0,1,14,25,244,200]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=void 0,C=ke(C);async function N(I,$){const d=await $.request(I,c.CancellationToken.None),g=(await(0,R.$Xe)(d.stream)).toString(),l=d.res.statusCode??200;return{headers:d.res.headers,statusCode:l,responseData:g}}async function O(I){const $={method:I.type,headers:I.headers};return new Promise((g,l)=>{const m=C.request(I.url??"",$,E=>{E.on("data",function(f){g({headers:E.headers,statusCode:E.statusCode??200,responseData:f.toString()})}),E.on("error",function(f){l(f)})});m.write(I.data,E=>{E&&l(E)}),m.end()})}async function k(I,$,d){const g=typeof $.data=="string"?$.data:new TextDecoder().decode($.data),l={type:"POST",headers:{...$.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength($.data).toString()},url:$.urlString,data:g};try{const m=I?await N(l,I):await O(l);d(m.statusCode,m.headers,m.responseData)}catch{d(0,{})}}class b extends A.$iR{constructor($,d,g,l,m){const E={sendPOST:(f,w)=>{k($,f,w)}};super(d,g,l,m,E)}}e.$jR=b}),define(he[202],ue([0,1,22,95,21,15,10,23,18,111,112,113]),function(oe,e,R,c,C,A,N,O,k,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;let d=class{constructor(l,m,E,f,w,P){this.b=l,this.c=m,this.d=E,this.e=f,this.f=w,this.g=P,this.a=new Map}h(l){if(!this.a.has(l.id)){const m=Object.create(null);m["common.vscodemachineid"]=this.c.machineId,m["common.vscodesessionid"]=this.c.sessionId;const E=[l.id,JSON.stringify(m),l.aiKey],w=new c.$fr(R.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new b.$ngc(w),new I.$Bdc(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new $.$es({appenders:P,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,m,E){this.h(l).publicLog(m,E)}publicLogError(l,m,E){this.h(l).publicLogError(m,E)}};e.$Bhc=d,e.$Bhc=d=ve([Z(0,C.$9i),Z(1,k.$9l),Z(2,N.$0j),Z(3,N.$$j),Z(4,A.$Ji),Z(5,O.$qk)],d)}),define(he[80],ue([0,1,3,2,5,9,21,4,10]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=$,e.$Ew=g,e.$Fw=l,e.$Hw=m,e.$Jw=E,e.$Kw=f,e.$Bw=(0,O.$Ci)("tunnelService"),e.$Cw=(0,O.$Ci)("sharedTunnelsService");var b;(function(p){p.Http="http",p.Https="https"})(b||(e.TunnelProtocol=b={}));var I;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(I||(e.TunnelPrivacyId=I={}));function $(p){return!!p.forwardPort}var d;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function g(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(o)return{address:o[1],port:+o[2]}}function l(p){if(p.scheme!=="http"&&p.scheme!=="https"||!p.query)return;const o=p.query.split("&");for(const u of o){const i=u.split("=")[1];if(/^https?:/.exec(i)){const n=g(A.URI.parse(i));if(n)return n}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(p){return e.$Gw.indexOf(p)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(p){return e.$Iw.indexOf(p)>=0}function f(p,o,u,i){if(u===C.OperatingSystem.Windows)return!1;if(u===C.OperatingSystem.Macintosh&&E(o)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(n?.length===4&&parseInt(n[1])>=18)return!1}return p<1024}class w{constructor(o,u,i){this.remoteAddress=o,this.localAddress=u,this.b=i,this.a=new R.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=w;let P=class extends c.$Tc{constructor(o,u){super(),this.r=o,this.s=u,this.a=new R.$je,this.onTunnelOpened=this.a.event,this.b=new R.$je,this.onTunnelClosed=this.b.event,this.c=new R.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const o=this.s.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.g=o,o?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.h=o.elevation,this.m=o.privacyOptions,this.j=o.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const o=[],u=Array.from(this.f.values());for(const i of u){const n=Array.from(i.values());for(const t of n){const s=await t.value;s&&typeof s!="string"&&o.push(s)}}return o}async dispose(){super.dispose();for(const o of this.f.values()){for(const{value:u}of o.values())await u.then(i=>typeof i!="string"?i?.dispose():void 0);o.clear()}this.f.clear()}setEnvironmentTunnel(o,u,i,n,t){this.z(o,u,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:u,localAddress:i,privacy:n,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,u){(E(o)||m(o))&&(o=e.$Gw[0]);const i=this.D(o,u);if(i)return++i.refcount,i.value}openTunnel(o,u,i,n,t,s=!1,r,a){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${i} on local port ${t}.`);const h=this.g??o;if(!h)return;if(u||(u="localhost"),n||(n=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.F(h,u,i,n,t,s,r,a);return y?y.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(u,i),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(u,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.w(L);return(L.tunnelRemoteHost!==u||L.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&L.privacy!==r&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}w(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const u=this.f.get(o.tunnelRemoteHost);if(u){const i=u.get(o.tunnelRemotePort);i&&(i.refcount--,await this.y(o.tunnelRemoteHost,o.tunnelRemotePort,i))}}}}async y(o,u,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${u}.`);const n=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.f.has(o)&&this.f.get(o).delete(u),n}}async closeTunnel(o,u){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${u} `);const i=this.f.get(o);if(i&&i.has(u)){const n=i.get(u);n.refcount=0,await this.y(o,u,n)}}z(o,u,i){this.f.has(o)||this.f.set(o,new Map),this.f.get(o).set(u,{refcount:1,value:i})}async C(o,u){const i=this.f.get(o);if(i){const n=i.get(u),t=n?await n.value:void 0;(!t||typeof t=="string")&&i.delete(u),i.size===0&&this.f.delete(o)}}D(o,u){const i=[o];m(o)?(i.push(...e.$Gw),i.push(...e.$Iw)):E(o)&&i.push(...e.$Iw);const n=i.map(t=>this.f.get(t));for(const t of n){const s=t?.get(u);if(s)return s}}canTunnel(o){return!!g(o)}G(o,u,i,n,t,s,r){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${i} on local port ${n}.`);const a=i;this.n.add(a);const h=n===void 0?i:n,y={elevationRequired:t?this.isPortPrivileged(h):!1},L={remoteAddress:{host:u,port:i},localAddressPort:n,privacy:s,public:s?s!==I.Private:void 0,protocol:r},S=o.forwardPort(L,y);return S?(this.z(u,i,S),S.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(a)})):this.n.delete(a),S}};e.$Mw=P,e.$Mw=P=ve([Z(0,k.$0j),Z(1,N.$9i)],P)}),define(he[203],ue([0,1,10,80,2,8,6]),function(oe,e,R,c,C,A,N){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class k extends C.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new N.$Zh),this.b.p)}setAddress($){this.a=$,this.b&&(this.b.complete($),this.b=null)}setTunnel($){this.B($)}}let b=class extends C.$Tc{static{O=this}static{this.a=0}constructor($,d){super(),this.f=$,this.g=d,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach($=>$.dispose())}async createTunnel(){return{id:String(++O.a)}}async startTunnel($,d,g,l,m,E,f){const w=new k,P=await Promise.resolve(this.f.openTunnel($,w,g,l,m,E,f));if(!P||typeof P=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${l} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this.c.has(d))throw this.c.delete(d),w.dispose(),await P.dispose(),(0,A.$5)();return w.setTunnel(P),this.b.set(d,w),this.g.info(`[SharedProcessTunnelService] Created tunnel ${d}: ${P.localAddress} (local) to ${g}:${l} (remote).`),{tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress}}async setAddress($,d){const g=this.b.get($);g&&g.setAddress(d)}async destroyTunnel($){const d=this.b.get($);if(d){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${$}.`),this.b.delete($),await d.dispose();return}this.c.add($)}};e.$Lhc=b,e.$Lhc=b=O=ve([Z(0,c.$Cw),Z(1,R.$0j)],b)}),define(he[28],ue([0,1,4]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=void 0,e.$Hl=(0,R.$Ci)("IUriIdentityService")}),define(he[204],ue([0,1,28,160,7,20,135,3,2]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class b{static{this._clock=0}constructor(d){this.uri=d,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let I=class{constructor(d){this.g=d,this.c=new k.$Sc,this.f=2**16;const g=new Map,l=m=>{let E=g.get(m.scheme);return E===void 0&&(E=d.hasProvider(m)&&!this.g.hasCapability(m,C.FileSystemProviderCapabilities.PathCaseSensitive),g.set(m.scheme,E)),E};this.c.add(O.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(m=>{g.delete(m.scheme)})),this.extUri=new A.$5g(l),this.d=new N.$Qs((m,E)=>this.extUri.compare(m,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$eh)(d));const g=this.d.get(d);return g?g.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new b(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((l,m)=>l[1].time<m[1].time?1:l[1].time>m[1].time?-1:0);b._clock=0,this.d.clear();const g=this.f*.5;for(let l=0;l<g;l++)this.d.set(d[l][0],d[l][1].touch())}};e.$Rs=I,e.$Rs=I=ve([Z(0,C.$0k)],I),(0,c.$Os)(R.$Hl,I,c.InstantiationType.Delayed)}),define(he[205],ue([0,1,3,2,7,51,31]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class O extends c.$Tc{constructor(b,I,$,d,g,l){super(),this.f=b,this.g=I,this.h=$,this.j=d,this.m=g,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new R.$je),this.onDidChangeFile=this.a.event,this.b=A.$Ii.forUris(()=>!(this.capabilities&C.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new N.$Ac(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const b of this.j.profiles)this.c.add(b.settingsResource),this.c.add(b.keybindingsResource),this.c.add(b.tasksResource),this.c.add(b.extensionsResource)}open(b,I){return this.g.open(this.t(b),I)}close(b){return this.g.close(b)}read(b,I,$,d,g){return this.g.read(b,I,$,d,g)}write(b,I,$,d,g){return this.g.write(b,I,$,d,g)}watch(b,I){this.b.set(b,b);const $=this.g.watch(this.t(b),I);return(0,c.$Rc)(()=>{this.b.delete(b),$.dispose()})}stat(b){return this.g.stat(this.t(b))}mkdir(b){return this.g.mkdir(this.t(b))}rename(b,I,$){return this.g.rename(this.t(b),this.t(I),$)}readFile(b,I){return this.g.readFile(this.t(b),I)}readFileStream(b,I,$){return this.g.readFileStream(this.t(b),I,$)}readdir(b){return this.g.readdir(this.t(b))}enforceAtomicReadFile(b){return this.c.has(b)}writeFile(b,I,$){return this.g.writeFile(this.t(b),I,$)}enforceAtomicWriteFile(b){return this.c.has(b)?{postfix:".vsctmp"}:!1}delete(b,I){return this.g.delete(this.t(b),I)}copy(b,I,$){if((0,C.$bl)(this.g))return this.g.copy(this.t(b),this.t(I),$);throw new Error("copy not supported")}cloneFile(b,I){if((0,C.$cl)(this.g))return this.g.cloneFile(this.t(b),this.t(I));throw new Error("clone not supported")}s(b){const I=[];for(const $ of b){if($.resource.scheme!==this.f)continue;const d=this.u($.resource);this.b.findSubstr(d)&&I.push({resource:d,type:$.type,cId:$.cId})}I.length&&(this.n.debug("User data changed"),this.a.fire(I))}t(b){return b.with({scheme:this.f})}u(b){return b.with({scheme:this.h})}}e.$chc=O}),define(he[81],ue([0,1,64]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=c,e.$tMb=C,e.$uMb=A;function c(N,O,k,b){const I=(0,R.$0n)(N,O,k,b)[0];return I&&(N=N.substring(0,I.offset)+I.content+N.substring(I.offset+I.length)),N}function C(N,O,k){let b=k;for(;b>=0;){if(N.charAt(b)===O.charAt(O.length-1)&&O.length===1)return b+1;if(b--,O.length===2&&b>=0&&N.charAt(b)===O.charAt(0))return b+2}return 0}function A(N,O,k){let b=k;for(;b>=0;)if(N.charAt(b)===O.charAt(O.length-1)&&O.length===1||(b++,O.length===2&&b>=0&&N.charAt(b)===O.charAt(1)))return b;return N.length-1}}),define(he[206],ue([0,1,29,60,12]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=A,c=ke(c);function A(g,l,m,E,f,w){const P=[],p=[],o=[];if(!l){const j=g.filter(({identifier:G})=>f.every(V=>V.toLowerCase()!==G.id.toLowerCase()));return{local:{added:P,removed:p,updated:o},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}g=g.map($),l=l.map($),m=m?m.map($):null;const u=new Map,i=j=>{j.uuid&&u.set(j.id.toLowerCase(),j.uuid)};g.forEach(({identifier:j})=>i(j)),l.forEach(({identifier:j})=>i(j)),m?.forEach(({identifier:j})=>i(j)),E?.forEach(({identifier:j})=>i(j)),w?.forEach(j=>i(j));const n=j=>{const G=j.identifier.uuid||u.get(j.identifier.id.toLowerCase());return G?`uuid:${G}`:`id:${j.identifier.id.toLowerCase()}`},t=(j,G)=>(j.set(n(G),G),j),s=g.reduce(t,new Map),r=l.reduce(t,new Map),a=l.reduce((j,G)=>t(j,(0,R.$bo)(G)),new Map),h=m?m.reduce(t,new Map):null,y=E.reduce(t,new Map),L=f.reduce((j,G)=>{const V=u.get(G.toLowerCase());return j.add(V?`uuid:${V}`:`id:${G.toLowerCase()}`)},new Set),S=w?w.reduce((j,{id:G,uuid:V})=>(V=V??u.get(G.toLowerCase()),j.add(V?`uuid:${V}`:`id:${G.toLowerCase()}`)),new Set):null,v=N(s,r,L,!1);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const j=N(h,s,L,!1),G=N(h,r,L,!0),V=(x,H,ie,z)=>{let W,ee,ne;return H.installed?(W=z.pinned,ne=z.preRelease,W&&(ee=z.version)):(W=ie.pinned,ne=ie.preRelease,W&&(ee=ie.version)),W===void 0&&(W=H.pinned,W&&(ee=H.version)),ne===void 0&&(ne=H.preRelease),{...z,installed:H.installed||ie.installed,pinned:W,preRelease:ne,version:ee??(ie.version&&(!H.installed||c.gt(ie.version,H.version))?ie.version:H.version),state:k(H,ie,h?.get(x))}};for(const x of G.removed.values()){const H=s.get(x);if(!H)continue;const ie=(0,C.$ng)(h?.get(x)),z=S&&!S.has(x)&&ie.installed;H.installed&&z?p.push(H.identifier):a.set(x,H)}for(const x of G.added.values()){const H=(0,C.$ng)(r.get(x)),ie=s.get(x);if(ie){if(v.updated.has(x)){const z=V(x,ie,H,H);O(ie,H,!1,!1)||o.push(d(z,x)),a.set(x,z)}}else H.installed&&P.push(d(H,x))}for(const x of G.updated.values()){const H=(0,C.$ng)(r.get(x)),ie=(0,C.$ng)(h?.get(x)),z=s.get(x);if(z)if(S&&!S.has(x)&&ie.installed&&z.installed&&!H.installed)p.push(z.identifier);else{const ee=V(x,z,H,H);o.push(d(ee,x)),a.set(x,ee)}else H.installed&&P.push(d(H,x))}for(const x of j.added.values())G.added.has(x)||a.set(x,(0,C.$ng)(s.get(x)));for(const x of j.updated.values()){if(G.removed.has(x)||G.updated.has(x))continue;const H=(0,C.$ng)(s.get(x)),ie=(0,C.$ng)(r.get(x));a.set(x,V(x,H,ie,H))}for(const x of j.removed.values())G.updated.has(x)||G.removed.has(x)||y.has(x)||(0,C.$ng)(r.get(x)).installed&&S&&(S.has(x)||!(0,C.$ng)(h?.get(x)).installed||a.delete(x))}const T=[],U=N(r,a,new Set,!0),F=U.added.size>0||U.updated.size>0||U.removed.size>0;return F&&a.forEach((j,G)=>T.push(d(j,G))),{local:{added:P,removed:p,updated:o},remote:F?{added:[...U.added].map(j=>a.get(j)),updated:[...U.updated].map(j=>a.get(j)),removed:[...U.removed].map(j=>r.get(j)),all:T}:null}}function N(g,l,m,E){const f=g?[...g.keys()].filter(u=>!m.has(u)):[],w=[...l.keys()].filter(u=>!m.has(u)),P=w.filter(u=>!f.includes(u)).reduce((u,i)=>(u.add(i),u),new Set),p=f.filter(u=>!w.includes(u)).reduce((u,i)=>(u.add(i),u),new Set),o=new Set;for(const u of f){if(p.has(u))continue;const i=g.get(u),n=l.get(u);(!n||!O(i,n,E,!0))&&o.add(u)}return{added:P,removed:p,updated:o}}function O(g,l,m,E){return!(g.disabled!==l.disabled||!!g.isApplicationScoped!=!!l.isApplicationScoped||E&&g.installed!==l.installed||g.installed&&l.installed&&(g.preRelease!==l.preRelease||g.pinned!==l.pinned||l.pinned&&g.version!==l.version)||!I(g.state,l.state)||m&&g.version!==l.version)}function k(g,l,m){const E=g.state,f=l.state,w=m?.state;if(!l.version||E&&c.gt(g.version,l.version))return E;if(f&&c.gt(l.version,g.version)||!E)return f;if(!f)return E;const P=(0,R.$bo)(E),p=w?b(w,f):{added:Object.keys(f).reduce((u,i)=>(u.add(i),u),new Set),removed:new Set,updated:new Set},o=w?b(w,E):{added:Object.keys(E).reduce((u,i)=>(u.add(i),u),new Set),removed:new Set,updated:new Set};for(const u of[...p.added.values(),...p.updated.values()])P[u]=f[u];for(const u of p.removed.values())o.updated.has(u)||delete P[u];return P}function b(g,l){const m=Object.keys(g),E=Object.keys(l),f=E.filter(p=>!m.includes(p)).reduce((p,o)=>(p.add(o),p),new Set),w=m.filter(p=>!E.includes(p)).reduce((p,o)=>(p.add(o),p),new Set),P=new Set;for(const p of m){if(w.has(p))continue;const o=g[p],u=l[p];(0,R.$fo)(o,u)||P.add(p)}return{added:f,removed:w,updated:P}}function I(g={},l={}){const{added:m,removed:E,updated:f}=b(g,l);return m.size===0&&E.size===0&&f.size===0}function $(g){return{...g,disabled:!!g.disabled,installed:!!g.installed}}function d(g,l){const m={...g,identifier:{id:g.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!g.preRelease,pinned:!!g.pinned};return g.disabled||delete m.disabled,g.installed||delete m.installed,g.state||delete m.state,g.isApplicationScoped||delete m.isApplicationScoped,m}}),define(he[114],ue([0,1,17,21,4]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KOb=e.$JOb=void 0,e.$JOb=(0,C.$Ci)("IIgnoredExtensionsManagementService");let A=class{constructor(O){this.a=O}hasToNeverSyncExtension(O){return this.b().includes(O.toLowerCase())}hasToAlwaysSyncExtension(O){return this.b().includes(`-${O.toLowerCase()}`)}updateIgnoredExtensions(O,k){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==O&&I!==`-${O}`),k&&b.push(O.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,c.ConfigurationTarget.USER)}updateSynchronizedExtensions(O,k){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==O&&I!==`-${O}`),k&&b.push(`-${O.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,c.ConfigurationTarget.USER)}getIgnoredExtensions(O){const k=O.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),b=this.b().map(d=>d.toLowerCase()),I=[],$=[];if(Array.isArray(b))for(const d of b)d.startsWith("-")?$.push(d.substring(1)):I.push(d);return(0,R.$Lb)([...k,...I].filter(d=>!$.includes(d)))}b(){let O=this.a.inspect("settingsSync.ignoredExtensions").userValue;return O!==void 0||(O=this.a.inspect("sync.ignoredExtensions").userValue,O!==void 0)?O:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$KOb=A,e.$KOb=A=ve([Z(0,c.$9i)],A)}),define(he[207],ue([0,1,17,36,29,96,81]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=k,C=ke(C),N=ke(N);function O(p){return(0,c.$Vn)(p)||[]}async function k(p,o,u,i,n){const t=O(p),s=O(o),r=u?O(u):null,a=[...t,...s,...r||[]].map(V=>V.key),h=await n.resolveUserBindings(a),y=I(t,s,r,h);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const L=d(t),S=d(s),v=r?d(r):null,T=l(L,S,h),U=v?l(v,L,h):{added:[...L.keys()].reduce((V,x)=>(V.add(x),V),new Set),removed:new Set,updated:new Set},F=v?l(v,S,h):{added:[...S.keys()].reduce((V,x)=>(V.add(x),V),new Set),removed:new Set,updated:new Set},j=b(T,U,F);let G=p;for(const V of j.removed.values())j.conflicts.has(V)||(G=w(G,V,i));for(const V of j.added.values()){if(j.conflicts.has(V))continue;const x=S.get(V);if(x.some(H=>H.command!==`-${V}`&&y.conflicts.has(h[H.key]))){j.conflicts.add(V);continue}G=f(G,x,i)}for(const V of j.updated.values()){if(j.conflicts.has(V))continue;const x=S.get(V);if(x.some(H=>H.command!==`-${V}`&&y.conflicts.has(h[H.key]))){j.conflicts.add(V);continue}G=P(G,V,x,i)}return{mergeContent:G,hasChanges:!0,hasConflicts:j.conflicts.size>0}}function b(p,o,u){const i=new Set,n=new Set,t=new Set,s=new Set;for(const r of o.removed.values())u.updated.has(r)&&s.add(r);for(const r of u.removed.values())s.has(r)||(o.updated.has(r)?s.add(r):n.add(r));for(const r of o.added.values())s.has(r)||u.added.has(r)&&p.updated.has(r)&&s.add(r);for(const r of u.added.values())s.has(r)||(o.added.has(r)?p.updated.has(r)&&s.add(r):i.add(r));for(const r of o.updated.values())s.has(r)||u.updated.has(r)&&p.updated.has(r)&&s.add(r);for(const r of u.updated.values())s.has(r)||(o.updated.has(r)?p.updated.has(r)&&s.add(r):t.add(r));return{added:i,removed:n,updated:t,conflicts:s}}function I(p,o,u,i){const n=new Set,t=$(p,i),s=$(o,i),r=u?$(u,i):null,a=g(t,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const h=r?g(r,t):{added:[...t.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?g(r,s):{added:[...s.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:L,removed:S,updated:v,conflicts:T}=b(a,h,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:L,removed:S,updated:v,conflicts:T}}function $(p,o){const u=new Map;for(const i of p){const n=o[i.key];let t=u.get(n);t||(t=[],u.set(n,t)),t.push(i)}return u}function d(p){const o=new Map;for(const u of p){const i=u.command[0]==="-"?u.command.substring(1):u.command;let n=o.get(i);n||(n=[],o.set(i,n)),n.push(u)}return o}function g(p,o){const u=[...p.keys()],i=[...o.keys()],n=i.filter(r=>!u.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=u.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=new Set;for(const r of u){if(t.has(r))continue;const a=p.get(r).map(y=>({...y,key:r})),h=o.get(r).map(y=>({...y,key:r}));(0,R.$tb)(a,h,(y,L)=>E(y,L))||s.add(r)}return{added:n,removed:t,updated:s}}function l(p,o,u){const i=[...p.keys()],n=[...o.keys()],t=n.filter(a=>!i.includes(a)).reduce((a,h)=>(a.add(h),a),new Set),s=i.filter(a=>!n.includes(a)).reduce((a,h)=>(a.add(h),a),new Set),r=new Set;for(const a of i){if(s.has(a))continue;const h=p.get(a).map(L=>({...L,key:u[L.key]})),y=o.get(a).map(L=>({...L,key:u[L.key]}));m(h,y)||r.add(a)}return{added:t,removed:s,updated:r}}function m(p,o){return!(!(0,R.$tb)(p.filter(({command:u})=>u[0]!=="-"),o.filter(({command:u})=>u[0]!=="-"),(u,i)=>E(u,i))||!(0,R.$tb)(p.filter(({command:u})=>u[0]==="-"),o.filter(({command:u})=>u[0]==="-"),(u,i)=>E(u,i)))}function E(p,o){if(p.command!==o.command||p.key!==o.key)return!1;const u=A.$Aj.deserialize(p.when),i=A.$Aj.deserialize(o.when);return!(u&&!i||!u&&i||u&&i&&!u.equals(i)||!C.$fo(p.args,o.args))}function f(p,o,u){for(const i of o)p=N.edit(p,[-1],i,u);return p}function w(p,o,u){const i=O(p);for(let n=i.length-1;n>=0;n--)(i[n].command===o||i[n].command===`-${o}`)&&(p=N.edit(p,[n],void 0,u));return p}function P(p,o,u,i){const n=O(p),t=n.findIndex(s=>s.command===o||s.command===`-${o}`);for(let s=n.length-1;s>=0;s--)(n[s].command===o||n[s].command===`-${o}`)&&(p=N.edit(p,[s],void 0,i));for(let s=u.length-1;s>=0;s--)p=N.edit(p,[t],u[s],i);return p}}),define(he[208],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=R,e.$tcc=C;function R(A,N,O){const k={},b={},I=new Set;if(!N)return{local:{added:k,updated:b,removed:[...I.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const $=c(A,N);if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{local:{added:k,updated:b,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=c(O,A),g=c(O,N),l={},m={},E=new Set,f=new Set;for(const w of d.removed.values())g.updated.has(w)?k[w]=N[w]:E.add(w);for(const w of g.removed.values())f.has(w)||(d.updated.has(w)?f.add(w):I.add(w));for(const w of d.updated.values())f.has(w)||(g.updated.has(w)?$.updated.has(w)&&f.add(w):m[w]=A[w]);for(const w of g.updated.values())f.has(w)||(d.updated.has(w)?$.updated.has(w)&&f.add(w):A[w]!==void 0&&(b[w]=N[w]));for(const w of d.added.values())f.has(w)||(g.added.has(w)?$.updated.has(w)&&f.add(w):l[w]=A[w]);for(const w of g.added.values())f.has(w)||(d.added.has(w)?$.updated.has(w)&&f.add(w):k[w]=N[w]);return{local:{added:k,removed:[...I.values()],updated:b},remote:{added:l,removed:[...E.values()],updated:m},conflicts:[...f.values()]}}function c(A,N){const O=A?Object.keys(A):[],k=N?Object.keys(N):[],b=k.filter(d=>!O.includes(d)).reduce((d,g)=>(d.add(g),d),new Set),I=O.filter(d=>!k.includes(d)).reduce((d,g)=>(d.add(g),d),new Set),$=new Set;for(const d of O){if(I.has(d))continue;const g=A[d],l=N[d];g!==l&&$.add(d)}return{added:b,removed:I,updated:$}}function C(A,N){const{added:O,removed:k,updated:b}=c(A,N);return O.size===0&&k.size===0&&b.size===0}}),define(he[209],ue([0,1,29]),function(oe,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=c;function c(A,N,O,k){const b={added:[],removed:[],updated:[]};let I={added:[],removed:[],updated:[]};if(!N){const d=A.filter(({id:g})=>!k.includes(g));return d.length?I.added=d:I=null,{local:b,remote:I}}const $=C(A,N,k);if($.added.length>0||$.removed.length>0||$.updated.length>0){const d=C(O,A,k),g=C(O,N,k);for(const l of g.removed){const m=A.find(E=>E.id===l);m&&b.removed.push(m)}for(const l of g.added){const m=N.find(E=>E.id===l);d.added.includes(l)?$.updated.includes(l)&&b.updated.push(m):b.added.push(m)}for(const l of g.updated)b.updated.push(N.find(m=>m.id===l));for(const l of d.added)g.added.includes(l)||I.added.push(A.find(m=>m.id===l));for(const l of d.updated)g.removed.includes(l)||g.updated.includes(l)||I.updated.push(A.find(m=>m.id===l));for(const l of d.removed){const m=N.find(E=>E.id===l);m&&I.removed.push(m)}}return I.added.length===0&&I.removed.length===0&&I.updated.length===0&&(I=null),{local:b,remote:I}}function C(A,N,O){A=A?A.filter(({id:g})=>!O.includes(g)):[],N=N.filter(({id:g})=>!O.includes(g));const k=A.map(({id:g})=>g),b=N.map(({id:g})=>g),I=b.filter(g=>!k.includes(g)),$=k.filter(g=>!b.includes(g)),d=[];for(const{id:g,name:l,shortName:m,icon:E,useDefaultFlags:f}of A){if($.includes(g))continue;const w=N.find(P=>P.id===g);(!w||w.name!==l||w.shortName!==m||w.icon!==E||!(0,R.$fo)(w.useDefaultFlags,f))&&d.push(g)}return{added:I,removed:$,updated:d}}}),define(he[24],ue([0,1,17,12,11,47,27,4,103,44]),function(oe,e,R,c,C,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnb=e.$Mnb=e.$Lnb=e.$Knb=e.$Jnb=e.$Inb=e.$Hnb=e.$Gnb=e.$Fnb=e.$Dnb=e.MergeState=e.Change=e.SyncStatus=e.$Cnb=e.$Bnb=e.$Anb=e.UserDataSyncErrorCode=e.$ynb=e.$xnb=e.$wnb=e.$vnb=e.$unb=e.$rnb=e.SyncResource=e.$onb=e.$nnb=void 0,e.$knb=I,e.$lnb=$,e.$mnb=d,e.$pnb=l,e.$qnb=m,e.$snb=f,e.$tnb=w,e.$znb=P,e.$Enb=r;function I(){const a=b.$oo.as(A.$to.Configuration).getConfigurationProperties();return Object.keys(a).filter(h=>!!a[h].disallowSyncIgnore)}function $(a=!1){const h=b.$oo.as(A.$to.Configuration).getConfigurationProperties(),y=g(h,a),L=I();return(0,R.$Lb)([...y,...L])}function d(a){if(!a.contributes?.configuration)return[];const h=Array.isArray(a.contributes.configuration)?a.contributes.configuration:[a.contributes.configuration];if(!h.length)return[];const y=(0,A.$Jo)(h);return g(y,!1)}function g(a,h){const y=new Set;for(const L in a){if(h&&a[L].source)continue;const S=(0,c.$cg)(a[L].scope)?(0,A.$Ko)(a[L].scope):a[L].scope;(a[L].ignoreSync||S===A.ConfigurationScope.MACHINE||S===A.ConfigurationScope.MACHINE_OVERRIDABLE)&&y.add(L)}return[...y.values()]}e.$nnb="settingsSync",e.$onb="settingsSync.keybindingsPerPlatform";function l(){const a="vscode://schemas/ignoredSettings",h=b.$oo.as(A.$to.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,C.localize)(10925,null),type:"object",properties:{[e.$onb]:{type:"boolean",description:(0,C.localize)(10926,null),default:!0,scope:A.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,C.localize)(10927,null),items:[{type:"string",pattern:N.$8o,errorMessage:(0,C.localize)(10928,null)}],default:[],scope:A.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,C.localize)(10929,null),default:[],scope:A.ConfigurationScope.APPLICATION,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=b.$oo.as(k.$po.JSONContribution),L=()=>{const S=I(),v=$(),T=Object.keys(A.$uo.properties).filter(j=>!v.includes(j)),U=v.filter(j=>!S.includes(j)),F={items:{type:"string",enum:[...T,...U.map(j=>`-${j}`)]}};y.registerSchema(a,F)};return h.onDidUpdateConfiguration(()=>L())}function m(a){return a&&(0,c.$eg)(a)&&(0,c.$cg)(a.id)&&Array.isArray(a.scopes)}var E;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Tasks="tasks",a.Extensions="extensions",a.GlobalState="globalState",a.Profiles="profiles",a.WorkspaceState="workspaceState"})(E||(e.SyncResource=E={})),e.$rnb=[E.Settings,E.Keybindings,E.Snippets,E.Tasks,E.Extensions,E.GlobalState,E.Profiles];function f(a,...h){return a?[a,...h]:h}function w(a,h,y,L){return L.joinPath(y.userDataSyncHome,...f(a,h,`lastSync${h}.json`))}e.$unb=(0,O.$Ci)("IUserDataSyncStoreManagementService"),e.$vnb=(0,O.$Ci)("IUserDataSyncStoreService"),e.$wnb=(0,O.$Ci)("IUserDataSyncLocalStoreService"),e.$xnb="x-operation-id",e.$ynb="X-Execution-Id";function P(a){const h={};return h[e.$ynb]=a,h}var p;(function(a){a.Unauthorized="Unauthorized",a.Forbidden="Forbidden",a.NotFound="NotFound",a.MethodNotFound="MethodNotFound",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.RequestProtocolNotSupported="RequestProtocolNotSupported",a.RequestPathNotEscaped="RequestPathNotEscaped",a.RequestHeadersNotObject="RequestHeadersNotObject",a.NoCollection="NoCollection",a.NoRef="NoRef",a.EmptyResponse="EmptyResponse",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyProfiles="LocalTooManyProfiles",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.Unknown="Unknown"})(p||(e.UserDataSyncErrorCode=p={}));class o extends Error{constructor(h,y,L,S){super(h),this.code=y,this.resource=L,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Anb=o;class u extends o{constructor(h,y,L,S,v){super(h,L,void 0,v),this.url=y,this.serverCode=S}}e.$Bnb=u;class i extends o{constructor(h,y){super(h,y)}}e.$Cnb=i,function(a){function h(y){if(y instanceof a)return y;const L=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(L&&L[1]){const S=L[2]==="unknown"?void 0:L[2],v=L[3]==="unknown"?void 0:L[3];return new a(y.message,L[1],S,v)}return new a(y.message,p.Unknown)}a.toUserDataSyncError=h}(o||(e.$Anb=o={}));var n;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var t;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(t||(e.Change=t={}));var s;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(s||(e.MergeState=s={})),e.$Dnb="sync.store.url.type";function r(a){return`sync.enable.${a}`}e.$Fnb=(0,O.$Ci)("IUserDataSyncEnablementService"),e.$Gnb=(0,O.$Ci)("IUserDataSyncService"),e.$Hnb=(0,O.$Ci)("IUserDataSyncResourceProviderService"),e.$Inb=(0,O.$Ci)("IUserDataAutoSyncService"),e.$Jnb=(0,O.$Ci)("IUserDataSyncUtilService"),e.$Knb=(0,O.$Ci)("IUserDataSyncLogService"),e.$Lnb="userDataSync",e.$Mnb="vscode-userdata-sync",e.$Nnb="preview"}),define(he[210],ue([0,1,29,24]),function(oe,e,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Nb=C,R=ke(R);function C(N,O,k,b,I){if(!O)return{remote:{added:Object.keys(N),removed:[],updated:[],all:Object.keys(N).length>0?N:null},local:{added:{},removed:[],updated:{}}};const $=A(N,O);if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const d=k?A(k,O):{added:Object.keys(O).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},g=k?A(k,N):{added:Object.keys(N).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},m=R.$bo(O),E=!k;for(const w of g.added.values())w!==c.$Dnb&&E&&d.added.has(w)||(m[w]=N[w]);for(const w of g.updated.values())m[w]=N[w];for(const w of g.removed.values())b.unregistered.includes(w)||delete m[w];for(const w of d.added.values()){const P=O[w];if(b.machine.includes(w)){I.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(k&&g.added.has(w))continue;const p=N[w];p&&p.value===P.value||w===c.$Dnb&&E&&g.added.has(w)||(p?l.updated[w]=P:l.added[w]=P)}for(const w of d.updated.values()){const P=O[w];if(b.machine.includes(w)){I.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(g.updated.has(w)||g.removed.has(w))continue;const p=N[w];p&&p.value===P.value||(l.updated[w]=P)}for(const w of d.removed.values()){if(b.machine.includes(w)){I.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}g.updated.has(w)||g.removed.has(w)||l.removed.push(w)}const f=A(O,m);return{local:l,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:m}}}function A(N,O){const k=Object.keys(N),b=Object.keys(O),I=b.filter(g=>!k.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),$=k.filter(g=>!b.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),d=new Set;for(const g of k){if($.has(g))continue;const l=N[g],m=O[g];R.$fo(l,m)||d.add(g)}return{added:I,removed:$,updated:d}}}),define(he[211],ue([0,1,17,36,64,45,29,81,24]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vMb=b,e.$wMb=d,e.$xMb=g,e.$yMb=l,e.$zMb=E,e.$AMb=w,N=ke(N),O=ke(O);function b(a,h,y){let L=[];y?L=$(y):L=I(h);const S=[],v=[...(0,k.$knb)()];if(Array.isArray(L))for(const T of L)T.startsWith("-")?v.push(T.substring(1)):S.push(T);return(0,R.$Lb)([...a,...S].filter(T=>!v.includes(T)))}function I(a){let h=a.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=a.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:a.getValue("settingsSync.ignoredSettings")||[]}function $(a){const h=(0,c.$Vn)(a);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function d(a,h){const y=(0,c.$Vn)(a)||{};let L="{}";for(const S of Object.keys(y)){const v=(0,C.$0n)(L,[S],y[S],h);L=(0,C.$ao)(L,v)}return L}function g(a,h,y,L){if(y.length){const S=r(h),v=(0,c.$Vn)(h)||{},T=(0,c.$Vn)(a);if(!T)return a;const U=[];for(const F of y){const j=v[F],G=T[F];j===void 0?a=O.edit(a,[F],void 0,L):G!==void 0?a=O.edit(a,[F],j,L):U.push(u(F,S))}U.sort((F,j)=>F.startOffset-j.startOffset),U.forEach(F=>a=w(F.setting.key,h,a,L))}return a}function l(a,h,y,L,S,v){const T=g(a,h,L,v),U=y!==T,F=y!==h;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:g(h,a,L,v),remoteContent:null,hasConflicts:!1};if(y===null&&E(a)){const D=m(a,h,L)?null:g(h,a,L,v);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let j=a,G=h;const V=(0,c.$Vn)(a),x=(0,c.$Vn)(h),H=y?(0,c.$Vn)(y):null,ie=L.reduce((D,J)=>(D.add(J),D),new Set),z=f(V,x,ie),W=f(H,V,ie),ee=f(H,x,ie),ne=new Map,ce=new Set,te=D=>{ce.add(D);const J=S.filter(({key:q})=>q===D)[0];J?(j=O.edit(j,[D],J.value,v),G=O.edit(G,[D],J.value,v)):ne.set(D,{key:D,localValue:V[D],remoteValue:x[D]})};for(const D of W.removed.values())ee.updated.has(D)?te(D):G=O.edit(G,[D],void 0,v);for(const D of ee.removed.values())ce.has(D)||(W.updated.has(D)?te(D):j=O.edit(j,[D],void 0,v));for(const D of W.updated.values())ce.has(D)||(ee.updated.has(D)?z.updated.has(D)&&te(D):G=O.edit(G,[D],V[D],v));for(const D of ee.updated.values())ce.has(D)||(W.updated.has(D)?z.updated.has(D)&&te(D):j=O.edit(j,[D],x[D],v));for(const D of W.added.values())ce.has(D)||(ee.added.has(D)?z.updated.has(D)&&te(D):G=w(D,j,G,v));for(const D of ee.added.values())ce.has(D)||(W.added.has(D)?z.updated.has(D)&&te(D):j=w(D,G,j,v));const X=ne.size>0||!m(j,G,L),K=X||!m(j,a,[]),B=X||!m(G,h,[]);return{localContent:K?j:null,remoteContent:B?G:null,conflictsSettings:[...ne.values()],hasConflicts:X}}function m(a,h,y){if(a===h)return!0;const L=(0,c.$Vn)(a),S=(0,c.$Vn)(h),v=y.reduce((F,j)=>(F.add(j),F),new Set),T=r(a).filter(F=>!(F.setting&&v.has(F.setting.key))),U=r(h).filter(F=>!(F.setting&&v.has(F.setting.key)));if(T.length!==U.length)return!1;for(let F=0;F<T.length;F++){const j=T[F],G=U[F];if(j.setting&&G.setting){if(j.setting.key!==G.setting.key||!N.$fo(L[j.setting.key],S[j.setting.key]))return!1}else if(!j.setting&&!G.setting){if(j.value!==G.value)return!1}else return!1}return!0}function E(a){return a?r(a).length===0:!0}function f(a,h,y){const L=a?Object.keys(a).filter(F=>!y.has(F)):[],S=Object.keys(h).filter(F=>!y.has(F)),v=S.filter(F=>!L.includes(F)).reduce((F,j)=>(F.add(j),F),new Set),T=L.filter(F=>!S.includes(F)).reduce((F,j)=>(F.add(j),F),new Set),U=new Set;if(a)for(const F of L){if(T.has(F))continue;const j=a[F],G=h[F];N.$fo(j,G)||U.add(F)}return{added:v,removed:T,updated:U}}function w(a,h,y,L){const S=(0,c.$Vn)(h),v=r(h),T=r(y),U=P(a,v,T);return p(y,a,S[a],U,T,L)}function P(a,h,y){const L=h.findIndex(v=>v.setting?.key===a),S=h[L-1];if(S){if(S.setting){const T=u(S.setting.key,y);if(T)return{index:y.indexOf(T),insertAfter:!0}}else{const T=i(L,h);if(T){const U=u(T.setting.key,y);if(U){const F=n(y.indexOf(U),y),j=t(h,T,h[L]);if(F){const G=t(y,U,F),V=s(j,G);return V?{index:y.indexOf(V),insertAfter:!0}:{index:y.indexOf(F),insertAfter:!1}}else{const G=t(y,U,y[y.length-1]),V=s(j,G);return V?{index:y.indexOf(V),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const v=h[L+1];if(v)if(v.setting){const T=u(v.setting.key,y);if(T)return{index:y.indexOf(T),insertAfter:!1}}else{const T=n(L,h);if(T){const U=u(T.setting.key,y);if(U){const F=i(y.indexOf(U),y),j=t(h,h[L],T);if(F){const G=t(y,F,U),V=s(j.reverse(),G.reverse());return V?{index:y.indexOf(V),insertAfter:!1}:{index:y.indexOf(F),insertAfter:!0}}else{const G=t(y,y[0],U),V=s(j.reverse(),G.reverse());return V?{index:y.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function p(a,h,y,L,S,v){let T;return L.index===-1?T=(0,C.$0n)(a,[h],y,v):T=o(a,h,y,L,S,v).map(U=>(0,C.$$n)(a,U,v)[0]),(0,C.$ao)(a,T)}function o(a,h,y,L,S,v){const T=`${JSON.stringify(h)}: ${JSON.stringify(y)}`,U=(0,A.$7n)(v,a),F=S[L.index];if(L.insertAfter){const j=[];if(F.setting)j.push({offset:F.endOffset,length:0,content:","+T});else{const G=n(L.index,S),V=i(L.index,S),x=V?.setting?.commaOffset;V&&x===void 0&&j.push({offset:V.endOffset,length:0,content:","});const H=x!==void 0&&x>F.endOffset;j.push({offset:H?x+1:F.endOffset,length:0,content:G?U+T+",":U+T})}return j}else{if(F.setting)return[{offset:F.startOffset,length:0,content:T+","}];const j=(S[L.index-1]&&!S[L.index-1].setting?U:"")+T+(n(L.index,S)?",":"")+U;return[{offset:F.startOffset,length:0,content:j}]}}function u(a,h){return h.filter(y=>y.setting?.key===a)[0]}function i(a,h){for(let y=a-1;y>=0;y--)if(h[y].setting)return h[y]}function n(a,h){for(let y=a+1;y<h.length;y++)if(h[y].setting)return h[y]}function t(a,h,y){const L=a.indexOf(h),S=a.indexOf(y);return a.filter((v,T)=>L<T&&T<S)}function s(a,h){if(a.length&&h.length){let y=0;for(;y<h.length&&y<a.length;y++)if(a[y].value!==h[y].value)return h[y-1];return h[y-1]}}function r(a){const h=[];let y=-1,L,S;const v={onObjectBegin:T=>{y++},onObjectProperty:(T,U,F)=>{y===0&&(L=U,S=T)},onObjectEnd:(T,U)=>{y--,y===0&&h.push({startOffset:L,endOffset:T+U,value:a.substring(L,T+U),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(T,U)=>{y++},onArrayEnd:(T,U)=>{y--,y===0&&h.push({startOffset:L,endOffset:T+U,value:a.substring(L,T+U),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(T,U,F)=>{y===0&&h.push({startOffset:L,endOffset:U+F,value:a.substring(L,U+F),setting:{key:S,commaOffset:void 0}})},onSeparator:(T,U,F)=>{if(y===0&&T===","){let j=h.length-1;for(;j>=0&&!h[j].setting;j--);const G=h[j];G&&h.splice(j,1,{startOffset:G.startOffset,endOffset:G.endOffset,value:G.value,setting:{key:G.setting.key,commaOffset:U}})}},onComment:(T,U)=>{y===0&&h.push({startOffset:T,endOffset:T+U,value:a.substring(T,T+U)})}};return(0,c.$3n)(a,v),h}}),define(he[82],ue([0,1,3,2,4,24]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gMb=e.$fMb=void 0,e.$fMb=(0,C.$Ci)("IUserDataSyncAccountService");let N=class extends c.$Tc{get account(){return this.a}constructor(k,b){super(),this.g=k,this.h=b,this.b=this.B(new R.$je),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.$je),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(I=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,I),this.updateAccount(void 0),I===A.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$gMb=N,e.$gMb=N=ve([Z(0,A.$vnb),Z(1,A.$Knb)],N)}),define(he[212],ue([0,1,20,11,15,10,24]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LOb=void 0;let O=class extends A.$ck{constructor(b,I){super(),this.g=this.B(b.createLogger((0,R.$dh)(I.logsHome,`${N.$Lnb}.log`),{id:N.$Lnb,name:(0,c.localize)(10924,null)}))}trace(b,...I){this.g.trace(b,...I)}debug(b,...I){this.g.debug(b,...I)}info(b,...I){this.g.info(b,...I)}warn(b,...I){this.g.warn(b,...I)}error(b,...I){this.g.error(b,...I)}flush(){this.g.flush()}};e.$LOb=O,e.$LOb=O=ve([Z(0,A.$$j),Z(1,C.$Ji)],O)}),define(he[213],ue([0,1,6,3,2]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;class A extends C.$Tc{constructor({onDidOpenMainWindow:O,onDidFocusMainWindow:k,getActiveWindowId:b}){super(),this.a=this.B(new C.$Sc),c.Event.latch(c.Event.any(O,k))(this.f,this,this.a),this.b=(0,R.$ph)(()=>b()),(async()=>{try{const $=await this.b;this.c=typeof this.c=="number"?this.c:$}catch{}finally{this.b=void 0}})()}f(O){this.b&&(this.b.cancel(),this.b=void 0),this.c=O}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Hgc=A}),define(he[115],ue([0,1,11,13,51,20,9,4,22]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=b,e.$Ni=I,e.$Qi=$,e.$Ri=d,e.$Si=g,e.$Ti=m,e.$Ui=E,e.$Xi=P,e.$3i=p,e.$4i=o,e.$6i=u,e.$7i=i,e.$8i=n,e.$Li=(0,O.$Ci)("contextService");function b(t){const s=t;return typeof s?.id=="string"&&N.URI.isUri(s.uri)}function I(t){return typeof t?.id=="string"&&!b(t)&&!d(t)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function $(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,c.$mc)(t)}:s?e.$Oi:e.$Pi;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function d(t){const s=t;return typeof s?.id=="string"&&N.URI.isUri(s.configPath)}function g(t){const s=t;if(s?.uri)return{id:s.id,uri:N.URI.revive(s.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function m(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function E(t){const s=t;return!!(s&&typeof s=="object"&&N.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class f{constructor(s,r,a,h,y){this.h=s,this.j=a,this.k=h,this.l=y,this.c=C.$Ii.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=C.$Ii.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=f;class w{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$dh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=w;function P(t){return new w({uri:t,index:0,name:(0,A.$_g)(t)},{uri:t.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,R.localize)(10895,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function p(t,s){return A.$7g.isEqualOrParent(t,s.untitledWorkspacesHome)}function o(t){let s;return N.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===k.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function u(t){return t.id===e.$5i}function i(t,s){return!p(t,s)&&!o(t)}function n(t){return(typeof t=="string"?(0,c.$nc)(t):(0,A.$bh)(t))===e.$Zi}}),define(he[19],ue([0,1,55,3,2,20,9,11,15,7,4,10,115,31,28,6,32,26,12]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Jl=e.ProfileResourceType=void 0,e.$Il=p,e.$Kl=o,e.$Ll=u;var P;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function p(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&N.URI.isUri(s.location)&&N.URI.isUri(s.globalStorageHome)&&N.URI.isUri(s.settingsResource)&&N.URI.isUri(s.keybindingsResource)&&N.URI.isUri(s.tasksResource)&&N.URI.isUri(s.snippetsHome)&&N.URI.isUri(s.extensionsResource))}e.$Jl=(0,I.$Ci)("IUserDataProfilesService");function o(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:N.URI.revive(t.location).with({scheme:s}),globalStorageHome:N.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:N.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:N.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:N.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:N.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:N.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:N.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function u(t,s,r,a,h,y){return{id:t,name:s,location:r,isDefault:!1,shortName:h?.shortName,icon:h?.icon,globalStorageHome:y&&h?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$dh)(r,"globalStorage"),settingsResource:y&&h?.useDefaultFlags?.settings?y.settingsResource:(0,A.$dh)(r,"settings.json"),keybindingsResource:y&&h?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$dh)(r,"keybindings.json"),tasksResource:y&&h?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$dh)(r,"tasks.json"),snippetsHome:y&&h?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$dh)(r,"snippets"),extensionsResource:y&&h?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$dh)(r,"extensions.json"),cacheHome:(0,A.$dh)(a,t),useDefaultFlags:h?.useDefaultFlags,isTransient:h?.transient}}let i=class extends C.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,r,a,h){super(),this.t=s,this.u=r,this.w=a,this.y=h,this.f=!0,this.h=this.B(new c.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new c.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new c.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new c.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new g.$zc,workspaces:new g.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),r=[s];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,w.$cg)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(u((0,A.$ah)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},s))}}catch(y){this.y.error(y)}const a=new g.$zc,h=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[L,S]of Object.entries(y.workspaces)){const v=N.URI.parse(L),T=r.find(U=>U.id===S);T&&a.set(v,T)}if(y.emptyWindows)for(const[L,S]of Object.entries(y.emptyWindows)){const v=r.find(T=>T.id===S);v&&h.set(L,v)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:a,emptyWindows:h}}return this.z}D(){const s=u("__default__profile__",(0,O.localize)(10942,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",a=new RegExp(`${(0,f.$ff)(r)}\\s(\\d+)`);let h=0;for(const L of this.profiles){const S=a.exec(L.name),v=S?parseInt(S[1]):0;h=v>h?v:h}const y=`${r} ${h+1}`;return this.createProfile((0,R.$qj)((0,E.$Yg)()).toString(16),y,{transient:!0},s)}async createNamedProfile(s,r,a){return this.createProfile((0,R.$qj)((0,E.$Yg)()).toString(16),s,r,a)}async createProfile(s,r,a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(s,r,a);return h&&await this.setProfileForWorkspace(h,y),y}async F(s,r,a){if(!(0,w.$cg)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let h=this.r.get(r);return h||(h=(async()=>{try{if(this.profiles.find(v=>v.name===r||v.id===s))throw new Error(`Profile with ${r} name already exists`);const L=u(s,r,(0,A.$dh)(this.profilesHome,s),this.g,a,this.defaultProfile);await this.u.createFolder(L.location);const S=[];return this.j.fire({profile:L,join(v){S.push(v)}}),await m.Promises.settled(S),this.I([L],[],[]),L}finally{this.r.delete(r)}})(),this.r.set(r,h)),h}async updateProfile(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(h=>h.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);return a=u(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(h=>h.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const a=[];this.m.fire({profile:r,join(h){a.push(h)}});try{await Promise.allSettled(a)}catch(h){this.y.error(h)}for(const h of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(h)?.id&&this.C.emptyWindows.delete(h);for(const h of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(h)?.id&&this.C.workspaces.delete(h);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(h){(0,b.$ol)(h)!==b.FileOperationResult.FILE_NOT_FOUND&&this.y.error(h)}}async setProfileForWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(h=>h.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(s,a)}unsetWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,r)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.G(s),a=N.URI.isUri(r)?this.C.workspaces.get(r):this.C.emptyWindows.get(r);return a||((0,d.$Mi)(s)?this.s.folders.get(s.uri):(0,d.$Ri)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,d.$Mi)(s)?s.uri:(0,d.$Ri)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.folders.values()].some(r=>this.w.extUri.isEqual(r.location,s.location)))}I(s,r,a){const h=[...this.profiles,...s],y=[],L=this.s.profiles;this.s.profiles=[];for(let S of h){if(S.isDefault||r.some(T=>S.id===T.id))continue;S=a.find(T=>S.id===T.id)??S;const v=L.find(T=>S.id===T.id);if(S.isTransient)this.s.profiles.push(S);else{if(v){for(const[T,U]of this.s.emptyWindows.entries())if(S.id===U.id){this.L({id:T},S);break}for(const[T,U]of this.s.workspaces.entries())if(S.id===U.id){this.L({id:"",configPath:T},S);break}for(const[T,U]of this.s.folders.entries())if(S.id===U.id){this.L({id:"",uri:T},S);break}}y.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags})}}this.P(y),this.z=void 0,this.J(s,r,a)}J(s,r,a){this.h.fire({added:s,removed:r,updated:a,all:this.profiles})}L(s,r,a){if(a=r?.isTransient?!0:a,a)(0,d.$Mi)(s)?(this.s.folders.delete(s.uri),r&&this.s.folders.set(s.uri,r)):(0,d.$Ri)(s)?(this.s.workspaces.delete(s.configPath),r&&this.s.workspaces.set(s.configPath,r)):(this.s.emptyWindows.delete(s.id),r&&this.s.emptyWindows.set(s.id,r));else{this.L(s,void 0,!0);const h=this.G(s);N.URI.isUri(h)?(this.C.workspaces.delete(h),r&&this.C.workspaces.set(h,r)):(this.C.emptyWindows.delete(h),r&&this.C.emptyWindows.set(h,r)),this.M()}}M(){const s={};for(const[a,h]of this.C.workspaces.entries())s[a.toString()]=h.id;const r={};for(const[a,h]of this.C.emptyWindows.entries())r[a.toString()]=h.id;this.R({workspaces:s,emptyWindows:r}),this.z=void 0}N(s){const r={},a=this.D();if(s.workspaces)for(const[y,L]of Object.entries(s.workspaces)){const S=N.URI.parse(L);r[y]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}const h={};if(s.emptyWindows)for(const[y,L]of Object.entries(s.emptyWindows)){const S=N.URI.parse(L);h[y]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:h}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Ml=i,e.$Ml=i=ve([Z(0,k.$Ji),Z(1,b.$0k),Z(2,l.$Hl),Z(3,$.$0j)],i);class n extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Nl=n}),define(he[214],ue([0,1,6,2,19]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;let A=class extends c.$Tc{constructor(O){super(),this.B(new R.$Oh(()=>{O.cleanUp()},10*1e3)).schedule()}};e.$Nhc=A,e.$Nhc=A=ve([Z(0,C.$Jl)],A)}),define(he[83],ue([0,1,17,6,25,8,3,2,31,5,12,9,11,27,35,34,59,10,23,18,28,19]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Cq=void 0,e.$Dq=i,d=ke(d);let u=class extends O.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(r,a,h,y,L,S){super(),this.z=r,this.C=a,this.D=h,this.F=y,this.G=L,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$je),this.s=this.B(new N.$je),this.t=this.B(new N.$je),this.u=this.B(new N.$je),this.w=this.B(new N.$je),this.y=[],this.B((0,O.$Rc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(r){const a=await this.getTargetPlatform();return r.allTargetPlatforms.some(h=>(0,g.$gp)(h,r.allTargetPlatforms,a))}async installFromGallery(r,a={}){try{const y=(await this.installGalleryExtensions([{extension:r,options:a}])).find(({identifier:L})=>(0,l.$Jp)(L,r.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new g.$kp(`Unknown error while installing extension ${r.identifier.id}`,g.ExtensionManagementErrorCode.Unknown)}catch(h){throw i(h)}}async installGalleryExtensions(r){if(!this.z.isEnabled())throw new g.$kp(d.localize(11368,null),g.ExtensionManagementErrorCode.NotAllowed);const a=[],h=[];return await Promise.allSettled(r.map(async({extension:y,options:L})=>{try{const S=await this.N(y,!!L?.installGivenVersion,!!L?.installPreReleaseVersion,L.productVersion??{version:this.G.version,date:this.G.date});h.push({...S,options:L})}catch(S){a.push({identifier:y.identifier,operation:g.InstallOperation.Install,source:y,error:S,profileLocation:L.profileLocation??this.W()})}})),h.length&&a.push(...await this.I(h)),a}async uninstall(r,a){return this.F.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtensions([{extension:r,options:a}])}async toggleAppliationScope(r,a){if((0,m.$rn)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let h=await this.updateMetadata(r,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||(h=await this.Z(r,this.H.defaultProfile.extensionsResource,a));for(const y of this.H.profiles){const L=(await this.getInstalled(m.ExtensionType.User,y.extensionsResource)).find(S=>(0,l.$Jp)(S.identifier,r.identifier));L?this.w.fire({local:L,profileLocation:y.extensionsResource}):this.u.fire({identifier:r.identifier,profileLocation:y.extensionsResource})}return h}else{const h=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(r,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:h.identifier,operation:g.InstallOperation.Install,local:h,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),h}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.g||r-this.h>1e3*60*5)&&(this.g=this.U(),this.h=r),this.g}registerParticipant(r){this.y.push(r)}async resetPinnedStateForAllUserExtensions(r){try{await this.L(this.H.profiles.map(async a=>{const h=await this.getInstalled(m.ExtensionType.User,a.extensionsResource);await this.L(h.map(async y=>{y.pinned!==r&&await this.updateMetadata(y,{pinned:r},a.extensionsResource)}))}))}catch(a){throw this.F.error("Error while resetting pinned state for all user extensions",(0,A.$9)(a)),a}}async I(r){const a=new Map,h=new Map,y=[],L=(v,T)=>`${l.$Kp.create(v).toString()}-${T.toString()}`,S=(v,T,U,F)=>{const j=this.X(v,T,U),G=`${(0,l.$Op)(v.publisher,v.name)}-${U.profileLocation.toString()}`;h.set(G,{task:j,root:F}),this.n.fire({identifier:j.identifier,source:T,profileLocation:U.profileLocation}),this.F.info("Installing extension:",j.identifier.id,U),$.URI.isUri(T)||this.j.set(L(T,U.profileLocation),{task:j,waitingTasks:[]})};try{for(const{manifest:v,extension:T,options:U}of r){const F=U.isApplicationScoped||U.isBuiltin||(0,m.$rn)(v),j={...U,installOnlyNewlyAddedFromExtensionPack:U.installOnlyNewlyAddedFromExtensionPack??!$.URI.isUri(T),isApplicationScoped:F,profileLocation:F?this.H.defaultProfile.extensionsResource:U.profileLocation??this.W(),productVersion:U.productVersion??{version:this.G.version,date:this.G.date}},G=$.URI.isUri(T)?void 0:this.j.get(L(T,j.profileLocation));G?(this.F.info("Extension is already requested to install",G.task.identifier.id,j.profileLocation.toString()),y.push(G.task.waitUntilTaskIsFinished())):S(v,T,j,void 0)}return await Promise.all([...h.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const T=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),U=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),F={...v.options,context:{...v.options.context,[g.$ap]:!0}};for(const{gallery:j,manifest:G}of(0,R.$Lb)(T,({gallery:V})=>V.identifier.id)){if(h.has(`${j.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`))continue;const V=this.j.get(L(j,F.profileLocation));if(V){if(this.J(v,V.task)){const x=V.task.identifier;this.F.info("Waiting for already requested installing extension",x.id,v.identifier.id,F.profileLocation.toString()),V.waitingTasks.push(v),y.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,H=>H.some(ie=>(0,l.$Jp)(ie.identifier,x)))).then(H=>{if(this.F.info("Finished waiting for already requested installing extension",x.id,v.identifier.id,F.profileLocation.toString()),!H.find(z=>(0,l.$Jp)(z.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else U.some(({identifier:x})=>(0,l.$Jp)(x,j.identifier))||S(G,j,F,v)}}catch(T){if($.URI.isUri(v.source))(0,R.$Kb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,T.message),(0,R.$Kb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,T.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),T}})),await this.L([...h.entries()].map(async([v,{task:T}])=>{const U=new Date().getTime();let F;try{F=await T.run(),await this.L(this.y.map(j=>j.postInstall(F,T.source,T.options,C.CancellationToken.None)),g.ExtensionManagementErrorCode.PostInstall)}catch(j){const G=i(j);throw $.URI.isUri(T.source)||n(this.C,T.operation===g.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Rp)(T.source),error:G,source:T.options.context?.[g.$_o]}),a.set(v,{error:G,identifier:T.identifier,operation:T.operation,source:T.source,context:T.options.context,profileLocation:T.options.profileLocation,applicationScoped:T.options.isApplicationScoped}),this.F.error("Error while installing the extension",T.identifier.id,(0,A.$9)(G),T.options.profileLocation.toString()),G}if(!$.URI.isUri(T.source)){const j=T.operation===g.InstallOperation.Update,G=j?void 0:(new Date().getTime()-T.source.lastUpdated)/1e3;if(n(this.C,j?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Rp)(T.source),verificationStatus:T.verificationStatus,duration:new Date().getTime()-U,durationSinceUpdate:G,source:T.options.context?.[g.$_o]}),b.$p&&T.operation!==g.InstallOperation.Update)try{await this.z.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,g.StatisticType.Install)}catch{}}a.set(v,{local:F,identifier:T.identifier,operation:T.operation,source:T.source,context:T.options.context,profileLocation:T.options.profileLocation,applicationScoped:F.isApplicationScoped})})),y.length&&await this.L(y),[...a.values()]}catch(v){const T=(j,G,V)=>{const x=[];j.manifest.extensionDependencies?.length&&x.push(...j.manifest.extensionDependencies),j.manifest.extensionPack?.length&&x.push(...j.manifest.extensionPack);for(const H of x){if(V.includes(H.toLowerCase()))continue;V.push(H.toLowerCase());const ie=a.get(`${H.toLowerCase()}-${G.toString()}`);ie?.local&&(V=T(ie.local,G,V))}return V},U=j=>({identifier:j.identifier,operation:g.InstallOperation.Install,source:j.source,context:j.options.context,profileLocation:j.options.profileLocation,error:v}),F=[];for(const[j,{task:G,root:V}]of h){const x=a.get(j);x?x.local&&V&&!a.get(`${V.identifier.id.toLowerCase()}-${G.options.profileLocation.toString()}`)?.local&&(F.push(this.Y(x.local,{versionOnly:!0,profileLocation:G.options.profileLocation})),a.set(j,U(G))):(G.cancel(),a.set(j,U(G)))}for(const[j,{task:G}]of h){const V=a.get(j);if(!V?.local||G.options.donotIncludePackAndDependencies)continue;T(V.local,G.options.profileLocation,[V.local.identifier.id.toLowerCase()]).slice(1).some(H=>h.has(`${H.toLowerCase()}-${G.options.profileLocation.toString()}`)&&!a.get(`${H.toLowerCase()}-${G.options.profileLocation.toString()}`)?.local)&&(F.push(this.Y(V.local,{versionOnly:!0,profileLocation:G.options.profileLocation})),a.set(j,U(G)))}throw F.length&&await Promise.allSettled(F.map(async j=>{try{await j.run(),this.F.info("Rollback: Uninstalled extension",j.extension.identifier.id)}catch(G){this.F.warn("Rollback: Error while uninstalling extension",j.extension.identifier.id,(0,A.$9)(G))}})),v}finally{for(const{task:v}of h.values())v.source&&!$.URI.isUri(v.source)&&this.j.delete(L(v.source,v.options.profileLocation));if(a.size){const v=[...a.values()];for(const T of v)T.local&&this.F.info("Extension installed successfully:",T.identifier.id,T.profileLocation.toString());this.s.fire(v)}}}J(r,a){for(const[,{task:h,waitingTasks:y}]of this.j.entries())if(h===r&&(y.includes(a)||y.some(L=>this.J(L,a)))||h===a&&y[0]&&!this.J(r,y[0]))return!1;return!0}async L(r,a){const h=[],y=[],L=await Promise.allSettled(r);for(const v of L)v.status==="fulfilled"?h.push(v.value):y.push(i(v.reason,a));if(!y.length)return h;if(y.length===1)throw y[0];let S=new g.$kp("",g.ExtensionManagementErrorCode.Unknown);for(const v of y)S=new g.$kp(S.message?`${S.message}, ${v.message}`:v.message,v.code!==g.ExtensionManagementErrorCode.Unknown&&v.code!==g.ExtensionManagementErrorCode.Internal?v.code:S.code);throw S}async M(r,a,h,y,L,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,L,S),T=[],U=[],F=async(j,G)=>{T.push(j);const V=G.extensionDependencies||[],x=[...V];if(G.extensionPack){const H=h?v.find(ie=>(0,l.$Jp)(ie.identifier,j)):void 0;for(const ie of G.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(z=>(0,l.$Jp)({id:z},{id:ie}))||x.every(z=>!(0,l.$Jp)({id:z},{id:ie}))&&x.push(ie)}if(x.length){const H=x.filter(ie=>T.every(z=>!(0,l.$Jp)(z,{id:ie})));if(H.length){const ie=await this.z.getExtensions(H.map(z=>({id:z,preRelease:y})),C.CancellationToken.None);for(const z of ie){if(T.find(ne=>(0,l.$Jp)(ne,z.identifier)))continue;const W=V.some(ne=>(0,l.$Jp)({id:ne},z.identifier));let ee;try{ee=await this.N(z,!1,y,S)}catch(ne){if(W)throw ne;this.F.info("Skipping the packed extension as it cannot be installed",z.identifier.id,(0,A.$9)(ne));continue}U.push({gallery:ee.extension,manifest:ee.manifest}),await F(ee.extension.identifier,ee.manifest)}}}};return await F(r,a),U}async N(r,a,h,y){let L;const S=await this.getExtensionsControlManifest();if(S.malicious.some(U=>(0,l.$Jp)(r.identifier,U)))throw new g.$kp(d.localize(11369,null,r.identifier.id),g.ExtensionManagementErrorCode.Malicious);const v=S.deprecated[r.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),L=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},C.CancellationToken.None))[0],!L)throw new g.$kp(d.localize(11370,null,r.identifier.id,v.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const U=await this.getTargetPlatform();throw new g.$kp(d.localize(11371,null,r.identifier.id,this.G.nameLong,(0,g.$cp)(U)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(L=await this.O(r,a,h,y),!L){const U=[];throw(0,E.$4p)(r.properties.enabledApiProposals??[],U)?!h&&r.properties.isPreReleaseVersion&&(await this.z.getExtensions([r.identifier],C.CancellationToken.None))[0]?new g.$kp(d.localize(11373,null,r.displayName??r.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$kp(d.localize(11374,null,r.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible):new g.$kp(d.localize(11372,null,r.displayName??r.identifier.id,U[0]),g.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",L.identifier.id);const T=await this.z.getManifest(L,C.CancellationToken.None);if(T===null)throw new g.$kp(`Missing manifest for extension ${L.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(T.version!==L.version)throw new g.$kp(`Cannot install '${L.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:L,manifest:T}}async O(r,a,h,y){const L=await this.getTargetPlatform();let S=null;return!a&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==h&&(S=(await this.z.getExtensions([{...r.identifier,preRelease:h}],{targetPlatform:L,compatible:!0,productVersion:y},C.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(r,h,L,y)&&(S=r),S||(a?S=(await this.z.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:L,compatible:!0,productVersion:y},C.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(r,h,L,y)),S}async uninstallExtensions(r){const a=(U,F)=>`${U.identifier.id.toLowerCase()}${F.versionOnly?`-${U.manifest.version}`:""}@${F.profileLocation.toString()}`,h=(U,F)=>{const j=this.Y(U,F);return this.m.set(a(j.extension,F),j),this.F.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString()),this.t.fire({identifier:U.identifier,profileLocation:F.profileLocation,applicationScoped:U.isApplicationScoped}),j},y=(U,F,j)=>{j?this.F.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString(),j.message):this.F.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString()),n(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Qp)(U),error:j}),this.u.fire({identifier:U.identifier,error:j?.code,profileLocation:F.profileLocation,applicationScoped:U.isApplicationScoped})},L=[],S=[],v=[],T=new k.$zc;for(const{extension:U,options:F}of r){const j={...F,profileLocation:U.isApplicationScoped?this.H.defaultProfile.extensionsResource:F?.profileLocation??this.W()},G=this.m.get(a(U,j));G?(this.F.info("Extensions is already requested to uninstall",U.identifier.id),v.push(G.waitUntilTaskIsFinished())):L.push(h(U,j))}try{for(const U of L.slice(0)){let F=T.get(U.options.profileLocation);if(F||T.set(U.options.profileLocation,F=await this.getInstalled(m.ExtensionType.User,U.options.profileLocation)),U.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${U.extension.identifier.id}@${U.extension.manifest.version}`);else{const j=this.R(U.extension,F);for(const G of j)this.m.has(a(G,U.options))?this.F.info("Extensions is already requested to uninstall",G.identifier.id):L.push(h(G,U.options))}U.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${U.extension.identifier.id}@${U.extension.manifest.version}`):this.P(L.map(j=>j.extension),F,U.extension)}await this.L(L.map(async U=>{try{if(await U.run(),await this.L(this.y.map(F=>F.postUninstall(U.extension,U.options,C.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,g.StatisticType.Uninstall)}catch{}}catch(F){const j=i(F);throw y(U.extension,U.options,j),j}finally{S.push(U)}})),v.length&&await this.L(v);for(const U of L)y(U.extension,U.options)}catch(U){const F=i(U);for(const j of L){try{j.cancel()}catch{}S.includes(j)||y(j.extension,j.options,F)}throw F}finally{for(const U of L)this.m.delete(a(U.extension,U.options))||this.F.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}P(r,a,h){for(const y of r){const L=this.S(y,a);if(L.length){const S=L.filter(v=>!r.some(T=>(0,l.$Jp)(T.identifier,v.identifier)));if(S.length)throw new Error(this.Q(y,S,h))}}}Q(r,a,h){return h===r?a.length===1?d.localize(11375,null,h.manifest.displayName||h.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?d.localize(11376,null,h.manifest.displayName||h.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):d.localize(11377,null,h.manifest.displayName||h.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?d.localize(11378,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?d.localize(11379,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):d.localize(11380,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}R(r,a,h=[]){if(h.indexOf(r)!==-1)return[];h.push(r);const y=r.manifest.extensionPack?r.manifest.extensionPack:[];if(y.length){const L=a.filter(v=>!v.isBuiltin&&y.some(T=>(0,l.$Jp)({id:T},v.identifier))),S=[];for(const v of L)S.push(...this.R(v,a,h));return[...L,...S]}return[]}S(r,a){return a.filter(h=>h.manifest.extensionDependencies&&h.manifest.extensionDependencies.some(y=>(0,l.$Jp)({id:y},r.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(r){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$9)(r)),{malicious:[],deprecated:{},search:[]}}}};e.$Cq=u,e.$Cq=u=ve([Z(0,g.$ip),Z(1,P.$9l),Z(2,p.$Hl),Z(3,f.$0j),Z(4,w.$qk),Z(5,o.$Jl)],u);function i(s,r){if(s instanceof g.$kp)return s;let a;return s instanceof g.$jp?a=new g.$kp(s.message,s.code===g.ExtensionGalleryErrorCode.DownloadFailedWriting?g.ExtensionManagementErrorCode.DownloadFailedWriting:g.ExtensionManagementErrorCode.Gallery):a=new g.$kp(s.message,(0,A.$3)(s)?g.ExtensionManagementErrorCode.Cancelled:r??g.ExtensionManagementErrorCode.Internal),a.stack=s.stack,a}function n(s,r,{extensionData:a,verificationStatus:h,duration:y,error:L,source:S,durationSinceUpdate:v}){let T,U;(0,I.$kg)(h)&&(h===!0?h="Verified":(h===!1||(T=g.ExtensionManagementErrorCode.Signature,U=h),h="Unverified")),L&&(T=L.code,L.code===g.ExtensionManagementErrorCode.Signature&&(U=L.message)),s.publicLog(r,{...a,verificationStatus:h,success:!L,duration:y,errorcode:T,errorcodeDetail:U,durationSinceUpdate:v,source:S})}class t{constructor(){this.d=new c.$Bh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,c.$ph)(r=>this.h(r))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,c.$ph)(r=>new Promise((a,h)=>{const y=r.onCancellationRequested(()=>{y.dispose(),h(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$Eq=t}),define(he[52],ue([0,1,6,14,2,3,31,9,27,35,7,4,10,19,28,12,8,18]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class P extends Error{constructor(n,t){super(n),this.code=t}}e.$Fq=P,e.$Gq=(0,$.$Ci)("IExtensionsProfileScannerService");let p=class extends C.$Tc{constructor(n,t,s,r,a,h){super(),this.j=n,this.m=t,this.n=s,this.r=r,this.s=a,this.t=h,this.b=this.B(new A.$je),this.onAddExtensions=this.b.event,this.c=this.B(new A.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$je),this.onDidRemoveExtensions=this.g.event,this.h=new N.$zc}scanProfileExtensions(n,t){return this.u(n,void 0,t)}async addExtensionsToProfile(n,t,s){const r=[],a=[];try{return await this.u(t,h=>{const y=[];if(s)y.push(...h);else for(const L of h)n.some(([S])=>(0,b.$Jp)(S.identifier,L.identifier)&&S.manifest.version!==L.version)?r.push(L):y.push(L);for(const[L,S]of n){const v=y.findIndex(U=>(0,b.$Jp)(U.identifier,L.identifier)&&U.version===L.manifest.version),T={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:S};v===-1?(a.push(T),y.push(T)):y.splice(v,1,T)}return a.length&&this.b.fire({extensions:a,profileLocation:t}),r.length&&this.f.fire({extensions:r,profileLocation:t}),y}),a.length&&this.c.fire({extensions:a,profileLocation:t}),r.length&&this.g.fire({extensions:r,profileLocation:t}),a}catch(h){throw a.length&&this.c.fire({extensions:a,error:h,profileLocation:t}),r.length&&this.g.fire({extensions:r,error:h,profileLocation:t}),h}}async updateMetadata(n,t){const s=[];return await this.u(t,r=>{const a=[];for(const h of r){const y=n.find(([L])=>(0,b.$Jp)(L.identifier,h.identifier)&&L.manifest.version===h.version);y&&(h.metadata={...h.metadata,...y[1]},s.push(h)),a.push(h)}return a}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.u(t,r=>{const a=[];for(const h of r)(0,b.$Jp)(h.identifier,n.identifier)?s.push(h):a.push(h);return s.length&&this.f.fire({extensions:s,profileLocation:t}),a}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:t}),r}}async u(n,t,s){return this.F(n).queue(async()=>{let r=[],a;try{const h=await this.m.readFile(n);a=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,I.$ol)(h)!==I.FileOperationResult.FILE_NOT_FOUND)throw h;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&s?.bailOutWhenFileNotFound)throw new P((0,E.$9)(h),w.ERROR_PROFILE_NOT_FOUND)}if(a){Array.isArray(a)||this.w(n);let h=!1;for(const y of a){o(y)||this.w(n);let L;if((0,m.$cg)(y.relativeLocation)&&y.relativeLocation)L=this.z(y.relativeLocation);else if((0,m.$cg)(y.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${y.location}`);continue}else{L=O.URI.revive(y.location);const S=this.y(L);S&&(h=!0,y.relativeLocation=S)}(0,m.$jg)(y.metadata?.hasPreReleaseVersion)&&y.metadata?.preRelease&&(h=!0,y.metadata.hasPreReleaseVersion=!0),r.push({identifier:y.identifier,location:L,version:y.version,metadata:y.metadata})}h&&await this.m.writeFile(n,c.$Le.fromString(JSON.stringify(a)))}if(t){r=t(r);const h=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(n,c.$Le.fromString(JSON.stringify(h)))}return r})}w(n){const t=new P(`Invalid extensions content in ${n.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(n)).value.toString()}catch(a){if((0,I.$ol)(a)===I.FileOperationResult.FILE_NOT_FOUND)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(s);Array.isArray(a)&&a.every(h=>o(h))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,c.$Le.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,I.$ol)(a)===I.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,I.$ol)(a)!==I.FileOperationResult.FILE_NOT_FOUND&&this.t.error(a)}try{await this.m.del(t)}catch(a){(0,I.$ol)(a)!==I.FileOperationResult.FILE_NOT_FOUND&&this.t.error(a)}return r})()),this.C}F(n){let t=this.h.get(n);return t||(t=new R.$Jh,this.h.set(n,t)),t}};e.$Hq=p,e.$Hq=p=ve([Z(1,I.$0k),Z(2,g.$Jl),Z(3,l.$Hl),Z(4,f.$9l),Z(5,d.$0j)],p);function o(i){return(0,m.$eg)(i)&&(0,k.$hp)(i.identifier)&&(u(i.location)||(0,m.$cg)(i.location)&&i.location)&&((0,m.$jg)(i.relativeLocation)||(0,m.$cg)(i.relativeLocation))&&i.version&&(0,m.$cg)(i.version)}function u(i){return i?(0,m.$cg)(i.path)&&(0,m.$cg)(i.scheme):!1}});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[84],ue([0,1,17,6,29,14,8,36,152,2,22,13,5,20,60,92,12,9,11,15,35,34,59,7,4,10,23,3,66,52,19,28,157]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o,u,i,n,t,s,r,a,h,y,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Mq=e.$Lq=e.$Kq=e.Translations=void 0,e.$Nq=G,C=ke(C),$=ke($),d=ke(d),l=ke(l),m=it(m);var v;(function(x){function H(ie,z){if(ie===z)return!0;const W=Object.keys(ie),ee=new Set;for(const ne of Object.keys(z))ee.add(ne);if(W.length!==ee.size)return!1;for(const ne of W){if(ie[ne]!==z[ne])return!1;ee.delete(ne)}return ee.size===0}x.equals=H})(v||(e.Translations=v={})),e.$Kq=(0,n.$Ci)("IExtensionsScannerService");let T=class extends b.$Tc{constructor(H,ie,z,W,ee,ne,ce,te,X,K,B,D){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=ie,this.r=z,this.s=W,this.t=ee,this.u=ne,this.w=ce,this.y=te,this.z=X,this.C=K,this.D=B,this.F=D,this.g=this.B(new r.$je),this.onDidChangeCache=this.g.event,this.h=(0,g.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(j,this.s,this.h)),this.m=this.B(this.F.createInstance(j,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(o.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(o.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Up)(this.w,this.y)),this.G}async scanAllExtensions(H,ie,z){const[W,ee]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(ie)]),ne=z?await this.scanExtensionsUnderDevelopment(H,[...W,...ee]):[];return this.L(W,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const ie=[];ie.push(this.M(!!H.useCache,H.language)),ie.push(this.N(H.language,!!H.checkControlFile));const[z,W]=await Promise.all(ie);return this.J([...z,...W],o.ExtensionType.System,H,!1)}async scanUserExtensions(H){const ie=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const z=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(ie,!!H.profileLocation,o.ExtensionType.User,!H.includeUninstalled,H.language,!0,z,H.productVersion??this.R()),ee=H.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ne;try{ne=await ee.scanExtensions(W)}catch(ce){if(ce instanceof h.$Fq&&ce.code===h.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ne=await ee.scanExtensions(W);else throw ce}return ne=await this.J(ne,o.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const z=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===I.Schemas.file).map(async W=>{const ee=await this.P(W,!1,o.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ee)).map(ce=>(ce.type=ie.find(te=>(0,p.$Jp)(te.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,ee)))}))).flat();return this.J(z,"development",H,!0)}return[]}async scanExistingExtension(H,ie,z){const W=await this.P(H,!1,ie,!0,z.language,!0,void 0,z.productVersion??this.R()),ee=await this.n.scanExtension(W);return!ee||!z.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(H,ie,z){const W=await this.P(H,!1,ie,!0,z.language,!0,void 0,z.productVersion??this.R()),ee=await this.n.scanOneOrMultipleExtensions(W);return this.J(ee,ie,z,!0)}async scanMultipleExtensions(H,ie,z){const W=[];return await Promise.all(H.map(async ee=>{const ne=await this.scanOneOrMultipleExtensions(ee,ie,z);W.push(...ne)})),this.J(W,ie,z,!0)}async scanMetadata(H){const ie=(0,g.$dh)(H,"package.json"),z=(await this.w.readFile(ie)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(H,ie){const z=(0,g.$dh)(H,"package.json"),W=(await this.w.readFile(z)).value.toString(),ee=JSON.parse(W);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,ee.__metadata={...ee.__metadata,...ie},await this.w.writeFile((0,g.$dh)(H,"package.json"),A.$Le.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof h.$Fq&&H.code===h.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Le.fromString(JSON.stringify([])))}catch(ie){(0,i.$ol)(ie)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$9)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,ie,z,W){return z.includeAllVersions||(H=this.L(ie===o.ExtensionType.System?H:void 0,ie===o.ExtensionType.User?H:void 0,ie==="development"?H:void 0,await this.getTargetPlatform(),W)),z.includeInvalid||(H=H.filter(ee=>ee.isValid)),H.sort((ee,ne)=>{const ce=$.$mc(ee.location.fsPath),te=$.$mc(ne.location.fsPath);return ce<te?-1:ce>te?1:0})}L(H,ie,z,W,ee){const ne=(te,X,K)=>{if(te.isValid&&!X.isValid)return!1;if(te.isValid===X.isValid){if(ee&&l.gt(te.manifest.version,X.manifest.version))return this.y.debug(`Skipping extension ${X.location.path} with lower version ${X.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(l.eq(te.manifest.version,X.manifest.version)){if(te.type===o.ExtensionType.System)return this.y.debug(`Skipping extension ${X.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===W)return this.y.debug(`Skipping extension ${X.location.path} from different target platform ${X.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${te.location.path} with ${X.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${X.location.path}.`),!0},ce=new o.$qn;return H?.forEach(te=>{const X=ce.get(te.identifier.id);(!X||ne(X,te,!1))&&ce.set(te.identifier.id,te)}),ie?.forEach(te=>{const X=ce.get(te.identifier.id);if(!X&&H&&te.type===o.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!X||ne(X,te,!1))&&ce.set(te.identifier.id,te)}),z?.forEach(te=>{const X=ce.get(te.identifier.id);(!X||ne(X,te,!0))&&ce.set(te.identifier.id,te),ce.set(te.identifier.id,te)}),[...ce.values()]}async M(H,ie){this.y.trace("Started scanning system extensions");const z=await this.P(this.systemExtensionsLocation,!1,o.ExtensionType.System,!0,ie,!0,void 0,this.R()),ee=await(H&&!z.devMode?this.j:this.n).scanExtensions(z);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(H,ie){const z=this.z.isBuilt?[]:this.C.builtInExtensions;if(!z?.length)return[];this.y.trace("Started scanning dev system extensions");const W=ie?await this.O():{},ee=[],ne=f.URI.file($.$gc($.$ic(I.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of z){const X=W[te.name]||"marketplace";switch(X){case"disabled":break;case"marketplace":ee.push((0,g.$dh)(ne,te.name));break;default:ee.push(f.URI.file(X));break}}const ce=await Promise.all(ee.map(async te=>this.n.scanExtension(await this.P(te,!1,o.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,R.$Gb)(ce)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,ie,z,W,ee,ne,ce,te){const X=await this.f(ee??d.$x),K=await this.Q(H),B=ie&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=B?await this.Q(B):void 0;return new U(H,K,B,D,ie,ce,z,W,ne,te.version,te.date,this.C.commit,!this.z.isBuilt,ee,X)}async Q(H){try{const ie=await this.w.stat(H);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Lq=T,e.$Lq=T=ve([Z(4,y.$Jl),Z(5,h.$Gq),Z(6,i.$0k),Z(7,t.$0j),Z(8,P.$Ji),Z(9,s.$qk),Z(10,L.$Hl),Z(11,n.$Bi)],T);class U{constructor(H,ie,z,W,ee,ne,ce,te,X,K,B,D,J,q,M){this.location=H,this.mtime=ie,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=W,this.profile=ee,this.profileScanOptions=ne,this.type=ce,this.excludeObsolete=te,this.validate=X,this.productVersion=K,this.productDate=B,this.productCommit=D,this.devMode=J,this.language=q,this.translations=M}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,ie){return(0,g.$9g)(H.location,ie.location)&&H.mtime===ie.mtime&&(0,g.$9g)(H.applicationExtensionslocation,ie.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&H.profile===ie.profile&&C.$fo(H.profileScanOptions,ie.profileScanOptions)&&H.type===ie.type&&H.excludeObsolete===ie.excludeObsolete&&H.validate===ie.validate&&H.productVersion===ie.productVersion&&H.productDate===ie.productDate&&H.productCommit===ie.productCommit&&H.devMode===ie.devMode&&H.language===ie.language&&v.equals(H.translations,ie.translations)}}e.$Mq=U;let F=class extends b.$Tc{constructor(H,ie,z,W,ee,ne,ce){super(),this.g=H,this.h=ie,this.j=z,this.m=W,this.n=ne,this.r=ce,this.f=ee.extensionsEnabledWithApiProposalVersion?.map(te=>te.toLowerCase())??[]}async scanExtensions(H){const ie=H.profile?await this.t(H):await this.s(H);let z={};if(H.excludeObsolete&&H.type===o.ExtensionType.User)try{const W=(await this.m.readFile(this.g)).value.toString();z=JSON.parse(W)}catch{}return(0,E.$pg)(z)?ie:ie.filter(W=>!z[p.$Kp.create(W).toString()])}async s(H){const ie=await this.m.resolve(H.location);if(!ie.children?.length)return[];const z=await Promise.all(ie.children.map(async W=>{if(!W.isDirectory||H.type===o.ExtensionType.User&&(0,g.$ah)(W.resource).indexOf(".")===0)return null;const ee=new U(W.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee)}));return(0,R.$Gb)(z).sort((W,ee)=>W.location.path<ee.location.path?-1:1)}async t(H){let ie=await this.u(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){ie=ie.filter(W=>!W.metadata?.isApplicationScoped);const z=await this.u(H.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,H);ie.push(...z)}return ie}async u(H,ie,z){const W=await this.h.scanProfileExtensions(H,z.profileScanOptions);if(!W.length)return[];const ee=await Promise.all(W.map(async ne=>{if(ie(ne)){const ce=new U(ne.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(ce,ne.metadata)}return null}));return(0,R.$Gb)(ee)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,g.$dh)(H.location,"package.json"))){const ie=await this.scanExtension(H);return ie?[ie]:[]}else return await this.scanExtensions(H)}catch(ie){return this.r.error(`Error scanning extensions at ${H.location.path}:`,(0,N.$9)(ie)),[]}}async scanExtension(H,ie){try{let z=await this.w(H.location);if(z){z.publisher||(z.publisher=o.$kn),ie=ie??z.__metadata,delete z.__metadata;const W=(0,p.$Op)(z.publisher,z.name),ee=ie?.id?{id:W,uuid:ie.id}:{id:W},ne=ie?.isSystem?o.ExtensionType.System:H.type,ce=ne===o.ExtensionType.System||!!ie?.isBuiltin;z=await this.y(H.location,z,U.createNlsConfiguration(H));let te={type:ne,identifier:ee,manifest:z,location:H.location,isBuiltin:ce,targetPlatform:ie?.targetPlatform??o.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return H.validate&&(te=this.validate(te,H)),z.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(W.toLowerCase()))&&(z.originalEnabledApiProposals=z.enabledApiProposals,z.enabledApiProposals=(0,o.$wn)([...z.enabledApiProposals])),te}}catch(z){H.type!==o.ExtensionType.System&&this.r.error(z)}return null}validate(H,ie){let z=!0;const W=this.n.isBuilt&&this.f.includes(H.identifier.id.toLowerCase()),ee=(0,u.$1p)(ie.productVersion,ie.productDate,ie.location,H.manifest,H.isBuiltin,W);for(const[ne,ce]of ee)ne===m.default.Error&&(z=!1,this.r.error(this.F(ie.location,ce)));return H.isValid=z,H.validations=ee,H}async w(H){const ie=(0,g.$dh)(H,"package.json");let z;try{z=(await this.m.readFile(ie)).value.toString()}catch(ee){return(0,i.$ol)(ee)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(H,(0,w.localize)(11326,null,ie.path,ee.message))),null}let W;try{W=JSON.parse(z)}catch{const ne=[];(0,O.$Vn)(z,ne);for(const ce of ne)this.r.error(this.F(H,(0,w.localize)(11327,null,ie.path,ce.offset,ce.length,(0,k.$Iq)(ce.error))));return null}return(0,O.$4n)(W)!=="object"?(this.r.error(this.F(H,(0,w.localize)(11328,null,ie.path))),null):W}async y(H,ie,z){const W=await this.z(H,ie,z);if(W)try{const ee=[],ne=await this.C(W.default,ee);if(ee.length>0)return ee.forEach(te=>{this.r.error(this.F(H,(0,w.localize)(11329,null,W.default?.path,(0,k.$Iq)(te.error))))}),ie;if((0,O.$4n)(W)!=="object")return this.r.error(this.F(H,(0,w.localize)(11330,null,W.default?.path))),ie;const ce=W.values||Object.create(null);return(0,S.$Jq)(this.r,ie,ce,ne)}catch{}return ie}async z(H,ie,z){const W=(0,g.$dh)(H,"package.nls.json"),ee=(X,K)=>{K.forEach(B=>{this.r.error(this.F(H,(0,w.localize)(11331,null,X?.path,(0,k.$Iq)(B.error))))})},ne=X=>{this.r.error(this.F(H,(0,w.localize)(11332,null,X?.path)))},ce=`${ie.publisher}.${ie.name}`,te=z.translations[ce];if(te)try{const X=f.URI.file(te),K=(await this.m.readFile(X)).value.toString(),B=[],D=(0,O.$Vn)(K,B);return B.length>0?(ee(X,B),{values:void 0,default:W}):(0,O.$4n)(D)!=="object"?(ne(X),{values:void 0,default:W}):{values:D.contents?D.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.m.exists(W))return;let K;try{K=await this.D(H,z)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const B=(await this.m.readFile(K.localized)).value.toString(),D=[],J=(0,O.$Vn)(B,D);return D.length>0?(ee(K.localized,D),{values:void 0,default:K.original}):(0,O.$4n)(J)!=="object"?(ne(K.localized),{values:void 0,default:K.original}):{values:J,default:K.original}}catch{return{values:void 0,default:K.original}}}}async C(H,ie){if(H)try{const z=(await this.m.readFile(H)).value.toString();return(0,O.$Vn)(z,ie)}catch{}}D(H,ie){return new Promise((z,W)=>{const ee=ne=>{const ce=(0,g.$dh)(H,`package.nls.${ne}.json`);this.m.exists(ce).then(te=>{te&&z({localized:ce,original:(0,g.$dh)(H,"package.nls.json")});const X=ne.lastIndexOf("-");X===-1?z({localized:(0,g.$dh)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,X),ee(ne))})};if(ie.devMode||ie.pseudo||!ie.language)return z({localized:(0,g.$dh)(H,"package.nls.json"),original:null});ee(ie.language)})}F(H,ie){return`[${H.path}]: ${ie}`}};F=ve([Z(1,h.$Gq),Z(2,L.$Hl),Z(3,i.$0k),Z(4,s.$qk),Z(5,P.$Ji),Z(6,t.$0j)],F);let j=class extends F{constructor(H,ie,z,W,ee,ne,ce,te,X){super(ie,W,ee,ne,ce,te,X),this.J=H,this.L=z,this.H=this.B(new c.$Ah(3e3)),this.I=this.B(new r.$je),this.onDidChangeCache=this.I.event}async scanExtensions(H){const ie=this.P(H),z=await this.M(ie);if(this.G=H,z&&z.input&&U.equals(z.input,this.G))return this.r.debug("Using cached extensions scan result",H.type===o.ExtensionType.System?"system":"user",H.location.toString()),this.H.trigger(()=>this.O()),z.result.map(ee=>(ee.location=f.URI.revive(ee.location),ee));const W=await super.scanExtensions(H);return await this.N(ie,{input:H,result:W}),W}async M(H){try{const ie=await this.m.readFile(H),z=JSON.parse(ie.value.toString());return{result:z.result,input:(0,a.$_h)(z.input)}}catch(ie){this.r.debug("Error while reading the extension cache file:",H.path,(0,N.$9)(ie))}return null}async N(H,ie){try{await this.m.writeFile(H,A.$Le.fromString(JSON.stringify(ie)))}catch(z){this.r.debug("Error while writing the extension cache file:",H.path,(0,N.$9)(z))}}async O(){if(!this.G)return;const H=this.P(this.G),ie=await this.M(H);if(!ie)return;const z=ie.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!C.$fo(W,z))try{this.r.info("Invalidating Cache",z,W),await this.m.del(H),this.I.fire()}catch(ee){this.r.error(ee)}}P(H){const ie=this.Q(H);return this.j.extUri.joinPath(ie.cacheHome,H.type===o.ExtensionType.System?o.$jn:o.$in)}Q(H){return H.type===o.ExtensionType.System?this.L.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.J.extensionsResource)?this.J:this.L.profiles.find(ie=>this.j.extUri.isEqual(H.location,ie.extensionsResource))??this.J:this.L.defaultProfile}};j=ve([Z(2,y.$Jl),Z(3,h.$Gq),Z(4,L.$Hl),Z(5,i.$0k),Z(6,s.$qk),Z(7,P.$Ji),Z(8,t.$0j)],j);function G(x,H){const ie=(0,p.$Mp)(x.manifest.publisher,x.manifest.name);return{id:ie,identifier:new o.$on(ie),isBuiltin:x.type===o.ExtensionType.System,isUserBuiltin:x.type===o.ExtensionType.User&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,publisherDisplayName:x.publisherDisplayName,...x.manifest}}class V extends T{constructor(H,ie,z,W,ee,ne,ce,te,X,K,B,D){super(H,ie,(0,g.$dh)(z,".vscode-oss-dev","extensions","control.json"),W,ee,ne,ce,te,X,K,B,D),this.S=(async()=>{if(d.$A)try{const J=await this.w.readFile(f.URI.file(d.$A));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Oq=V}),define(he[215],ue([0,1,68,6,43,3,2,22,13,30,10,19]),function(oe,e,R,c,C,A,N,O,k,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;let d=class extends N.$Tc{constructor(l,m){super(),this.b=l,this.f=m,this.a=new c.$Ih(5)}async postUninstall(l){const m=this.g(l,"uninstall");m&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(m.script,"uninstall",m.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(E)}}));try{await b.Promises.rm(this.m(l))}catch(E){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(E)}}g(l,m){const E=`vscode:${m}`;if(l.location.scheme===O.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[E]=="string"){const f=l.manifest.scripts[E].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${E} should be a node script`),null):{script:(0,k.$ic)(l.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(l,m,E,f,w){return new Promise((P,p)=>{const o=this.j(l,m,E,w);let u;const i=n=>{u&&(clearTimeout(u),u=null),n?p(n):P(void 0)};o.on("error",n=>{i((0,C.$nj)(n)||"Unknown")}),o.on("exit",(n,t)=>{i(n?`post-${m} process exited with code ${n}`:void 0)}),f&&(u=setTimeout(()=>{u=null,o.kill(),p("timed out")},5e3))})}j(l,m,E,f){const w={silent:!0,execArgv:void 0},P=(0,R.fork)(l,[`--type=extension-post-${m}`,...E],w);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(P.stdout,"data"),o=A.Event.fromNodeEventEmitter(P.stderr,"data");this.B(p(n=>this.f.info(f.identifier.id,f.manifest.version,`post-${m}`,n))),this.B(o(n=>this.f.error(f.identifier.id,f.manifest.version,`post-${m}`,n)));const u=A.Event.any(A.Event.map(p,n=>({data:`%c${n}`,format:[""]}),this.q),A.Event.map(o,n=>({data:`%c${n}`,format:["color: red"]}),this.q));return A.Event.debounce(u,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(n=>{console.group(f.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),P}m(l){return(0,k.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$Sq=d,e.$Sq=d=ve([Z(0,$.$Jl),Z(1,I.$0j)],d)}),define(he[116],ue([0,1,72,11,83,27]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=N,e.$Qq=O;function N(k){let b=A.ExtensionManagementErrorCode.Extract;return k instanceof R.$yq&&(k.type==="CorruptZip"?b=A.ExtensionManagementErrorCode.CorruptZip:k.type==="Incomplete"&&(b=A.ExtensionManagementErrorCode.IncompleteZip)),(0,C.$Dq)(k,b)}async function O(k){let b;try{b=await(0,R.$Bq)(k,"extension/package.json")}catch(I){throw N(I)}try{return JSON.parse(b.toString("utf8"))}catch{throw new A.$kp((0,c.localize)(11316,null),A.ExtensionManagementErrorCode.Invalid)}}}),define(he[216],ue([0,1,6,8,2,22,20,60,12,32,30,72,21,15,83,27,35,116,110,7,10,18]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,O=ke(O);let i=class extends C.$Tc{static{u=this}static{this.c=".sigzip"}constructor(t,s,r,a,h,y,L){super(),this.h=s,this.j=r,this.m=a,this.n=h,this.r=y,this.t=L,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,r,a){await this.g;const h=await this.w(t,s);let y=!1;if(r&&this.u(t)){let L;try{L=await this.y(t)}catch(S){try{await this.delete(h)}catch(v){this.t.error(v)}throw S}try{y=await this.n.verify(t,h.fsPath,L.fsPath,a)}catch(S){if(y=S.code,y===w.ExtensionSignatureVerificationCode.PackageIsInvalidZip||y===w.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(h)}catch(v){this.t.error(v)}throw new m.$kp($.$xq,m.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(L)}catch(S){this.t.error(S)}}}return{location:h,verificationStatus:y}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,k.$ig)(s)?s:!0}async w(t,s){try{const r=(0,N.$dh)(this.extensionsDownloadDir,this.G(t)),a=await this.C(t,"vsix",async()=>{await this.z(t,r,h=>this.j.download(t,h,s));try{await this.D(r.fsPath,"extension/package.json")}catch(h){try{await this.h.del(r)}catch(y){this.t.warn(`Error while deleting: ${r.path}`,(0,c.$9)(y))}throw h}},2);return a>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:a}),r}catch(r){throw(0,l.$Dq)(r,m.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,N.$dh)(this.extensionsDownloadDir,`.${(0,b.$Yg)()}`),r=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(a){try{await this.h.del(s)}catch(h){this.t.warn(`Error while deleting: ${s.path}`,(0,c.$9)(h))}throw a}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:r}),s}catch(s){throw(0,l.$Dq)(s,m.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,r){if(await this.h.exists(s))return;if(s.scheme!==A.Schemas.file){await r(s);return}const a=(0,N.$dh)(this.extensionsDownloadDir,`.${(0,b.$Yg)()}`);try{await r(a)}catch(h){try{await this.h.del(a)}catch{}throw h}try{await I.Promises.rename(a.fsPath,s.fsPath,2*60*1e3)}catch(h){try{await this.h.del(a)}catch{}let y=!1;try{y=await this.h.exists(s)}catch{}if(y)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,c.$9)(h)}. Deleted the file from downloaded location`,a.path),h}}async C(t,s,r,a){let h=1;for(;;)try{return await r(),h}catch(y){if(h++>a)throw y;this.t.warn(`Failed downloading ${s}. ${(0,c.$9)(y)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,$.$Bq)(t,s)}catch(r){throw(0,f.$Pq)(r)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],r=[],a=[];for(const L of t.children)if(L.name.endsWith(u.c))a.push(L.resource);else{const S=E.$Kp.parse(L.name);S&&r.push([S,L])}const h=(0,E.$Pp)(r,([L])=>L),y=[];for(const L of h)L.sort((S,v)=>O.rcompare(S[0].version,v[0].version)),s.push(...L.slice(1).map(S=>S[1].resource)),y.push(L[0][1]);y.sort((L,S)=>L.mtime-S.mtime),s.push(...y.slice(0,Math.max(0,y.length-this.f)).map(L=>L.resource)),s.push(...a),await R.Promises.settled(s.map(L=>(this.t.trace("Deleting from cache",L.path),this.h.del(L))))}}catch(t){this.t.error(t)}}G(t){return this.f?E.$Kp.create(t).toString().toLowerCase():(0,b.$Yg)()}};e.$Rq=i,e.$Rq=i=u=ve([Z(0,g.$Ki),Z(1,P.$0k),Z(2,m.$ip),Z(3,d.$9i),Z(4,w.$qq),Z(5,o.$9l),Z(6,p.$0j)],i)}),define(he[117],ue([0,1,33,6,14,25,43,8,3,55,2,31,22,13,20,60,12,9,32,30,72,11,98,15,83,27,35,52,84,216,215,116,188,198,34,59,7,4,10,23,18,28,19]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o,u,i,n,t,s,r,a,h,y,L,S,v,T,U,F,j,G,V,x,H,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=e.$Vq=void 0,R=ke(R),g=ke(g),m=ke(m),P=ke(P),o=ke(o),e.$Vq=(0,j.$Di)(t.$lp);const z=".vsctmp";let W=class extends n.$Cq{constructor(X,K,B,D,J,q,M,Q,_,Y,re,le){super(X,K,re,B,Y,le),this.db=J,this.eb=q,this.fb=M,this.gb=Q,this.hb=_,this.cb=new Map,this.sb=new $.$Ac;const ge=this.B(Q.createInstance(y.$Sq));this.$=this.B(Q.createInstance(ee,Ee=>ge.postUninstall(Ee))),this.ab=this.B(new S.$Tq(le,_,re,this,this.F)),this.bb=this.B(Q.createInstance(h.$Rq));const pe=this.B(new v.$Uq(this,this.db,le,q,re,_,B));this.B(pe.onDidChangeExtensionsByAnotherSource(Ee=>this.rb(Ee))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Up)(this.hb,this.F)),this.ib}async zip(X){this.F.trace("ExtensionManagementService#zip",X.identifier.id);const K=await this.qb(X),B=await(0,p.zip)((0,l.$dh)(this.bb.extensionsDownloadDir,(0,w.$Yg)()).fsPath,K);return f.URI.file(B)}async getManifest(X){const{location:K,cleanup:B}=await this.kb(X),D=g.$jc(K.fsPath);try{return await(0,L.$Qq)(D)}finally{await B()}}getInstalled(X,K=this.H.defaultProfile.extensionsResource,B={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(X??null,K,B)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.$.scanUserExtensionAtLocation(X)}async install(X,K={}){this.F.trace("ExtensionManagementService#install",X.toString());const{location:B,cleanup:D}=await this.kb(X);try{const J=await(0,L.$Qq)(g.$jc(B.fsPath)),q=(0,s.$Op)(J.publisher,J.name);if(J.engines&&J.engines.vscode&&!(0,U.$3p)(J.engines.vscode,this.G.version,this.G.date))throw new Error(o.localize(11317,null,q,this.G.version));const Q=(await this.I([{manifest:J,extension:B,options:K}])).find(({identifier:_})=>(0,s.$Jp)(_,{id:q}));if(Q?.local)return Q.local;throw Q?.error?Q.error:(0,n.$Dq)(new Error(`Unknown error while installing extension ${q}`))}finally{await D()}}async installFromLocation(X,K){this.F.trace("ExtensionManagementService#installFromLocation",X.toString());const B=await this.$.scanUserExtensionAtLocation(X);if(!B||!B.manifest.name||!B.manifest.version)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.vb([[B,{source:"resource"}]],K),this.F.info("Successfully installed extension",B.identifier.id,K.toString()),B}async installExtensionsFromProfile(X,K,B){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",X,K.toString(),B.toString());const D=(await this.getInstalled(T.ExtensionType.User,K)).filter(J=>X.some(q=>(0,s.$Jp)(q,J.identifier)));if(D.length){const J=await Promise.all(D.map(q=>this.$.scanMetadata(q,K)));await this.vb(D.map((q,M)=>[q,J[M]]),B),this.F.info("Successfully installed extensions",D.map(q=>q.identifier.id),B.toString())}return D}async updateMetadata(X,K,B){return this.F.trace("ExtensionManagementService#updateMetadata",X.identifier.id),K.isPreReleaseVersion&&(K.preRelease=!0,K.hasPreReleaseVersion=!0),K.isMachineScoped===!1&&(K.isMachineScoped=void 0),K.isBuiltin===!1&&(K.isBuiltin=void 0),K.pinned===!1&&(K.pinned=void 0),X=await this.$.updateMetadata(X,K,B),this.ab.invalidate(B),this.w.fire({local:X,profileLocation:B}),X}async reinstallFromGallery(X){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.z.isEnabled())throw new Error(o.localize(11318,null));const K=await this.getTargetPlatform(),[B]=await this.z.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:K,compatible:!0},A.CancellationToken.None);if(!B)throw new Error(o.localize(11319,null));await this.$.setUninstalled(X);try{await this.$.removeUninstalledExtension(X)}catch(D){throw new Error(o.localize(11320,null,(0,N.$nj)(D)))}return this.installFromGallery(B)}Z(X,K,B,D){return this.$.copyExtension(X,K,B,D)}copyExtensions(X,K){return this.$.copyExtensions(X,K,{version:this.G.version,date:this.G.date})}markAsUninstalled(...X){return this.$.setUninstalled(...X)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(X){this.F.error(X)}}async download(X,K,B){const{location:D}=await this.bb.download(X,K,!B);return D}async kb(X){if(X.scheme===d.Schemas.file)return{location:X,async cleanup(){}};this.F.trace("Downloading extension from",X.toString());const K=(0,l.$dh)(this.bb.extensionsDownloadDir,(0,w.$Yg)());return await this.fb.download(X,K),this.F.info("Downloaded extension to",K.toString()),{location:K,cleanup:async()=>{try{await this.hb.del(K)}catch(D){this.F.error(D)}}}}W(){return this.H.defaultProfile.extensionsResource}X(X,K,B){const D=K instanceof f.URI?new s.$Kp({id:(0,s.$Op)(X.publisher,X.name)},X.version):s.$Kp.create(K);return this.gb.createInstance(ne,D,X,K,B,(J,q)=>{if(K instanceof f.URI)return this.pb(D,K,B,q);let M=this.cb.get(D.toString());return M||(this.cb.set(D.toString(),M=this.ob(D,K,J,B,q)),M.finally(()=>this.cb.delete(D.toString()))),M},this.$)}Y(X,K){return new ce(X,K,this.eb)}async ob(X,K,B,D,J){const{verificationStatus:q,location:M}=await this.bb.download(K,B,!D.donotVerifySignature,D.context?.[t.$bp]);try{if(J.isCancellationRequested)throw new O.$4;const Q=await(0,L.$Qq)(M.fsPath);if(!new s.$Kp(K.identifier,K.version).equals(new s.$Kp({id:(0,s.$Op)(Q.publisher,Q.name)},Q.version)))throw new t.$kp(o.localize(11321,null,K.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(X,M.fsPath,{id:K.identifier.uuid,publisherId:K.publisherId,publisherDisplayName:K.publisherDisplayName,targetPlatform:K.properties.targetPlatform,isApplicationScoped:D.isApplicationScoped,isMachineScoped:D.isMachineScoped,isBuiltin:D.isBuiltin,isPreReleaseVersion:K.properties.isPreReleaseVersion,hasPreReleaseVersion:K.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:D.installGivenVersion?!0:!!D.pinned,preRelease:(0,E.$ig)(D.preRelease)?D.preRelease:D.installPreReleaseVersion||K.properties.isPreReleaseVersion,source:"gallery"},!1,J),verificationStatus:q}}catch(Q){try{await this.bb.delete(M)}catch(_){this.F.warn("Error while deleting the downloaded file",M.toString(),(0,O.$9)(_))}throw(0,n.$Dq)(Q)}}async pb(X,K,B,D){return{local:await this.$.extractUserExtension(X,g.$jc(K.fsPath),{isApplicationScoped:B.isApplicationScoped,isMachineScoped:B.isMachineScoped,isBuiltin:B.isBuiltin,installedTimestamp:Date.now(),pinned:B.installGivenVersion?!0:!!B.pinned,source:"vsix"},B.keepExisting??!0,D)}}async qb(X){const K=async D=>{let J=await P.Promises.readdir(D);J=J.map(Q=>g.$ic(D,Q));const q=await Promise.all(J.map(Q=>R.promises.stat(Q)));let M=Promise.resolve([]);return q.forEach((Q,_)=>{const Y=J[_];Q.isFile()&&(M=M.then(re=>[...re,Y])),Q.isDirectory()&&(M=M.then(re=>K(Y).then(le=>[...re,...le])))}),M};return(await K(X.location.fsPath)).map(D=>({path:`extension/${g.$kc(X.location.fsPath,D)}`,localPath:D}))}async rb({added:X,removed:K}){if(K){const B=X&&this.D.extUri.isEqual(K.profileLocation,X.profileLocation)?K.extensions.filter(D=>X.extensions.every(J=>!(0,s.$Jp)(J,D))):K.extensions;for(const D of B)this.F.info("Extensions removed from another source",D.id,K.profileLocation.toString()),this.u.fire({identifier:D,profileLocation:K.profileLocation})}if(X){const D=(await this.getInstalled(T.ExtensionType.User,X.profileLocation)).filter(J=>X.extensions.some(q=>(0,s.$Jp)(q,J.identifier)));this.s.fire(D.map(J=>(this.F.info("Extensions added from another source",J.identifier.id,X.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:X.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(K=>this.sb.add(K)));const X=await this.hb.resolve(this.db.userExtensionsLocation);for(const K of X.children??[])K.isDirectory&&this.sb.add(K.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(K=>this.ub(K)))}async ub(X){if(!X.affects(this.db.userExtensionsLocation,F.FileChangeType.ADDED))return;const K=[];for(const B of X.rawAdded){if(this.sb.has(B)||!this.D.extUri.isEqual(this.D.extUri.dirname(B),this.db.userExtensionsLocation)||this.D.extUri.isEqual(B,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(B).startsWith(".")||!(await this.hb.stat(B)).isDirectory)continue;const D=await this.$.scanUserExtensionAtLocation(B);D&&D.installedTimestamp===void 0&&(this.sb.add(B),K.push(D))}K.length&&(await this.vb(K.map(B=>[B,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",K.map(B=>B.identifier.id)))}async vb(X,K){const B=X.map(D=>D[0]);await this.wb(B),await this.eb.addExtensionsToProfile(X,K),this.s.fire(B.map(D=>({local:D,identifier:D.identifier,operation:t.InstallOperation.None,profileLocation:K})))}async wb(X){const K=await this.$.getUninstalledExtensions();for(const B of X){const D=s.$Kp.create(B);K[D.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",D.id),await this.$.setInstalled(D),this.F.info("Removed the extension from uninstalled list:",D.id))}}};e.$Wq=W,e.$Wq=W=ve([Z(0,t.$ip),Z(1,x.$9l),Z(2,G.$0j),Z(3,i.$Ki),Z(4,a.$Kq),Z(5,r.$Gq),Z(6,u.$Yo),Z(7,j.$Bi),Z(8,F.$0k),Z(9,V.$qk),Z(10,H.$Hl),Z(11,ie.$Jl)],W);let ee=class extends I.$Tc{constructor(X,K,B,D,J,q,M){super(),this.n=X,this.s=K,this.t=B,this.u=D,this.w=J,this.y=q,this.z=M,this.h=this.B(new k.$je),this.onExtract=this.h.event,this.j=new $.$zc,this.m=new $.$zc,this.c=(0,l.$dh)(this.t.userExtensionsLocation,".obsolete"),this.g=new c.$Jh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(X,K,B){try{const D={includeInvalid:!0,profileLocation:K,productVersion:B};let J=[];if(X===null||X===T.ExtensionType.System){let q=this.j.get(K);q||(q=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},D,!1).finally(()=>this.j.delete(K)),this.j.set(K,q)),J.push(...await q)}else if(X===T.ExtensionType.User){let q=this.m.get(K);q||(q=this.t.scanUserExtensions(D).finally(()=>this.m.delete(K)),this.m.set(K,q)),J.push(...await q)}return J=X!==null?J.filter(q=>q.type===X):J,await Promise.all(J.map(q=>this.H(q)))}catch(D){throw(0,n.$Dq)(D,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(X){try{const K=await this.t.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return await Promise.all(K.map(B=>this.H(B)))}catch(K){throw(0,n.$Dq)(K,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(X){try{const K=await this.t.scanExistingExtension(X,T.ExtensionType.User,{includeInvalid:!0});if(K)return await this.H(K)}catch(K){this.z.error(K)}return null}async extractUserExtension(X,K,B,D,J){const q=X.toString(),M=f.URI.file(g.$ic(this.t.userExtensionsLocation.fsPath,`.${(0,w.$Yg)()}`)),Q=f.URI.file(g.$ic(this.t.userExtensionsLocation.fsPath,q));if(await this.s.exists(Q)){if(!D)try{return await this.scanLocalExtension(Q,T.ExtensionType.User)}catch(_){this.z.warn(`Error while scanning the existing extension at ${Q.path}. Deleting the existing extension and extracting it.`,(0,O.$9)(_))}try{await this.D(X.id,Q,"removeExisting")}catch{throw new t.$kp(o.localize(11322,null,Q.fsPath,X.id),t.ExtensionManagementErrorCode.Delete)}}try{if(J.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started extracting the extension from ${K} to ${Q.fsPath}`),await(0,p.$Aq)(K,M.fsPath,{sourcePath:"extension",overwrite:!0},J),this.z.info(`Extracted extension to ${Q}:`,X.id)}catch(_){throw(0,L.$Pq)(_)}try{await this.t.updateMetadata(M,B)}catch(_){throw this.y.publicLog2("extension:extract",{extensionId:X.id,code:`${(0,F.$ol)(_)}`}),(0,n.$Dq)(_,t.ExtensionManagementErrorCode.UpdateMetadata)}if(J.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started renaming the extension from ${M.fsPath} to ${Q.fsPath}`),await this.G(M.fsPath,Q.fsPath),this.z.info("Renamed to",Q.fsPath)}catch(_){if(_.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);try{await this.s.del(M,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,O.$9)(_)}. Deleted from extracted location`,M),_}this.h.fire(Q)}catch(_){try{await this.s.del(M,{recursive:!0})}catch{}throw _}return this.scanLocalExtension(Q,T.ExtensionType.User)}async scanMetadata(X,K){return K?(await this.C(X,K))?.metadata:this.t.scanMetadata(X.location)}async C(X,K){return(await this.u.scanProfileExtensions(K)).find(D=>(0,s.$Jp)(D.identifier,X.identifier))}async updateMetadata(X,K,B){try{B?await this.u.updateMetadata([[X,K]],B):await this.t.updateMetadata(X.location,K)}catch(D){throw this.y.publicLog2("extension:extract",{extensionId:X.identifier.id,code:`${(0,F.$ol)(D)}`,isProfile:!!B}),(0,n.$Dq)(D,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(X.location,X.type,B)}async getUninstalledExtensions(){try{return await this.F()}catch(X){throw(0,n.$Dq)(X,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...X){const K=X.map(B=>s.$Kp.create(B));await this.F(B=>K.forEach(D=>{B[D.toString()]=!0,this.z.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(X){try{await this.F(K=>delete K[X.toString()])}catch(K){throw(0,n.$Dq)(K,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(X,K){if(this.w.extUri.isEqualOrParent(X.location,this.t.userExtensionsLocation))return this.D(X.identifier.id,X.location,K)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.F(K=>delete K[s.$Kp.create(X).toString()])}async copyExtension(X,K,B,D){const J=await this.C(X,K),q=await this.C(X,B);if(D={...J?.metadata,...D},q)if(this.w.extUri.isEqual(q.location,X.location))await this.u.updateMetadata([[X,{...q.metadata,...D}]],B);else{const M=await this.scanLocalExtension(q.location,X.type,B);await this.u.removeExtensionFromProfile(M,B),await this.u.addExtensionsToProfile([[X,{...q.metadata,...D}]],B)}else await this.u.addExtensionsToProfile([[X,D]],B);return this.scanLocalExtension(X.location,X.type,B)}async copyExtensions(X,K,B){const D=await this.scanExtensions(T.ExtensionType.User,X,B),J=await Promise.all(D.filter(q=>!q.isApplicationScoped).map(async q=>[q,await this.scanMetadata(q,X)]));await this.u.addExtensionsToProfile(J,K)}async D(X,K,B){this.z.trace(`Deleting ${B} extension from disk`,X,K.fsPath);const D=this.w.extUri.joinPath(this.w.extUri.dirname(K),`${this.w.extUri.basename(K)}.${(0,b.$qj)((0,w.$Yg)()).toString(16)}${z}`);await this.G(K.fsPath,D.fsPath),await this.s.del(D,{recursive:!0}),this.z.info(`Deleted ${B} extension from disk`,X,K.fsPath)}F(X){return this.g.queue(async()=>{let K;try{K=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(D){if((0,F.$ol)(D)!==F.FileOperationResult.FILE_NOT_FOUND)throw D}let B={};if(K)try{B=JSON.parse(K)}catch{}return X&&(X(B),Object.keys(B).length?await this.s.writeFile(this.c,C.$Le.fromString(JSON.stringify(B))):await this.s.del(this.c)),B})}async G(X,K){try{await P.Promises.rename(X,K,2*60*1e3)}catch(B){throw(0,n.$Dq)(B,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(X,K,B){try{if(B){const J=(await this.t.scanUserExtensions({profileLocation:B})).find(q=>this.w.extUri.isEqual(q.location,X));if(J)return await this.H(J)}else{const D=await this.t.scanExistingExtension(X,K,{includeInvalid:!0});if(D)return await this.H(D)}throw new t.$kp(o.localize(11323,null,X.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(D){throw(0,n.$Dq)(D,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(X){const K=await this.s.resolve(X.location);let B,D;return K.children&&(B=K.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,D=K.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:B,changelogUrl:D,publisherDisplayName:X.metadata?.publisherDisplayName,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!X.metadata?.hasPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned,isWorkspaceScoped:!1,source:X.metadata?.source??(X.identifier.uuid?"gallery":"vsix")}}async I(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(X));const K=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),B=new Set;for(const J of K)X[s.$Kp.create(J).toString()]||B.add(J.identifier.id.toLowerCase());try{const J=(0,s.$Pp)(K,q=>q.identifier);await c.Promises.settled(J.map(async q=>{const M=q.sort((Q,_)=>m.rcompare(Q.manifest.version,_.manifest.version))[0];B.has(M.identifier.id.toLowerCase())||await this.n(await this.H(M))}))}catch(J){this.z.error(J)}const D=K.filter(J=>J.metadata&&X[s.$Kp.create(J).toString()]);await Promise.allSettled(D.map(J=>this.removeUninstalledExtension(J)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let X;try{X=await this.s.resolve(this.t.userExtensionsLocation)}catch(K){(0,F.$ol)(K)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(K);return}if(X?.children)try{await Promise.allSettled(X.children.map(async K=>{if(!(!K.isDirectory||!K.name.endsWith(z))){this.z.trace("Deleting the temporarily deleted folder",K.resource.toString());try{await this.s.del(K.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",K.resource.toString())}catch(B){(0,F.$ol)(B)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(B)}}}))}catch{}}};e.$Xq=ee,e.$Xq=ee=ve([Z(1,F.$0k),Z(2,a.$Kq),Z(3,r.$Gq),Z(4,H.$Hl),Z(5,x.$9l),Z(6,G.$0j)],ee);let ne=class extends n.$Eq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(X,K,B,D,J,q,M,Q,_,Y,re,le){super(),this.l=X,this.manifest=K,this.source=B,this.options=D,this.m=J,this.n=q,this.o=M,this.p=Q,this.q=_,this.s=Y,this.t=re,this.u=le,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(X){const B=(await this.n.scanExtensions(T.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(M=>(0,s.$Jp)(M.identifier,this.identifier));B&&(this.j=t.InstallOperation.Update);const D={isApplicationScoped:this.options.isApplicationScoped||B?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||B?.isMachineScoped,isBuiltin:this.options.isBuiltin||B?.isBuiltin,isSystem:B?.type===T.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??B?.pinned,source:this.source instanceof f.URI?"vsix":"gallery"};let J;if(this.source instanceof f.URI){if(B&&this.l.equals(new s.$Kp(B.identifier,B.manifest.version)))try{await this.n.removeExtension(B,"existing")}catch{throw new Error(o.localize(11324,null,this.manifest.displayName||this.manifest.name))}const M=await this.w(this.l);if(M)try{await this.n.removeExtension(M,"existing")}catch{throw new Error(o.localize(11325,null,this.manifest.displayName||this.manifest.name))}}else{if(D.id=this.source.identifier.uuid,D.publisherId=this.source.publisherId,D.publisherDisplayName=this.source.publisherDisplayName,D.targetPlatform=this.source.properties.targetPlatform,D.updated=!!B,D.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,D.hasPreReleaseVersion=B?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,D.preRelease=(0,E.$ig)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||B?.preRelease,B&&B.type!==T.ExtensionType.System&&B.manifest.version===this.source.version)return this.n.updateMetadata(B,D,this.options.profileLocation);J=await this.w(this.l)}if(X.isCancellationRequested)throw(0,n.$Dq)(new O.$4);if(!J){const M=await this.m(this.operation,X);J=M.local,this.k=M.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(M){throw(0,n.$Dq)(M,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(X.isCancellationRequested)throw(0,n.$Dq)(new O.$4);try{await this.t.addExtensionsToProfile([[J,D]],this.options.profileLocation,!J.isValid)}catch(M){throw(0,n.$Dq)(M,t.ExtensionManagementErrorCode.AddToProfile)}const q=await this.n.scanLocalExtension(J.location,T.ExtensionType.User,this.options.profileLocation);if(!q)throw new t.$kp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof f.URI&&this.x(J,X),q}async w(X){return(await this.n.getUninstalledExtensions())[X.toString()]?(this.u.trace("Removing the extension from uninstalled list:",X.id),await this.n.setInstalled(X),this.u.info("Removed the extension from uninstalled list:",X.id),(await this.n.scanAllUserExtensions(!0)).find(D=>s.$Kp.create(D).equals(X))):void 0}async x(X,K){try{let[B]=await this.p.getExtensions([{id:X.identifier.id,version:X.manifest.version}],K);if(B||([B]=await this.p.getExtensions([{id:X.identifier.id}],K)),B){const D={id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,hasPreReleaseVersion:X.hasPreReleaseVersion||B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(X,D,this.options.profileLocation)}}catch{}}};ne=ve([Z(6,H.$Hl),Z(7,t.$ip),Z(8,ie.$Jl),Z(9,a.$Kq),Z(10,r.$Gq),Z(11,G.$0j)],ne);class ce extends n.$Eq{constructor(X,K,B){super(),this.extension=X,this.options=K,this.j=B}async h(X){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(he[217],ue([0,1,10,19,28,18,52,7,15,9]),function(oe,e,R,c,C,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uR=void 0;let I=class extends N.$Hq{constructor(d,g,l,m,E,f){super(b.URI.file(d.extensionsPath),g,l,m,E,f)}};e.$uR=I,e.$uR=I=ve([Z(0,k.$Ki),Z(1,O.$0k),Z(2,c.$Jl),Z(3,C.$Hl),Z(4,A.$9l),Z(5,R.$0j)],I)}),define(he[218],ue([0,1,9,15,52,84,7,4,10,23,28,19]),function(oe,e,R,c,C,A,N,O,k,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;let d=class extends A.$Oq{constructor(l,m,E,f,w,P,p,o){super(R.URI.file(w.builtinExtensionsPath),R.URI.file(w.extensionsPath),w.userHome,l.defaultProfile,l,m,E,f,w,P,p,o)}};e.$Lgc=d,e.$Lgc=d=ve([Z(0,$.$Jl),Z(1,C.$Gq),Z(2,N.$0k),Z(3,k.$0j),Z(4,c.$Ki),Z(5,b.$qk),Z(6,I.$Hl),Z(7,O.$Bi)],d)}),define(he[16],ue([0,1,6,3,2,100,12,70,4,19]),function(oe,e,R,c,C,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=g,e.$iq=m,e.$kq=f,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,k.$Ci)("storageService");var I;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var $;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})($||(e.StorageScope=$={}));var d;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function g(w){const P=w.get(e.$eq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class l extends C.$Tc{static{this.a=60*1e3}constructor(P={flushInterval:l.a}){super(),this.m=P,this.b=this.B(new c.$me),this.c=this.B(new c.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new c.$je),this.onWillSaveState=this.f.event,this.h=this.B(new R.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,p,o){return c.Event.filter(this.b.event,u=>u.scope===P&&(p===void 0||u.key===p),o)}n(){this.j.value=(0,R.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,p){const{key:o,external:u}=p;if(o===e.$eq){switch(P){case $.APPLICATION:this.H=void 0;break;case $.PROFILE:this.F=void 0;break;case $.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:o,target:this.J(P)[o],external:u})}w(P){this.f.fire({reason:P})}get(P,p,o){return this.P(p)?.get(P,o)}getBoolean(P,p,o){return this.P(p)?.getBoolean(P,o)}getNumber(P,p,o){return this.P(p)?.getNumber(P,o)}getObject(P,p,o){return this.P(p)?.getObject(P,o)}storeAll(P,p){this.y(()=>{for(const o of P)this.store(o.key,o.value,o.scope,o.target,p)})}store(P,p,o,u,i=!1){if((0,N.$lg)(p)){this.remove(P,o,i);return}this.y(()=>{this.z(P,o,u),this.P(o)?.set(P,p,i)})}remove(P,p,o=!1){this.y(()=>{this.z(P,p,void 0),this.P(p)?.delete(P,o)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,p){const o=[],u=this.J(P);for(const i of Object.keys(u))u[i]===p&&o.push(i);return o}z(P,p,o,u=!1){const i=this.J(p);typeof o=="number"?i[P]!==o&&(i[P]=o,this.P(p)?.set(e.$eq,JSON.stringify(i),u)):typeof i[P]=="number"&&(delete i[P],this.P(p)?.set(e.$eq,JSON.stringify(i),u))}get D(){return this.C||(this.C=this.L($.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L($.PROFILE)),this.F}get I(){return this.H||(this.H=this.L($.APPLICATION)),this.H}J(P){switch(P){case $.APPLICATION:return this.I;case $.PROFILE:return this.G;default:return this.D}}L(P){const p=this.P(P);return p?g(p):Object.create(null)}isNew(P){return this.getBoolean(e.$dq,P)===!0}async flush(P=I.NONE){this.f.fire({reason:P});const p=this.P($.APPLICATION),o=this.P($.PROFILE),u=this.P($.WORKSPACE);switch(P){case I.NONE:await R.Promises.settled([p?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await R.Promises.settled([p?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P($.APPLICATION)?.items??new Map,p=this.P($.PROFILE)?.items??new Map,o=this.P($.WORKSPACE)?.items??new Map;return f(P,p,o,this.Q($.APPLICATION)??"",this.Q($.PROFILE)??"",this.Q($.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,p){return this.w(I.NONE),(0,b.$Il)(P)?this.R(P,p):this.S(P,p)}M(P,p){return!(P.id===p.id||m(p)&&m(P))}N(P,p,o){this.y(()=>{const u=new Set;for(const[i,n]of P)u.add(i),p.get(i)!==n&&this.u(o,{key:i,external:!0});for(const[i]of p.items)u.has(i)||this.u(o,{key:i,external:!0})})}}e.$hq=l;function m(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class E extends l{constructor(){super(),this.U=this.B(new O.$bq(new O.$cq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$bq(new O.$cq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$bq(new O.$cq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u($.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u($.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u($.APPLICATION,P)))}P(P){switch(P){case $.APPLICATION:return this.U;case $.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case $.APPLICATION:return"inMemory (application)";case $.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$jq=E;async function f(w,P,p,o,u,i){const n=v=>{try{return JSON.parse(v)}catch{return v}},t=new Map,s=new Map;w.forEach((v,T)=>{t.set(T,v),s.set(T,n(v))});const r=new Map,a=new Map;P.forEach((v,T)=>{r.set(T,v),a.set(T,n(v))});const h=new Map,y=new Map;p.forEach((v,T)=>{h.set(T,v),y.set(T,n(v))}),console.group(o!==u?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const L=[];if(t.forEach((v,T)=>{L.push({key:T,value:v})}),console.table(L),console.groupEnd(),console.log(s),o!==u){console.group(`Storage: Profile (path: ${u}, profile specific)`);const v=[];r.forEach((T,U)=>{v.push({key:U,value:T})}),console.table(v),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${i})`);const S=[];h.forEach((v,T)=>{S.push({key:T,value:v})}),console.table(S),console.groupEnd(),console.log(y)}}),define(he[118],ue([0,1,3,2,12,27,35,16]),function(oe,e,R,c,C,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eMb=e.$dMb=void 0;let k=class extends c.$Tc{constructor($,d){super(),this.a=new R.$je,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b($)),this.B(this.b.onDidChange(g=>this.a.fire({extensions:g,source:"storage"}))),this.B(d.onDidInstallExtensions(g=>g.forEach(({local:l,operation:m})=>{l&&m===A.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension($,d){return this.f($)?(this.a.fire({extensions:[$],source:d}),!0):!1}async disableExtension($,d){return this.c($)?(this.a.fire({extensions:[$],source:d}),!0):!1}getDisabledExtensions(){return this.h(A.$mp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c($){const d=this.getDisabledExtensions();return d.every(g=>!(0,N.$Jp)(g,$))?(d.push($),this.g(d),!0):!1}f($){const d=this.getDisabledExtensions();for(let g=0;g<d.length;g++){const l=d[g];if((0,N.$Jp)(l,$))return d.splice(g,1),this.g(d),!0}return!1}g($){this.j(A.$mp,$)}h($){return this.b.get($,O.StorageScope.PROFILE)}j($,d){this.b.set($,d,O.StorageScope.PROFILE)}};e.$dMb=k,e.$dMb=k=ve([Z(0,O.$fq),Z(1,A.$lp)],k);class b extends c.$Tc{constructor($){super(),this.c=$,this.a=Object.create(null),this.b=this.B(new R.$je),this.onDidChange=this.b.event,this.B($.onDidChangeValue(O.StorageScope.PROFILE,void 0,this.B(new c.$Sc))(d=>this.f(d)))}get($,d){let g;return d===O.StorageScope.PROFILE?((0,C.$lg)(this.a[$])&&(this.a[$]=this.g($,d)),g=this.a[$]):g=this.g($,d),JSON.parse(g)}set($,d,g){const l=JSON.stringify(d.map(({id:E,uuid:f})=>({id:E,uuid:f})));this.g($,g)!==l&&(g===O.StorageScope.PROFILE&&(d.length?this.a[$]=l:delete this.a[$]),this.h($,d.length?l:void 0,g))}f($){if(!(0,C.$lg)(this.a[$.key])&&this.g($.key,$.scope)!==this.a[$.key]){const g=this.get($.key,$.scope);delete this.a[$.key];const l=this.get($.key,$.scope),m=g.filter(f=>!l.some(w=>(0,N.$Jp)(f,w))),E=l.filter(f=>!g.some(w=>(0,N.$Jp)(w,f)));(m.length||E.length)&&this.b.fire([...m,...E])}}g($,d){return this.c.get($,d,"[]")}h($,d,g){d?this.c.store($,d,g,O.StorageTarget.MACHINE):this.c.remove($,g)}}e.$eMb=b}),define(he[85],ue([0,1,4,3,2,16,35,23,17,10,12]),function(oe,e,R,c,C,A,N,O,k,b,I){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$nw=void 0,e.$nw=(0,R.$Ci)("IExtensionStorageService");const d=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class extends C.$Tc{static{$=this}static{this.a=512*1024}static b(m){return`extensionKeys/${(0,N.$Np)(m.id)}@${m.version}`}static c(m){const E=d.exec(m);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(m,E){const f=await m.getInstalled(),w=[];for(const[P,p]of $.f(E)){const o=f.find(u=>(0,N.$Jp)(u.identifier,{id:P}))?.manifest.version;for(const u of p)o!==u&&w.push($.b({id:P,version:u}))}for(const P of w)E.remove(P,A.StorageScope.PROFILE)}static f(m){const E=new Map,f=m.keys(A.StorageScope.PROFILE,A.StorageTarget.MACHINE);for(const w of f){const P=$.c(w);if(P){let p=E.get(P.id.toLowerCase());p||E.set(P.id.toLowerCase(),p=[]),p.push(P.version)}}return E}constructor(m,E,f){super(),this.j=m,this.m=E,this.n=f,this.g=this.B(new c.$je),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=$.f(m),this.B(this.j.onDidChangeValue(A.StorageScope.PROFILE,void 0,this.B(new C.$Sc))(w=>this.r(w)))}r(m){if(this.h.has(m.key.toLowerCase())){this.g.fire();return}const E=$.c(m.key);if(E){if(this.j.get(m.key,A.StorageScope.PROFILE)===void 0)this.h.delete(E.id.toLowerCase());else{let f=this.h.get(E.id.toLowerCase());f||this.h.set(E.id.toLowerCase(),f=[]),f.push(E.version),this.g.fire()}return}}s(m){if((0,I.$cg)(m))return m;const E=m.manifest?m.manifest.publisher:m.publisher,f=m.manifest?m.manifest.name:m.name;return(0,N.$Mp)(E,f)}getExtensionState(m,E){const f=this.s(m),w=this.getExtensionStateRaw(m,E);if(w)try{return JSON.parse(w)}catch(P){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${E}): ${P}`)}}getExtensionStateRaw(m,E){const f=this.s(m),w=this.j.get(f,E?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE);return w&&w?.length>$.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${E}): ${w.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),w}setExtensionState(m,E,f){const w=this.s(m);E===void 0?this.j.remove(w,f?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE):this.j.store(w,JSON.stringify(E),f?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE,A.StorageTarget.MACHINE)}setKeysForSync(m,E){this.j.store($.b(m),JSON.stringify(E),A.StorageScope.PROFILE,A.StorageTarget.MACHINE)}getKeysForSync(m){const E=this.m.extensionSyncedKeys?.[m.id.toLowerCase()],f=this.j.get($.b(m),A.StorageScope.PROFILE),w=f?JSON.parse(f):void 0;return w&&E?(0,k.$Lb)([...w,...E]):w||E}addToMigrationList(m,E){if(m!==E){const f=this.t.filter(w=>!w.includes(m)&&!w.includes(E));f.push([m,E]),this.t=f}}getSourceExtensionToMigrate(m){const E=this.t.find(([,f])=>m===f);return E?E[0]:void 0}get t(){const m=this.j.get("extensionStorage.migrationList",A.StorageScope.APPLICATION,"[]");try{const E=JSON.parse(m);if(Array.isArray(E))return E}catch{}return[]}set t(m){m.length?this.j.store("extensionStorage.migrationList",JSON.stringify(m),A.StorageScope.APPLICATION,A.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",A.StorageScope.APPLICATION)}};e.$ow=g,e.$ow=g=$=ve([Z(0,A.$fq),Z(1,O.$qk),Z(2,b.$0j)],g)}),define(he[219],ue([0,1,2,27,85,197,117,10,16]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;let b=class extends R.$Tc{constructor($,d,g,l,m,E){super(),$.cleanUp(),(0,A.$e7b)($,d,g,l,E),C.$ow.removeOutdatedExtensionVersions($,m)}};e.$Vhc=b,e.$Vhc=b=ve([Z(0,N.$Vq),Z(1,c.$ip),Z(2,C.$nw),Z(3,c.$op),Z(4,k.$fq),Z(5,O.$0j)],b)}),define(he[220],ue([0,1,17,2,20,9,7,23,6,3,13,5,37,35,74,34,16]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=e.$bec=void 0;let f=class extends c.$Tc{constructor(u,i){super(),this.b=u,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,n])=>this.a.set(n.configPath,n))}getConfigBasedTips(u){return this.f(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(u){const i=[];for(const[n,t]of this.a)if(!(t.configScheme&&t.configScheme!==u.scheme))try{const s=(await this.b.readFile((0,C.$dh)(u,n))).value.toString();for(const[r,a]of Object.entries(t.recommendations))(!a.contentPattern||new RegExp(a.contentPattern,"mig").test(s))&&i.push({extensionId:r,extensionName:a.name,configName:t.configName,important:!!a.important,isExtensionPack:!!a.isExtensionPack,whenNotInstalled:a.whenNotInstalled})}catch{}return i}};e.$bec=f,e.$bec=f=ve([Z(0,N.$0k),Z(1,O.$qk)],f);const w="extensionTips/promptedExecutableTips",P="extensionTips/lastPromptedMediumImpExeTime";class p extends f{constructor(u,i,n,t,s,r,a,h){super(a,h),this.r=u,this.s=i,this.t=n,this.u=t,this.w=s,this.z=r,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,h.exeBasedExtensionTips&&Object.entries(h.exeBasedExtensionTips).forEach(([y,L])=>{const S=[],v=[],T=[];Object.entries(L.recommendations).forEach(([U,F])=>{F.important?L.important?S.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):v.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):T.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack})}),S.length&&this.g.set(y,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:S}),v.length&&this.h.set(y,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:v}),T.length&&this.j.set(y,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:T})}),(0,k.$Eh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const u=await this.O(this.g),i=await this.O(this.h);return[...u,...i]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const u=await this.O(this.g),i=await this.O(this.h),n=await this.u.getInstalled();this.m=this.D(u,n),this.n=this.D(i,n)}D(u,i){const n=new Map;u.forEach(h=>n.set(h.extensionId.toLowerCase(),h));const{installed:t,uninstalled:s}=this.N([...n.keys()],i);for(const h of t){const y=n.get(h);y&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:h,exeName:y.exeName})}for(const h of s){const y=n.get(h);y&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:h,exeName:y.exeName})}const r=this.L(),a=new Map;for(const h of s){const y=n.get(h);if(y&&(!r[y.exeName]||!r[y.exeName].includes(y.extensionId))){let L=a.get(y.exeName);L||(L=[],a.set(y.exeName,L)),L.push(y)}}return a}F(){if(this.m.size===0)return;const[u,i]=[...this.m.entries()][0];this.H(i).then(n=>{switch(n){case l.RecommendationsNotificationResult.Accepted:this.M(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(u);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this.B(new c.$Uc);t.value=(0,k.$Eh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const u=this.I(),i=Date.now()-u,n=7*24*60*60*1e3;if(i<n){const r=this.B(new c.$Uc);r.value=(0,k.$Eh)(()=>{r.dispose(),this.G()},n-i);return}const[t,s]=[...this.n.entries()][0];this.H(s).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(t),this.M(s[0].exeName,s);const a=this.B(new c.$Uc);a.value=(0,k.$Eh)(()=>{a.dispose(),this.G()},n);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(t),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const a=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(a(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const a=this.B(new c.$Uc);a.value=(0,k.$Eh)(()=>{a.dispose(),this.G()},60*60*1e3);break}}})}async H(u){const i=await this.u.getInstalled(m.ExtensionType.User),n=u.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(s=>i.every(r=>!(0,g.$Jp)(r.identifier,{id:s})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:n,source:l.RecommendationSource.EXE,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}I(){let u=this.w.getNumber(P,E.StorageScope.APPLICATION);return u||(u=Date.now(),this.J(u)),u}J(u){this.w.store(P,u,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(w,E.StorageScope.APPLICATION,"{}"))}M(u,i){const n=this.L();n[u]=i.map(({extensionId:t})=>t.toLowerCase()),this.w.store(w,JSON.stringify(n),E.StorageScope.APPLICATION,E.StorageTarget.USER)}N(u,i){const n=[],t=[],s=i.reduce((r,a)=>(r.add(a.identifier.id.toLowerCase()),r),new Set);return u.forEach(r=>{s.has(r.toLowerCase())?n.push(r):t.push(r)}),{installed:n,uninstalled:t}}async O(u){const i=[],n=new Map;for(const t of u.keys()){const s=u.get(t);if(!s||!(0,R.$Kb)(s.recommendations))continue;const r=[];$.$j?s.windowsPath&&r.push(s.windowsPath.replace("%USERPROFILE%",()=>d.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>d.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>d.env.ProgramFiles).replace("%APPDATA%",()=>d.env.APPDATA).replace("%WINDIR%",()=>d.env.WINDIR)):(r.push((0,I.$ic)("/usr/local/bin",t)),r.push((0,I.$ic)("/usr/bin",t)),r.push((0,I.$ic)(this.r.fsPath,t)));for(const a of r){let h=n.get(a);if(h===void 0&&(h=await this.b.exists(A.URI.file(a)),n.set(a,h)),h)for(const{extensionId:y,extensionName:L,isExtensionPack:S,whenNotInstalled:v}of s.recommendations)i.push({extensionId:y,extensionName:L,isExtensionPack:S,exeName:t,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:v})}}return i}}e.$cec=p}),define(he[221],ue([0,1,27,7,23,15,74,57,16,18,220]),function(oe,e,R,c,C,A,N,O,k,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;let $=class extends I.$cec{constructor(g,l,m,E,f,w,P,p){super(g.userHome,f,l,m,E,w,P,p)}};e.$3hc=$,e.$3hc=$=ve([Z(0,A.$Ki),Z(1,b.$9l),Z(2,R.$lp),Z(3,k.$fq),Z(4,O.$Xfc),Z(5,N.$Y6b),Z(6,c.$0k),Z(7,C.$qk)],$)}),define(he[49],ue([0,1,14,32,16]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=A;async function A(N,O,k){let b=k&&k.get("storage.serviceMachineId",C.StorageScope.APPLICATION)||null;if(b)return b;try{const $=(await O.readFile(N.serviceMachineIdResource)).value.toString();b=(0,c.$Xg)($)?$:null}catch{b=null}if(!b){b=(0,c.$Yg)();try{await O.writeFile(N.serviceMachineIdResource,R.$Le.fromString(b))}catch{}}return k?.store("storage.serviceMachineId",b,C.StorageScope.APPLICATION,C.StorageTarget.MACHINE),b}}),define(he[222],ue([0,1,49,18,48]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=A;async function A(N,O,k,b,I,$,d){const g={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${O.nameShort})`};if((0,C.$Bp)(O,k)&&(0,C.$Dp)(b)===c.TelemetryLevel.USAGE){const l=await(0,R.$lq)(k,I,$);g["X-Market-User-Id"]=l,g["VSCode-SessionId"]=d.machineId||l}return g}}),define(he[223],ue([0,1,17,25,8,5,37,12,9,21,15,27,35,34,59,7,10,23,61,222,16,18,54]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0,e.$nq=te;const i=A.$p?g.TargetPlatform.WEB:(0,$.$ep)(A.$v,N.$dc),n="X-Market-Search-Activity-Id";var t;(function(q){q[q.None=0]="None",q[q.IncludeVersions=1]="IncludeVersions",q[q.IncludeFiles=2]="IncludeFiles",q[q.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",q[q.IncludeSharedAccounts=8]="IncludeSharedAccounts",q[q.IncludeVersionProperties=16]="IncludeVersionProperties",q[q.ExcludeNonValidated=32]="ExcludeNonValidated",q[q.IncludeInstallationTargets=64]="IncludeInstallationTargets",q[q.IncludeAssetUri=128]="IncludeAssetUri",q[q.IncludeStatistics=256]="IncludeStatistics",q[q.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",q[q.Unpublished=4096]="Unpublished",q[q.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function s(...q){return String(q.reduce((M,Q)=>M|Q,0))}var r;(function(q){q[q.Tag=1]="Tag",q[q.ExtensionId=4]="ExtensionId",q[q.Category=5]="Category",q[q.ExtensionName=7]="ExtensionName",q[q.Target=8]="Target",q[q.Featured=9]="Featured",q[q.SearchText=10]="SearchText",q[q.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},L={pageNumber:1,pageSize:10,sortBy:$.SortBy.NoneOrRelevance,sortOrder:$.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class S{constructor(M=L){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,Q=this.d.pageSize){return new S({...this.d,pageNumber:M,pageSize:Q})}withFilter(M,...Q){const _=[...this.d.criteria,...Q.length?Q.map(Y=>({filterType:M,value:Y})):[{filterType:M}]];return new S({...this.d,criteria:_})}withSortBy(M){return new S({...this.d,sortBy:M})}withSortOrder(M){return new S({...this.d,sortOrder:M})}withFlags(...M){return new S({...this.d,flags:M.reduce((Q,_)=>Q|_,0)})}withAssetTypes(...M){return new S({...this.d,assetTypes:M})}withSource(M){return new S({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:Q,pageSize:_,sortBy:Y,sortOrder:re,flags:le,assetTypes:ge}=this.d;return{filters:[{criteria:M,pageNumber:Q,pageSize:_,sortBy:Y,sortOrder:re}],assetTypes:ge,flags:le}}get searchText(){const M=this.d.criteria.filter(Q=>Q.filterType===r.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(q,M){const Q=(q||[]).filter(_=>_.statisticName===M)[0];return Q?Q.value:0}function T(q){const M="Microsoft.VisualStudio.Code.Translation.";return q.files.filter(_=>_.assetType.indexOf(M)===0).reduce((_,Y)=>{const re=j(q,Y.assetType);return re&&_.push([Y.assetType.substring(M.length),re]),_},[])}function U(q){if(q.properties){const M=q.properties.filter(Y=>Y.key===a.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),_=M.filter(Y=>Q.test(Y.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return j(q,a.Repository)}function F(q){return{uri:`${q.fallbackAssetUri}/${a.VSIX}?redirect=true${q.targetPlatform?`&targetPlatform=${q.targetPlatform}`:""}`,fallbackUri:`${q.fallbackAssetUri}/${a.VSIX}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`}}function j(q,M){return q.files.filter(_=>_.assetType===M)[0]?{uri:`${q.assetUri}/${M}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`,fallbackUri:`${q.fallbackAssetUri}/${M}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`}:null}function G(q,M){const Q=q.properties?q.properties.filter(Y=>Y.key===M):[],_=Q.length>0&&Q[0].value;return _?_.split(",").map(Y=>(0,d.$Np)(Y)):[]}function V(q){const M=q.properties?q.properties.filter(Q=>Q.key===h.Engine):[];return M.length>0&&M[0].value||""}function x(q){const M=q.properties?q.properties.filter(Q=>Q.key===h.PreRelease):[];return M.length>0&&M[0].value==="true"}function H(q){const M=q.properties?q.properties.filter(_=>_.key===h.EnabledApiProposals):[],Q=M.length>0&&M[0].value||"";return Q?Q.split(","):[]}function ie(q){const M=q.properties?q.properties.filter(_=>_.key===h.LocalizedLanguages):[],Q=M.length>0&&M[0].value||"";return Q?Q.split(","):[]}function z(q){return q.properties?.find(M=>M.key===h.SponsorLink)?.value}function W(q){return q.properties?.find(M=>M.key===h.SupportLink)?.value}function ee(q){return q.indexOf("preview")!==-1}function ne(q){return q.targetPlatform?(0,$.$dp)(q.targetPlatform):g.TargetPlatform.UNDEFINED}function ce(q){const M=(0,R.$Lb)(q.versions.map(ne)),Q=!!q.tags?.includes($.$0o),_=M.indexOf(g.TargetPlatform.WEB);return Q?_===-1&&M.push(g.TargetPlatform.WEB):_!==-1&&M.splice(_,1),M}function te(q,M){for(let Q=0;Q<q.length;Q++){const _=q[Q];if(_.version===q[Q-1]?.version){let Y=Q;if(ne(_)===M)for(;Y>0&&q[Y-1].version===_.version;)Y--;Y!==Q&&(q.splice(Q,1),q.splice(Y,0,_))}}return q}function X(q,M,Q){q.telemetryData={index:M,querySource:Q,queryActivityId:q.queryContext?.[n]}}function K(q,M,Q,_){const Y=q.versions[0],re={manifest:j(M,a.Manifest),readme:j(M,a.Details),changelog:j(M,a.Changelog),license:j(M,a.License),repository:U(M),download:F(M),icon:j(M,a.Icon),signature:j(M,a.Signature),coreTranslations:T(M)};return{type:"gallery",identifier:{id:(0,d.$Op)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},name:q.extensionName,version:M.version,displayName:q.displayName,publisherId:q.publisher.publisherId,publisher:q.publisher.publisherName,publisherDisplayName:q.publisher.displayName,publisherDomain:q.publisher.domain?{link:q.publisher.domain,verified:!!q.publisher.isDomainVerified}:void 0,publisherSponsorLink:z(Y),description:q.shortDescription??"",installCount:v(q.statistics,"install"),rating:v(q.statistics,"averagerating"),ratingCount:v(q.statistics,"ratingcount"),categories:q.categories||[],tags:q.tags||[],releaseDate:Date.parse(q.releaseDate),lastUpdated:Date.parse(q.lastUpdated),allTargetPlatforms:Q,assets:re,properties:{dependencies:G(M,h.Dependency),extensionPack:G(M,h.ExtensionPack),engine:V(M),enabledApiProposals:H(M),localizedLanguages:ie(M),targetPlatform:ne(M),isPreReleaseVersion:x(M)},hasPreReleaseVersion:x(Y),hasReleaseVersion:!0,preview:ee(q.flags),isSigned:!!re.signature,queryContext:_,supportLink:W(Y)}}let B=class{constructor(M,Q,_,Y,re,le,ge,pe){this.l=Q,this.n=_,this.o=Y,this.q=re,this.u=le,this.w=ge,this.x=pe;const Ee=ge.extensionsGallery,we=Ee?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=we?Ee.servicePPEUrl:Ee?.serviceUrl,this.g=we?void 0:Ee?.searchUrl,this.h=Ee?.controlUrl,this.k=ge.extensionsEnabledWithApiProposalVersion?.map(be=>be.toLowerCase())??[],this.j=(0,P.$mq)(ge.version,ge,this.o,this.x,this.u,M,this.q)}y(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,Q,_){const Y=c.CancellationToken.isCancellationToken(Q)?{}:Q,re=c.CancellationToken.isCancellationToken(Q)?Q:_,le=[],ge=[],pe=[],Ee=[];let we=!0;for(const Re of M){Re.uuid?ge.push(Re.uuid):le.push(Re.id);const ae=!!(Re.version||Re.preRelease);pe.push({id:Re.id,uuid:Re.uuid,includePreRelease:ae}),Re.version&&Ee.push({id:Re.id,uuid:Re.uuid,version:Re.version}),we=we&&!!Re.hasPreRelease&&!ae}if(!ge.length&&!le.length)return[];let be=new S().withPage(1,M.length);ge.length&&(be=be.withFilter(r.ExtensionId,...ge)),le.length&&(be=be.withFilter(r.ExtensionName,...le)),(Y.queryAllVersions||we)&&(be=be.withFlags(be.flags,t.IncludeVersions)),Y.source&&(be=be.withSource(Y.source));const{extensions:Se}=await this.B(be,{targetPlatform:Y.targetPlatform??i,includePreRelease:pe,versions:Ee,compatible:!!Y.compatible,productVersion:Y.productVersion??{version:this.w.version,date:this.w.date}},re);return Y.source&&Se.forEach((Re,ae)=>X(Re,ae,Y.source)),Se}async getCompatibleExtension(M,Q,_,Y={version:this.w.version,date:this.w.date}){if((0,$.$fp)(M.allTargetPlatforms,_))return null;if(await this.isExtensionCompatible(M,Q,_))return M;const re=new S().withFlags(t.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,M.identifier.uuid),{extensions:le}=await this.B(re,{targetPlatform:_,compatible:!0,includePreRelease:Q,productVersion:Y},c.CancellationToken.None);return le[0]||null}async isExtensionCompatible(M,Q,_,Y={version:this.w.version,date:this.w.date}){if(!(0,$.$gp)(M.properties.targetPlatform,M.allTargetPlatforms,_)||!Q&&M.properties.isPreReleaseVersion)return!1;let re=M.properties.engine;if(!re){const le=await this.getManifest(M,c.CancellationToken.None);if(!le)throw new Error("Manifest was not found");re=le.engines.vscode}return!(!(0,l.$3p)(re,Y.version,Y.date)||!this.z(M.identifier,M.properties.enabledApiProposals))}z(M,Q){return!Q||!this.k.includes(M.id.toLowerCase())?!0:(0,l.$4p)(Q)}async A(M,Q,_,Y,re,le,ge={version:this.w.version,date:this.w.date}){if(!(0,$.$gp)(ne(Q),re,le)||_!=="any"&&x(Q)!==(_==="prerelease"))return!1;if(Y)try{const pe=await this.G(M,Q);if(!(0,l.$3p)(pe,ge.version,ge.date))return!1}catch(pe){return this.n.error(`Error while getting the engine for the version ${Q.version}.`,(0,C.$9)(pe)),!1}return!0}async query(M,Q){let _=M.text||"";const Y=M.pageSize??50;let re=new S().withPage(1,Y);_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Se)=>(re=re.withFilter(r.Category,Se||be),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Se)=>(re=re.withFilter(r.Tag,Se||be),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),re=re.withFilter(r.SearchText,_)),re=re.withSortBy($.SortBy.NoneOrRelevance)):M.ids?re=re.withFilter(r.ExtensionId,...M.ids):M.names?re=re.withFilter(r.ExtensionName,...M.names):re=re.withSortBy($.SortBy.InstallCount),typeof M.sortBy=="number"&&(re=re.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(re=re.withSortOrder(M.sortOrder)),M.source&&(re=re.withSource(M.source));const le=async(we,be)=>{const{extensions:Se,total:Re}=await this.B(we,{targetPlatform:i,compatible:!1,includePreRelease:!!M.includePreRelease,productVersion:M.productVersion??{version:this.w.version,date:this.w.date}},be);return Se.forEach((ae,de)=>X(ae,(we.pageNumber-1)*we.pageSize+de,M.source)),{extensions:Se,total:Re}},{extensions:ge,total:pe}=await le(re,Q),Ee=async(we,be)=>{if(be.isCancellationRequested)throw new C.$4;const{extensions:Se}=await le(re.withPage(we+1),be);return Se};return{firstPage:ge,total:pe,pageSize:re.pageSize,getPage:Ee}}async B(M,Q,_){const Y=M.flags;M.flags&t.IncludeLatestVersionOnly&&M.flags&t.IncludeVersions&&(M=M.withFlags(M.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(M.flags&t.IncludeLatestVersionOnly)&&!(M.flags&t.IncludeVersions)&&(M=M.withFlags(M.flags,t.IncludeLatestVersionOnly)),Q.versions?.length&&(M=M.withFlags(M.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),M=M.withFlags(M.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:re,total:le,context:ge}=await this.D(M,_);if(!(M.flags&t.IncludeLatestVersionOnly)){const be=[];for(const Se of re){const Re=await this.C(Se,Q,ge);Re&&be.push(Re)}return{extensions:be,total:le}}const Ee=[],we=new Map;for(let be=0;be<re.length;be++){const Se=re[be],Re={id:(0,d.$Op)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},ae=(0,O.$ig)(Q.includePreRelease)?Q.includePreRelease:!!Q.includePreRelease.find(me=>(0,d.$Jp)(me,Re))?.includePreRelease;if(Q.compatible&&(0,$.$fp)(ce(Se),Q.targetPlatform))continue;const de=await this.C(Se,Q,ge);!de||de.properties.isPreReleaseVersion&&(!ae||!de.hasReleaseVersion)||!de.properties.isPreReleaseVersion&&de.properties.targetPlatform!==Q.targetPlatform&&de.hasPreReleaseVersion?we.set(Se.extensionId,be):Ee.push([be,de])}if(we.size){const be=new u.$de,Se=new S().withFlags(Y&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,we.size).withFilter(r.ExtensionId,...we.keys()),{extensions:Re}=await this.B(Se,Q,_);this.q.publicLog2("galleryService:additionalQuery",{duration:be.elapsed(),count:we.size});for(const ae of Re){const de=we.get(ae.identifier.uuid);Ee.push([de,ae])}}return{extensions:Ee.sort((be,Se)=>be[0]-Se[0]).map(([,be])=>be),total:le}}async C(M,Q,_){const Y={id:(0,d.$Op)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},re=Q.versions?.find(Ee=>(0,d.$Jp)(Ee,Y))?.version,le=(0,O.$ig)(Q.includePreRelease)?Q.includePreRelease:!!Q.includePreRelease.find(Ee=>(0,d.$Jp)(Ee,Y))?.includePreRelease,ge=ce(M),pe=te(M.versions,Q.targetPlatform);if(Q.compatible&&(0,$.$fp)(ge,Q.targetPlatform))return null;for(let Ee=0;Ee<pe.length;Ee++){const we=pe[Ee];if(!(re&&we.version!==re)){if(await this.A(Y.id,we,le?"any":"release",Q.compatible,ge,Q.targetPlatform,Q.productVersion))return Q.compatible&&!this.z(Y,H(we))?null:K(M,we,ge,_);if(re&&we.version===re)return null}}return re||Q.compatible?null:K(M,M.versions[0],ge)}async D(M,Q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,t.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,s(t.Unpublished));const _=await this.j,Y=JSON.stringify(M.raw),re={..._,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},le=new u.$de;let ge,pe,Ee=0;try{if(ge=await this.l.request({type:"POST",url:this.g&&M.criteria.some(be=>be.filterType===r.SearchText)?this.g:this.y("/extensionquery"),data:Y,headers:re},Q),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Ee};const we=await(0,w.$$p)(ge);if(we){const be=we.results[0],Se=be.extensions,Re=be.resultMetadata&&be.resultMetadata.filter(ae=>ae.metadataType==="ResultCount")[0];return Ee=Re&&Re.metadataItems.filter(ae=>ae.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:Ee,context:{[n]:ge.res.headers.activityid}}}return{galleryExtensions:[],total:Ee}}catch(we){if((0,C.$3)(we))throw pe=$.ExtensionGalleryErrorCode.Cancelled,we;{const be=(0,C.$9)(we);throw pe=be.startsWith("XHR timeout")?$.ExtensionGalleryErrorCode.Timeout:$.ExtensionGalleryErrorCode.Failed,new $.$jp(be,pe)}}finally{this.q.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(Y.length),duration:le.elapsed(),success:!!ge&&(0,w.$7p)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:pe,count:String(Ee)})}}async reportStatistic(M,Q,_,Y){if(!this.isEnabled())return;const re=A.$p?this.y(`/itemName/${M}.${Q}/version/${_}/statType/${Y===$.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${M}/extensions/${Q}/${_}/stats?statType=${Y}`),le=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:le};try{await this.l.request({type:"POST",url:re,headers:pe},c.CancellationToken.None)}catch{}}async download(M,Q,_){this.n.trace("ExtensionGalleryService#download",M.identifier.id);const Y=(0,d.$Rp)(M),re=new Date().getTime(),le=_===$.InstallOperation.Install?"install":_===$.InstallOperation.Update?"update":"",ge=le?{uri:`${M.assets.download.uri}${k.URI.parse(M.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${M.assets.download.fallbackUri}${k.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:M.assets.download,pe=M.queryContext?.[n]?{[n]:M.queryContext[n]}:void 0,Ee=await this.F(M.identifier.id,ge,a.VSIX,pe?{headers:pe}:void 0);try{await this.u.writeFile(Q,Ee.stream)}catch(we){try{await this.u.del(Q)}catch(be){this.n.warn(`Error while deleting the file ${Q.toString()}`,(0,C.$9)(be))}throw new $.$jp((0,C.$9)(we),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...Y,duration:new Date().getTime()-re})}async downloadSignatureArchive(M,Q){if(!M.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const _=await this.F(M.identifier.id,M.assets.signature,a.Signature);try{await this.u.writeFile(Q,_.stream)}catch(Y){try{await this.u.del(Q)}catch(re){this.n.warn(`Error while deleting the file ${Q.toString()}`,(0,C.$9)(re))}throw new $.$jp((0,C.$9)(Y),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(M,Q){if(M.assets.readme){const _=await this.F(M.identifier.id,M.assets.readme,a.Details,{},Q);return await(0,w.$0p)(_)||""}return""}async getManifest(M,Q){if(M.assets.manifest){const _=await this.F(M.identifier.id,M.assets.manifest,a.Manifest,{},Q),Y=await(0,w.$0p)(_);return Y?JSON.parse(Y):null}return null}async E(M,Q,_){const Y=j(Q,a.Manifest);if(!Y)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},le=await this.F(M,Y,a.Manifest,{headers:re});return await(0,w.$$p)(le)}async getCoreTranslation(M,Q){const _=M.assets.coreTranslations.filter(Y=>Y[0]===Q.toUpperCase())[0];if(_){const Y=await this.F(M.identifier.id,_[1],_[0]),re=await(0,w.$0p)(Y);return re?JSON.parse(re):null}return null}async getChangelog(M,Q){if(M.assets.changelog){const _=await this.F(M.identifier.id,M.assets.changelog,a.Changelog,{},Q);return await(0,w.$0p)(_)||""}return""}async getAllCompatibleVersions(M,Q,_){let Y=new S().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);M.uuid?Y=Y.withFilter(r.ExtensionId,M.uuid):Y=Y.withFilter(r.ExtensionName,M.id);const{galleryExtensions:re}=await this.D(Y,c.CancellationToken.None);if(!re.length)return[];const le=ce(re[0]);if((0,$.$fp)(le,_))return[];const ge=[];await Promise.all(re[0].versions.map(async we=>{try{await this.A(M.id,we,Q?"any":"release",!0,le,_)&&this.z(M,H(we))&&ge.push(we)}catch{}}));const pe=[],Ee=new Set;for(const we of te(ge,_))Ee.has(we.version)||(Ee.add(we.version),pe.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:x(we)}));return pe}async F(M,Q,_,Y={},re=c.CancellationToken.None){const le=await this.j,ge={type:"GET"},pe={...le,...Y.headers||{}};Y={...Y,...ge,headers:pe};const Ee=Q.uri,we=Q.fallbackUri,be={...Y,url:Ee};try{const Se=await this.l.request(be,re);if(Se.res.statusCode===200)return Se;const Re=await(0,w.$0p)(Se);throw new Error(`Expected 200, got back ${Se.res.statusCode} instead.

${Re}`)}catch(Se){if((0,C.$3)(Se))throw Se;const Re=(0,C.$9)(Se);this.q.publicLog2("galleryService:cdnFallback",{extension:M,assetType:_,message:Re});const ae={...Y,url:we};return this.l.request(ae,re)}}async G(M,Q){let _=V(Q);if(!_){this.q.publicLog2("galleryService:engineFallback",{extension:M,version:Q.version});const Y=await this.E(M,Q,c.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");_=Y.engines.vscode}return _}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const M=await this.l.request({type:"GET",url:this.h},c.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,w.$$p)(M),_=[],Y={},re=[],le=[];if(Q){for(const ge of Q.malicious)_.push({id:ge});if(Q.migrateToPreRelease)for(const[ge,pe]of Object.entries(Q.migrateToPreRelease))(!pe.engine||(0,l.$3p)(pe.engine,this.w.version,this.w.date))&&(Y[ge.toLowerCase()]={disallowInstall:!0,extension:{id:pe.id,displayName:pe.displayName,autoMigrate:{storage:!!pe.migrateStorage},preRelease:!0}});if(Q.deprecated)for(const[ge,pe]of Object.entries(Q.deprecated))pe&&(Y[ge.toLowerCase()]=(0,O.$ig)(pe)?{}:pe);if(Q.search)for(const ge of Q.search)re.push(ge);if(Array.isArray(Q.extensionsEnabledWithPreRelease))for(const ge of Q.extensionsEnabledWithPreRelease)le.push(ge.toLowerCase())}return{malicious:_,deprecated:Y,search:re,extensionsEnabledWithPreRelease:le}}};B=ve([Z(1,w.$5p),Z(2,E.$0j),Z(3,I.$Ji),Z(4,o.$9l),Z(5,m.$0k),Z(6,f.$qk),Z(7,b.$9i)],B);let D=class extends B{constructor(M,Q,_,Y,re,le,ge,pe){super(M,Q,_,Y,re,le,ge,pe)}};e.$oq=D,e.$oq=D=ve([Z(0,p.$fq),Z(1,w.$5p),Z(2,E.$0j),Z(3,I.$Ji),Z(4,o.$9l),Z(5,m.$0k),Z(6,f.$qk),Z(7,b.$9i)],D);let J=class extends B{constructor(M,Q,_,Y,re,le,ge){super(void 0,M,Q,_,Y,re,le,ge)}};e.$pq=J,e.$pq=J=ve([Z(0,w.$5p),Z(1,E.$0j),Z(2,I.$Ji),Z(3,o.$9l),Z(4,m.$0k),Z(5,f.$qk),Z(6,b.$9i)],J)}),define(he[224],ue([0,1,107,3,18,15,2,10,13,68,23,5,6,101,21,11,38,16,12,143,20]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;const o=[R.$Rhc,R.$Shc],u="remoteTunnelSession",i="remoteTunnelIsService";let n=class extends N.$Tc{constructor(a,h,y,L,S,v,T){super(),this.y=a,this.z=h,this.C=y,this.D=v,this.F=T,this.f=new c.$je,this.onDidTokenFailed=this.f.event,this.g=new c.$je,this.onDidChangeTunnelStatus=this.g.event,this.h=new c.$je,this.onDidChangeMode=this.h.event,this.n=R.$Phc,this.w=!1,this.I=(U,F)=>{F?this.j.error(U):this.j.info(U)},this.j=this.B(L.createLogger((0,p.$dh)(y.logsHome,`${R.$Thc}.log`),{id:R.$Thc,name:R.$Uhc})),this.t=new d.$zh(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,O.$mk)(U)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(v.onDidChangeConfiguration(U=>{o.some(F=>U.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=R.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){s(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(h){this.j.error(h)}return this.s}J(){if(!this.u){let a;$.$k?a=this.C.appRoot:a=(0,k.$lc)((0,k.$lc)(this.C.appRoot)),this.u=(0,k.$ic)(a,"bin",`${this.z.tunnelApplicationName}${$.$j?".exe":""}`)}return this.u}async startTunnel(a){if(s(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(h){this.j.error(h)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(R.$Phc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(h){this.j.error(h)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(R.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",h=!1;const y=(F,j)=>{j?this.j.error(F):a+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(R.TunnelStates.connecting((0,m.localize)(11098,null)))},L=this.O("status",["status"],y);this.r=L;try{if(await L,this.r!==L)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(j=>j.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(R.TunnelStates.disconnected());return}if(h=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(R.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(R.TunnelStates.disconnected());return}finally{this.r===L&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const F=S.token;this.G(R.TunnelStates.connecting((0,m.localize)(11099,null,S.accountLabel,S.providerId)));const j=(V,x)=>{V=V.replaceAll(F,"*".repeat(4)),y(V,x)},G=this.O("login",["user","login","--provider",S.providerId,"--log",(0,O.$mk)(this.j.getLevel())],j,{VSCODE_CLI_ACCESS_TOKEN:F});this.r=G;try{if(await G,this.r!==G)return}catch(V){this.j.error(V),this.r=void 0,this.f.fire(S),this.G(R.TunnelStates.disconnected(S));return}}const v=this.Q();v?this.G(R.TunnelStates.connecting((0,m.localize)(11100,null,v))):this.G(R.TunnelStates.connecting((0,m.localize)(11101,null)));const T=["--accept-server-license-terms","--log",(0,O.$mk)(this.j.getLevel())];v?T.push("--name",v):T.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!h&&(U=await this.M(T)===!1),this.N(S,T,U)}async M(a){let h;try{h=await this.O("serviceInstall",["service","install",...a])}catch(y){this.j.error(y),h=1}if(h!==0){const y=(0,m.localize)(11102,null);return this.j.warn(y),this.G(R.TunnelStates.connecting(y)),!1}return!0}async N(a,h,y){h.push("--parent-process-id",String(process.pid)),this.P()&&h.push("--no-sleep");let L=!1;const S=this.O("tunnel",h,(v,T)=>{T?this.j.error(v):this.j.info(v),v.includes("Connected to an existing tunnel process")&&(L=!0);const U=v.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const F={link:U[1],domain:U[2],tunnelName:U[4],isAttached:L};this.G(R.TunnelStates.connected(F,y))}else v.match(/error refreshing token/)&&(S.cancel(),this.f.fire(a),this.G(R.TunnelStates.disconnected(a)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=R.$Phc,this.G(R.TunnelStates.disconnected()))})}O(a,h,y=this.I,L){return(0,d.$ph)(S=>new Promise((v,T)=>{S.isCancellationRequested&&v(-1);let U;const F=["ignore","pipe","pipe"];if(S.onCancellationRequested(()=>{U&&(this.j.info(`${a} terminating(${U.pid})`),U.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${a} Spawning: cargo run -- tunnel ${h.join(" ")}
`,!1),U=(0,b.spawn)("cargo",["run","--","tunnel",...h],{cwd:(0,k.$ic)(this.C.appRoot,"cli"),stdio:F,env:{...process.env,RUST_BACKTRACE:"1",...L}});else{y(`Running tunnel CLI
`,!1);const j=this.J();y(`${a} Spawning: ${j} tunnel ${h.join(" ")}
`,!1),U=(0,b.spawn)(j,["tunnel",...h],{cwd:(0,E.homedir)(),stdio:F,env:{...process.env,...L}})}U.stdout.pipe(new P.$AX(`
`)).on("data",j=>{if(U){const G=j.toString();y(G,!1)}}),U.stderr.pipe(new P.$AX(`
`)).on("data",j=>{if(U){const G=j.toString();y(G,!0)}}),U.on("exit",j=>{U&&(y(`${a} exit(${U.pid}): + ${j} `,!1),U=void 0,v(j||0))}),U.on("error",j=>{U&&(y(`${a} error(${U.pid}): + ${j} `,!0),U=void 0,T())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(R.$Shc)}Q(){let a=this.D.getValue(R.$Rhc)||(0,E.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(u,f.StorageScope.APPLICATION),h=this.F.getBoolean(i,f.StorageScope.APPLICATION,!1);if(a){const y=JSON.parse(a);if(y&&(0,w.$cg)(y.accountLabel)&&(0,w.$cg)(y.sessionId)&&(0,w.$cg)(y.providerId))return{active:!0,session:y,asService:h};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(a){this.j.error("Problems restoring session from storage",a)}return R.$Phc}S(a){if(a.active){const h={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(u,JSON.stringify(h),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),this.F.store(i,a.asService,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.F.remove(u,f.StorageScope.APPLICATION),this.F.remove(i,f.StorageScope.APPLICATION)}};e.$Yhc=n,e.$Yhc=n=ve([Z(0,C.$9l),Z(1,I.$qk),Z(2,A.$Ki),Z(3,O.$$j),Z(4,g.$Whc),Z(5,l.$9i),Z(6,f.$fq)],n);function t(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const s=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&t(r.session,a.session):!0}),define(he[225],ue([0,1,6,2,22,20,70,16,79,19]),function(oe,e,R,c,C,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class I extends O.$hq{constructor(d,g,l,m){super(),this.bb=d,this.cb=g,this.db=l,this.eb=m,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new c.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new c.$Sc),this.ab=this.hb(this.bb)}fb(){const d=this.B(new k.$NMb(this.db.getChannel("storage"))),g=this.B(new N.$bq(d));return this.B(g.onDidChangeStorage(l=>this.u(O.StorageScope.APPLICATION,l))),g}gb(d){this.X.clear(),this.W=d;let g;if((0,O.$iq)(d))g=this.U;else{const l=this.X.add(new k.$OMb(this.db.getChannel("storage"),d));g=this.X.add(new N.$bq(l))}return this.X.add(g.onDidChangeStorage(l=>this.u(O.StorageScope.PROFILE,l))),g}hb(d){this.$.clear(),this.Z=d?.id;let g;if(d){const l=this.$.add(new k.$PMb(this.db.getChannel("storage"),d));g=this.$.add(new N.$bq(l)),this.$.add(g.onDidChangeStorage(m=>this.u(O.StorageScope.WORKSPACE,m)))}return g}async O(){await R.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(d){switch(d){case O.StorageScope.APPLICATION:return this.U;case O.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(d){switch(d){case O.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:C.Schemas.file}).fsPath;case O.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:C.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$dh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:C.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(O.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(d){if(!this.M(this.W,d))return;const g=this.Y,l=g.items;g!==this.U&&await g.close(),this.Y=this.gb(d),await this.Y.init(),this.N(l,this.Y,O.StorageScope.PROFILE)}async S(d,g){const l=this.ab,m=l?.items??new Map;await l?.close(),this.ab=this.hb(d),await this.ab.init(),this.N(m,this.ab,O.StorageScope.WORKSPACE)}hasScope(d){return(0,b.$Il)(d)?this.W.id===d.id:this.Z===d.id}}e.$4hc=I}),define(he[226],ue([0,1,3,2,19,94]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=e.$BR=void 0;class N{constructor(b,I){this.a=b,this.b=I}listen(b,I){const $=this.b(b);switch(I){case"onDidChangeProfiles":return R.Event.map(this.a.onDidChangeProfiles,d=>({all:d.all.map(g=>(0,A.$Ln)({...g},$)),added:d.added.map(g=>(0,A.$Ln)({...g},$)),removed:d.removed.map(g=>(0,A.$Ln)({...g},$)),updated:d.updated.map(g=>(0,A.$Ln)({...g},$))}))}throw new Error(`Invalid listen ${I}`)}async call(b,I,$){const d=this.b(b);switch(I){case"createProfile":{const g=await this.a.createProfile($[0],$[1],$[2]);return(0,A.$Ln)({...g},d)}case"updateProfile":{let g=(0,C.$Kl)((0,A.$Mn)($[0],d),this.a.profilesHome.scheme);return g=await this.a.updateProfile(g,$[1]),(0,A.$Ln)({...g},d)}case"removeProfile":{const g=(0,C.$Kl)((0,A.$Mn)($[0],d),this.a.profilesHome.scheme);return this.a.removeProfile(g)}}throw new Error(`Invalid call ${I}`)}}e.$BR=N;class O extends c.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,I,$){super(),this.profilesHome=I,this.f=$,this.a=[],this.b=this.B(new R.$je),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(d=>(0,C.$Kl)(d,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(d=>{const g=d.added.map(E=>(0,C.$Kl)(E,this.profilesHome.scheme)),l=d.removed.map(E=>(0,C.$Kl)(E,this.profilesHome.scheme)),m=d.updated.map(E=>(0,C.$Kl)(E,this.profilesHome.scheme));this.a=d.all.map(E=>(0,C.$Kl)(E,this.profilesHome.scheme)),this.b.fire({added:g,removed:l,updated:m,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,I,$){const d=await this.f.call("createNamedProfile",[b,I,$]);return(0,C.$Kl)(d,this.profilesHome.scheme)}async createProfile(b,I,$,d){const g=await this.f.call("createProfile",[b,I,$,d]);return(0,C.$Kl)(g,this.profilesHome.scheme)}async createTransientProfile(b){const I=await this.f.call("createTransientProfile",[b]);return(0,C.$Kl)(I,this.profilesHome.scheme)}async setProfileForWorkspace(b,I){await this.f.call("setProfileForWorkspace",[b,I])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,I){const $=await this.f.call("updateProfile",[b,I]);return(0,C.$Kl)($,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$CR=O}),define(he[62],ue([0,1,2,70,4,16,3,79,19]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TMb=e.$SMb=e.$RMb=void 0,e.$RMb=(0,C.$Ci)("IUserDataProfileStorageService");let b=class extends R.$Tc{constructor(g,l){super(),this.b=l,g&&(this.a=this.B(new R.$3c))}async readStorageData(g){return this.withProfileScopedStorageService(g,async l=>this.c(l))}async updateStorageData(g,l,m){return this.withProfileScopedStorageService(g,async E=>this.f(E,l,m))}async withProfileScopedStorageService(g,l){if(this.b.hasScope(g))return l(this.b);let m=this.a?.get(g.id);if(!m){m=new $(this.g(g)),this.a?.set(g.id,m);try{await m.initialize()}catch(E){throw this.a?.has(g.id)?this.a.deleteAndDispose(g.id):m.dispose(),E}}try{const E=await l(m);return await m.flush(),E}finally{this.a?.has(g.id)||m.dispose()}}c(g){const l=new Map,m=E=>{for(const f of g.keys(A.StorageScope.PROFILE,E))l.set(f,{value:g.get(f,A.StorageScope.PROFILE),target:E})};return m(A.StorageTarget.USER),m(A.StorageTarget.MACHINE),l}f(g,l,m){g.storeAll(Array.from(l.entries()).map(([E,f])=>({key:E,value:f,scope:A.StorageScope.PROFILE,target:m})),!0)}};e.$SMb=b,e.$SMb=b=ve([Z(1,A.$fq)],b);class I extends b{constructor(g,l,m,E,f){super(g,E),this.j=l;const w=l.getChannel("profileStorageListener"),P=this.B(new R.$Uc);this.h=this.B(new N.$je({onWillAddFirstListener:()=>{P.value=w.listen("onDidChange")(p=>{f.trace("profile storage changes",p),this.h.fire({targetChanges:p.targetChanges.map(o=>(0,k.$Kl)(o,m.profilesHome.scheme)),valueChanges:p.valueChanges.map(o=>({...o,profile:(0,k.$Kl)(o.profile,m.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>P.value=void 0})),this.onDidChange=this.h.event}async g(g){const l=this.j.getChannel("storage");return(0,A.$iq)(g)?new O.$NMb(l):new O.$OMb(l,g)}}e.$TMb=I;class $ extends A.$hq{constructor(g){super({flushInterval:100}),this.U=g}async O(){const g=await this.U,l=new c.$bq(g);return this.B(l.onDidChangeStorage(m=>{this.u(A.StorageScope.PROFILE,m)})),this.B((0,R.$Rc)(()=>{l.close(),l.dispose(),(0,R.$Nc)(g)&&g.dispose()})),this.s=l,this.s.init()}P(g){return g===A.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(he[227],ue([0,1,16,10,19,56,62]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;let O=class extends N.$TMb{constructor(b,I,$,d){super(!0,b,I,$,d)}};e.$Ihc=O,e.$Ihc=O=ve([Z(0,A.$dhc),Z(1,C.$Jl),Z(2,R.$fq),Z(3,c.$0j)],O)}),define(he[40],ue([0,1,17,6,14,25,3,36,2,26,12,11,21,15,7,10,49,16,18,28,24,19]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Nb=e.$ZNb=e.$YNb=e.$XNb=void 0,e.$UNb=u,e.$VNb=i,e.$WNb=n;function u(h){return!!(h&&h.ref!==void 0&&typeof h.ref=="string"&&h.ref!==""&&h.syncData!==void 0&&(h.syncData===null||i(h.syncData)))}function i(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}function n(h,y){return`${(0,b.$7f)(h)}${y.isDefault?"":` (${y.name})`}`}let t=class extends k.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,L,S,v,T,U,F,j,G,V,x,H){super(),this.syncResource=y,this.collection=L,this.G=S,this.H=v,this.I=T,this.J=U,this.L=F,this.M=j,this.N=G,this.O=V,this.P=x,this.c=null,this.m=p.SyncStatus.Idle,this.n=this.B(new N.$je),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new N.$je),this.onDidChangeConflicts=this.t.event,this.u=this.B(new c.$Ah(50)),this.w=this.B(new N.$je),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(y.syncResource,y.profile),this.h=H.extUri,this.f=this.h.joinPath(v.userDataSyncHome,...(0,p.$snb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,p.$Nnb),this.y=(0,p.$tnb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,v,this.h),this.j=(0,E.$lq)(v,S,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===p.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const L=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(L)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,L={}){await this.U(y,!0,this.ob(),L)}async preview(y,L,S={}){return this.U(y,!1,L,S)}async apply(y,L={}){try{this.F={...L};const S=await this.ab(y);return this.S(S),this.c}finally{this.F={}}}async U(y,L,S,v){try{if(this.F={...v},this.status===p.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===p.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(p.SyncStatus.Syncing);let T=p.SyncStatus.Idle;try{const U=await this.getLastSyncUserData(),F=await this.X(y,U);return T=await this.Y(F,U,L,S),T===p.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T===p.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(y){const L=this.kb(y);if(!L)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(p.SyncStatus.Syncing);const S=await this.getLastSyncUserData(),v=await this.X(null,S),T=await this.W(v),U=await this.qb({ref:v.ref,syncData:L},S,T,this.ob(),A.CancellationToken.None),F=[];for(const j of U){const G=await this.sb(j,j.remoteResource,void 0,A.CancellationToken.None),{remoteChange:V}=await this.sb(j,j.previewResource,j.remoteContent,A.CancellationToken.None);F.push([j,{...G,remoteChange:V!==p.Change.None?V:p.Change.Modified}])}await this.tb(v,S,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(p.SyncStatus.Idle)}return!0}async W(y){const L=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===L}async X(y,L){if(L){const S=y?y[this.resource]:void 0;if(L.ref===S||S===void 0&&L.syncData===null)return L}return this.getRemoteUserData(L)}async Y(y,L,S,v){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new p.$Anb((0,$.localize)(10940,null,this.resource,this.pb,y.syncData.version),p.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(y,L,S,v)}catch(T){if(T instanceof p.$Anb)switch(T.code){case p.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,L,S,v);case p.UserDataSyncErrorCode.Conflict:case p.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),L=await this.getLastSyncUserData(),this.Y(y,L,S,v)}throw T}}async Z(y,L,S,v){try{const T=await this.W(y),U=!T&&L===null&&this.gb()!==void 0,F=S&&!U;this.c||(this.c=(0,c.$ph)(G=>this.eb(y,L,T,F,v,G)));let j=await this.c;if(S&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const G of j.resourcePreviews)j=await this.accept(G.remoteResource)||j}return this.cb(j.resourcePreviews),j.resourcePreviews.some(({mergeState:G})=>G===p.MergeState.Conflict)?p.SyncStatus.HasConflicts:S?await this.ab(!1):p.SyncStatus.Syncing}catch(T){throw this.c=null,T}}async merge(y){return await this.$(y,async L=>{const S=await this.rb(L,A.CancellationToken.None);await this.G.writeFile(L.previewResource,C.$Le.fromString(S?.content||""));const v=S&&!S.hasConflicts?await this.sb(L,L.previewResource,void 0,A.CancellationToken.None):void 0;return L.acceptResult=v,L.mergeState=S.hasConflicts?p.MergeState.Conflict:v?p.MergeState.Accepted:p.MergeState.Preview,L.localChange=v?v.localChange:S.localChange,L.remoteChange=v?v.remoteChange:S.remoteChange,L}),this.c}async accept(y,L){return await this.$(y,async S=>{const v=await this.sb(S,y,L,A.CancellationToken.None);return S.acceptResult=v,S.mergeState=p.MergeState.Accepted,S.localChange=v.localChange,S.remoteChange=v.remoteChange,S}),this.c}async discard(y){return await this.$(y,async L=>{const S=await this.rb(L,A.CancellationToken.None);return await this.G.writeFile(L.previewResource,C.$Le.fromString(S.content||"")),L.acceptResult=void 0,L.mergeState=p.MergeState.Preview,L.localChange=S.localChange,L.remoteChange=S.remoteChange,L}),this.c}async $(y,L){if(!this.c)return;let S=await this.c;const v=S.resourcePreviews.findIndex(({localResource:T,remoteResource:U,previewResource:F})=>this.h.isEqual(T,y)||this.h.isEqual(U,y)||this.h.isEqual(F,y));v!==-1&&(this.c=(0,c.$ph)(async T=>{const U=[...S.resourcePreviews];return U[v]=await L(U[v]),{...S,resourcePreviews:U}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:T})=>T===p.MergeState.Conflict)?this.S(p.SyncStatus.HasConflicts):this.S(p.SyncStatus.Syncing))}async ab(y){if(!this.c)return p.SyncStatus.Idle;const L=await this.c;return L.resourcePreviews.some(({mergeState:S})=>S===p.MergeState.Conflict)?p.SyncStatus.HasConflicts:L.resourcePreviews.some(({mergeState:S})=>S!==p.MergeState.Accepted)?p.SyncStatus.Syncing:(await this.tb(L.remoteUserData,L.lastSyncUserData,L.resourcePreviews.map(S=>[S,S.acceptResult]),y),this.c=null,await this.bb(),p.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const L=y.filter(({mergeState:S})=>S===p.MergeState.Conflict);(0,R.$tb)(this.s,L,(S,v)=>this.h.isEqual(S.previewResource,v.previewResource))||(this.s=L,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const L=this.c?await this.c:null;if(L)for(const S of L.resourcePreviews){if(this.h.isEqual(S.acceptedResource,y))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,y))return S.remoteContent;if(this.h.isEqual(S.localResource,y))return S.localContent;if(this.h.isEqual(S.baseResource,y))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,f.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(y){(0,l.$ol)(y)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(y)}}async eb(y,L,S,v,T,U){const F=await this.qb(y,L,S,T,U),j=[];for(const G of F){const V=G.previewResource.with({scheme:p.$Mnb,authority:"accepted"});if(G.localChange===p.Change.None&&G.remoteChange===p.Change.None)j.push({...G,acceptedResource:V,acceptResult:{content:null,localChange:p.Change.None,remoteChange:p.Change.None},mergeState:p.MergeState.Accepted});else{const x=v?await this.rb(G,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(G.previewResource,C.$Le.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(G,G.previewResource,void 0,U):void 0;j.push({...G,acceptResult:H,mergeState:x?.hasConflicts?p.MergeState.Conflict:H?p.MergeState.Accepted:p.MergeState.Preview,localChange:H?H.localChange:x?x.localChange:G.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:G.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:L,resourcePreviews:j,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const L=JSON.parse(y),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!L.version&&!!S&&L.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${L.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let v,T=1;for(;v===void 0&&T++<6;)try{const U=await this.hb();U&&(U.ref===L.ref?v=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof l.$sl&&U.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof p.$Anb)throw U;this.O.error(U,T)}}if(v===void 0)try{const U=await this.J.resolveResourceContent(this.resource,L.ref,this.collection,this.F);v=U===null?null:this.kb(U),await this.ib({ref:L.ref,syncData:v})}catch(U){if(U instanceof p.$Anb&&U.code===p.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return v===void 0?null:{...L,syncData:v}}async fb(y,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),v={ref:y.ref,version:S,...L};this.I.store(this.z,JSON.stringify(v),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib(y)}gb(){return this.I.get(this.z,f.StorageScope.APPLICATION)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const L=y?JSON.parse(y):void 0;if(u(L))return L}catch(L){this.O.error(L)}}async ib(y){await this.G.writeFile(this.y,C.$Le.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),L=JSON.parse(y.value.toString());await this.G.del(this.y),L.ref&&L.content!==void 0?(this.I.store(this.z,JSON.stringify({...L,content:void 0}),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib({ref:L.ref,syncData:L.content===null?null:JSON.parse(L.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,L)}catch(y){y instanceof l.$sl&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,f.StorageScope.APPLICATION)}async getRemoteUserData(y){const{ref:L,content:S}=await this.lb(y);let v=null;return S!==null&&(v=this.kb(S)),{ref:L,syncData:v}}kb(y){try{const L=JSON.parse(y);if(i(L))return L}catch(L){this.O.error(L)}throw new p.$Anb((0,$.localize)(10941,null),p.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(y){const L=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,L,this.collection,this.F)}async mb(y,L){const S=await this.j,v={version:this.pb,machineId:S,content:y};try{return L=await this.J.writeResource(this.resource,JSON.stringify(v),L,this.collection,this.F),{ref:L,syncData:v}}catch(T){throw T instanceof p.$Anb&&T.code===p.UserDataSyncErrorCode.TooLarge&&(T=new p.$Anb(T.message,T.code,this.resource)),T}}async nb(y){const L={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(L),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==p.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(p.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(p.$nnb)}};e.$XNb=t,e.$XNb=t=ve([Z(2,l.$0k),Z(3,g.$Ji),Z(4,f.$fq),Z(5,p.$vnb),Z(6,p.$wnb),Z(7,p.$Fnb),Z(8,w.$9l),Z(9,p.$Knb),Z(10,d.$9i),Z(11,P.$Hl)],t);let s=class extends t{constructor(y,L,S,v,T,U,F,j,G,V,x,H,ie){super(L,S,v,T,U,F,j,G,V,x,H,ie),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(z=>this.yb(z)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,L,S){try{L?await this.G.writeFile(this.r,C.$Le.fromString(y),S?void 0:L):await this.G.createFile(this.r,C.$Le.fromString(y),{overwrite:S})}catch(v){throw v instanceof l.$sl&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||v instanceof l.$sl&&v.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new p.$Anb(v.message,p.UserDataSyncErrorCode.LocalPreconditionFailed):v}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof l.$sl&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$YNb=s,e.$YNb=s=ve([Z(3,l.$0k),Z(4,g.$Ji),Z(5,f.$fq),Z(6,p.$vnb),Z(7,p.$wnb),Z(8,p.$Fnb),Z(9,w.$9l),Z(10,p.$Knb),Z(11,d.$9i),Z(12,P.$Hl)],s);let r=class extends s{constructor(y,L,S,v,T,U,F,j,G,V,x,H,ie,z){super(y,L,S,v,T,U,F,j,G,V,x,ie,z),this.zb=H,this.Bb=void 0}Ab(y,L){const S=[],v=(0,O.$Vn)(y,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,I.$jg)(v)&&L!==Array.isArray(v)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$ZNb=r,e.$ZNb=r=ve([Z(3,l.$0k),Z(4,g.$Ji),Z(5,f.$fq),Z(6,p.$vnb),Z(7,p.$wnb),Z(8,p.$Fnb),Z(9,w.$9l),Z(10,p.$Knb),Z(11,p.$Jnb),Z(12,d.$9i),Z(13,P.$Hl)],r);let a=class{constructor(y,L,S,v,T,U,F){this.resource=y,this.g=L,this.h=S,this.j=v,this.k=T,this.l=U,this.d=F.extUri,this.f=(0,p.$tnb)(void 0,this.resource,S,this.d)}async initialize({ref:y,content:L}){if(!L){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(L);if(S)try{await this.o({ref:y,syncData:S})}catch(v){this.j.error(v)}}m(y){try{const L=JSON.parse(y);if(i(L))return L}catch(L){this.j.error(L)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const S={ref:y.ref,version:void 0,...L};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.k.writeFile(this.f,C.$Le.fromString(JSON.stringify(y)))}};e.$1Nb=a,e.$1Nb=a=ve([Z(1,o.$Jl),Z(2,g.$Ji),Z(3,m.$0j),Z(4,l.$0k),Z(5,f.$fq),Z(6,P.$Hl)],a)}),define(he[119],ue([0,1,6,25,8,3,45,2,26,21,15,118,27,35,85,34,7,4,76,10,16,18,28,19,40,206,114,24,62]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o,u,i,n,t,s,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=e.$jcc=e.$icc=void 0,e.$gcc=y,e.$hcc=L;async function h(U,F){const j=JSON.parse(U.content);if(U.version===1||U.version===2){const G=(await F.getInstalled(m.ExtensionType.System)).filter(V=>V.isBuiltin);for(const V of j)U.version===1&&(V.enabled===!1&&(V.disabled=!0),delete V.enabled),U.version===2&&G.every(x=>!(0,g.$Jp)(x.identifier,V.identifier))&&(V.installed=!0)}return j}function y(U){return JSON.parse(U.content)}function L(U,F){return U.sort((j,G)=>!j.identifier.uuid&&G.identifier.uuid?-1:j.identifier.uuid&&!G.identifier.uuid?1:(0,k.$wf)(j.identifier.id,G.identifier.id)),F?(0,N.$6n)(U,{}):JSON.stringify(U)}let S=class extends n.$XNb{constructor(F,j,G,V,x,H,ie,z,W,ee,ne,ce,te,X,K,B,D){super({syncResource:r.SyncResource.Extensions,profile:F},j,V,G,x,H,ie,ce,te,ee,ne,K),this.Cb=z,this.Db=W,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Mnb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Mnb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Mnb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Mnb,authority:"accepted"}),this.Bb=this.Eb.createInstance(v),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,J=>J.some(({local:q})=>!!q)),A.Event.filter(this.Cb.onDidUninstallExtension,J=>!J.error),A.Event.filter(B.onDidChange,J=>J.valueChanges.some(({profile:q,changes:M})=>this.syncResource.profile.id===q.id&&M.some(Q=>Q.key===d.$mp))),X.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,j){const G=F.syncData?await h(F.syncData,this.Cb):null,V=j?.skippedExtensions??[],x=j?.builtinExtensions??null,H=j?.syncData?await h(j.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:z}=await this.Bb.getLocalExtensions(this.syncResource.profile);G?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:ee}=(0,t.$fcc)(ie,G,H,V,z,x),ne={local:W,remote:ee,content:this.Hb(ie,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:ee!==null?r.Change.Modified:r.Change.None},ce=this.Ob(ie,!1);return[{skippedExtensions:V,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):ce,localResource:this.yb,localContent:ce,localExtensions:ie,remoteResource:this.zb,remoteExtensions:G,remoteContent:G?this.Ob(G,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(F){const j=F.syncData?await h(F.syncData,this.Cb):null,{localExtensions:G,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.$fcc)(G,j,j,F.skippedExtensions||[],V,F.builtinExtensions||[]);return x!==null}Hb(F,j,G,V){const x=[...j,...G],H=new Set,ie=z=>{H.add(z.id.toLowerCase()),z.uuid&&H.add(z.uuid)};x.forEach(({identifier:z})=>ie(z)),V.forEach(ie);for(const z of F)H.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&H.has(z.identifier.uuid)||x.push(z);return this.Ob(x,!1)}async rb(F,j){return{...F.previewResult,hasConflicts:!1}}async sb(F,j,G,V){if(this.h.isEqual(j,this.yb))return this.Kb(F);if(this.h.isEqual(j,this.zb))return this.Lb(F);if(this.h.isEqual(j,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async Kb(F){const j=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),G=this.Db.getIgnoredExtensions(j),V=(0,t.$fcc)(F.localExtensions,null,null,F.skippedExtensions,G,F.builtinExtensions),{local:x,remote:H}=V;return{content:F.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:H!==null?r.Change.Modified:r.Change.None}}async Lb(F){const j=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),G=this.Db.getIgnoredExtensions(j),V=F.remoteContent?JSON.parse(F.remoteContent):null;if(V!==null){const x=(0,t.$fcc)(F.localExtensions,V,F.localExtensions,[],G,F.builtinExtensions),{local:H,remote:ie}=x;return{content:F.remoteContent,local:H,remote:ie,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:ie!==null?r.Change.Modified:r.Change.None}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async tb(F,j,G,V){let{skippedExtensions:x,builtinExtensions:H,localExtensions:ie}=G[0][0];const{local:z,remote:W,localChange:ee,remoteChange:ne}=G[0][1];if(ee===r.Change.None&&ne===r.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==r.Change.None&&(await this.nb(JSON.stringify(ie)),x=await this.Bb.updateLocalExtensions(z.added,z.removed,z.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const ce=JSON.stringify(W.all);F=await this.mb(ce,V?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(te=>te.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(te=>te.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(te=>te.identifier.id))}.`:""}`)}j?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(ie,H),await this.fb(F,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ce=>ce.identifier.id))}.`:""}`))}Nb(F,j){const G=new Set,V=[];for(const x of F)G.add(x.identifier.id.toLowerCase()),x.installed||V.push(x.identifier);if(j)for(const x of j)G.has(x.id.toLowerCase())||V.push(x);return V}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const j=await this.db(F);return j&&this.Ob(JSON.parse(j),!0)}return null}Ob(F,j){return L(F,j)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(j=>j.installed||j.disabled))return!0}catch{}return!1}};e.$icc=S,e.$icc=S=ve([Z(2,I.$Ji),Z(3,E.$0k),Z(4,p.$fq),Z(5,r.$vnb),Z(6,r.$wnb),Z(7,d.$lp),Z(8,s.$JOb),Z(9,r.$Knb),Z(10,b.$9i),Z(11,r.$Fnb),Z(12,o.$9l),Z(13,l.$nw),Z(14,u.$Hl),Z(15,a.$RMb),Z(16,f.$Bi)],S);let v=class{constructor(F,j,G,V,x,H){this.a=F,this.b=j,this.c=G,this.d=V,this.f=x,this.g=H}async getLocalExtensions(F){const j=await this.a.getInstalled(void 0,F.extensionsResource),G=this.d.getIgnoredExtensions(j);return{localExtensions:await this.j(F,async(x,H)=>{const ie=x.getDisabledExtensions();return j.map(z=>{const{identifier:W,isBuiltin:ee,manifest:ne,preRelease:ce,pinned:te,isApplicationScoped:X}=z,K={identifier:W,preRelease:ce,version:ne.version,pinned:!!te};X&&!(0,m.$rn)(ne)&&(K.isApplicationScoped=X),ie.some(B=>(0,g.$Jp)(B,W))&&(K.disabled=!0),ee||(K.installed=!0);try{const B=H.getKeysForSync({id:W.id,version:ne.version});if(B){const D=H.getExtensionState(z,!0)||{};K.state=Object.keys(D).reduce((J,q)=>(B.includes(q)&&(J[q]=D[q]),J),{})}}catch(B){this.g.info(`${(0,n.$WNb)(r.SyncResource.Extensions,F)}: Error while parsing extension state`,(0,C.$9)(B))}return K})}),ignoredExtensions:G}}async updateLocalExtensions(F,j,G,V,x){const H=(0,n.$WNb)(r.SyncResource.Extensions,x),ie=[],z=new Map,W=[],ee=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((F.length||G.length)&&await this.j(x,async(X,K)=>{await R.Promises.settled([...F,...G].map(async B=>{const D=ne.find(M=>(0,g.$Jp)(M.identifier,B.identifier));if(D&&D.isBuiltin){B.state&&D.manifest.version===B.version&&this.h(B.state,D,D.manifest.version,K),X.getDisabledExtensions().some(Q=>(0,g.$Jp)(Q,B.identifier))!==!!B.disabled&&(B.disabled?(this.g.trace(`${H}: Disabling extension...`,B.identifier.id),await X.disableExtension(B.identifier),this.g.info(`${H}: Disabled extension`,B.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,B.identifier.id),await X.enableExtension(B.identifier),this.g.info(`${H}: Enabled extension`,B.identifier.id))),W.push(B.identifier);return}const J=B.pinned?B.version:void 0,q=(await this.c.getExtensions([{...B.identifier,version:J,preRelease:J?void 0:B.preRelease}],c.CancellationToken.None))[0];if(B.state&&(D?D.manifest.version===B.version:q)&&this.h(B.state,D||q,D?.manifest.version,K),q)try{X.getDisabledExtensions().some(Q=>(0,g.$Jp)(Q,B.identifier))!==!!B.disabled&&(B.disabled?(this.g.trace(`${H}: Disabling extension...`,B.identifier.id,q.version),await X.disableExtension(q.identifier),this.g.info(`${H}: Disabled extension`,B.identifier.id,q.version)):(this.g.trace(`${H}: Enabling extension...`,B.identifier.id,q.version),await X.enableExtension(q.identifier),this.g.info(`${H}: Enabled extension`,B.identifier.id,q.version))),(!D||D.preRelease!==B.preRelease||D.pinned!==B.pinned||J&&D.manifest.version!==J)&&(await this.a.canInstall(q)?(ie.push({extension:q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:B.pinned&&!!B.version,pinned:B.pinned,installPreReleaseVersion:B.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:B.isApplicationScoped,context:{[d.$$o]:!0,[d.$_o]:d.ExtensionInstallSource.SETTINGS_SYNC}}}),z.set(q.identifier.id.toLowerCase(),B)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),ee.push(B)))}catch(M){ee.push(B),this.g.error(M),this.g.info(`${H}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else ee.push(B),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,B.identifier.id)}))}),j.length){const X=ne.filter(({identifier:K,isBuiltin:B})=>!B&&j.some(D=>(0,g.$Jp)(K,D)));await R.Promises.settled(X.map(async K=>{this.g.trace(`${H}: Uninstalling local extension...`,K.identifier.id),await this.a.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,K.identifier.id),W.push(K.identifier)}))}const ce=await this.a.installGalleryExtensions(ie);for(const{identifier:X,local:K,error:B,source:D}of ce){const J=D;if(K)this.g.info(`${H}: Installed extension.`,X.id,J.version),W.push(X);else{const q=z.get(X.id.toLowerCase());q&&(ee.push(q),this.g.info(`${H}: Skipped synchronizing extension`,J.displayName||J.identifier.id)),B instanceof d.$kp&&[d.ExtensionManagementErrorCode.Incompatible,d.ExtensionManagementErrorCode.IncompatibleApi,d.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(B.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,J.displayName||J.identifier.id):B&&this.g.error(B)}}const te=[];for(const X of V)W.some(K=>(0,g.$Jp)(K,X.identifier))||te.push(X);for(const X of ee)te.some(K=>(0,g.$Jp)(K.identifier,X.identifier))||te.push(X);return te}h(F,j,G,V){const x=V.getExtensionState(j,!0)||{},H=G?V.getKeysForSync({id:j.identifier.id,version:G}):void 0;H?H.forEach(ie=>{x[ie]=F[ie]}):Object.keys(F).forEach(ie=>x[ie]=F[ie]),V.setExtensionState(j,x,!0)}async j(F,j){return this.b.withProfileScopedStorageService(F,async G=>{const V=new O.$Sc,x=V.add(this.f.createChild(new w.$Ai([p.$fq,G]))),H=V.add(x.createInstance($.$dMb)),ie=V.add(x.createInstance(l.$ow));try{return await j(H,ie)}finally{V.dispose()}})}};e.$jcc=v,e.$jcc=v=ve([Z(0,d.$lp),Z(1,a.$RMb),Z(2,d.$ip),Z(3,s.$JOb),Z(4,f.$Bi),Z(5,r.$Knb)],v);let T=class extends n.$1Nb{constructor(F,j,G,V,x,H,ie,z){super(r.SyncResource.Extensions,V,x,H,G,ie,z),this.p=F,this.q=j}async t(F){return F.syncData?await h(F.syncData,this.p):null}u(F,j){const G=[],V=[],x=[];for(const H of F){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const ie=j.find(z=>(0,g.$Jp)(z.identifier,H.identifier));ie?(G.push(ie),H.disabled&&x.push(H.identifier)):H.installed&&(V.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:G,newExtensions:V,disabledExtensions:x,remoteExtensions:F}}};e.$kcc=T,e.$kcc=T=ve([Z(0,d.$lp),Z(1,s.$JOb),Z(2,E.$0k),Z(3,i.$Jl),Z(4,I.$Ji),Z(5,P.$0j),Z(6,p.$fq),Z(7,u.$Hl)],T)}),define(he[120],ue([0,1,14,8,3,36,45,5,32,21,15,7,10,49,16,18,28,40,81,210,24,19,62,4]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Nb=e.$6Nb=e.$5Nb=e.$4Nb=void 0,e.$3Nb=s;const n="globalState.argv.",t=["locale"];function s(S,v){const T=S.storage?Object.keys(S.storage).sort():[],U={};return T.forEach(F=>U[F]=S.storage[F]),S.storage=U,v?(0,N.$6n)(S,{}):JSON.stringify(S)}const r=1;let a=class extends f.$XNb{constructor(v,T,U,F,j,G,V,x,H,ie,z,W,ee,ne){super({syncResource:p.SyncResource.GlobalState,profile:v},T,F,x,W,j,G,H,ie,V,z,ee),this.Bb=U,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:p.$Mnb,authority:"base"}),this.xb=this.vb.with({scheme:p.$Mnb,authority:"local"}),this.yb=this.vb.with({scheme:p.$Mnb,authority:"remote"}),this.zb=this.vb.with({scheme:p.$Mnb,authority:"accepted"}),this.Ab=ne.createInstance(h),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(C.Event.any(C.Event.filter(F.onDidFilesChange,ce=>ce.contains(this.H.argvResource)),C.Event.filter(U.onDidChange,ce=>!!(ce.targetChanges.some(te=>this.syncResource.profile.id===te.id)||ce.valueChanges.some(({profile:te,changes:X})=>this.syncResource.profile.id===te.id&&X.some(K=>K.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(v,T,U){const F=v.syncData?JSON.parse(v.syncData.content):null;T=T===null&&U?v:T;const j=T&&T.syncData?JSON.parse(T.syncData.content):null,G=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=await this.Jb(j),{local:x,remote:H}=(0,P.$2Nb)(G.storage,F?F.storage:null,j?j.storage:null,V,this.O),ie={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?p.Change.Modified:p.Change.None,remoteChange:H.all!==null?p.Change.Modified:p.Change.None},z=s(G,!1);return[{baseResource:this.wb,baseContent:j?s(j,!1):z,localResource:this.xb,localContent:z,localUserData:G,remoteResource:this.yb,remoteContent:F?s(F,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:V}]}async ub(v){const T=v.syncData?JSON.parse(v.syncData.content):null;if(T===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(T),{remote:j}=(0,P.$2Nb)(U.storage,T.storage,T.storage,F,this.O);return j.all!==null}async rb(v,T){return{...v.previewResult,hasConflicts:!1}}async sb(v,T,U,F){if(this.h.isEqual(T,this.xb))return this.Gb(v);if(this.h.isEqual(T,this.yb))return this.Hb(v);if(this.h.isEqual(T,this.vb))return v.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(v.localUserData.storage),removed:[],updated:[],all:v.localUserData.storage},localChange:p.Change.None,remoteChange:p.Change.Modified}}async Hb(v){if(v.remoteContent!==null){const T=JSON.parse(v.remoteContent),{local:U,remote:F}=(0,P.$2Nb)(v.localUserData.storage,T.storage,null,v.storageKeys,this.O);return{content:v.remoteContent,local:U,remote:F,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?p.Change.Modified:p.Change.None,remoteChange:F!==null?p.Change.Modified:p.Change.None}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:p.Change.None,remoteChange:p.Change.None}}async tb(v,T,U,F){const{localUserData:j}=U[0][0],{local:G,remote:V,localChange:x,remoteChange:H}=U[0][1];if(x===p.Change.None&&H===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==p.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(j)),await this.Ab.writeLocalGlobalState(G,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==p.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:V.all});v=await this.mb(ie,F?null:v.ref),this.O.info(`${this.D}: Updated remote ui state.${V.added.length?` Added: ${V.added}.`:""}${V.updated.length?` Updated: ${V.updated}.`:""}${V.removed.length?` Removed: ${V.removed}.`:""}`)}T?.ref!==v.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(v),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(v){if(this.h.isEqual(this.yb,v)||this.h.isEqual(this.wb,v)||this.h.isEqual(this.xb,v)||this.h.isEqual(this.zb,v)){const T=await this.db(v);return T&&s(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:v}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(v).length>1||v[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(v){const T=await this.Bb.readStorageData(this.syncResource.profile),U=[],F=[];for(const[V,x]of T)x.target===l.StorageTarget.USER?U.push(V):x.target===l.StorageTarget.MACHINE&&F.push(V);const j=[...U,...F],G=v?.storage?Object.keys(v.storage).filter(V=>!V.startsWith(n)&&!j.includes(V)&&T.get(V)!==void 0):[];if(!O.$p){const V=[...p.$rnb.map(x=>(0,p.$Enb)(x)),p.$Dnb];G.push(...V),F.push(...V)}return{user:U,machine:F,unregistered:G}}};e.$4Nb=a,e.$4Nb=a=ve([Z(2,u.$RMb),Z(3,$.$0k),Z(4,p.$vnb),Z(5,p.$wnb),Z(6,p.$Knb),Z(7,I.$Ji),Z(8,p.$Fnb),Z(9,m.$9l),Z(10,b.$9i),Z(11,l.$fq),Z(12,E.$Hl),Z(13,i.$Bi)],a);let h=class{constructor(v,T,U,F){this.a=v,this.b=T,this.c=U,this.d=F}async getLocalGlobalState(v){const T={};if(v.isDefault){const F=await this.f(),j=(0,A.$Vn)(F);for(const G of t)j[G]!==void 0&&(T[`${n}${G}`]={version:1,value:j[G]})}const U=await this.c.readStorageData(v);for(const[F,j]of U)j.value&&j.target===l.StorageTarget.USER&&(T[F]={version:1,value:j.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const v=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),v.value.toString()}catch(v){this.d.debug((0,c.$9)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:T,updated:U},F){const j=(0,f.$WNb)(p.SyncResource.GlobalState,F),G={},V=new Map,x=await this.c.readStorageData(F),H=(ie,z)=>{for(const W of ie){if(W.startsWith(n)){G[W.substring(n.length)]=z?z[W].value:void 0;continue}if(z){const ee=z[W];ee.value!==x.get(W)?.value&&V.set(W,ee.value)}else x.get(W)!==void 0&&V.set(W,void 0)}};if(H(Object.keys(v),v),H(Object.keys(U),U),H(T),Object.keys(G).length){this.d.trace(`${j}: Updating locale...`);const ie=await this.f();let z=ie;for(const W of Object.keys(G))z=(0,w.edit)(z,[W],G[W],{});ie!==z&&(this.d.trace(`${j}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.$Le.fromString(z)),this.d.info(`${j}: Updated locale.`)),this.d.info(`${j}: Updated locale`)}V.size&&(this.d.trace(`${j}: Updating global state...`),await this.c.updateStorageData(F,V,l.StorageTarget.USER),this.d.info(`${j}: Updated global state`,[...V.keys()]))}};e.$5Nb=h,e.$5Nb=h=ve([Z(0,$.$0k),Z(1,I.$Ji),Z(2,u.$RMb),Z(3,p.$Knb)],h);let y=class extends f.$1Nb{constructor(v,T,U,F,j,G){super(p.SyncResource.GlobalState,U,F,j,T,v,G)}async o(v){const T=v.syncData?JSON.parse(v.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},F={};for(const j of Object.keys(T.storage))j.startsWith(n)?U[j.substring(n.length)]=T.storage[j].value:this.l.get(j,l.StorageScope.PROFILE)===void 0&&(F[j]=T.storage[j].value);if(Object.keys(U).length){let j="{}";try{j=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const G of Object.keys(U))j=(0,w.edit)(j,[G],U[G],{});await this.k.writeFile(this.h.argvResource,R.$Le.fromString(j))}if(Object.keys(F).length){const j=[];for(const G of Object.keys(F))j.push({key:G,value:F[G],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(j,!0)}}};e.$6Nb=y,e.$6Nb=y=ve([Z(0,l.$fq),Z(1,$.$0k),Z(2,o.$Jl),Z(3,I.$Ji),Z(4,p.$Knb),Z(5,E.$Hl)],y);let L=class{constructor(v,T,U,F,j){this.a=v,this.b=T,this.c=U,this.d=F,this.f=j}getSyncStoreType(v){return this.h(v)?.storage[p.$Dnb]?.value}async sync(v){const T=(0,p.$znb)((0,k.$Yg)());try{return await this.g(v,T)}catch(U){if(U instanceof p.$Anb)switch(U.code){case p.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(v,T)}throw U}}async g(v,T){const U=await this.a.readResource(p.SyncResource.GlobalState,null,void 0,T),F=this.h(U)||{storage:{}};F.storage[p.$Dnb]={value:v,version:r};const j=await(0,g.$lq)(this.c,this.d,this.b),G={version:r,machineId:j,content:s(F,!1)};await this.a.writeResource(p.SyncResource.GlobalState,JSON.stringify(G),U.ref,void 0,T)}h({content:v}){if(!v)return null;const T=JSON.parse(v);if((0,f.$VNb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$7Nb=L,e.$7Nb=L=ve([Z(1,l.$fq),Z(2,I.$Ji),Z(3,$.$0k),Z(4,d.$0j)],L)}),define(he[121],ue([0,1,17,14,3,36,5,12,11,21,15,7,16,18,28,19,40,207,24]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=void 0,e.$mcc=P;function P(u,i,n){try{const t=JSON.parse(u);if(!i)return(0,O.$jg)(t.all)?null:t.all;switch(N.OS){case N.OperatingSystem.Macintosh:return(0,O.$jg)(t.mac)?null:t.mac;case N.OperatingSystem.Linux:return(0,O.$jg)(t.linux)?null:t.linux;case N.OperatingSystem.Windows:return(0,O.$jg)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}let p=class extends E.$ZNb{constructor(i,n,t,s,r,a,h,y,L,S,v,T,U){super(i.keybindingsResource,{syncResource:w.SyncResource.Keybindings,profile:i},n,y,L,S,t,s,h,T,r,v,a,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:w.$Mnb,authority:"base"}),this.Gb=this.Eb.with({scheme:w.$Mnb,authority:"local"}),this.Hb=this.Eb.with({scheme:w.$Mnb,authority:"remote"}),this.Ib=this.Eb.with({scheme:w.$Mnb,authority:"accepted"}),this.B(C.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(i,n,t,s){const r=i.syncData?P(i.syncData.content,s.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&t?i:n;const a=n?this.Ob(n):null,h=await this.vb(),y=await this.Cb();let L=null,S=!1,v=!1,T=!1;if(r){let j=h?h.value.toString():"[]";if(j=j||"[]",this.Ab(j,!0))throw new w.$Anb((0,k.localize)(10938,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!a||a!==j||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const G=await(0,f.$lcc)(j,r,a,y,this.zb);G.hasChanges&&(L=G.mergeContent,T=G.hasConflicts,S=T||G.mergeContent!==j,v=T||G.mergeContent!==r)}}else h&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),L=h.value.toString(),v=!0);const U={content:T?a:L,localChange:S?h?w.Change.Modified:w.Change.Added:w.Change.None,remoteChange:v?w.Change.Modified:w.Change.None,hasConflicts:T},F=h?h.value.toString():null;return[{fileContent:h,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:F,localChange:U.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(i){const n=this.Ob(i);if(n===null)return!0;const t=await this.vb(),s=t?t.value.toString():"",r=await this.Cb(),a=await(0,f.$lcc)(s||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(i,n){return i.previewResult}async sb(i,n,t,s){if(this.h.isEqual(n,this.Gb))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(n,this.Hb))return{content:i.remoteContent,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(n,this.Eb))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(i,n,t,s){const{fileContent:r}=t[0][0];let{content:a,localChange:h,remoteChange:y}=t[0][1];if(h===w.Change.None&&y===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new w.$Anb((0,k.localize)(10939,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(h!==w.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,s),this.O.info(`${this.D}: Updated local keybindings`)),y!==w.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const L=this.Pb(a||"[]",i.syncData?.content);i=await this.mb(L,s?null:i.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(i,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.vb();if(i){const n=(0,A.$Vn)(i.value.toString());if((0,R.$Kb)(n))return!0}}catch(i){if(i.fileOperationResult!==$.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.Hb,i)||this.h.isEqual(this.Fb,i)||this.h.isEqual(this.Gb,i)||this.h.isEqual(this.Ib,i)?this.db(i):null}Ob(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.Qb()?null:P(i.syncData.content,this.Qb(),this.O)}Pb(i,n){let t={};try{t=JSON.parse(n||"{}")}catch(s){this.O.error(s)}switch(this.Qb()?delete t.all:t.all=i,N.OS){case N.OperatingSystem.Macintosh:t.mac=i;break;case N.OperatingSystem.Linux:t.linux=i;break;case N.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}Qb(){return!!this.P.getValue(w.$onb)}};e.$ncc=p,e.$ncc=p=ve([Z(2,w.$vnb),Z(3,w.$wnb),Z(4,w.$Knb),Z(5,b.$9i),Z(6,w.$Fnb),Z(7,$.$0k),Z(8,I.$Ji),Z(9,d.$fq),Z(10,w.$Jnb),Z(11,g.$9l),Z(12,l.$Hl)],p);let o=class extends E.$1Nb{constructor(i,n,t,s,r,a){super(w.SyncResource.Keybindings,n,t,s,i,r,a)}async o(i){const n=i.syncData?this.p(i.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,c.$Le.fromString(n)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Vn)(i.value.toString());return!(0,R.$Kb)(n)}catch(i){return i.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND}}p(i){try{return P(i,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$occ=o,e.$occ=o=ve([Z(0,$.$0k),Z(1,m.$Jl),Z(2,I.$Ji),Z(3,w.$Knb),Z(4,d.$fq),Z(5,l.$Hl)],o)}),define(he[122],ue([0,1,17,14,3,11,21,77,15,27,34,7,16,18,28,19,40,211,24]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=e.$qcc=void 0,e.$pcc=p;function P(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function p(i){const n=JSON.parse(i);return P(n)?n:{settings:i}}let o=class extends E.$ZNb{constructor(n,t,s,r,a,h,y,L,S,v,T,U,F,j){super(n.settingsResource,{syncResource:w.SyncResource.Settings,profile:n},t,s,r,a,h,y,T,U,L,S,v,j),this.Eb=n,this.Fb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$Mnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Mnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Mnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Mnb,authority:"accepted"}),this.Pb=void 0,this.Qb=void 0,this.Rb=void 0}async getRemoteUserDataSyncConfiguration(n){const t=await this.getLastSyncUserData(),s=await this.X(n,t),r=this.Mb(s),a=new O.$Mo(w.$nnb,this.O);return r?.settings&&a.parse(r.settings),a.configurationModel.getValue(w.$nnb)||{}}async qb(n,t,s){const r=await this.vb(),a=await this.Cb(),h=this.Mb(n);t=t===null&&s?n:t;const y=t?this.Mb(t):null,L=await this.Sb();let S=null,v=!1,T=!1,U=!1;if(h){let V=r?r.value.toString().trim():"{}";V=V||"{}",this.Vb(V),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const x=(0,f.$yMb)(V,h.settings,y?y.settings:null,L,[],a);S=x.localContent||x.remoteContent,v=x.localContent!==null,T=x.remoteContent!==null,U=x.hasConflicts}else r&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=r.value.toString().trim()||"{}",this.Vb(S),T=!0);const F=r?r.value.toString():null,j=y?.settings??null,G={content:U?j:S,localChange:v?w.Change.Modified:w.Change.None,remoteChange:T?w.Change.Modified:w.Change.None,hasConflicts:U};return[{fileContent:r,baseResource:this.baseResource,baseContent:j,localResource:this.localResource,localContent:F,localChange:G.localChange,remoteResource:this.remoteResource,remoteContent:h?h.settings:null,remoteChange:G.remoteChange,previewResource:this.previewResource,previewResult:G,acceptedResource:this.acceptedResource}]}async ub(n){const t=this.Mb(n);if(t===null)return!0;const s=await this.vb(),r=s?s.value.toString().trim():"",a=await this.Sb(),h=await this.Cb();return(0,f.$yMb)(r||"{}",t.settings,t.settings,a,[],h).remoteContent!==null}async rb(n,t){const s=await this.Cb(),r=await this.Sb();return{...n.previewResult,content:n.previewResult.content?(0,f.$xMb)(n.previewResult.content,"{}",r,s):null}}async sb(n,t,s,r){const a=await this.Cb(),h=await this.Sb();if(this.h.isEqual(t,this.localResource))return{content:n.fileContent?(0,f.$xMb)(n.fileContent.value.toString(),"{}",h,a):null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:n.remoteContent!==null?(0,f.$xMb)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",h,a):null,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,f.$xMb)(s,n.fileContent?n.fileContent.value.toString():"{}",h,a):null,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(n,t,s,r){const{fileContent:a}=s[0][0];let{content:h,localChange:y,remoteChange:L}=s[0][1];if(y===w.Change.None&&L===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),h=h?h.trim():"{}",h=h||"{}",this.Vb(h),y!==w.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),a&&await this.nb(JSON.stringify(this.Ob(a.value.toString()))),await this.wb(h,a,r),await this.P.reloadConfiguration(N.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),L!==w.Change.None){const S=await this.Cb(),v=this.Mb(n),T=await this.Sb(h);h=(0,f.$xMb)(h,v?v.settings:"{}",T,S),this.O.trace(`${this.D}: Updating remote settings...`),n=await this.mb(JSON.stringify(this.Ob(h)),r?null:n.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(n),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.vb();if(n)return!(0,f.$zMb)(n.value.toString())}catch(n){if(n.fileOperationResult!==$.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(n){return this.h.isEqual(this.remoteResource,n)||this.h.isEqual(this.localResource,n)||this.h.isEqual(this.acceptedResource,n)||this.h.isEqual(this.baseResource,n)?this.db(n):null}async db(n){let t=await super.db(n);if(t){const s=await this.Cb(),r=await this.Sb();t=(0,f.$xMb)(t,"{}",r,s)}return t}Mb(n){return n.syncData?this.Nb(n.syncData.content):null}Nb(n){try{return p(n)}catch(t){this.O.error(t)}return null}Ob(n){return{settings:n}}async Sb(n){if(this.Pb||(this.Pb=this.zb.resolveDefaultCoreIgnoredSettings()),this.Qb||(this.Qb=this.Tb()),!this.Rb){this.Rb=this.Ub();const s=this.B(C.Event.any(C.Event.filter(this.Fb.onDidInstallExtensions,r=>r.some(({local:a})=>!!a)),C.Event.filter(this.Fb.onDidUninstallExtension,r=>!r.error))(()=>{s.dispose(),this.Rb=void 0}))}const t=(await Promise.all([this.Pb,this.Qb,this.Rb])).flat();return(0,f.$vMb)(t,this.P,n)}async Tb(){const n=await this.Fb.getInstalled(I.ExtensionType.System);return(0,R.$Lb)(n.map(t=>(0,w.$mnb)(t.manifest)).flat())}async Ub(){const n=await this.Fb.getInstalled(I.ExtensionType.User,this.Eb.extensionsResource);return(0,R.$Lb)(n.map(t=>(0,w.$mnb)(t.manifest)).flat())}Vb(n){if(this.Ab(n,!1))throw new w.$Anb((0,A.localize)(10937,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$qcc=o,e.$qcc=o=ve([Z(2,$.$0k),Z(3,k.$Ji),Z(4,d.$fq),Z(5,w.$vnb),Z(6,w.$wnb),Z(7,w.$Knb),Z(8,w.$Jnb),Z(9,N.$9i),Z(10,w.$Fnb),Z(11,g.$9l),Z(12,b.$lp),Z(13,l.$Hl)],o);let u=class extends E.$1Nb{constructor(n,t,s,r,a,h){super(w.SyncResource.Settings,t,s,r,n,a,h)}async o(n){const t=n.syncData?this.p(n.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,c.$Le.fromString(t.settings)),await this.n(n)}async i(){try{const n=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,f.$zMb)(n.value.toString().trim())}catch(n){return n.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND}}p(n){try{return p(n)}catch(t){this.j.error(t)}return null}};e.$rcc=u,e.$rcc=u=ve([Z(0,$.$0k),Z(1,m.$Jl),Z(2,k.$Ji),Z(3,w.$Knb),Z(4,d.$fq),Z(5,l.$Hl)],u)}),define(he[123],ue([0,1,14,3,29,21,15,7,16,18,28,19,40,208,24]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=e.$vcc=void 0,e.$ucc=m;function m(w){return JSON.parse(w.content)}let E=class extends d.$XNb{constructor(P,p,o,u,i,n,t,s,r,a,h,y){super({syncResource:l.SyncResource.Snippets,profile:P},p,u,o,i,n,t,a,h,s,r,y),this.pb=1,this.vb=P.snippetsHome,this.B(this.G.watch(o.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(c.Event.filter(this.G.onDidFilesChange,L=>L.affects(this.vb))(()=>this.Q()))}async qb(P,p,o){const u=await this.Hb(),i=this.Gb(u),n=P.syncData?this.Fb(P.syncData):null;p=p===null&&o?P:p;const t=p&&p.syncData?this.Fb(p.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,g.$scc)(i,n,t);return this.Bb(s,u,n||{},t||{})}async ub(P){const p=P.syncData?this.Fb(P.syncData):null;if(p===null)return!0;const o=await this.Hb(),u=this.Gb(o),i=(0,g.$scc)(u,p,p);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async rb(P,p){return P.previewResult}async sb(P,p,o,u){if(this.h.isEqualOrParent(p,this.g.with({scheme:l.$Mnb,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:P.fileContent?P.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent(p,this.g.with({scheme:l.$Mnb,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent(p,this.g))return o===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:o,localChange:o===null?P.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:o===null?P.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${p.toString()}`)}async tb(P,p,o,u){const i=o.map(([n,t])=>({...n,acceptResult:t}));i.every(({localChange:n,remoteChange:t})=>n===l.Change.None&&t===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),i.some(({localChange:n})=>n!==l.Change.None)&&(await this.Cb(i),await this.Db(i,u)),i.some(({remoteChange:n})=>n!==l.Change.None)&&(P=await this.Eb(i,P,u)),p?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of i)try{await this.G.del(n)}catch{}}Bb(P,p,o,u){const i=new Map;for(const n of Object.keys(P.local.added)){const t={content:P.local.added[n],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"remote"}),remoteContent:o[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"accepted"})})}for(const n of Object.keys(P.local.updated)){const t={content:P.local.updated[n],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"remote"}),remoteContent:o[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"accepted"})})}for(const n of P.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"accepted"})})}for(const n of Object.keys(P.remote.added)){const t={content:P.remote.added[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"accepted"})})}for(const n of Object.keys(P.remote.updated)){const t={content:P.remote.updated[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"remote"}),remoteContent:o[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"accepted"})})}for(const n of P.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"remote"}),remoteContent:o[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"accepted"})})}for(const n of P.conflicts){const t={content:u[n]??null,hasConflicts:!0,localChange:p[n]?l.Change.Modified:l.Change.Added,remoteChange:o[n]?l.Change.Modified:l.Change.Added},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"local"}),fileContent:p[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"remote"}),remoteContent:o[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"accepted"})})}for(const n of Object.keys(p))if(!i.has(n)){const t={content:p[n]?p[n].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"local"}),fileContent:p[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"remote"}),remoteContent:o[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Mnb,authority:"accepted"})})}return[...i.values()]}async resolveContent(P){return this.h.isEqualOrParent(P,this.g.with({scheme:l.$Mnb,authority:"remote"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Mnb,authority:"local"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Mnb,authority:"base"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Mnb,authority:"accepted"}))?this.db(P):null}async hasLocalData(){try{const P=await this.Hb();if(Object.keys(P).length)return!0}catch{}return!1}async Cb(P){const p={};for(const o of P)o.fileContent&&(p[this.h.basename(o.localResource)]=o.fileContent);await this.nb(JSON.stringify(this.Gb(p)))}async Db(P,p){for(const{fileContent:o,acceptResult:u,localResource:i,remoteResource:n,localChange:t}of P)if(t!==l.Change.None){const s=n?this.h.basename(n):this.h.basename(i),r=this.h.joinPath(this.vb,s);t===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):t===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,R.$Le.fromString(u.content),{overwrite:p}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,R.$Le.fromString(u.content),p?void 0:o),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(P,p,o){const u=p.syncData?this.Fb(p.syncData):{},i=(0,C.$bo)(u);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:r}of P)if(r!==l.Change.None){const a=t?this.h.basename(t):this.h.basename(s);r===l.Change.Deleted?delete i[a]:i[a]=n.content}return(0,g.$tcc)(u,i)||(this.O.trace(`${this.D}: Updating remote snippets...`),p=await this.mb(JSON.stringify(i),o?null:p.ref),this.O.info(`${this.D}: Updated remote snippets`)),p}Fb(P){return m(P)}Gb(P){const p={};for(const o of Object.keys(P))p[o]=P[o].value.toString();return p}async Hb(){const P={};let p;try{p=await this.G.resolve(this.vb)}catch(o){if(o instanceof O.$sl&&o.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND)return P;throw o}for(const o of p.children||[]){const u=o.resource,i=this.h.extname(u);if(i===".json"||i===".code-snippets"){const n=this.h.relativePath(this.vb,u),t=await this.G.readFile(u);P[n]=t}}return P}};e.$vcc=E,e.$vcc=E=ve([Z(2,N.$Ji),Z(3,O.$0k),Z(4,k.$fq),Z(5,l.$vnb),Z(6,l.$wnb),Z(7,l.$Knb),Z(8,A.$9i),Z(9,l.$Fnb),Z(10,b.$9l),Z(11,I.$Hl)],E);let f=class extends d.$1Nb{constructor(P,p,o,u,i,n){super(l.SyncResource.Snippets,p,o,u,P,i,n)}async o(P){const p=P.syncData?JSON.parse(P.syncData.content):null;if(!p){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const u of Object.keys(p)){const i=p[u];if(i){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,u);await this.k.createFile(n,R.$Le.fromString(i)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(P)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND}}};e.$wcc=f,e.$wcc=f=ve([Z(0,O.$0k),Z(1,$.$Jl),Z(2,N.$Ji),Z(3,l.$Knb),Z(4,k.$fq),Z(5,I.$Hl)],f)}),define(he[124],ue([0,1,14,21,15,7,16,18,28,19,40,24]),function(oe,e,R,c,C,A,N,O,k,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=e.$ycc=void 0,e.$xcc=d;function d(E,f){try{return JSON.parse(E).tasks??null}catch(w){return f.error(w),null}}let g=class extends I.$YNb{constructor(f,w,P,p,o,u,i,n,t,s,r,a){super(f.tasksResource,{syncResource:$.SyncResource.Tasks,profile:f},w,n,t,s,P,p,i,r,o,u,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:$.$Mnb,authority:"base"}),this.Cb=this.Ab.with({scheme:$.$Mnb,authority:"local"}),this.Db=this.Ab.with({scheme:$.$Mnb,authority:"remote"}),this.Eb=this.Ab.with({scheme:$.$Mnb,authority:"accepted"})}async qb(f,w,P,p){const o=f.syncData?d(f.syncData.content,this.O):null;w=w===null&&P?f:w;const u=w?.syncData?d(w.syncData.content,this.O):null,i=await this.vb();let n=null,t=!1,s=!1,r=!1;if(f.syncData){const y=i?i.value.toString():null;if(!u||u!==y||u!==o){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const L=m(y,o,u);n=L.content,r=L.hasConflicts,t=L.hasLocalChanged,s=L.hasRemoteChanged}}else i&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=i.value.toString(),s=!0);const a={content:r?u:n,localChange:t?i?$.Change.Modified:$.Change.Added:$.Change.None,remoteChange:s?$.Change.Modified:$.Change.None,hasConflicts:r},h=i?i.value.toString():null;return[{fileContent:i,baseResource:this.Bb,baseContent:u,localResource:this.Cb,localContent:h,localChange:a.localChange,remoteResource:this.Db,remoteContent:o,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(f){const w=f?.syncData?d(f.syncData.content,this.O):null;if(w===null)return!0;const P=await this.vb(),p=P?P.value.toString():null,o=m(p,w,w);return o.hasLocalChanged||o.hasRemoteChanged}async rb(f,w){return f.previewResult}async sb(f,w,P,p){if(this.h.isEqual(w,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:$.Change.None,remoteChange:$.Change.Modified};if(this.h.isEqual(w,this.Db))return{content:f.remoteContent,localChange:$.Change.Modified,remoteChange:$.Change.None};if(this.h.isEqual(w,this.Ab))return P===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:P,localChange:$.Change.Modified,remoteChange:$.Change.Modified};throw new Error(`Invalid Resource: ${w.toString()}`)}async tb(f,w,P,p){const{fileContent:o}=P[0][0],{content:u,localChange:i,remoteChange:n}=P[0][1];if(i===$.Change.None&&n===$.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),i!==$.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),o&&await this.nb(JSON.stringify(this.Kb(o.value.toString()))),u?await this.wb(u,o,p):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==$.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const t=JSON.stringify(this.Kb(u));f=await this.mb(t,p?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}w?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$ycc=g,e.$ycc=g=ve([Z(2,$.$vnb),Z(3,$.$wnb),Z(4,$.$Knb),Z(5,c.$9i),Z(6,$.$Fnb),Z(7,A.$0k),Z(8,C.$Ji),Z(9,N.$fq),Z(10,O.$9l),Z(11,k.$Hl)],g);let l=class extends I.$1Nb{constructor(f,w,P,p,o,u){super($.SyncResource.Tasks,w,P,p,f,o,u),this.c=this.g.defaultProfile.tasksResource}async o(f){const w=f.syncData?d(f.syncData.content,this.j):null;if(!w){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.$Le.fromString(w)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$zcc=l,e.$zcc=l=ve([Z(0,A.$0k),Z(1,b.$Jl),Z(2,C.$Ji),Z(3,$.$Knb),Z(4,N.$fq),Z(5,k.$Hl)],l);function m(E,f,w){if(E===null&&f===null&&w===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(E===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const P=w!==E,p=w!==f;return!P&&!p?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:P&&!p?{content:E,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:p&&!P?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:E,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(he[125],ue([0,1,45,21,15,7,16,18,28,19,40,209,24]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0,e.$hec=l,e.$iec=m;let g=class extends I.$XNb{constructor(f,w,P,p,o,u,i,n,t,s,r,a,h){super({syncResource:d.SyncResource.Profiles,profile:f},w,p,o,u,i,n,r,a,t,s,h),this.vb=P,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:d.$Mnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.$Mnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.$Mnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.$Mnb,authority:"accepted"}),this.B(P.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?m(f.syncData):null}async getRemoteSyncedProfiles(f){const w=await this.getLastSyncUserData(),P=await this.X(f,w);return P?.syncData?m(P.syncData):null}async qb(f,w,P){if(!this.vb.isEnabled())throw new d.$Anb("Cannot sync profiles because they are disabled",d.UserDataSyncErrorCode.LocalError);const p=f.syncData?m(f.syncData):null,o=w?.syncData?m(w.syncData):null,u=this.Db(),{local:i,remote:n}=(0,$.$fec)(u,p,o,[]),t={local:i,remote:n,content:o?this.Eb(o):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:n!==null?d.Change.Modified:d.Change.None},s=l(u,!1);return[{baseResource:this.baseResource,baseContent:o?this.Eb(o):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:p?this.Eb(p):null,remoteProfiles:p,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const w=f?.syncData?m(f.syncData):null,P=this.Db(),{remote:p}=(0,$.$fec)(P,w,w,[]);return!!p?.added.length||!!p?.removed.length||!!p?.updated.length}async rb(f,w){return{...f.previewResult,hasConflicts:!1}}async sb(f,w,P,p){if(this.h.isEqual(w,this.localResource))return this.Ab(f);if(this.h.isEqual(w,this.remoteResource))return this.Bb(f);if(this.h.isEqual(w,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async Ab(f){const w=this.Db(),P=(0,$.$fec)(w,null,null,[]),{local:p,remote:o}=P;return{content:f.localContent,local:p,remote:o,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:o!==null?d.Change.Modified:d.Change.None}}async Bb(f){const w=f.remoteContent?JSON.parse(f.remoteContent):null,P=[],p=[];for(const o of this.Db()){const u=w?.find(i=>i.id===o.id);u&&(P.push({id:o.id,name:o.name,collection:u.collection}),p.push(o))}if(w!==null){const o=(0,$.$fec)(p,w,P,[]),{local:u,remote:i}=o;return{content:f.remoteContent,local:u,remote:i,localChange:u.added.length>0||u.removed.length>0||u.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:i!==null?d.Change.Modified:d.Change.None}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:d.Change.None,remoteChange:d.Change.None}}async tb(f,w,P,p){const{local:o,remote:u,localChange:i,remoteChange:n}=P[0][1];i===d.Change.None&&n===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const t=P[0][0].remoteProfiles||[];if(t.length+(u?.added.length??0)-(u?.removed.length??0)>20)throw new d.$Anb("Too many profiles to sync. Please remove some profiles and try again.",d.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==d.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(o.removed.map(async s=>{this.O.trace(`${this.D}: Removing '${s.name}' profile...`),await this.vb.removeProfile(s),this.O.info(`${this.D}: Removed profile '${s.name}'.`)})),await Promise.all(o.added.map(async s=>{this.O.trace(`${this.D}: Creating '${s.name}' profile...`),await this.vb.createProfile(s.id,s.name,{shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${s.name}'.`)})),await Promise.all(o.updated.map(async s=>{const r=this.vb.profiles.find(a=>a.id===s.id);r?(this.O.trace(`${this.D}: Updating '${s.name}' profile...`),await this.vb.updateProfile(r,{name:s.name,shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${s.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${s.id}' to update.`)}))),n!==d.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const s=[],r=t.length+(u?.added.length??0)<=20;if(r)for(const a of u?.added||[]){const h=await this.J.createCollection(this.F);s.push(h),t.push({id:a.id,name:a.name,collection:h,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of u?.removed||[])t.splice(t.findIndex(({id:h})=>a.id===h),1);for(const a of u?.updated||[]){const h=t.find(({id:y})=>a.id===y);h&&t.splice(t.indexOf(h),1,{...h,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{f=await this.updateRemoteProfiles(t,p?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&u?.added.length?` Added: ${JSON.stringify(u.added.map(a=>a.name))}.`:""}${u?.updated.length?` Updated: ${JSON.stringify(u.updated.map(a=>a.name))}.`:""}${u?.removed.length?` Removed: ${JSON.stringify(u.removed.map(a=>a.name))}.`:""}`)}catch(a){if(s.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const h of s)await this.J.deleteCollection(h,this.F)}throw a}for(const a of u?.removed||[])await this.J.deleteCollection(a.collection,this.F)}w?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,w){return this.mb(this.Eb(f),w)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const w=await this.db(f);return w&&(0,R.$6n)(JSON.parse(w),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((w,P)=>w.name.localeCompare(P.name)))}};e.$gec=g,e.$gec=g=ve([Z(2,b.$Jl),Z(3,A.$0k),Z(4,C.$Ji),Z(5,N.$fq),Z(6,d.$vnb),Z(7,d.$wnb),Z(8,d.$Knb),Z(9,c.$9i),Z(10,d.$Fnb),Z(11,O.$9l),Z(12,k.$Hl)],g);function l(E,f){const w=[...E].sort((P,p)=>P.name.localeCompare(p.name)).map(P=>({id:P.id,name:P.name}));return f?(0,R.$6n)(w,{}):JSON.stringify(w)}function m(E){return JSON.parse(E.content)}}),define(he[228],ue([0,1,3,2,5,15,16,18,24]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;const b="sync.enable";let I=class extends c.$Tc{constructor(d,g,l,m){super(),this.c=d,this.f=g,this.g=l,this.h=m,this.a=new R.$je,this.onDidChangeEnablement=this.a.event,this.b=new R.$je,this.onDidChangeResourceEnablement=this.b.event,this.B(d.onDidChangeValue(N.StorageScope.APPLICATION,void 0,this.B(new c.$Sc))(E=>this.m(E)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,N.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:d}),this.c.store(b,d,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE))}isResourceEnabled(d){return this.c.getBoolean((0,k.$Enb)(d),N.StorageScope.APPLICATION,!0)}setResourceEnablement(d,g){if(this.isResourceEnabled(d)!==g){const l=(0,k.$Enb)(d);this.j(l,g)}}getResourceSyncStateVersion(d){}j(d,g){this.c.store(d,g,N.StorageScope.APPLICATION,C.$p?N.StorageTarget.USER:N.StorageTarget.MACHINE)}m(d){if(b===d.key){this.a.fire(this.isEnabled());return}const g=k.$rnb.filter(l=>(0,k.$Enb)(l)===d.key)[0];if(g){this.b.fire([g,this.isResourceEnabled(g)]);return}}};e.$6dc=I,e.$6dc=I=ve([Z(0,N.$fq),Z(1,O.$9l),Z(2,A.$Ji),Z(3,k.$unb)],I)}),define(he[229],ue([0,1,6,14,71,2,20,21,15,7,19,24]),function(oe,e,R,c,C,A,N,O,k,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;let d=class extends A.$Tc{constructor(l,m,E,f,w){super(),this.a=l,this.b=m,this.c=E,this.f=f,this.g=w,this.h()}async h(){for(const m of this.g.profiles)for(const E of $.$rnb)try{await this.m(this.j(E,m.isDefault?void 0:m.id))}catch(f){this.f.error(f)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(m){(0,b.$ol)(m)!==b.FileOperationResult.FILE_NOT_FOUND&&this.f.error(m);return}if(l.children){for(const m of l.children)if(m.isDirectory&&!$.$rnb.includes(m.name)&&!this.g.profiles.some(E=>E.id===m.name))try{this.f.info("Deleting non existing profile from backup",m.resource.path),await this.b.del(m.resource,{recursive:!0})}catch(E){this.f.error(E)}}}async getAllResourceRefs(l,m,E){const f=this.j(l,m,E);try{const w=await this.b.resolve(f);if(w.children)return w.children.filter(p=>p.isFile&&!p.name.startsWith("lastSync")).sort().reverse().map(p=>({ref:p.name,created:this.n(p)}))}catch(w){if((0,b.$ol)(w)!==b.FileOperationResult.FILE_NOT_FOUND)throw w}return[]}async resolveResourceContent(l,m,E,f){const w=this.j(l,E,f),P=(0,N.$dh)(w,m);try{return(await this.b.readFile(P)).value.toString()}catch(p){return this.f.error(p),null}}async writeResource(l,m,E,f,w){const P=this.j(l,f,w),p=(0,N.$dh)(P,`${(0,C.$1m)(E).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(p,c.$Le.fromString(m))}catch(o){this.f.error(o)}}j(l,m,E=this.a.userDataSyncHome){return(0,N.$dh)(E,...m?[m,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const m=await this.b.resolve(l);if(m.children){const E=m.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let w=E.filter(p=>Date.now()-this.n(p)>f);const P=E.length-w.length;P<10&&(w=w.slice(10-P)),await R.Promises.settled(w.map(async p=>{this.f.info("Deleting from backup",p.resource.path),await this.b.del(p.resource)}))}}catch(m){this.f.error(m)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$eec=d,e.$eec=d=ve([Z(0,k.$Ji),Z(1,b.$0k),Z(2,O.$9i),Z(3,$.$Knb),Z(4,I.$Jl)],d)}),define(he[86],ue([0,1,3,2,5,26,11,15,7,4,23,49,16,24]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$jnb=e.$hnb=void 0,e.$inb=o,e.$hnb=(0,b.$Ci)("IUserDataSyncMachinesService");const m="sync.currentMachineName",E="Safari",f="Chrome",w="Edge",P="Firefox",p="Android";function o(n){switch(n){case E:case f:case w:case P:case p:case(0,C.$i)(C.Platform.Web):return!0}return!1}function u(){return C.$H?E:C.$F?f:C.$I?w:C.$G?P:C.$J?p:(0,C.$i)(C.$p?C.Platform.Web:C.$v)}let i=class extends c.$Tc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(t,s,r,a,h,y){super(),this.h=r,this.j=a,this.m=h,this.n=y,this.c=this.B(new R.$je),this.onDidChange=this.c.event,this.g=null,this.f=(0,$.$lq)(t,s,r)}async getMachines(t){const s=await this.f;return(await this.s(t)).machines.map(a=>({...a,isCurrent:a.id===s}))}async addCurrentMachine(t){const s=await this.f,r=await this.s(t);r.machines.some(({id:a})=>a===s)||(r.machines.push({id:s,name:this.r(r.machines),platform:u()}),await this.t(r))}async removeCurrentMachine(t){const s=await this.f,r=await this.s(t),a=r.machines.filter(({id:h})=>h!==s);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(t,s,r){const a=await this.s(r),h=a.machines.find(({id:y})=>y===t);if(h){h.name=s,await this.t(a);const y=await this.f;t===y&&this.h.store(m,s,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}}async setEnablements(t){const s=await this.s();for(const[r,a]of t){const h=s.machines.find(y=>y.id===r);h&&(h.disabled=a?void 0:!0)}await this.t(s)}r(t){const s=this.h.get(m,d.StorageScope.APPLICATION);if(s)return s;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${u()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$ff)(r)}\\s#(\\d+)`);let h=0;for(const y of t){const L=a.exec(y.name),S=L?parseInt(L[1]):0;h=S>h?S:h}return`${r} #${h+1}`}async s(t){this.g=await this.u(t);const s=this.w(this.g);if(s.version!==l.a)throw new Error((0,N.localize)(10923,null,this.n.nameLong));return s}async t(t){const s=JSON.stringify(t),r=await this.j.writeResource(l.b,s,this.g?.ref||null);this.g={ref:r,content:s},this.c.fire()}async u(t){if(this.g){const s=t&&t.latest?t.latest[l.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.m.error(s)}return{version:l.a,machines:[]}}};e.$jnb=i,e.$jnb=i=l=ve([Z(0,O.$Ji),Z(1,k.$0k),Z(2,d.$fq),Z(3,g.$vnb),Z(4,g.$Knb),Z(5,I.$qk)],i)}),define(he[230],ue([0,1,6,71,43,8,3,2,5,20,9,11,23,16,18,24,82,86]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;const w="sync.disableMachineEventually",P="sync.sessionId",p="sync.storeUrl",o="sync.productQuality";let u=class extends O.$Tc{get n(){const t=this.H.get(p,g.StorageScope.APPLICATION);return t?I.URI.parse(t):void 0}set n(t){t?this.H.store(p,t.toString(),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE):this.H.remove(p,g.StorageScope.APPLICATION)}get s(){return this.H.get(o,g.StorageScope.APPLICATION)}set s(t){t?this.H.store(o,t,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE):this.H.remove(o,g.StorageScope.APPLICATION)}constructor(t,s,r,a,h,y,L,S,v,T){super(),this.u=s,this.w=r,this.y=a,this.z=h,this.C=y,this.D=L,this.F=S,this.G=v,this.H=T,this.a=this.B(new O.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new N.$je),this.onError=this.h.event,this.S=[],this.f=this.B(new R.$Ah(this.U())),this.j=this.n,this.n=s.userDataSyncStore?.url,this.r=this.s,this.s=t.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,b.$9g)(this.n,s.userDataSyncStore?.url)||(this.j=this.n,this.n=s.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(L.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(h.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(N.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:t,message:s}=this.L();t?this.a.value===void 0&&(this.a.value=new i(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.C.info(s),this.a.clear()):s&&this.y.isEnabled()&&this.C.info(s))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,c.$1m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(t,s,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(P,g.StorageScope.APPLICATION),t?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),s)this.M(!1);else throw a}}M(t){this.y.isEnabled()!==t&&(this.y.setEnablement(t),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(t){if(!t){this.b=0;return}const s=m.$Anb.toUserDataSyncError(t);s instanceof m.$Cnb&&this.F.publicLog2("autosync/error",{code:s.code,service:this.u.userDataSyncStore.url.toString()}),s.code===m.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):s.code===m.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code===m.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):s.code===m.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code===m.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code===m.UserDataSyncErrorCode.UpgradeRequired||s.code===m.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code===m.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code===m.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code===m.UserDataSyncErrorCode.ServiceChanged||s.code===m.UserDataSyncErrorCode.DefaultServiceChanged?k.$p&&s.code===m.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(s),this.b++),this.h.fire(s)}async P(){this.H.store(w,!0,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await(0,R.$Dh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(w,g.StorageScope.APPLICATION,!1)}R(){this.H.remove(w,g.StorageScope.APPLICATION)}async triggerSync(t,s,r){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...t),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$kec=u,e.$kec=u=ve([Z(0,d.$qk),Z(1,m.$unb),Z(2,m.$vnb),Z(3,m.$Fnb),Z(4,m.$Gnb),Z(5,m.$Knb),Z(6,E.$fMb),Z(7,l.$9l),Z(8,f.$hnb),Z(9,g.$fq)],u);class i extends O.$Tc{static{this.a="Interval"}constructor(t,s,r,a,h,y,L,S,v){super(),this.m=t,this.n=s,this.r=r,this.s=a,this.u=h,this.w=y,this.y=L,this.z=S,this.C=v,this.b=this.B(new O.$Uc),this.c=this.B(new N.$je),this.onDidStartSync=this.c.event,this.f=this.B(new N.$je),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,O.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(i.a,!1)}D(){this.b.value=(0,R.$Eh)(()=>{this.sync(i.a,!1),this.b.value=void 0},this.n)}sync(t,s){const r=(0,R.$ph)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(h){if((0,A.$3)(h))return}return this.H(t,s,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,b.$9g)(this.m,this.r.userDataSyncStore?.url)}async G(){const t=await this.r.getPreviousUserDataSyncStore(),s=this.r.userDataSyncStore;return!!s&&!!t&&(!(0,b.$9g)(s.defaultUrl,t.defaultUrl)||!(0,b.$9g)(s.insidersUrl,t.insidersUrl)||!(0,b.$9g)(s.stableUrl,t.stableUrl))}async H(t,s,r){this.y.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let a;try{await this.I(s,r)}catch(h){if(this.y.error(h),a=h,m.$Anb.toUserDataSyncError(h).code===m.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(s,r),a=void 0}catch(y){this.y.error(y),a=y}}this.f.fire(a)}async I(t,s){if(this.h=await this.u.createSyncTask(this.g,t),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new m.$Cnb((0,$.localize)(10930,null),m.UserDataSyncErrorCode.DefaultServiceChanged):new m.$Cnb((0,$.localize)(10931,null),m.UserDataSyncErrorCode.ServiceChanged):new m.$Cnb((0,$.localize)(10932,null),m.UserDataSyncErrorCode.TurnedOff);const r=this.C.get(P,g.StorageScope.APPLICATION);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new m.$Cnb((0,$.localize)(10933,null),m.UserDataSyncErrorCode.DefaultServiceChanged):new m.$Cnb((0,$.localize)(10934,null),m.UserDataSyncErrorCode.ServiceChanged):new m.$Cnb((0,$.localize)(10935,null),m.UserDataSyncErrorCode.SessionExpired);const a=await this.w.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const h=a.find(L=>L.isCurrent);if(h?.disabled)throw new m.$Cnb((0,$.localize)(10936,null),m.UserDataSyncErrorCode.TurnedOff);const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(L){throw new m.$Cnb((0,C.$nj)(L),L instanceof m.$Anb?L.code:m.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==r&&this.C.store(P,this.g.session,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),!s.isCancellationRequested&&(h||await this.w.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}}),define(he[231],ue([0,1,9,11,15,7,49,16,28,24,19,40,123,122,121,21,124,119,120,4,125,45,26]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o,u){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;let n=class{static{i=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(s,r,a,h,y,L,S,v,T,U){this.e=s,this.f=r,this.g=a,this.h=y,this.i=L,this.j=S,this.k=v,this.l=T,this.n=U,this.d=h.extUri}async getRemoteSyncedProfiles(){const s=await this.e.readResource(b.SyncResource.Profiles,null,void 0);if(s.content){const r=this.L(s.content,b.SyncResource.Profiles);return(0,p.$iec)(r)}return[]}async getLocalSyncedProfiles(s){const r=await this.f.getAllResourceRefs(b.SyncResource.Profiles,void 0,s);if(r.length){const a=await this.f.resolveResourceContent(b.SyncResource.Profiles,r[0].ref,void 0,s);if(a){const h=this.L(a,b.SyncResource.Profiles);return(0,p.$iec)(h)}}return[]}async getLocalSyncedMachines(s){const r=await this.f.getAllResourceRefs("machines",void 0,s);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,s);if(a)return JSON.parse(a).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(s,r){return(await this.e.getAllResourceRefs(s,r?.collection)).map(({created:h,ref:y})=>({created:h,uri:this.J({remote:!0,syncResource:s,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(s,r,a){return(await this.f.getAllResourceRefs(s,r?.collection,a)).map(({created:y,ref:L})=>({created:y,uri:this.J({remote:!1,syncResource:s,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:L,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:s}){const r=this.K(s),a=r?this.k.profiles.find(h=>h.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:s}){const r=this.K(s);if(!r)return[];const a=this.k.profiles.find(h=>h.id===r.profile);switch(r.syncResource){case b.SyncResource.Settings:return this.s(s,a);case b.SyncResource.Keybindings:return this.u(s,a);case b.SyncResource.Tasks:return this.w(s,a);case b.SyncResource.Snippets:return this.y(s,a);case b.SyncResource.GlobalState:return this.D(s,a);case b.SyncResource.Extensions:return this.A(s,a);case b.SyncResource.Profiles:return this.G(s,a);case b.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:s}){const r=this.K(s);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,N.$lq)(this.h,this.j,this.i)}}async resolveContent(s){const r=this.K(s);if(!r||r.node===i.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(s,r,a,h,y){if(s){const{content:L}=await this.M(r,h,a);return L}return this.f.resolveResourceContent(r,h,a,y)}q(s,r,a){const h=this.L(r,s);switch(s){case b.SyncResource.Settings:return this.t(h,a);case b.SyncResource.Keybindings:return this.v(h,a);case b.SyncResource.Tasks:return this.x(h,a);case b.SyncResource.Snippets:return this.z(h,a);case b.SyncResource.GlobalState:return this.E(h,a);case b.SyncResource.Extensions:return this.B(h,a);case b.SyncResource.Profiles:return this.H(h,a);case b.SyncResource.WorkspaceState:return null}}async r(s,r){const a=this.k.profiles.find(h=>h.id===r);if(!a)return null;switch(s){case b.SyncResource.GlobalState:return this.F(a);case b.SyncResource.Extensions:return this.C(a);case b.SyncResource.Profiles:return this.I(a);case b.SyncResource.Settings:return null;case b.SyncResource.Keybindings:return null;case b.SyncResource.Tasks:return null;case b.SyncResource.Snippets:return null;case b.SyncResource.WorkspaceState:return null}}s(s,r){const a=this.d.joinPath(s,"settings.json"),h=r?r.settingsResource:this.d.joinPath(s,i.a);return[{resource:a,comparableResource:h}]}t(s,r){switch(r){case"settings.json":return(0,g.$pcc)(s.content).settings}return null}u(s,r){const a=this.d.joinPath(s,"keybindings.json"),h=r?r.keybindingsResource:this.d.joinPath(s,i.a);return[{resource:a,comparableResource:h}]}v(s,r){switch(r){case"keybindings.json":return(0,l.$mcc)(s.content,!!this.l.getValue(b.$onb),this.g)}return null}w(s,r){const a=this.d.joinPath(s,"tasks.json"),h=r?r.tasksResource:this.d.joinPath(s,i.a);return[{resource:a,comparableResource:h}]}x(s,r){switch(r){case"tasks.json":return(0,E.$xcc)(s.content,this.g)}return null}async y(s,r){const a=await this.resolveContent(s);if(a){const h=this.L(a,b.SyncResource.Snippets);if(h){const y=(0,d.$ucc)(h),L=[];for(const S of Object.keys(y)){const v=this.d.joinPath(s,S),T=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(s,i.a);L.push({resource:v,comparableResource:T})}return L}}return[]}z(s,r){return(0,d.$ucc)(s)[r]||null}A(s,r){const a=this.d.joinPath(s,"extensions.json"),h=r?this.J({remote:!1,syncResource:b.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:a,comparableResource:h}]}B(s,r){switch(r){case"extensions.json":return(0,f.$hcc)((0,f.$gcc)(s),!0)}return null}async C(s){const{localExtensions:r}=await this.n.createInstance(f.$jcc).getLocalExtensions(s);return(0,f.$hcc)(r,!0)}D(s,r){const a=this.d.joinPath(s,"globalState.json"),h=r?this.J({remote:!1,syncResource:b.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:a,comparableResource:h}]}E(s,r){switch(r){case"globalState.json":return(0,w.$3Nb)(JSON.parse(s.content),!0)}return null}async F(s){const r=await this.n.createInstance(w.$5Nb).getLocalGlobalState(s);return(0,w.$3Nb)(r,!0)}G(s,r){const a=this.d.joinPath(s,"profiles.json"),h=this.J({remote:!1,syncResource:b.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:h}]}H(s,r){switch(r){case"profiles.json":return(0,o.$6n)(JSON.parse(s.content),{})}return null}async I(s){return(0,p.$hec)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(s){const r=s.remote?i.b:i.c,a=[];return s.location&&(a.push(`scheme:${s.location.scheme}`),a.push(`authority:${s.location.authority}`),a.push((0,u.$jf)(s.location.path,"/"))),a.push(`syncResource:${s.syncResource}`),a.push(`profile:${s.profile}`),s.collection&&a.push(`collection:${s.collection}`),s.ref&&a.push(`ref:${s.ref}`),s.node&&a.push(s.node),this.d.joinPath(R.URI.from({scheme:b.$Mnb,authority:r,path:"/",query:s.location?.query,fragment:s.location?.fragment}),...a)}K(s){if(s.scheme!==b.$Mnb)return;const r=[];for(;s.path!=="/";)r.unshift(this.d.basename(s)),s=this.d.dirname(s);if(r.length<2)return;const a=s.authority===i.b;let h,y;const L=[];let S,v,T,U,F;for(;r.length;){const j=r.shift();j.startsWith("scheme:")?h=j.substring(7):j.startsWith("authority:")?y=j.substring(10):j.startsWith("syncResource:")?S=j.substring(13):j.startsWith("profile:")?v=j.substring(8):j.startsWith("collection:")?T=j.substring(11):j.startsWith("ref:")?U=j.substring(4):S?F=j:L.push(j)}return{remote:a,syncResource:S,profile:v,collection:T,ref:U,node:F,location:h&&y!==void 0?this.d.joinPath(R.URI.from({scheme:h,authority:y,query:s.query,fragment:s.fragment,path:"/"}),...L):void 0}}L(s,r){try{const a=JSON.parse(s);if((0,$.$VNb)(a))return a}catch(a){this.g.error(a)}throw new b.$Anb((0,c.localize)(10922,null),b.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async M(s,r,a){const h=await this.e.resolveResourceContent(s,r,a);return{ref:r,content:h}}};e.$Zec=n,e.$Zec=n=i=ve([Z(0,b.$vnb),Z(1,b.$wnb),Z(2,b.$Knb),Z(3,k.$Hl),Z(4,C.$Ji),Z(5,O.$fq),Z(6,A.$0k),Z(7,I.$Jl),Z(8,m.$9i),Z(9,P.$Bi)],n)}),define(he[232],ue([0,1,17,6,25,43,3,2,20,12,32,21,27,7,4,16,18,19,119,120,121,122,123,124,125,24]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o,u,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;const s="sync.lastSyncTime";let r=class extends O.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,v,T,U,F,j,G,V,x,H,ie){super(),this.C=S,this.D=v,this.F=T,this.G=U,this.H=F,this.I=j,this.J=G,this.L=V,this.M=x,this.N=H,this.O=ie,this.f=t.SyncStatus.Uninitialized,this.g=this.B(new N.$je),this.onDidChangeStatus=this.g.event,this.h=this.B(new N.$je),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new N.$je),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new N.$je),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new N.$je),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new N.$je),this.onDidResetLocal=this.w.event,this.y=this.B(new N.$je),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this.t=this.J.getNumber(s,m.StorageScope.APPLICATION,void 0),this.B((0,O.$Rc)(()=>this.cb())),this.B(new c.$Oh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(S,v){this.db(),this.H.info("Sync started.");const T=new Date().getTime(),U=(0,I.$Yg)();try{const V=(0,t.$znb)(U);v&&(V["Cache-Control"]="no-cache"),S=await this.D.manifest(S,V)}catch(V){const x=t.$Anb.toUserDataSyncError(V);throw y(x,U,this.F,this.I),x}const F=!1,j=this;let G;return{manifest:S,async run(){if(F)throw new Error("Can run a task only once");G=(0,c.$ph)(V=>j.P(S,!1,U,V)),await G.finally(()=>G=void 0),j.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),j.ab()},stop(){return G?.cancel(),j.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new t.$Anb("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const S=new Date().getTime(),v=(0,I.$Yg)(),T=(0,t.$znb)(v);let U;try{U=await this.D.manifest(null,T)}catch(G){const V=t.$Anb.toUserDataSyncError(G);throw y(V,v,this.F,this.I),V}await this.resetLocal();const F=this,j=new C.$ue;return{id:v,async merge(){return F.P(U,!0,v,j.token)},async apply(){try{try{await F.R(U,v,j.token)}catch(G){if(t.$Anb.toUserDataSyncError(G).code===t.UserDataSyncErrorCode.MethodNotFound)F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(U,v,j.token);else throw G}}catch(G){throw F.H.error(G),G}F.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),F.ab()},async stop(){j.cancel(),await F.U(),await F.resetLocal()}}}async P(S,v,T,U){this.n=[];try{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Syncing);const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,S,v,T,U));const j=F.enabled.find(G=>G.resource===t.SyncResource.Profiles);if(j){const G=await j.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(G,S,v,T,U)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Idle),this.r.fire(this.n)}}async Q(S,v,T,U,F){for(const j of S){if(F.isCancellationRequested)return;const G=this.M.profiles.find(x=>x.id===j.id);if(!G){this.H.error(`Profile with id:${j.id} and name: ${j.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",j.name);const V=this.getOrCreateActiveProfileSynchronizer(G,j);this.n.push(...await this.S(V,v,T,U,F))}for(const[j,G]of this.z.entries())this.M.profiles.some(V=>V.id===G[0].profile.id)||(await G[0].resetLocal(),G[1].dispose(),this.z.delete(j))}async R(S,v,T){const U=this.bb();for(const x of U){if(T.isCancellationRequested)return;await x.apply(v,T)}const F=U.find(x=>x.profile.isDefault);if(!F)return;const j=F.enabled.find(x=>x.resource===t.SyncResource.Profiles);if(!j)return;const V=(await j.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(x=>U.every(H=>H.profile.id!==x.id));V.length&&await this.Q(V,S,!1,v,T)}async S(S,v,T,U,F){return(await S.sync(v,T,U,F)).map(([G,V])=>({profile:S.profile,syncResource:G,error:V}))}async U(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(S=>S.stop()))}async resolveContent(S){const v=await this.N.resolveContent(S);if(v)return v;for(const T of this.bb())for(const U of T.enabled){const F=await U.resolveContent(S);if(F)return F}return null}async replace(S){this.db();const v=this.N.resolveUserDataSyncResource(S);if(!v)return;const T=await this.resolveContent(S.uri);T&&await this.X(v.profile,async U=>{if(v.syncResource===U.resource)return await U.replace(T),!0})}async accept(S,v,T,U){this.db(),await this.X(S.profile,async F=>{if(S.syncResource===F.resource)return await F.accept(v,T),U&&await F.apply((0,b.$ig)(U)?!1:U.force,(0,t.$znb)((0,I.$Yg)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async v=>{if(v.resource!==t.SyncResource.GlobalState&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(s,m.StorageScope.APPLICATION);for(const[S]of this.z.values())try{await S.resetLocal()}catch(v){this.H.error(v)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const S=this.J.keys(m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),v=[];for(const U of S){if(!U.endsWith(".lastSyncUserData"))continue;const F=U.split(".");F.length===3&&v.push([U,F[0]])}if(!v.length)return;const T=new O.$Sc;try{let U=this.z.get(this.M.defaultProfile.id)?.[0];U||(U=T.add(this.G.createInstance(a,this.M.defaultProfile,void 0)));const F=U.enabled.find(V=>V.resource===t.SyncResource.Profiles);if(!F)return;const G=(await F.getLastSyncedProfiles())?.map(V=>V.collection)??[];for(const[V,x]of v)G.includes(x)||(this.H.info(`Removing last sync state for stale profile: ${x}`),this.J.remove(V,m.StorageScope.APPLICATION))}finally{T.dispose()}}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),v=S.map(j=>j.collection),T=await this.D.getAllCollections(),U=T.filter(j=>!v.includes(j));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(j=>this.D.deleteCollection(j))),this.H.info("Deleted redundant collections on server"));const F=S.filter(j=>T.includes(j.collection));if(F.length!==S.length){const j=this.G.createInstance(n.$gec,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await j.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await j.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{j.dispose()}}}async saveRemoteActivityData(S){this.db();const v=await this.D.getActivityData();await this.C.writeFile(S,v)}async extractActivityData(S,v){const T=(await this.C.readFile(S)).value.toString(),U=JSON.parse(T);if(U.resources)for(const F in U.resources)for(const j of U.resources[F])await this.O.writeResource(F,j.content,new Date(j.created*1e3),void 0,v);if(U.collections)for(const F in U.collections)for(const j in U.collections[F].resources)for(const G of U.collections[F].resources?.[j]??[])await this.O.writeResource(j,G.content,new Date(G.created*1e3),F,v)}async X(S,v){const T=new O.$Sc;try{const U=this.z.get(S.id);if(U){const x=await this.Y(U[0],v,T);return(0,b.$jg)(x)?null:x}if(S.isDefault){const x=T.add(this.G.createInstance(a,S,void 0)),H=await this.Y(x,v,T);return(0,b.$jg)(H)?null:H}if(this.M.isEnabled())return null;const F=T.add(this.G.createInstance(n.$gec,S,void 0)),j=await this.D.manifest(null),V=(await F.getRemoteSyncedProfiles(j?.latest??null)||[]).find(x=>x.id===S.id);if(V){const x=T.add(this.G.createInstance(a,S,V.collection)),H=await this.Y(x,v,T);return(0,b.$jg)(H)?null:H}return null}finally{T.dispose()}}async Y(S,v,T){const U=[...S.enabled,...S.disabled.reduce((F,j)=>(j!==t.SyncResource.WorkspaceState&&F.push(T.add(S.createSynchronizer(j))),F),[])];for(const F of U){const j=await v(F);if(!(0,b.$jg)(j))return j}}Z(S){const v=this.f;this.f!==S&&(this.f=S,this.g.fire(S),v===t.SyncStatus.HasConflicts&&this.ab())}$(){const S=this.bb().map(v=>v.conflicts).flat();(0,R.$tb)(this.j,S,(v,T)=>v.profile.id===T.profile.id&&v.syncResource===T.syncResource&&(0,R.$tb)(v.conflicts,T.conflicts,(U,F)=>(0,k.$9g)(U.previewResource,F.previewResource)))||(this.j=S,this.m.fire(S))}ab(){this.status===t.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(s,this.t,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,v){let T=this.z.get(S.id);if(T&&T[0].collection!==v?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(S.id)),!T){const U=new O.$Sc,F=U.add(this.G.createInstance(a,S,v?.collection));U.add(F.onDidChangeStatus(j=>this.Z(j))),U.add(F.onDidChangeConflicts(j=>this.$())),U.add(F.onDidChangeLocal(j=>this.h.fire(j))),this.z.set(S.id,T=[F,U])}return T[0]}bb(){const S=[];for(const[v]of this.z.values())S.push(v);return S}cb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$jec=r,e.$jec=r=ve([Z(0,g.$0k),Z(1,t.$vnb),Z(2,t.$unb),Z(3,l.$Bi),Z(4,t.$Knb),Z(5,E.$9l),Z(6,m.$fq),Z(7,t.$Fnb),Z(8,f.$Jl),Z(9,t.$Hnb),Z(10,t.$wnb)],r);let a=class extends O.$Tc{get enabled(){return this.f.sort((S,v)=>S[1]-v[1]).map(([S])=>S)}get disabled(){return t.$rnb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,v,T,U,F,j,G,V,x,H){super(),this.profile=S,this.collection=v,this.r=T,this.t=U,this.u=F,this.w=j,this.y=G,this.z=V,this.C=x,this.D=H,this.f=[],this.g=t.SyncStatus.Idle,this.h=this.B(new N.$je),this.onDidChangeStatus=this.h.event,this.j=this.B(new N.$je),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new N.$je),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([ie,z])=>this.F(ie,z))),this.B((0,O.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of t.$rnb)T.isResourceEnabled(ie)&&this.G(ie)}F(S,v){v?this.G(S):this.H(S)}G(S){if(this.f.some(([F])=>F.resource===S))return;if(S===t.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||S===t.SyncResource.WorkspaceState)return;if(S!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const v=new O.$Sc,T=v.add(this.createSynchronizer(S));v.add(T.onDidChangeStatus(()=>this.L())),v.add(T.onDidChangeConflicts(()=>this.M())),v.add(T.onDidChangeLocal(()=>this.j.fire(S)));const U=this.N(S);this.f.push([T,U,v])}H(S){const v=this.f.findIndex(([T])=>T.resource===S);if(v!==-1){const[[T,,U]]=this.f.splice(v,1);U.dispose(),this.L(),T.stop().then(null,F=>this.z.error(F))}}createSynchronizer(S){switch(S){case t.SyncResource.Settings:return this.t.createInstance(o.$qcc,this.profile,this.collection);case t.SyncResource.Keybindings:return this.t.createInstance(p.$ncc,this.profile,this.collection);case t.SyncResource.Snippets:return this.t.createInstance(u.$vcc,this.profile,this.collection);case t.SyncResource.Tasks:return this.t.createInstance(i.$ycc,this.profile,this.collection);case t.SyncResource.GlobalState:return this.t.createInstance(P.$4Nb,this.profile,this.collection);case t.SyncResource.Extensions:return this.t.createInstance(w.$icc,this.profile,this.collection);case t.SyncResource.Profiles:return this.t.createInstance(n.$gec,this.profile,this.collection)}}async sync(S,v,T,U){if(U.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const j=[],G=(0,t.$znb)(T),V=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,x=v?await this.I(V):{};for(const H of F){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(v){const ie=await H.preview(V,x,G);if(ie)for(const z of ie.resourcePreviews)(z.localChange!==t.Change.None||z.remoteChange!==t.Change.None)&&z.mergeState===t.MergeState.Preview&&await H.merge(z.previewResource)}else await H.sync(V,G)}catch(ie){const z=t.$Anb.toUserDataSyncError(ie);if(y(z,T,this.w,this.y),h(ie))throw z;this.z.error(ie),this.z.error(`${H.resource}: ${(0,A.$nj)(ie)}`),j.push([H.resource,z])}}return j}finally{this.L()}}async apply(S,v){const T=(0,t.$znb)(S);for(const U of this.enabled){if(v.isCancellationRequested)return;try{await U.apply(!1,T)}catch(F){const j=t.$Anb.toUserDataSyncError(F);if(y(j,S,this.w,this.y),h(F))throw j;this.z.error(F),this.z.error(`${U.resource}: ${(0,A.$nj)(F)}`)}}}async stop(){for(const S of this.enabled)try{S.status!==t.SyncStatus.Idle&&await S.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(v){this.z.error(`${S.resource}: ${(0,A.$nj)(v)}`),this.z.error(v)}}async I(S){if(!this.profile.isDefault)return{};const v=this.D.getValue(t.$nnb),T=this.enabled.find(U=>U instanceof o.$qcc);if(T){const U=await T.getRemoteUserDataSyncConfiguration(S);return{...v,...U}}return v}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status===t.SyncStatus.HasConflicts)?this.J(t.SyncStatus.HasConflicts):this.enabled.some(S=>S.status===t.SyncStatus.Syncing)?this.J(t.SyncStatus.Syncing):this.J(t.SyncStatus.Idle)}M(){const S=this.enabled.filter(v=>v.status===t.SyncStatus.HasConflicts).filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,R.$tb)(this.m,S,(v,T)=>v.syncResource===T.syncResource&&(0,R.$tb)(v.conflicts,T.conflicts,(U,F)=>(0,k.$9g)(U.previewResource,F.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};a=ve([Z(2,t.$Fnb),Z(3,l.$Bi),Z(4,d.$ip),Z(5,t.$unb),Z(6,E.$9l),Z(7,t.$Knb),Z(8,f.$Jl),Z(9,$.$9i)],a);function h(L){if(L instanceof t.$Anb)switch(L.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function y(L,S,v,T){T.publicLog2("sync/error",{code:L.code,serverCode:L instanceof t.$Bnb?String(L.serverCode):void 0,url:L instanceof t.$Bnb?L.url:void 0,resource:L.resource,executionId:S,service:v.userDataSyncStore.url.toString()})}}),define(he[233],ue([0,1,3,2,9,19,24]),function(oe,e,R,c,C,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=void 0;function O(d,g){return{...d,profile:(0,A.$Kl)(d.profile,g.profilesHome.scheme)}}function k(d){return{created:d.created,uri:C.URI.revive(d.uri)}}class b{constructor(g,l,m){this.c=g,this.d=l,this.f=m,this.a=new Map,this.b=new R.$je}listen(g,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(g,l,m){try{return await this.g(g,l,m)}catch(E){throw this.f.error(E),E}}async g(g,l,m){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(C.URI.revive(m[0]));case"accept":return this.c.accept(O(m[0],this.d),C.URI.revive(m[1]),m[2],m[3]);case"replace":return this.c.replace(k(m[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(C.URI.revive(m[0]));case"extractActivityData":return this.c.extractActivityData(C.URI.revive(m[0]),C.URI.revive(m[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const E=l.substring(11),f=m[0],w=this.h(f);switch(m=m.slice(1),E){case"merge":return w.merge();case"apply":return w.apply().then(()=>this.a.delete(this.j(w.id)));case"stop":return w.stop().finally(()=>this.a.delete(this.j(w.id)))}}throw new Error("Invalid call")}h(g){const l=this.a.get(this.j(g));if(!l)throw new Error(`Manual sync taks not found: ${g}`);return l}async i(){const g=await this.c.createManualSyncTask();return this.a.set(this.j(g.id),g),g.id}j(g){return`manualSyncTask-${g}`}}e.$Ghc=b;let I=class extends c.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(g,l){super(),this.n=l,this.b=N.SyncStatus.Uninitialized,this.c=this.B(new R.$je),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.$je),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new R.$je),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new R.$je),this.onSyncErrors=this.m.event,this.a={call(m,E,f){return g.call(m,E,f).then(null,w=>{throw N.$Anb.toUserDataSyncError(w)})},listen(m,E){return g.listen(m,E)}},this.a.call("_getInitialData").then(([m,E,f])=>{this.s(m),this.t(E),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(w=>this.s(w))),this.B(this.a.listen("onDidChangeLastSyncTime")(w=>this.u(w)))}),this.B(this.a.listen("onDidChangeConflicts")(m=>this.t(m))),this.B(this.a.listen("onSyncErrors")(m=>this.m.fire(m.map(E=>({...E,error:N.$Anb.toUserDataSyncError(E.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const g=await this.a.call("createManualSyncTask"),l=this;return new $(g,{async call(E,f,w){return l.a.call(`manualSync/${E}`,[g,...Array.isArray(f)?f:[f]],w)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(g,l,m,E){return this.a.call("accept",[g,l,m,E])}resolveContent(g){return this.a.call("resolveContent",[g])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(g){return this.a.call("replace",[g])}saveRemoteActivityData(g){return this.a.call("getRemoteActivityData",[g])}extractActivityData(g,l){return this.a.call("extractActivityData",[g,l])}async s(g){this.b=g,this.c.fire(g)}async t(g){this.f=g.map(l=>({syncResource:l.syncResource,profile:(0,A.$Kl)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(m=>({...m,baseResource:C.URI.revive(m.baseResource),localResource:C.URI.revive(m.localResource),remoteResource:C.URI.revive(m.remoteResource),previewResource:C.URI.revive(m.previewResource)}))})),this.g.fire(this.f)}u(g){this.h!==g&&(this.h=g,this.j.fire(g))}};e.$Hhc=I,e.$Hhc=I=ve([Z(1,A.$Jl)],I);class $ extends c.$Tc{constructor(g,l){super(),this.id=g,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(he[126],ue([0,1,6,25,8,3,2,134,5,20,12,9,32,21,15,7,23,61,49,16,24]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TNb=e.$SNb=e.$RNb=e.$QNb=e.$PNb=void 0;const o="configurationSync.store",u="sync.previous.store",i="sync.donot-make-requests-until",n="sync.user-session-id",t="sync.machine-session-id",s=100,r=1e3*60*5;let a=class extends N.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(p.$Dnb,P.StorageScope.APPLICATION)}set c(T){this.h.store(p.$Dnb,T,P.StorageScope.APPLICATION,k.$p?P.StorageTarget.USER:P.StorageTarget.MACHINE)}constructor(T,U,F){super(),this.f=T,this.g=U,this.h=F,this.a=this.B(new A.$je),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const j=this.B(new N.$Sc);this.B(A.Event.filter(F.onDidChangeValue(P.StorageScope.APPLICATION,p.$Dnb,j),()=>this.c!==this.userDataSyncStore?.type,j)(()=>this.j()))}j(){this.b=this.m(this.f[o]),this.a.fire()}m(T){if(T&&(T=k.$p&&T.web?{...T,...T.web}:T,(0,I.$cg)(T.url)&&(0,I.$eg)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(U=>Array.isArray(T.authenticationProviders[U].scopes)))){const U=T,F=!!U.canSwitch,j=U.url===U.insidersUrl?"insiders":"stable",G=(F?this.c:void 0)||j,V=G==="insiders"?U.insidersUrl:G==="stable"?U.stableUrl:U.url;return{url:$.URI.parse(V),type:G,defaultType:j,defaultUrl:$.URI.parse(U.url),stableUrl:$.URI.parse(U.stableUrl),insidersUrl:$.URI.parse(U.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(U.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:U.authenticationProviders[H].scopes}),x),[])}}}};e.$PNb=a,e.$PNb=a=ve([Z(0,E.$qk),Z(1,g.$9i),Z(2,P.$fq)],a);let h=class extends a{constructor(T,U,F){super(T,U,F);const j=this.h.get(u,P.StorageScope.APPLICATION);j&&(this.n=JSON.parse(j));const G=this.f[o];G?this.h.store(u,JSON.stringify(G),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE):this.h.remove(u,P.StorageScope.APPLICATION)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$QNb=h,e.$QNb=h=ve([Z(0,E.$qk),Z(1,g.$9i),Z(2,P.$fq)],h);let y=class extends N.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(T,U,F,j,G,V,x){super(),this.n=F,this.r=j,this.s=x,this.g=this.B(new A.$je),this.onTokenFailed=this.g.event,this.h=this.B(new A.$je),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$je),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,w.$lq)(G,V,x).then(H=>{const ie={"X-Client-Name":`${U.applicationName}${k.$p?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(ie["X-Client-Commit"]=U.commit),ie}),this.f=new S(s,r,this.n,this.r),this.u(),this.B((0,N.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,U){this.b={token:T,type:U}}t(T){this.a=T?(0,b.$dh)(T,"v1"):void 0}u(){const T=this.s.getNumber(i,P.StorageScope.APPLICATION);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(i,this.j.getTime(),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),this.w=(0,R.$ph)(U=>(0,R.$Dh)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(i,P.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,b.$dh)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const F=await this.D(U,{type:"GET",headers:T},[],c.CancellationToken.None);return(await(0,f.$$p)(F))?.map(({id:j})=>j)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,b.$dh)(this.a,"collection").toString();T={...T},T["Content-Type"]=O.$8s.text;const F=await this.D(U,{type:"POST",headers:T},[],c.CancellationToken.None),j=await(0,f.$0p)(F);if(!j)throw new p.$Bnb("Server did not return the collection id",U,p.UserDataSyncErrorCode.NoCollection,F.res.statusCode,F.res.headers[p.$xnb]);return j}async deleteCollection(T,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=T?(0,b.$dh)(this.a,"collection",T).toString():(0,b.$dh)(this.a,"collection").toString();U={...U},await this.D(F,{type:"DELETE",headers:U},[],c.CancellationToken.None)}async getAllResourceRefs(T,U){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,U,T),j={},G=await this.D(F.toString(),{type:"GET",headers:j},[],c.CancellationToken.None);return(await(0,f.$$p)(G)||[]).map(({url:x,created:H})=>({ref:(0,b.$fh)(F,F.with({path:x})),created:H*1e3}))}async resolveResourceContent(T,U,F,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=(0,b.$dh)(this.z(this.a,F,T),U).toString();j={...j},j["Cache-Control"]="no-cache";const V=await this.D(G,{type:"GET",headers:j},[],c.CancellationToken.None);return await(0,f.$0p)(V)}async deleteResource(T,U,F){if(!this.a)throw new Error("No settings sync store url configured.");const j=U!==null?(0,b.$dh)(this.z(this.a,F,T),U).toString():this.z(this.a,F,T).toString(),G={};await this.D(j,{type:"DELETE",headers:G},[],c.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,b.$dh)(this.a,"resource").toString(),U={"Content-Type":O.$8s.text};await this.D(T,{type:"DELETE",headers:U},[],c.CancellationToken.None)}async readResource(T,U,F,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=(0,b.$dh)(this.z(this.a,F,T),"latest").toString();j={...j},j["Cache-Control"]="no-cache",U&&(j["If-None-Match"]=U.ref);const V=await this.D(G,{type:"GET",headers:j},[304],c.CancellationToken.None);let x=null;if(V.res.statusCode===304&&(x=U),x===null){const H=V.res.headers.etag;if(!H)throw new p.$Bnb("Server did not return the ref",G,p.UserDataSyncErrorCode.NoRef,V.res.statusCode,V.res.headers[p.$xnb]);const ie=await(0,f.$0p)(V);if(!ie&&V.res.statusCode===304)throw new p.$Bnb("Empty response",G,p.UserDataSyncErrorCode.EmptyResponse,V.res.statusCode,V.res.headers[p.$xnb]);x={ref:H,content:ie}}return x}async writeResource(T,U,F,j,G={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=this.z(this.a,j,T).toString();G={...G},G["Content-Type"]=O.$8s.text,F&&(G["If-Match"]=F);const x=await this.D(V,{type:"POST",data:U,headers:G},[],c.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new p.$Bnb("Server did not return the ref",V,p.UserDataSyncErrorCode.NoRef,x.res.statusCode,x.res.headers[p.$xnb]);return H}async manifest(T,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$dh)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",T&&(U["If-None-Match"]=T.ref);const j=await this.D(F,{type:"GET",headers:U},[304],c.CancellationToken.None);let G=null;if(j.res.statusCode===304&&(G=T),!G){const x=j.res.headers.etag;if(!x)throw new p.$Bnb("Server did not return the ref",F,p.UserDataSyncErrorCode.NoRef,j.res.statusCode,j.res.headers[p.$xnb]);const H=await(0,f.$0p)(j);if(!H&&j.res.statusCode===304)throw new p.$Bnb("Empty response",F,p.UserDataSyncErrorCode.EmptyResponse,j.res.statusCode,j.res.headers[p.$xnb]);H&&(G={...JSON.parse(H),ref:x})}const V=this.s.get(n,P.StorageScope.APPLICATION);return V&&G&&V!==G.session&&this.C(),G===null&&V&&this.C(),G&&this.s.store(n,G.session,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),G}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,b.$dh)(this.a,"download").toString(),U={},F=await this.D(T,{type:"GET",headers:U},[],c.CancellationToken.None);if(!(0,f.$7p)(F))throw new p.$Bnb("Server returned "+F.res.statusCode,T,p.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[p.$xnb]);if((0,f.$8p)(F))throw new p.$Bnb("Empty response",T,p.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[p.$xnb]);return F.stream}z(T,U,F){return U?(0,b.$dh)(T,"collection",U,"resource",F):(0,b.$dh)(T,"resource",F)}C(){this.s.remove(n,P.StorageScope.APPLICATION),this.s.remove(t,P.StorageScope.APPLICATION)}async D(T,U,F,j){if(!this.b)throw new p.$Bnb("No Auth Token Available",T,p.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new p.$Bnb(`${U.type} request '${T}' failed because of too many requests (429).`,T,p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const G=await this.c;U.headers={...U.headers||{},...G,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:T,type:U.type,headers:{...U.headers,authorization:void 0}});let V;try{V=await this.f.request(T,U,j)}catch(W){if(!(W instanceof p.$Bnb)){let ee=p.UserDataSyncErrorCode.RequestFailed;const ne=(0,C.$9)(W).toLowerCase();ne.includes("xhr timeout")?ee=p.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?ee=p.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?ee=p.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?ee=p.UserDataSyncErrorCode.RequestHeadersNotObject:(0,C.$3)(W)&&(ee=p.UserDataSyncErrorCode.RequestCanceled),W=new p.$Bnb(`Connection refused for the request '${T}'.`,T,ee,void 0,void 0)}throw this.r.info("Request failed",T),W}const x=V.res.headers[p.$xnb],H={url:T,status:V.res.statusCode,"execution-id":U.headers[p.$ynb],"operation-id":x},ie=(0,f.$7p)(V)||V.res.statusCode&&F.includes(V.res.statusCode);let z="";if(ie?this.r.trace("Request succeeded",H):(z=await(0,f.$9p)(V)||"",this.r.info("Request failed",H,z)),V.res.statusCode===401||V.res.statusCode===403){if(this.b=void 0,V.res.statusCode===401)throw this.g.fire(p.UserDataSyncErrorCode.Unauthorized),new p.$Bnb(`${U.type} request '${T}' failed because of Unauthorized (401).`,T,p.UserDataSyncErrorCode.Unauthorized,V.res.statusCode,x);if(V.res.statusCode===403)throw this.g.fire(p.UserDataSyncErrorCode.Forbidden),new p.$Bnb(`${U.type} request '${T}' failed because the access is forbidden (403).`,T,p.UserDataSyncErrorCode.Forbidden,V.res.statusCode,x)}if(this.h.fire(),V.res.statusCode===404)throw new p.$Bnb(`${U.type} request '${T}' failed because the requested resource is not found (404).`,T,p.UserDataSyncErrorCode.NotFound,V.res.statusCode,x);if(V.res.statusCode===405)throw new p.$Bnb(`${U.type} request '${T}' failed because the requested endpoint is not found (405). ${z}`,T,p.UserDataSyncErrorCode.MethodNotFound,V.res.statusCode,x);if(V.res.statusCode===409)throw new p.$Bnb(`${U.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,p.UserDataSyncErrorCode.Conflict,V.res.statusCode,x);if(V.res.statusCode===410)throw new p.$Bnb(`${U.type} request '${T}' failed because the requested resource is not longer available (410).`,T,p.UserDataSyncErrorCode.Gone,V.res.statusCode,x);if(V.res.statusCode===412)throw new p.$Bnb(`${U.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,p.UserDataSyncErrorCode.PreconditionFailed,V.res.statusCode,x);if(V.res.statusCode===413)throw new p.$Bnb(`${U.type} request '${T}' failed because of too large payload (413).`,T,p.UserDataSyncErrorCode.TooLarge,V.res.statusCode,x);if(V.res.statusCode===426)throw new p.$Bnb(`${U.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,p.UserDataSyncErrorCode.UpgradeRequired,V.res.statusCode,x);if(V.res.statusCode===429){const W=V.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new p.$Bnb(`${U.type} request '${T}' failed because of too many requests (429).`,T,p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,V.res.statusCode,x)):new p.$Bnb(`${U.type} request '${T}' failed because of too many requests (429).`,T,p.UserDataSyncErrorCode.TooManyRequests,V.res.statusCode,x)}if(!ie)throw new p.$Bnb("Server returned "+V.res.statusCode,T,p.UserDataSyncErrorCode.Unknown,V.res.statusCode,x);return V}F(T){let U=this.s.get(t,P.StorageScope.APPLICATION);U===void 0&&(U=(0,d.$Yg)(),this.s.store(t,U,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE)),T["X-Machine-Session-Id"]=U;const F=this.s.get(n,P.StorageScope.APPLICATION);F!==void 0&&(T["X-User-Session-Id"]=F)}};e.$RNb=y,e.$RNb=y=ve([Z(1,E.$qk),Z(2,f.$5p),Z(3,p.$Knb),Z(4,l.$Ji),Z(5,m.$0k),Z(6,P.$fq)],y);let L=class extends y{constructor(T,U,F,j,G,V,x){super(T.userDataSyncStore?.url,U,F,j,G,V,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$SNb=L,e.$SNb=L=ve([Z(0,p.$unb),Z(1,E.$qk),Z(2,f.$5p),Z(3,p.$Knb),Z(4,l.$Ji),Z(5,m.$0k),Z(6,P.$fq)],L);class S{constructor(T,U,F,j){this.c=T,this.d=U,this.f=F,this.g=j,this.a=[],this.b=void 0}request(T,U,F){if(this.h()&&this.i(),U.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new p.$Bnb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,p.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(U,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$TNb=S}),define(he[234],ue([0,1,3,2,9,21,23,16,126]),function(oe,e,R,c,C,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=e.$Dhc=e.$Chc=void 0;class b{constructor(l){this.a=l}listen(l,m){switch(m){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${m}`)}call(l,m,E){switch(m){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(E)}throw new Error("Invalid call")}}e.$Chc=b;class I extends c.$Tc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new R.$je),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(m=>{this.a=m,this.B(this.c.listen("onDidChangeAccount")(E=>{this.a=E,this.b.fire(E)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$Dhc=I;class ${constructor(l){this.a=l}listen(l,m){switch(m){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${m}`)}call(l,m,E){switch(m){case"switch":return this.a.switch(E[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Ehc=$;let d=class extends k.$PNb{constructor(l,m,E,f){super(m,E,f),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:C.URI.revive(l.url),type:l.type,defaultUrl:C.URI.revive(l.defaultUrl),insidersUrl:C.URI.revive(l.insidersUrl),stableUrl:C.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$Fhc=d,e.$Fhc=d=ve([Z(1,N.$qk),Z(2,A.$9i),Z(3,O.$fq)],d)}),define(he[235],ue([0,1,3,57,23,16,18,230,24,82,86]),function(oe,e,R,c,C,A,N,O,k,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;let $=class extends O.$kec{constructor(g,l,m,E,f,w,P,p,o,u,i){super(g,l,m,E,f,P,p,o,u,i),this.B(R.Event.debounce(R.Event.any(R.Event.map(w.onDidFocusMainWindow,()=>"windowFocus"),R.Event.map(w.onDidOpenMainWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$2hc=$,e.$2hc=$=ve([Z(0,C.$qk),Z(1,k.$unb),Z(2,k.$vnb),Z(3,k.$Fnb),Z(4,k.$Gnb),Z(5,c.$Xfc),Z(6,k.$Knb),Z(7,b.$fMb),Z(8,N.$9l),Z(9,I.$hnb),Z(10,A.$fq)],$)}),define(he[236],ue([0,1,75,22,5,20]),function(oe,e,R,c,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0,e.$lfc=N,e.$mfc=O,e.$nfc=k,e.$kfc=128/4;function N(b){function I(){let $=b.scheme===c.Schemas.file?(0,A.$4g)(b):b.toString();return C.$l||($=$.toLowerCase()),(0,R.createHash)("md5").update($).digest("hex")}return{id:I(),configPath:b}}function O(b,I){function $(){if(b.scheme!==c.Schemas.file)return(0,R.createHash)("md5").update(b.toString()).digest("hex");if(!I)return;let g;return C.$l?g=I.ino:C.$k?g=I.birthtime.getTime():C.$j&&(typeof I.birthtimeMs=="number"?g=Math.floor(I.birthtimeMs):g=I.birthtime.getTime()),(0,R.createHash)("md5").update(b.fsPath).update(g?String(g):"").digest("hex")}const d=$();if(typeof d=="string")return{id:d,uri:b}}function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(he[237],ue([0,1,6,8,2,13,30,15,10,79,115,236,57,56,22]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;let m=class extends C.$Tc{constructor(f,w,P,p){super(),this.a=f,this.b=w,this.c=P,this.f=p,this.B(new R.$Oh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,w=await N.Promises.readdir(f),P=new b.$QMb(this.f.getChannel("storage"));await Promise.all(w.map(async p=>{const o=(0,A.$ic)(f,p);p.length===$.$kfc||p===I.$Oi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===p)||await P.isUsed(o)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${p} as it seems to be an unused empty workspace.`),await N.Promises.rm(o))}))}catch(f){(0,c.$Y)(f)}}};e.$yhc=m,e.$yhc=m=ve([Z(0,O.$Ki),Z(1,k.$0j),Z(2,d.$Xfc),Z(3,g.$dhc)],m)}),define(he[127],ue([0,1,75,67,38,245,14,8,3,2,13,5,32,42,69]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=t,e.$vi=s,e.$xi=h,e.$yi=y;const m=3e4;class E{traceSocketEvent(S,v){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,v)}constructor(S,v=""){this.f=!0,this.debugLabel=v,this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=U=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,O.$Y)(U)}},this.socket.on("error",this.a);let T;this.b=U=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:U}),this.f=!1,T&&clearTimeout(T)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,T=setTimeout(()=>S.destroy(),m)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const v=T=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,T),S(N.$Le.wrap(T))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(S){const v=T=>{S({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:T,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(S){const v=()=>{S()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,S),this.socket.write(S.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,O.$Y)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,O.$Y)(v)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((S,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.$ri=E;var f;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var w;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(w||(w={}));class P extends b.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,v){this.socket.traceSocketEvent(S,v)}constructor(S,v,T,U){super(),this.f=this.B(new k.$je),this.g=this.B(new k.$je),this.h=!1,this.j={state:w.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:T?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new p(this,v,T,U,this.f,(F,j)=>this.m(F,j))),this.B(this.a.onError(F=>{console.error(F),(0,O.$Y)(F),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:F})})),this.b=new l.$mi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let v=0;for(;v<S.byteLength;)this.a.writeMessage(S.slice(v,Math.min(v+f.MaxWebSocketMessageLength,S.byteLength)),{compressed:!0,opcode:2}),v+=f.MaxWebSocketMessageLength}m(S,{compressed:v,opcode:T}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,S);let U=f.MinHeaderByteSize;S.byteLength<126?U+=0:S.byteLength<2**16?U+=2:U+=8;const F=N.$Le.alloc(U),j=v?64:0,G=T&15;if(F.writeUInt8(128|j|G,0),S.byteLength<126)F.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){F.writeUInt8(126,1);let V=1;F.writeUInt8(S.byteLength>>>8&255,++V),F.writeUInt8(S.byteLength>>>0&255,++V)}else{F.writeUInt8(127,1);let V=1;F.writeUInt8(0,++V),F.writeUInt8(0,++V),F.writeUInt8(0,++V),F.writeUInt8(0,++V),F.writeUInt8(S.byteLength>>>24&255,++V),F.writeUInt8(S.byteLength>>>16&255,++V),F.writeUInt8(S.byteLength>>>8&255,++V),F.writeUInt8(S.byteLength>>>0&255,++V)}this.socket.write(N.$Le.concat([F,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===w.PeekHeader){const v=this.b.peek(this.j.readLen),T=v.readUInt8(0),U=(T&128)>>>7,F=(T&64)>>>6,j=T&15,G=v.readUInt8(1),V=(G&128)>>>7,x=G&127;this.j.state=w.ReadHeader,this.j.readLen=f.MinHeaderByteSize+(V?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===w.ReadHeader){const v=this.b.read(this.j.readLen),T=v.readUInt8(1),U=(T&128)>>>7;let F=T&127,j=1;F===126?F=v.readUInt8(++j)*2**8+v.readUInt8(++j):F===127&&(F=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let G=0;U&&(G=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=w.ReadBody,this.j.readLen=F,this.j.mask=G,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===w.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),i(v,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=w.PeekHeader,this.j.readLen=f.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=P;class p extends b.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:N.$Le.alloc(0)}constructor(S,v,T,U,F,j){super(),this.n=S,this.r=F,this.s=j,this.a=this.B(new k.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new o(this.n,U,T,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(S,v){this.g.push({data:S,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:v}=this.g.shift();if(this.f&&v.compressed){const T=await this.w(this.f,S);this.s(T,v)}else this.s(S,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,v){return new Promise((T,U)=>{S.write(v),S.flush(F=>T(F))})}acceptFrame(S,v,T){this.h.push({data:S,isCompressed:v,isLastFrameOfMessage:T}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const v=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,v,T){return new Promise((U,F)=>{S.write(v),T&&S.write(N.$Le.fromByteArray([0,0,255,255])),S.flush(j=>U(j))})}}class o extends b.$Tc{get recordedInflateBytes(){return this.j?N.$Le.concat(this.f):N.$Le.alloc(0)}constructor(S,v,T,U){super(),this.h=S,this.j=v,this.a=this.B(new k.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(U),this.b.on("error",F=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,F),this.g.push(N.$Le.wrap(F))}),T&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,T.buffer),this.b.write(T.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=N.$Le.concat(this.g);this.g.length=0,S(v)})}}class u extends b.$Tc{constructor(S,v){super(),this.g=S,this.a=this.B(new k.$je),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",T=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,T),this.f.push(N.$Le.wrap(T))})}write(S){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=N.$Le.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),S(v)})}}function i(L,S){if(S===0)return;const v=L.byteLength>>>2;for(let V=0;V<v;V++){const x=L.readUInt32BE(V*4);L.writeUInt32BE(x^S,V*4)}const T=v*4,U=L.byteLength-T,F=S>>>24&255,j=S>>>16&255,G=S>>>8&255;U>=1&&L.writeUInt8(L.readUInt8(T)^F,T),U>=2&&L.writeUInt8(L.readUInt8(T+1)^j,T+1),U>=3&&L.writeUInt8(L.readUInt8(T+2)^G,T+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const n={[$.Platform.Linux]:107,[$.Platform.Mac]:103};function t(){const L=(0,d.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const S=process.platform!=="darwin"&&e.$ti?e.$ti:(0,C.tmpdir)(),v=(0,I.$ic)(S,`vscode-ipc-${L}.sock`);return r(v),v}function s(L,S,v){const U=(0,R.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${v}-${S}-sock`;const F=v.substr(0,4),j=S.substr(0,6);let G;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?G=(0,I.$ic)(e.$ti,`vscode-${U}-${F}-${j}.sock`):G=(0,I.$ic)(L,`${F}-${j}.sock`),r(G),G}function r(L){const S=n[$.$v];typeof S=="number"&&L.length>=S&&console.warn(`WARNING: IPC handle "${L}" is longer than ${S} chars, try a shorter --user-data-dir`)}class a extends g.$gi{static b(S){const v=k.Event.fromNodeEventEmitter(S,"connection");return k.Event.map(v,T=>({protocol:new l.$ni(new E(T,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(T,"close"))}))}constructor(S){super(a.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=a;function h(L){return new Promise((S,v)=>{const T=(0,c.createServer)();T.on("error",v),T.listen(L,()=>{T.removeListener("error",v),S(new a(T))})})}function y(L,S){return new Promise((v,T)=>{const U=(0,c.createConnection)(L,()=>{U.removeListener("error",T),v(l.$oi.fromSocket(new E(U,`ipc-client${S}`),S))});U.once("error",T)})}}),define(he[238],ue([0,1,67,127,185]),function(oe,e,R,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0,R=ke(R),e.$5hc=new class{supports(A){return!0}connect({host:A,port:N},O,k,b){return new Promise((I,$)=>{const d=R.createConnection({host:A,port:N},()=>{d.removeListener("error",$),d.write((0,C.$gxb)(O,k,b));const g=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(d.off("data",g),I(new c.$ri(d,b)))};d.on("data",g)});d.setNoDelay(!0),d.once("error",$)})}}}),define(he[239],ue([0,1,67,38,147,127,6,2,5,21,10,23,186,106,108,80,14]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=e.$8gc=e.$7gc=void 0,R=ke(R),c=ke(c);async function f(u,i,n,t,s){let r;for(let a=3;a&&(r?.dispose(),r=await new w(u,i,n,t,s).waitForReady(),!(s&&C.$2g[s]||!C.$2g[r.tunnelLocalPort]));a--);return r}class w extends O.$Tc{constructor(i,n,t,s,r){super(),this.m=n,this.n=r,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=R.createServer(),this.c=new N.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,n=(0,m.$Jw)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,C.$3g)(i,2,1e3,n),s=null;return this.b.listen(t,this.m),await this.c.wait(),s=this.b.address(),s||(t=0,this.b.listen(t,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(i){i.pause();const n=(0,m.$Hw)(this.tunnelRemoteHost)||(0,m.$Jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,d.$Zl)(this.a,n,this.tunnelRemotePort),s=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),s.end()}),i.on("close",()=>s.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),s instanceof A.$ri?s.socket.destroy():s.end()}),s instanceof A.$ri?this.t(i,s):this.s(i,s),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),s.end()})}s(i,n){n.onClose(()=>i.destroy()),n.onEnd(()=>i.end()),n.onData(t=>i.write(t.buffer)),i.on("data",t=>n.write(E.$Le.wrap(t))),i.resume()}t(i,n){const t=n.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.$7gc=w;let P=class extends m.$Mw{constructor(i,n,t,s,r){super(n,r),this.H=i,this.I=t,this.J=s}isPortPrivileged(i){return(0,m.$Kw)(i,this.t,k.OS,c.release())}F(i,n,t,s,r,a,h,y){const L=this.D(n,t);if(L)return++L.refcount,L.value;if((0,m.$Dw)(i))return this.G(i,n,t,r,a,h,y);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${t} on local port ${r}.`);const S={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=f(S,s,n,t,r);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(n,t,v),v}}};e.$8gc=P,e.$8gc=P=ve([Z(0,g.$Tl),Z(1,I.$0j),Z(2,l.$Wl),Z(3,$.$qk),Z(4,b.$9i)],P);let p=class extends P{constructor(i,n,t,s,r){super(i,n,t,s,r)}};e.$9gc=p,e.$9gc=p=ve([Z(0,g.$Tl),Z(1,I.$0j),Z(2,l.$Wl),Z(3,$.$qk),Z(4,b.$9i)],p);let o=class extends O.$Tc{constructor(i,n,t,s,r){super(),this.b=i,this.c=n,this.f=t,this.g=s,this.h=r,this.a=new Map}async openTunnel(i,n,t,s,r,a,h,y,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${s} on local port ${a}.`),!this.a.has(i)){const S=new p(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(i,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(n,t,s,r,a,h,y,L)}};e.$0gc=o,e.$0gc=o=ve([Z(0,g.$Tl),Z(1,I.$0j),Z(2,$.$qk),Z(3,l.$Wl),Z(4,b.$9i)],o)});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[246],ue([0,1,38,43,8,2,22,9,17,3,42,151,179,180,189,171,237,162,163,21,184,97,196,98,191,15,118,223,27,110,187,117,74,7,173,174,73,4,170,76,78,199,10,175,102,23,61,16,109,18,111,112,113,48,202,85,114,24,82,229,234,212,86,228,232,233,126,62,227,213,108,195,80,239,190,203,28,204,5,205,164,182,181,84,218,19,52,178,58,226,201,214,107,231,219,11,176,101,224,217,192,158,57,177,235,221,56,225,106,104,238,156,193,145,133,144]),function(oe,e,R,c,C,A,N,O,k,b,I,$,d,g,l,m,E,f,w,P,p,o,u,i,n,t,s,r,a,h,y,L,S,v,T,U,F,j,G,V,x,H,ie,z,W,ee,ne,ce,te,X,K,B,D,J,q,M,Q,_,Y,re,le,ge,pe,Ee,we,be,Se,Re,ae,de,me,Pe,Oe,Fe,Ne,Le,Ue,qe,He,je,Be,ze,We,Ce,se,fe,$e,ye,Ae,Te,Me,xe,Je,Ye,Ve,_e,Qe,nt,at,Lt,Ct,Tt,Nt,Dt,Ut,Ft,yt,jt,vt,Mt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,W=it(W);class Vt extends A.$Tc{constructor(Ie){super(),this.f=Ie,this.a=this.B(new $.$TX(this)),this.b=void 0,this.c=this.B(new b.$je),this.g()}g(){let Ie=!1;const De=()=>{Ie||(Ie=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",De),(0,$.$UX)(process.parentPort,ht.$hgc.exit,De)}async init(){const Ie=await this.h();(0,_.$pnb)(),Ie.invokeFunction(De=>{const Ke=De.get(ie.$0j),Ge=De.get(X.$9l),et=De.get(fe.$Jl);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(De),this.m(Ke),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Ke)}),this.B((0,A.$Qc)(Ie.createInstance(d.$uhc,this.f.codeCachePath),Ie.createInstance(g.$vhc),Ie.createInstance(E.$yhc),Ie.createInstance(m.$xhc),Ie.createInstance(l.$whc),Ie.createInstance(Ve.$Vhc),Ie.createInstance(xe.$Nhc)))}async h(){const Ie=new V.$Ai,De={_serviceBrand:void 0,...W.default};Ie.set(ee.$qk,De);const Ke=new I.$ki(Ze=>Ze==="main"),Ge=new yt.$ehc(this.a,Ke);Ie.set(yt.$dhc,Ge);const et=this.f.policiesData?new ye.$Kgc(this.f.policiesData,Ge.getChannel("policy")):new Ae.$so;Ie.set(Ae.$qo,et);const Xe=new Bt.$6m(this.f.args,De);Ie.set(t.$Ki,Xe);const ot=new z.$qs(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:O.URI.revive(Ze.resource)})),Ge.getChannel("logger"));Ie.set(ie.$$j,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(12061,null)})),$t=this.B(new ie.$fk(ft.getLevel())),tt=this.B(new Qe.$vR(ft,[$t]));Ie.set(ie.$0j,tt),this.b=this.B(new nt.$Xhc(tt)),Ie.set(nt.$Whc,this.b);const st=this.B(new T.$Zq(tt));Ie.set(v.$0k,st);const pt=this.B(new U.$qr(tt));st.registerProvider(N.Schemas.file,pt);const dt=new qe.$Rs(st);Ie.set(Ue.$Hl,dt);const rt=this.B(new Te.$CR(this.f.profiles.all,O.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Ie.set(fe.$Jl,rt);const wt=this.B(new je.$chc(N.Schemas.file,this.B(new Be.$eR(Ge.getChannel(Be.$dR),{pathCaseSensitive:He.$l})),N.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(N.Schemas.vscodeUserData,wt);const ct=this.B(new p.$Uo(rt.defaultProfile.settingsResource,st,et,tt));Ie.set(P.$9i,ct);const bt=new jt.$4hc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Xe);Ie.set(ce.$fq,bt),this.B((0,A.$Rc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const Rt=new Ct.$as(Ge.getChannel("request"));Ie.set(ne.$5p,Rt),Ie.set(f.$zhc,new F.$zi(w.$Ahc,void 0,!1)),Ie.set(We.$PG,new F.$zi(ze.$Mhc,void 0,!1));const It=new Dt.$ghc(-1,Ge);Ie.set(Nt.$Xfc,It),Ie.set(i.$Yo,new F.$zi(n.$KR,void 0,!0));const Gt=this.B(new de.$Hgc(It)),Kt=new I.$ki(Ze=>Gt.getActiveClientId().then(mt=>Ze===mt));Ie.set(S.$Y6b,new Tt.$Zhc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,J.$Gp)(De,ct);if((0,J.$Bp)(De,Xe)){const Ze=new B.$Bdc(tt,ot,Xe,De);if(lt.push(Ze),!(0,J.$Cp)(De,Xe)&&De.aiConfig?.ariaKey){const mt=new Me.$jR(Rt,Pt,"monacoworkbench",null,De.aiConfig.ariaKey);this.B((0,A.$Rc)(()=>mt.flush())),lt.push(mt)}gt=new D.$es({appenders:lt,commonProperties:(0,te.$sp)((0,R.release)(),(0,R.hostname)(),process.arch,De.commit,De.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,J.$Hp)(Xe)},ct,De)}else{gt=J.$wp;const Ze=J.$Ap;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new K.$mgc(lt)),Ie.set(X.$9l,gt);const Jt=new q.$Bhc(ct,gt,tt,ot,Xe,De);Ie.set(X.$0l,Jt),Ie.set($e.$Gq,new F.$zi(Lt.$uR,void 0,!0)),Ie.set(Ce.$Kq,new F.$zi(se.$Lgc,void 0,!0)),Ie.set(h.$qq,new F.$zi(h.$sq,void 0,!0)),Ie.set(L.$Vq,new F.$zi(L.$Wq,void 0,!0)),Ie.set(a.$ip,new F.$zi(r.$oq,void 0,!0)),Ie.set(a.$pp,new F.$zi(Ft.$3hc,void 0,!1)),Ie.set(x.$9r,new F.$zi(H.$$r,void 0,!1)),Ie.set(o.$Qm,new F.$zi(u.$Ys,void 0,!1)),Ie.set(Y.$fMb,new F.$zi(Y.$gMb,void 0,!0)),Ie.set(_.$Knb,new F.$zi(ge.$LOb,void 0,!0)),Ie.set(_.$Jnb,I.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Ie.set(a.$op,new F.$zi(s.$dMb,void 0,!1)),Ie.set(Q.$JOb,new F.$zi(Q.$KOb,void 0,!0)),Ie.set(M.$nw,new F.$zi(M.$ow)),Ie.set(_.$unb,new F.$zi(Se.$QNb,void 0,!0)),Ie.set(_.$vnb,new F.$zi(Se.$SNb,void 0,!0)),Ie.set(pe.$hnb,new F.$zi(pe.$jnb,void 0,!0)),Ie.set(_.$wnb,new F.$zi(re.$eec,void 0,!1)),Ie.set(_.$Fnb,new F.$zi(Ee.$6dc,void 0,!0)),Ie.set(_.$Gnb,new F.$zi(we.$jec,void 0,!1)),Ie.set(Re.$RMb,new F.$zi(ae.$Ihc,void 0,!0)),Ie.set(_.$Hnb,new F.$zi(Ye.$Zec,void 0,!0)),Ie.set(me.$Wl,new F.$zi(Pe.$_gc,void 0,!1));const kt=new vt.$Ul;return Ie.set(vt.$Tl,kt),kt.register(Mt.RemoteConnectionType.WebSocket,qt.$5hc),Ie.set(Oe.$Cw,new F.$zi(Fe.$0gc)),Ie.set(Ne.$Jhc,new F.$zi(Le.$Lhc)),Ie.set(Je.$Ohc,new F.$zi(at.$Yhc)),new G.$tr(Ie)}j(Ie){const De=new y.$uq(Ie.get(a.$lp),()=>null);this.a.registerChannel("extensions",De);const Ke=I.ProxyChannel.fromService(Ie.get(x.$9r),this.q);this.a.registerChannel("languagePacks",Ke);const Ge=I.ProxyChannel.fromService(Ie.get(o.$Qm),this.q);this.a.registerChannel("diagnostics",Ge);const et=new y.$wq(Ie.get(a.$pp));this.a.registerChannel("extensionTipsService",et);const Xe=I.ProxyChannel.fromService(Ie.get(f.$zhc),this.q);this.a.registerChannel("checksum",Xe);const ot=I.ProxyChannel.fromService(Ie.get(We.$PG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=I.ProxyChannel.fromService(Ie.get(pe.$hnb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=I.ProxyChannel.fromService(Ie.get(X.$0l),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new le.$Chc(Ie.get(Y.$fMb));this.a.registerChannel("userDataSyncAccount",tt);const st=new le.$Ehc(Ie.get(_.$unb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new be.$Ghc(Ie.get(_.$Gnb),Ie.get(fe.$Jl),Ie.get(ie.$0j));this.a.registerChannel("userDataSync",pt);const dt=this.B(Ie.get(j.$Bi).createInstance(Ut.$2hc));this.a.registerChannel("userDataAutoSync",I.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",I.ProxyChannel.fromService(Ie.get(_.$Hnb),this.q));const rt=I.ProxyChannel.fromService(Ie.get(Ne.$Jhc),this.q);this.a.registerChannel(Ne.$Khc,rt);const wt=I.ProxyChannel.fromService(Ie.get(Je.$Ohc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Ie){process.on("uncaughtException",De=>(0,C.$Y)(De)),process.on("unhandledRejection",De=>(0,C.$Y)(De)),(0,C.setUnexpectedErrorHandler)(De=>{const Ke=(0,c.$nj)(De,!0);Ke&&Ie.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Ie,De){Ie.publicLog2("profilesInfo",{count:De.profiles.length})}async r(Ie,De){if(He.$l){const[Ke,Ge]=await Promise.all([(0,zt.$Zg)(De.error.bind(De)),(0,Et.$BX)(De.error.bind(De))]),et=(0,Wt.$fX)(),Xe=(0,Et.$CX)(Ge,this.f.args["ozone-platform"]);Ke&&Ie.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Xe})}}handledClientConnection(Ie){if(Ie.data!==ht.$jgc.response)return!1;const De=(0,k.$Nb)(Ie.ports);return De?(this.c.fire(De),!0):!1}}async function St(ut){try{const Ie=new Vt(ut);process.parentPort.postMessage(ht.$hgc.ipcReady),await Ie.init(),process.parentPort.postMessage(ht.$hgc.initDone)}catch(Ie){process.parentPort.postMessage({error:Ie.toString()})}}const Ht=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Ht),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/a35380d6f0ff65f7c35345baafcf1c3f8a378d38/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
